#define GTK_DISABLE_DEPRECATED 1

#ifdef HAVE_CONFIG_H
#  include <config.h>
#else
#  include <config_any.h>
#endif
#include <vector>
#include <algorithm>
#include <functional>
#include <iostream>
#include <gtk/gtk.h>
#ifdef _WIN32
#include <gdk/gdkwin32.h>
#endif
#include <cmath>
#include <gdk/gdkkeysyms.h>

#define MyBLUE NULL
#define MyRED  NULL
#define LABELCOLOR    NULL
//#define MyBLUE "blue"
//#define MyRED  "red"
//#define LABELCOLOR    "#0000DD"


enum {LEFT_TO_RIGHT, RIGHT_TO_LEFT, BOTTOM_TO_TOP, TOP_TO_BOTTOM};

#define USE_TOOLBAR 1
#ifdef USE_TOOLBAR
#ifndef GTK_TOOL_ITEM
#undef USE_TOOLBAR
#endif
#endif
#ifdef MACOSX
#define MONOSPACE_FONT "courier"
#elif defined(_WIN32)
#define MONOSPACE_FONT "Monospace"
#else
#define MONOSPACE_FONT "monospace"
#endif

#define USE_CMAP 1
#define USE_ACTIONS 1

#ifndef GTK_ACTION
#undef USE_ACTIONS
#endif

#define USE_VALUE_CHANGED 1

#if GTK_MAJOR_VERSION >= 3
#define IN_GTK3  1

#if GTK_MINOR_VERSION >= 18
#undef USE_VALUE_CHANGED
#endif

#if 0              // NEW FROM GTK-3.22
#if GTK_MINOR_VERSION > 2

#define USE_MYSPIN  1
#define MY_TYPE_SPIN_BUTTON                  (my_spin_button_get_type ())
#define MY_SPIN_BUTTON(obj)                  (G_TYPE_CHECK_INSTANCE_CAST ((obj), MY_TYPE_SPIN_BUTTON, MySpinButton))
#define MY_SPIN_BUTTON_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST ((klass), MY_TYPE_SPIN_BUTTON, MySpinButtonClass))
#define MY_IS_SPIN_BUTTON(obj)               (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MY_TYPE_SPIN_BUTTON))
#define MY_IS_SPIN_BUTTON_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE ((klass), MY_TYPE_SPIN_BUTTON))
#define MY_SPIN_BUTTON_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj), MY_TYPE_SPIN_BUTTON, MySpinButtonClass))

#define GTK_INPUT_ERROR -1
typedef enum
{
  MY_UPDATE_ALWAYS,
  MY_UPDATE_IF_VALID
} MySpinButtonUpdatePolicy;

typedef enum
{
  MY_SPIN_STEP_FORWARD,
  MY_SPIN_STEP_BACKWARD,
  MY_SPIN_PAGE_FORWARD,
  MY_SPIN_PAGE_BACKWARD,
  MY_SPIN_HOME,
  MY_SPIN_END,
  MY_SPIN_USER_DEFINED
} MySpinType;

typedef struct _MySpinButton              MySpinButton;
typedef struct _MySpinButtonPrivate       MySpinButtonPrivate;
typedef struct _MySpinButtonClass         MySpinButtonClass;

struct _MySpinButton
{
  GtkEntry entry;
  MySpinButtonPrivate *priv;
};

struct _MySpinButtonClass
{
  GtkEntryClass parent_class;

  gint (*input)  (MySpinButton *spin_button,
                  gdouble       *new_value);
  gint (*output) (MySpinButton *spin_button);
  void (*value_changed) (MySpinButton *spin_button);
  void (*change_value) (MySpinButton *spin_button,
                  GtkScrollType  scroll);

  void (*wrapped) (MySpinButton *spin_button);
};


GType my_spin_button_get_type(void) G_GNUC_CONST;

void my_spin_button_configure   (MySpinButton  *spin_button,
                                 GtkAdjustment *adjustment,
                                 gdouble       climb_rate,
                                 guint         digits);

GtkWidget* my_spin_button_new (GtkAdjustment  *adjustment,
                               gdouble         climb_rate,
                               guint           digits);

GtkWidget* my_spin_button_new_with_range (gdouble  min,
                                          gdouble  max,
                                          gdouble  step);

void my_spin_button_set_adjustment (MySpinButton  *spin_button,
                                    GtkAdjustment  *adjustment);

GtkAdjustment* my_spin_button_get_adjustment (MySpinButton  *spin_button);

void my_spin_button_set_digits (MySpinButton  *spin_button,
                                guint          digits);
guint           my_spin_button_get_digits         (MySpinButton  *spin_button);

void my_spin_button_set_increments (MySpinButton  *spin_button,
                                    gdouble         step,
                                    gdouble         page);
void            my_spin_button_get_increments     (MySpinButton  *spin_button,
                                    gdouble        *step,
                                    gdouble        *page);

void my_spin_button_set_range (MySpinButton  *spin_button,
                               gdouble         min,
                               gdouble         max);
void            my_spin_button_get_range          (MySpinButton  *spin_button,
                               gdouble        *min,
                               gdouble        *max);

gdouble my_spin_button_get_value          (MySpinButton  *spin_button);

gint my_spin_button_get_value_as_int   (MySpinButton  *spin_button);

void my_spin_button_set_value (MySpinButton  *spin_button,
                               gdouble        value);

void my_spin_button_set_update_policy  (MySpinButton  *spin_button,
                                        MySpinButtonUpdatePolicy  policy);
MySpinButtonUpdatePolicy my_spin_button_get_update_policy (MySpinButton *spin_button);

void my_spin_button_set_numeric (MySpinButton  *spin_button,
                                 gboolean       numeric);
gboolean        my_spin_button_get_numeric        (MySpinButton  *spin_button);

void my_spin_button_spin (MySpinButton  *spin_button,
                          MySpinType     direction,
                          gdouble        increment);

void my_spin_button_set_wrap (MySpinButton  *spin_button,
                              gboolean       wrap);
gboolean        my_spin_button_get_wrap           (MySpinButton  *spin_button);

void my_spin_button_set_snap_to_ticks  (MySpinButton  *spin_button,
                                        gboolean       snap_to_ticks);
gboolean        my_spin_button_get_snap_to_ticks  (MySpinButton  *spin_button);
void            my_spin_button_update             (MySpinButton  *spin_button);

GdkWindow*      _my_spin_button_get_panel         (MySpinButton  *spin_button);

#define MY_TYPE_SPIN_BUTTON_UPDATE_POLICY (my_spin_button_get_update_policy)

gboolean _gtk_boolean_handled_accumulator (GSignalInvocationHint *ihint,
                                           GValue                *return_accu,
                                           const GValue          *handler_return,
                                           gpointer               dummy);
#endif

#endif
#undef USE_CMAP
typedef struct {
  gint x1;
  gint y1;
  gint x2;
  gint y2;
}GdkSegment;

#define COLOR_CHANGED "style-updated"
#define DRAW_EVENT "draw"
const int KeyUp = GDK_KEY_Up;
const int KeyKpUp = GDK_KEY_KP_Up;
const int KeyDown = GDK_KEY_Down;
const int KeyKpDown = GDK_KEY_KP_Down;
const int KeyLeft = GDK_KEY_Left;
const int KeyKpLeft = GDK_KEY_KP_Left;
const int KeyRight = GDK_KEY_Right;
const int KeyKpRight = GDK_KEY_KP_Right;
const int KeyPageUp = GDK_KEY_Page_Up;
const int KeyKpPageUp = GDK_KEY_KP_Page_Up;
const int KeyPageDown = GDK_KEY_Page_Down;
const int KeyKpPageDown = GDK_KEY_KP_Page_Down;
const int KeyEnd = GDK_KEY_End;
const int KeyKpEnd = GDK_KEY_KP_End;
const int KeyHome = GDK_KEY_Home;
const int KeyKpHome = GDK_KEY_KP_Home;
const int KeyB = GDK_KEY_B;
const int Keyb = GDK_KEY_b;
const int KeyC = GDK_KEY_C;
const int Keyc = GDK_KEY_c;
const int KeyE = GDK_KEY_E;
const int Keye = GDK_KEY_e;
const int KeyF = GDK_KEY_F;
const int Keyf = GDK_KEY_f;
const int KeyG = GDK_KEY_G;
const int Keyg = GDK_KEY_g;
const int KeyH = GDK_KEY_H;
const int Keyh = GDK_KEY_h;
const int KeyL = GDK_KEY_L;
const int Keyl = GDK_KEY_l;
const int KeyP = GDK_KEY_P;
const int Keyp = GDK_KEY_p;
const int KeyQ = GDK_KEY_Q;
const int Keyq = GDK_KEY_q;
const int KeyR = GDK_KEY_R;
const int Keyr = GDK_KEY_r;
const int KeyS = GDK_KEY_S;
const int Keys = GDK_KEY_s;
const int KeyW = GDK_KEY_W;
const int Keyw = GDK_KEY_w;
const int KeyY = GDK_KEY_Y;
const int Keyy = GDK_KEY_y;
const int KeyZ = GDK_KEY_Z;
const int Keyz = GDK_KEY_z;
const int Key0 = GDK_KEY_0;
const int KeyKp0 = GDK_KEY_KP_0;
const int Key1 = GDK_KEY_1;
const int KeyKp1 = GDK_KEY_KP_1;
const int Key2 = GDK_KEY_2;
const int KeyKp2 = GDK_KEY_KP_2;
const int Key3 = GDK_KEY_3;
const int KeyKp3 = GDK_KEY_KP_3;
const int Key4 = GDK_KEY_4;
const int KeyKp4 = GDK_KEY_KP_4;
const int Key5 = GDK_KEY_5;
const int KeyKp5 = GDK_KEY_KP_5;
const int Key6 = GDK_KEY_6;
const int KeyKp6 = GDK_KEY_KP_6;
const int Key7 = GDK_KEY_7;
const int KeyKp7 = GDK_KEY_KP_7;
const int Key8 = GDK_KEY_8;
const int KeyKp8 = GDK_KEY_KP_8;
const int Key9 = GDK_KEY_9;
const int KeyKp9 = GDK_KEY_KP_9;
const int Keyplus = GDK_KEY_plus;
const int KeyKpadd = GDK_KEY_KP_Add;
const int Keyminus = GDK_KEY_minus;
const int KeyKpsubtract = GDK_KEY_KP_Subtract;
const int Aring = GDK_KEY_Aring;
const int Degree = GDK_KEY_degree;
const int Alpha = GDK_KEY_Greek_alpha;
typedef cairo_region_t MyRegion;
#else
#undef IN_GTK3
#define COLOR_CHANGED "style-set"
#define DRAW_EVENT "expose_event"
const int KeyUp = GDK_Up;
const int KeyKpUp = GDK_KP_Up;
const int KeyDown = GDK_Down;
const int KeyKpDown = GDK_KP_Down;
const int KeyLeft = GDK_Left;
const int KeyKpLeft = GDK_KP_Left;
const int KeyRight = GDK_Right;
const int KeyKpRight = GDK_KP_Right;
const int KeyPageUp = GDK_Page_Up;
const int KeyKpPageUp = GDK_KP_Page_Up;
const int KeyPageDown = GDK_Page_Down;
const int KeyKpPageDown = GDK_KP_Page_Down;
const int KeyEnd = GDK_End;
const int KeyKpEnd = GDK_KP_End;
const int KeyHome = GDK_Home;
const int KeyKpHome = GDK_KP_Home;
const int KeyB = GDK_B;
const int Keyb = GDK_b;
const int KeyC = GDK_C;
const int Keyc = GDK_c;
const int KeyE = GDK_E;
const int Keye = GDK_e;
const int KeyF = GDK_F;
const int Keyf = GDK_f;
const int KeyG = GDK_G;
const int Keyg = GDK_g;
const int KeyH = GDK_H;
const int Keyh = GDK_h;
const int KeyL = GDK_L;
const int Keyl = GDK_l;
const int KeyP = GDK_P;
const int Keyp = GDK_p;
const int KeyQ = GDK_Q;
const int Keyq = GDK_q;
const int KeyR = GDK_R;
const int Keyr = GDK_r;
const int KeyS = GDK_S;
const int Keys = GDK_s;
const int KeyW = GDK_W;
const int Keyw = GDK_w;
const int KeyY = GDK_Y;
const int Keyy = GDK_y;
const int KeyZ = GDK_Z;
const int Keyz = GDK_z;
const int Key0 = GDK_0;
const int KeyKp0 = GDK_KP_0;
const int Key1 = GDK_1;
const int KeyKp1 = GDK_KP_1;
const int Key2 = GDK_2;
const int KeyKp2 = GDK_KP_2;
const int Key3 = GDK_3;
const int KeyKp3 = GDK_KP_3;
const int Key4 = GDK_4;
const int KeyKp4 = GDK_KP_4;
const int Key5 = GDK_5;
const int KeyKp5 = GDK_KP_5;
const int Key6 = GDK_6;
const int KeyKp6 = GDK_KP_6;
const int Key7 = GDK_7;
const int KeyKp7 = GDK_KP_7;
const int Key8 = GDK_8;
const int KeyKp8 = GDK_KP_8;
const int Key9 = GDK_9;
const int KeyKp9 = GDK_KP_9;
const int Keyplus = GDK_plus;
const int KeyKpadd = GDK_KP_Add;
const int Keyminus = GDK_minus;
const int KeyKpsubtract = GDK_KP_Subtract;
const int Aring = GDK_Aring;
const int Degree = GDK_degree;
const int Alpha = GDK_Greek_alpha;
typedef GdkRegion MyRegion;

#if GTK_MINOR_VERSION < 2
#ifndef VERY_LOW_VERSION
#define VERY_LOW_VERSION = 1
#endif
#endif
#if GTK_MINOR_VERSION < 4
#ifndef CANNOT_PAD_ALIGN
#define CANNOT_PAD_ALIGN = 1
#endif
#ifndef NOMKESC
#define NOMKESC = 1
#endif
#ifndef NOCURS_FROM_PIXBUF
#define NOCURS_FROM_PIXBUF = 1
#endif
#ifndef MUST_SET_CM
#define MUST_SET_CM = 1
#endif
#endif

#if GTK_MINOR_VERSION < 6
#ifndef NOELLIPSIZE
#define NOELLIPSIZE = 1
#endif
#ifndef CANNOT_FLIP
#define CANNOT_FLIP = 1
#endif
#ifndef NOACC_LABEL
#define NOACC_LABEL = 1
#endif
#endif

#if GTK_MINOR_VERSION < 8
#ifndef NOIMAGEBUTTON
#define NOIMAGEBUTTON = 1
#endif
#endif

#if GTK_MINOR_VERSION < 10
#ifndef NODELETABLE_PROP
#define NODELETABLE_PROP = 1
#endif
#endif

#if GTK_MINOR_VERSION < 12
#ifndef NOCELL_LAYOUT_GET_CELLS
#define NOCELL_LAYOUT_GET_CELLS = 1
#endif
#endif

#if GTK_MINOR_VERSION < 24
#ifndef HAVE_DRAWABLE
#define HAVE_DRAWABLE = 1
#endif
#endif

#if GLIB_MINOR_VERSION <= 2
#ifndef VERY_LOW_GVERSION
#define VERY_LOW_GVERSION = 1
#endif
#endif

#if GLIB_MINOR_VERSION < 14
#ifndef NOADD_SECS
#define NOADD_SECS = 1
#endif
#endif

#endif

#define Black    { 0,     0,     0,     0}
#define Yellow   { 0, 65535, 65535,  6000}
#define Blue     { 0,  6656, 17920, 31744}
#define White    { 0, 65535, 65535, 65535}
#define Red      { 0, 65535,     0,     0}
#define Green    { 0,     0, 65535,     0}
#define DarkBlue { 0,     0,     0, 20000}
#define Light    { 0, 61166, 61166, 61166}

#ifdef GDK_WINDOWING_WIN32
  #define MY_FONT_SIZE 8
#elif defined (GDK_WINDOWING_X11)
  #define MY_FONT_SIZE 9
#else
  #define MY_FONT_SIZE 12
#endif
#define USE_MY_FONT_SIZE 1
#undef USE_MY_FONT_SIZE 

#define HOOKUP_OBJECT(component,widget,name) \
   g_object_set_data (G_OBJECT (component), name, widget)

typedef struct {
                 bool          Bold;
                 float         size;
                 const char   *color;
                 GtkShadowType shadow_type;
                 int           top_p, bottom_p, left_p, right_p;
               } _StyleType; 

static _StyleType TabStyleDef = {false, 0, NULL, GTK_SHADOW_NONE, 6, 6, 20, 6};
static _StyleType FrameStyleDef = {true, 1, NULL, GTK_SHADOW_NONE, 6, 6, 20, 6};

typedef struct {
                 GtkWidget  *window;
                 const char *name;
               } chiudi_dlg_data;
void chiudi_dlg(GtkWidget *button, gpointer data);


void set_mandatory(GtkWidget *label);
gchar *find_pixmap_file (const gchar *filename);
bool parse_text(const char *str_in);
GtkWidget*  lookup_widget              (GtkWidget       *widget,
                                        const gchar     *widget_name);
GObject *lookup_object (GtkWidget *widget, const gchar *widget_name);
char *special_car_greek(int chr);
char *special_car(int chr);
GtkWidget *get_widget(GtkWidget *father, const char *name);
GtkWidget *get_widget_num(GtkWidget *father, const char *name, int num);
gpointer get_object(GtkWidget *father, const char *name);
int get_int(gpointer father, const char *name);
char *get_string(GtkWidget *father, const char *name);
char *getpwd (void);
void add_pixmap_directory (const gchar     *directory);
GtkWidget *create_pixmap (GtkWidget  *, const gchar     *filename);
GdkPixbuf *dummy_pixbuf();
GdkPixbuf *create_pixbuf  (const gchar *filename);
GdkPixbufAnimation*  mr_load_animation (const gchar     *filename);
void set_icon (GtkWidget *window, const gchar *filename);
GtkWidget *xpm_button(const gchar  *xpm_filename);
GtkWidget *toolbar_button(const gchar  *xpm_filename, const gchar *label=NULL);
#ifdef USE_TOOLBAR
GtkToolItem *toolpalette_button(const gchar  *xpm_filename, const gchar *label);
#endif
GtkWidget* create_image (const gchar *filename);
GtkWidget *create_menuicon(const gchar *filename, int w, int h);
void register_stock_icon (const char *stock_id);
void set_entry_text(GtkWidget *widget, const char *testo);
void set_label_text(GtkWidget *label, const char *string, const char *color, float factor);
void set_label_text(GtkWidget *label, const char *string, const char *color, float factor, int ifmne);
GtkWidget *NewNotebook(GtkWidget *father);
void set_label_text(GtkWidget *label, const char *string, const char *color=NULL);
void set_tab_label(GtkNotebook *notebook, int npag, const char *label,
                   _StyleType *style=&TabStyleDef);
GtkWidget *get_tab_label(GtkNotebook *notebook, GtkWidget *child);
GtkWidget *LABEL_BOLD_WITH_FONT(const char *string, const gchar *color, float factor,
                                PangoFontDescription *fdesc);
GtkWidget *LABEL_BOLD(const char *string, const gchar *color, float factor);
GtkWidget *LABEL_BOLD(const char *string, const gchar *color, float factor, int ifmne);
GtkWidget *LABEL_NEW(const char *string, const gchar *color);
GtkWidget *LABEL_NEW(const char *string, const gchar *color, int ifmne);
GtkWidget *label_boxed (const gchar  *string);
GtkWidget *xpm_menu_item(const gchar *xpm_filename, const gchar *labeltext,
                         gboolean ifmne);
GtkWidget *SPIN_WITH_LABEL(const gchar *string, const char *colore, double vmin,
         double vmax, double val, double step, int ncifre, int ori=0);
GtkWidget *BrowseButton();
GtkWidget *entry_for_filesel(GtkWidget *parentbox, const char *labelstring,
                             const char *entryname, 
                             int ifPreview, int ifBrowse, int ifModify=0);  
int get_hFont(PangoFontDescription *font_desc);
void PrintFile(GtkWidget *dlg, const char *file);
int load_file_into_buffer(const char *filename, GtkTextBuffer *text, int flags);
GtkWidget *image_button(const char *imagename);
GtkWidget *myimage_button(const gchar *label, const gchar  *filename);
GtkWidget *myimage_togbutton(const gchar  *filename);
char *get_spg(gchar *spgstring, int ifSilent);
int GetSpgNum(char *spacegroupname, float r[], int *nsymop=NULL);
void clear_list(GtkWidget *list);
void add_line_to_list(GtkWidget *list, gpointer line, gint ncol=0);
void add_gen_line_to_list(GtkWidget *list, int n, ...);
gpointer get_selection_from_path(GtkTreeView *tree_view, GtkTreePath *path);
gpointer get_selection_from_pathC(GtkTreeView *tree_view, GtkTreePath *path, int col);
void unselect_all(GtkTreeView *list, bool block_hnd=false);
GtkSelectionMode get_selection_mode(GtkWidget *list);
void set_selection_mode(GtkWidget *list, GtkSelectionMode mode);
GList *get_selections(GtkWidget *list);
gchar *get_selected_row(GtkWidget *list);
gchar *get_selected_row_col(GtkWidget *list, int col);
void populate_listg(GtkTreeView *list, GList *values);
void populate_selection(GtkTreeView *list, GList *values_1, GList *values_2);
gchar *get_text(GtkTextView *tw);
void clear_text (GtkWidget *text_view);
void put_text(GtkWidget *w, const char *text, const char *tagname=NULL);
int get_selected_row_num(GtkWidget *list);
int row_selected (GtkTreeSelection *sele);
GList *copy_selection_to_list(GtkWidget *selec);
void populate_list(GtkTreeView *list, gchar *values[], int numval, int ifClear);
void populate_list(GtkTreeView *list, const gchar *values[], int numval, int ifClear);
void set_listfont(GtkWidget *treeview,PangoFontDescription *fd, int col);
void set_wrapwidth(GtkWidget *treeview,int w, int col);
int n_colonne (GtkWidget *list);
void remove_nth_line(GtkWidget *widget, int n);
int n_children (GtkWidget *list);
void select_row (GtkWidget *list, int row, bool block_hnd=false);
void unselect_row (GtkWidget *list, int row);
char *get_selected_row_path(GtkWidget *list);
void get_selected_rownums(GtkWidget *selec, int selvet[]);
void remove_selection(GtkWidget *list);
gpointer get_nth_row(GtkWidget *list, int nrow, int ncol);
GtkWidget *createSelection(GtkWidget *parent, GtkWidget *parentbox,
           const char *title, const char *id, int formato, const char *col);
GtkWidget *new_selection(GtkWidget *parent, GtkWidget *parentbox, 
           const char *id, int ncol, const char *titles[], 
           int sizes[], GType *types=NULL, int *precs=NULL,
           bool *editable=NULL, GCallback edit_func=NULL);
gboolean find_elem_in_list(GtkWidget *list, const char *str, int ncolumn);
std::string fToStr(float num, int precision);
std::string fToStr2(float num, int precision);

GtkTreeViewColumn *get_column(GtkWidget *filsel, int ncol);
void clear_store(GtkWidget *list);
void populate_model (GtkTreeView *list, GList *chains, GList **residues, int ifClear);
void create_tree_store (GtkWidget *father, GtkWidget *parent, const char *name, GCallback cb, GtkWidget *cb_data);
GtkWidget *create_combo_str(GCallback cb, gpointer data, bool with_entry = true);
GtkWidget *create_combo_str(bool with_entry = true);
void get_comboselection (GtkWidget *widget, int *val);
void fill_combo(GtkWidget *option_button, const char *labels[],
                              int nlabels, int def_b);
GtkWidget *create_combo(GtkWidget *parentbox, const char *items[], int n_items,
                        int default_selected, int *val, GCallback cb=NULL,
                        bool with_entry = true);
void set_popdown_strings (GtkWidget *combo, GList *strings);
void fill_my_combog (GtkWidget *combo, GList *strings);
GtkWidget *create_combog(GList *items, int default_selected);
void combo_set_val (GtkWidget *combo, int val);
int  combo_get_val (GtkWidget *combo);
gchar *combo_get_text(GtkWidget *combo);

void URLOpen(std::string Url, std::string Internet_Browser, GtkWidget *dlg);
void OpenPdf(std::string pdfFile, GtkWidget *dlg);

void get_metrics(PangoFontDescription *font_desc,
                 int *char_width, int *char_height);
GtkWidget *hypertext_new(const char *string, const char *browser);
void set_hypertext(GtkWidget *label, const char *string);
int MessageDialog(GtkWidget *parent, GtkMessageType type, 
            GtkButtonsType buttons, const gchar *message, ...) ;
int MessageDialog(const char *title, GtkWidget *parent, GtkMessageType type, 
            GtkButtonsType buttons, const gchar *message, ...) ;
int MessageDialog(const char *title, int timeout, int def, GtkWidget *parent,
            GtkMessageType type, 
            GtkButtonsType buttons, const gchar *message, ...);

void setSmiley(GtkWidget *wind, const char *filenam);
void resetSmiley(GtkWidget *wind);
GList *fill_list(const char *stringa, const char *delimiter);
int num_fields(const char *stringa, const char *delim);
void get_int_tokens (const char *str, const char *c, int num_tokens, int my_tokens[]);
void get_float_tokens (const char *str, const char *c, int num_tokens, float my_tokens[]);
int get_str_tokens (const char *str, const char *c, int num_tokens, char *my_tokens[]);
typedef enum {
                 CROSS_CURSOR = 0,
                 WAIT_CURSOR  = 1,
                 HAND_CURSOR  = 2,
                 MOVE_CURSOR  = 3,
                 PICK_CURSOR  = 4,
                 DRAG1_CURSOR = 5,
                 DRAG2_CURSOR = 6,
                 ZOOM_CURSOR  = 7} cursors;

#ifdef NOCURS_FROM_PIXBUF
typedef struct {
                int width;
                int height;
                int x_hot;
                int y_hot;
                char *bits_bmp;
                char *bits_msk;
               } my_cursor;
#else
typedef struct {
                int x_hot;
                int y_hot;
                const char *filename;
               } my_cursor;
#endif

GType pix_num_get_type (void);
GdkPixbuf *create_rect(float col[]);
      
#define PIX_NUM_TYPE pix_num_get_type ()
typedef struct {
                 int num;
                 GdkPixbuf *icon;
               } PixNum;

GdkCursor *create_my_cursor(cursors tipo);
GtkWidget *ScrolledText (GtkWidget *parent);
void ClearText(GtkWidget *textview);
gchar *GetTextW(GtkWidget *textview);
gboolean true_cb (GtkWidget *widget, GdkEventAny *event, gpointer data);

GtkWidget   *NEW_FRAME          (const gchar  *string, bool show_frame);
GtkWidget   *NEW_FRAME          (const gchar  *string, 
                                 _StyleType *style=&FrameStyleDef);
GtkWidget   *FRAME_NEW          (const gchar  *string, const char *col);
GtkWidget   *FRAME_BOLD         (const gchar  *string, const char *col,
                                float sc_fac);
GtkWidget   *FRAME_BOLD         (const gchar  *string, const char *col,
                                float sc_fac, int ifmne);
GtkWidget   *SPIN_WITH_LABEL2   (const gchar *string, const gchar *col,
                                double vmin, double vmax, double val,
                                double step, int ncifre, gboolean use_default);
GtkWidget *SPIN_NEW(double vmin, double vmax, double val, double step, int ncifre);
GtkWidget   *RADIO_BUTTON_WITH_LABEL    (GSList *gr, const gchar *string, const char *color, int ifmne);
GtkWidget   *RADIO_BUTTON_WITH_LABEL    (GSList *gr, const gchar *string, const char *color);
GtkWidget   *RADIO_BUTTON_WITH_LABELW   (GtkRadioButton *radio, const char *string, const char *color);
GtkWidget   *CHECK_BUTTON_WITH_LABEL    (const gchar     *string, const char *colore);
GtkWidget *CHECK_BUTTON_WITH_LABEL(const char *string, const char *color, int ifmne);
GtkWidget   *CHECK_BUTTON_BOLD          (const gchar     *string, const char *colore, float factor);
GtkWidget   *RADIO_BUTTON_BOLD          (const gchar     *string, const char *colore, float factor);
GtkWidget   *TOGGLE_BUTTON_WITH_LABEL   (const gchar     *string);
GtkWidget   *TOGGLE_BUTTON_WITH_LABEL   (const gchar     *string, const char *color);
void       on_cb_attiva                 (GtkToggleButton *button, GtkWidget *wid);
void       on_cb_disattiva              (GtkToggleButton *button, GtkWidget *wid);
void       button_set_label             (GtkButton *button, const gchar *label);
GtkWidget *show_image                   (const gchar *filename, const gchar *title, GtkWidget *parent);
void       set_widget_font              (GtkWidget *wid, const char *font);
void       set_widget_fontN             (GtkWidget *widget, double fact=1.);
PangoFontDescription *get_fontN         (const char *desc, double fact=1.);
PangoFontDescription *get_font          (double fact=1., int dime=0);
PangoFontDescription *get_fontP         (int sz);
GtkWidget  *spgr_widget                 (const char *filespg, int ifSilent);
                                                                                                             
GtkWidget* mr_toggle_button_new_with_color (void);
GtkWidget* mr_toggle_button_new_with_pixmap(GtkWidget *pix1, gboolean ini);

void set_widget_color (GtkWidget *widget, GdkColor colore);
void set_widget_color (GtkWidget *widget, GdkColor *colore);
void set_error_color(GtkWidget *widget, bool err);
void set_label_color (GtkWidget *widget, const char *colore);
void set_bg_color (GtkWidget *widget, GdkColor colore);
void set_text_color (GtkWidget *widget, const char *colore);

GtkWidget *create_frame_colors(GtkWidget *dialog1, GCallback cb_func);
void ToggleButtons (GtkWidget *win, int colore_attivo);
void ResetButtons (GtkWidget *win);
void myshow_mtz(const std::string &fn, GtkWindow *window);
void Read_PDB(const std::string &fn, int &nres0, int &nres1,
            int &numeroResidui);

void *get_nth_field (const char *str, const char *c, int n_field, char type);
size_t read_project(const char *fn, char *str, size_t dime);
int open_project(const char *fn, std::ifstream &f);
size_t read_project(std::ifstream &f, char *str, size_t dime);
int run_command(const std::string &exe, const std::vector<std::string> &args ,
                std::string &msg, int s=0, char **buffer=NULL, char **errbuf=NULL);
std::string strstrip(std::string &s);
void block_handler(GtkWidget *combo);
void unblock_handler(GtkWidget *combo);
int GetMtzCols(std::string fn, std::string &MtzCols);
gboolean on_entry_focus_in_event  (GtkWidget  *widget, GdkEventFocus *event,
                                    gpointer user_data);
void mremove(const char *filter);
const char *get_ext(std::string &filename);
int fill_formats( std::vector<std::string> &vecExts, std::string &strExts);
int fill_formats(std::vector<std::string> &types,
                 std::vector<std::string> &exts, std::string &extensions);
int find_extension_in_list(std::string &fn, std::vector<std::string> exts);
char *get_exts_from_filter(const char *filtro);
void fill_list_exts(const char *extensions, std::vector<std::string> &exts);

GtkWidget *create_combo(GtkWidget *parentbox, GList *items,
                        int default_selected, int *val);

typedef struct {
                int          level;
                int          type;
                const char   *name;
                const char   *string;
                const char   *tip;
                const char   *icon;
                GCallback    cb;
                const char   *accel;
                int          num;
                int          abi;
                int          stato;
                } mr_action_entry;

#ifdef USE_ACTIONS
void set_tooltips_on_menu(GtkWidget *top, guint n_entries,
                          mr_action_entry menu_entries[]);
GtkWidget *get_widget_from_action(GtkAction *act, GtkWidget *top=NULL);
GtkAction *get_action_from_widget(GtkWidget *w, GtkWidget *top);
#endif

typedef struct {
                GtkWidget     *statusbar;
                const char    *msg;
               } Re_data;

void SetMainMenu(GtkWidget *menubar, bool set_ready);

GtkWidget* CreateMenubar(GtkWidget  *window, mr_action_entry menu_items[],
                         guint n_menu_items,
                         int w=16, int h=16, bool ifmne=true);

GtkWidget *CreateToolbar(GtkWidget *father, int orientation,
                           mr_action_entry tb_entries[], guint n_tb_entries);

#ifdef USE_ACTIONS
GtkWidget *CreateMenubar(GtkWidget  *window, const char *info,
                         GtkUIManager *merge,  GtkActionGroup *action_group);
GtkWidget *CreateToolbar(GtkWidget  *window, const char *info,
                         GtkUIManager *merge,  GtkActionGroup *action_group,
                         const char *nome ="ToolBar", int ori=0);
void AddUIManager(GtkWidget  *window, const char *info,
                 GtkUIManager *merge);
GtkActionGroup *CreateActionGroup(GtkWidget  *window, guint n_entries,
          mr_action_entry menu_entries[], const char *fathername);
#endif
GtkWidget *CreateToolpalette(GtkWidget *father, mr_action_entry tb[]);

void       AddWelcomeMessage         (GtkWidget *statusbar, const char*msg);
gboolean   RefreshWelcomeMessage     (gpointer data);

void obj_set_active(gpointer w, gboolean act, bool ifBlock=false);
void obj_set_visible(gpointer w, gboolean vis);
void obj_show(gpointer w);
void obj_hide(gpointer w);
void obj_set_label(gpointer w, const gchar *str);
const gchar *obj_get_label(gpointer w);
gboolean obj_get_active(gpointer w);
gboolean obj_get_visible(gpointer w);
void obj_set_sensitive(gpointer w, gboolean sens);
gboolean obj_get_sensitive(gpointer w);
void obj_activate(gpointer w);
GtkWidget *create_range(GtkWidget *father, GtkWidget *parent,
          const char *label, int orientation, const char *name=NULL);

inline GObject* adj_new  (gdouble value, gdouble lower, gdouble upper,
                          gdouble step_increment, gdouble page_increment)
{
    return G_OBJECT(gtk_adjustment_new(value, lower, upper, step_increment, page_increment, 0));
}

GtkWidget *color_button(const float colore[], const char *title);
GtkWidget *mycolor_button(const float *colore, const char *title,
              GCallback cb = NULL, gpointer data = NULL, const char *label=NULL);
void mycolor_button_get_color(GtkWidget *button, float *colore);
void mycolor_button_set_color(GtkWidget *button, const float *colore);
void color_button_get_color(GtkWidget *button, float colore[]);
void color_button_set_color(GtkWidget *button, const float colore[]);
const char *font_button_get_font_name(GtkWidget *button);
void font_button_set_font_name(GtkWidget *button, const char *fontname);
GtkWidget *font_button(const char *fontname);
int MY_MAJOR_VERSION(std::string vers);
int MY_MINOR_VERSION(std::string vers);
int MY_MICRO_VERSION(std::string vers);
int MY_NUM_VERSION(std::string vers);
void remove_children(GtkWidget *parent);
void dlg_warning(const gchar *fmt, ...);
bool dlgest_yesno(GtkWindow *parent, const gchar *fmt, ...);
void set_win_main(GtkWidget *win);
void set_tip(GtkWidget *widget, const char *tip);
void set_smil_tip(GtkWidget *widget, const char *tip);
void enable_tip(GtkWidget *widget, gboolean status);
GtkWidget *new_combo();
GdkPixbuf *pix_from_file_and_text(const char *file, char *text,
                                  PangoFontDescription *fontdesc,
                                  int x, int y, GdkColor *col, GtkWidget *w);
//DEPRECATED
#if GTK_MAJOR_VERSION < 3

inline gboolean IsTable(GtkWidget *w)
{
   return GTK_IS_TABLE(w);
}

inline void set_focus_visible(GtkWidget *w, gboolean visible)
{
}

GdkPixmap*  mr_load_pixmap_withmask    (GtkWidget       *widget, 
                                        const gchar     *filename,
                                        GdkBitmap       **mask);
inline GtkWidget *hpaned_new()
{
   return gtk_hpaned_new();
}

inline GtkWidget *vpaned_new()
{
   return gtk_vpaned_new();
}

#if GLIB_MINOR_VERSION < 28
inline gint64 g_get_real_time()
{
    GTimeVal tv;
    g_get_current_time (&tv);
    gint64 timer = (gint64)(tv.tv_sec*1e6 + tv.tv_usec);
    return timer;
}
#endif

#if GTK_MINOR_VERSION < 22
inline gint gdk_visual_get_bits_per_rgb(GdkVisual *visual)
{
   return (visual->bits_per_rgb);
}
#endif
#if GTK_MINOR_VERSION < 20
inline GtkWidget *gtk_statusbar_get_message_area(GtkStatusbar *sb)
{
   return(sb->label);
}
inline gboolean gtk_widget_get_mapped(GtkWidget *widget)
{
  return (gboolean) GTK_WIDGET_MAPPED(widget);
}
inline gboolean gtk_widget_get_realized(GtkWidget *widget)
{
  return (gboolean) GTK_WIDGET_REALIZED(widget);
}
#endif
#if GTK_MINOR_VERSION < 18
inline void gtk_widget_get_allocation (GtkWidget *widget,
                                       GtkAllocation *allocation)
{
     *allocation = widget->allocation;
}

inline gboolean gtk_widget_is_drawable(GtkWidget *widget)
{
  return (gboolean) GTK_WIDGET_DRAWABLE (widget);
}

inline gboolean gtk_widget_has_focus(GtkWidget *widget)
{
  return (gboolean) GTK_WIDGET_HAS_FOCUS (widget);
}

inline gboolean gtk_widget_has_default(GtkWidget *widget)
{
  return (gboolean) GTK_WIDGET_HAS_DEFAULT (widget);
}

inline gboolean gtk_widget_get_can_default(GtkWidget *widget)
{
  return (gboolean) GTK_WIDGET_CAN_DEFAULT (widget);
}

inline gboolean gtk_widget_get_has_window(GtkWidget *widget)
{
  return (gboolean) !GTK_WIDGET_NO_WINDOW (widget);
}

inline gboolean gtk_widget_get_visible(GtkWidget *widget)
{
  return (gboolean) GTK_WIDGET_VISIBLE (widget);
}

inline void gtk_widget_set_visible(GtkWidget *widget, gboolean show)
{
  if(show)
     gtk_widget_show(widget);
  else
     gtk_widget_hide(widget);
}

inline gboolean gtk_widget_is_sensitive(GtkWidget *widget)
{
  return (gboolean) GTK_WIDGET_SENSITIVE (widget);
}

inline gboolean gtk_widget_get_sensitive(GtkWidget *widget)
{
  return (gboolean) GTK_WIDGET_SENSITIVE (widget);
}

inline GtkStateType gtk_widget_get_state(GtkWidget *widget)
{
  return (GtkStateType) GTK_WIDGET_STATE(widget);
}

inline void gtk_widget_set_can_focus (GtkWidget *widget, gboolean can)
{
   if(can)
      GTK_WIDGET_SET_FLAGS (widget, GTK_CAN_FOCUS);
   else
      GTK_WIDGET_UNSET_FLAGS (widget, GTK_CAN_FOCUS);
}

inline void gtk_widget_set_can_default (GtkWidget *widget, gboolean can)
{
   if(can)
      GTK_WIDGET_SET_FLAGS (widget, GTK_CAN_DEFAULT);
   else
      GTK_WIDGET_UNSET_FLAGS (widget, GTK_CAN_DEFAULT);
}
#endif
#if GTK_MINOR_VERSION < 16
inline void gtk_menu_item_set_label (GtkMenuItem *menu_item, const gchar *label)
{
   GtkWidget *lab = (GTK_BIN(menu_item))->child;
   gtk_label_set_text(GTK_LABEL(lab), label);
}
#ifdef GTK_ACTION
inline const gchar *gtk_action_get_label(GtkAction *act)
{
   gchar *str;
   g_object_get(G_OBJECT(act), "label", &str, NULL);
   return str;
}

inline void gtk_action_set_label(GtkAction *act, const gchar *label)
{
   g_object_set(G_OBJECT(act), "label", label, NULL);
}

inline void gtk_action_block_activate(GtkAction *act)
{
}

inline void gtk_action_unblock_activate(GtkAction *act)
{
}

#endif
#endif
#if GTK_MINOR_VERSION < 14
inline GtkWidget *gtk_color_selection_dialog_get_color_selection(
                      GtkColorSelectionDialog * dlg)
{
   return (dlg->colorsel);
}

inline GdkWindow *gtk_widget_get_window (GtkWidget *widget)
{
   return (widget->window);
}
inline GtkWidget *gtk_dialog_get_content_area(GtkDialog *dlg)
{
   return dlg->vbox;
}
#endif

#if GTK_MINOR_VERSION < 2
inline  gtk_notebook_get_n_pages(GtkNotebook *nt)
{
  int i;
  for( i=0; 1 ; ++i ) {
    if(NULL == gtk_notebook_get_nth_page(nt, i) )
      break;
  }

  return i;
}
#endif

inline void add_to_scrollwin(GtkWidget *win, GtkWidget *w)
{
   gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(win), w);
}

inline void setta_colore(GtkWidget *label, const gchar *color)
{
   GdkColor gdkcolor;
   if(gdk_color_parse(color, &gdkcolor))
   {  
      gtk_widget_modify_fg(label, GTK_STATE_NORMAL, &gdkcolor);
      gtk_widget_modify_fg(label, GTK_STATE_ACTIVE, &gdkcolor);
      gtk_widget_modify_fg(label, GTK_STATE_SELECTED, &gdkcolor);
      gtk_widget_modify_fg(label, GTK_STATE_PRELIGHT, &gdkcolor);
   }
}

inline void setta_colorebg(GtkWidget *label, const gchar *color)
{
   GdkColor gdkcolor;
   if(gdk_color_parse(color, &gdkcolor))
   {
      gtk_widget_modify_bg(label, GTK_STATE_NORMAL, &gdkcolor);
      gtk_widget_modify_bg(label, GTK_STATE_ACTIVE, &gdkcolor);
      gtk_widget_modify_bg(label, GTK_STATE_SELECTED, &gdkcolor);
      gtk_widget_modify_bg(label, GTK_STATE_PRELIGHT, &gdkcolor);
   }
}

inline void set_width_chars(GtkEntry *entry, guint nchars)
{
     gtk_entry_set_width_chars(entry, nchars);
}

#else                     // GTK3


inline gboolean IsTable(GtkWidget *w)
{
   return GTK_IS_GRID(w);
}

#if GTK_MINOR_VERSION < 8
inline void add_to_scrollwin(GtkWidget *win, GtkWidget *w)
{
   gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(win), w);
}
#else
inline void add_to_scrollwin(GtkWidget *win, GtkWidget *w)
{
   gtk_container_add(GTK_CONTAINER(win), w);
}
#endif

#if GTK_MINOR_VERSION < 2
inline void set_focus_visible(GtkWidget *w, gboolean visible)
{
}
#else
inline void set_focus_visible(GtkWidget *w, gboolean visible)
{
    gtk_window_set_focus_visible(GTK_WINDOW(w), visible);
}
#endif

inline GtkWidget *hpaned_new()
{
   return gtk_paned_new(GTK_ORIENTATION_HORIZONTAL);
}

inline GtkWidget *vpaned_new()
{
   return gtk_paned_new(GTK_ORIENTATION_VERTICAL);
}

inline void setta_colore(GtkWidget *label, const gchar *color)
{
    std::string nome= "text";
    if(color)
    {
       nome.append(color);
       gtk_widget_set_name(label, nome.c_str());
    }
#if 0
   GdkRGBA rgbacolor;
   if(gdk_rgba_parse(&rgbacolor, color))
   {
      gtk_widget_override_color(label, GTK_STATE_FLAG_NORMAL, &rgbacolor);
      gtk_widget_override_color(label, GTK_STATE_FLAG_ACTIVE, &rgbacolor);
      gtk_widget_override_color(label, GTK_STATE_FLAG_SELECTED, &rgbacolor);
      gtk_widget_override_color(label, GTK_STATE_FLAG_PRELIGHT, &rgbacolor);
      gtk_widget_override_color(label, GTK_STATE_FLAG_INSENSITIVE, NULL);
   }
#endif
}

inline void setta_colorebg(GtkWidget *label, const gchar *color)
{
    std::string nome= "bg";
    if(color)
    {
       nome.append(color);
       gtk_widget_set_name(label, nome.c_str());
    }
#if 0
   GdkRGBA rgbacolor;
   if(gdk_rgba_parse(&rgbacolor, color))
   {
      gtk_widget_override_background_color(label, GTK_STATE_FLAG_NORMAL, &rgbacolor);
      gtk_widget_override_background_color(label, GTK_STATE_FLAG_ACTIVE, &rgbacolor);
      gtk_widget_override_background_color(label, GTK_STATE_FLAG_SELECTED, &rgbacolor);
      gtk_widget_override_background_color(label, GTK_STATE_FLAG_PRELIGHT, &rgbacolor);
      gtk_widget_override_background_color(label, GTK_STATE_FLAG_INSENSITIVE, NULL);
   }
#endif
}

inline void set_width_chars(GtkEntry *entry, guint nchars)
{
     gtk_entry_set_width_chars(entry, nchars);
#if GTK_MINOR_VERSION >= 12
     gtk_entry_set_max_width_chars(entry, nchars);
#endif
}
#endif

float *ToColor3f(const GdkColor *gdkcolor);
float *ToColor4f(const GdkColor *gdkcolor);
GdkColor *ToGdkColor(const float color[]);

//Cairo support
#define USE_CAIRO 1
#if !defined CAIRO_VERSION 
  #undef USE_CAIRO
#endif

#ifdef DONOT_USE_CAIRO
  #undef USE_CAIRO
#endif

#define USE_CAIRO_RENDERING 1
#ifndef USE_CAIRO
  #undef USE_CAIRO_RENDERING
#elif CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
  #undef USE_CAIRO_RENDERING
#endif
#define HAVE_SUBPATH 1
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
  #undef HAVE_SUBPATH
#endif

//le font sembrano migliori senza
//#ifndef MACOSX
//#undef USE_CAIRO_RENDERING
//#endif


typedef struct {
                 gpointer os;
                 gpointer gc;
               } os_and_gc;
#ifdef USE_CAIRO
#define STRIDE 4
#else
#define STRIDE 3
#endif

void draw_string(gpointer outPix,PangoFontDescription *fontdesc,
                 gpointer context, int xb, int yb, const char *string,
                 GdkColor *fore,GdkColor *back, PangoAlignment alignment=PANGO_ALIGN_LEFT);
void draw_Vstring(gpointer outPix, PangoFontDescription *fontdesc,
                gpointer context, int xb, int yb, const char *string,
                GdkColor *fore, GdkColor *back, int yalign);
void draw_Vstring(gpointer outPix, PangoFontDescription *fontdesc,
                gpointer context, int xb, int yb, const char *string,
                GdkColor *fore, int yalign);
void destroy_os_and_gc(gpointer os, gpointer gc);
os_and_gc *get_os_and_gc(GtkWidget* widget);
void disegna_pixnew(gpointer winout, gpointer context, gpointer myp,
                    int xb, int yb, int *xd, int *yd,
                    bool force_pos=false);
void disegna_pix(gpointer winout, gpointer context,
                 gpointer myp, int xb, int yb);
gpointer pixbuf_get_from_struct(os_and_gc *rt);
os_and_gc *create_cairo_stuff(int wi, int he, GtkWidget *w);
GdkPixbuf *pixbuf_get_from_cairo_stuff(gpointer p1, int wi, int he);
void save_pixbuf_from_window(GtkWidget *vw, const char *filename);
void save_pixbuf_from_mem(os_and_gc *rt, const char *filename);
void set_clip(GtkWidget *win,  gpointer context);
void set_foreground(gpointer context, GdkColor *colore);
void draw_rectangle(gpointer win, gpointer context, gboolean ifFill,
                    int x1, int y1, int width, int height);
void draw_rectangle(gpointer win, gpointer context, gboolean ifFill,
                    gpointer rect);
void draw_rectangle2(gpointer win, gpointer context, gboolean ifFill,
                    int x1, int y1, int width, int height, float col[]);
void draw_line(gpointer win, gpointer context, int x1, int y1, int x2, int y2, int lw=1);
void draw_segments(gpointer win, gpointer context, GdkSegment *segs, int ns);
void draw_circle(gpointer win, gpointer context, gboolean ifFill,
              int x1, int y1, int d);
void draw_arc(gpointer win, gpointer context, gboolean ifFill,
              int x1, int y1, int d, int ang1, int ang2);
void draw_sector(gpointer win, gpointer context, gboolean ifFill,
              int x1, int y1, int d, int ang1, int ang2);
void draw_ell(gpointer win, gpointer context, gboolean ifFill,
              int x1, int y1, int width, int height, int ang1, int ang2);
void draw_polygon(gpointer win, gpointer context, gboolean ifFill,
              GdkPoint *points, int npoints);
void draw_lines(gpointer win, gpointer context, 
              GdkPoint *points, int npoints, int lw=1);
void draw_lines_aa(gpointer win, gpointer context, 
              GdkPoint *points, int npoints);
void draw_point(gpointer win, gpointer context, int x, int y);
void draw_points(gpointer win, gpointer context, GdkPoint *p, int np);
void drawable_get_size(gpointer mypixmap, int *wi, int *he);
gpointer  mr_load_pixmap             (GtkWidget       *widget, 
                                        const gchar     *filename);
gpointer draw_rgb_image (gpointer outPix, gpointer context, 
                     int x, int y, int w, int h,
                     unsigned char *fbuffer, int stride);
void render_pixbuf_to_drawable(gpointer mypixmap, gpointer winout,
                               gpointer contest, int xdest, int ydest);
void draw_drawable(gpointer win, gpointer context, gpointer mypixmap, 
                   int xdest, int ydest);
void draw_drawable(gpointer win, gpointer context, gpointer mypixmap, 
                   int xsrc, int ysrc, int xdest, int ydest,int w, int h);
void set_dash_style(gpointer context);
void reset_style(gpointer context);
gpointer region_new();
gpointer region_rectangle(gpointer rectangle);
void  region_destroy(gpointer region);
void region_get_clipbox (gpointer region, GdkRectangle *rectangle);
gboolean point_in_region(gpointer region, int x, int y);
gpointer create_initial_pix(const gchar *filename);
gpointer create_surface_from_png(const gchar *filename);
void flush_os(gpointer outPix, gpointer outWindow, gpointer context);
void palla_sfumata(gpointer context, gpointer outPix, 
                         int x, int y, int raggio, GdkColor *col);
int  MRblend  (int fg, int bg, double fgfactor, double flim) ;
double MRblend(double fg, double bg, double fgfactor, double flim);
GtkWidget *myimage_button(const gchar *label, const gchar  *filename);
void myimage_button_set_text(GtkWidget *but, const char *text);
inline GtkWidget   *OK_button    () { return myimage_button("   _OK", "ok.png"); }
inline GtkWidget   *QUIT_button  () { return myimage_button("   _Quit", "quit.png"); }
inline GtkWidget   *HELP_button  () { return myimage_button("   _Help", "help.png"); }
inline GtkWidget   *CANCEL_button() { return myimage_button("_Cancel", "cancel.png"); }
inline GtkWidget   *CLOSE_button () { return myimage_button("_Close ", "cancel.png"); }
inline GtkWidget   *APPLY_button () { return myimage_button("  _Apply", "apply.png"); }
inline GtkWidget   *RESET_button () { return myimage_button("  _Reset", "reset1.png"); }
inline GtkWidget   *GO_button    () { return myimage_button("  _Execute", "go.png"); }
inline GtkWidget   *SAVE_button  () { return myimage_button(" _Save\nrestraints", "save.png"); }
inline GtkWidget   *OPEN_button  () { return myimage_button(" _Load\nrestraints", "opensir.png");}
inline GtkWidget   *DEFAULTS_button  () { return myimage_button(" _Defaults", "reset.png");}
inline GtkWidget   *RUN_button   () { return myimage_button("  _Run", "go.png"); };

void sync_menubar();
GtkWidget *combo_new();
GtkWidget *combo_box_new();
void combo_remove_text(GtkWidget *combo);
void combo_insert_text(GtkWidget *combo, int i, const char *str);
gboolean AcceptLicence(std::string LicFile, std::string dire);
GtkWidget *MRcombo_new(const char *strings[], 
                       void (*selection_cb) (GtkWidget *w, int val),
                       int def_selected, int nlabels);
void MRcombo_set_val(GtkWidget *combo, int val, bool ifBlock=false);
void free_context(gpointer cr);
void UpdateCheck(GtkWidget *father, int result, int *checkstatus,
                  const char *v=NULL);
void ShowWaitCursor(GtkWidget *window);
void HideWaitCursor(GtkWidget *window);
void widget_modify_font(GtkWidget *widget, PangoFontDescription *font_desc);
void widget_modify_fg(GtkWidget *widget, int state, const float *colore);
void widget_modify_bg(GtkWidget *widget, int state, GdkColor *colore);
void widget_modify_text(GtkWidget *widget, int state, GdkColor *colore);
void widget_modify_base(GtkWidget *widget, int state, GdkColor *colore);
PangoFontDescription *DefaultFont();
PangoFontDescription *DefaultFontMono();
void set_right_justified(GtkWidget *item);
void widget_size_request(GtkWidget *w, GtkRequisition *req);
GtkWidget *scrolled_text (GtkWidget *box1, bool ifScroll=true);
GtkWidget *scrolled_labeltext (GtkWidget *box1, bool ifScroll=true);
GtkWidget *OpenContactWindow(GtkWidget *mv);
void CloseContactWindow(GtkWidget *w);

namespace gtkext
{
  enum e_select_type {
    eSELECT_TO_READ = 0,
    eSELECT_TO_WRITE = 1,
    eSELECT_DIR = 2,
    eSELECT_NP = 3,
    eSELECT_ALIEN = 4
  };
  enum edit_flags
  {
  IFPROP     = 1 << 0,
  IFSAVE     = 1 << 1,
  IFSAVEAS   = 1 << 2,
  IFOPEN     = 1 << 3,
  IFREADONLY = 1 << 4,
  IFMARKUP   = 1 << 5,
  IFWRAP     = 1 << 6
  } ;

typedef enum {NEW = 1, OPEN, SAVE, SAVEAS, PRINT, FIND, EXIT, CHSIZE} bottoni;

typedef struct _FilselItem FilselItem;
struct _FilselItem{
                char *title;
                char *label;
                char *filter;
                gboolean ifEditable;
                gboolean ifPreview;
                gboolean ifOutput;
                gboolean ifAlpha;
                gboolean ifExe;
                gboolean ifSave;
                gboolean ifMultiple;
                gboolean ifDirOnly;
                gboolean AllFiles;
                gboolean nofilter;
                gboolean ifDisp;
                char *fileinp;
                char *cwd;
                char *fileout;
                GList *selection;
                int exitCode;
                PangoFontDescription *fd;
                GtkWidget *window;
                int nfilt;
               } ;

typedef struct {
                char          *title;
                char          *text1;
                char          *htext1;
                char          *text2;
                char          *htext2;
                char          *text3;
                char          *htext3;
                char          *text4;
                char          *htext4;
                char          *text5;
                char          *htext5;
                char          *image;
                char          *browser;
               } AboutItem;

void dlg_errmsg(GtkWindow *parent, const gchar *fmt, ...);
void dlg_errmsg(const gchar *fmt, ...);
void on_click (GtkWidget *button, gpointer data);
inline void dlg_errmsg(GtkWindow *parent, const std::string &msg)
  { dlg_errmsg(parent, "%s", msg.c_str()); }
gboolean dlg_yesno(GtkWindow *parent, const gchar *fmt, ...);
std::string dlg_select_file(GtkWidget *mw, const std::string &fn, e_select_type flags, const char *pattern=0, bool showT=true, bool *ifT=0, bool ifAll=true, int *tipo=NULL, bool showD=false, bool *ifD=0);
void file_open(FilselItem *local_it, bool showT=true, bool showD=false);
FilselItem saveas  (GtkWidget *mw, const char *filter, const char *filenam, bool ifAll=true);
void text_window(GtkWindow *winmain, const char *filnam, const char *filter, int flags, const char *title);
void text_window(GtkWindow *winmain, const char *filnam, const char *filter, int flags, const char *title,
                   int wid, int hei);
int text_width(PangoFontDescription *fontdesc, const char *text);
bool is_monospace(const char *fontnam);
char*  get_filt(char *filnam);
void clistfiles(const char *filter, std::vector<std::string> &Files);
GdkPixbuf *get_pixbuf(GtkWidget *dlg, char quale);
void dir_selected(GtkTreeView *tree_view, GtkTreePath *path,
                   GtkTreeViewColumn *column, gpointer user_data);
void change_default(GtkWidget *list);
void check_default(GtkWidget *list, const char *filename);
std::string GetTmpFile();
void riempi_list(GtkWidget *list);
void riempi_listNew(GtkWidget *list);
GtkWidget* create_about_dialog (GtkWidget *mwin, AboutItem *it);
void  mr_CopyDir(const char *dirold, const char *dirnew, bool ifOverride=false);
void mr_make_absolute_path(char *name, char *dirname=NULL);
}

#if GTK_MAJOR_VERSION >= 3
void RGBAToGdk(GdkRGBA  color_rgba, GdkColor *gdkcolor);

inline void widget_set_prelight(GtkWidget *w)
{
    gtk_widget_set_state_flags(w, GTK_STATE_FLAG_PRELIGHT, 1);
}

inline void widget_set_unselected(GtkWidget *w)
{
    gtk_widget_unset_state_flags(w, GTK_STATE_FLAG_SELECTED);
}

inline void widget_set_selected(GtkWidget *w)
{
    gtk_widget_set_state_flags(w, GTK_STATE_FLAG_SELECTED, 1);
}

inline GtkWidget* vbox_new(gboolean homogeneous, gint spacing)
{
    GtkWidget *box = gtk_box_new(GTK_ORIENTATION_VERTICAL, spacing);
    gtk_box_set_homogeneous(GTK_BOX(box), homogeneous);
    return box;
}

inline GtkWidget* hbox_new(gboolean homogeneous, gint spacing)
{
    GtkWidget *box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, spacing);
    gtk_box_set_homogeneous(GTK_BOX(box), homogeneous);
    return box;
}

inline GtkWidget* vseparator_new()
{
    return gtk_separator_new(GTK_ORIENTATION_VERTICAL);
}

inline GtkWidget* hseparator_new()
{
    return gtk_separator_new(GTK_ORIENTATION_HORIZONTAL);
}

inline GtkWidget* hbutton_box_new()
{
    return gtk_button_box_new(GTK_ORIENTATION_HORIZONTAL);
}

inline GtkWidget* vscale_new_with_range(gdouble min, gdouble max, gdouble step)
{
    return gtk_scale_new_with_range(GTK_ORIENTATION_VERTICAL, min, max, step);
}

inline GtkWidget* hscale_new_with_range(gdouble min, gdouble max, gdouble step)
{
    return gtk_scale_new_with_range(GTK_ORIENTATION_HORIZONTAL, min, max, step);
}

inline GtkWidget* hscale_new(GtkAdjustment *adj)
{
    return gtk_scale_new(GTK_ORIENTATION_HORIZONTAL, adj);
}

inline GtkWidget *table_new(guint rows, guint columns, gboolean homogeneous)
{
    GtkWidget *table = gtk_grid_new();
    gtk_grid_set_row_homogeneous(GTK_GRID(table), homogeneous);
    gtk_grid_set_column_homogeneous(GTK_GRID(table), homogeneous);
    return table;
}

inline void table_resize(GtkWidget *table, guint rows, guint columns)
{
}

inline void table_attach(GtkWidget *table, GtkWidget *w, guint left,
         guint right, guint top, guint bottom, gboolean expand=FALSE)
{
    gtk_grid_attach(GTK_GRID(table), w, left, top, right-left, bottom-top);
//    if(expand)
    {
       gtk_widget_set_hexpand(w, expand);
//       gtk_widget_set_vexpand(w, expand);
    }
}

inline void table_attach_all(GtkWidget *table, GtkWidget *w, guint left,
         guint right, guint top, guint bottom)
{
    gtk_grid_attach(GTK_GRID(table), w, left, top, right-left, bottom-top);
}

inline void table_attach_exp(GtkWidget *table, GtkWidget *w, guint left,
         guint right, guint top, guint bottom)
{
    gtk_grid_attach(GTK_GRID(table), w, left, top, right-left, bottom-top);
       gtk_widget_set_hexpand(w, FALSE);
}

inline void table_set_row_spacings(GtkWidget *table, guint space)
{
      gtk_grid_set_row_spacing(GTK_GRID(table), space);
}

inline void table_set_col_spacings(GtkWidget *table, guint space)
{
      gtk_grid_set_column_spacing(GTK_GRID(table), space);
}

inline void set_margins(GtkWidget *frame, gint top_p, gint bottom_p,gint left_p,
                gint right_p)
{
#if GTK_MINOR_VERSION >= 12
     gtk_widget_set_margin_end(frame, right_p);
     gtk_widget_set_margin_start(frame, left_p);
     gtk_widget_set_margin_top(frame, top_p);
     gtk_widget_set_margin_bottom(frame, bottom_p);
#else
     gtk_widget_set_margin_right(frame, right_p);
     gtk_widget_set_margin_left(frame, left_p);
     gtk_widget_set_margin_top(frame, top_p);
     gtk_widget_set_margin_bottom(frame, bottom_p);
#endif
}

inline GtkWidget *new_alignment(GtkAlign xalign, GtkAlign yalign,
                gboolean hexpand, gboolean vexpand)
{
     GtkWidget *w = gtk_frame_new(NULL);
     gtk_frame_set_shadow_type(GTK_FRAME(w), GTK_SHADOW_NONE);
     gtk_widget_set_hexpand(w, hexpand);
     gtk_widget_set_vexpand(w, vexpand);
     g_object_set(G_OBJECT(w), "halign", xalign, NULL);
     g_object_set(G_OBJECT(w), "valign", yalign, NULL);
     return w;
}
#else
inline void widget_set_prelight(GtkWidget *w)
{
    gtk_widget_set_state(w, GTK_STATE_PRELIGHT);
}

inline void widget_set_unselected(GtkWidget *w)
{
    gtk_widget_set_state(w, GTK_STATE_NORMAL);
}

inline void widget_set_selected(GtkWidget *w)
{
#ifdef _WIN32
    gtk_widget_set_state(w, GTK_STATE_PRELIGHT);
#else
    gtk_widget_set_state(w, GTK_STATE_SELECTED);
#endif
}

inline GtkWidget *table_new(guint rows, guint columns, gboolean homogeneous)
{
    return gtk_table_new(rows, columns, homogeneous);
}

inline void table_resize(GtkWidget *table, guint rows, guint columns)
{
    gtk_table_resize(GTK_TABLE(table), rows, columns);
}

inline void table_attach(GtkWidget *table, GtkWidget *w, guint left,
         guint right, guint top, guint bottom, gboolean expand=FALSE)
{
    if(expand)
       gtk_table_attach_defaults(GTK_TABLE(table), w, left, right, top, bottom);
   else
       gtk_table_attach(GTK_TABLE(table), w, left, right, top, bottom,
         (GtkAttachOptions) 0, (GtkAttachOptions) 0, 0, 0);
}           

inline void table_attach_all(GtkWidget *table, GtkWidget *w, guint left,
         guint right, guint top, guint bottom)
{
    GtkWidget *align = gtk_alignment_new(0, 0.5, 0, 0);
    gtk_widget_show(align);
    gtk_container_add(GTK_CONTAINER(align), w);
    table_attach(table, align, left, right, top, bottom, FALSE);
}           

inline void table_attach_exp(GtkWidget *table, GtkWidget *w, guint left,
         guint right, guint top, guint bottom)
{
    gtk_table_attach(GTK_TABLE(table), w, left, right, top, bottom,
         (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) 0, 0, 0);
/*
    GtkWidget *align = gtk_alignment_new(0, 0.5, 0, 0);
    gtk_widget_show(align);
    gtk_container_add(GTK_CONTAINER(align), w);
    table_attach(table, align, left, right, top, bottom, TRUE);
*/
}           

inline void table_set_row_spacings(GtkWidget *table, guint space)
{
      gtk_table_set_row_spacings(GTK_TABLE(table), space);
}

inline void table_set_col_spacings(GtkWidget *table, guint space)
{
      gtk_table_set_col_spacings(GTK_TABLE(table), space);
}

inline GtkWidget* vbox_new(gboolean homogeneous, gint spacing)
{
    return gtk_vbox_new(homogeneous, spacing);
}

inline GtkWidget* hbox_new(gboolean homogeneous, gint spacing)
{
    return gtk_hbox_new(homogeneous, spacing);
}

inline GtkWidget* vseparator_new()
{
    return gtk_vseparator_new();
}

inline GtkWidget* hseparator_new()
{
    return gtk_hseparator_new();
}

inline GtkWidget* hbutton_box_new()
{
    return gtk_hbutton_box_new();
}

inline GtkWidget* vscale_new_with_range(gdouble min, gdouble max, gdouble step)
{
    return gtk_vscale_new_with_range(min, max, step);
}

inline GtkWidget* hscale_new_with_range(gdouble min, gdouble max, gdouble step)
{
    return gtk_hscale_new_with_range(min, max, step);
}

inline GtkWidget* hscale_new(GtkAdjustment *adj)
{
    return gtk_hscale_new(adj);
}

#endif

inline void add_to_frame(GtkWidget *frame, GtkWidget *w)
{
   gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), w);
}

#ifdef USE_MYSPIN
inline GtkWidget *spin_button_new_with_range(double vmin, double vmax, double step)
{
   return my_spin_button_new_with_range(vmin, vmax, step);
}
 
inline void spin_button_set_value(GtkWidget *spin, double val)
{
  my_spin_button_set_value(MY_SPIN_BUTTON(spin), val);
}

inline void spin_button_set_digits(GtkWidget *spin, int val)
{
  my_spin_button_set_digits(MY_SPIN_BUTTON(spin), val);
}

inline void spin_button_set_numeric(GtkWidget *spin, gboolean val)
{
  my_spin_button_set_numeric(MY_SPIN_BUTTON(spin), val);
}

inline gdouble spin_button_get_value (GtkWidget  *spin)
{
   return my_spin_button_get_value(MY_SPIN_BUTTON(spin));
}

inline gint spin_button_get_value_as_int (GtkWidget  *spin)
{
   return my_spin_button_get_value_as_int(MY_SPIN_BUTTON(spin));
}

inline void spin_button_set_range (GtkWidget *spin, gdouble min1, gdouble max1)
{
  my_spin_button_set_range(MY_SPIN_BUTTON(spin), min1, max1);
}

inline GtkWidget *spin_button_new (GtkAdjustment  *adjustment,
                                   gdouble         climb_rate,
                                   guint           digits)
{
     return my_spin_button_new(adjustment, climb_rate, digits);
}

inline GtkAdjustment *spin_button_get_adjustment(GtkWidget  *spin)
{
     return my_spin_button_get_adjustment(MY_SPIN_BUTTON(spin));
}

inline void spin_button_set_update_policy  (GtkWidget  *spin,
                                        guint  policy)
{
     my_spin_button_set_update_policy(MY_SPIN_BUTTON(spin), 
          (MySpinButtonUpdatePolicy) policy);
}

inline void spin_button_set_adjustment (GtkWidget  *spin, GtkAdjustment  *adj)
{
     my_spin_button_set_adjustment (MY_SPIN_BUTTON(spin), adj);
}

inline void spin_button_update (GtkWidget  *spin)
{
    my_spin_button_update (MY_SPIN_BUTTON(spin));
}

inline void spin_button_get_range(GtkWidget  *spin, gdouble *min, gdouble *max)
{
    my_spin_button_get_range (MY_SPIN_BUTTON(spin), min, max);
}

#else
inline GtkWidget *spin_button_new_with_range(double vmin, double vmax, double step)
{
   return gtk_spin_button_new_with_range(vmin, vmax, step);
}

inline void spin_button_set_value(GtkWidget *spin, double val)
{
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin), val);
}

inline void spin_button_set_digits(GtkWidget *spin, int val)
{
  gtk_spin_button_set_digits(GTK_SPIN_BUTTON(spin), val);
}

inline void spin_button_set_numeric(GtkWidget *spin, gboolean val)
{
  gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(spin), val);
}

inline gdouble spin_button_get_value (GtkWidget  *spin)
{
   return gtk_spin_button_get_value(GTK_SPIN_BUTTON(spin));
}

inline gint spin_button_get_value_as_int (GtkWidget  *spin)
{
   return gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin));
}

inline void spin_button_set_range (GtkWidget *spin, gdouble min1, gdouble max1)
{
  gtk_spin_button_set_range(GTK_SPIN_BUTTON(spin), min1, max1);
}

inline GtkWidget *spin_button_new (GtkAdjustment  *adjustment,
                                   gdouble         climb_rate,
                                   guint           digits)
{
     return gtk_spin_button_new(adjustment, climb_rate, digits);
}

inline GtkAdjustment *spin_button_get_adjustment(GtkWidget *spin)
{
     return gtk_spin_button_get_adjustment(GTK_SPIN_BUTTON(spin));
}

inline void spin_button_set_update_policy  (GtkWidget  *spin,
                                        guint  policy)
{
     gtk_spin_button_set_update_policy(GTK_SPIN_BUTTON(spin), 
          (GtkSpinButtonUpdatePolicy) policy);
}

inline void spin_button_set_adjustment (GtkWidget  *spin, GtkAdjustment  *adj)
{
     gtk_spin_button_set_adjustment (GTK_SPIN_BUTTON(spin), adj);
}

inline void spin_button_update (GtkWidget  *spin)
{
    gtk_spin_button_update (GTK_SPIN_BUTTON(spin));
}

inline void spin_button_get_range(GtkWidget  *spin, gdouble *min, gdouble *max)
{
    gtk_spin_button_get_range (GTK_SPIN_BUTTON(spin), min, max);
}

#endif

#define MR_TYPE_CHAIN_BUTTON            (mr_chain_button_get_type ())
#define MR_CHAIN_BUTTON(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MR_TYPE_CHAIN_BUTTON, MrChainButton))
#define MR_CHAIN_BUTTON_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), MR_TYPE_CHAIN_BUTTON, MrChainButtonClass))
#define MR_IS_CHAIN_BUTTON(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MR_TYPE_CHAIN_BUTTON))
#define MR_IS_CHAIN_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MR_TYPE_CHAIN_BUTTON))
#define MR_CHAIN_BUTTON_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), MR_TYPE_CHAIN_BUTTON, MrChainButtonClass))

typedef struct _MrChainButton           MrChainButton;

typedef struct _MrChainButtonClass  MrChainButtonClass;

struct _MrChainButton
{
  GtkButton          parent_instance;
  gboolean           active;
  GtkWidget         *image;
};

struct _MrChainButtonClass
{
  GtkButtonClass  parent_class;

  void (* toggled)  (MrChainButton *button);
};


GType       mr_chain_button_get_type   (void) G_GNUC_CONST;

GtkWidget * mr_chain_button_new        ();

void        mr_chain_button_set_active (MrChainButton   *button,
                                          gboolean           active);
gboolean    mr_chain_button_get_active (MrChainButton   *button);
GdkColor *getBgColor(GtkWidget *w);
void mr_type_init();

static inline void progress_bar_set_orientation(GtkWidget *w, int ori)
{
#if GTK_MAJOR_VERSION >= 3
   switch(ori)
   {
   case RIGHT_TO_LEFT:
        gtk_progress_bar_set_inverted(GTK_PROGRESS_BAR(w), TRUE);
   case LEFT_TO_RIGHT:
   default:
        gtk_orientable_set_orientation(GTK_ORIENTABLE(w),
           GTK_ORIENTATION_HORIZONTAL);
        break;
   case BOTTOM_TO_TOP:
        gtk_progress_bar_set_inverted(GTK_PROGRESS_BAR(w), TRUE);
   case TOP_TO_BOTTOM:
        gtk_orientable_set_orientation(GTK_ORIENTABLE(w),
           GTK_ORIENTATION_VERTICAL);
        break;
   }
#else
   gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(w),
                   (GtkProgressBarOrientation) ori);
#endif
}
//#if defined(IN_GTK3) && (GTK_MINOR_VERSION >= 14)

#ifdef IN_GTK3
static inline void center_image(GtkWidget *w)
{
    g_object_set(G_OBJECT(w), "halign", GTK_ALIGN_CENTER, NULL);
    g_object_set(G_OBJECT(w), "valign", GTK_ALIGN_CENTER, NULL);
}

static inline void set_alignment(GtkWidget *w, gfloat x, gfloat y)
{
    if(GTK_IS_LABEL(w))
    {
       g_object_set(G_OBJECT(w), "xalign", x, NULL);
       g_object_set(G_OBJECT(w), "yalign", y, NULL);
    }
}

static inline void set_alignment(GtkWidget *w, gdouble x, gdouble y)
{
    set_alignment(w, (gfloat)x, (gfloat)y);
}
#else

static inline void center_image(GtkWidget *w)
{
    gtk_misc_set_alignment(GTK_MISC(w), 0.5, 0.5);
}

static inline void set_alignment(GtkWidget *w, gfloat x, gfloat y)
{
    gtk_misc_set_alignment(GTK_MISC(w), x, y);
}

static inline void set_alignment(GtkWidget *w, gdouble x, gdouble y)
{
    set_alignment(w, (gfloat)x, (gfloat)y);
}

inline void set_margins(GtkWidget *label, gint top_p, gint bottom_p,gint left_p,
                gint right_p)
{
   gtk_misc_set_padding(GTK_MISC(label), left_p, bottom_p);
}

#endif

#ifndef __LISTA_H
#define __LISTA_H

typedef char string_t[80];
namespace Lista {
   class MyList {
      public:
        MyList( int ListCode);
        MyList( int ListCode, int ncols, int coltypes[], string_t coltits[],
               void (*func)(int  *code));
        void Fill(int nRows);
        void FillColumn (int whichCol, int ivet[], float fvet[], string_t svet[]);
        GtkWidget *ListW() const {return widget;}
        int   GetNColumns() const {return nColumns;}
        int   GetNRows() const {return nRows;}
        void  (*func)(int *);
        void  SetNRows (int nrows){nRows=nrows;}
        int   GetCode() const {return Code;}
        static void SetParent(GtkWidget *f) {Parent = f; }
        static GtkWidget *GetParent() {return Parent; }
      private:
        int   Code;
        int   nColumns;
        int   nRows;
        GType *types;
        char  **titles;
        int   *sizes;
        int   *precs;
        GtkWidget *widget;
        static GtkWidget *Parent;
   };
}
#endif
void get_row_from_val(GtkWidget *list, int col_posi, std::vector<int> &iord);
void SaveSelection(GtkWidget *list, int col_posi, std::vector<int> &sel_vet);
void RedoSelection(GtkWidget *list, int col_posi, int num, std::vector<int> &sel_vet);
void HOOKUP_NUM(gpointer component,const char *name, gpointer widget, int num);
void HOOKUP_REF_NUM(gpointer component,const char *name, gpointer widget, int num);
