#include "callbacks.h"

// scommentando l'istruzione successiva si vede il menù 'Indexing'
#define MENUINDEX 1
                
gboolean ifMenubar = TRUE;

static mr_action_entry Menu_Items[] = {
{0, 1, "File", "_File", "File Operations", NULL, NULL, NULL, -1, 1, 0}, 
{1, 1, "New", "_New", "Create a New Project", "filenew", G_CALLBACK(open_newproj_dlg), NULL, -1, 1, 0}, 
{1, 1, "LoadMenu", "_Load and Go", "Load input (.exp) file and start the run", "opensir", G_CALLBACK(open_file), NULL, 0, 1, 0}, 
{1, 1, "Old Project", "_Old Project", "Load Project (." PROJ_EXT ") file", "openbin", G_CALLBACK(open_file), NULL, 1, 1, 0}, 
{1, 1, "Save Project", "_Save Project", "Save Project (." PROJ_EXT ") file", "save", G_CALLBACK(save_project), NULL, 1, 0, 0}, 
{1, 1, "Save Project As", "_Save Project As", "Save Project (." PROJ_EXT ") file", "save", G_CALLBACK(open_file), NULL, 3, 1, 0}, 
{1, 1, "Recent Projects", "_Recent Projects", "Load 1 of 5 projects", "void", NULL, NULL, -1, 1, 0}, 
{2, 1, "1", "_1", NULL, NULL, NULL, NULL, -1, 1, 0}, 
{2, 1, "2", "_2", NULL, NULL, NULL, NULL, -1, 1, 0}, 
{2, 1, "3", "_3", NULL, NULL, NULL, NULL, -1, 1, 0}, 
{2, 1, "4", "_4", NULL, NULL, NULL, NULL, -1, 1, 0}, 
{2, 1, "5", "_5", NULL, NULL, NULL, NULL, -1, 1, 0}, 
{1, 1, "Import Diffraction Pattern", "Import Diffraction Pattern", "Import Diffraction Pattern", "opensir", G_CALLBACK(open_file), NULL, 102, 1},
{1, 1, "Load Examples", "Load Ex_amples", "Load Example (.exp) file and start the run", "opensir", G_CALLBACK(open_file), NULL, 101, 1},
{1, 1, "Import Structure", "_Import Structure", "File import", "void",  G_CALLBACK(on_open), NULL, -1, 1, 0}, 
{1, 1, "Export", "_Export", "File Export", "void", NULL, NULL, -1, 0, 0},
{2, 1, "Powder Pattern (*.xy)", "Po_wder Pattern (*.xy)", "Powder Pattern", NULL, G_CALLBACK(c_esporta), NULL, 16, 1, 0},
{2, 1, "Reflection File (*.hkl)", "Reflection File (*.hkl)", "The indices h k l, a measured intensity I and its error sigma(I)", NULL, G_CALLBACK(c_esporta), NULL, 17, 1, 0},
{1, 1, "HardCopy", "_HardCopy", "Hard Copy", "camera", G_CALLBACK(PrintScreen), NULL, 1, 1, 0}, 
{1, 4},
{1, 1, "Exit", "E_xit", "Exit " MR_PACKAGE , "quit", G_CALLBACK(exit_confirm), NULL, -1, 1, 0}, 
{0, 1, "Pattern", "_Pattern", "Modify the pattern", NULL, NULL, NULL, -1, 0, 0}, 
{1, 1, "Range", "_Range", "Modify 2-theta Range", "range", G_CALLBACK(open_tb_range), NULL, -1, 1, 0}, 
{1, 1, "Intervals", "_Intervals", "Modify Intervals", NULL, G_CALLBACK(open_tb_intervals), NULL, -1, 1, 0}, 
{1, 1, "Background", "_Background", "Modify Background", "background", G_CALLBACK(open_poly_riet), NULL, -1, 1, 0}, 
{1, -1, "Background Settings", "_Background Settings", "Modify Background", "background", G_CALLBACK(open_polynomial), NULL, -1, 1, 0}, 
{1, 1, "Peaks", "_Peaks", "Modify Peaks Selection", "addpeak", NULL, NULL, -1, 0, 0}, 
{2, 1, "Peak Search", "_Peak Search", "Peak Search", NULL, G_CALLBACK(peak_search), NULL, -1, 1, 0}, 
{2, 1, "Peak Search Conditions", "_Peak Search Conditions", "Modify Peak Search Conditions", "find3", G_CALLBACK(open_new_search), NULL, -1, 1, 0}, 
{2, 1, "Add_Del Peaks", "_Add/Del Peaks", "Add peaks (left mouse click) / Del peaks (right mouse click)", NULL, G_CALLBACK(add_delPeaks), NULL, -1, 1, 0}, 
{2, 1, "Peak List", "Peak List", "Peak List", NULL, G_CALLBACK(peak_list), NULL, -1, 1, 0}, 
{2, 1, "Load Peaks", "_Load Peaks", "Load Peaks from External File", NULL, G_CALLBACK(loadPeaks), NULL, -1, 1, 0}, 
{2, 1, "Save Peaks", "_Save Peaks", "Save Peaks on External File", NULL, G_CALLBACK(savePeaks), NULL, -1, 1, 0}, 
{2, 3, "Hide Peaks", "Hide Peaks", "Hide Peaks", NULL, G_CALLBACK(on_hide_peaks), NULL, -1, 1, 0}, 
#ifdef MENUINDEX
{1, 1, "Indexing", "_Indexing", "Indexing", NULL, NULL, NULL, -1, 0, 0}, 
{2, 1, "N-TREOR09", "_N-TREOR09", "N-TREOR09", NULL, G_CALLBACK(c_indexing), NULL, 1, 1, 0}, 
{2, 1, "DICVOL06", "_DICVOL06", "DICVOL06", NULL, G_CALLBACK(c_indexing), NULL, 2, 1, 0}, 
{2, 1, "McMaille", "_McMaille", "McMaille", NULL, G_CALLBACK(c_indexing), NULL, 3, 1, 0}, 
{2, 4},
{2, 1, "I_Output", "Output", "Output", NULL, NULL, NULL, -1, 1, 0}, 
{3, 1, "ON-TREOR09", "_N-TREOR09", "N-TREOR09", NULL, G_CALLBACK(out_indexing), NULL, 1, 1, 0}, 
{3, 1, "ODICVOL06", "_DICVOL06", "DICVOL06", NULL, G_CALLBACK(out_indexing), NULL, 2, 1, 0}, 
{3, 1, "OMcMaille", "_McMaille", "McMaille", NULL, G_CALLBACK(out_indexing), NULL, 3, 1, 0}, 
{2, 1, "Cell List", "Cell List", "Cell List", NULL, G_CALLBACK(cell_list), NULL, -1, 1, 0}, 
#endif
{1, 1, "Space Group", "_Space Group", "Space Group", NULL, NULL, NULL, -1, 0, 0}, 
{2, 1, "Space Group Determination", "Space Group Determination", "Space Group Determination", NULL, G_CALLBACK(c_spgdet), NULL, 2, 1, 0}, 
{2, 1, "Space Group List", "Space Group List", "Space Group List", NULL, G_CALLBACK(c_spglist), NULL, 2, 1, 0}, 
{0, 1, "View", "_View", "View", NULL, NULL, NULL, -1, 1, 0}, 
{1, 1, "Plot Style", "Plot Style", "Plot Style", "preferences", G_CALLBACK(OpenStyleWindow), NULL, -1, 0, 0}, 
{1, 4},
{1, 1, "Jav", "Jav Molecular Viewer", "Open structure in Jav", "ilmview", G_CALLBACK(call_javs), NULL, -1, 1, 0}, 
//{1, 1, "contour", "contour", "Map viewer", "contour", G_CALLBACK(call_jav), NULL, -1, 0, 0}, 
//{1, 1, "Display Fourier maps", "Display Fourier Maps", "Display Fourier Maps", "contour", NULL, NULL, -1, 0, 0}, 
//{2, 1, "Show Fourier Map", "Show Fourier Map", "Show Fourier Map", NULL, G_CALLBACK(call_jav), NULL, 0, 1, 0}, 
//{2, 1, "Compute Fo", "Compute Fo", "Compute Fo", NULL, G_CALLBACK(call_jav), NULL, 1, 1, 0}, 
//{2, 1, "Compute 2Fo - Fc", "Compute 2Fo - Fc", "Compute 2Fo - Fc", NULL, G_CALLBACK(call_jav), NULL, 2, 1, 0}, 
//{2, 1, "Compute Fo-Fc", "Compute Fo-Fc", "Compute Fo-Fc", NULL, G_CALLBACK(call_jav), NULL, 3, 1, 0}, 
//{2, 1, "Compute Fc", "Compute Fc", "Compute Fc", NULL, G_CALLBACK(call_jav), NULL, 4, 1, 0}, 
{0, 1, "Solve", "_Solve", "Direct Space Procedure", NULL, NULL, NULL, -1, 0, 0}, 
{1, 1, "RAMM", "_RAMM Procedure", "Random Model based Method", "rubik", G_CALLBACK(c_random), NULL, 0, 1, 0}, 
{1, 1, "Explore trials", "_Explore trials", "Restart Fourier/Least-Squares refinement", "new_trials", G_CALLBACK(c_restart), NULL, -1, 1, 0}, 
{1, 1, "Simulated Annealing", "Simulated Annealing", "Global Optimization", "dice", G_CALLBACK(c_globalopt), NULL, 0, 1, 0}, 
{1, 1, "Simulated Annealing + Direct Methods", "Simulated Annealing + Direct Methods", "Global Optimization", "lsq1_ico", G_CALLBACK(c_sadm), NULL, -1, 1, 0}, 
{1, 1, "POLPO", "_POLPO", "Polyhedra Procedure", NULL, G_CALLBACK(c_polpo), NULL, -1, 1, 0}, 
{1, 1, "Recycle in extra", "_Recycle in extra", "Recycle the fragment information in extraction", "re-compute", G_CALLBACK(c_recycle), NULL, -1, 1, 0}, 
{0, 1, "Refine", "R_efine", "Refine the structure", NULL, NULL, NULL, -1, 0, 0}, 
{1, 1, "Resolution Bias Modification (RBM)", "_Resolution Bias Modification (RBM)", "Resolution Bias Modification", "cont_hig", NULL, NULL, -1, 0, 0}, 
{2, 1, "RBM (Direct Space)", "_RBM (Direct Space)", "Resolution Bias Modification in Direct Space", NULL, G_CALLBACK(c_fsrbm), NULL, 1, 1, 0}, 
{2, 1, "RBM (Direct and Reciprocal Space)", "R_BM (Direct and Reciprocal Space)", "Resolution Bias Modification in Direct and Reciprocal Space", NULL, G_CALLBACK(c_fsrbm), NULL, 2, 1, 0}, 
{2, 1, "RBM - COVMAP", "RB_M - COVMAP", "Resolution Bias Modification combined to connectivity based procedure", NULL, G_CALLBACK(c_fsrbm), NULL, -10, 1, 0}, 
{1, 1, "Fourier Recycling", "_Fourier Recycling", "Least Squares Refinement", "automatic_lsq", G_CALLBACK(c_fslsq), NULL, -1, 1, 0}, 
{1, 1, "Rietveld", "_Rietveld", "Rietveld Analysis", "lsq1_ico", G_CALLBACK(c_rietveld), NULL, 0, 1, 0}, 
{1, 1, "Fourier", "_Fourier", "Fourier synthesis", "fourier_ico", G_CALLBACK(open_fourier_dlg), NULL, -1, 1, 0}, 
{1, 1, "Peak labelling", "Pea_k labelling", "Peak Labelling Procedure", NULL, G_CALLBACK(open_label_dlg), NULL, -1, 1, 0}, 
{0, 1, "Info", "_Info", "Informations on the structure", NULL, NULL, NULL, -1, 0, 0}, 
{1, 1, "HKL List", "HKL List", "List of h k l, observed  and calculated Structure Factors, calculated phases", "hkl", G_CALLBACK(c_browserv2), NULL, 7, 1, 0}, 
{1, 1, "Profile", "_Profile", "Modify Background", "void", G_CALLBACK(open_tb_profile), NULL, -1, 1, 0}, 
{1, 1, "Summary", "_Summary", "Summary of results", "summary", G_CALLBACK(c_browserv2), NULL, 1, 1, 0}, 
{1, 1, "View Output file", "_View Output file", "View output file", "output", G_CALLBACK(c_browserv2), NULL, 5, 1, 0}, 
{0, 1, "Help", "_Help", "Help", NULL, NULL, NULL, -1, 1, 0}, 
{1, 1, "Documentation(HTML)", "_Documentation(HTML)", "Help on Content", "content_ico", G_CALLBACK(system_browser), NULL, -1, 1, 0}, 
{1, 1, "Documentation(PDF)", "Documentation(PDF)", "Help on Content(PDF file)", "content_ico", G_CALLBACK(pdf_open), NULL, -1, 1, 0}, 
{1, 1, "Check for Updates", "Check for _Updates", "Check for updates", "checkforupdate", G_CALLBACK(CheckForUpdates), NULL, -1, 1, 0},
{1, 1, "About", "_About", "Help About " MR_PACKAGE , "about_ico", G_CALLBACK(open_about), NULL, -1, 1, 0}
};
static guint n_menu_items = G_N_ELEMENTS (Menu_Items);

static gpointer menuitems = (gpointer) Menu_Items;

#ifdef USE_ACTIONS
static const gchar *menu_info =
"<ui>"
"  <menubar name='MenuBar'>"
"    <menu action='File'>"
"      <menuitem action='New'/>"
"      <menuitem action='LoadMenu'/>"
"      <menuitem action='Old Project'/>"
"      <menuitem action='Save Project'/>"
"      <menuitem action='Save Project As'/>"
"      <menu action='Recent Projects'>"
"         <menuitem action='1'/>"
"         <menuitem action='2'/>"
"         <menuitem action='3'/>"
"         <menuitem action='4'/>"
"         <menuitem action='5'/>"
"      </menu>"
"      <separator/>"
"      <menuitem action='Load Examples'/>"
"      <menuitem action='Import Diffraction Pattern'/>"
"      <menuitem action='Import Structure'/>"
"      <menu action='Export'>"
"         <menuitem action='Powder Pattern (*.xy)'/>"
"         <menuitem action='Reflection File (*.hkl)'/>"
"      </menu>"
"      <separator/>"
"      <menuitem action='HardCopy'/>"
"      <separator/>"
"      <menuitem action='Exit'/>"
"    </menu>"
"    <menu action='Pattern'>"
"      <menuitem action='Range'/>"
"      <menuitem action='Intervals'/>"
"      <menuitem action='Background'/>"
"      <menuitem action='Background Settings'/>"
"      <menu action='Peaks'>"
"         <menuitem action='Peak Search'/>"
"         <menuitem action='Peak Search Conditions'/>"
"         <menuitem action='Add_Del Peaks'/>"
"         <menuitem action='Peak List'/>"
"         <menuitem action='Load Peaks'/>"
"         <menuitem action='Save Peaks'/>"
"         <menuitem action='Hide Peaks'/>"
"      </menu>"
#ifdef MENUINDEX
"      <menu action='Indexing'>"
"         <menuitem action='N-TREOR09'/>"
"         <menuitem action='DICVOL06'/>"
"         <menuitem action='McMaille'/>"
"         <separator/>"
"         <menu action='I_Output'>"
"            <menuitem action='ON-TREOR09'/>"
"            <menuitem action='ODICVOL06'/>"
"            <menuitem action='OMcMaille'/>"
"         </menu>"
"         <menuitem action='Cell List'/>"
"      </menu>"
#endif
"      <menu action='Space Group'>"
"         <menuitem action='Space Group Determination'/>"
"         <menuitem action='Space Group List'/>"
"      </menu>"
"    </menu>"
"    <menu action='View'>"
"      <menuitem action='Plot Style'/>"
"      <separator/>"
"      <menuitem action='Jav'/>"
//"      <menu action='Display Fourier maps'>"
//"         <menuitem action='Show Fourier Map'/>"
//"         <menuitem action='Compute Fo'/>"
//"         <menuitem action='Compute 2Fo - Fc'/>"
//"         <menuitem action='Compute Fo-Fc'/>"
//"         <menuitem action='Compute Fc'/>"
//"      </menu>"
"    </menu>"
"    <menu action='Solve'>"
"      <menuitem action='RAMM'/>"
"      <menuitem action='Explore trials'/>"
"      <menuitem action='Simulated Annealing'/>"
"      <menuitem action='Simulated Annealing + Direct Methods'/>"
"      <menuitem action='POLPO'/>"
"      <menuitem action='Recycle in extra'/>"
"    </menu>"
"    <menu action='Refine'>"
"      <menu action='Resolution Bias Modification (RBM)'>"
"        <menuitem action='RBM (Direct Space)'/>"
"        <menuitem action='RBM (Direct and Reciprocal Space)'/>"
"        <menuitem action='RBM - COVMAP'/>"
"      </menu>"
"      <menuitem action='Fourier Recycling'/>"
"      <menuitem action='Rietveld'/>"
"      <menuitem action='Fourier'/>"
"      <menuitem action='Peak labelling'/>"
"    </menu>"
"    <menu action='Info'>"
"      <menuitem action='HKL List'/>"
"      <menuitem action='Profile'/>"
"      <menuitem action='Summary'/>"
"      <menuitem action='View Output file'/>"
"    </menu>"
"    <menu action='Help'>"
"      <menuitem action='Documentation(HTML)'/>"
"      <menuitem action='Documentation(PDF)'/>"
"      <menuitem action='Check for Updates'/>"
"      <menuitem action='About'/>"
"    </menu>"
"  </menubar>"
"</ui>";
#endif

