#ifdef _WIN32
#define DIR_SEPAR '\\'
#else
#define DIR_SEPAR '/'
#endif
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


/*           GTK & GDK include            */

#define NUMSPECIES 40
#ifdef GUI_ENV
//#define GTK_DISABLE_DEPRECATED
//#include <gtk/gtk.h>
//#include <gdk/gdkkeysyms.h>
//#include <gtk/gtkfontsel.h>
#endif

#include <utils.h>

#define MR_PACKAGE "expo"
#define PROJ_EXT "expo"

#define MaxAtLSQ 500
#define RParDef 4
#define drawingareaname              "areagrafica"

#define prg_files_dir   "expodir"
#define CONFIG_DIR      "EXPOCFGDIR"
//corr #define initial_pixmap  "logoexpo.xpm"
#define initial_pixmap  "ini.png"
#define about_pixmap    "about.png"
#define program_ico     "expo"
#define splash_xpm      ""
#define CREDITS         ""
#define MSGCOLOR      (const char *)"#008050"

#define PK "Expo"

#define MAX_COLORS  512
#define NUM_WAIT 9
#define NUM_SMILEY 6
//enum {GHOST = NUMSPECIES, BONDS, LABS, CELL, RESTR, 
//              OBS, BACKG, COMP, DIFFE, AXIS, MARKREF, MARKBG, MARKINT, MARKPK};
     
enum {OBS = NUMSPECIES, BACKG, COMP, DIFFE, AXIS, MARKREF, MARKBG, MARKINT, MARKPK};
// Style
enum Objects {STYLE_OBS, STYLE_BACK, STYLE_CALC, STYLE_DIFF,
              STYLE_CUMUL, STYLE_REFL, STYLE_PEAKS, STYLE_AXIS,
              STYLE_BACKP, STYLE_INTERVAL, STYLE_BG, STYLE_LEGEND,
              STYLE_UND_PEAKS, NITEMS};

enum PlotStyles {LINEPLOT, SCATTERPLOT, LINESCATTER, NPSTYLES};
enum LineStyles {SOLIDLINE, DASHEDLINE, NLSTYLES};

typedef struct {
       int  plot_type;   // linee, punti, linee+punti
       int  colline;     // colore delle linee
       int  colmarker;   // colore dei marker
       int  linetype;    // tipo della linea
       int  linewidth;   // spessore della linea
       int  markertype;  // tipo di marker
       int  sizemarker;  // dimensione del marker
       int  font_size;   // dimensione del carattere
       int  vis;         // visibile?
              } style_type;


/* Define if you have the ANSI C header files. */
#define STDC_HEADERS 1

#define MAXPROJ 5
#define MAX_LIV 3
#define REC_LEN 120

#define MAX_LEN 280
//#define NUM_STYLES 9

#define MRmin(a,b)               ( ((a) < (b)) ? (a) : (b) )
#define MRmax(a,b)               ( ((a) > (b)) ? (a) : (b) )
#define MRabs(x)                 ( (x >= 0) ? x : -(x))
#define  CHARS                    sizeof(char)


#ifndef M_PI
#define M_PI    3.14159265358979323846
#endif /* M_PI */

#define DEGTORAD(a) (2.0*M_PI*a/360.0)
#define RADTODEG(a) (360.0*a/(2*M_PI))
#define SQR(a) (a*a)

/* ---------------------------------------------------------------- */
/*       User-defined types                                         */
/* ---------------------------------------------------------------- */

/*
typedef struct {
                unsigned short red;
                unsigned short green;
                unsigned short blue;
               } rgbCol;
*/

typedef char stringa[60];
typedef char stringa120[120];
//typedef char nomefile[256];

typedef struct {
                int      nRecentProjects;
                nomefile RecentProj[5];
               } RecentPr;

typedef struct {
                char SWRC[256];
                char HOMEdir[256];
                char WorkingDirectory[256];
               } SWareRC;

typedef struct {
//               int NatMol;
               int ifBrekke;
//               int ixBr;
//               int iyBr;
//               int iRotSpeed;
//               int ifCellP;
//               int ifBallP;
//               int ifLabels; 
//               int ifCell; 
//               int ifNoDraw;
//               int ifFour;
//               float ViewDist;
//               float RaggioSfera;
//               int STICKS;
//               int RODS;
//               int SIMPLE;
//               int STICKS_N_BALLS;
//               int BUBBLES;
//               int SHADING;
//               int VAN_DER_WAALS;
//               int ELLIPSOIDS;
//               int POLYHEDRA;
//               int nAided;
//               int jAided[100];
//               int kktest;
               int color_BLACK;
               int color_BLUE;
               int color_GREEN;
               int color_CYAN;
               int color_RED;
               int color_MAGENTA;
               int color_BROWN;
               int color_WHITE;
               int color_GRAY;
               int color_LIGHTBLUE;
               int color_LIGHTGREEN;
               int color_LIGHTCYAN;
               int color_LIGHTRED;
               int color_LIGHTMAGENTA;
               int color_YELLOW;
               int color_BRIGHTWHITE;
               int color_OBS;
//               int color_GHOST;
//               int color_BONDS;
//               int color_LABS;
//               int color_CELL;
//               int color_RESTR;
//               int cp[CPSIZE];
//               int nRadType;
//               float ProbF;
//               int kptrc[1000];
//               int lPkgName;
//               int ifGTK;
//               int ifCentro;
//               int ifMadEnv;
//               int Madx;
//               int Mady;
//               int QualeAbilita;
//               int ifCellOnly;
//               int ifCont;
               int ifPDBcoded;
//               int ifSkeletonOn;
//               int ifMolrepG;
               int MaxAtomsGr;
//               int ifIsOver;
               int viewerOpened;
               int button_ev;
               int ModelToCompare;
//               char PkgName[256];
//               char input_ext[6];
//               stringa SmallIt[24];
              } _Dialogo;

#ifdef GUI_ENV

typedef struct {
                const char    *title;
                const char    *text;
                const char    *image;
                const char    *label1;
                const char    *label2;
                const char    *label3;
                const char    *image1;
                const char    *image2;
                const char    *image3;
                int           format;
                int           nButtons;
                int           focus;
                int           width;
                int           height;
                GCallback cb_func1;
                GCallback cb_func2;
                GCallback cb_func3;
                gpointer      cb_data2;
                gpointer      cb_data1;
                gpointer      cb_data3;
                int           nlines;
               } DlgItem;
                                                                                
typedef struct 
{
  gchar *colore;
  int   colonna;
} ColorText;

typedef struct _TreeItem TreeItem;
struct _TreeItem
{
  const gchar    *label;
  TreeItem       *children;
};

typedef struct  {
                  int obs;     // observed profile
                  int calc;    // computed profile
                  int back;    // background
                  int diff;    // difference profile
                  int bpoints; // background points
                  int cumul;   // cumulative chi squared
                  int markint; // mark intervels
                  int ref;     // mark reflections
                  int peaks;   // peaks
                 } plot_option_type;


typedef struct {
                 int   code;  // indica il tipo di restraint: 1=distanza,2=angolo,3=piano
                 int   nna;   // numero di atomi coinvolti nel restraint
                 int   *na;   // puntatori agli atomi coinvolti nel restraint
                 float val;   // valore corrente del restraint
                 float targ;  // valore target del restraint
                 float sigma; // deviazione standard
                 float wei;   // weight
                 int   sym;   // consider symmetry equivalent atoms
               } restraint_type;

gboolean key_pressed_sir (GtkWidget *widget, GdkEventKey *event, gpointer data);
gboolean button_press    (GtkWidget *widget, GdkEventButton *ev, gpointer data);
gboolean button_release  (GtkWidget *widget, GdkEventButton *ev, gpointer data);
gboolean button_move     (GtkWidget *widget, GdkEventMotion *ev, gpointer data);
gboolean on_mainwin_closing (GtkWidget *widget, GdkEventAny *event, gpointer data);
gboolean configure_area_expo  (GtkWidget *widget, GdkEventConfigure *event,
                          gpointer user_data);

                                                                                                     
void load_recent_project (gpointer widget, gchar *data);
void init_toggles        (GtkWidget *widget, gpointer data);
void saveas_cb           (GtkButton *widget, gpointer data);

/* ---------------------------------------------------------------- */
/*                         utility functions                        */
/* ---------------------------------------------------------------- */
void ChangeCursor(GtkWidget *w, GdkCursor *cursor);
gboolean true_cb (GtkWidget *widget, GdkEventAny *event, gpointer data);

void        set_widget_color_integral  (GtkWidget *widget, GdkColor colore);

void        changefont                 (GtkWidget *widget, 
                                        PangoFontDescription *font);
int         text_width                 (PangoFontDescription *fontdesc,
                                        const char *text);
int         cStartMainLoop             (int flag);
void        clear_string               (char *str);
int         ftn_index                  (char *str1, char *str2);

void get_cell(GtkWidget *list, gpointer line, int nrow, int ncol);
void add_line_to_listM(GtkWidget *list, char *line[]);

GtkWidget   *label_boxed2               (gchar     *string);
void        set_widget_color            (GtkWidget *wid, GdkColor col);
void        set_label_color             (GtkWidget *label, GdkColor colore);
void        set_text_color              (GtkWidget *label, GdkColor colore);

GtkWidget   *cMsgWin                    (char *title, char *cmsg, int type, int to);

void        string_to_vector            (char *atoms, char *Atomi[]);
void        string_to_vector2           (char *string, char* vecstr[],
                                         const char *delim, int ifstrip);
void        stringatovector             (char *str, char *strvec[], 
                                         int nElem, int lung);
GtkWidget   *create_combo_colors        (GtkWidget *parentbox,
                                         int default_selected, int *val);
gchar       *check_file_exists          (const gchar *directory, 
                                         const gchar *filename);
int         save_restore_pm             (int tipo);
GtkWidget   *window_tip                 (gchar *string, int lriga);
void        check_numeric               (GtkEditable *editable,
                                         const gchar *text, gint length,
                                         gint *position, gpointer data);
int         check_is_numeric            (char *string);
void        create_tree                 (GtkWidget *window, char *itemnames[], 
                                         int NumItems, int NumSubItems[], 
                                         int offset, GCallback cb1, 
                                         GCallback cb2);
gchar**     strsplit                    (const gchar *string,
	                                        const gchar *delimiter,
	                                        gint max_tokens);
void CheckForUpdates(gpointer item, gpointer data);

/* ---------------------------------------------------------------- */
/*               Viewers  and  Dialogs                              */
/* ---------------------------------------------------------------- */

void       find_str                   (GtkButton  *button, gpointer data);
void       delete_viewer              (GtkButton       *button,
                                       gpointer         user_data);
void       close_viewer               (GtkButton       *button,
                                       gpointer         user_data);
gboolean   onViewer_configure_event   (GtkWidget       *widget,
                                       GdkEventConfigure *event,
                                       gpointer         user_data);
gboolean   on_viewer_expose_event     (GtkWidget       *widget,
                                       gpointer         event,
                                       gpointer         user_data);
GtkWidget* create_dialog              (GtkWidget *winmain, DlgItem *dlg_it);

GtkWidget* create_textwindow          (DlgItem *it, PangoFontDescription *pfd);
GtkWidget* scrolled_text_new          (GtkWidget *container);
void       get_drawing_area_size      (int *w, int *h);

void       close_dlg                  (GtkButton       *button,
                                       gpointer         user_data);
void       reset_handler              (GtkWidget       *hwnd,
                                       GdkEvent        *event,
                                       gpointer         user_data);
gboolean   chiudi_dlg                 (gpointer data);
gboolean   hide_dlg                   (gpointer data);

void       mr_restore_pixmap          (void);
void       mr_send_viewer_pixmap      (GtkWidget *win);
void       finestra_modale_aperta2    (GtkWidget *win);
void       finestra_modale_chiusa2    (void);
int        preview_or_file            (int action);
void       set_smiley                 (int come);
void       fortran_al_lavoro          (void);
void       fine_lavoro                (void);
void       elaborazione_in_corso      (void);
void       fine_elaborazione          (void);
void       mr_send_pixmap             (GtkWidget *win);
void       primecose                  (GtkWidget *mwin);
void       print_mess                 (const char *riga);
void       draw_stella                (int dx, int dy, int ic, gpointer gc,
                                       gpointer drawable);
void DrawLine(int x1, int y1, int x2, int y2, GdkColor *color, int lw);
void set_forecolor(int col, gpointer gc=NULL);
void DrawPoints(GtkWidget *window, GdkPoint punti[], int npunti,
                 GdkColor *color, int markertype, int size);
void DrawRectangle(int ixx, int iyy, int w, int h, int filled);
void       clear_status_bar           (void);
int        load_file_into_buffer      (char *filename, GtkTextBuffer *text, 
                                       int nlines, char **tags, int ntags);
void       add_text                   (GtkWidget *lista, char *stringa);

/* ---------------------------------------------------------------- */
/*                  Liste scrollabili                               */
/* ---------------------------------------------------------------- */
void       set_cell_color             (GtkWidget *list, int nrow, int ncol, const char *colore);
GtkWidget *create_selection           (GtkWidget *parent, GtkWidget *parentbox,
                                       const char *title, const char *id, int size);
GtkWidget *create_cselection          (GtkWidget *parent, GtkWidget *parentbox,
                                      const char *title, const char *id);
GtkWidget *createSelectionM           (GtkWidget *parent, GtkWidget *parentbox,
                                       const char *title[], const char *id, int ncol, const char *col);
GtkWidget  *mostra_lista              (const char *wtitle, const char *title, const char *vec[], 
                                       int n_el, int selmode,GCallback cb2);
int        tog_button                 (GtkWidget *widget, int count);
void       update_colors              (int iflag);
void       riempi_list                (GtkWidget *listad);
void       stop_continue_rot          (void);
void       nascondi_tb                (GtkWidget *mwin);
void       abilitamb                  (GtkWidget *mwin, int stato);
void       abilitatb                  (GtkWidget *mwin, int stato);

void       call_fortran               (const char *inpFile, const char *outFile,
                                       const char *tipo);
//corrvoid       call_fortran_bis           (char *inpFile, char *dir,
//corr                                       int tipo);
GtkWidget *entry_for_fileselection    (const char *label_string, const char *pix, GCallback cb,
                                       gpointer data, int ifPreview, int ifBrowse,
                                       const char *colore);
GtkWidget *entry_for_fileselection    (const char *label_string, const char *pix, GCallback cb,
                                       gpointer data, int ifPreview, int ifBrowse,
                                       const char *colore, const char mod);

int        load_file_into_window      (char *filnam, GtkWidget *text, 
                                       char *fore, char *back, int nlines);
void       file_preview               (GtkButton *button, GtkWidget *entry);

void       find_widgets               (GtkContainer *father, GtkWidget *dialog);
void       write_file                 (char *nomestru, GtkWidget *dialog);
void       on_cb_attiva               (GtkToggleButton *button, GtkWidget *wid);
void       on_cb_disattiva            (GtkToggleButton *button, GtkWidget *wid);
void       on_cb_show                 (GtkToggleButton *button, GtkWidget *wid);
void       on_cb_hide                 (GtkToggleButton *button, GtkWidget *wid);
void       do_tree_store              (GtkWidget *window, TreeItem tops[], GCallback cb, 
                                       GtkWidget *cb_data, int offset);

void updclistavec (GtkWidget *gtklist, const char *list[], int n_el, int fClear);

int find_element(const char *string, const char *vect[], int n_el);
#endif

void        write_palette               (void);
void        resetta_palette             (int ialloc);
void        update_cfg                  (int nline, char *line);
void        leggi_fonts                 (void);
void        update_fonts                (void);
void        scrivi_fonts                (void);
void        c_allocacolori              (int flag);
int         cMsgWinErr                  (const char *title, const char *cmsg, int type);
char        *get_program_directory      (char *filnam);
void        open_htm                    (const char *urlname, bool top=true);
std::string DateInfo(const char *fil=NULL);
float *get_fcolor(int quale);
