#include "mrconfig.h"
#include "aliasx.h"
//#include "forcomm1.h"
#include "callbacks.h"
#include <fstream>
#include <sstream>
#include <iomanip>
typedef char stringa4[4];
typedef char stringa5[5];

static GtkWidget *new_project_dlg = NULL;

const char *labels[] = {"a:", "b:", "c:", "alpha:", "beta:", "gamma:"};

const char  *sources[] = { "X rays", "Neutron", "Synchrotron"};
int form;

char structnam[80];
char jobnam[80];

extern  char files_dir[256];
extern  SWareRC  *cSWareRC;
extern  GtkWidget *finestre[6];
extern  PangoFontDescription *fontdescU;

int vspace = 4;

void insert_line(GtkWidget *list, char *line[], int row);
int get_n_tokens (const char *str, const char *c);
int check_spg(GtkWidget *father, GtkWidget *combo1, char str[17],int checkz);
char *greek(int i);
void  update_infopatt(const gchar *wFather, gchar *stringdata);
void reset_project_name();

extern "C" float cellvolumeforc_(float cell[]);
extern "C" float contentvolumeforc_(int *nEl, stringa5 El[], int Am[]);
extern "C" float volumeperatomforc_(int *nEl, stringa5 El[], int Am[], float *V,
                     float *dens);
extern "C" int   get_content_from_formula_(char *param, int Amount[], int Z[],
                    size_t idum);
extern "C" void  get_info_datafilec_(char *f,float *t1,float *t2,float *wavel,
                   int *ier, size_t idum);

#define SYMLEN  8
#define L_UTILE 4

void combo_set_text(GtkWidget *combo, char *string)
{
     gtk_entry_set_text(GTK_ENTRY(get_widget(combo,"entry")), string);
}

int combo_get_text_len(GtkWidget *combo, char *string, size_t sz)
{
     CopiaStringa(string, sz, gtk_entry_get_text(GTK_ENTRY(get_widget(combo,"entry"))));
     return (int) strlen(string);
}

GtkWidget *my_combo(GCallback cb, gpointer cb_data)
{
    GtkWidget *combo = combo_new();
    int hnd = 0;

#ifndef GTK_COMBO_BOX
    g_object_set_data (G_OBJECT(combo), "entry", GTK_COMBO(combo)->entry);
    g_object_set_data (G_OBJECT(GTK_COMBO(combo)->list), "entry", GTK_COMBO(combo)->entry);
    if(cb)
       hnd = g_signal_connect(G_OBJECT(GTK_COMBO(combo)->list), "select-child",
               cb, cb_data);
#else
    g_object_set_data (G_OBJECT(combo), "entry", gtk_bin_get_child(GTK_BIN(combo)));
    if(cb)
    {
       hnd = g_signal_connect(G_OBJECT(combo), "changed", cb, cb_data);
       g_signal_connect(G_OBJECT(gtk_bin_get_child(GTK_BIN(combo))), "activate", cb, cb_data);
    }
#endif
    if(hnd)
       g_object_set_data (G_OBJECT(combo), "hnd", GINT_TO_POINTER(hnd));
        return combo;
}

bool IsStd(int ext_type)
{
    bool result = false;
    if(ext_type == 1)
       result = true;
    else if(ext_type == 4)
       result = true;
    else if(ext_type == 5)
       result = true;
    return result;
}

int get_format_from_ext(const char *filnam)
{
    std::string filec = filnam;
    const char *ext = get_ext(filec);
    int ff = -1;
    if(!str_white(ext))
    {
       if (g_ascii_strcasecmp(ext, "xy") == 0)
           ff = 1;
       else if((g_ascii_strcasecmp(ext, "cif") == 0) ||
                  (g_ascii_strcasecmp(ext, "rtv") == 0))
           ff = 5;
       else if(g_ascii_strcasecmp(ext, "gda")  == 0)
           ff = 4;
    }
    return ff;
}

namespace Expo
{
  const char *filet[] = {"XY", "counts", "double", "GSAS", "cif"};
  const char *src[] = {"xrays", "neutro", "synchr"};
  bool OldFile;
  int CreatePrj = 0;
  char OldF[MaxLenFilename];
  bool ok_struct = false;
  bool ok_job = false;
  bool ok_data = false;
  class Project {
  public:
        Project();
        void FillProject(char *filnam, float cell[6], int ifFindSpace,
                         char *spg, char *formula);
        void FillProject(char *filnam, float cell[6], int ifFindSpace,
                         char *spg, int nk, int nw[], stringa4 str[]);
        int Open(const std::string &fn, GtkWidget *dlg);
        void Save(const std::string &strfn, GtkWidget *dlg) const;
        void ExpToPrj();
        void ReadExp(char *filnam);
        int SaveAsExp();
        void FillForm(GtkWidget *dialog, int ifMissing=0);
        int ReadForm(GtkWidget *dialog, int ifMissing=0);
        void BuildFilenames(const char *dirnam, const char *basenam);
        void SetContent(const char *cont) {strContent = cont;}
        const std::string &Content() const {return strContent;}
        void add_struct(FILE *fp);
        void add_job(FILE *fp);
        void add_data(FILE *fp);
        void add_range(FILE *fp);
        void add_pattern(FILE *fp);
        void add_source(FILE *fp);
        void add_wavelen(FILE *fp);
        void add_alphacorr(FILE *fp);
        void add_space(FILE *fp);
        void add_cell(FILE *fp);
        void add_content(FILE *fp);
        void add_ntreor(FILE *fp);
        void add_end(FILE *fp);
        char WorkingDir[MaxLenFilename];
        char StructureName[80];
        char JobTitle[80];
        char PCountsFile[MaxLenFilename];
        int Range;
        float thmin;
        float thmax;
        int Source;
        float Wavelen;
        int Alpha2;
        char szSpaceGroup[30];
        int  FindSpace;
        int  ifN3or;
        float Cell[6];
        int nElements;
        char Elem[NUMSPECIES][SYMLEN+1];
        int Amount[NUMSPECIES];
        int ifStSol;
        int ifDirectM;
        int ifSannel;
        char szFragment[MaxLenFilename];
        char InputF[MaxLenFilename];
        char OutputF[MaxLenFilename];
        bool Changed;
private:
        std::string strContent;
    };
static Project *project;
static Project *missing;

Project::Project()
{
    CopiaStringa(WorkingDir, sizeof(WorkingDir),  getPWD());

    memset(StructureName, 0, sizeof(StructureName));
    memset(JobTitle, 0, sizeof(JobTitle));
    memset(PCountsFile, 0, sizeof(PCountsFile));
    memset(OldF, 0, sizeof(OldF));
    Range = 0;
    Source = 1;
    Wavelen = 0;
    Alpha2 = 0;
    thmin = 0;
    thmax = 0;
    FindSpace = 1; //041111 0;
    memset(szSpaceGroup, 0, sizeof(szSpaceGroup));

    ifN3or = 1; //041111 0;
    for(int i=0; i<6; i++)
        Cell[i] = 0;
    nElements = 0;
    for(int i=0; i<NUMSPECIES; i++)
    {
        Amount[i] = 0;
        memset(Elem, 0, sizeof(Elem));
    }
    ifStSol = 1;
    ifDirectM = 0;
    ifSannel = 0;
    memset(szFragment, 0, sizeof(szSpaceGroup));
    memset(InputF, 0, sizeof(InputF));
    memset(OutputF, 0, sizeof(OutputF));
    OldFile = false;
    Changed = false;
}

void Project::FillProject(char *filnam, float cell[6], int ifFindSpace, 
                          char *spg, int nk, int nw[], stringa4 specchar[])
{
    int i;

    if(filnam != NULL)
        ReadExp(filnam);

    ifN3or = 0;
    FindSpace = ifFindSpace;
    CopiaStringa(szSpaceGroup, sizeof(szSpaceGroup), spg);

    for(i=0; i<6; i++)
        Cell[i] = cell[i];
    nElements = nk;
    for(i=0; i<nk; i++)
    {
        CopiaStringan(Elem[i], SYMLEN+1, specchar[i], 4);
        Elem[i][4] = '\0';
        Amount[i] = nw[i];
    }
    std::stringstream formula;
    for(i=0; i<nElements; i++)
        formula << g_strstrip(Elem[i]) << Amount[i];
    SetContent (formula.str().c_str());

}

void Project::FillProject(char *filnam, float cell[6], int ifFindSpace, 
                          char *spg, char *formula=NULL)
{
    int i;

    if(filnam != NULL)
        ReadExp(filnam);

    ifN3or = 0;
    FindSpace = ifFindSpace;
    CopiaStringa(szSpaceGroup, sizeof(szSpaceGroup), spg);

    for(i=0; i<6; i++)
        Cell[i] = cell[i];
    if(formula != NULL)
       SetContent (formula);

}

bool isComment(std::string line)
{
   if(line.substr(0,1).compare("!") == 0)
     return true;
   if(line.substr(0,1).compare(">") == 0)
     return true;
   return false;
}

bool isCommand(std::string line)
{
   if(line.substr(0,1).compare("%") == 0)
     return true;
   return false;
}

int nCommand(std::string line)
{
   const char *allcom[] = {
   "              ","              ","              ",//  3
   "data          ","extraction    ","normal        ",//  6
   "seminvariants ","invariants    ","phase         ",//  9
   "fourier       ","menu          ","end           ",// 12
   "continue      ","choice        ","sdirect       ",// 15
   "polyedra      ","recycle       ","changelabel   ",// 18
   "              ","zmatrix       ","automatic     ",// 21
   "patterson     ","ntreor        ","rietveld      ",// 24
   "piero         ","coordinates   ","sannel        ",// 27
   "structure     ","window        ","nowindow      ",// 30
   "initialize    ","job           ","fragment      ",// 33
   "save          ","%             "};

   for (int i=0; i<(int)(sizeof(allcom)/sizeof(allcom[0])); i++)
   {
        std::string com4(allcom[i], L_UTILE);
        std::string coml(g_ascii_strdown(line.substr(1,L_UTILE).c_str(),L_UTILE));
        int ll = (int) strlen(coml.c_str());
        if(coml.compare(0, ll, com4, 0, ll) == 0)
           return i+1;
   }
   return 0;
}

int get_file_format(std::string param)
{
   std::string str2(g_ascii_strdown(param.c_str(),-1));
   for(int i=0; i<(int)(sizeof(filet)/sizeof(filet[0])); i++)
   {
        std::string str1(g_ascii_strdown(filet[i],-1));
        if(str2.find(str1) != std::string::npos)
           return (i+1);
   }
   return 2;
}

int CheckFile(const char *campo, const char* nomecampo)
{
    FILE *fp;

    if(str_white(campo))
    {
       cMsgWinErr("Error", nomecampo, 90+ERR_WINDOW);
       return -1;
    }
    if(!g_file_test(toUTF8(campo), G_FILE_TEST_EXISTS))
    {
       cMsgWinErr("Error", campo, 170+ERR_WINDOW);
       return -1;
    }
    fp = fOpen(campo, "r");
    if(fp == NULL)
    {
       cMsgWinErr("Error", campo, 10+ERR_WINDOW);
       return -1;
    }
    fclose (fp);
    return 0;
}

void Project::ExpToPrj()
{
  FILE *fp = fOpen(OldF, "r");
  char *line = g_new0(char, MAX_LEN+1);
  char *fields[2*NUMSPECIES];
  int i, num;
  bool data_section = false;

  if(!fp)
  {
        MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                   "Error in open file: ", OldF);
     return;
  }

  ok_struct = false;
  ok_job = false;
  ok_data = false;
  CopiaStringa(WorkingDir, sizeof(WorkingDir),  getPWD());
  ifN3or = 0;
  FindSpace = 1;
  while(fgets(line, MAX_LEN, fp) != NULL)
  {
     std::string linea = g_strstrip(line);
     std::string param;
     int nco;
	 size_t kpos;
     if(isComment(linea))
        continue;
     kpos  = linea.find("!");
     if( kpos != std::string::npos)
        linea.erase(kpos);
     if(isCommand(linea))
     {
        data_section = false;
        nco = nCommand(linea);
        switch(nco)
        {
        case 13:            //%continue
             ifDirectM = 1;
             break;
        case 23:            //%ntreor
             ifN3or = 1;
             break;
        case 27:            //%sannel
             ifSannel = 1;
             break;
        case 33:            //%fragment
             if(linea.find(" ") != std::string::npos)
             {
                param = linea.substr(linea.find(" "));
                CopiaStringa(szFragment, sizeof(szFragment),  param.c_str());
                g_strchug(szFragment);
             }
             break;

        case 32:            //%job
             if(linea.find(" ") != std::string::npos)
             {
                ok_job = true;
                param = linea.substr(linea.find(" "));
                CopiaStringa(JobTitle, sizeof(JobTitle),  param.c_str());
                g_strchug(JobTitle);
             }
             break;
        case 28:            //%structure
             if(linea.find(" ") != std::string::npos)
             {
                ok_struct = true;
                param = linea.substr(linea.find(" "));
                CopiaStringa(StructureName, sizeof(StructureName),  param.c_str());
                g_strchug(StructureName);
             }
             break;
        case 4:            //%data
             data_section = true;
             ok_data = true;
             Source = 1;
             break;
        }
     }
     else if(data_section)
     {
        std::string comx(g_ascii_strdown(linea.substr(0,L_UTILE).c_str(),L_UTILE));
        if(comx.compare("patt") == 0)
        {
           if(linea.find(" ") != std::string::npos)
           {
              param = linea.substr(linea.find(" "));
              CopiaStringa(PCountsFile, sizeof(PCountsFile),  param.c_str());
              g_strchug(PCountsFile);
           }
        }
        else if(comx.compare("wave") == 0)
        {
           if(linea.find(" ") != std::string::npos)
           {
              param = linea.substr(linea.find(" "));
              Wavelen = (float) atof(param.c_str());
           }
        }
        else if(comx.compare("alpha") == 0)
              Alpha2 = 1;
        else if(comx.compare("spac") == 0)
        {
           if(linea.find(" ") != std::string::npos)
           {
              param = linea.substr(linea.find(" "));
              FindSpace = 0;
              CopiaStringa(szSpaceGroup, sizeof(szSpaceGroup),  param.c_str());
              g_strchug(szSpaceGroup);
           }
        }
        else if(comx.compare("find") == 0)
        {
           FindSpace = 1;
        }
        else if(comx.compare("cell") == 0)
        {
           if(linea.find(" ") != std::string::npos)
           {
              param = linea.substr(linea.find(" "));
              num = get_str_tokens (param.c_str(), " ", 6, fields);
              for(i=0; i<num; i++)
                  Cell[i] = (float)atof(fields[i]);
           }
        }
        else if(comx.compare("cont") == 0)
        {
           if(linea.find(" ") != std::string::npos)
           {
              int *Z = g_new0(int, NUMSPECIES);
              param = linea.substr(linea.find(" "));
              nElements = get_content_from_formula_(g_strdup(param.c_str()),
                    Amount, Z, strlen(param.c_str()));
              for(i=0; i<nElements; i++)
                 CopiaStringa(Elem[i], SYMLEN+1, get_nth_element(Z[i]-1));
              g_free(Z);
              SetContent(trim(param).c_str());
           }
        }
        else if(comx.compare("rang") == 0)
        {
           if(linea.find(" ") != std::string::npos)
           {
              Range = 1;
              param = linea.substr(linea.find(" "));
              num = get_str_tokens (param.c_str(), " ", 2, fields);
              thmin = (float)atof(fields[0]);
              thmax = (float)atof(fields[1]);
           }
        }
        else if(comx.compare("sync") == 0)
        {
           Source = 3;
        }
        else if(comx.compare("neut") == 0)
        {
           Source = 2;
        }
        else if(comx.compare("xray") == 0)
        {
           Source = 1;
        }
        else if(comx.compare("peak") == 0)
        {
//           g_print("peak  \n");
        }
     }
  }
  ifStSol = 1;      //ifDirectM | ifSannel;
  if(ifSannel)
     ifDirectM = 0;

  fclose(fp);
  g_free(line);
}

void Project::ReadExp(char *filnam)
{
   //if(this != NULL)
   {
      std::string s = fromUTF8(filnam);
      if (g_path_is_absolute(filnam))
          CopiaStringa(OldF, MaxLenFilename, s.c_str());
      else
          CopiaStringa(OldF, MaxLenFilename,g_build_filename(getPWD(), s.c_str(), NULL));
      OldFile = true;
      this->ExpToPrj();
   }
}

int Project::SaveAsExp()
{
    FILE *fp;

    fp = fOpen(this->InputF, "w");
    if(fp == NULL)
       return -1;

//190511    fprintf(fp, "%%window\n");
    add_struct(fp);
    add_job(fp);
    fprintf(fp, "%%init \n");
    add_data(fp);
    add_range(fp);
    add_pattern(fp);
    add_source(fp);
    add_wavelen(fp);
    add_alphacorr(fp);
    add_space(fp);
    add_cell(fp);
    add_content(fp);
    add_ntreor(fp);
    add_end(fp);
    fclose(fp);
    return 0;
}

void Project::add_struct(FILE *fp1)
{
     fprintf(fp1, "%%structure %s\n", StructureName);
}

void Project::add_job(FILE *fp1)
{
     fprintf(fp1, "%%job %s\n", JobTitle);
}

void Project::add_data(FILE *fp1)
{
     fprintf(fp1, "%%data\n");
}

void Project::add_pattern(FILE *fp1)
{
     std::string s = fromUTF8(PCountsFile);
     fprintf(fp1, "pattern %s\n", s.c_str());
}

void Project::add_source(FILE *fp1)
{
    if(Source != 1)
       fprintf(fp1, "%s\n", src[Source-1]);
}

void Project::add_range(FILE *fp1)
{
    if(Range)
       fprintf(fp1, "range %.3f %.3f\n", thmin, thmax);
}

void Project::add_wavelen(FILE *fp1)
{
    fprintf(fp1, "wave %.6f\n", Wavelen);
}

void Project::add_alphacorr(FILE *fp1)
{
    if(Alpha2)
       fprintf(fp1, "alpha\n");
}

void Project::add_space(FILE *fp1)
{
    if(FindSpace)
    {
       if(!ifN3or)                     // 10-06-2013
          fprintf(fp1, "findspace\n");
    }
    else if(!str_white(szSpaceGroup))
       fprintf(fp1, "space %s\n", szSpaceGroup);
}

void Project::add_content(FILE *fp1)
{
    if(!nElements)
       return;
    fprintf(fp1, "cont %s\n", Content().c_str());
}

void Project::add_cell(FILE *fp1)
{
    if(!ifN3or)
    {
       fprintf(fp1, "cell ");
       for(int i=0; i<3;i++)
           fprintf(fp1, " %.6f", Cell[i]);
       for(int i=3; i<6;i++)
           fprintf(fp1, " %.5f", Cell[i]);
       fprintf(fp1, "\n");
    }
}

void Project::add_ntreor(FILE *fp1)
{
    if(ifN3or)
       fprintf(fp1, "%%ntreor\n");
}

void Project::add_end(FILE *fp1)
{
    if(ifDirectM)
       fprintf(fp1, "%%continue\n");
    else if(ifSannel)
    {
//       fprintf(fp1, "%%extraction\n");
//       fprintf(fp1, "%%fragment %s\n", szFragment);
       std::string s = fromUTF8(szFragment);
       fprintf(fp1, "%%fragment %s\n", s.c_str());
       fprintf(fp1, "%%sannel\n");
       fprintf(fp1, "%%continue\n");
    }
    else
       fprintf(fp1,"%%continue\n");
//210610       fprintf(fp1,"%%end\n");
}

void Project::BuildFilenames(const char* dir, const char *basenam)
{
    std::string strfile;
    strfile = g_build_filename(dir, basenam, NULL);
    strfile.append(".exp");
    std::string s = fromUTF8(strfile);
    CopiaStringa(InputF, MaxLenFilename, s.c_str());
    strfile = g_build_filename(dir, basenam, NULL);
    strfile.append(".out");
    s.assign(fromUTF8(strfile));
    CopiaStringa(OutputF, MaxLenFilename, s.c_str());
}

int Project::ReadForm(GtkWidget *dlg, int ifMissing)
{
    GtkWidget *entry;
    GtkWidget *button;
    GtkWidget *widget;
    int ier, i, nr, check;
    float numero;
    std::string megastr = "";
    std::string title, strfile;
    const gchar *campo;

    ier = 0;

    if (!ifMissing)
    {
//  Working Directory 

      entry = get_widget(dlg, "wd");
      std::string s = fromUTF8(gtk_entry_get_text (GTK_ENTRY(entry)));
      campo = s.c_str();
      if(strcmp(campo, WorkingDir))
         Changed = true;
      CopiaStringa(WorkingDir, MaxLenFilename, campo);
      ier = dir_set_current(WorkingDir);
      if(ier != 0)
      {
         i = cMsgWinErr("Warning", WorkingDir, 50+WARN_WINDOW);
         return ier;
      }
      CopiaStringa(cSWareRC->WorkingDirectory, MaxLenFilename, WorkingDir);

//  Structure Name  

      entry = get_widget(dlg, "structnam");
      s.assign(fromUTF8(gtk_entry_get_text (GTK_ENTRY(entry))));
      campo = s.c_str();
      if(strcmp(campo, StructureName))
         Changed = true;
      CopiaStringa(StructureName, sizeof(StructureName),  campo);
      if(strlen(StructureName) <= 0)
      {
//       cMsgWinErr("Warning", " ", 60+WARN_WINDOW);
//       return  -2;
         entry = get_widget(dlg, "rpc_file");
         campo = gtk_editable_get_chars (GTK_EDITABLE(entry), 0, -1);
         if(!str_white(campo))
         {
            std::string nome = g_path_get_basename(campo);
            size_t n1 = nome.find(".");
            s.assign(fromUTF8(nome.substr(0, n1)));
            CopiaStringa(StructureName, sizeof(StructureName),  s.c_str());
         }
      }
      if(str_white(JobTitle))
      {
         title = "structure ";
         title.append(StructureName);
         CopiaStringa(JobTitle, sizeof(JobTitle),  title.c_str());
      }

//  Input and Output files

      if(!OldFile)
      {
         strfile = g_build_filename(WorkingDir, StructureName, NULL);
         strfile.append(".exp");
         CopiaStringa(InputF, MaxLenFilename, strfile.c_str());
         strfile = g_build_filename(WorkingDir, StructureName, NULL);
         strfile.append(".out");
         CopiaStringa(OutputF, MaxLenFilename, strfile.c_str());
      }

//  Profile Counts

      entry = get_widget(dlg, "rpc_file");
      s.assign(fromUTF8(gtk_entry_get_text (GTK_ENTRY(entry))));
      campo = s.c_str();
      i = CheckFile(campo, "Profile counts filename");
      if(i == 0)
      {
         if(strcmp(campo, PCountsFile))
            Changed = true;
         CopiaStringa(PCountsFile, MaxLenFilename, campo);
      }

//  Range

      entry = get_widget(dlg, "range");
      check = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
      if(check != Range)
         Changed = true;
      Range = 0;
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
      {
         Range = 1;
         entry = get_widget(dlg, "thmin");
         errno = 0;
         numero = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
         if ((errno != 0) || (MRabs(numero) < 1e-6))
         {
            cMsgWinErr("Warning", "Incorrect or missing value for thmin", WARN_WINDOW);
            return -5;
         }
         if(MRabs(numero - thmin) > 1e-6)
            Changed = true;
         thmin = numero;
         entry = get_widget(dlg, "thmax");
         errno = 0;
         numero = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
         if ((errno != 0) || (MRabs(numero) < 1e-6))
         {
            cMsgWinErr("Warning", "Incorrect or missing value for thmax", WARN_WINDOW);
            return -5;
         }
         if(MRabs(numero - thmax) > 1e-6)
            Changed = true;
         thmax = numero;
      }

//  Source

      for(i=0; i<(int) (sizeof(sources)/sizeof(sources[0]));i++)
      {
          button = get_widget(dlg,sources[i]);
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
             check = i+1;
      }
      if(check != Source)
         Changed = true;
      Source = check;

//  Wavelength 
      entry = get_widget(dlg,"wavelength");
      errno = 0;
      numero = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
      if ((errno != 0) || (MRabs(numero) < 1e-6))
      {
           cMsgWinErr("Warning", "wavelength", 110+WARN_WINDOW);
           return -5;
      }
      if(MRabs(numero - Wavelen) > 1e-6)
         Changed = true;
      Wavelen = numero;

//  k Alpha 2 correction

      entry = get_widget(dlg, "kalpha2");
      check = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
      if(check != Alpha2)
         Changed = true;
      Alpha2 = check;

//  Structure solution
#if 0
       entry = get_widget(dlg,"solution_check");
       check = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
       if(check != ifStSol)
          Changed = true;
       ifStSol = check;
#endif
      ifStSol = 1;

      if(ifStSol)
      {
//  Direct Method 
         entry = get_widget(dlg,"dm_check");
         check = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
         if(check != ifDirectM)
            Changed = true;
         ifDirectM = check;
// Simulated annealing
         entry = get_widget(dlg,"sa_check");
         check = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
         if(check != ifSannel)
            Changed = true;
         ifSannel = check;
         if(ifSannel)
         {
            entry = get_widget(dlg, "frag_file");
            s.assign(fromUTF8(gtk_entry_get_text (GTK_ENTRY(entry))));
            campo = s.c_str();
            i = CheckFile(campo, "Fragment filename");
            if(i == 0)
            {
               if(strcmp(campo, szFragment))
                  Changed = true;
               CopiaStringa(szFragment, MaxLenFilename, campo);
            }
         }
      }
      else
      {
         ifDirectM = 0;
         ifSannel = 0;
      }
// N3OR
      entry = get_widget(dlg, "n3or_check");
      check = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
      if(check != ifN3or)
         Changed = true;
      ifN3or = check;
    }

//  Space Group
    entry = get_widget(dlg, "fs_check");
    check = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
    if(FindSpace != check)
       Changed = true;
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
    {
       memset(szSpaceGroup, 0, sizeof(szSpaceGroup));
       FindSpace = 1;
    }
    else
    {
       FindSpace = 0;
       entry = get_widget(dlg, "space_group_combo");
       char spstri[17];
       memset(spstri, 0, sizeof(spstri));
       int checkz = 1;
       if(ifN3or && (!ifDirectM))
          checkz = 0;
       int ier = check_spg(dlg, entry,spstri, checkz);
       if(ier)
          return -5;
       g_strstrip(spstri);
       if(strcmp(szSpaceGroup, spstri))
          Changed = true;
       CopiaStringa(szSpaceGroup, sizeof(szSpaceGroup), spstri);
    }

//  Cell Parameters

    if(ifN3or)
    {
       for(i=0; i<6; i++)
           Cell[i] = 0;
    }
    else
    {
       for(i=0; i<6; i++)
       {
           entry = get_widget(dlg, labels[i]);
           errno = 0;
           numero = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
           if ((errno != 0) || (MRabs(numero) < 1e-6))
           {
              if(ifMissing)
                 gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
              cMsgWinErr("Warning", labels[i], 110+WARN_WINDOW);
              if(ifMissing)
                 gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
              return -5;
           }
           if(MRabs(numero - Cell[i]) > 1e-6)
              Changed = true;
           Cell[i] = numero;
       }
    }

//  Cell Content

    if(ifMissing < 2)
    {
       widget = get_widget(dlg,"formula");
       char *line = g_strdup(gtk_entry_get_text(GTK_ENTRY(widget)));
       int *Z = g_new0(int, NUMSPECIES);
       int *NW = g_new0(int, NUMSPECIES);
       nr = get_content_from_formula_(line, NW, Z, strlen(line));
       if(nr > 0)
       {
          if(nr != nElements)
             Changed = true;
          nElements = nr;
          for(i=0; i<nr; i++)
          {
              if(NW[i] != Amount[i])
                 Changed = true;
              Amount[i] = NW[i];
              const char *string0 = get_nth_element(Z[i]-1);
              if(strcmp(Elem[i], string0))
                 Changed = true;
              CopiaStringa(Elem[i], SYMLEN+1, string0);
          }
          if(strcmp(Content().c_str(), line))
             Changed = true;
       }
       else if(nr < 0)
       {
           if(ifMissing)
              gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
           i = cMsgWinErr("Warning", "Wrong Cell Content.", WARN_WINDOW);
           if(ifMissing)
              gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
           return -2;
       }
//    else if (!ifN3or)        //mr111009 || FindSpace || ifStSol)
//    else if (FindSpace || ifDirectM)     //mr020611
//    else if (!ifN3or)        //mr071111
// il contenuto serve con findspace e DM e non con ntreor e SA
       else if ( (FindSpace || ifDirectM) && !ifN3or )     //corr030912
       {
            if(ifMissing)
               gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
            cMsgWinErr("Warning", "cell content", 110+WARN_WINDOW);
            if(ifMissing)
               gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
            return -5;
       }
       else
            nElements = 0;
       SetContent(line);
    }
    return 0;
}

void Project::FillForm(GtkWidget *dlg, int ifMissing)
{
    GtkWidget *entry;
    GtkWidget *button;
    GtkWidget *widget;
    int i;
    std::string title;

   if(!ifMissing)
   {
//  Working Directory 

       entry = get_widget(dlg, "wd");
       gtk_entry_set_text(GTK_ENTRY(entry), toUTF8(WorkingDir));
       CopiaStringa(cSWareRC->WorkingDirectory, MaxLenFilename, WorkingDir);
       gtk_widget_set_sensitive(entry, !OldFile);
       entry = get_widget(dlg, "wd_b");
       gtk_widget_set_sensitive(entry, !OldFile);

//  Structure Name  

       entry = get_widget(dlg, "structnam");
       gtk_entry_set_text(GTK_ENTRY(entry),toUTF8(StructureName));

//  Input and Output files

       if(OldFile)
          BuildFilenames(g_path_get_dirname(OldF), str_cut(g_path_get_basename(OldF), "."));

//  Profile Counts

       entry = get_widget(dlg, "rpc_file");
       gtk_entry_set_text(GTK_ENTRY(entry),toUTF8(PCountsFile));
       update_infopatt("new_project_dlg", PCountsFile);

//  Range

       entry = get_widget(dlg, "range");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), Range);
       entry = get_widget(dlg, "tablerange");
       gtk_widget_set_sensitive(entry, Range);
       entry = get_widget(dlg, "thmin");
       gtk_entry_set_text(GTK_ENTRY(entry), fToStr(thmin, 3).c_str());
       entry = get_widget(dlg, "thmax");
       gtk_entry_set_text(GTK_ENTRY(entry), fToStr(thmax, 3).c_str());

//  Source

       button = get_widget(dlg, sources[Source-1]);
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);

//  Wavelength 
       entry = get_widget(dlg,"wavelength");
       gtk_entry_set_text(GTK_ENTRY(entry), fToStr(Wavelen, 6).c_str());

//  k Alpha2 correction

       button = get_widget(dlg, "kalpha2");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), Alpha2);
    }

//  Space Group
    if(ifMissing < 2)
    {
       entry = get_widget(dlg, "fs_check");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), FindSpace);
    }
    entry = get_widget(dlg, "space_group_combo");
    combo_set_text(entry, szSpaceGroup);

//  Cell Parameters

    entry = get_widget(dlg, "n3or_check");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), ifN3or);
    for(i=0; i<3; i++)
    {
        entry = get_widget(dlg, labels[i]);
        gtk_entry_set_text(GTK_ENTRY(entry), fToStr(Cell[i], 6).c_str());
    }
    for(i=3; i<6; i++)
    {
        entry = get_widget(dlg, labels[i]);
        gtk_entry_set_text(GTK_ENTRY(entry), fToStr(Cell[i], 5).c_str());
    }
    entry = get_widget(dlg, "cell_param");
    gtk_widget_set_sensitive(entry, !ifN3or);

    entry = get_widget(get_widget(dlg, "space_group_combo"), "entry");
    g_signal_emit_by_name  ((GObject *) entry, "activate", entry, dlg);

//  Cell Content

    if(ifMissing < 2)
    {
       widget = get_widget(dlg,"formula");
       gtk_entry_set_text(GTK_ENTRY(widget), "");
       if(Content().c_str())
          gtk_entry_set_text(GTK_ENTRY(widget),  Content().c_str());
    }

    if(!ifMissing)
    {
//  Structure Solution
#if 0
       entry = get_widget(dlg,"solution_check");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), ifStSol);
#endif
//  Direct Method 
       entry = get_widget(dlg,"dm_check");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), ifDirectM & ifStSol);
// Simulated annealing
       entry = get_widget(dlg,"sa_check");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), ifSannel & ifStSol);
       if(ifSannel)
       {
          entry = get_widget(dlg, "frag_file");
          gtk_entry_set_text(GTK_ENTRY(entry),toUTF8(szFragment));
       }
       Changed = false;
    }
}

void Project::Save(const std::string &strfn, GtkWidget *dlg ) const
{
    std::ofstream fil;

    fil.open(strfn.c_str(), std::ios::binary|std::ios::out);
    if( !fil || !fil.is_open() )
    {
      MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "Error in open file: %s", strfn.c_str());
      return;
    }
    fil.write(static_cast<const char*>(static_cast<const void*>(this)), sizeof(*this));
}

int Project::Open(const std::string &strfn, GtkWidget *dlg )
{
  std::ifstream f;

  //memset(this, 0, sizeof(*this));

  size_t nsz = read_project(strfn.c_str(), static_cast<char*>(static_cast<void*>(this)), sizeof(*this));

  if( nsz <= 0 )
  {
    MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "Error in open file: %s", strfn.c_str());
    return -1;
  }
  if( nsz!=sizeof(*this) )
  {
    MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "This is not a Expo project file");
    return -1;
  }
  if(dir_set_current(WorkingDir))
  {
    MessageDialog(dlg, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "Error in dir_set_current: %s ", WorkingDir);
    CopiaStringa(WorkingDir, sizeof(WorkingDir), cSWareRC->WorkingDirectory);
  }
  if(!mr_access(WorkingDir, 'm'))
  {
    MessageDialog(dlg, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
          "Working directory '%s' is read-only", WorkingDir);
    CopiaStringa(WorkingDir, sizeof(WorkingDir), cSWareRC->WorkingDirectory);
  }
  if(dir_set_current(WorkingDir))
  {
    MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "Error in dir_set_current: %s ", WorkingDir);
    return -1;
  }
  return 0;
}

}       // end namespace

void  update_infopatt(const gchar *wFather, gchar *data)
{
using namespace Expo;
   if(wFather == NULL)
      return;
   std::string s = fromUTF8(data);
   gchar *stringdata = g_strdup(s.c_str());
   GtkWidget *widget = get_widget(finestre[0], wFather);
   int ier;
   float tmin, tmax, wavel;
   get_info_datafilec_(stringdata,&tmin,&tmax,&wavel,&ier, strlen(stringdata));
   if(ier)
      return;
   GtkWidget *w = get_widget(widget, "thmin");
   gtk_entry_set_text(GTK_ENTRY(w), fToStr(tmin, 3).c_str());
   w = get_widget(widget, "thmax");
   if(MRabs(project->Wavelen) < 1e-6)
      gtk_entry_set_text(GTK_ENTRY(w), fToStr(tmax, 3).c_str());
   w = get_widget(widget, "wavelength");
   gtk_entry_set_text(GTK_ENTRY(w), fToStr(wavel, 6).c_str());
   std::string nome = g_path_get_basename(stringdata);
   size_t n1 = nome.find(".");
   w = get_widget(widget, "structnam");
   const char *campo = gtk_entry_get_text(GTK_ENTRY(w));
   if(str_white(campo))
      gtk_entry_set_text(GTK_ENTRY(w), nome.substr(0, n1).c_str());
   project->thmin = tmin;
   project->thmax = tmax;
   if(MRabs(project->Wavelen) < 1e-6)
      project->Wavelen = wavel;
   if(str_white(project->StructureName))
      CopiaStringa(project->StructureName, sizeof(project->StructureName),
     nome.substr(0, n1).c_str());
}

const char *struct_to_prj(const gchar *nomestru)
{
   char *string, *suffix;
   unsigned int i;
   size_t sz = strlen(nomestru) + strlen(PK) + 6;
   std::string stringa;

   string = g_new0(char, sz);
   suffix = g_strdup_printf("%s", PK);
   for(i=0; i<strlen(suffix); i++)
           suffix[i] = tolower(suffix[i]);
   ScriviStringa(string, sz, "%s_%s.prj", nomestru, suffix);
   stringa = string;
   return stringa.c_str();
}

int write_file(GtkWidget *dialog)
{
using namespace Expo;
using namespace gtkext;
   const std::string fn = struct_to_prj(project->StructureName);
   FilselItem local_it;
   bool ok = false;

//   project->ReadForm(dialog);
   if(!project->Changed)
       return 0;
    if(OldFile)
       project->BuildFilenames(g_path_get_dirname(OldF), str_cut(g_path_get_basename(OldF), "."));
    else
       project->BuildFilenames(project->WorkingDir, project->StructureName);
   if(g_file_test(project->InputF, G_FILE_TEST_EXISTS))
   {
      gboolean response = dlg_yesno(GTK_WINDOW(dialog), "File already exists. OK to overwrite %s?", project->InputF);
      if(response)
         ok = true;
      else
      {
         local_it = saveas(finestre[0], "*.exp", project->InputF);
         if(local_it.exitCode > 0)
         {
             std::string nomestru = str_cut(g_path_get_basename(local_it.fileinp), ".");
             project->BuildFilenames(local_it.cwd, nomestru.c_str());
             ok = true;
         }
      }
   }
   else
      ok = true;
   if(ok)
   {
      project->SaveAsExp();
      if(CreatePrj)
         project->Save(fn, dialog);
      return 0;
   }
   return 1;
}

void riempi_newproj(GtkWidget *dialog)
{
using namespace Expo;
   std::string fn = struct_to_prj(gtk_entry_get_text(GTK_ENTRY(get_widget(dialog, "structnam"))));
   if(project != NULL)
      delete project;
   project = NULL;
   project = new Project();
   if(project->Open(fn, dialog) == 0)
      project->FillForm(dialog);
}

void to_open_file(GtkButton *button, gpointer data)
{

  if(GTK_IS_WIDGET(new_project_dlg))
     gtk_widget_set_sensitive(new_project_dlg, FALSE);
  open_file(NULL, data);
  if(GTK_IS_WIDGET(new_project_dlg))
  {
     if(GPOINTER_TO_INT(data) == 10)
        riempi_newproj(new_project_dlg);
     GtkWidget *entry = get_widget(new_project_dlg, "wd");
     if(GPOINTER_TO_INT(data) == 5)             // data file
        gtk_entry_set_text(GTK_ENTRY(entry), toUTF8(cSWareRC->WorkingDirectory));
     gtk_widget_set_sensitive(new_project_dlg, TRUE);
  }
}

gboolean on_entry_focus_out_event  (GtkWidget  *widget, GdkEventFocus *event,
                                    gpointer user_data)
{
  gtk_editable_set_position(GTK_EDITABLE(widget), 0);
  return FALSE;
}

#ifndef GTK_COMBO_BOX
void space_group_assigned  (GtkList *list, GtkWidget  *wid, gpointer data)
{
     GtkWidget *combo1 = get_widget((GtkWidget *) data, "space_group_combo");
#else
void space_group_assigned  (GtkWidget  *combo, gpointer data)
{
     GtkWidget *combo1;
     if(GTK_IS_COMBO_BOX(combo))
     {
        if (gtk_combo_box_get_active(GTK_COMBO_BOX(combo)) == -1)
            return;
        combo1 = combo;
     }
     else
        combo1 = gtk_widget_get_parent(combo);
#endif
     char string0[17];
     GtkWidget *dlg = gtk_widget_get_toplevel(combo1);
     (void) check_spg(dlg, combo1, string0, 0);
}

void close_newproj_dlg(GtkButton *button, gpointer data)
{
using namespace Expo;
using namespace gtkext;

    GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
    int ier = -1;

    if(GPOINTER_TO_INT(data))
    {
       if(project->ReadForm(dlg))
          return;
       ier = write_file(dlg);
    }   
    if(ier <= 0)
       close_dlg(button, GINT_TO_POINTER(1));
    if(ier == 0)
    {
      dlg = gtk_message_dialog_new(GTK_WINDOW(finestre[0]),GTK_DIALOG_MODAL,
          GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "File: %s has been created.\n"
          "Do you want edit it, run or quit?", toUTF8(project->InputF));
      GtkWidget *button1 =  myimage_button("  _Edit", "edit.png");
      gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button1, 1);
      button1 =  myimage_button("    _Go", "go.png");
      gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button1, 2);
      gtk_widget_grab_focus (button1);
      button1 = QUIT_button();
      gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button1, 3);
      int response = gtk_dialog_run(GTK_DIALOG(dlg));
      gtk_widget_destroy(dlg);
      switch(response)
      {
      case 3:
      default:
           return;
           break;
      case 1:
           text_window(NULL, project->InputF, "*.exp", 
              IFPROP + IFSAVE, project->InputF);
           break;
      case 2:
           break;
      }
//      g_print("response %d\n", response);
      reset_project_name();
      call_fortran(project->InputF, project->OutputF, "exp");
    }
}

GtkWidget *list_store_new(int ncol, const char *titles[], int sizes[])
{
  GtkWidget *dirsel;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  GType *types = g_new0(GType, ncol);
  int i;

  dirsel = gtk_tree_view_new();
  g_object_set_data(G_OBJECT(dirsel), "formato", GINT_TO_POINTER(ncol));
  for(i=0; i<ncol; i++)
      types[i] = G_TYPE_STRING;

  store = gtk_list_store_newv(ncol, types);
  for(i=0; i<ncol; i++)
  {
        renderer = gtk_cell_renderer_text_new ();
        g_object_set (GTK_CELL_RENDERER (renderer),
                "font-desc", fontdescU, "xpad", sizes[i]/4,
                "xalign", 1., NULL);
        column = gtk_tree_view_column_new_with_attributes (titles[i],
            renderer, "text", i, NULL);
        gtk_tree_view_column_set_sizing (column,GTK_TREE_VIEW_COLUMN_FIXED);
        gtk_tree_view_column_set_fixed_width(column, sizes[i]);
        gtk_tree_view_column_set_clickable(column, FALSE);
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column);
  }
  gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
  return dirsel;
}

int get_cell_param(GtkWidget *dlg, float cell[])
{
using namespace Expo;
   int ier = 0;
   for(int i=0; i<6; i++)
   {
       GtkWidget *entry = get_widget(dlg, labels[i]);
       errno = 0;
       float numero = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
       if ((errno != 0) || numero < 1e-6)
          ier = 1;
       else
          cell[i] = numero;
   }
   return ier;
}

int get_cell_content(GtkWidget *dlg, stringa5 El[], int Am[])
{
    GtkWidget *widget = get_widget(dlg,"formula");
    if(widget == NULL)
       return -1;
    char *param = g_strdup(gtk_entry_get_text(GTK_ENTRY(widget)));
    if(str_white(param))
       return -1;
    int *Z = g_new0(int, NUMSPECIES);
    int nEl = get_content_from_formula_(param, Am, Z, strlen(param));
    if(nEl == 0)
       return -1;
    int hnd = get_int(widget, "hnd");
    g_signal_handler_block(G_OBJECT(widget), hnd);
    set_error_color(widget, (nEl < 0));
    g_signal_handler_unblock(G_OBJECT(widget), hnd);
    if(nEl < 0)
       return -1;
    else
    {
        for(int i=0; i<nEl; i++)
            CopiaStringa(El[i], SYMLEN+1, get_nth_element(Z[i]-1));
    }
    g_free(Z);
    return nEl;
}

void cell_param_changed(GtkWidget *widget, GtkWidget *dlg)
{
   float cell[6];
   stringa5 El[NUMSPECIES];
   int Am[NUMSPECIES];

   int ier = get_cell_param(dlg, cell);

   GtkWidget *label  = get_widget(dlg, "CellVolume");
   GtkWidget *label2 = get_widget(dlg, "Volumeperat");
   GtkWidget *label3 = get_widget(dlg, "density");
   if(!ier)
   {
      float V = cellvolumeforc_(cell);
      set_label_text(label, g_strdup_printf("%.3f", V), MyBLUE, 0.99f);
      int nEl = get_cell_content(dlg, El, Am);
      if(nEl > 0)
      {
         float d;
         float VxAt = volumeperatomforc_(&nEl, El, Am, &V, &d);
         set_label_text(label2, g_strdup_printf("%.3f", VxAt), MyBLUE, 0.99f);
         set_label_text(label3, g_strdup_printf("%.3f", d), MyBLUE, 0.99f);
      }
      else 
      {
         if(label2 != NULL)
            gtk_label_set_text(GTK_LABEL(label2), " ");
         if(label3 != NULL)
            gtk_label_set_text(GTK_LABEL(label3), " ");
      }
   }
   else
   {
      gtk_label_set_text(GTK_LABEL(label), " ");
      if(label2 != NULL)
         gtk_label_set_text(GTK_LABEL(label2), " ");
      if(label3 != NULL)
         gtk_label_set_text(GTK_LABEL(label3), " ");
   }
}

GtkWidget *create_spacegroup(GtkWidget *father, int ifVert)
{
  GtkWidget *hbox2, *label, *combo, *frame;
  char      filspg[256], *spg;
  GtkWidget *button, *entry;
  GList     *glist=NULL;
  FILE *fp;

  frame = NEW_FRAME("Space Group");
  if(ifVert)
     hbox2 = vbox_new (FALSE, 0);
  else
     hbox2 = hbox_new (FALSE, 0);
  add_to_frame(frame, hbox2);
  g_object_set_data(G_OBJECT(frame), "box", hbox2);

  button = gtk_check_button_new_with_mnemonic (" _Find Space Group");
  gtk_widget_show(button);
  g_object_set_data(G_OBJECT(father), "fs_check", button);
  gtk_box_pack_start( GTK_BOX(hbox2), button, FALSE, FALSE, vspace);

  combo = my_combo(G_CALLBACK (space_group_assigned), father);
  g_object_set_data (G_OBJECT (father), "space_group_combo", combo);
  ScriviStringa(filspg,sizeof(filspg),"%s%c%s.spg", files_dir, DIR_SEPAR, MR_PACKAGE);
  fp = fOpen(filspg, "r");
  if(fp != NULL)
  {
     glist = NULL;
     spg = g_new0(char, 17);
     while(fgets(filspg, 256, fp) != NULL)
     {
        if(filspg[0] != '$')
        {
            CopiaStringan(spg, 17, filspg, 12);
            *(spg + 12) = '\0';
            glist = g_list_append(glist, DuplicaStringa(spg));
        }
     }
     fclose(fp);
  }
  fill_my_combog(combo, glist);
  entry = get_widget(combo, "entry");

#ifdef GTK_ENTRY_COMPLETION
  int i;
  GtkTreeIter iter;
  GtkListStore *completion_model;
  GtkEntryCompletion *completion = gtk_entry_completion_new ();
  gtk_entry_set_completion (GTK_ENTRY (entry), completion);
  g_object_set_data (G_OBJECT (father), "completion", completion);
  completion_model = gtk_list_store_new(1, G_TYPE_STRING);
  for(i=0; i < (int)g_list_length(glist);i++)
  {
      gtk_list_store_append(completion_model, &iter);
      gtk_list_store_set(completion_model, &iter, 0, g_list_nth_data(glist, i), -1);
  }
  gtk_entry_completion_set_model (completion, GTK_TREE_MODEL(completion_model));
  gtk_entry_completion_set_text_column (completion, 0);
#endif

  g_list_free (glist);

  label = gtk_label_new ("Space Group Symbol:");
  if(ifVert)
     set_alignment(label, 0, 0.5);
  else
     set_alignment(label, 1, 0.5);

  gtk_box_pack_end( GTK_BOX(hbox2), combo, FALSE, FALSE, vspace);
  gtk_box_pack_end( GTK_BOX(hbox2), label, FALSE, FALSE, vspace);

  g_signal_connect(G_OBJECT (button), "toggled",
              G_CALLBACK (on_cb_disattiva), combo);
/* 071111
  if(ifVert == 0)                // solo per New project e non per missing
     g_signal_connect(G_OBJECT (button), "toggled",
              G_CALLBACK (toggle_cellcontent), GINT_TO_POINTER(1));
*/

  return frame;
}

GtkWidget *create_cell_parameters(GtkWidget *father, int if3)
{
  GtkWidget *frame, *table2, *table1, *label, *entry, *button;
  int k, kl;

  frame = NEW_FRAME("Cell Parameters");

  table2 = table_new (1, 2, FALSE);
  gtk_widget_show (table2);
  table_set_row_spacings (table2, 2);
  table_set_col_spacings (table2, 2);
  add_to_frame (frame, table2);

  button = gtk_check_button_new_with_mnemonic("_Cell Determination by N-TREOR");
  if(!if3)
     table_attach_exp(table2, button, 0, 1, 0, 1);
  g_object_set_data(G_OBJECT (father), "n3or_check", button);
  table1 = table_new (3, 6, FALSE);
  gtk_widget_show (table1);
  g_object_set_data(G_OBJECT (father), "cell_param", table1);
  table_set_row_spacings (table1, vspace);
  table_set_col_spacings (table1, vspace);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 0);
  table_attach_exp(table2, table1, 0, 1, 1, 2);
  for(k = 0; k<12; k++)
  {
      kl = k / 2;
      if((k % 2) == 0)                     /* label */
      {
          if(k < 6)
             label = gtk_label_new (labels[kl]);
          else
             label = gtk_label_new (greek(kl-3));
          gtk_widget_show (label);
          table_attach_exp(table1, label, k, k+1, 0, 1);
          set_alignment(label, 1.0, 0.5);
      }
      else                                 /* entry */
      {
          entry = gtk_entry_new ();
          g_object_set_data(G_OBJECT (father), labels[kl], entry);
          gtk_widget_show (entry);
          set_width_chars(GTK_ENTRY(entry), 10);
          table_attach_exp(table1, entry, k, k+1, 0, 1);
          g_signal_connect (G_OBJECT (entry), "focus_out_event",
                      G_CALLBACK (on_entry_focus_out_event),
                      NULL);
          g_signal_connect (G_OBJECT (entry), "changed",
                      G_CALLBACK (cell_param_changed),
                      father);
       }

      label = gtk_label_new ("Volume:");
      gtk_widget_show (label);
      table_attach_exp(table1, label, 0, 1, 1, 2);
      set_alignment(label, 1.0, 0.5);
      entry = gtk_label_new (" ");
      g_object_set_data(G_OBJECT (father), "CellVolume", entry);
      gtk_widget_show (entry);
      gtk_widget_set_size_request(entry, 90, -1);
      table_attach_exp(table1, entry, 1, 2, 1, 2);
  }
  g_signal_connect (G_OBJECT(button), "toggled", G_CALLBACK(on_cb_disattiva), table1);
  return frame;
}

GtkWidget *create_cell_parameters(GtkWidget *father)
{
   return create_cell_parameters(father, 0);
}

//void cell_content_changed(GtkTextBuffer *tb, GtkWidget *dlg)
void cell_content_changed(GtkWidget *, GtkWidget *dlg)
{
   stringa5 El[NUMSPECIES];
   int Am[NUMSPECIES];
   float cell[6];

   int nEl = get_cell_content(dlg, El, Am);
   GtkWidget *label = get_widget(dlg, "ContentVolume");
   GtkWidget *label2 = get_widget(dlg, "Volumeperat");
   GtkWidget *label3 = get_widget(dlg, "density");
   if(nEl > 0)
   {
      float ContentV = contentvolumeforc_(&nEl, El, Am);
      set_label_text(label, g_strdup_printf("%.3f", ContentV), MyBLUE, 0.99f);
      int ier = get_cell_param(dlg, cell);
      if(!ier)
      {
         float d;
         float V = cellvolumeforc_(cell);
         float VxAt = volumeperatomforc_(&nEl, El, Am, &V,&d);
         set_label_text(label2, g_strdup_printf("%.3f", VxAt), MyBLUE, 0.99f);
         set_label_text(label3, g_strdup_printf("%.3f", d), MyBLUE, 0.99f);
      }
      else
      {
         gtk_label_set_text(GTK_LABEL(label2), " ");
         gtk_label_set_text(GTK_LABEL(label3), " ");
      }
   }
   else
   {
      gtk_label_set_text(GTK_LABEL(label), " ");
      gtk_label_set_text(GTK_LABEL(label2), " ");
      gtk_label_set_text(GTK_LABEL(label3), " ");
   }
}

GtkWidget *create_Cell_Content(GtkWidget *dialog)
{
  GtkWidget *frame1, *content, *vbox, *table, *entry, *label;

//  frame1 = NEW_FRAME("Cell Content");
  vbox = vbox_new(FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 4);
  frame1 = hbox_new(FALSE, 0);
  g_object_set_data (G_OBJECT (dialog), "frame_content", frame1);
  gtk_box_pack_start(GTK_BOX(vbox), frame1, FALSE, FALSE, 2);
  label = LABEL_BOLD("Cell Content: ", NULL, 1.05f);
  gtk_box_pack_start(GTK_BOX(frame1), label, FALSE, FALSE, 0);
  set_alignment(label, 1.0, 0.5);
  content = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(frame1), content, TRUE, TRUE, 2);
  g_object_set_data(G_OBJECT (dialog), "formula", content);
  int hnd = g_signal_connect(G_OBJECT(content),  "changed", 
     G_CALLBACK(cell_content_changed), dialog);
  g_object_set_data(G_OBJECT (content), "hnd", GINT_TO_POINTER(hnd));
  GtkWidget *hb = hbox_new(FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), hb, FALSE, FALSE, 2);
  table = table_new (1, 6, FALSE);
  gtk_widget_show (table);
  table_set_col_spacings (table, 4);
  gtk_box_pack_start (GTK_BOX (hb), table, TRUE, TRUE, 20);

  label = LABEL_NEW ("Content Volume:", MyBLUE);
  gtk_widget_show (label);
  table_attach_exp(table, label, 0, 1, 0, 1);
  set_alignment(label, 1.0, 0.5);
  entry = gtk_label_new (" ");
  g_object_set_data(G_OBJECT (dialog), "ContentVolume", entry);
  gtk_widget_show (entry);
  gtk_widget_set_size_request(entry, 90, 24);
  table_attach_exp(table, entry, 1, 2, 0, 1);

  label = LABEL_NEW ("Volume per Atom:", MyBLUE);
  gtk_widget_show (label);
  table_attach_exp(table, label, 2, 3, 0, 1);
  set_alignment(label, 1.0, 0.5);
  entry = gtk_label_new (" ");
  g_object_set_data(G_OBJECT (dialog), "Volumeperat", entry);
  gtk_widget_show (entry);
  gtk_widget_set_size_request(entry, 90, 24);
  table_attach_exp(table, entry, 3, 4, 0, 1);

  label = LABEL_NEW ("Density:", MyBLUE);
  gtk_widget_show (label);
  table_attach_exp(table, label, 4, 5, 0, 1);
  set_alignment(label, 1.0, 0.5);
  entry = gtk_label_new (" ");
  g_object_set_data(G_OBJECT (dialog), "density", entry);
  gtk_widget_show (entry);
  gtk_widget_set_size_request(entry, 90, 24);
  table_attach_exp(table, entry, 5, 6, 0, 1);

  return vbox;
}

void structnam_changed(GtkEditable *entry, gpointer data)
{
using namespace Expo;
    GtkWidget *father = gtk_widget_get_toplevel(GTK_WIDGET(entry));
    std::string title;
    if(OldFile)
    {
       title = "New Project: ";
       title.append(gtk_editable_get_chars(entry, 0, -1));
    }
    else
    {
       title = "File: ";
       title.append(OldF);
    }
    gtk_window_set_title ( GTK_WINDOW (father), title.c_str());
}

/*
void edit_file(GtkButton *button, GtkWidget *entry)
{
using namespace gtkext;
    gtk_widget_set_sensitive(gtk_widget_get_toplevel(entry), FALSE);
    const gchar *filen = gtk_entry_get_text (GTK_ENTRY(entry));
    if(!str_white(filen) && g_file_test(filen, G_FILE_TEST_EXISTS))
       text_window(NULL, filen, "*.pow", IFPROP + IFSAVE, filen);
    gtk_widget_set_sensitive(gtk_widget_get_toplevel(entry), TRUE);
}
*/

GtkWidget *create_page(GtkWidget *father)
{
using namespace Expo;
  GtkWidget *vbox, *widget, *table, *frame, *button;
  GtkWidget *entry, *label, *vvbox, *hbox, *hbox1;
  GtkSizeGroup *szgroup1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  GtkSizeGroup *szgroup2 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  GSList    *rays_group = NULL;
  int i;

  vbox = vbox_new(FALSE, 0);
  
  widget = entry_for_fileselection(" User Working Directory: ", NULL,
             G_CALLBACK(to_open_file), GINT_TO_POINTER(20), 0, 1, MyRED, 'h');
  gtk_box_pack_start(GTK_BOX(vbox), widget, FALSE, FALSE, 10);
  gtk_size_group_add_widget(szgroup1, get_widget(widget, "label"));
  gtk_size_group_add_widget(szgroup2, get_widget(widget, "entry"));
  g_object_set_data(G_OBJECT(father), "all_wd", widget);
  g_object_set_data(G_OBJECT(father), "wd_b", get_widget(widget, "browse"));
  g_object_set_data(G_OBJECT(father), "wd", get_widget(widget, "entry"));
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(widget, "entry")), FALSE);

  widget = entry_for_fileselection(" Structure Name: ", NULL,
             G_CALLBACK(to_open_file), GINT_TO_POINTER(10), 0, CreatePrj, MyRED, 'h');
  g_object_set_data(G_OBJECT(father), "structnam", get_widget(widget, "entry"));
  gtk_size_group_add_widget(szgroup1, get_widget(widget, "label"));
  if (CreatePrj)
      gtk_size_group_add_widget(szgroup2, get_widget(widget, "entry"));
  else
  {
      gtk_box_set_child_packing (GTK_BOX(get_widget(widget, "box2")), get_widget(widget, "entry"), FALSE, FALSE, 0, GTK_PACK_START);
      gtk_box_set_child_packing (GTK_BOX(widget), get_widget(widget, "box2"), FALSE, FALSE, 0, GTK_PACK_START);
  }
  gtk_box_pack_start(GTK_BOX(vbox), widget, FALSE, FALSE, 4);
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(widget, "entry")), TRUE);
  g_signal_connect(G_OBJECT(get_widget(widget, "entry")), "changed",
             G_CALLBACK(structnam_changed), NULL);
  widget = entry_for_fileselection(" Profile Counts filename: ", NULL,
             G_CALLBACK(to_open_file), GINT_TO_POINTER(5), 0, 1, MyRED, 'h');
  gtk_size_group_add_widget(szgroup1, get_widget(widget, "label"));
  gtk_size_group_add_widget(szgroup2, get_widget(widget, "entry"));
  g_object_set_data(G_OBJECT (father), "rpc_file", get_widget(widget,"entry"));
  gtk_box_pack_start(GTK_BOX(vbox), widget, FALSE, FALSE, 4);
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(widget, "entry")), TRUE);
//  button = get_widget(widget, "preview");
//  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(edit_file), get_widget(widget, "entry"));

  frame = NEW_FRAME("Range");
  gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 4);
  vvbox = hbox_new(FALSE, 0);
  add_to_frame(frame, vvbox);
  button =  gtk_check_button_new_with_mnemonic ("_Modify range");
  gtk_box_pack_start(GTK_BOX(vvbox), button, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT (father), "range", button);

  frame = NEW_FRAME("Source");
  gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 4);

  table = table_new (1, 5, FALSE);
  gtk_container_set_border_width (GTK_CONTAINER (table), vspace);
  table_set_col_spacings (table, 10);
  gtk_box_pack_start(GTK_BOX(vvbox), table, FALSE, FALSE, 20);
  g_object_set_data(G_OBJECT (father), "tablerange", table);

  label = gtk_label_new("   ");
  gtk_widget_show (label);
  table_attach_exp (table, label, 2, 3, 0, 1);

  label = gtk_label_new("2theta min");
  gtk_widget_show (label);
  table_attach_exp (table, label, 0, 1, 0, 1);

  entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (father), "thmin", entry);
  gtk_widget_show (entry);
  table_attach_exp (table, entry, 1, 2, 0, 1);
  set_width_chars(GTK_ENTRY(entry), 10);

  label = gtk_label_new("2theta max");
  gtk_widget_show (label);
  table_attach_exp (table, label, 3, 4, 0, 1);

  entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (father), "thmax", entry);
  gtk_widget_show (entry);
  table_attach_exp (table, entry, 4, 5, 0, 1);
  set_width_chars(GTK_ENTRY(entry), 10);
  gtk_widget_set_sensitive(table, FALSE);
  g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(on_cb_attiva), table);

  hbox1 = hbox_new (FALSE, 0);
  add_to_frame (frame, hbox1);

  for(i=0; i< (int) (sizeof(sources)/sizeof(sources[0]));i++)
  {
      button = RADIO_BUTTON_WITH_LABEL (rays_group, sources[i], NULL);
      rays_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
      g_object_set_data (G_OBJECT (father), sources[i], button);
      gtk_box_pack_start (GTK_BOX (hbox1), button, TRUE, TRUE, (i==0)?0:8);
  }

  label = gtk_label_new("Wavelength");
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 20);
  set_alignment(label, 0, 0.5);

  entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (father), "wavelength", entry);
  gtk_widget_show (entry);
  gtk_box_pack_start (GTK_BOX (hbox1), entry, FALSE, FALSE, 4);
  set_width_chars(GTK_ENTRY(entry), 10);

  button =  gtk_check_button_new_with_mnemonic ("_K Alpha2 Correction");
  gtk_box_pack_start(GTK_BOX(hbox1), button, TRUE, TRUE, 10);
  g_object_set_data(G_OBJECT (father), "kalpha2", button);

  frame = create_spacegroup(father, 0);
  gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 4);

  hbox = hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 4);

  frame = create_cell_parameters(father);
  gtk_box_pack_start(GTK_BOX(hbox), frame, FALSE, FALSE, 4);

  frame = create_Cell_Content(father);
  gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 4);

  frame = NEW_FRAME("Structure Solution ");
  gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 4);
  hbox = table_new(2, 2, TRUE);
  add_to_frame(frame, hbox);

  GSList *group = NULL;
  button = gtk_radio_button_new_with_mnemonic (group, " _Direct Methods");
  table_attach(hbox, button, 0, 1, 0, 1, TRUE);
  g_object_set_data (G_OBJECT (father), "dm_check", button);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));

  button = gtk_radio_button_new_with_mnemonic (group, " _Simulated Annealing");
  table_attach(hbox, button, 1, 2, 0, 1, TRUE);
  g_object_set_data (G_OBJECT (father), "sa_check", button);
  widget = entry_for_fileselection(" Fragment filename: ", NULL,
             G_CALLBACK(to_open_file), GINT_TO_POINTER(40), 0, 1, MyRED, 'h');
  table_attach(hbox, widget, 0, 2, 1, 2, TRUE);
  g_object_set_data (G_OBJECT (father), "frag_file", get_widget(widget, "entry"));
  g_signal_connect (G_OBJECT(button), "toggled",
                G_CALLBACK(on_cb_show),widget);

  gtk_widget_show_all(vbox);
  gtk_widget_hide(widget);
  widget = get_widget(father, "all_wd");
  gtk_widget_hide(widget);

  return vbox;
}

void help_newproj(GtkButton *button, gpointer data)
{
    //open_htm("help_newproj.htm");
    open_htm("preparing-input-file");
}

void create_new_project (void)
{
  GtkWidget *vbox, *button1, *button2, *button3, *button4;
  GtkWidget *page;

  new_project_dlg = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (new_project_dlg),
                       "new_project_dlg", new_project_dlg);
  gtk_window_set_title (GTK_WINDOW (new_project_dlg), "New Project");
  vbox = gtk_dialog_get_content_area(GTK_DIALOG(new_project_dlg));
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 2);

  page = create_page(new_project_dlg);
  g_object_set_data (G_OBJECT (finestre[0]), "new_project_dlg",
                   new_project_dlg);
  gtk_box_pack_start (GTK_BOX (vbox), page, TRUE, TRUE, 0);
  gtk_widget_show (page);

  button2 =  CANCEL_button();
  g_object_set_data (G_OBJECT (new_project_dlg), "cancelbutton", button2);
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (new_project_dlg), button2, 1);
  g_signal_connect (G_OBJECT(button2), "clicked",
                G_CALLBACK(close_newproj_dlg),GINT_TO_POINTER(0));
  set_tip( button2, "Quit new project ");

  button1 = myimage_button("   _Save ", "save.png");
  g_object_set_data (G_OBJECT (new_project_dlg), "okbutton", button1);
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (new_project_dlg), button1, 2);
  g_signal_connect (G_OBJECT(button1), "clicked",
                G_CALLBACK(close_newproj_dlg),GINT_TO_POINTER(1));
  set_tip( button1, "Save input file and run ");

  button3 =  myimage_button(" _Open", "fileopen.png");
  g_object_set_data (G_OBJECT (new_project_dlg), "openbutton", button3);
  gtk_widget_show (button3);
  gtk_dialog_add_action_widget (GTK_DIALOG (new_project_dlg), button3, 3);
  g_signal_connect (G_OBJECT(button3), "clicked",
                G_CALLBACK(to_open_file),GINT_TO_POINTER(21));
  set_tip( button3, "Edit an existing input file ");

  button4 = HELP_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (new_project_dlg), button4, 4);
  gtk_widget_show (button4);
  g_signal_connect (G_OBJECT(button4), "clicked",G_CALLBACK(help_newproj), NULL);
  set_tip( button4, "Help on procedure");

  (void) g_signal_connect_swapped(G_OBJECT(new_project_dlg), "delete_event",
              G_CALLBACK(gtk_button_clicked), G_OBJECT(button2));
  (void) g_signal_connect(G_OBJECT(new_project_dlg), "delete_event",
              G_CALLBACK(true_cb), NULL);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button2)),
         GTK_BUTTONBOX_SPREAD);
}

void open_newproj_dlg (GtkWidget *menuitem, const char *user_data)
{
using namespace Expo;

   dir_set_current(cSWareRC->WorkingDirectory);
   if(project != NULL)
      delete project;
   project = NULL;
   project = new Project();

  if(new_project_dlg == NULL)
     create_new_project();
  project->FillForm(new_project_dlg);
  gtk_window_set_transient_for(GTK_WINDOW(new_project_dlg), GTK_WINDOW(finestre[0]));
  gtk_widget_show(new_project_dlg);
  finestra_modale_aperta2(new_project_dlg);
}

GtkWidget *create_missing_dialog(bool ifNtreor)
{
     GtkWidget *dialog, *frame, *vbox, *button, *hbox2;

     dialog = gtk_dialog_new();
     gtk_window_set_title (GTK_WINDOW (dialog), "Missing Information");

     vbox = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
     frame = create_cell_parameters(dialog, 1);
     gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 4);
     hbox2 = hbox_new(FALSE, 0);
     gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 4);
     frame = create_spacegroup(dialog, 1);
     gtk_box_pack_start(GTK_BOX(hbox2), frame, FALSE, FALSE, 4);
     if(ifNtreor)
     {
        frame = create_Cell_Content(dialog);
        gtk_box_pack_start(GTK_BOX(hbox2), frame, TRUE, TRUE, 4);
     }

     button = OK_button();
     gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, GTK_RESPONSE_OK);
     gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
              GTK_BUTTONBOX_SPREAD);
     if(!ifNtreor)
     {
        button = CANCEL_button();
        gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, GTK_RESPONSE_CANCEL);
     }
     gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(finestre[0]));
     gtk_widget_show_all(dialog);
     if(!ifNtreor)
     {
        frame = get_widget(dialog, "fs_check");
        gtk_widget_hide(frame);
     }

     return dialog;
}

extern "C" void cell_parameters_dlg_(float cell[6], int *ifFindSpace, char *spg,
               char *formula, int *return_flag, int *max_lung)
{
using namespace Expo;
    GtkWidget *dlg;
    int i;

    if(missing != NULL)
       delete missing;
    missing = NULL;
    missing = new Project();
    missing->FillProject(NULL, cell, *ifFindSpace, spg, formula);

    dlg = create_missing_dialog(true);
    gtk_widget_set_sensitive(finestre[0], FALSE);
    missing->FillForm(dlg, 1);

    int result = 0;
    bool cicla = true;
    while(cicla || (result == GTK_RESPONSE_NONE))
    {
         cicla = false;
         result = gtk_dialog_run(GTK_DIALOG(dlg));
         if(result == GTK_RESPONSE_OK)
         {
            gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
            if (missing->ReadForm(dlg, 1))
            {
                  cicla = true;
                  gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
            }
         }
    }
    gtk_widget_destroy(dlg);
    if(result == GTK_RESPONSE_OK)
    {
       *return_flag = 1;
       *ifFindSpace = missing->FindSpace;
       if(!missing->FindSpace)
       {
          g_strchug(missing->szSpaceGroup);
          memset(spg, ' ', 17);
          CopiaStringan(spg, 18, missing->szSpaceGroup, MRmin(16, strlen(missing->szSpaceGroup)));
       }
       for(i=0; i<6; i++)
           cell[i] = missing->Cell[i]; 
       CopiaStringa(formula, *max_lung-1, missing->Content().c_str());
    }
    else
       *return_flag = 0;
    delete missing;
    missing = NULL;
    gtk_widget_set_sensitive(finestre[0], TRUE);
}

#if 0
extern "C" void cell_parameters_dlg_(float cell[6], int *ifFindSpace, char *spg,
               int *nk, int nw[], stringa4 specchar[], int *return_flag)
{
using namespace Expo;
    GtkWidget *dlg;
    stringa4 *specch = specchar;
    int i, j;

    if(missing != NULL)
       delete missing;
    missing = NULL;
    missing = new Project();
    missing->FillProject(NULL, cell, *ifFindSpace, spg, *nk, nw, specch);

    dlg = create_ntreor_dialog();
    gtk_widget_set_sensitive(finestre[0], FALSE);
    missing->FillForm(dlg, 1);

    int result = 0;
    bool cicla = true;
    while(cicla || (result == GTK_RESPONSE_NONE))
    {
         cicla = false;
         result = gtk_dialog_run(GTK_DIALOG(dlg));
         if(result == GTK_RESPONSE_OK)
         {
            gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
            if (missing->ReadForm(dlg, 1))
            {
                  cicla = true;
                  gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
            }
         }
    }
    gtk_widget_destroy(dlg);
    if(result == GTK_RESPONSE_OK)
    {
       *return_flag = 1;
       *ifFindSpace = missing->FindSpace;
       if(!missing->FindSpace)
       {
          g_strchug(missing->szSpaceGroup);
          CopiaStringan(spg, 18, missing->szSpaceGroup, MRmin(16, strlen(missing->szSpaceGroup)));
       }
       for(i=0; i<6; i++)
           cell[i] = missing->Cell[i]; 
       *nk = missing->nElements;
       for(i=0; i<missing->nElements;i++)
       {
           for(j=0; j<SYMLEN; j++)
               specch[i][j] = missing->Elem[i][j];
           nw[i] = missing->Amount[i];
       }
    }
    else
       *return_flag = 0;
    delete missing;
    missing = NULL;
    gtk_widget_set_sensitive(finestre[0], TRUE);
}

extern "C" void writenewfile_(char *newfile, char *filnam, float cell[6],
             int *ifFindSpace, char *spg, int *nk, int nw[], stringa4 specchar[])
{
using namespace Expo;
    stringa4 *specch = specchar;

    dir_set_current(cSWareRC->WorkingDirectory);
    if(newProject != NULL)
       delete newProject;
    newProject = NULL;
    newProject = new Project();
    newProject->FillProject(filnam, cell, *ifFindSpace, spg, *nk, nw, specch);
    newProject->BuildFilenames(g_path_get_dirname(OldF), str_cut(g_path_get_basename(newfile), "."));
    newProject->SaveAsExp();
    delete newProject;
    newProject = NULL;
}
#endif
void read_exp(char *filnam)
{
using namespace Expo;
   if(project != NULL)
      delete project;
   project = NULL;
   project = new Project();
   project->ReadExp(filnam);
   project->FillForm(new_project_dlg);
}


int check_spg(GtkWidget *father, GtkWidget *combo1, char stringf[17], int checkz)
{
using namespace gtkext;
     char *string0, buffer[16];
     int ier = 0;
     GtkWidget *entry;
     int cellconditions[14];

     string0 = g_new0(char, 30);
     int l1 = combo_get_text_len(combo1, string0, 30);
     if(str_white(string0))
     {
        entry = get_widget(father, "fs_check");
        if(!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
           gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
        return 0;
/*071111
        if(checkz)
        {
           entry = get_widget(father, "fs_check");
           if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
              return 0;
           if(!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
              gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
           return 0;
           gboolean ifModal = gtk_window_get_modal(GTK_WINDOW(father));
           gtk_window_set_modal(GTK_WINDOW(father), FALSE);
           dlg_errmsg(GTK_WINDOW(father),"%s", "You should specify a Space Group Symbol.");
           gtk_editable_set_position(GTK_EDITABLE(get_widget(combo1,"entry")), 0);
           gtk_widget_grab_focus(get_widget(combo1,"entry"));
           gtk_window_set_modal(GTK_WINDOW(father), ifModal);
           ier = -1;
        }
*/
     }
     else
     {
        ScriviStringa(stringf, 17, "%16.16s", string0);
        size_t l2 = strlen(stringf);
        gtk_widget_hide(father); // 270512
        manage_symm_(&ier, stringf, cellconditions, l2);
        gtk_widget_show(father); // 270512
/* 270512
        if(ier)
        {
           gboolean ifModal = gtk_window_get_modal(GTK_WINDOW(father));
           gtk_window_set_modal(GTK_WINDOW(father), FALSE);
           dlg_errmsg(GTK_WINDOW(father),"Error in Space Group Symbol: %s", stringf);
           gtk_editable_set_position(GTK_EDITABLE(get_widget(combo1,"entry")), 0);
           gtk_widget_grab_focus(get_widget(combo1,"entry"));
           gtk_window_set_modal(GTK_WINDOW(father), ifModal);
        }
        else
*/
        if(!ier)      // 270512
        {
          for(l1=3;l1<6;l1++)
          {
              entry = get_widget(father, labels[l1]);
              if(cellconditions[l1] > 0)
              {
                   ScriviStringa(buffer, sizeof(buffer), "%.4f", (float) cellconditions[l1]);
                   gtk_entry_set_text(GTK_ENTRY(entry), buffer);
                   gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                   gtk_widget_set_sensitive(entry, FALSE);
              }
              else
              {
                   gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
                   gtk_widget_set_sensitive(entry, TRUE);
              }
           }
         }
     }
     return ier;
}

extern "C" void cell_and_spg_dlg_(float cell[6], char *spg, int *return_flag)
{
using namespace Expo;
    GtkWidget *dlg;
    int i;

    if(missing != NULL)
       delete missing;
    missing = NULL;
    missing = new Project();
    missing->FillProject(NULL, cell, 0, spg);

    dlg = create_missing_dialog(false);
    gtk_widget_set_sensitive(finestre[0], FALSE);
    missing->FillForm(dlg, 2);

    int result = 0;
    bool cicla = true;
    while(cicla || (result == GTK_RESPONSE_NONE))
    {
         cicla = false;
         result = gtk_dialog_run(GTK_DIALOG(dlg));
         if(result == GTK_RESPONSE_OK)
         {
            gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
            if (missing->ReadForm(dlg, 2))
            {
                  cicla = true;
                  gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
            }
         }
    }
    gtk_widget_destroy(dlg);
    if(result == GTK_RESPONSE_OK)
    {
       *return_flag = 1;
       g_strchug(missing->szSpaceGroup);
       CopiaStringan(spg, 18, missing->szSpaceGroup, MRmin(16, strlen(missing->szSpaceGroup)));
       for(i=0; i<6; i++)
           cell[i] = missing->Cell[i];
    }
    else
       *return_flag = 0;
    delete missing;
    missing = NULL;
    gtk_widget_set_sensitive(finestre[0], TRUE);
}

