#include "mrconfig.h"
#include "forcomm.h"
#include "aliasx.h"

style_type Style[NITEMS];

static int nPALETTELINES = 16;

typedef struct {
                unsigned short red;
                unsigned short green;
                unsigned short blue;
               } rgbCol;

char config_filename[MaxLenFilename];
char fback[MaxLenFilename];
char myScratchFile[MaxLenFilename];
char Internet_Browser[MaxLenFilename];
char POVRAYP[MaxLenFilename];
char *filesir, *filebin, *fileout;
char prog_dir[MaxLenFilename];
char cfg_dir[MaxLenFilename];
char files_dir[MaxLenFilename];
char *fontp;
char *fontn;
char *fontu;

int w_env, kscrx, kscry;
int ifMaximized = 0, xstart = 0, ystart =0, auto_update = 0;

typedef enum {  PROGRAM,
                HD,
                IB,
                PVR,
                WD,
                STRU,
                OUTP,
                PROPF,
                FIXF,
                USERF,
                MISC1,
                MISC2,
                STYLE,
                PRJ1=MISC2+NITEMS,
                PRJ2,
                PRJ3,
                PRJ4,
                PRJ5,
                CFGLINES
             } config_lines;

#define MAX_ERR ((1<<STYLE) -1)

static char *aWorkingDirectory;
static char rigar[MAX_LEN];

void UpdateMenu();
void update_WD(void);

/* Default Palette */

#if 0
int cpsdef[CPSIZE] = { 4, 5, 6, 7, 8, 9,10,11,12,   //species da 1 a 9
                      13,14,15, 4, 5, 6, 7, 8, 9,   //species da 10 a 18
//                    gh bo lb ce rs ob bk co di
                       3, 2,10, 4,12,10,11,13, 8,
//                     x mr mb mi mp
                       3,13,10,12, 6,10,11,13};
#endif

rgbCol     bcolors[] = {{  0,   0,   0},
                        {255, 255, 255},
                        {  0,   0, 255},   // observed
                        { 50, 205,  50},   // background
                        {255,   0,   0},   // calculated
                        {148,   0, 211},   // difference
                        {153,   0, 204},   // cumulative
                        {  0,   0, 128},   // reflections
                        {178,  34,  34},   // peaks
                        {127, 127, 127},   // axis
                        {  0, 153, 153},
                        {255,   0, 255},
                        {255,   0,   0},
                        {124, 252,   0},
                        {204, 204, 204},
                        {255, 255, 255}};

rgbCol   fcolors[] = {{  0,   0,   0},
                      {255, 255, 255},
                      {192, 192, 192},
                      {127, 127, 127},
                      {  0,   0, 160},
                      {  0, 160,   0},
                      {  0, 160, 160},
                      {160,   0,   0},
                      {160,   0, 160},
                      {160, 160,   0},
                      {  0,   0, 255},
                      {  0, 255,   0},
                      {  0, 255, 255},
                      {255,   0,   0},
                      {255,   0, 255},
                      {255, 255,   0}};


rgbCol pal_colors[16];


std::string ExamplesDir()
{
      std::string ex_dir = g_get_home_dir();
      ex_dir.append(G_DIR_SEPARATOR_S);
      ex_dir.append("share");
      if(!g_file_test(ex_dir.c_str(), G_FILE_TEST_EXISTS))
         dir_create(ex_dir.c_str());
      ex_dir.append(G_DIR_SEPARATOR_S);
      ex_dir.append(PACKAGE);
      if(!g_file_test(ex_dir.c_str(), G_FILE_TEST_EXISTS))
         dir_create(ex_dir.c_str());
      ex_dir.append(G_DIR_SEPARATOR_S);
      ex_dir.append("examples");
      if(!g_file_test(ex_dir.c_str(), G_FILE_TEST_EXISTS))
         dir_create(ex_dir.c_str());
      //dir_set_current(ex_dir.c_str());
      return ex_dir;
}

void ricrea_config(int errore, int np)
{
  int i, ibit, val[10];
  static style_type Style0[NITEMS] = {
                    {LINEPLOT+1, 2,  11,SOLIDLINE+1,1,1,3,8,1},
                    {LINEPLOT+1, 3,  12,SOLIDLINE+1,1,1,3,8,1},
                    {LINEPLOT+1, 4,   0,SOLIDLINE+1,1,1,3,8,1},
                    {LINEPLOT+1, 5,   0,SOLIDLINE+1,1,1,3,8,1},
                    {LINEPLOT+1, 6,   0,SOLIDLINE+1,1,1,3,8,1},
                    {LINEPLOT+1, 7,   0,SOLIDLINE+1,1,1,3,8,1},
                    {LINEPLOT+1, 8,   0,SOLIDLINE+1,1,1,3,8,1},
                    {LINEPLOT+1, 9,   0,SOLIDLINE+1,1,1,3,8,1},
                    {LINEPLOT+1,10,  13,SOLIDLINE+1,3,1,3,8,1},
                    {LINEPLOT+1,14,   0, NLSTYLES+1,3,1,3,8,1},
                    {LINEPLOT+1, 1,   0,SOLIDLINE+1,3,1,3,8,1},
                    {LINEPLOT+1, 0,   0,SOLIDLINE+1,3,1,3,8,1}};
#if 0
                    {LINEPLOT+1, 2,  11,SOLIDLINE+1,1,3,8,1,1},
                    {LINEPLOT+1, 3,  12,SOLIDLINE+1,1,3,8,1,1},
                    {LINEPLOT+1, 4,   0,SOLIDLINE+1,1,3,8,1,1},
                    {LINEPLOT+1, 5,   0,SOLIDLINE+1,1,3,8,1,1},
                    {LINEPLOT+1, 6,   0,SOLIDLINE+1,1,3,8,1,1},
                    {LINEPLOT+1, 7,   0,SOLIDLINE+1,1,3,8,1,1},
                    {LINEPLOT+1, 8,   0,SOLIDLINE+1,1,3,8,1,1},
                    {LINEPLOT+1, 9,   0,SOLIDLINE+1,1,3,8,1,1},
                    {LINEPLOT+1,10,  13,SOLIDLINE+1,3,3,8,1,1},
                    {LINEPLOT+1,14,   0, NLSTYLES+1,3,3,8,1,1},
                    {LINEPLOT+1, 1,   0,SOLIDLINE+1,3,3,8,1,1},
                    {LINEPLOT+1, 0,   0,SOLIDLINE+1,3,3,8,1,1}};
#endif

  ibit = 0;
  if(b_test(errore, ibit))                  /* program version */
  {
     ScriviStringa(rigar, MAX_LEN, "%s %s", MR_PACKAGE, VERSION);
     update_cfg(PROGRAM, rigar);
  }
  ibit++;
  if(b_test(errore, ibit))                 /*  Home Directory */
  {
     update_cfg(HD, cfg_dir);
  }
  ibit++;
  if(b_test(errore, ibit))                 /*  internet browser */
  {
     update_cfg(IB, (char *)GetBrowser());
     ScriviStringa(Internet_Browser, MaxLenFilename, "%s", GetBrowser());
  }
  ibit++;
  if(b_test(errore, ibit))                 /*  PovRay */
  {
#ifdef _WIN32
     update_cfg(PVR, (char *)"pvengine.exe");
     ScriviStringa(POVRAYP, MaxLenFilename, "pvengine.exe");
#else
     update_cfg(PVR, (char *)"/usr/local/bin/povray");
     ScriviStringa(POVRAYP, MaxLenFilename, "/usr/local/bin/povray");
#endif
  }
  ibit++;
  if(b_test(errore, ibit))
  {
     aWorkingDirectory = (char *)malloc(256*sizeof(char));
     CopiaStringa(aWorkingDirectory, MaxLenFilename, ExamplesDir().c_str());
     //CopiaStringa(aWorkingDirectory, MaxLenFilename, getPWD());
     update_cfg(WD, aWorkingDirectory);
     ScriviStringa(cSWareRC->WorkingDirectory, MaxLenFilename, "%s", aWorkingDirectory);
   }
   ibit++;
   if(b_test(errore, ibit))
   {
      leggi_fonts();
      update_fonts();
   }
   ibit++;
   if(b_test(errore, ibit))
   {
      leggi_fonts();
      update_fonts();
   }
   ibit++;
   if(b_test(errore, ibit))
   {
      leggi_fonts();
      update_fonts();
   }
   ibit++;
   if(b_test(errore, ibit))             /* last run values */
   {
      ScriviStringa(rigar, MAX_LEN, "  730  637    0 -99 -99 0");
      get_int_tokens(rigar, " ", 6, val);
      kscrx                = val[0];
      kscry                = val[1];
      ifMaximized          = val[2];
      xstart               = val[3];
      ystart               = val[4];
      auto_update          = val[5];

      update_cfg(MISC1, rigar);
   }
   ibit++;
   if(b_test(errore, ibit))             /* style values */
   {
      memcpy(Style, Style0, NITEMS*sizeof(style_type));
      for(i=0; i<NITEMS; i++)
      {
          ScriviStringa(rigar, MAX_LEN, "%d %d %d %d %d %d %d %d %d",
            Style[i].plot_type, Style[i].colline, Style[i].colmarker,
            Style[i].linetype, Style[i].markertype, Style[i].sizemarker,
            Style[i].font_size, Style[i].vis, Style[i].linewidth) ;
          update_cfg(MISC2+i, rigar);
      }
   }
   for(i=0; i<5; i++)
   {
       ScriviStringa(rigar, MAX_LEN, "#%d", i+1);
       update_cfg(CFGLINES-5+i, rigar);
   } 
  ibit++;
  if(b_test(errore, ibit))                 /* color palette */
  {
     resetta_palette(0);
     write_palette();
  }
  if(b_test(errore, 0))                  
  {
       ScriviStringa(rigar, MAX_LEN, "%d", CFGLINES);
       update_cfg(CFGLINES+nPALETTELINES, rigar);
  }
}

void crea_config(void)
{
  int i;
  FILE *fp;

  fp = fOpen(config_filename, "w");
  for(i=0; i<CFGLINES+nPALETTELINES+1;i++)
      (void) fprintf(fp,"\n");
  (void) fclose(fp);
  ricrea_config(MAX_ERR, 0);
  dir_set_current(cSWareRC->WorkingDirectory);
}

void write_palette (void)
{
  FILE *fp, *fp1;
  int i;
  
  (void) Cancella(myScratchFile);
  mr_CopyFile(config_filename, myScratchFile);
  fp1 = fOpen(myScratchFile, "r");
  fp = fOpen(config_filename, "w");
  if(fp && fp1)
  {
      for(i=0;i<CFGLINES;i++)
      {
          if (fgets(rigar, MAX_LEN, fp1))
              (void) fputs(rigar, fp);
      }
#if 0
      rigar[0] = '\0';
      char num[5];
      for(i=0; i< CPSIZE; i++)
      {
          ScriviStringa(num, sizeof(num), " %d", Cps[i]);
          (void) AppendiStringa(rigar, MAX_LEN, num);
      }
      (void) AppendiStringa(rigar, MAX_LEN, "\n");
      (void) fputs(rigar, fp);
#endif
      for(i=0; i<16; i++)
      {
          ScriviStringa(rigar, MAX_LEN, "%d %d %d\n", pal_colors[i].red,
                  pal_colors[i].green,pal_colors[i].blue);
          (void) fputs(rigar, fp);
      }
       ScriviStringa(rigar, MAX_LEN, "%d\n", CFGLINES);
       (void) fputs(rigar, fp);
   }
   if(fp)
      (void) fclose(fp);
   if(fp1)
      (void) fclose(fp1);
   (void) Cancella(myScratchFile);
}

void read_palette(FILE *fp, int *errore, int err_cod)
{
      int ier, rgb[3];
  
      ier = 0;
#if 0
      if(fgets(rigar,MAX_LEN,fp) != NULL) 
         get_int_tokens(rigar, " ", CPSIZE, Cps);
      else
      {
         ier = 1;
         for(int i=0; i<CPSIZE; i++)
             Cps[i] = cpsdef[i];
      }
#endif
      for(int i=0; i<16; i++)
      {
          if(fgets(rigar,MAX_LEN,fp) != NULL) 
          {
             get_int_tokens(rigar, " ", 3, rgb);
             pal_colors[i].red   = rgb[0];
             pal_colors[i].green = rgb[1];
             pal_colors[i].blue  = rgb[2];
          }
          else
          {
             ier = 1;
             pal_colors[i].red   = bcolors[i].red;
             pal_colors[i].green = bcolors[i].green;
             pal_colors[i].blue  = bcolors[i].blue;
          }
      }
      if(ier)
         *errore = b_set(*errore, err_cod);
}

char* strchomp (char *string)
{
  int len;

  if(!string)
      return NULL;
  len = (int) strlen (string);
  while (len--)
  {
      if (string[len] == ' ')
	string[len] = '\0';
      else
	break;
  }

  return string;
}

void read_config(void)
{
  int errore, i, np, err_cod, val[12];
  FILE *fp;
  char *pkv[2];

  errore= 0;
  err_cod= 0;
  np = 0;
  pkv[0] = (char *) malloc(80*sizeof(char));;
  pkv[1] = (char *) malloc(80*sizeof(char));;

  filesir = (char *)malloc(256*sizeof(char));
  filebin = (char *)malloc(256*sizeof(char));
  fileout = (char *)malloc(256*sizeof(char));
  for(i=0; i<255; i++)
  {
     *(filesir+i) = ' ';
     *(filebin+i) = ' ';
     *(fileout+i) = ' ';
  }
  *(filesir+255) = '\0';
  *(filebin+255) = '\0';
  *(fileout+255) = '\0';

  fp = fOpen(config_filename, "r");
  if (fp == NULL)
      crea_config();
  else
  {
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
     {
	 int nt = get_str_tokens(filtra(rigar, "\n"), " ",2, pkv);
         if((nt < 2 ) || strcmp(strchomp(pkv[1]), VERSION))
            errore = b_set(errore, err_cod);
     }
     else
         errore = b_set(errore, err_cod);

     err_cod++;
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
         ScriviStringa(cfg_dir, MaxLenFilename, "%s",  filtra(rigar, "\n"));
     else
         errore = b_set(errore,err_cod);

     err_cod++;
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
         ScriviStringa(Internet_Browser, MaxLenFilename, "%s", filtra(rigar, "\n"));
     else
         errore = b_set(errore,err_cod);

     err_cod++;
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
         ScriviStringa(POVRAYP, MaxLenFilename, "%s", filtra(rigar, "\n"));
     else
         errore = b_set(errore,err_cod);

     err_cod++;
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
     {
         aWorkingDirectory = filtra(rigar, "\n");
         ScriviStringa(cSWareRC->WorkingDirectory, MaxLenFilename, "%s", aWorkingDirectory);
     }
     else
         errore = b_set(errore,err_cod);

     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
     {
         (void) CopiaStringa(filesir, MaxLenFilename, filtra(rigar, "\n"));
         (void) CopiaStringa(filebin, MaxLenFilename, filtra(rigar, "\n"));
         (void) AppendiStringa(filesir, MaxLenFilename, ".exp");
         (void) AppendiStringa(filebin, MaxLenFilename, ".bin");
     }

     fileout = (char *)malloc(256*sizeof(char));
     memset(fileout, ' ',255);
     fileout[255] = '\0';
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
         ScriviStringa(fileout,MaxLenFilename, "%s", filtra(rigar, "\n"));

     err_cod++;
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
         fontp = DuplicaStringa(filtra(rigar, "\n"));
     else
         errore = b_set(errore,err_cod);

     err_cod++;
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
         fontn = DuplicaStringa(filtra(rigar, "\n"));
     else
         errore = b_set(errore,err_cod);

     err_cod++;
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
         fontu = DuplicaStringa(filtra(rigar, "\n"));
     else
         errore = b_set(errore,err_cod);

     err_cod++;
     if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
     {
         get_int_tokens(rigar, " ", 6, val);
         kscrx                 = val[0];
         kscry                 = val[1];
         ifMaximized           = val[2];
         xstart                = val[3];
         ystart                = val[4];
         auto_update           = val[5];
     
         if(kscry < 1)
            kscry = 1;
     }
     else
         errore = b_set(errore,err_cod);

     err_cod++;
     for(i=0; i<NITEMS; i++)
     {
         if((fgets(rigar,MAX_LEN,fp) != NULL) && (strlen(rigar) > 1))
         {
              get_int_tokens(rigar, " ", 9, val);
              Style[i].plot_type  = val[0];
              Style[i].colline    = val[1];
              Style[i].colmarker  = val[2];
              Style[i].linetype   = val[3];
              Style[i].markertype = val[4];
              Style[i].sizemarker = val[5];
              Style[i].font_size  = val[6];
              Style[i].vis        = val[7];
              Style[i].linewidth  = val[8];
         }
         else
             errore = b_set(errore,err_cod);
     }

     for(i=1; i<=MAXPROJ; i++)
     {
         if(fgets(rigar,MAX_LEN,fp) != NULL)
         {
            if(rigar[0] != '#')
            {
               ScriviStringa(RP->RecentProj[np], MaxLenFilename, "%s", filtra(rigar, "\n"));
               if(strlen(RP->RecentProj[np]) >1)
                  np++;
            }
         }
     }
     err_cod++;
     RP->nRecentProjects = np;
     read_palette(fp, &errore, err_cod);
     err_cod++;
     if(fgets(rigar,MAX_LEN,fp) != NULL)
     {
         get_int_tokens(rigar, " ", 1, val);
         if(val[0] != CFGLINES)
            errore = b_set(errore, 0);
     }
     else      
         errore = b_set(errore, 0);
     (void) fclose(fp);
  }
  if(b_test(errore, 0))
  {
     cpause("Configuration file is an old version!!!\nIt will be restored by the program.\n");
     crea_config();
  }
  else if(errore)
  {
     cpause("Configuration file is corrupted!!!\nIt will be restored by the program.\n");
     ricrea_config(errore, np);
  }
#if 0
  for(i=0; i<CPSIZE; i++)
      dialogo->cp[i] = Cps[i];
#endif
}
  
void AddLast(const char *projectnam)
{
using namespace std;
     int np = 0;
     string f1 = projectnam;
     vector<string> lasts;
     lasts.push_back(f1);
     np++;
     for(int i=0; i<MAXPROJ; i++)
     {
         if(!str_white(RP->RecentProj[i]))
         {
            string f2 = RP->RecentProj[i];
            if(!compare_names(f1, f2) && (np <MAXPROJ))
            {
               lasts.push_back(f2);
               np++;
            }
         }
     }
     RP->nRecentProjects = np;
     for(int i=0; i<np; i++)
     {
//         g_print("%d -  %s\n", i+1, lasts.at(i).c_str());
         ScriviStringa(RP->RecentProj[i], MaxLenFilename, "%s", lasts.at(i).c_str());
         update_cfg(CFGLINES-5+i, RP->RecentProj[i]);
     }
     if(lasts.size() > 0)
        lasts.clear();
     for(int i=np; i<5; i++)
         update_cfg(CFGLINES-5+i, g_strdup_printf( "#%d", i+1));
     UpdateMenu();
}

void mr_CopyDir(const char *srcdir, const char *dstdir)
{
    GDir *dir;
    const gchar *name;
    dir = g_dir_open (srcdir, 0, NULL);
    if (!dir)
      return;

    name = g_dir_read_name (dir);
    while (name != NULL)
    {
        gchar *srcpath, *dstpath;
        gboolean is_dir;

        if (name[0] != '.')
        {
                srcpath = g_build_filename (srcdir, name, NULL);
            dstpath = g_build_filename (dstdir, name, NULL);
                is_dir = g_file_test (srcpath, G_FILE_TEST_IS_DIR);
            if(is_dir)
            {
               dir_create(dstpath);
               mr_CopyDir(srcpath, dstpath);
            }
            else if(!g_file_test (dstpath, G_FILE_TEST_EXISTS))
               mr_CopyFile(srcpath, dstpath);
            g_free (srcpath);
            g_free (dstpath);
        }
        name = g_dir_read_name (dir);
    }
    g_dir_close(dir);
}

void clistfiles(const char *filter, std::vector<std::string> &Files)
{
    GDir *dir;
    const gchar *name;
    size_t sz = strlen(filter)+1;
    gchar *filt = g_new0(char, sz);

    if(strcmp(filter, "*.*"))
       CopiaStringa(filt, sz, filter);
    else
       CopiaStringa(filt, sz, "*");

    GPatternSpec *pattern = g_pattern_spec_new(filt);
    dir = g_dir_open (g_get_current_dir(), 0, NULL);
    if (!dir)
      return;

    name = g_dir_read_name (dir);
    while (name != NULL)
    {
        gchar *path;
        gboolean is_dir;
      
        if (name[0] != '.')
     	{
	    path = g_build_filename (g_get_current_dir(), name, NULL);
	    is_dir = g_file_test (path, G_FILE_TEST_IS_DIR);
            if(!is_dir)
            {
               if(g_pattern_match_string (pattern, g_utf8_casefold(name, -1)))
                  Files.push_back (name);
            }
            g_free (path);
        }
        name = g_dir_read_name (dir);      
    }
    g_dir_close(dir);        
}

void GetExamples()
{
      std::string ex_dir = ExamplesDir();
      std::vector<std::string> Dirs;
      std::string curdir = getPWD();
  
/*
      if(g_file_test(ex_dir.c_str(), G_FILE_TEST_EXISTS) &&
         g_file_test(ex_dir.c_str(), G_FILE_TEST_IS_DIR))
         return;
*/
      std::string strExamplesDir;
      strExamplesDir.assign(files_dir);
      strExamplesDir.append(G_DIR_SEPARATOR_S);
      strExamplesDir.append("examples");
      if(ex_dir.compare(strExamplesDir) != 0)
         mr_CopyDir(strExamplesDir.c_str(), ex_dir.c_str());
//      g_print("Copying examples from %s to %s\n", strExamplesDir.c_str(),
//             ex_dir.c_str());
      ex_dir.append(G_DIR_SEPARATOR_S);
      dir_set_current(ex_dir.c_str());
      ChangeMode(ex_dir.c_str(), tXt);
      std::vector<std::string> SirFiles;
      clistfiles("*.exp", SirFiles);
      for(unsigned int j=0; j < SirFiles.size(); j++)
      {
          char *filnam = g_build_filename(ex_dir.c_str(), SirFiles[j].c_str(), NULL);
          std::string fn = filnam;
          ChangeMode(fn.c_str(),  rwXt);
      }
      dir_set_current(curdir.c_str());
}

//int prendi_parametro()
extern "C" int leggiconfig_()
{
      char *wd = g_new0(char, MaxLenFilename);
      w_env = 0;
#ifdef _WIN32
      w_env = 1;
#endif
// Recupera la directory del programma  (gia' fatto mr060608)
//      ScriviStringa(prog_dir, MaxLenFilename, "%s", get_prog_dir(string));

// Costruisce il nome del file di configurazione
      if(Ambiente(CONFIG_DIR))
         ScriviStringa(cfg_dir, MaxLenFilename, "%s", Ambiente(CONFIG_DIR));
      else
         ScriviStringa(cfg_dir, MaxLenFilename, "%s", 
            g_build_filename(getHomeDir(), "." PACKAGE, NULL));

      if(mr_access(cfg_dir, 'm') == 0)
         dir_create(cfg_dir);
      ScriviStringa(config_filename,MaxLenFilename, "%s%c.%s.cfg", cfg_dir,
             DIR_SEPAR, MR_PACKAGE);
// controlla l'esistenza del file di configurazione

      ScriviStringa(fback, MaxLenFilename, "%s%c.%sfonts.bu", cfg_dir,DIR_SEPAR,MR_PACKAGE);
      ScriviStringa(myScratchFile, MaxLenFilename, "%s%ctmp.out", cfg_dir, DIR_SEPAR);
      //fontp = (char *)malloc(MAX_LEN*sizeof(char));
      //fontn = (char *)malloc(MAX_LEN*sizeof(char));
      if(!str_white(cSWareRC->WorkingDirectory))
         CopiaStringa(wd, MaxLenFilename, cSWareRC->WorkingDirectory);
      read_config();
      if(!str_white(wd))
      {
         CopiaStringa(cSWareRC->WorkingDirectory, MaxLenFilename, wd);
         update_WD();
         dir_set_current(wd);
      }
      g_free(wd);
//      if(!w_env)
//      {
        // expodir files in $prefix/share/expo
        ScriviStringa(files_dir, MaxLenFilename, "%s%cshare%c%s", 
            g_path_get_dirname(prog_dir), DIR_SEPAR, DIR_SEPAR, g_ascii_strdown (PK, 4));
        std::string pxdir(files_dir);
        pxdir.append(G_DIR_SEPARATOR_S);
        pxdir.append("pixmaps");
        // expodir files in $prefix/bin/expodir
        //if(!mr_access(files_dir, 'e'))          // old style
        if(!mr_access(pxdir.c_str(), 'e'))          // old style
          ScriviStringa(files_dir, MaxLenFilename, "%s%c%s", prog_dir, DIR_SEPAR, prg_files_dir);
//corr        printf("files_dir = %s\n", files_dir);
        put_servdir(files_dir);
//      }
//      else
//        ScriviStringa(files_dir, MaxLenFilename, "%s%c%s", prog_dir, DIR_SEPAR, prg_files_dir);
//    pixmapdir = g_strdup_printf("%s%cpixmaps", files_dir, DIR_SEPAR);
      ScriviStringa(cSWareRC->SWRC, MaxLenFilename, "%s", config_filename);
      ScriviStringa(cSWareRC->HOMEdir, MaxLenFilename, "%s", cfg_dir);
#ifndef LIBEXPO
      GetExamples();
#endif
      return 0;
}

void resetta_palette(int ialloc)
{
  int i, flag = 1;

#if 0
  for(i=0; i<CPSIZE; i++)
      Cps[i] = cpsdef[i];
#endif
  for(i=0; i<16; i++)
  {
      pal_colors[i].red   = bcolors[i].red;
      pal_colors[i].green = bcolors[i].green;
      pal_colors[i].blue  = bcolors[i].blue;
  }
#if 0
  for(i=0; i<CPSIZE; i++)
      dialogo->cp[i] = Cps[i];
#endif
  if(ialloc)
     c_allocacolori(flag);
}

/*-------------------------------------------------------------*/
/*         update file di configurazione                       */
/*-------------------------------------------------------------*/

void update_cfg (int nline, char *line)
{
   int ier;
   FILE *fp, *fp1;
   char riga1[MAX_LEN];

   if(nline == MISC1)
   {
      if((kscry < 1) || (kscry < 1))
         exit(-1);
   }
   (void) Cancella(myScratchFile);
   mr_CopyFile(config_filename, myScratchFile);
   fp = fOpen(myScratchFile, "r");
   fp1 = fOpen(config_filename, "w");
   if (fp == NULL)
       (void) cMsgWinErr("Error", myScratchFile, 10+ERR_WINDOW);
   if (fp1 == NULL)
       (void) cMsgWinErr("Error", config_filename, 10+ERR_WINDOW);
   if(fp && fp1)
   {
      for(ier=0; ier<nline;ier ++)
      {
          if(fgets(riga1,MAX_LEN,fp) != NULL) 
             (void) fputs(riga1,fp1);
          else
             (void) fputs(" \n", fp1);
      }
      if(fgets(riga1, MAX_LEN, fp))
         (void) fputs(line, fp1);
      else
         (void) fputs(line, fp1);
      (void) fputs("\n", fp1);
      for(ier=0; ier<CFGLINES+nPALETTELINES-nline;ier ++)
      {
          if(fgets(riga1,MAX_LEN,fp) != NULL)
             (void) fputs(riga1,fp1);
          else
             (void) fputs(" \n", fp1);
      }
      //(void) fclose(fp);
      //(void) fclose(fp1);
   }
   if(fp)
      (void) fclose(fp);
   if(fp1)
      (void) fclose(fp1);
   (void) Cancella(myScratchFile);
//   g_print("update cfg %d %s\n", nline, line);
}
void scrivi_fonts (void)
{
   FILE *fp;

   fp = fOpen(fback, "w");
   if (fp != NULL)
   {
      if(fontn)
         (void) fputs(fontn, fp);
      else
         (void) fputs("*", fp);
      (void) fputs("\n", fp);
      if(fontp)
         (void) fputs(fontp, fp);
      else
         (void) fputs("*", fp);
      (void) fputs("\n", fp);
      if(fontu)
         (void) fputs(fontu, fp);
      else
         (void) fputs("*", fp);
      (void) fputs("\n", fp);
   }
   (void) fclose(fp);
}
void leggi_fonts (void)
{
   FILE *fp;

   fontn = DuplicaStringa("*");
   fontp = DuplicaStringa("*");
   fontu = DuplicaStringa("*");
   fp = fOpen(fback, "r");
   if (fp != NULL)
   {
       if((fgets(rigar,MAX_LEN,fp) != NULL) &&
             (strlen(rigar) > 1))
              fontn = filtra(rigar, "\n");
       if((fgets(rigar,MAX_LEN,fp) != NULL) &&
             (strlen(rigar) > 1))
              fontp = filtra(rigar, "\n");
       if((fgets(rigar,MAX_LEN,fp) != NULL) &&
             (strlen(rigar) > 1))
              fontu = filtra(rigar, "\n");
       (void) fclose(fp);
   }
}

void update_WD(void)
{
    update_cfg(WD, cSWareRC->WorkingDirectory);
}

void update_IB(void)
{
    update_cfg(IB, Internet_Browser);
}

void update_povray(void)
{
    update_cfg(PVR, POVRAYP);
}

void update_position(int x, int y)
{
   char line[MAX_LEN];

   if(x < 0)
      x = 0;
   if(y < 0)
      y = 0;
   xstart = x;
   ystart = y;
   ScriviStringa(line, MAX_LEN, "%d %d %d %d %d %d",
                   kscrx, kscry, ifMaximized, xstart, ystart, auto_update);
   update_cfg(MISC1, line);
}

int last_update(bool ifSilent)
{
   char *filinfo = g_build_filename(files_dir, ".instdate", NULL);
   return IsUpdateAvailable(filinfo, ifSilent);
}

std::string DateInfo(const char *fil)
{
const char *Months[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
                        "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
   if(fil == NULL)
   {
      char *filinfo = g_build_filename(files_dir, ".instdate", NULL);
      return dateinfo(filinfo);
   }
   struct tm *clock;
   struct stat attrib;
   stat(fil, &attrib);
#if !__STDC_WANT_SECURE_LIB__
   clock = gmtime(&(attrib.st_mtime));  
#else
   tm pclock;
   clock = &pclock;
   (void) gmtime_s(clock,  &(attrib.st_mtime));  
#endif

   std::stringstream out;
   out << "Created on " << clock->tm_year+1900 << " "
       << Months[clock->tm_mon] << " " << clock->tm_mday;
   return out.str();
}

int get_autoupdate()
{
   return auto_update;
}

void set_autoupdate(int val)
{
   char line[MAX_LEN];

   auto_update = val;
   ScriviStringa(line, MAX_LEN, "%d %d %d %d %d %d",
                   kscrx, kscry, ifMaximized, xstart, ystart, auto_update);
   update_cfg(MISC1, line);
}

void update_dime(int w, int h)
{
   char line[MAX_LEN];

   kscrx = w;
   kscry = h;
   ScriviStringa(line, MAX_LEN, "%d %d %d %d %d %d",
                   kscrx, kscry, ifMaximized, xstart, ystart, auto_update);
   update_cfg(MISC1, line);
}

void update_style()
{
   char line[MAX_LEN];

   for(int i=0; i<NITEMS; i++)
   {
       ScriviStringa(line, MAX_LEN, "%d %d %d %d %d %d %d %d %d",
            Style[i].plot_type, Style[i].colline, Style[i].colmarker,
            Style[i].linetype, Style[i].markertype, Style[i].sizemarker,
            Style[i].font_size, Style[i].vis, Style[i].linewidth) ;
       update_cfg(MISC2+i, line);
   }
}

void update_fonts(void)
{
   update_cfg(PROPF, fontp);
   update_cfg(FIXF, fontn);
   update_cfg(USERF, fontu);
   scrivi_fonts();
}

/*-------------------------------------------------------------*/
/*         Utilities and system dependent functions            */
/*-------------------------------------------------------------*/

int check_is_numeric(char *string)
{
  int ier;
  size_t nch;

  nch = strlen(string);
  if(nch == 0)
     return 0;
       ier = f_checkisnumeric_(string, nch);
  return ier;
}

extern "C"
{
/*
void fget_program_directory_(char *exedir, int *l1)
{

   ScriviStringa(exedir, *l1, "%s%c", files_dir, DIR_SEPAR);
   *l1 = strlen(exedir);
}
*/
void getstylefromc_(style_type localStyle[])
{
   for(int i=0; i<NITEMS;i++)
       memcpy(&localStyle[i], &Style[i], sizeof(style_type));
}

void upd_recprojects_(char *proj)
{
    AddLast(proj);
}
}

