      module fourpamod
      implicit none
      real, dimension(:), allocatable      :: rappor
      integer, dimension(:,:), allocatable :: iphkl
      integer, dimension(:), allocatable   :: iordine
      real, dimension(:), allocatable      :: fop1,fop2,fop3
      real, dimension(:), allocatable      :: fcp

      contains

      subroutine allocate_fourpa(nref)
      USE arrayutil
      integer, intent(in) :: nref
      call new_array(rappor,nref)
      call new_array(iphkl,[1,1],[nref,4])
      call new_array(iordine,nref)
      call new_array(fop1,nref)
      call new_array(fop2,nref)
      call new_array(fop3,nref)
      call new_array(fcp,nref)
      end subroutine allocate_fourpa

      end module fourpamod
* =======================
* PATTER.F
* =======================
      subroutine pattersub(ier)
      USE Riflessi
      USE FourStaff
      USE Atomi
      USE General      
      USE Symmetry      
      USE Molcom      
      USE messagemod
      USE strutil
      USE fourpamod, only: rappor,fop1,fop2,fop3,fcp,allocate_fourpa
c
      character*80 name,MsgB
      character cff,space*16,laues*5
      common/ylimi/nfl,lfl,fldummy(4),nfls
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
!corr      common /xdTMP/ idummy(100000),fcp(3000),fop4(3000),idummy1(12000)
!corr      common /xdTMP/ fcp(3000),fop4(3000)
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common /setequ/ jpatt,jpuntt(501),ksacc,jseteq,jumpp
!corr      common/genob/irho,thetamin
      common/genob2/thmin,thmax,thstep
      common/fourpa/numbext
!corr      common/fourpa1/fop2(3000)
      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
      common/fourinv/ jinv,sog,iquad,irecyc,nrecy,ncpat
      common /tran/ scaleFour,mh(3),level,it4,xlim(3)
      character *80 MessH,Messages(200)
      common /scmess/MessH,Messages
      common /stampastat/npatter
canna
      nfl=1
      eps = 1.e-10
      iconn(1)=-1
cc    ncpat = 1
      ncpat = 0
      MsgB = '                 '
canna
      call write_inte_routine('Patterson')
      write(lo,'(20x,"***   patterson synthesis section    ***",/)')
      if (jscreen > 0) then
          call clear_messages()
          call write_message('Patterson command',pos=1)
      endif
c
      call srlin (6,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
        call ysfl07(iy)
      else
        write(lo,9050)
        ier=-1
      endif
      if(ier.lt.0) return
c
      itype=1
      iform=2
      jop=jopen(jrel ,name,itype,iform,ier)
      if (jop.lt.0) go to 9000
      jop=jopen(ifour,name,itype,iform,ier)
      if (jop.lt.0) go to 9010
c
      call dirpat(npatter,ier)
      if (ier.lt.0) return
c
      if(sc.lt.0.0.and.jpatt.ne.2) then
        write(lo,9040)
        ier=-1
      endif
      call yfl02
!corr
      call allocate_fourpa(nrefl)
!corr
c
c-- modifica degli operatori di simmetria
c
CCC   do i=1,nnsym
      do i=1,nsym
        do j=1,3
          tmat(i,j)=0
        enddo
      enddo
      ncent=1
      call defco(nsize)
      call inptf 
      call presearch
      write(space,'(16a1)') nSpaceG
      call laue(space,jsys,laues)
cc    if(ncpat.eq.1) then
        if(jpatt.eq.1) then
          write(lo,18)
        else if (jpatt.eq.2) then
          write(lo,19)
        else
          write(lo,20)
        endif
        write(lo,15) laues
cc    endif
   15 format(30x,' Laue class: ',a5,//)
   18 format(/,30x,' /E/**2 coefficients ')
   19 format(/,30x,' /F/**2 coefficients ')
   20 format(/,30x,' /F/*/E/ coefficients ')
c
      if(jinv.gt.0) call chargeref
      if(jinv.eq.1) then
!corr        write(MsgB,2999) npatter
!corr 2999     format('Performing',i3,
!corr     &          ' cycles of Patterson + Inverse Patterson')
!corr        call scrper(MsgB,0,0)
!corr        call scrper(' ',1,npatter)
        call progress_bar_init()
        call write_message('Performing '//trim(i_to_s(npatter))//
     *  ' cycles of Patterson + Inverse Patterson',pos=2)
      endif
      pfwhmsav=pfwhm
CCCCCCCCCCCCCCCCCCCCc
!corr-moved in Convert0      fop4(:)=0.0
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCccc
c
c--loop sui cicli di inversione
c
      do k=1,npatter
c
        ncpat=k
c----expo distribuito
      if(neutro.eq.0)then
         sog=0.7-(k-1)*0.15
        else
         sog=0.5-(k-1)*0.1
      endif
      if(sog.lt.0.1)sog=0.1
c----expo distribuito
c
        call ysfl07(iy)
c
        mode=1
        numb2=0
        negmp=0
        istop=0
!anna   call fft(numb2,anat,ccfom,nsize,negmp,mode,istop,ier)
        call fft(numb2,ccfom,nsize,negmp,mode,istop,0,kevent,ier)
        if (ier.lt.0) return
c
        if(jinv.gt.0) then
          if (ncpat.eq.1)then
             write(lo,119)
           else 
             if (iprin.gt.1) write(lo,119)
          endif
        endif
 119    format(/,1x,41('-'),/,'Patterson map before any modification',/,
     *         1x,41('-'))
        if(ncpat.eq.1) then
            write(lo,120) 
          else 
           if (iprin.gt.1) write(lo,120)
        endif
  120   format(2h  ,5h peak,2x,6hheight,5x,1hx,6x,
     &               1hy,6x,1hz,3x,7h  occ. )
c
c--stampe di controllo
c
        if (iprin.gt.1.or.ncpat.le.1) then 
          do i=1,nats
            kk=xyzs(4,i)+0.5
            if (abs(xyzs(1,i) - 1.0).lt.0.006) 
     *         xyzs(1,i) = abs( xyzs(1,i) - 1.0 )
            if (abs(xyzs(2,i) - 1.0).lt.0.006) 
     *         xyzs(2,i) = abs( xyzs(2,i) - 1.0 )
            if (abs(xyzs(3,i) - 1.0).lt.0.006) 
     *         xyzs(3,i) = abs( xyzs(3,i) - 1.0 )
            if (abs(xyzs(1,i)) .lt.0.001) xyzs(1,i) = abs(xyzs(1,i))
            if (abs(xyzs(2,i)) .lt.0.001) xyzs(2,i) = abs(xyzs(2,i))
            if (abs(xyzs(3,i)) .lt.0.001) xyzs(3,i) = abs(xyzs(3,i))
            write(lo,140) i,kk,(xyzs(j,i),j=1,3),abs(xyzs(5,i))
            nz(i)=200   
            xyzs(5,i)=abs(xyzs(5,i))
          enddo
  140     format(i5,i8,2x,3f7.3,f8.4)
        endif
c
c---- plot barra rossa
c
        if (jinv.eq.1.and.k.gt.1) then
!corr          call scrper(' ',k,npatter)
          call progress_bar_update(cval=k,fval=npatter)
        endif
C---------------------------------------------------------------------------
C------------------ Introduzione della FFT inversa--------------------------
C---------------------------------------------------------------------------
        if(jinv.eq.1) then
c
c--parte attivata se c'e' la direttiva invar
c
          numb2=nrefl
          call ysfl07(iy)
cdeb
c         do i=1,nrefl
c           write(6,'(a,i5,3f10.2,e10.2)') 
c    &           'prima ',i,fop1(i),fop2(i),fop3(i),rappor(i)
c         enddo
cdeb
c
          if (k.ne.1) then
            do i=1,nrefl
              fop1(i)=fop3(i)*rappor(i)  ! (quello vero)
ccc           fop1(i)=fop2(i)*rappor(i)  ! prova di riciclo
!              write(6,'(a,2i6,f10.0)') ' Ciclo i fop1(i)',k,i,fop1(i)
            enddo
          endif
c
! variabile usata per cambiare il numero di riflessi nei cicli successivi
          numbext=nrefl  
c
c--assero per sicurezza i vettori 
c
          fop2(:)=0.0
          fop3(:)=0.0
c
          call fftinv(numb2,mode,ccfom,nsize,negmp,ier,npatter)
          if (ier.lt.0) return
cdeb
c         do i=1,nrefl
c           write(6,'(a,i5,3f10.2,e10.3)') 'prima1'
c    &                    ,i,fop1(i),fop2(i),fop3(i),rappor(i)
c         enddo
cdeb
c
c--eventualmente trasformo gli |E|**2 in |F|**2
c
          if (jpatt.ne.2) then
            do i=1,nrefl
              if(fop1(i).le.0.0.and.k.eq.1) then
                call sth(i,jrif) 
                rappor(i)=rappor(jrif)
              endif
              if(rappor(i).gt.eps) then
                fop1(i)=fop1(i)/rappor(i)    
                fop2(i)=fop2(i)/rappor(i)    
              endif
            enddo
          endif
c
c--stampe di controllo
c
          if (ncpat.eq.npatter) then
             write(lo,121) npatter
             write(lo,120)
           else
             if (iprin.gt.1.and.ncpat.lt.npatter) then
                  write(lo,121) k
                  write(lo,120)
             endif
          endif
 121      format(/,1x,50('-'),/,'    Modified Patterson Map after ',i3,
     *          2x,'cycles     ',/,1x,50('-'))
          if (iprin.gt.1.or.ncpat.ge.npatter) then 
            do i=1,nats
              kk=xyzs(4,i)+0.5
              if (abs(xyzs(1,i) - 1.0).lt.0.006) 
     *            xyzs(1,i) = abs( xyzs(1,i) - 1.0 )
              if (abs(xyzs(2,i) - 1.0).lt.0.006) 
     *            xyzs(2,i) = abs( xyzs(2,i) - 1.0 )
              if (abs(xyzs(3,i) - 1.0).lt.0.006) 
     *            xyzs(3,i) = abs( xyzs(3,i) - 1.0 )
              if (abs(xyzs(1,i)).lt.0.001) xyzs(1,i) = abs(xyzs(1,i))
              if (abs(xyzs(2,i)).lt.0.001) xyzs(2,i) = abs(xyzs(2,i))
              if (abs(xyzs(3,i)).lt.0.001) xyzs(3,i) = abs(xyzs(3,i))
              write(lo,141) i,kk,(xyzs(j,i),j=1,3),abs(xyzs(5,i))
              nz(i)=200
              xyzs(5,i)=abs(xyzs(5,i))
            enddo
  141       format(i5,i8,2x,3f7.3,f8.4)
          endif
c
c--calcolo i fattori di accordo
c
!!        call computerre(k,npatter,sograndom)
          call computerre(k)
c
        endif  ! fine if su jinv
c
      enddo  ! fine loop sui ricicli Patterson
      call progress_bar_close()
c
      close(jrel )
      close(ifour)
c
c-------- Use Patterson information in the two-stage method
c
      if(ipriorp.ne.0.or.ipriors.ne.0.or.ipriofr.ne.0) go to 555 
      if(jinv.ne.0.and.ipriopa.eq.0) then
        call UsePatt(igo,ier)
        if (ier.lt.0.0) return
        if(igo.gt.0) then
          izz = 37
          if (ipriopa.eq.0) write(lo,550)
          if (kscreen.gt.0) write(Messages(icomat)(1:izz),500)
          ipriopa = ipriopa + 1
c         do kk=1,nrefl
!            write(6,*)'PATT',kk,fcp(kk),fxsav(kk)
c         enddo
!g        call ysfr06(fcp)
!         call CreaListaRiflessi(fcp)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!111
          call LeggiRiflessi
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!111
!         fcvet = fcp
          fcvet(1:nrefl) = fcp(1:nrefl)
          call CreaListaRiflessi
c         write(lo,550)
        endif
      endif
  500 format(' Patterson information used in Extra ')
  550 format(/,15x,'***  Patterson information will be used as  ***',
     &       /,15x,'***           prior information in Extra    ***')
c------------
  555 continue
c
c-- reset e gestione degli errori
c
      jpatt = 0
!corr      jspini = -1
      pfwhm=pfwhmsav
      return
 9000 continue
      write(lo,9020) ier,jrel
      ier=-1
      return
 9010 continue
      write(lo,9030) ier,ifour
      ier=-1
 9020 format(' *** error ***  open error on scratch file jrel, code ='
     *,i5,',  channel =',i5)
 9030 format(' *** error ***  open error on scratch file ifour, code ='
     *,i5,',  channel =',i5)
 9040 format(' *** error ***  reflections must be normalized ')
 9050 format(' *** error ***  no reflections in direct acces file ')
c
      call AllocaFourStaff(2)
c
      return
      end
c----------------------------------------------------------------------
      subroutine dirpat(npatter,ier)
      USE General
      USE Symmetry
      USE ParametriMappa
!
      character line*80,dire*80,diret*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /tran/ scaleFour,mh(3),level,it4,xlim(3)
      common /sdir/ dm,npc,nproj,nojoin,jplt
      common /setequ/ jpatt,jpuntt(501),ksacc,jseteq,jumpp
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/fourinv/ jinv,sog,iquad,irecyc,nrecy,ncpat
      dimension vet(40),ivet(40)
c-- set default values
c
!corr      jspini=-1
      jinv=0
      iquad=0
      sog=1.0
      iprin=1
      nsec=1
      jpatt=1
      npc=0
      npatter=1
      kpatter=0
      kkpatt=0
      factr= 1.0/3.0
      it4=0
      level = 100
      xlim(1)=1.0
      xlim(2)=1.0
      xlim(3)=1.0
      irecyc=0 
      nrecy=0
c
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
      if (dire(1:4).eq.'layy') then
          nsec=1
          go to 100
          endif
      if (dire(1:4).eq.'layx') then
          nsec=2
          go to 100
          endif
      if (dire(1:4).eq.'layz') then
          nsec=3
          go to 100
          endif
      if (dire(1:4).eq.'e**2'.or.dire(1:4).eq.'e*e') then
          jpatt=1
          kkpatt=jpatt
          go to 100
          endif
      if (dire(1:4).eq.'f**2'.or.dire(1:4).eq.'f*f') then
          jpatt=2
          go to 100
          endif
      if (dire(1:3).eq.'f*e'.or.dire(1:3).eq.'e*f') then
          jpatt=3
          kkpatt=jpatt
          go to 100
          endif
      if (dire(1:3).eq.'map' ) then
          it4=lo
          go to 100
          endif
      if (dire(1:3).eq.'inv') then
          jinv=1
          if (neutro.eq.0) then
                  npatter=6
           else
                  npatter=5
          endif
          go to 100
          endif
      if (dire(1:4).eq.'recy') then
          jprecy=1
          go to 100
          endif
      if (dire(1:4).eq.'squ1') then
          iquad=1
          go to 100
          endif
      if (dire(1:4).eq.'squ2') then
          iquad=2
          go to 100
          endif
      iopt=0
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 9000
      if (dire(1:4).eq.'npat') then
          if (iv.ne.1) go to 9000
          kpatter=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'peak') then
          if (iv.ne.1) go to 9000
          npc=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'grid') then
          if (iv.ne.1) go to 9000
          factr=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 9000
          iprin=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'recy') then
          if (iv.ne.1) go to 9000
          irecyc=1
          nrecy=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'limi') then
          if (iv.ne.3) go to 9000
          do 7500 i=1,3
 7500     xlim(i)=amin1(vet(i),1.0)
          go to 100
          endif
      write(Msg,6500) diret(1:Lung(diret))
 6500 format(' wrong directive on following line:',/a)
      ier=-1
      call MsgWinErr('ERROR',Msg,5,nExitCode)        
      return
 8000 continue
      if(irecyc.eq.1.and.nrecy.eq.0)go to 9000
      if (kpatter.gt.0 ) npatter = kpatter
      if (kkpatt.eq.0.and.jinv.eq.1) jpatt = 2
      return
 9000 continue
      ier=-1
      write(Msg,9001) diret(1:Lung(diret))
 9001 format('Error in directive: ',a)
      call MsgWinErr('ERROR',Msg,5,nExitCode)        
      return
      end
c--------------------------------------------------------------------
      subroutine laue(space,jsys,laues)
      character space*16,laues*5,string*16,dire*16
c
      if (jsys.le.3) then
                       if (jsys.eq.1) then
                                        laues=' -1  '
                  else if (jsys.eq.2) then
                                        laues=' 2/m '
                  else if (jsys.eq.3) then
                                        laues=' mmm '
                                      endif
                     else
                       string=space 
                       call cutst(string,lens,dire,lend)
c--calcola il numero di operatori
                       nop=1
                       do 40 i=1,3
                       call cutst(string,lens,dire,lend)
                       if (lens.le.0) go to 45
                       nop=nop+1
   40                  continue 
   45                  continue 
           if (jsys.eq.4) then
                if (nop.eq.1) then
                                laues=' 4/m '
                              else 
                                laues='4/mmm'
                              endif
       else if (jsys.eq.5) then
                 j=index(space,'3')
                 if (j.eq.0) then
                  if (nop.eq.1) then
                                   laues=' 6/m '
                                 else 
                                   laues='6/mmm'
                                 endif
                              else 
                     if (nop.eq.1) then
                                      laues='  -3 '
                                    else  
                                      laues=' -3m '
                                    endif 
                                endif
        else          
             if (nop.eq.2) then
                             laues=' m-3 '
                           else 
                            laues=' m-3m'
                           endif
                       endif
                       endif
        return
        end  
c--------------------------------------------------------------------
      subroutine sth(irif,jrif)
      USE General
      USE fourpamod, only: iphkl,fop1
!corr      common/fourpa/numbext
!corr      common/fourpa1/fop1(3000)
      dimension ih(3),sith(nrefl)
c
      dstmin=9999999.0
      do 100 i=1,nrefl
      ih(1)=iphkl(i,1)
      ih(2)=iphkl(i,2)
      ih(3)=iphkl(i,3)
      st=rhof(pp,ih(1),ih(2),ih(3))
      sith(i)=st
  100 continue
      strif=sith(irif)
      do 200 i=1,nrefl
      dfst=abs(sith(i)-strif)
      if(dfst.lt.dstmin.and.fop1(i).gt.0.0)then
      jrif=i
      dstmin=dfst
      endif
  200 continue
      return
      end
c------------------------------------------------------------
      subroutine chargeref
      USE Riflessi
      USE xdataMod
      USE General
      USE fourpamod, only: rappor,iphkl,fop1
      common /setequ/ jpatt,jpuntt(501),ksacc,jseteq,jumpp
!corr      common/fourpa/numbext
!corr      common/fourpa1/fop1(3000)
      common/fourinv/ jinv,sog,iquad,irecyc,nrecy,ncpat
c
!        do 2799 i=1,nrefl
!         rappor(i)=1.0
!         call snr07(vet)
!         jh=ivet(1)
!         jk=ivet(2)
!         jl=ivet(3)
!         iphkl(i,1) = jh 
!         iphkl(i,2) = jk 
!         iphkl(i,3) = jl 
!         ihkl(i) = 262144 * ivet(1) + 512 * ivet(2)
!     *                 + ivet(3) + 131328
!         if (jpatt.ne.3) then
!              fop1(i) = vet(jps)**2
!         else
!              fop1(i) = vet(4)*vet(5)
!         endif
!         if(fop1(i).gt.0.0.and.jps.ne.5)rappor(i)=fop1(i)/(vet(5)**2)
! 2799   continue
!
!-- jpatt = 0     no patterson
!-- jpatt = 1     E*E
!-- jpatt = 2     F*F
!-- jpatt = 3     E*F
!
      sumfca= 0.0
      if (jpatt.ne.3) jps=jpatt +3
!#!   call xfl06
!anna
      call LeggiRiflessiOrdinati
!     write(6,*) ' DOPO LEGGIRIFLESSIORDINATI'
!     write(6,*) ' In chargeref   i    h k l   ex   fx   fx**2  rappor '
      do i=1,nrefl
         rappor(i)=1.0
         jh=khl(1,i)
         jk=khl(2,i)
         jl=khl(3,i)
         iphkl(i,1) = jh 
         iphkl(i,2) = jk 
         iphkl(i,3) = jl 
         ihkl(i) = 262144 * khl(1,i) + 512 * khl(2,i)
     *                    + khl(3,i) + 131328
         if (jpatt.ne.3) then
             if (jps == 4) then
                 fop1(i) = ex(i)**2
              else
                 fop1(i) = fx(i)**2 
              endif
         else
             fop1(i) = ex(i) * fx(i)
         endif
         if (fop1(i).gt.0.0.and.jps.ne.5) then
             rappor(i)=fop1(i)/(fx(i)**2)
         endif
!       write(6,'(i3,1h),3i4,4f10.2)')i,iphkl(i,1:3),ex(i),fx(i),
!    *                                fx(i)**2,rappor(i)
      enddo
!      call ysfl06(nrif)
!      do 111 i = 1,nrefl
!        call snr06(vett)
!        IndHKL(i,1)=ivett(1)
!        IndHKL(i,2)=ivett(2)
!        IndHKL(i,3)=ivett(3)
!        IndHKL(i,4)=ivett(4)
!        SetFob(i,1)=vett(5)
!        SetFob(i,2)=vett(6)
!        SetFob(i,4)=vett(8)
!        WHM(i)=vett(9)
!        TThet(i)=vett(10)
!        Mult(i)=ivett(11)
!        IndHKL(i,5)=ivett(12)
!        fxsav(i)=vett(13)
!        sinth(i)=vett(7)
! 111  continue
      
!#!   call xfl06
      call LeggiRiflessi
!corr      sinth(1:nrefl) = SetFob(1:nrefl,5)
CANNA
       do i = 1,nrefl
        do j = 1,nrefl
          if(IndHKL(i,1).eq.iphkl(j,1).and.
     *       IndHKL(i,2).eq.iphkl(j,2).and.
     *       IndHKL(i,3).eq.iphkl(j,3)) then
! versione precedente sbagliata!
!              if(ncpat.eq.1.and.knw.gt.0) fc(j)=fxsav(i) 
      sumfca= sumfca +  fxsav(i)
      fc(j)= fxsav(i)
c
          endif
        enddo
        enddo
CANNA
      call LeggiRiflessiOrdinati
      return
      end
c-----------------------------------------------------------------------
!!!   subroutine computerre(k,npatter,sograndom)
      subroutine computerre(k)
      USE Riflessi
      USE xdataMod
      USE General
      USE fourpamod, only: fop1,fop2,fop3
      common /setequ/ jpatt,jpuntt(501),ksacc,jseteq,jumpp
!corr      common/fourpa/numbext
!corr      common/fourpa1/fop2(3000)
      common/fourinv/ jinv,sog,iquad,irecyc,nrecy,ncpat
c
      eps=1.0E-10
c
c--calcolo dei fattori di accordo
c
      sumfi =  0.
      sumfo =  0.
      do i=1,nrefl
        sumfo = sumfo + sqrt(fop1(i))
        sumfi = sumfi + sqrt(fop2(i))
      enddo
      if (sumfi.gt.eps) scalaf = sumfo/sumfi
!     write(6,*) ' SCALAF = ',scalaf
      sumf =  0.
      do i=1,nrefl
        sumf = sumf + abs(sqrt(fop1(i)) - scalaf * sqrt(fop2(i)))
!       write(6,'(a,i4,1h),2f10.0)') ' i fop1 fop2',i,fop1(i),fop2(i)
      enddo
      erreinv=0.
      if (sumfo.gt.eps) erreinv = 100. * sumf/sumfo
      if (iprin.gt.0) write(lo,2961) erreinv
 2961 format(/,' RF before and after inverse Patterson map =',
     *        f10.5,' %',/)
c
c--eventualmente applico un fattore di scala agli fop2
c
      cf0=100.
      if(fop2(1).gt.1000.0.or.fop2(2).gt.1000.0.or.fop2(3).gt.1000.)
     *                           cf0=1.0
      if(fop2(1).gt.10000000.0.or.fop2(2).gt.10000000.0.or.fop2(3).gt.
     *     10000000.)  cf0=1.0/1000.
      do  i =1,nrefl
        fop2(i)=fop2(i)*cf0  
      enddo
c
!!!   call convert0(k,sumf3,sograndom)
      call convert0(k,sumf3)
c
      if(knw.ne.0) then 
        sumfc2=0.
        do i=1,nrefl
          sumfc2 =  sumfc2 + fc(i)
        enddo
        if( sumfo.gt.eps) scalafco = sumfc2/sumfo
        sumfco =  0.
        do i=1,nrefl
          sumfco = sumfco + abs(fc(i) - scalafco * sqrt(fop1(i)))
!         write(6,'(a,i4,1h),2f12.0)') 
!    *         ' i fc(i)  scalafco * sqrt(fop1(i))',
!    *               i,fc(i),scalafco * sqrt(fop1(i))
        enddo
c
        if (sumfc2.gt.eps) then
          erreco = 100. * sumfco/sumfc2
        endif
        if (sumf3.gt.eps) scalf3=sumfc2/sumf3
!       write(6,'(a,f15.3)') ' sumfc2 in convert0',sumfc2
!       write(6,'(a,f15.3)') ' sumfc3 in convert0',sumf3
        sumftot3=0.0 
!       write(6,*) '  H   K   L  fc   scalf3*sqrt(fop3(i))   Abs(delta)'
        do i=1,nrefl
           sumftot3=sumftot3+abs(scalf3*sqrt(fop3(i))-fc(i))
!        write(6,'(3i4,3f15.2)')iphkl(i,1:3),fc(i),
!    *  scalf3*sqrt(fop3(i)),abs(scalf3*sqrt(fop3(i))-fc(i))
        enddo
        if (sumfc2.gt.eps) erref3=(sumftot3/sumfc2)*100.0
        if (iprin.gt.0) then
          write(lo,127) k,erreco,erref3
        endif
  127   format(' Inverse Patterson cycle',i3,2x,'RF Fo-Fc =',f10.5,
     *           /,29x,'RF Fc-Fpatt. inv =',f10.5,/)
c
c--calcolo i fattori di accordo per varie soglie di overlap
c
!!!!!   call computerre_ovlp1(npatter,dummy)
c
      endif  
c
      return
      end
c-----------------------------------------------------------------------
      subroutine UsePatt(kgo,ier)
      USE General
      USE Molcom      
      USE commandsmod, only:allcom
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /viewp/ jxvp1, jyvp1, jxvp2, jyvp2
      character(len=10) :: command
c ---
c
c-- check if extra has run in the past
c
      call srlin (37,lsn,lixx,ljxx,lkxx,llxx)
      if (lixx.le.0) return
c
      k = 0
      kk = 0
      kgo = 0
      command = 'fsir'
      k = Lung(command) + 1
      write(Inte,100)
  100 format(' Inverse Patterson Procedure ')
      Msg = 'Do you want to use it in Extra?'
c
c-- copy %extract and %normal directives ( if any ) in card reader
c
      ilast = size(card)
      kextra = 0
      ncardx = 0
CANG
      numdirx=0
      numdirn=0
CANG
      do 30 i=1,icomat
         if (kextra.eq.0) then
             j = icomq(i,1)
             if (allcom(j)(1:4).eq.'extr') then
                 kextra = 1 
                 numdirx = icomq(i,2)
             else
                 ncardx=ncardx+icomq(i,2)
             endif
         endif
   30 continue
CANG
      if(numdirx.lt.1)then
c        kextra=0
         go to 41
      endif
CANG
      j = ncardx
      do 40 i=1,numdirx
         j = j + 1
         card(ilast-i+1) = card(j)
   40 continue
   41 continue
      ilast = ilast - numdirx
c- normal
      knorma = 0
      ncardn = 0
      do 50 i=1,icomat
         if (knorma.eq.0) then
             j = icomq(i,1)
             if (allcom(j)(1:4).eq.'norm') then
                 knorma = 1 
                 numdirn = icomq(i,2)
             else
                 ncardn=ncardn+icomq(i,2)
             endif
         endif
   50 continue
      j = ncardn
canna
      if(numdirn.lt.1)go to 61
canna
      do 60 i=1,numdirn
         j = j + 1
         card(ilast-i+1) = card(j)
   60 continue
   61 continue
      ilast = size(card)
c
      if (kscreen.eq.0) then
         iExCode = 1
         go to 144
      endif
c
c     lh1 = Lhs(1)
c     lh2 = Lhh(1)
      ix1 = 100
      iy1 = 110
      ix2 = 360
      iy2 = 200
      iTipo = 2
      iExCode = 0
      call MsgWinErr(Inte,Msg,iTipo,iExCode)
 144  continue
      if (iExCode .eq. 1) then
          iPdire=ipdir
          call svcard(nAddComm,ier)
          if (ier.lt.0) return
c         if (kextra.eq.1) then
          call upcard(nAddComm,'%extract      ',14,ier)
          if (ier.lt.0) return
c         endif
          call upcard(nAddComm,command         ,k,ier)
          if (ier.lt.0) return
          call upcard(nAddComm,'fast          ',14,ier)
          if (ier.lt.0) return
          if (kextra.eq.1.and.numdirx.gt.0) then
              do 200 i=1,numdirx
                 kk = ilast - i + 1
                 k = Lung(card(kk))
                 call upcard(nAddComm,card(kk),k,ier)
                 if (ier.lt.0) return
  200         continue
              ilast = ilast - numdirx
          endif
CANNA
          if (knorma.eq.1) then
             call upcard(nAddComm,'%normal       ',14,ier)
             if (ier.lt.0) return
              if (numdirn.gt.0) then
                 do 300 i=1,numdirn
                    kk = ilast - i + 1
                    k = Lung(card(kk))
                    call upcard(nAddComm,card(kk),k,ier)
                    if (ier.lt.0) return
  300            continue
              endif
          endif
CAG       call upcard(nAddComm,'%invar        ',14,ier)
CAG       if (ier.lt.0) return
CAG       call upcard(nAddComm,'%phase        ',14,ier)
CAG       if (ier.lt.0) return
CAG       call upcard(nAddComm,'%fourier      ',14,ier)
CAG       if (ier.lt.0) return
CAG       call upcard(nAddComm,'%menu         ',14,ier)
CAG       if (ier.lt.0) return
CAG       call upcard(nAddComm,'%end          ',14,ier)
CAG       if (ier.lt.0) return
          call rscard(nAddComm,iPdire)
          kgo = 1
      endif
c
      return
      end
c-----------------------------------------------------------------------
!!!   subroutine convert0(kpat,sumf3,sograndom)
      subroutine convert0(kpat,sumf3)
      Use Riflessi
      Use xdataMod
      USE General
      USE Molcom
      USE fourpamod, only: iphkl,fop1,fop2,fop3,fcp
      common /setequ/ jpatt,jpunt0(501),ksacc,jseteq,jumpp
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
!corr      common/fourpa/numbext
!corr      common/fourpa1/fop2(3000)
!corr      common /xdTMP/ idummy(100000),fcp(3000),fop4(3000),idummy1(12000)
!corr      common /xdTMP/ fcp(3000),fop4(3000)
      common/fourinv/ jinv,sog,iquad,irecyc,nrecy,ncpat
      dimension Setcalc(nrefl),Setobs(nrefl),fop4(nrefl)
      integer nov(500)
c
      eps=1.0E-10
      sumf3=0.0
       if(neutro.eq.0)then
         pfwhm=0.7
        else
         pfwhm=0.5
       endif
c
!     call ysfl06(nrif)
!     do i = 1,nrefl
!       call snr06(vett)
!       IndHKL(i,1)=ivett(1)
!       IndHKL(i,2)=ivett(2)
!       IndHKL(i,3)=ivett(3)
c       IndHKL(i,4)=ivett(4)
c       SetFob(i,1)=vett(5)
!       SetFob(i,2)=vett(6)
!       SetFob(i,4)=vett(8)
!       WHM(i)=vett(9)
!       TThet(i)=vett(10)
!       Mult(i)=ivett(11)
!       IndHKL(i,5)=ivett(12)
!       fxsav(i)=vett(13)
!       sinth(i)=vett(7)
!     enddo
      
!#!   call xfl06
      call LeggiRiflessi
!corr      sinth(1:nrefl) = SetFob(1:nrefl,5)
       if(neutro.eq.0)then
         pfwhm=0.7
        else
         pfwhm=0.5
       endif
c
!RRRRRRRRRRRRRRR
      do i = 1,nrefl
        SetFob(i,1)=0.0
        Setobs(i)=0.0
        Setcalc(i)=0.0
        IndHKL(i,4)=-1.0
!       write(6,'(a,i4,1h),3i4,i6,i8,2f15.0)') 
!    *' indhkl setfob(i,4) fxsav',i,IndHKL(i,1:4),
!    *             mult(i),setfob(i,4),fxsav(i)
        do j = 1,nrefl
          if(IndHKL(i,1).eq.iphkl(j,1).and.
     *       IndHKL(i,2).eq.iphkl(j,2).and.
     *       IndHKL(i,3).eq.iphkl(j,3)) then
               SetFob(i,3) =fop1(j)
               SetFob(i,5) =fop2(j)
! versione precedente sbagliata!
c              if(ncpat.eq.1.and.knw.gt.0) fc(j)=fxsav(i) 
!       write(6,*) ' i j fop1(j) sqrt(fop1(j)',i,j,fop1(j),sqrt(fop1(j))
               if(knw.gt.0) fc(j)=fxsav(i)  
c
          endif
        enddo
      enddo
c
!     write(6,*) ' PRIMA DI DEFOVL '
!     do i=1,nrefl
!      write(6,'(a,i9,1h),4i5,i8,2f8.0,4f11.0)')
!    *   ' prima di defovl i indhkl(1:5) setfob4 2theta fc fop4 etc',
!    *  i,indhkl(i,1:5),setfob(i,4),tthet(i)
!    *,fxsav(i),fop4(i),SetFob(i,1),SetFob(i,5)
!
!!!    write(6,'(8x,3i5,13x,f15.8,16x,f11.2)')indhkl(i,1:3),
!!!  *            setfob(i,4),fxsav(i)
!
!      enddo
      call defovl
      sumfop2=0.
      sumfop3=0.
      nov=0
!corr
      fop4(:) = 0
!corr
!     write(6,*) ' setfob1 in convert0'
      do i=1,nrefl
        if(IndHKL(i,4).eq.0) then
          Setcalc(i)=0.0
          Setobs(i)=0.0
          SetFob(i,1)=0.0
        elseif(IndHKL(i,4).eq.1) then
          fop4(i)=SetFob(i,1)/Mult(i)
          Setcalc(i)=Mult(i)*(fxsav(i))**2
          Setobs(i)=SetFob(i,1)
          nov(1)=nov(1)+1
        elseif(IndHKL(i,4).gt.1) then
          sumintcalc=0.0
          do k=0,IndHKL(i,4)-1
             sumintcalc = sumintcalc + Mult(i+k)*(fxsav(i+k))**2
          enddo
          Setcalc(i) = sumintcalc
          do j=0,IndHKL(i,4)-1
            sumden=0.0
            do k=0,IndHKL(i,4)-1
              if (SetFob(i+j,5).gt.1.E-10) sumden=sumden+(Mult(i+k) 
     *          *SetFob(i+k,5))/(Mult(i+j)*SetFob(i+j,5))
            enddo
            if(sumden.gt.0.0) fop4(i+j)=SetFob(i,1)/(Mult(i+j)*sumden)
          enddo
          sumint0=0.0
          do j=0,IndHKL(i,4)-1
            sumint0 = sumint0 + Mult(i+j)*fop4(i+j)
          enddo
          Setobs(i) = sumint0
          nov(IndHKL(i,4))=nov(IndHKL(i,4))+1
        endif
        sumfop2=sumfop2+SetFob(i,5)
        sumfop3=sumfop3+fop4(i)
!       write(6,'(a,i4,1h),4i4,i8,5f11.0)')
!    *   ' i indhkl(1:5) 2theta fc fop4 Setfob(1) e (5)',
!    *  i,indhkl(i,1:5),tthet(i)
!    *,fxsav(i),fop4(i),SetFob(i,1),SetFob(i,5)
!
!      write(6,'(8x,3i5,i6,7x,f15.8,16x,f11.2)')indhkl(i,1:4),
!    *            fop4(i),fxsav(i)
!    *            setfob(i,1),fxsav(i)
!
      enddo
c
c--calcolo il fattore di scala per allineare gli fop3 agli fop2
c
      if(sumfop3>0.0) then
        scalfop2fop3=sumfop2/sumfop3
      else
        scalfop2fop3=0.0
        return
      endif
c
c--calcolo dei fattori di accordo per le intensita'
c
      if(iprin>1.and.knw.ne.0) then 
        sumint=0.0
        sumint0=0.0
        sumintcalc=0.0
        do i=1,nrefl
          sumint= sumint + SetFob(i,1)
          sumint0= sumint0 +  Setobs(i)
          sumintcalc = sumintcalc + Setcalc(i)
        enddo
        if (sumint.gt.eps) scalaint = sumintcalc/sumint
        if (sumint0.gt.eps) scalaint0 = sumintcalc/sumint0
        diffint = 0.0
        diffint0 = 0.0
        do  i =1,nrefl
          if (IndHKL(i,4).ne.0) then
            diffint=diffint + abs( scalaint * SetFob(i,1) - Setcalc(i))
            diffint0=diffint0 +abs( scalaint0 * Setobs(i) - Setcalc(i))
          endif
        enddo
        if(sumintcalc.gt.eps) then
          erreint  = (diffint / sumintcalc) * 100.
          erreint0 = (diffint0/ sumintcalc) * 100. 
        endif
      endif
c
      do j=1,nrefl
        do i=1,nrefl
          if(IndHKL(i,1).eq.iphkl(j,1).and.
     *       IndHKL(i,2).eq.iphkl(j,2).and.
     *       IndHKL(i,3).eq.iphkl(j,3))   then
ccc            fop3(j)=fop4(i)  ! originale
               fop3(j)=fop4(i)*scalfop2fop3  ! modifica mia
               sumf3=sumf3+sqrt(fop3(j))
               fcp(i)=fop4(i)
               exit 
          endif
        enddo
      enddo
c     
!     if(iprin>0) then
!       novtot1=0
!       do i=1,30
!        novtot1=novtot1+nov(i)*i
!        if(nov(i)/=0) novmax=i
!       enddo
!     endif
c
      return
      end
c-----------------------------------------------------------------
c  Compute  a density histogram
c------------------------------------------------------------------
      subroutine denhist(sog,stot,dennew,npatter)
      USE ParametriMappa      
c     
      USE General
      integer p1,p2,r
      character name1*80
      common /tran/ scaleFour,mh(3),level,it4,xlim(3)
      common/xdata/ x(350000)
      common/invfou/ invf,ifmapt,f000,denmax,denmin,scale1,
     * v_p,sumff
      common/denpar/den_p,den_s,n_p,n_s,perc,sperc,den_m
c
      x(:)=0.0
c
      nx = np(1)
      ny = np(2)
      nz = np(3)
c
      itype=0
      iform=2
      jrel1=49
      name1='mapnew.out'
      jop=jopen(jrel1,name1,itype,iform,ier)
c
 5    rewind jrel
      rewind jrel1
c
      p1=350000/(nx*nz)
      p2=350000/(2*ny*(mh(3)+1))
c
c--codice per la densogSub (comunque non usata)
c---- jflag = 0 Inizializza vettori
c---- jflag = 1 Legge la mappa
c---- jflag = 2 Effettua modifica della mappa
c
      r=0
      jflag=0
      jjmod=-1

      stot1 = 0.0
      stot  = 0.0
      spar  = 0.0
 15   if ( r+p1 .gt. ny ) p1=ny-r
      call readmapp(x,nz,nx,p1,jjmod,stot,spar,jrel,dennew,npatter)
      call writemap(x,nz,nx,p1,jrel1)
      call densogSub(x,nz,nx,p1,jflag,sog)
      r = r+p1
      jflag=1
      if ( r.lt.ny) then
         write(6,*) 'Warning in denhist: controllare la mappa'
         goto 15
      endif
      jflag=2
      call densogSub(x,nz,nx,p1,jflag,sog)
      if (jjmod.eq.-1) stot1 = stot1 + stot
c      write(6,*)'Area Totale considerata, jjmod ', jjmod,stot1
      return
      end
*----------------------------------------------*
      subroutine densogSub(x,nz,nx,ny,jflag,sog) 

      USE General
      common/invfou/ invf,ifmapt,f000,denmax,denmin,scale1,
     * v_p,sumff
      common/denpar/den_p,den_s,n_p,n_s,perc,sperc,den_m
      common/tempd/range(201),hisp(201),dipf(201),nrange

      real x(nz,nx,ny)
      real dip(201)
      integer hisp
c     character name*80

*---- jflag=0 Inizio dello studio ----*
*---- jflag=1 E' in fase di studio ----*
*---- jflag=2 Fine dello studio ----*
c----
c----  denmax e denmin sono riempiti in outpufn di pp1
c----
c      densav=denmin
       f=0.7
c      f=0.6
       denmin=0.0
       if(jflag.eq.0)denmax=denmax*f
      rang=(denmax - denmin)/200.0
      if (jflag.eq.2) goto 50
      if (jflag.eq.0) then
         do 10 i=1,201
            hisp(i)=0
            range(i)=denmin + rang*(i-1)
 10      continue
      endif
      do 40 i=1,nz
         do 30 j=1,nx
            do 20 k=1,ny
c              if (x(i,j,k).lt.0.0) x(i,j,k) = 0.0
               xx=x(i,j,k)
               if (xx.gt.0) then
                n=int((xx-denmin)/rang) + 1
                if (n.gt.200) n=200
                if (n.le.1) n=1
                hisp(n)=hisp(n)+1
               endif
 20         continue
 30      continue 
 40   continue
      return

 50   itot=0
      do i=1,201
         range(i)=denmin + rang*(i-1)
      enddo
      do 60 i=1,200
         itot=hisp(i)+itot
 60   continue
      dismax=-1.0
      do 65 i=1,200
         dip(i)=hisp(i)/float(itot)
         if ( dip(i) .gt. dismax ) dismax=dip(i)
 65   continue
      dipf(1)=(dip(1)+dip(2))/2.0
      do 70 i=2,199
         dipf(i)=(dip(i-1) + dip(i) + dip(i+1))/3.0
 70   continue
      nrange=201

*---- Select the cut ----* 
c     perc=0.50
c     write(6,*)'denmin denmax in lmod',denmin,denmax
      npts=nint(itot*(1.-sog))
Ctot  npts=itot
c      write(6,*)'NPTS in modiden',npts
      
      ires=0
      do 90 i=201,2,-1
         ires=ires+hisp(i-1)
         if (ires.ge.npts) then
            sogden=denmin + (rang*(i-2) + rang/2)
            goto 100
         endif
 90   continue
      sogden=denmin
 100  continue
      den_p=sogden
      if (sog.eq.1.0) den_p=0.0      
      return
      end
*---------------------------------------------*
      subroutine readmapp(x,nz,nx,ny,jjmod,stot,spar,ifile,
     &                           dennew,npatter)
      USE ParametriMappa
c
      USE General
      integer inut(180)
      real x(nz,nx,ny)
!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
*      common/trig/sint(45000),pi,twopi,dtor,rtod
c     common/rc/pp(6),cell(9),nrefl,nbWils,rhomax,mm,en,mz,er,th,rhomin
      common /tran/ scaleFour,mh(3),level,it4,xlim(3)
      common/denpar/den_p,den_s,n_p,n_s,perc,sperc,den_m
      common/invfou/ invf,ifmapt,f000,denmax,denmin,scale1,v_p,sumff
      common/fourinv/ jinv,sog,iquad,irecyc,nrecy,ncpat
      common/annasu/ntotal,ntotal1,npos,npos1,stotm
c
*---- jjmod=-1 legge la densita' modificando solo le origini ----*
*---- jjmod=+1 legge la densita' e la modifica               ----*
c
c--inizializzazioni
c
      nsoglia=0
      ntotal=0
      npos=0
      stot=0.
c
c--definizioni dei tagli
c
      f=0.7       ! valore di default
      raggio=2.0  ! valore di default
cnew
      averd = 0.0
      stdvt = 0.0
      stdvn = 0.0
      avernn = 0.0
      stdvnn = 0.0
cnew
CJAMES
       raggioq=(raggio/factr)**2
       ca=cos(cell(4)*(pi/180.))
       cb=cos(cell(5)*(pi/180.))
       cg=cos(cell(6)*(pi/180.))
       nup=0
       vpar = 0.0
       xb=0.0
CJAMES
C
      nrim=0
      do  k=1,ny
        do  j=1,nz
          read(ifile,end=400,err=300) ( inut(i), i=1,nx )
          do  i=1,nx
CJAMES
       rix=i-0.5
       riy=k-0.5
       riz=j-0.5
CJAMES   
            x(j,i,k) = float(inut(i))
cnew
            if (jjmod.eq.-1) then
              stdvt = stdvt + x(j,i,k) * x(j,i,k)
              averd = averd + x(j,i,k) 
            endif
cnew
                if (x(j,i,k).lt.0.0) x(j,i,k) = 0.0
                xb=xb+x(j,i,k)
cnew
              stdvn = stdvn + x(j,i,k) * x(j,i,k)
cnew
CJAMES
      if (jjmod.eq.-1)then
      if ((rix**2+riy**2+riz**2+2.*rix*riy*cg+2.*rix*riz*cb+
     *     2.*riy*riz*ca.lt.raggioq).or.   
     *     ((rix-nx)**2+riy**2+riz**2+2.*(rix-nx)*riy*cg+2.
     *     *(rix-nx)*riz*cb+2.*riy*riz*ca.lt.raggioq).or.   
     *     (rix**2+(riy-ny)**2+riz**2+2.*rix*(riy-ny)*cg+2.
     *     *rix*riz*cb+2.*(riy-ny)*riz*ca.lt.raggioq).or.   
     *     (rix**2+riy**2+(riz-nz)**2+2.*rix*riy*cg+2.
     *     *rix*(riz-nz)*cb+2.*riy*(riz-nz)*ca.lt.raggioq).or.   
     *((rix-nx)**2+(riy-ny)**2+riz**2+2.*(rix-nx)*(riy-ny)*cg+2.
     *     *(rix-nx)*riz*cb+2.*(riy-ny)*riz*ca.lt.raggioq).or.   
     *     ((rix-nx)**2+riy**2+(riz-nz)**2+2.*(rix-nx)*riy*cg+2.
     *     *(rix-nx)*(riz-nz)*cb+2.*riy*(riz-nz)*ca.lt.raggioq).or.   
     *     (rix**2+(riy-ny)**2+(riz-nz)**2+2.*rix*(riy-ny)*cg+2.
     *     *rix*(riz-nz)*cb+2.*(riy-ny)*(riz-nz)*ca.lt.raggioq).or.   
     *     ((rix-nx)**2+(riy-ny)**2+(riz-nz)**2+2.*(rix-nx)*
     *(riy-ny)*cg+2.*(rix-nx)*(riz-nz)*cb+2.*(riy-ny)*(riz-nz)*ca. 
     *     lt.raggioq)) then 
           x(j,i,k)=x(j,i,k)*f 
           nup=nup+1
           vpar = vpar + x(j,i,k)
      endif
      endif
CJAMES
                 if (jjmod.eq.-1) then
                          xa=x(j,i,k)
                          ntotal = ntotal +1
                          if (xa.gt.0.0) then
                            npos = npos + 1
                            stot = stot + xa
                           endif
cnew
              stdvnn = stdvnn + x(j,i,k) * x(j,i,k)
              avernn = avernn + x(j,i,k) 
cnew
                  endif
cnew
               if (jjmod .eq. 1) then
                  xx=x(j,i,k)
c
                  if (xx .lt. dennew)then
                                    x(j,i,k)=0.0
                                    xx=0.0
                                    nsoglia=nsoglia+1
c                                   write(6,*)'JMOD,xx',jjmod,xx
                  endif
                  if (xx.ge.0.0) spar = spar + xx
                  if (iquad.eq.1)  x(j,i,k)=(x(j,i,k)**2)/denmax
                               elseif (jjmod .eq.-1) then
                  if (iquad.eq.2) then
                   if(x(j,i,k).le.0.0)x(j,i,k)=0.0
                   x(j,i,k)=(x(j,i,k)**2)/denmax
                   denmin=0.0
                                 endif
                                 endif
          enddo
        enddo
      enddo   ! fine loop sulla mappa
         fxyz = nx*ny*nz
       if (jjmod.eq.-1) then
         ntotal1=ntotal
         npos1=npos
         averd = averd / fxyz
         stdvt = stdvt / fxyz - averd * averd
         stdvt = sqrt(stdvt)
         dennew= averd + stdvt/float(ncpat)
      if (iprin.gt.0) write(lo,112) averd,stdvt
c--stampe di controllo
c
 112      format(/,1x,60('-'),/,' Average value = ',f8.3,
     &                      ' Standard deviation =',f8.3,/,1x,60('-'))

      avern = xb / fxyz
      stdvn = stdvn / fxyz - avern * avern
      stdvn = sqrt(stdvn)
      avernn = avernn / fxyz
      stdvnn = stdvnn / fxyz - avernn * avernn
      stdvnn = sqrt(stdvnn)
       endif 
!
!      write(6,*) 'section, Num. di Punti eliminati',ny,nsoglia
!      if (jjmod.eq.-1) then
!       write(6,*) 'NTOTAL, Num. POS',ntotal,npos
!      endif
!      write(6,*) 'DENSOG', den_p
!      write(6,*) 'RHO DI SOGLIA', dennew
CJAMES
      nrim=ntotal1-nsoglia
      if (nsoglia.eq.0) nrim=npos1
      if (jjmod.eq.-1) then
       stotm=stot
!      write(6,*) 'Intensita totale mappa prima modifica origini=', xb
!      write(6,*) 'Intensita mappa dopo modifica origini=', stot
!      write(6,*) 'Numero punti inclusi nella zona modificata =', nup
!      write(6,*) 'Intensita rimanente attorno origini=', vpar
      endif
!      write(6,'(a,3f15.10)') 'ca, cb, cg =', ca, cb, cg
!      write(6,'(a,4f15.0)') 'cella(4:6) pi', cell(4:6),pi
      if (jjmod.eq.1) then
       rappunti=(float(nrim))/(float(npos1))
       rapp=spar/stotm
!      write(6,*) 'Punti rimanenti nella mappa dopo il taglio =', nrim
!      write(6,*) 'Rapporto punti rimanenti dopo il taglio con punti pre 
!    *senti prima del taglio =', rappunti
!      write(6,*) 'Rapporto intensita rimanente dopo il taglio con inten
!    *sita presente prima del taglio =', rapp
      endif
CJAMES
!     write(6,*) 'stot in readmap',stot
!      write(6,*) 'Jmod, spar in readmap',jjmod,spar
      return
 300  write(lo,*) 'Reading Error in FFT-1'
      stop
 400  write(lo,*) 'End of the file in FFT-1'
      stop
      
      end
    
*-------------------------------------------------*
      subroutine writemap(x,nz,nx,ny,ifile)
Corig integer inut(300)
      integer inut(180)
      real x(nz,nx,ny)

      do 40 k=1,ny
         do 30 j=1,nz
            do 20 i=1,nx
               inut(i)=0
               xx=x(j,i,k)
               if ( xx .ne. 0.0 ) inut(i)=xx+sign(0.5,xx)
 20         continue
            write(ifile) (inut(i),i=1,nx)
 30      continue 
 40   continue
      return
      end
*-------------------------------------------------*
      subroutine maxminmio(x,nz,nx,ny,denmin,denmax,avden,stden)
c
      real x(nz,nx,ny)
c
      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
      npunt=0
c
       do iz = 1, nz
         do iy = 1, ny
           do ix = 1, nx
            xx=x(iz,ix,iy)
            denmin=amin1(denmin,xx)
            if(xx>0) then ! nota bene
              denmax=amax1(denmax,xx)
              avden=avden + xx
              stden=stden + xx * xx
              npunt=npunt+1
            endif
           enddo
         enddo
       enddo
c
      avden=avden/float(npunt)
      stden=stden/float(npunt) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif
c
      return
      end
*-------------------------------------------------*
      subroutine DrawMap(x,nz,nx,ny,id)
      real x(nz,nx,ny)
c
      do k=1,ny
         do j=1,nz
            do i=1,nx
               write(id,'(3i4,f20.2)') j,i,k,x(j,i,k)
            enddo
         enddo 
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine modiden(dennew,spar,npatter)
      USE ParametriMappa
c
      USE General
      integer p1,r
      character name1*80

      common /tran/ scaleFour,mh(3),level,it4,xlim(3)
      common/xdata/ x(350000)
      common/fourinv/ jinv,sog,iquad,irecyc,nrecy,ncpat
      common/invfou/invf,ifmapt,f000,denmax,denmin,scale1,
     *              v_p,sumff
c
*---- Preparo para hacer una copia del mapa de la densidad ----*
c
      nx = np(1)
      ny = np(2)
      nz = np(3)
c
      itype=0
      iform=2
      jrel1=49
      name1='mapnew.out'
      jop=jopen(jrel1,name1,itype,iform,ier)
c
      rewind jrel1
      rewind jrel
c
      p1=350000/(nx*nz)
      scale1 = 1./(nx*ny*nz)
c
      r=0
      jjmod=1
      if (iprin.gt.0) write(lo,111) dennew,ncpat
      spar=0.0
      spar1=0.0
c
 15   if ( r+p1 .gt. ny ) p1=ny-r
      call readmapp(x,nz,nx,p1,jjmod,stot,spar,jrel1,dennew,npatter)
      call writemap(x,nz,nx,p1,jrel)
      imapp=0
      if (imapp.eq.1 ) call outfinv(x,np(3),np(1),p1, r,np(2))
      r = r+p1
      if ( r.lt.ny) then
!anna         write(6,*) 'Warning in modiden: controllare la mappa'
         goto 15
      endif
c
      spar1=spar1 + spar
c
 111  format(35h  Threshold for the Patterson map =,f8.3,3h at,i3,
     * 10h-th  cycle,/,1x,60('-'),/) 
c
      close(jrel1,status='delete')
c
c--stampo la mappa. La stampa e' completa solo se nx*ny*nz<350000
c  ( vero per tutte le strutture incontrate finora
c
c     id=id+100
c     call DrawMap(x,np(3),np(1),np(2),id)
c
      return
      end

*------------------------------------------------------------*
*------------------------------------------------------------*
      subroutine outfinv(x, nz, nx, ny, y, nyt)
      USE General      
      real x(nz,nx,ny)
      integer y,sec,xl,xu
      character*10 star,blankLine,inutil(180)                     
      dimension inutile(180),line(50)
*      common/trig/sint(45000),pi,twopi,dtor,rtod
      common /tran/ scaleFour,mh(3),level,it4,xlim(3)
      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
     *               itry,pfwhm,kequirip
      common/invfou/ invf,ifmapt,f000,denmax,denmin,scale1,
     *v_p,sumff
      common/fourinv/ jinv,sog,iquad,irecyc,nrecy,ncpat
      data star/'**'/,blankLine/'    '/,ncol/36/
c
c     put out scaled y-sections or x-sections or z-sections
c
c in the following file a section of the map is written if the directive
c 'map' is given in input
Corig nsec=1
!      write(6,*)'SCALE1 IN OUT',scale1
!      write(6,*)'SCALE  IN OUT',scaleFour 
      scalan=scaleFour*6.2/(scale1*100.)
C     scalan=2.0
      if(it4.eq.0) go to 250
      nxm=min0(nx,int(xlim(1)*float(nx))+1)
      nym=min0(nyt,int(xlim(2)*float(nyt))+1)
      if(ny.le.nyt.and.nsec.ne.1)nym=min0(ny,int(xlim(2)*float(ny))+1)
      nzm=min0(nz,int(xlim(3)*float(nz))+1)
      asc=1000.0/float(nx)
c
  250 continue
c  put  out scaled y-sections
      if (nsec.eq.1) then
                       nn1=ny
                       nn2=nz
                       nn3=nx
                       nnm1=nxm
                       nnm2=nym
                       nnm3=nzm
                     end if
c  put  out scaled x-sections
      if (nsec.eq.2) then
                       nn1=nx
                       nn2=nz
                       nn3=ny
                       nnm1=nym
                       nnm2=nxm
                       nnm3=nzm
                     end if
c  put  out scaled z-sections
      if (nsec.eq.3) then
                       nn1=nz
                       nn2=nx
                       nn3=ny
                       nnm1=nym
                       nnm2=nzm
                       nnm3=nxm
                     end if
      do 100 k = 1, ny
      do 150 j=1,nz
      do 130 i=1,nx
Corig xx=x(j,i,k)*scaleFour
      xx=x(j,i,k)*scalan
      inutile(i)=0
      if(xx.ne.0.0) inutile(i)=xx+sign(0.5,xx)
  130 continue
  150 continue
  100 continue
      asc=1000.0/float(nn3)
c     write(6,*)'nn1,nn2,nn3',nn1,nn2,nn3
      do 900 k = 1, nn1
      sec = y + k - 1
      do 350 j=1,nn2
      do 330 i=1,nn3
           if (nsec.eq.1) then
Corig                       xx=x(j,i,k)*scaleFour
                            xx=x(j,i,k)*scalan
                            x(j,i,k)=xx
      else if (nsec.eq.2) then
Corig                       xx=x(j,k,i)*scaleFour
                            xx=x(j,k,i)*scalan
                            x(j,k,i)=xx
      else if (nsec.eq.3) then
Corig                       xx=x(k,j,i)*scaleFour
                            xx=x(k,j,i)*scalan
                            x(k,j,i)=xx
                          end if
  330 continue
  350 continue
      if (it4 .eq. 0) go to 900
      nec=1000.*(float(sec))/(float(nn1))+0.5
c     if(nec.le.470.or.nec.ge.510) go to 900
c     if(nec.ne.500) go to 900
      xu = 0
  450 xl = xu + 1
      xu = xu + ncol
      if(xu.gt.nnm1) xu=nnm1
      do 460 l=xl,xu
      inutile(l)=float((l-1))*asc+0.5
  460 continue
      if(nsec.eq.1) write (it4,480) trim(jobname),nec
      if(nsec.eq.2) write (it4,481) trim(jobname),nec
      if(nsec.eq.3) write (it4,482) trim(jobname),nec
  480 format(1h1,7x,a,8x,12hsection  y =,i4/)
  481 format(1h1,7x,a,8x,12hsection  x =,i4/)
  482 format(1h1,7x,a,8x,12hsection  z =,i4/)
      if(nsec.eq.1) write (it4,500) (inutile(nn),nn=xl,xu,2)
      if(nsec.eq.2) write (it4,501) (inutile(nn),nn=xl,xu,2)
      if(nsec.eq.3) write (it4,502) (inutile(nn),nn=xl,xu,2)
  500 format(8x,3hx =,i4,17i6)
  501 format(8x,3hy =,i4,17i6)
  502 format(8x,3hy =,i4,17i6)
      ilim = xl + 1
      write (it4,520) (inutile(nn),nn=ilim,xu,2)
  520 format(12x,18i6)
      write(it4,530)
  530 format(/)
      do 700 i = 1,nnm3
      line(1)=float((i-1))*1000./float(nn2)+0.5
      l = 1
      do 600 j = xl, xu
      l = l + 1
CANG  inutile(l)=blank
      inutil(l)=blankLine
      if(nsec.eq.1) xx=x(i,j,k)
      if(nsec.eq.2) xx=x(i,k,j)
      if(nsec.eq.3) xx=x(k,i,j)
      line(l)=0
      if(xx.ne.0.0) line(l)=int(0.1*xx+sign(0.5,xx))
      if (iabs(line(l)) .gt. 99) line(l) = isign(99,line(l))
CANG  if (10 * line(l) .gt. level) inutile(l) = star
      if (10 * line(l) .gt. level) inutil(l) = star
  600 continue
      if(nsec.eq.1) write (it4,630) (line(j), j = 1, l)
      if(nsec.eq.2) write (it4,631) (line(j), j = 1, l)
      if(nsec.eq.3) write (it4,632) (line(j), j = 1, l)
  630 format(4h z =,i4,4h *  ,36i3)
  631 format(4h z =,i4,4h *  ,36i3)
  632 format(4h x =,i4,4h *  ,36i3)
CANG  write(it4,660) (inutile(j),j=2,l)
      write(it4,660) (inutil(j),j=2,l)
  660 format(12x,36(1x,a2))
  700 continue
      if(xu.lt.nnm1) go to 450
      if(sec.ge.nnm2) it4=0
  900 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine restar(ier)
      return
      end
c----------------------------------------------------------------------
      subroutine dirres(jcompl,ier)
      return
      end
c----------------------------------------------------------------------
      subroutine getcod(line,ncod,iz,kjump,ier)
      return
      end
c----------------------------------------------------------------------
      subroutine change0(ier)
      return
      end
c----------------------------------------------------------------------
      subroutine change1(ier)
      return
      end
c---------------------------------------------------------------------
      subroutine sftrc(mode,numb)
      return
      end
c-----------------------------------------------------------------------
      subroutine assbtl
      return
      end
c--------------------------------------------------------------------------

