#include "mrconfig.h"
#include "callbacks.h"
#include "forcomm2.h"
#include "aliasx.h"

extern char *fontn;
extern plotok *cplotok;
extern _Dialogo *dialogo;
extern GtkWidget *finestre[6];
extern PangoFontDescription *fontdescN;

static GtkWidget *restart_dialog = NULL;
static int statofinale[10];

void get_metrics(PangoFontDescription *font_desc,
                 int *char_width, int *char_height);
extern "C" void trialselected_(int *quale);
extern "C" void  prefourier_ (int *nats, int *nadd);
extern "C" void  startfourier_(int *ier, int statofinale[]);


/*****************************************************************/
/*              F O U R I E R                                    */
/*****************************************************************/

static GtkWidget *fourier_dialog = NULL;
static int nats;

void c_prefourier (int *nats, int *nadd)
{
       prefourier_(nats, nadd);
}

void c_startfourier (int *ier, int statofinale[])
{
       startfourier_(ier, statofinale);
}
/*corrado
void c_finishfourier (int *np)
{
       finishfourier_(np);
}
*/

void
ok_fourier                              (GtkButton       *button,
                                        gpointer         user_data)
{
    GtkWidget *window, *add, *check;
    int ier;

    window = gtk_widget_get_toplevel(GTK_WIDGET(button));

    add = get_widget(window, "add");
    statofinale[1] = spin_button_get_value_as_int(add);

    check = get_widget(window, "check_weight");
    statofinale[2] = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));

    check = get_widget(window, "display_contour");
    statofinale[5] = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));

    fortran_al_lavoro();
    gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    finestra_modale_chiusa2();
    c_startfourier (&ier, statofinale);
    fine_lavoro();
//    if(ier >= 0)
//    {
//     c_finishfourier ();
//    }
    
}

void on_change_fourier  (GtkToggleButton *togglebutton, gpointer user_data)
{
        int val;

        if(gtk_toggle_button_get_active(togglebutton))
        {
           val = GPOINTER_TO_INT(user_data);

           switch(val)
           {
           case 0:
                statofinale[0] = val+1;
//              g_print("tasto premuto\n");
                break;
           case 1:
                statofinale[0] = val+1;
                break;
           case 2:
                statofinale[0] = val+1;
                break;
           }
        }
}

GtkWidget* create_fourier ()
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *frame1;
  GtkWidget *frame2;
  GtkWidget *hbox2;
  GtkWidget *hbox3;
  GSList *hbox2_group = NULL;
  GtkWidget *radiof[3];
  GtkWidget *label1;
  GObject *add_adj;
  GtkWidget *add;
  GtkWidget *checkbutton;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *label0;
  int i;

  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "Fourier Synthesis");
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));
  g_object_set_data (G_OBJECT (window1), "vbox1", vbox1);

  label0 = gtk_label_new ("Info: ");
  g_object_set_data (G_OBJECT (window1), "info", label0);
  gtk_widget_show (label0);
  gtk_box_pack_start (GTK_BOX (vbox1), label0, TRUE, TRUE, 0);
  set_alignment (label0, 0, 0.5);

  frame1 = NEW_FRAME ("Fourier type");
  g_object_set_data (G_OBJECT (window1), "frame1", frame1);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, TRUE, TRUE, 20);

  frame2 = NEW_FRAME ("Fourier conditions");
  g_object_set_data (G_OBJECT (window1), "frame2", frame2);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox1), frame2, TRUE, TRUE, 20);

  hbox2 = hbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  add_to_frame (frame1, hbox2);

  radiof[0] = RADIO_BUTTON_WITH_LABEL (hbox2_group, "Observed", LABELCOLOR);
  hbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof[0]));
  g_object_set_data (G_OBJECT (window1), "radiof[0]", radiof[0]);
  gtk_widget_show (radiof[0]);
  gtk_box_pack_start (GTK_BOX (hbox2), radiof[0], FALSE, FALSE, 0);

  radiof[1] = RADIO_BUTTON_WITH_LABEL (hbox2_group, "2*Fobs - Fcalc", LABELCOLOR);
  hbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof[1]));
  g_object_set_data (G_OBJECT (window1), "radiof[1]", radiof[1]);
  gtk_widget_show (radiof[1]);
  gtk_box_pack_start (GTK_BOX (hbox2), radiof[1], FALSE, FALSE, 10);

  radiof[2] = RADIO_BUTTON_WITH_LABEL (hbox2_group, "Fobs - Fcalc", LABELCOLOR);
  hbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof[2]));
  g_object_set_data (G_OBJECT (window1), "radiof[2]", radiof[2]);
  gtk_widget_show (radiof[2]);
  gtk_box_pack_start (GTK_BOX (hbox2), radiof[2], FALSE, FALSE, 10);

  hbox3 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  add_to_frame (frame2, hbox3);

  label1 = gtk_label_new ("Peaks to add");
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox3), label1, FALSE, FALSE, 0);
  set_alignment (label1, 0, 0.5);

  add_adj = adj_new (1.f, 1.f, 500.f, 1.f, 10.f);
  add = spin_button_new (GTK_ADJUSTMENT (add_adj), 1, 0);
  g_object_set_data (G_OBJECT (window1), "add", add);
  gtk_widget_show (add);
  gtk_box_pack_start (GTK_BOX (hbox3), add, FALSE, FALSE, 6);
  gtk_entry_set_width_chars(GTK_ENTRY(add), 4);

  checkbutton = CHECK_BUTTON_WITH_LABEL ("weight", LABELCOLOR);
  g_object_set_data (G_OBJECT (window1), "check_weight", checkbutton);
  gtk_widget_show (checkbutton);
  gtk_box_pack_end (GTK_BOX (hbox3), checkbutton, FALSE, FALSE, 0);

  checkbutton = CHECK_BUTTON_WITH_LABEL ("Display Contour Map", LABELCOLOR);
  g_object_set_data (G_OBJECT (window1), "display_contour", checkbutton);
  gtk_widget_show (checkbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), checkbutton, FALSE, FALSE, 10);

  button1 = GO_button();
  g_object_set_data (G_OBJECT (window1), "button1", button1);
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, 1);

  button2 =  CANCEL_button();
  g_object_set_data (G_OBJECT (window1), "button2", button2);
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
         GTK_BUTTONBOX_SPREAD);

  // default

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiof[1]), TRUE);
  statofinale[0] = 2;

  //  segnali
  for(i=0; i<3; i++)
  {
    g_signal_connect (G_OBJECT (radiof[i]), "toggled",
                      G_CALLBACK (on_change_fourier),
                      GINT_TO_POINTER(i));
  }

  g_object_set_data (G_OBJECT (window1), "cancel_button", 
                            button2);
  g_signal_connect (G_OBJECT(button2), "clicked", 
  G_CALLBACK(close_dlg), GINT_TO_POINTER(1));

  g_signal_connect (G_OBJECT(button1), "clicked", 
            G_CALLBACK(ok_fourier), NULL);

  gtk_widget_show (window1);

  return window1;
}

void open_fourier_dlg(GtkWidget *item, gpointer data)
{
     GtkWidget *label;
     char info[90];
     int nadd;
  
     c_prefourier(&nats, &nadd);
     if(fourier_dialog == NULL)
           fourier_dialog = create_fourier();
     gtk_widget_show(fourier_dialog);
     finestra_modale_aperta2(fourier_dialog);

     ScriviStringa(info, sizeof(info),
             " Info: %d atoms in current model", nats); 
     label = get_widget(fourier_dialog, "info");
     gtk_label_set_text(GTK_LABEL(label), info);

     label = get_widget(fourier_dialog, "add");

     spin_button_set_value(label, (float)nadd);
}
/*****************************************************************/
/*              R E S T A R T                                    */
/*****************************************************************/

int   *ivtrial;
int   *ivset;
float *cfomvalue;
int   *ivdone;
float *rfvalue;
int    bestset;
const char *str_restart[] = { "RBM", "Fourier recycling", "E-map", "COVMAP"};
int   Nstr = (int)(sizeof(str_restart)/sizeof(str_restart[0]));

void c_finishrestart (int kproc)
{
     GtkWidget *tb;
     tb = lookup_widget(finestre[0], "toolbar_main");
//     fortran_al_lavoro();
     abilitamb(finestre[0], 0);
     abilitatb(tb, 0);
     finishrestart_( ivtrial, &kproc, ivset, cfomvalue, ivdone, rfvalue, &bestset);
     abilitamb(finestre[0], 2);
     abilitatb(tb, 2);
}


void c_recycle (GtkWidget *item,  gpointer data)
{
       //GtkWidget *tb;

//corr       abilitamb(finestre[0], 0);
//corr       tb = lookup_widget(finestre[0], "toolbar_main");
//corr       abilitatb(tb, 0);
//       fortran_al_lavoro();
       elaborazione_in_corso();
       recycle_();
       fine_elaborazione();
//       fine_lavoro();
//corr       abilitamb(finestre[0], 2);
//corr       abilitatb(tb, 2);
       if (cplotok->kexitrun==1) gtk_main_quit();   // ho dato 'exit' prima della fine del recycle
}

void get_all_selected_trials(int ntrials, GtkWidget *list)
{
   GtkTreeIter iter;
   gboolean fixed;
   int i = 0;

   GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));

   gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
   while (valid && (i<ntrials))
   {
       gtk_tree_model_get (model, &iter, 0, &fixed, -1);
       valid = gtk_tree_model_iter_next (model, &iter);
       ivtrial[i++] = fixed;
    }
}

void riempilistaTrials(GtkTreeView *list, int numval, int ifClear)
{
    GtkTreeModel *model = gtk_tree_view_get_model(list);
    GtkListStore *list_store = GTK_LIST_STORE(model);
    GtkTreeIter iter;
    int i;

    if(ifClear)
    {
       gtk_list_store_clear(GTK_LIST_STORE(list_store));
       for(i=0; i<numval; i++)
       {
           std::string strdone;
           std::stringstream os;
           std::stringstream os2;
           if(ivdone[i])
           {
              strdone = " yes";
              os2 << std::fixed << std::setw(7) << std::setprecision(3) 
              << std::right << rfvalue[i];
           }
           else
           {
              strdone = " no ";
              os2 << "   -   ";
           }
           os << std::fixed << std::setw(7) << std::setprecision(3) 
              << std::right << cfomvalue[i];
           gtk_list_store_append (list_store, &iter);
           gtk_list_store_set (list_store, &iter, 0, ivtrial[i], 
                   1, ivset[i], 2, os.str().c_str(), 3, strdone.c_str(), 
                   4, os2.str().c_str(), -1);
       }
    }
    else
    {
       gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
       i = 0;
       while (valid)
       {
           std::string strdone;
           std::stringstream os;
           gboolean fixed;
           if(ivdone[i])
              strdone = "yes";
           else
              strdone = "no ";
           if(ivdone[i])
           {
              strdone = "yes";
              os << std::setw(7) << std::setprecision(5) << std::right << rfvalue[i];
           }
           else
           {
              strdone = "no ";
              os << "   -   ";
           }
           gtk_tree_model_get (model, &iter, 0, &fixed, -1);
           gtk_list_store_set (GTK_LIST_STORE (model), &iter, 0, ivtrial[i], 
                     3, strdone.c_str(), 4, os.str().c_str(), -1);
           valid = gtk_tree_model_iter_next (model, &iter);
           i++;
       }
   }
}

void reopen_window(GtkWidget *dlg)
{
   GtkWidget *list = get_widget(dlg, "listaTrials");

   GtkWidget *button = get_widget(dlg, "check_trial");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), false);

   int nset = n_children(list);
   riempilistaTrials( GTK_TREE_VIEW(list), nset, 1);  //0);
   select_row(list, bestset-1);
   gtk_widget_show(dlg);
   finestra_modale_aperta2(dlg);
}

namespace GLextmr
{
   void updateModify(int val);
}

void cancel_restart (GtkButton *button, gpointer user_data)
{
    close_dlg(button, GINT_TO_POINTER(1));
    GLextmr::updateModify(1);
}

void ok_restart (GtkButton *button, gpointer user_data)
{
    GtkWidget *window, *check;
    int kproc = 0;

    window = gtk_widget_get_toplevel(GTK_WIDGET(button));

    for(int i=0; i<Nstr; i++)
    {
       check = get_widget(window, str_restart[i]);
       if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check)))
       {
           kproc = i+1;
           break;
       }
    }

//--leggo lo stato dei check
    int ntrials = n_children(get_widget(window, "listaTrials"));
    get_all_selected_trials(ntrials, get_widget(window, "listaTrials"));
//    fortran_al_lavoro();
    elaborazione_in_corso();
    gtk_widget_hide (window);
    finestra_modale_chiusa2();

    c_finishrestart (kproc);
    abilitamb(finestre[0], 2);
//    fine_lavoro();
    fine_elaborazione();
    reopen_window(window);
}


static void   on_select_restart (GtkTreeSelection *selec, gpointer data)
{
   int sel, pos, SelectedTrial;
   GtkTreeModel *model;
   GtkTreeIter iter;
   GtkWidget *dlg = (GtkWidget *) data;

   sel = gtk_tree_selection_get_selected (selec, &model, &iter);
   pos = -1;
   if(sel)
      pos = row_selected(selec);
/* pos indica il numero d'ordine nella lista                 */
   SelectedTrial = pos + 1 ;
   if(SelectedTrial > 0)
   {
      g_object_set_data(G_OBJECT(dlg), "lastsel", GINT_TO_POINTER(pos));
      trialselected_(&SelectedTrial);
   }

}

void on_change_restart (GtkToggleButton *togglebutton, gpointer user_data)
{
    int val;
    GtkWidget *dlg;
    GtkWidget *frame;
    GtkWidget *newt;
    GtkWidget *label;


        if(gtk_toggle_button_get_active(togglebutton))
        {
           val = GPOINTER_TO_INT(user_data);
           dlg   = gtk_widget_get_toplevel (
                   GTK_WIDGET(togglebutton));
           frame = get_widget(dlg, "frameOldTrials");
           newt   = get_widget(dlg, "newtrials");
           label = get_widget(dlg, "labelnew");

           switch(val)
           {
           case 0:        /* old */
                gtk_widget_set_sensitive(frame, TRUE);
                gtk_widget_set_sensitive(newt, FALSE);
                gtk_widget_set_sensitive(label, FALSE);
                break;
           case 1:        /* new */
                gtk_widget_set_sensitive(frame, FALSE);
                gtk_widget_set_sensitive(newt, TRUE);
                gtk_widget_set_sensitive(label, TRUE);
                break;
           }
        }
}

static void fixed_toggled(GtkCellRendererToggle *cell, gchar *path_str, gpointer data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;

  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, 0, &fixed, -1);

  fixed ^= 1;
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, 0, fixed, -1);
  gtk_tree_path_free (path);
}

GtkWidget *createlistaTrials(GtkWidget *parent, GtkWidget *parentbox,
                             const char *id)
{  
 GtkWidget *scrollwin, *dirsel, *frame;
 GtkListStore *store;
 GtkCellRenderer *renderer;
 GtkTreeViewColumn *column;
 GType types[] = {G_TYPE_BOOLEAN, G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING};
 PangoFontDescription *fontlist =  get_fontN(MONOSPACE_FONT);
 static const char *title[] = {"Set", " cfom", "done", "   RF  "};

  frame = gtk_frame_new(NULL);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  if(parentbox)
  {
     if (GTK_IS_BOX(G_OBJECT(parentbox)))
         gtk_box_pack_start (GTK_BOX (parentbox), frame, TRUE, TRUE, 0);
     else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
         gtk_container_add(GTK_CONTAINER(parentbox), frame);
  }
  gtk_widget_show (frame);

  scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add(GTK_CONTAINER(frame), scrollwin);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);
  dirsel = gtk_tree_view_new();
  g_object_set_data(G_OBJECT(dirsel), "formato", GINT_TO_POINTER(3));
  g_object_set_data(G_OBJECT(dirsel), "frame", frame);
  g_object_set_data(G_OBJECT(dirsel), "scrollwin", scrollwin);

  store = gtk_list_store_newv(sizeof(types)/sizeof(types[0]), types);
  renderer = gtk_cell_renderer_toggle_new ();
  column = gtk_tree_view_column_new_with_attributes ("Develop\ntrial",
            renderer, "active", 0, NULL);
  g_object_set_data(G_OBJECT(dirsel), "togglerenderer", renderer);
  gtk_tree_view_column_set_clickable(column, FALSE);
  gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
  gtk_tree_view_column_set_resizable (column, TRUE);
//  gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
//                                   GTK_TREE_VIEW_COLUMN_FIXED);
//  gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), 60);
  gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column);
  g_signal_connect (renderer, "toggled", G_CALLBACK (fixed_toggled),
          GTK_TREE_MODEL(store));


  for(int i=0; i< (int) (sizeof(title)/sizeof(title[0])); i++)
  {
     renderer = gtk_cell_renderer_text_new ();
     g_object_set (GTK_CELL_RENDERER (renderer),
                "font-desc", fontlist, NULL);
     column = gtk_tree_view_column_new_with_attributes (title[i],
               renderer, "text", i+1, NULL);
     gtk_tree_view_column_set_clickable(column, FALSE);
     gtk_tree_view_column_set_resizable (column, TRUE);
//  gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
     gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
//     label = LABEL_BOLD_WITH_FONT(title[i], NULL, 0.99f, fontlist);
//     gtk_widget_show (label);
//     gtk_tree_view_column_set_widget(column, label);
  }

  gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
  g_object_set_data(G_OBJECT (parent), id, dirsel);
  gtk_widget_show (dirsel);
  gtk_container_add (GTK_CONTAINER (scrollwin), dirsel);

  return dirsel;
}

void check_all_trials(GtkToggleButton *button, GtkWidget *list)
{
   gboolean active = gtk_toggle_button_get_active(button);
   GtkTreeIter iter;
   gboolean fixed;
   
   GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));

   gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
   int i = 0;
   while (valid)
   {
       gtk_tree_model_get (model, &iter, 0, &fixed, -1);
       if(!active)
          gtk_list_store_set (GTK_LIST_STORE (model), &iter, 0, FALSE, -1);
       else     // lo attiva solo se non e' gia' stato fatto
          gtk_list_store_set (GTK_LIST_STORE (model), &iter, 0, !ivdone[i], -1);
       valid = gtk_tree_model_iter_next (model, &iter);
       i++;
    }
}

GtkWidget* create_restart (int kproc)
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *frame3;
  GtkWidget *list1;
  GtkWidget *radiobutton;
  GtkWidget *button1;
  GtkWidget *button2;
  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  int larg, alt;
  GSList *radio_group = NULL;

  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "Explore trials");
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));
  g_object_set_data(G_OBJECT (window1), "vbox1", vbox1);

  frame3 = FRAME_NEW("Fourier Procedures", MyBLUE);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, FALSE, FALSE, 0);
  gtk_widget_show (frame3);

  hbox1 = hbox_new(FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame3), hbox1);
  
  for(int i=0; i<Nstr; i++)
  {
      radiobutton = RADIO_BUTTON_WITH_LABEL(radio_group, str_restart[i], NULL);
      g_object_set_data (G_OBJECT (window1), str_restart[i], radiobutton);
      radio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
      gtk_widget_show (radiobutton);
      gtk_box_pack_start (GTK_BOX (hbox1), radiobutton, TRUE, TRUE, 4);
      if(i == (kproc-1))
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
  }
  gtk_widget_show_all (hbox1);
//
//--frame per scrivere i new trials
//
  frame3 = vbox_new(FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "frameOldTrials", frame3);

  gtk_widget_show (frame3);

  GtkWidget *label = CHECK_BUTTON_WITH_LABEL ("Select all new trials", MyBLUE);
  gtk_widget_show_all(label);
  g_object_set_data (G_OBJECT (window1), "check_trial", label);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 4);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, TRUE, TRUE, 4);

//
//-------lista Trials
//
  list1 = createlistaTrials (window1, frame3, "listaTrials");
  get_metrics(fontlist, &larg, &alt);
  gtk_widget_set_size_request(get_widget(list1, "scrollwin"),30*larg+50,200);
  set_selection_mode(list1, GTK_SELECTION_SINGLE);
  gtk_widget_show (list1);
  g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(check_all_trials), list1);

//
//--crea il tasto go
//
  button1 = xpm_button ("go.xpm");
  g_object_set_data (G_OBJECT (window1), "button1", button1);
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, 1);

//
//--crea il tasto cancel
//
  button2 =  QUIT_button();
  g_object_set_data (G_OBJECT (window1), "button2", button2);
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
         GTK_BUTTONBOX_SPREAD);

  statofinale[0] = 2;

//
//--funzioni del tasto cancel
//
  g_object_set_data (G_OBJECT (window1), "cancel_button", button2);
  g_signal_connect (G_OBJECT(button2), "clicked", 
                      G_CALLBACK(cancel_restart), NULL);
  g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2)); 
  g_signal_connect (G_OBJECT (window1), "delete_event",
        G_CALLBACK(true_cb), NULL);

//
//--funzioni del tasto go
//
  g_signal_connect_swapped (G_OBJECT(button1), "clicked", 
                      G_CALLBACK(ok_restart), G_OBJECT(window1));
//
//--funzioni della selezione delle righe di soluzioni
//
 g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (list1))),
        "changed", G_CALLBACK(on_select_restart), (gpointer) window1);

  return window1;
}

extern "C" void open_restart_(int *ke, int *ns, int ivs[], float cfom[], int ivd[], float rfv[], int *bs)
{
     bool ifirst = false;
     int kproc = *ke;
     int nset = *ns;
     GtkWidget *list1;
     ivset = g_new0(int, nset);
     cfomvalue = g_new0(float, nset);
     ivdone = g_new0(int, nset);
     rfvalue = g_new0(float, nset);
     ivtrial = g_new0(int, nset);
     bestset = *bs;
     for(int i=0; i<nset; i++)
     {
         ivtrial[i]   = 0;
         ivset[i]     = ivs[i];
         cfomvalue[i] = cfom[i];
         ivdone[i]    = ivd[i];
         rfvalue[i]   = rfv[i];
     }

    if(restart_dialog == NULL)
    {
       restart_dialog = create_restart(kproc);
       ifirst = true;
    }
    gtk_widget_show(restart_dialog);
    finestra_modale_aperta2(restart_dialog);
/* Recuperiamo la lista trials */
    list1 = get_widget(restart_dialog, "listaTrials");
    riempilistaTrials( GTK_TREE_VIEW(list1), nset, 1);
    if(ifirst)
       select_row(list1, bestset-1);
    else
       select_row(list1, get_int(restart_dialog, "lastsel"));
    list1 = get_widget(restart_dialog, str_restart[kproc-1]);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(list1), TRUE);
}

void c_restart (GtkWidget *item,  gpointer data)
{
    GLextmr::updateModify(0);
    restart_();
}

void c_random (GtkWidget *item,  gpointer data)
{
    randomsolve_();
}
