#include "mrconfig.h"
#include "forcomm2.h"
#include "callbacks.h"
#include "aliasx.h"
//#include "forcomm1.h"
#include "cry.h"
Crystal *crys;
Dataset *dataset;
extern char *fontn;
extern plotok *cplotok;
extern GdkColor *LIGHTRED, *LIGHTBLUE, *BLACK;
extern GdkColor color[MAX_COLORS]; 
extern _Dialogo *dialogo;
extern GtkWidget *finestre[6];
extern int win_stack;

static GtkWidget *rietveld_dialog = NULL;

void page_general(GtkWidget *notebook, GtkWidget *rietveld_dlg);
void page_cell(GtkWidget *notebook, GtkWidget *rietveld_dlg);
void page_crystal(GtkWidget *notebook, GtkWidget *rietveld_window, int ph);
void page_profile(GtkWidget *notebook, GtkWidget *rietveld_window, int ph);
void page_PO(GtkWidget *notebook, GtkWidget *rietveld_window, int ph);
void page_background(GtkWidget *notebook, GtkWidget *rietveld_dlg);
int SpecFromAtm(atom_type atm[], std::vector<int> &specv, int nats);
extern "C" void get_constraints_(int *ph);
extern "C" void put_num_constraints_(int *num_c, int *ph, int *rm, float *adp);
extern "C" void put_constr_(int *code, int *npar, int *ref, int *vpar, int *vat, float *coef, float *sumc, int *kc, int *typec, int *npari, int *ph);
extern "C" void puntibg_(int *flag);
void combo_changed(GtkWidget *combo, GCallback cb, gpointer cb_data);
void       c_disegna_interval         (int *val, int kdraw);

static const char *labelcell[] = {"a:", "b:", "c:","alpha:", "beta:", "gamma:"};
static const char *labels_auto[] = {"Automatic refinement of profile", "Automatic refinement of structure"};
                               
static const char *labelsOP[] = {"h", "k", "l", "G factor", "Fraction"};

static const char *pesi_riet[] = {"#  1 : W=1.0", "#  2 : W=1.0/Count", "#  3 : W=1.0/Count^2"};

static const char *parametri[5] = {"x","y","z","B[iso]","Occ."};

static const char *label_back[] =  { "Polynomial","Chebyshev", "Cosine Fourier series"};

static const char *label_profile[] =  { "Pearson VII","Pseudo-Voigt","TCH pseudo-Voigt"};
#define NFPROF sizeof(label_profile)/sizeof(label_profile[0])
#define HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)
#define HOOKUP_OBJECT_REF(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    g_object_ref (G_OBJECT(widget)), (GDestroyNotify) g_object_unref)

#define ENTRY_SIZE  65
#define ASYM1 6
int dime_riet;
static std::vector<int> specv;
//static int   no[NUMSPECIES];
//static int Specie_active[NUMSPECIES];
static int ncoeff[] = { 12, 36, 12 };
 

/*****************************************************************/
/*              R I E T V E L D                                  */
/*****************************************************************/

enum Pages { GEN, PROF, CELLA, NPAGES };
#define MAXCOEF 36

//corrtypedef struct {
//corr     float ttmin;    // 2theta minimo usato
//corr     float ttmax;    // 2theta massimo usato
//corr     int   nreftot;  // num. totale di riflessi
//corr     int   nrefu;    // num. di riflessi usati
//corr     int   nri;      // primo riflesso usato
//corr     int   nrf;      // ultimo riflesso usato
//corr     int   nctot;    // num. totale di conteggi
//corr     int   ncu;      // num. di conteggi usati
//corr     int   nci;      // primo conteggio usato
//corr     int   ncf;      // ultimo conteggio usato
//corr               }  ref_limit_type;

typedef struct {
//corr     ref_limit_type   lim;           // info sui limiti di affinamento
     int              algo;          // tipo di algoritmo di l.sq.
//     int              typeback;      // tipo di background
//     int              typefun;       // tipo di funzione di profilo
//     int              nback;         // num. di coefficienti di background
     int              auto_coefb;    // selezione automatica del numero di coeff. di backgr.?
     int              auto_prof;     // affinamento automatico profilo
     int              auto_stru;     // affinamento automatico struttura
     int              ncauto;        // num. di cicli di affinamento automatico
     int              winmess;       // messagistica attiva?
     int              typewei;       // schema di pesaggio
     float            eps;           // criterio di convergenza
     int              maxcy;         // numero massimo di cicli di affinamento
     int              raction;       // 0=Rietveld 1=Le Bail 2=Pawley
     char             sprint[6];     // V=verbose,S=small,C=correlation,E=st.dev.,M=lsq matrices,W=window per chi
     //int              riding_model;
     //float            adp_factor;
                } refine_condition_type;

typedef struct {
     int        refine_cell;
//     int        refine_structure;
     int        refine_profile;
     float      dw; 
     float      rp;
     float      rwp;
     int        npar;
               } refine_info_type;
/*
typedef struct  {
     float             val;    // valore del parametro
     int               rcod;   // posizione nella matrice jac. del parametro se affinato; 0 se non affinato
     char              str[10];// stringa associata al parametro
                } r_param_type;

typedef struct  {
     r_param_type  u;
     r_param_type  v;
     r_param_type  w;
     r_param_type  b0;
     r_param_type  b1;
     r_param_type  b2;
     r_param_type  asym[4];
                } pearson_function_type;

typedef struct  {
     r_param_type  u;
     r_param_type  v;
     r_param_type  w;
     r_param_type  eta0;
     r_param_type  eta1;
     r_param_type  eta2;
     r_param_type  asym[4];
                } pvoigt_function_type;

typedef struct  {
     r_param_type  u;
     r_param_type  v;
     r_param_type  w;
     r_param_type  z;
     r_param_type  x;
     r_param_type  y;
     r_param_type  asym[4];
                 } tch_function_type;

#define PEARSON7  1
#define PVOIG     2
#define TCHZ      3

typedef struct  {
     int          ftype;
     r_param_type par[10];
                } profile_function_t;
*/
/*
typedef struct  {
     int     code;   // codice identificativo del tipo di
     int     *vpar;  // i parametri coinvolti
     int     *vat;   // gli atomi coinvolti
     float   *coef;  // coefficienti
     float   sumc;   // known term in constraint equation
     int     npar;   // numero totale di parametri coinvolti
     int     npari;  // numero di parametri indipendenti
     int     ref;    // codice di affinamento
     int     typec;  // settato da 1=user 2=programma
                } constraint_type;

typedef struct {
    int ph;          // fase cristallina 
    int katom;       // atomo 
    int kpar;        // parametro
               } constraint_ref;
*/
typedef struct {
    int btype;
    int autosel;
    int ncoef;
               } back_condition_type;

//atom_type *atm;
refine_condition_type refcond, refcond_back;
back_condition_type backriet, backriet_back;
refine_info_type rinfo;
//int nconstr;
//constraint_type *vconstr;
crystal_t *cryphC;
int *natomsC;
int *nelemC;
int numphC;

GtkWidget* create_rietveld (void);
GtkWidget *create_table_refine(r_param_type *paramv[], int nmix, int nfwhm1,
     int nfwhm2);
extern "C" void finishriet_glob_ (refine_condition_type *refc,
                  int *bcode, float *zero, int *zcode,
                  float *sdisp, int *sdcode,
                  float *tran, int *stcode,
                  back_condition_type *backr);
extern "C" void finishriet_ph_ (atom_type *atml, float *cell, int *cellcod,
                  float *scal, int *scalcod, profile_function_t *pe,
                  profile_function_t *pv,profile_function_t *tchh,
                  int *kopcorr, int *hklpo, float *gpar, int *gcode, int *ph);
extern "C" void ripassa_valori_glob_ (refine_condition_type *refc,
                  int *bcode, float *zero, int *zcode,
                  float *sdisp, int *sdcode,
                  float *tran, int *stcode,
                  back_condition_type *backr);
extern "C" void ripassa_valori_ph_(atom_type *atml, float cell[6],
                  int cellcod[6], float *scal, int *scalcod,
                  profile_function_t *pe, profile_function_t *pv,
                  profile_function_t *tchh,
                  int *kopcorr, int *hklpo, float *gpar, int *gcode, 
                  //int *rm, float *adp,
                  int *typefun, int *ph);
extern "C" void applyriet_(int *numph, int *modzero,int *modcell,int *modop,int *modxyz,int *modfun,int *modwei);
extern "C" void modify_background_(back_condition_type *backr, int *code);
extern "C" void rietveld_();
extern "C" void get_info_(refine_info_type *rinfol);
extern "C" void show_model_(int *ph);


GtkWidget *entry_for_refine(const char *str, float val, int rcod, const char *col)
{
   GtkWidget *label, *entry, *check, *table;
   char string[16];
   std::string str1 = str;
   std::string strnoblank = strstrip(str1);

   table = table_new(1,3,FALSE);
   table_set_col_spacings(table, 10);

   label = LABEL_NEW(strnoblank.c_str(), col);
   set_alignment(label, 0., 0.5);
//   gtk_widget_set_size_request(label, 40, 22);
   table_attach(table, label, 0, 1, 0, 1);
   g_object_set_data(G_OBJECT(table), "label", label);
   entry = gtk_entry_new();
//   gtk_widget_set_size_request(entry, (int) (1.5*ENTRY_SIZE), 22);
   set_width_chars(GTK_ENTRY(entry), 10);
   table_attach(table, entry, 1, 2, 0, 1);
   g_object_set_data(G_OBJECT(table), "entry", entry);
   ScriviStringa(string, sizeof(string), "%-12.6f", val);
   gtk_entry_set_text(GTK_ENTRY(entry), string);
   check = gtk_check_button_new();
   table_attach(table, check, 2, 3, 0, 1);
   g_object_set_data(G_OBJECT(table), "check", check);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), rcod);
   gtk_widget_show_all(table);

   return table;
}

char *greek(int i)
{
    gunichar car;
    char *str1= g_new0(char, 7);
    int newchr;

    newchr = Alpha + i;
    car = gdk_keyval_to_unicode(newchr);
    g_unichar_to_utf8(car, str1);
    AppendiStringa(str1, 7, ":");
    return str1;
}

void my_combo_set_val(GtkWidget *combo, int val)
{
     if(val < 1)
        return;
#ifndef GTK_COMBO_BOX
     gtk_list_select_item (GTK_LIST(GTK_COMBO(combo)->list), val-1);
#else
     gtk_combo_box_set_active(GTK_COMBO_BOX(combo), val-1);
#endif
}

void fill_my_combo(GtkWidget *combo, const char *labels[],
                              int nlabels, int def_b)
{
    int i;
    int hnd;

    hnd = get_int(combo, "hnd");
#ifndef GTK_COMBO_BOX
    if(hnd)
       g_signal_handler_block(G_OBJECT(GTK_COMBO(combo)->list), hnd);
  if(nlabels)
  {
      GList *combo_items = NULL;
      for(i=0; i<nlabels;i++)
      {
          combo_items = g_list_append (combo_items, labels[i]);
          g_object_set_data(G_OBJECT(combo),
            g_strdup_printf("%d",i), DuplicaStringa(labels[i]+1));
      }
      gtk_combo_set_popdown_strings (GTK_COMBO (combo), combo_items);
      g_list_free (combo_items);
      gtk_combo_disable_activate (GTK_COMBO(combo));
  }
    my_combo_set_val(combo, def_b);
    if(hnd)
       g_signal_handler_unblock(G_OBJECT(GTK_COMBO(combo)->list), hnd);
#else
    if(hnd)
       g_signal_handler_block(G_OBJECT(combo), hnd);
    for(i=0; i<nlabels; i++)
        combo_remove_text (combo);
    for(i=0; i<nlabels; i++)
    {
        combo_insert_text (combo, i, labels[i]);
        g_object_set_data(G_OBJECT(combo),
            g_strdup_printf("%d",i), DuplicaStringa(labels[i]+1));
    }
    my_combo_set_val(combo, def_b);
    if(hnd)
       g_signal_handler_unblock(G_OBJECT(combo), hnd);
#endif
}

gboolean is_char_in(const char str[], const char c, int lunstr)
{
     int i;
     for(i=0; i<lunstr; i++)
     {
         if(str[i] == c)
            return true;
     }
     return false;
}

void add_c_to(char *str, char c, int lunstr)
{
     int i;
     for(i=0; i<lunstr; i++)
     {
	 if(str[i] == c)
            return;
      }
     for(i=0; i<lunstr; i++)
     {
	 if(str[i] == ' ')
         {
            str[i] = c;
	    return;
         }
      }
}

void setta_constraints(int ph)
{
     int i, code, npar, ref, typec, npari;
     float sumc;
     int nconstr = crys[ph].Nconstraints();
     int nph = ph + 1;
     int rm = crys[ph].RidingModel();
     float adp = crys[ph].ADP();
     put_num_constraints_(&nconstr, &nph, &rm, &adp);
     for (i=0; i<nconstr; i++)
     {
          code = crys[ph].Constr(i).code;
          npar = crys[ph].Constr(i).npar;
          ref  = crys[ph].Constr(i).ref;
          typec  = crys[ph].Constr(i).typec;
          npari  = crys[ph].Constr(i).npari;
          sumc = crys[ph].Constr(i).sumc;
          put_constr_(&code, &npar, &ref, crys[ph].Constr(i).vpar, crys[ph].Constr(i).vat, crys[ph].Constr(i).coef, &sumc, &i, &typec, &npari, &nph);
     }
}

void get_par_profile(int prof_func, int *nmix, int *nfwhm1, int *nfwhm2,
        r_param_type *param1[], int ph)
{
//
//---A partire da tipo di funzione, determina il numero di mixing parameters, di fwhm1 parameters e
//   di fwhm2 parameters; inoltre riempie il vettore param1 con i 'valori' (tripletta stringa+valore+
//   codice affinamento) relativi. Nell'ultima posizione del vettore c'e' asym.
//
   switch(prof_func)
   {
   default:
   case 1:
        *nmix = 3;
        *nfwhm1 = 3;
        *nfwhm2 = 0;
        for(int i=0; i<10; i++)
            param1[i] = &(dataset[0].pear[ph].par[i]);
        //param1[0] = &pear.b0;
        //param1[1] = &pear.b1;
        //param1[2] = &pear.b2;
        //param1[3] = &pear.u;
        //param1[4] = &pear.v;
        //param1[5] = &pear.w;
        //param1[9] = &pear.asym[0];
        break;
   case 2:
        *nmix = 3;
        *nfwhm1 = 3;
        *nfwhm2 = 0;
        for(int i=0; i<10; i++)
            param1[i] = &(dataset[0].pvoi[ph].par[i]);
        //param1[0] = &pvoi.eta0;
        //param1[1] = &pvoi.eta1;
        //param1[2] = &pvoi.eta2;
        //param1[3] = &pvoi.u;
        //param1[4] = &pvoi.v;
        //param1[5] = &pvoi.w;
        //param1[9] = &pvoi.asym[0];
        break;
   case 3:
        *nmix = 0;
        *nfwhm1 = 4;
        *nfwhm2 = 2;
        for(int i=0; i<10; i++)
            param1[i] = &(dataset[0].tch[ph].par[i]);
        //param1[0] = &tch.u;
        //param1[1] = &tch.v;
        //param1[2] = &tch.w;
        //param1[3] = &tch.z;
        //param1[4] = &tch.x;
        //param1[5] = &tch.y;
        //param1[9] = &tch.asym[0];
        break;
   }
}

void FillAtomicParameters(GtkWidget *window1, int ph=0)
{
  GtkWidget *entry;
  GtkWidget *checkbutton;
  char val[20];
  char string[30];
  int i,j,kconstr;

  for(i=0; i<5; i++)
  {
      for (j=0;j<crys[ph].GetNats();j++)
      {
          if(i < 3)
             ScriviStringa(val,sizeof(val), "%-12.6f",crys[ph].GetAtom(j).xc[i]);
          else if(i == 3)
             ScriviStringa(val,sizeof(val), "%-12.6f",crys[ph].GetAtom(j).biso);
          else
             ScriviStringa(val,sizeof(val), "%-12.6f",crys[ph].GetAtom(j).och);
          ScriviStringa(string,sizeof(string), "entrystru%d%d_",j,i);
          entry = get_widget_num(window1,string, ph);
          kconstr = crys[ph].par_in_constraint(j+1, i+1);
          if(kconstr)
          {
             //set_text_color(entry, "lightblue");
             set_text_color(entry, "#0000FF");
             gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
          }
          else
          {
             if(crys[ph].GetAtom(j).rcod[i] >= 0)
             {
                set_text_color(entry, "black");
                gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
             }
             else
             {
                set_text_color(entry, "red");
                gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
             }
          }
          gtk_entry_set_text(GTK_ENTRY(entry), val);
      }
  }
  for(j=0;j<crys[ph].GetNats();j++)
  {
      gboolean c_active = FALSE;
      int c_sensitive = 0;
      for(i=0; i<5; i++)
      {
          kconstr = crys[ph].par_in_constraint(j+1, i+1);
          if(i >= 3)
          {
             ScriviStringa(string,sizeof(string), "checkstru%d%d_",j,i);
             checkbutton = get_widget_num(window1,string, ph);
             if(crys[ph].GetAtom(j).rcod[i] >= 0)
             {
                gtk_widget_set_sensitive(checkbutton, TRUE);
                if(kconstr)
                   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), crys[ph].Constr(kconstr-1).ref);
                else
                   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), (crys[ph].GetAtom(j)).rcod[i]);
             }
             else
             {
                gtk_widget_set_sensitive(checkbutton, FALSE);
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), FALSE);
             }
          }
          else
          {
             ScriviStringa(string,sizeof(string), "checkstru%d2_",j);
             checkbutton = get_widget_num(window1,string, ph);
             if(crys[ph].GetAtom(j).rcod[i] > 0)
             {
                c_active = TRUE;
                c_sensitive = TRUE;
             }
             else if(crys[ph].GetAtom(j).rcod[i] == 0)
             {
                c_sensitive = TRUE;
                if(kconstr)
                {
                   if(crys[ph].Constr(kconstr-1).ref)
                      c_active = TRUE;
                }
             }
             if(i == 2)
             {
                gtk_widget_set_sensitive(checkbutton, c_sensitive);
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), c_active);
             }
          }
      }
  }
}

int get_combo_sel(GtkWidget *wid)
{
   int val = 0;
//
// determino quale riga del combo e' stata selezionata
//
#ifndef GTK_COMBO_BOX
      int i;
      GtkWidget *entry;
      if(GTK_IS_ENTRY(wid))
         entry = wid;
      else
         entry = get_widget(wid, "entry");
      const gchar *ent = gtk_entry_get_text(GTK_ENTRY(entry));
      for(i=0; i<(int)(NFPROF); i++)
          if(strcmp(label_profile[i], ent) == 0)
             val = i;
#else
     val = gtk_combo_box_get_active(GTK_COMBO_BOX(wid));
     if(val == -1)
        val = 0;
#endif
     return val;
}

std::string rtz(std::string str)
{
// remove trailing zeros
  std::string::size_type found = str.find_last_not_of("0 ");
  if (found!=std::string::npos)
    str.erase(found+1);
  else
    str.clear();

   return str;
}

int check_modi(char *string, float *val)
{
    char stst[30];
    std::string str1(string);
    str1 = trim(str1);
    std::string strinp = rtz(str1);
    ScriviStringa(stst, sizeof(stst), "%-12.6f", *val);
    g_strstrip(stst);
    std::string str2(stst);
    std::string strval = rtz(str2);
    if(strinp.compare(strval) == 0)
       return 0;
    else
    {
       //cout << "strval:" << strinp << " val:" << strval << endl;
       *val = (float) atof(strinp.c_str());
       return 1;
    }
}

void GetInfo()
{
   refine_info_type rinfol;
   GtkWidget *label;

   get_info_(&rinfol);
   rinfo = rinfol;
   label = get_widget(rietveld_dialog, "Info");
   gtk_label_set_text(GTK_LABEL(label), g_strdup_printf("Rp  = %.3f        Rwp = %.3f", rinfo.rp, rinfo.rwp));
}

atom_type *recupera_info(int ph, r_param_type *scalr, r_param_type cell1[])
{
//adattamento alle variabili precedenti;
   atom_type *atm1 = crys[ph].GetAtoms();
   scalr->val = crys[ph].GetScale();
   scalr->rcod = crys[ph].SC();
   for(int j=0; j<6; j++)
   {
       cell1[j].val  = crys[ph].GetCell(j);
       cell1[j].rcod = crys[ph].GetCellCod(j);
   }
   return atm1;
//
}

int cApply(void)
{
    int nselection = 0;
    int i, j, iactive, prof_func, modi_prof, modi_op, modi_cell, modi_stru;
    int nmix, nfwhm1, nfwhm2, kconstr;
    GtkWidget *add, *checkbutton, *table, *entry;
    char stringa[30];
    char *string;
    r_param_type *paramv[10];
    int modzero = 0, modwei = 0;
    int *modcell = g_new0(int, numphC), *modxyz = g_new0(int, numphC);
    int *modop = g_new0(int, numphC), *modfun = g_new0(int, numphC);
    

//
//--Numero di cicli (automatic procedures)
//
    add = get_widget(rietveld_dialog, "nautocycles");
    refcond.ncauto = spin_button_get_value_as_int(add);
//
//--Numero di cicli
//
    add = get_widget(rietveld_dialog, "ncycles");
    refcond.maxcy = spin_button_get_value_as_int(add);
//
//--Criterio di convergenza
//
    add = get_widget(rietveld_dialog, "digits");
    refcond.eps = (float) pow(10,-spin_button_get_value(add));
//
//--Schema di pesaggio
//
    if (refcond.typewei != dime_riet)
    {
        refcond.typewei = dime_riet;
         modwei = 1;
    }
//
//--- Radio per LeBail
//
    refcond.raction = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(
            get_widget(rietveld_dialog, "radioleb")));
//
//--Automatic procedures
//
    checkbutton = get_widget(rietveld_dialog, labels_auto[0]);
    refcond.auto_prof = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton));
    checkbutton = get_widget(rietveld_dialog, labels_auto[1]);
    refcond.auto_stru = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton));
//rimuoverebbe l'inizializzazione del fortran
//corr    for(i=0; i<=6; i++)
//corr        refcond.sprint[i] = ' ';
    if (refcond.auto_prof > 0) nselection++;
    if (refcond.auto_stru > 0) nselection++;
//
//--Attivare la visualizzazione grafica dell' andamento dell' Rwp
//
//    add = get_widget(rietveld_dialog, "view_graph");
//    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(add)))
//        add_c_to(refcond.sprint, 'W', sizeof(refcond.sprint));
//
// PrintOptions
//
   checkbutton = get_widget(rietveld_dialog, "printM");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)))
        add_c_to(refcond.sprint, 'M', sizeof(refcond.sprint));
   checkbutton = get_widget(rietveld_dialog, "printC");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)))
        add_c_to(refcond.sprint, 'C', sizeof(refcond.sprint));
   checkbutton = get_widget(rietveld_dialog, "printV");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)))
        add_c_to(refcond.sprint, 'V', sizeof(refcond.sprint));
   checkbutton = get_widget(rietveld_dialog, "printS");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)))
        add_c_to(refcond.sprint, 'S', sizeof(refcond.sprint));
   checkbutton = get_widget(rietveld_dialog, "printE");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)))
        add_c_to(refcond.sprint, 'E', sizeof(refcond.sprint));
//
//--Background
//
   checkbutton = get_widget(rietveld_dialog, "check_background");
   iactive = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton));
   dataset[0].bcode = iactive;
   if (iactive > 0) nselection++; 
//
// Zero
//
   entry = get_widget(rietveld_dialog, "Zero");
   string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
   modzero = check_modi(string, &(dataset[0].zero));
   checkbutton = get_widget (rietveld_dialog, "check_zero");
   dataset[0].zcode = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton));
   if (dataset[0].zcode > 0) nselection++;

   entry = get_widget(rietveld_dialog, "tran");
   string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
   modzero += check_modi(string, &(dataset[0].stran));
   checkbutton = get_widget (rietveld_dialog, "check_tran");
   dataset[0].stcode = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton));
   if (dataset[0].stcode > 0) nselection++;

   entry = get_widget(rietveld_dialog, "disp");
   string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
   modzero += check_modi(string, &(dataset[0].sdisp));
   checkbutton = get_widget (rietveld_dialog, "check_disp");
   dataset[0].sdcode = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton));
   if (dataset[0].sdcode > 0) nselection++;

// Per i valori seguenti bisogna far riferimento alla fase cristallina
   for(int ph=0;ph<numphC; ph++)
   {
     float val;
     int result;
//
//   orientazione preferenziale
//
     modi_op = 0;
     for(i=1; i<=3; i++)        
     {
       ScriviStringa(stringa,sizeof(stringa), "entryHKL%d_", i);
       entry = get_widget_num(rietveld_dialog, stringa,ph);
       string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
       if(atoi(string) != crys[ph].HKLpo(i-1))
       {
          modi_op++;
          crys[ph].SetHKLpo(i-1, atoi(string));
       }
     }
     entry = get_widget_num (rietveld_dialog, "entryG1_", ph);
     string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
     val = crys[ph].Gpar();
     result = check_modi(string, &(val));
     modi_op += result;
     if(result)
        crys[ph].SetGpar(val);
     checkbutton = get_widget_num(rietveld_dialog, "checkG1_", ph);
     crys[ph].SetGcod(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)));
     modop[ph] = (modi_op > 0);
     if (crys[ph].Gcod() == 0 && MRabs(crys[ph].Gpar() - 1.000000) < 0.0001)
         crys[ph].SetKopcorr(0);
     else
         crys[ph].SetKopcorr(1);
     if (crys[ph].Gcod() > 0) nselection++;

//
//   Parametri di profilo
//
     modi_prof = 0;
     prof_func = get_combo_sel(get_widget_num(rietveld_dialog, "profile_func",ph)) + 1;
     if(prof_func != dataset[0].typefun[ph])
        modi_prof++;
     dataset[0].typefun[ph] = prof_func;
     get_par_profile(prof_func, &nmix, &nfwhm1, &nfwhm2, paramv,ph);
     ScriviStringa(stringa,sizeof(stringa), "table_%d_", prof_func);
     table = get_widget_num(rietveld_dialog, stringa,ph);
     for(i=1; i<=nmix+nfwhm1+nfwhm2; i++)   
     {
       ScriviStringa(stringa,sizeof(stringa), "entryprof%d", i);
       entry = get_widget(table, stringa);
       string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
       modi_prof += check_modi(string, &(paramv[i-1]->val));
       ScriviStringa(stringa,sizeof(stringa), "checkprof%d", i);
       checkbutton = get_widget(table, stringa);
       paramv[i-1]->rcod = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton));
       if (paramv[i-1]->rcod > 0) nselection++;
     }
     for(int ia=0; ia<4; ia++)
     {
         entry = get_widget_num(table, "entryasym",ia);
         string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
         modi_prof += check_modi(string, &(paramv[ia+ASYM1]->val));
         checkbutton = get_widget_num(table, "checkasym",ia);
         paramv[ia+ASYM1]->rcod = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton));
         if (paramv[ia+ASYM1]->rcod > 0) nselection++;
     }
     modfun[ph]  = (modi_prof > 0);
//
//   Scala
//
     modi_cell = 0;
     entry = get_widget_num(rietveld_dialog, "entryscalr", ph);
     string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
     val = crys[ph].GetScale();
     result = check_modi(string, &val);
     modi_cell += result;
     if(result)
        crys[ph].SetScal(val);
     checkbutton = get_widget_num (rietveld_dialog, "checkscalr", ph);
     crys[ph].SetScalCod(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)));
     if (crys[ph].SC() > 0) nselection++;

     //modfun = (modi_prof > 0);
//
//   Parametri di cella 
//
     for(i = 0; i<6; i++)
     {
       entry = get_widget_num(rietveld_dialog, labelcell[i], ph);
       if(crys[ph].GetCellCod(i) >= 0)
       {
          entry = get_widget_num(rietveld_dialog, labelcell[i], ph);
          string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
          val = crys[ph].GetCell(i);
          result = check_modi(string, &val);
          modi_cell += result;
          if(result)
             crys[ph].SetCell(i, val);
          ScriviStringa(stringa,sizeof(stringa), "checkcell%d_",i);
          checkbutton = get_widget_num(rietveld_dialog, stringa, ph);
          crys[ph].SetCellCod(i, gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)));
          if(crys[ph].GetCellCod(i) > 0) nselection++;
       }
     }
     modcell[ph] = (modi_cell > 0);
//
//   Parametri strutturali
//
     modi_stru = 0;
     for (i=0;i<crys[ph].GetNats();i++)
     {
         for (j=0;j<5;j++)
         {
             if((crys[ph].GetAtom(i)).rcod[j] >= 0)
             {
                ScriviStringa(stringa,sizeof(stringa), "entrystru%d%d_", i,j);
                entry = get_widget_num(rietveld_dialog, stringa, ph);
                string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
                if(j < 3)
                {
                   val = (crys[ph].GetAtom(i)).xc[j];
                   result = check_modi(string, &val);
                   if(result)
                     crys[ph].SetXC(val, i, j);
                   modi_stru += result;
                }
                else if (j == 3)
                {
                   val = (crys[ph].GetAtom(i)).biso;
                   result = check_modi(string, &val);
                   if(result)
                     crys[ph].SetBiso(val, i);
                   modi_stru += result;
                }
                else
                {
                   val = (crys[ph].GetAtom(i)).och;
                   result = check_modi(string, &val);
                   if(result)
                     crys[ph].SetOch(val, i);
                   modi_stru += result;
                }
                kconstr = crys[ph].par_in_constraint(i+1, j+1);
                if(j >= 3)
                   ScriviStringa(stringa,sizeof(stringa), "checkstru%d%d_",i,j);
                else
                   ScriviStringa(stringa,sizeof(stringa), "checkstru%d2_",i);
                checkbutton = get_widget_num(rietveld_dialog,stringa, ph);

                if(kconstr)
                {
                   crys[ph].SetRcod(0, i, j);
                   int valref = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton));
                   crys[ph].SetRefine(kconstr-1, valref);
                   if(valref > 0) nselection++;
                }
                else
                   crys[ph].SetRcod(
                     gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)),
                     i, j);
                if((crys[ph].GetAtom(i)).rcod[j] > 0) nselection++;
             }
         }
     }
     modxyz[ph] = (modi_stru > 0);
     setta_constraints(ph);
   }


   ripassa_valori_glob_(&refcond, &(dataset[0].bcode),
              &(dataset[0].zero), &(dataset[0].zcode), 
              &(dataset[0].sdisp), &(dataset[0].sdcode),
              &(dataset[0].stran), &(dataset[0].stcode),
              &backriet);
 
   for(int ph=1;ph<=numphC; ph++)
   {
       float scalr = crys[ph-1].GetScale();
       int scalcod = crys[ph-1].SC();
       int kopcorr = crys[ph-1].Kopcorr();
       float gpar = crys[ph-1].Gpar();
       int gcode = crys[ph-1].Gcod();
       //int rm = crys[ph-1].RidingModel();
       //float adp = crys[ph-1].ADP();
       ripassa_valori_ph_(crys[ph-1].GetAtoms(), crys[ph-1].Cell(), 
            crys[ph-1].CellCode(), &scalr, &scalcod, &(dataset[0].pear[ph-1]),
            &(dataset[0].pvoi[ph-1]), &(dataset[0].tch[ph-1]), &kopcorr,
            crys[ph-1].HKLpoV(), &gpar, &gcode, //&rm, &adp,
            &(dataset[0].typefun[ph-1]), &ph);
   }
   //applyriet_new_(&modzero,&modcell,&modop,&modxyz,&modfun,&modwei);
   applyriet_(&numphC,&modzero,modcell,modop,modxyz,modfun,&modwei);
   GetInfo();
   g_free(modcell);
   g_free(modop);
   g_free(modxyz);
   g_free(modfun);

   return nselection;
}
void aggiorna(int ph=0)
{
//   GtkWidget *checkbutton, *entry, *checkRp, *table;
   GtkWidget *checkbutton, *entry, *table;
   int i, iactive, nmix, nfwhm1, nfwhm2, k;
   char stringa[30]; 
   r_param_type *paramv[10];

//
//--- resatta toggle buttons
//
   checkbutton = get_widget_num(rietveld_dialog, "buttonpar0_", ph);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), FALSE);
   for (i=3;i<5;i++)
   {
        ScriviStringa(stringa,sizeof(stringa), "buttonpar%d_",i-2);
        checkbutton = get_widget_num(rietveld_dialog, stringa, ph);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), FALSE);
   }
   for (i=0;i<crys[ph].GetNelems();i++)
   {
       ScriviStringa(stringa,sizeof(stringa), "buttonspe%d_",i);
       checkbutton = get_widget_num(rietveld_dialog, stringa, ph);
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), FALSE);
   }
   for (i=0;i<crys[ph].GetNats();i++)
   {
       ScriviStringa(stringa,sizeof(stringa), "buttonlabel%d_",i);
       checkbutton = get_widget_num(rietveld_dialog, stringa, ph);
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), FALSE);
   }

//
//--- riempi frame dei parametri
//
   FillAtomicParameters(rietveld_dialog, ph);
//
// Parametri di cella 
//
   for(i = 0; i<6; i++)
   {
       ScriviStringa(stringa,sizeof(stringa), "checkcell%d_",i); 
       checkbutton = get_widget_num(rietveld_dialog, stringa, ph);
       entry = get_widget_num(rietveld_dialog, labelcell[i], ph);

       if(crys[ph].GetCellCod(i) >= 0)
       {
          gtk_widget_set_sensitive(checkbutton, TRUE);
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), crys[ph].GetCellCod(i));
          ScriviStringa(stringa, sizeof(stringa), "%-12.6f", crys[ph].GetCell(i));
          gtk_entry_set_text(GTK_ENTRY(entry), stringa);
          set_text_color(entry, "black");
          gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
       }
       else
       {
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), FALSE);
          gtk_widget_set_sensitive(checkbutton, FALSE);
          if((i==1) || (i==2))
              ScriviStringa(stringa, sizeof(stringa), " = a");
          else
              ScriviStringa(stringa, sizeof(stringa), "%-12.6f", crys[ph].GetCell(i));
          gtk_entry_set_text(GTK_ENTRY(entry), stringa);
          set_text_color(entry, "red");
          gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
       }
   }
//
// Profilo
// 
   get_par_profile(dataset[0].typefun[ph], &nmix, &nfwhm1, &nfwhm2, paramv,ph);
   ScriviStringa(stringa,sizeof(stringa), "table_%d_", dataset[0].typefun[ph]);
   table = get_widget_num(rietveld_dialog, stringa,ph);

//
//---Mixing
//

  k = 1;
  for(i = 0; i<nmix; i++)
  {
      r_param_type *param1 = g_new0(r_param_type, 1);
      memcpy(param1, paramv[i], sizeof(r_param_type));
      ScriviStringa(stringa,sizeof(stringa), "entryprof%d", k);
      entry = get_widget(table, stringa);
      ScriviStringa(stringa, sizeof(stringa), "%-12.6f", param1->val);
      gtk_entry_set_text(GTK_ENTRY(entry), stringa);
      ScriviStringa(stringa,sizeof(stringa), "checkprof%d", k);
      checkbutton = get_widget(table, stringa);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), param1->rcod);
      k++;
      g_free(param1);
  }
//
//---FWHM1
//
  for(i = 0; i<nfwhm1; i++)
  {
      r_param_type *param1 = g_new0(r_param_type, 1);
      memcpy(param1, paramv[i+nmix], sizeof(r_param_type));
      ScriviStringa(stringa,sizeof(stringa), "entryprof%d", k);
      entry = get_widget(table, stringa);
      ScriviStringa(stringa, sizeof(stringa), "%-12.6f", param1->val);
      gtk_entry_set_text(GTK_ENTRY(entry), stringa);
      ScriviStringa(stringa,sizeof(stringa), "checkprof%d", k);
      checkbutton = get_widget(table, stringa);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), param1->rcod);
      k++;
      g_free(param1);
  }

//
//---FWHM2
//
  for(i = 0; i<nfwhm2; i++)
  {
      r_param_type *param1 = g_new0(r_param_type, 1);
      memcpy(param1, paramv[i+nmix+nfwhm1], sizeof(r_param_type));
      ScriviStringa(stringa,sizeof(stringa), "entryprof%d", k);
      entry = get_widget(table, stringa);
      ScriviStringa(stringa, sizeof(stringa), "%-12.6f", param1->val);
      gtk_entry_set_text(GTK_ENTRY(entry), stringa);
      ScriviStringa(stringa,sizeof(stringa), "checkprof%d", k);
      checkbutton = get_widget(table, stringa);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), param1->rcod);
      k++;
      g_free(param1);
  }

//
//---Asymmetry
//
  for(int ia=0; ia<4; ia++)
  {
      entry = get_widget_num(table, "entryasym",ia);
      ScriviStringa(stringa, sizeof(stringa), "%-12.6f", paramv[ia+ASYM1]->val);
      gtk_entry_set_text(GTK_ENTRY(entry), stringa);
      checkbutton = get_widget_num(table, "checkasym",ia);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), paramv[ia+ASYM1]->rcod);
  }

//
// Scala
//
   checkbutton = get_widget_num(rietveld_dialog, "checkscalr", ph);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), crys[ph].SC());
   entry = get_widget_num(rietveld_dialog, "entryscalr", ph);
   ScriviStringa(stringa, sizeof(stringa), "%-12.6f", crys[ph].GetScale());
   gtk_entry_set_text(GTK_ENTRY(entry), stringa);
//
// Background
//
   checkbutton = get_widget(rietveld_dialog, "check_background");
   iactive = 0;
   iactive += dataset[0].bcode;
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), iactive);

//
// Zero
//
   entry = get_widget(rietveld_dialog, "Zero");
   ScriviStringa(stringa, sizeof(stringa), "%-12.6f", dataset[0].zero);
   gtk_entry_set_text(GTK_ENTRY(entry), stringa);
   checkbutton = get_widget(rietveld_dialog, "check_zero");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), dataset[0].zcode);

   entry = get_widget(rietveld_dialog, "disp");
   ScriviStringa(stringa, sizeof(stringa), "%-12.6f", dataset[0].sdisp);
   gtk_entry_set_text(GTK_ENTRY(entry), stringa);
   checkbutton = get_widget(rietveld_dialog, "check_disp");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), dataset[0].sdcode);

   entry = get_widget(rietveld_dialog, "tran");
   ScriviStringa(stringa, sizeof(stringa), "%-12.6f", dataset[0].stran);
   gtk_entry_set_text(GTK_ENTRY(entry), stringa);
   checkbutton = get_widget(rietveld_dialog, "check_tran");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), dataset[0].stcode);
//
// Orientazione Preferenziale
//
   entry = get_widget_num(rietveld_dialog, "entryG1_", ph);
   ScriviStringa(stringa, sizeof(stringa), "%-12.6f", crys[ph].Gpar());
   gtk_entry_set_text(GTK_ENTRY(entry), stringa);

   checkbutton = get_widget_num(rietveld_dialog, "checkG1_", ph);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton),
       crys[ph].Gcod());

//
// Check procedure automatiche
//
    checkbutton = get_widget(rietveld_dialog, labels_auto[0]);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton),  refcond.auto_prof);
    checkbutton = get_widget(rietveld_dialog, labels_auto[1]);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), refcond.auto_stru);
//
// Visualizzazione grafica Rwp 
//
//   checkRp = get_widget(rietveld_dialog, "view_graph");
//   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkRp),is_char_in(refcond.sprint, 'W', sizeof(refcond.sprint)));
//
// PrintOptions
//
   checkbutton = get_widget(rietveld_dialog, "printM");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton),is_char_in(refcond.sprint, 'M', sizeof(refcond.sprint)));
   checkbutton = get_widget(rietveld_dialog, "printC");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton),is_char_in(refcond.sprint, 'C', sizeof(refcond.sprint)));
   checkbutton = get_widget(rietveld_dialog, "printV");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton),is_char_in(refcond.sprint, 'V', sizeof(refcond.sprint)));
   checkbutton = get_widget(rietveld_dialog, "printS");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton),is_char_in(refcond.sprint, 'S', sizeof(refcond.sprint)));
   checkbutton = get_widget(rietveld_dialog, "printE");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton),is_char_in(refcond.sprint, 'E', sizeof(refcond.sprint)));

   GetInfo();

}

//void apply_rietveld  (GtkButton *button, gpointer user_data)
//{
//    if (cplotok->iriet == 1) (void) cApply();
//}

void exit_rietveld  (GtkButton *button, gpointer user_data)
{
   cplotok->kcount_status = 0;

   (void) cApply();
   gtk_widget_destroy(rietveld_dialog);
   rietveld_dialog = NULL;
   for(int ph=0;ph<numphC; ph++)
       crys[ph].free_constraints();

   exitriet_();
}

void c_finishriet ()
{
     elaborazione_in_corso();
     finishriet_glob_(&refcond, &(dataset[0].bcode),
              &(dataset[0].zero), &(dataset[0].zcode),
              &(dataset[0].sdisp), &(dataset[0].sdcode),
              &(dataset[0].stran), &(dataset[0].stcode),
              &backriet);
     for(int ph=1;ph<=numphC; ph++)
     {
         float scalr = crys[ph-1].GetScale();
         int scalcod = crys[ph-1].SC();
         int kopcorr = crys[ph-1].Kopcorr();
         float gpar = crys[ph-1].Gpar();
         int gcode = crys[ph-1].Gcod();
         finishriet_ph_(crys[ph-1].GetAtoms(), crys[ph-1].Cell(),
            crys[ph-1].CellCode(), &scalr, &scalcod, &(dataset[0].pear[ph-1]),
            &(dataset[0].pvoi[ph-1]), &(dataset[0].tch[ph-1]),  &kopcorr,
            crys[ph-1].HKLpoV(), &gpar, &gcode, &ph);
         crys[ph-1].SetScal(scalr);
         crys[ph-1].SetScalCod(scalcod);
         crys[ph-1].SetKopcorr(kopcorr);
         crys[ph-1].SetGpar(gpar);
         crys[ph-1].SetGcod(gcode);
     }

     fine_elaborazione();
}

void ok_rietveld  (GtkButton *button, gpointer user_data)
{

    GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
    int nsel;

    //apply_rietveld(NULL, NULL);
    nsel = cApply();
//
//  Se nsel > 0 qualcosa e' stato selezionato
    if (nsel > 0) 
    {
        gtk_widget_hide (dlg);
        cplotok->kcount_status = 0;
        c_finishriet ();
        for(int nph=1; nph<=numphC; nph++)
            get_constraints_(&nph);
//        if (cplotok->iriet == 1)
        for(int nph=0; nph<numphC; nph++)
            aggiorna(nph);

        gtk_widget_show(dlg);
        cplotok->kcount_status = 1;
    }
    else
    {
        (void) cMsgWinErr("Warning", "No parameter has been selected. Please set the strategy before going on!", WARN_WINDOW);
        gdk_window_raise(gtk_widget_get_window(dlg));
    }
}

void open_rietveld_dlg()
{
   GtkWidget *radio1, *label;
   char info[80];
   char string[60];
   char label_text[120];
   int ieps;

   cplotok->kcount_status = 1;
   //prendi_specie_riet();
   rietveld_dialog = create_rietveld();
//
//--- numero di cicli (Automatic Procedures)
//
   label = get_widget(rietveld_dialog, "nautocycles");
   spin_button_set_value(label, refcond.ncauto);
//
//--- numero di cicli
//
   label = get_widget(rietveld_dialog, "ncycles");
   spin_button_set_value(label, refcond.maxcy);
//
//--- criterio di convergenza
//
   label = get_widget(rietveld_dialog, "digits");
   ieps = - (int) log10(refcond.eps);
   spin_button_set_value(label, ieps);
//
//--- Scrivi la label del background 
//
   label = get_widget(rietveld_dialog,"infoback");
   ScriviStringa(label_text,sizeof(label_text),"Function type: %s; Number of coefficients: %d",
                       label_back[backriet.btype-1],backriet.ncoef);
   gtk_label_set_text(GTK_LABEL(label),label_text);
//
//--- Setta radio per LeBail 
//
   radio1 = get_widget(rietveld_dialog,"radioleb");
   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radio1), refcond.raction);

//
//--- Genera stringa del gruppo spaziale 
//
   for(int nph=0; nph<numphC; nph++)
   {
       label = get_widget_num(rietveld_dialog,"label_cellp", nph);
       ScriviStringa(string,sizeof(string), "Cell Parameters (Space Group: %s)",
          crys[nph].GetSpg().c_str());
       set_label_text(label,string, MyBLUE, 1, 0);
//
//--- Scrivi il numero di atomi 
//
       label = get_widget_num(rietveld_dialog,"label_atomicp", nph);
       ScriviStringa(info,sizeof(info),"Atomic Parameters (%d atoms in current model) ", crys[nph].GetNats());
       set_label_text(label, info, MyBLUE, 1, 0);
       aggiorna(nph);
   }
   gtk_widget_show(rietveld_dialog);
}

void help_rietveld(GtkButton *button, gpointer data)
{
    //open_htm("Rietveld.html");
    open_htm("rietveld-refinement/");
}

GtkWidget* create_rietveld (void)
{
  GtkWidget *rietveld_window;
  GtkWidget *vbox;
  GtkWidget *label;
  GtkWidget *frame1;
  GtkWidget *notebook;
  GtkWidget *hbuttonbox;
  GtkWidget *ok_button;
//corrado  GtkWidget *apply_button;
  GtkWidget *cancel_button;
  GtkWidget *help_button;
  GtkSizeGroup *szgroup = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);

  rietveld_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_object_set_data (G_OBJECT (finestre[0]),"rietveld_window", rietveld_window);
  gtk_window_set_title (GTK_WINDOW (rietveld_window), "Rietveld Refinement");
  gtk_window_set_position (GTK_WINDOW(rietveld_window), GTK_WIN_POS_MOUSE);

  vbox = vbox_new (FALSE, 2);
  g_object_set_data (G_OBJECT (rietveld_window), "vbox", vbox);
  gtk_container_add (GTK_CONTAINER (rietveld_window), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 2);
  gtk_widget_show (vbox);

  notebook = NewNotebook (vbox);
  g_object_set_data (G_OBJECT (rietveld_window), "notebook", notebook);
  //gtk_box_pack_start (GTK_BOX (vbox), notebook, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (notebook), 8);
  gtk_widget_show (notebook);

  frame1 = FRAME_NEW ("Info", MyBLUE);
  gtk_widget_show(frame1);
  gtk_box_pack_start (GTK_BOX (vbox), frame1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 4);

  label = gtk_label_new("");
  gtk_widget_show(label);
  gtk_container_add(GTK_CONTAINER(frame1), label);
  set_alignment(label, 0.5, 0.5);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_CENTER);
  set_margins (label, 6, 6, 4, 4);
  g_object_set_data (G_OBJECT (rietveld_window), "Info", label);


  hbuttonbox = hbox_new(TRUE,0);
  gtk_box_pack_start (GTK_BOX (vbox), hbuttonbox, FALSE, FALSE, 0);
  gtk_widget_show (hbuttonbox);

  ok_button = myimage_button ("  _Refine", "lsq1_ico.xpm");
  gtk_box_pack_start (GTK_BOX (hbuttonbox), ok_button, FALSE, FALSE, 2);
  gtk_size_group_add_widget(szgroup, ok_button);
  gtk_widget_show (ok_button);
  g_signal_connect_swapped (G_OBJECT(ok_button), "clicked",
           G_CALLBACK(ok_rietveld), G_OBJECT(rietveld_window));

/*corrado
  apply_button = APPLY_button();
  gtk_box_pack_start (GTK_BOX (hbuttonbox), apply_button, FALSE, FALSE, 2);
  gtk_widget_show (apply_button);
  gtk_size_group_add_widget(szgroup, apply_button);
  g_signal_connect (G_OBJECT(apply_button), "clicked",G_CALLBACK(apply_rietveld), NULL);
*/

  cancel_button = QUIT_button();
  gtk_box_pack_start (GTK_BOX (hbuttonbox), cancel_button, FALSE, FALSE, 2);
  gtk_widget_show (cancel_button);
  gtk_size_group_add_widget(szgroup, cancel_button);
  g_signal_connect (G_OBJECT(cancel_button), "clicked",G_CALLBACK(exit_rietveld), NULL);

  g_signal_connect_swapped (G_OBJECT(rietveld_window), "delete_event",
           G_CALLBACK(gtk_button_clicked), G_OBJECT(cancel_button));
  g_signal_connect(G_OBJECT(rietveld_window), "delete_event", G_CALLBACK(true_cb), NULL);

  help_button = HELP_button();
  gtk_box_pack_start (GTK_BOX (hbuttonbox), help_button, FALSE, FALSE, 2);
  gtk_widget_show (help_button);
  gtk_size_group_add_widget(szgroup, help_button);
  g_signal_connect (G_OBJECT(help_button), "clicked",G_CALLBACK(help_rietveld), NULL);

//  if (cplotok->iriet == 1)
//  {
     page_general(notebook, rietveld_window);
     page_background(notebook, rietveld_window);
     //page_cell(notebook, rietveld_window);
     for(int i=0; i<numphC; i++)
         page_crystal(notebook, rietveld_window, i);
//  }
//  else if(cplotok->iriet == 2)  
//  {
//     page_general(notebook, rietveld_window);
//  }

  return rietveld_window;
}

void selected_LeBail (GtkToggleButton *togglebutton, gpointer user_data)
{
    int val = gtk_toggle_button_get_active(togglebutton);
    GtkWidget *label = get_widget(rietveld_dialog, labels_auto[1]);
    if (val == 1)
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), FALSE);
    gtk_widget_set_sensitive(label, !val);
    label = get_widget(rietveld_dialog, "box_restr_constr");
    gtk_widget_set_sensitive(label,!val);
    label = get_widget(rietveld_dialog, "frame_atpar");
    gtk_widget_set_sensitive(label,!val);
}

void on_cb_autoref_old(GtkToggleButton *button, GtkWidget *to_active)
{
//using namespace std;
    int i, j, attivo[2], ifAuto;
    GtkWidget *check, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
    int nmix, nfwhm1, nfwhm2;
    GtkWidget *table;
    char stringa[30];
    r_param_type *paramv[10];

    for (i=0;i<2;i++)
    {
         check = get_widget(dlg, labels_auto[i]);
         attivo[i] = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));
    }
    ifAuto = attivo[0] | attivo[1];
    gtk_widget_set_sensitive(to_active, !ifAuto);

// NEW
    GtkWidget *autoc = get_widget(dlg, "nautocycles");
    gtk_widget_set_sensitive(autoc, ifAuto);
    check = get_widget(dlg, "check_background");
    gtk_widget_set_sensitive(check, !ifAuto);
    for(int nph=0; nph<numphC;nph++)
    {
    get_par_profile(dataset[0].typefun[nph], &nmix, &nfwhm1, &nfwhm2, paramv,nph);
    ScriviStringa(stringa,sizeof(stringa), "table_%d_", dataset[0].typefun[nph]);
    table = get_widget_num(dlg, stringa,nph);
    for(i=1; i<=nmix+nfwhm1+nfwhm2; i++)
    {
      ScriviStringa(stringa,sizeof(stringa), "checkprof%d", i);
      check = get_widget (table, stringa);
      gtk_widget_set_sensitive(check, !ifAuto);
    }
    for(int ia=0; ia<4; ia++)
    {
        check = get_widget_num (table, "checkasym", ia);
        gtk_widget_set_sensitive(check, !ifAuto);
    }
    check = get_widget (dlg, "check_zero");
    gtk_widget_set_sensitive(check, !ifAuto);

    check = get_widget_num(dlg, "checkscalr", nph);
    gtk_widget_set_sensitive(check, !ifAuto);
    for(i = 0; i<6; i++)
    {
        ScriviStringa(stringa,sizeof(stringa),"checkcell%d_",i);
        check = get_widget_num (dlg, stringa, nph);
        gtk_widget_set_sensitive(check, !ifAuto);
    }
    //clock_t begin = clock();
    for (i=0;i<crys[nph].GetNats();i++)
    {
       ScriviStringa(stringa,sizeof(stringa), "buttonlabel%d_",i);
       check = get_widget_num(dlg,stringa, nph);
       gtk_widget_set_sensitive(check, !ifAuto);
       for (j=0;j<5;j++)
       {
            if(j >= 3)
               ScriviStringa(stringa,sizeof(stringa), "checkstru%d%d_",i,j);
            else
               ScriviStringa(stringa,sizeof(stringa), "checkstru%d2_",i);
            check = get_widget_num(dlg,stringa, nph);
            gtk_widget_set_sensitive(check, !ifAuto);
       }
    }
    //double elapsed_secs = double(clock() - begin) / CLOCKS_PER_SEC;
    //g_print("elapsed %f\n", elapsed_secs);

    for(i = 0; i<3; i++)
    {
        ScriviStringa(stringa,sizeof(stringa), "buttonpar%d_",i);
        check = get_widget_num (dlg, stringa, nph);
        gtk_widget_set_sensitive(check, !ifAuto);
    }
    for (i=0;i<crys[nph].GetNelems();i++)
    {
       //if (Specie_active[i] == 1)
       {
          ScriviStringa(stringa,sizeof(stringa), "buttonspe%d_",i);
          check = get_widget_num (dlg, stringa, nph);
          gtk_widget_set_sensitive(check, !ifAuto);
       }
    }
    }
}

void on_cb_autoref(GtkToggleButton *button, GtkWidget *to_active)
{
//using namespace std;
    int i, attivo[2], ifAuto;
    GtkWidget *check, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
    int nmix, nfwhm1, nfwhm2;
    GtkWidget *table;
    char stringa[30];
    r_param_type *paramv[10];

    for (i=0;i<2;i++)
    {
         check = get_widget(dlg, labels_auto[i]);
         attivo[i] = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));
    }
    ifAuto = attivo[0] | attivo[1];
    gtk_widget_set_sensitive(to_active, !ifAuto);

// NEW
    GtkWidget *autoc = get_widget(dlg, "nautocycles");
    gtk_widget_set_sensitive(autoc, ifAuto);
    check = get_widget(dlg, "check_background");
    gtk_widget_set_sensitive(check, !ifAuto);
    for(int nph=0; nph<numphC;nph++)
    {
        get_par_profile(dataset[0].typefun[nph], &nmix, &nfwhm1, &nfwhm2, paramv,nph);
        ScriviStringa(stringa,sizeof(stringa), "table_%d_", dataset[0].typefun[nph]);
        table = get_widget_num(dlg, stringa,nph);
        for(i=1; i<=nmix+nfwhm1+nfwhm2; i++)
        {
          ScriviStringa(stringa,sizeof(stringa), "checkprof%d", i);
          check = get_widget (table, stringa);
          gtk_widget_set_sensitive(check, !ifAuto);
        }
        for(int ia=0; ia<4; ia++)
        {
            check = get_widget_num (table, "checkasym", ia);
            gtk_widget_set_sensitive(check, !ifAuto);
        }
        check = get_widget (dlg, "check_zero");
        gtk_widget_set_sensitive(check, !ifAuto);

        check = get_widget_num(dlg, "checkscalr", nph);
        gtk_widget_set_sensitive(check, !ifAuto);
        for(i = 0; i<6; i++)
        {
            ScriviStringa(stringa,sizeof(stringa),"checkcell%d_",i);
            check = get_widget_num (dlg, stringa, nph);
            gtk_widget_set_sensitive(check, !ifAuto);
        }
        //clock_t begin = clock();
        for (i=0;i<crys[nph].GetNats();i++)
        {
           ScriviStringa(stringa,sizeof(stringa), "buttonlabel%d_",i);
           check = get_widget_num(dlg,stringa, nph);
           gtk_widget_set_sensitive(check, !ifAuto);
        }
        for (i=0;i<crys[nph].GetNats();i++)
        {
             ScriviStringa(stringa,sizeof(stringa), "checkstru%d2_",i);
             check = get_widget_num(dlg,stringa, nph);
             gtk_widget_set_sensitive(check, !ifAuto);
        }
        for (i=0;i<crys[nph].GetNats();i++)
        {
             ScriviStringa(stringa,sizeof(stringa), "checkstru%d3_",i);
             check = get_widget_num(dlg,stringa, nph);
             gtk_widget_set_sensitive(check, !ifAuto);
        }
        for (i=0;i<crys[nph].GetNats();i++)
        {
             ScriviStringa(stringa,sizeof(stringa), "checkstru%d4_",i);
             check = get_widget_num(dlg,stringa, nph);
             gtk_widget_set_sensitive(check, !ifAuto);
        }

        //double elapsed_secs = double(clock() - begin) / CLOCKS_PER_SEC;
        //g_print("elapsed %f\n", elapsed_secs);
        for(i = 0; i<3; i++)
        {
            ScriviStringa(stringa,sizeof(stringa), "buttonpar%d_",i);
            check = get_widget_num (dlg, stringa, nph);
            gtk_widget_set_sensitive(check, !ifAuto);
        }
        for (i=0;i<crys[nph].GetNelems();i++)
        {
           //if (Specie_active[i] == 1)
           {
              ScriviStringa(stringa,sizeof(stringa), "buttonspe%d_",i);
              check = get_widget_num (dlg, stringa, nph);
              gtk_widget_set_sensitive(check, !ifAuto);
           }
        }
    }
}

void page_general(GtkWidget *notebook, GtkWidget *rietveld_window)
{
  GtkWidget *vbox1;
  GtkWidget *label;
  GtkWidget *combo1;
  GtkWidget *table0;
  GtkWidget *table1;
  GtkWidget *table2;
  GtkWidget *frame1;
  GtkWidget *checkbutton1;
//corr  GtkWidget *check_graph;
  GtkWidget *check_prS;
  GtkWidget *check_prV;
  GtkWidget *check_prM;
  GtkWidget *check_prC;
  GtkWidget *check_prE;
  GObject *ncycles_adj;
  GtkWidget *ncycles;
  GtkWidget *nautocycles;
  GObject *digits_adj;
  GtkWidget *digits;
  int i;

  vbox1 = vbox_new (FALSE,0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (notebook), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 15);

  table0 = table_new (1, 2, FALSE);
  gtk_widget_show (table0);
  table_set_col_spacings (table0, 10);
  gtk_container_set_border_width (GTK_CONTAINER (table0), 4);
  gtk_box_pack_start (GTK_BOX (vbox1), table0, FALSE, FALSE, 0);

  frame1 = NEW_FRAME ("Automatic Procedures", true);
  gtk_widget_show(frame1);
  table_attach(table0, frame1, 0, 1, 0, 1, TRUE);

  table2 = table_new (3, 2, TRUE);
  gtk_widget_show (table2);
  table_set_row_spacings (table2, 14);
  table_set_col_spacings (table2, 24);
  add_to_frame (frame1, table2);

  for (i=0;i<2;i++) 
  {
    checkbutton1 = CHECK_BUTTON_WITH_LABEL (labels_auto[i], NULL);
    g_object_set_data (G_OBJECT (rietveld_window), labels_auto[i], checkbutton1);
    gtk_widget_show (checkbutton1);
    table_attach_exp(table2, checkbutton1, 0, 2, i, i+1);
  }

  GtkWidget *spin  = SPIN_WITH_LABEL("Number of Cycles:   ", NULL, 1, 100, 1, 1, 0);
  nautocycles = get_widget (spin, "spin");
  set_width_chars(GTK_ENTRY(nautocycles), 3);
  g_object_set_data (G_OBJECT (rietveld_window), "nautocycles", nautocycles);
  gtk_widget_show_all(spin);
  table_attach_exp(table2, spin, 0, 2, 2, 3);
  gtk_widget_set_sensitive(nautocycles, FALSE);

  frame1 = NEW_FRAME ("Print Options", true);
  gtk_widget_show(frame1);
  table_attach(table0, frame1, 1, 2, 0, 1, TRUE);

  table2 = table_new (3, 2, TRUE);
  gtk_widget_show (table2);
  table_set_row_spacings (table2, 14);
  table_set_col_spacings (table2, 24);
  add_to_frame (frame1, table2);

  check_prS = CHECK_BUTTON_WITH_LABEL ("start/end cycle", NULL);
  g_object_set_data(G_OBJECT (rietveld_window), "printS", check_prS);
  gtk_widget_show (check_prS);
  table_attach_exp(table2, check_prS, 0, 1, 0, 1);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_prS),is_char_in(refcond.sprint, 'S', sizeof(refcond.sprint)));

  check_prV = CHECK_BUTTON_WITH_LABEL ("each cycle", NULL);
  g_object_set_data(G_OBJECT (rietveld_window), "printV", check_prV);
  gtk_widget_show (check_prV);
  table_attach_exp(table2, check_prV, 1, 2, 0, 1);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_prV),is_char_in(refcond.sprint, 'V', sizeof(refcond.sprint)));

  check_prC = CHECK_BUTTON_WITH_LABEL ("correlation matrix", NULL);
  g_object_set_data(G_OBJECT (rietveld_window), "printC", check_prC);
  gtk_widget_show (check_prC);
  table_attach_exp(table2, check_prC, 0, 1, 1, 2);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_prC),is_char_in(refcond.sprint, 'C', sizeof(refcond.sprint)));

  check_prM = CHECK_BUTTON_WITH_LABEL ("LSQ matrix", NULL);
  g_object_set_data(G_OBJECT (rietveld_window), "printM", check_prM);
  gtk_widget_show (check_prM);
  table_attach_exp(table2, check_prM, 1, 2, 1, 2);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_prM),is_char_in(refcond.sprint, 'M', sizeof(refcond.sprint)));

  check_prE = CHECK_BUTTON_WITH_LABEL ("Standard deviation", NULL);
  g_object_set_data(G_OBJECT (rietveld_window), "printE", check_prE);
  gtk_widget_show (check_prE);
  table_attach_exp(table2, check_prE, 0, 1, 2, 3);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_prE),is_char_in(refcond.sprint, 'E', sizeof(refcond.sprint)));

  frame1 = NEW_FRAME ("LSQ Options", true);
  gtk_widget_show(frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, FALSE, FALSE, 0);

  table1 = table_new (2, 5, FALSE);
  gtk_widget_show (table1);
  table_set_row_spacings (table1, 10);
  table_set_col_spacings (table1, 10);
  add_to_frame (frame1, table1);

  label = LABEL_NEW ("Number of Cycles:", NULL);
  gtk_widget_show(label);
  g_object_set_data(G_OBJECT (rietveld_window), "frame_cycles", label);
  set_alignment(label, 0, 0.5);
  table_attach_exp(table1, label, 0, 1, 0, 1);

  ncycles_adj = adj_new (30, 1, 999, 1, 10);
  ncycles = spin_button_new (GTK_ADJUSTMENT (ncycles_adj), 1, 0);
  set_width_chars(GTK_ENTRY(ncycles), 3);
  g_object_set_data (G_OBJECT (rietveld_window), "ncycles", ncycles);
  gtk_widget_show(ncycles);
  table_attach_exp(table1, ncycles, 1, 2, 0, 1);
  gtk_widget_set_sensitive(ncycles, !(refcond.auto_prof | refcond.auto_stru));

  label = LABEL_NEW ("          ", NULL);
  gtk_widget_show(label);
  table_attach_exp(table1, label, 2, 3, 0, 1);

  label = LABEL_NEW ("Weighting Scheme:", NULL);
  gtk_widget_show(label);
  table_attach_exp(table1, label, 3, 4, 0, 1);
  set_alignment(label, 0, 0.5);

  dime_riet = refcond.typewei;
  combo1 = create_combo(NULL, pesi_riet, 3, refcond.typewei, &dime_riet);
  g_object_set_data(G_OBJECT(rietveld_window),"pesi_riet",get_widget(combo1, "entry"));
  gtk_widget_show(combo1);
  table_attach_exp(table1, get_widget(combo1, "parent"), 4, 5, 0, 1);

  label = LABEL_NEW ("Criterium of Convergence:", NULL);
  gtk_widget_show(label);
  table_attach_exp(table1, label, 0, 1, 1, 2);
  set_alignment(label, 0, 0.5);

  digits_adj = adj_new (4, 1, 10, 1, 10);
  digits = spin_button_new (GTK_ADJUSTMENT (digits_adj), 1, 0);
  set_width_chars(GTK_ENTRY(digits), 3);
  g_object_set_data (G_OBJECT (rietveld_window), "digits", digits);
  gtk_widget_show(digits);
  table_attach_exp(table1, digits, 1, 2, 1, 2);

  frame1 = gtk_frame_new(NULL);
  gtk_widget_show(frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, FALSE, FALSE, 10);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 4);

  checkbutton1 = CHECK_BUTTON_WITH_LABEL ("Refine non-structural parameters with Le Bail method", MyBLUE);
  g_object_set_data(G_OBJECT (rietveld_window), "radioleb", checkbutton1);
  gtk_widget_show(checkbutton1);
  gtk_container_add (GTK_CONTAINER (frame1), checkbutton1);
  g_signal_connect (G_OBJECT (checkbutton1), "toggled",
                      G_CALLBACK (selected_LeBail), NULL);
  gtk_container_set_border_width (GTK_CONTAINER (checkbutton1), 8);

  set_tab_label (GTK_NOTEBOOK (notebook), GEN, "General");
  for (i=0;i<2;i++)
  {
    checkbutton1 = get_widget(rietveld_window, labels_auto[i]);
    g_signal_connect (G_OBJECT (checkbutton1), "toggled",
                      G_CALLBACK (on_cb_autoref),
                      ncycles);
  }
}

void on_buttonlabel_active(GtkWidget *widget, gpointer data)
{
   GtkWidget *button, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(widget));
   char stringa[30]; 
   int atompos;
   int i; 

   int num = GPOINTER_TO_INT(data);
   atompos = num % 10000;
   int ph = num / 10000;

   for(i = 0; i<5; i++)
   {
       if(i >= 3)
          ScriviStringa(stringa,sizeof(stringa), "checkstru%d%d_", atompos,i);
       else
          ScriviStringa(stringa,sizeof(stringa), "checkstru%d2_", atompos);
       button = get_widget_num(dlg, stringa, ph);
       if(gtk_widget_get_sensitive(button))
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), 
               gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
   }
}

void on_buttonpar_active(GtkWidget *widget, gpointer data)
{
   GtkWidget *button, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(widget));

   char stringa[30]; 
   int parpos;
   int i; 

   int num = GPOINTER_TO_INT(data);
   int ph = num / 10;
   parpos = num % 10;

   for(i = 0; i<crys[ph].GetNats(); i++)
   {
       ScriviStringa(stringa,sizeof(stringa), "checkstru%d%d_", i,parpos);
       button = get_widget_num(dlg, stringa, ph);
       if(gtk_widget_get_sensitive(button))
           gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), 
                 gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
   }
}

void on_buttonspec_active(GtkWidget *widget, gpointer data)
{
   GtkWidget *button, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(widget));

   char stringa[30]; 
   int parspec;
   int i;

   int num = GPOINTER_TO_INT(data);
   int ph  = num / 10;
   parspec = crys[ph].GetElemptab(num % 10);

   for(i = 0; i<crys[ph].GetNats(); i++)
   {
      int ptab_at = crys[ph].GetAtom(i).ptab;
      if (ptab_at == parspec)
      {
         ScriviStringa(stringa,sizeof(stringa), "buttonlabel%d_", i);
         button = get_widget_num(dlg, stringa, ph);
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button),gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget))); 
      }
   }
}

void on_refine_par(GtkToggleButton *button, gpointer data)
{
   int i, hnd;
   GtkWidget *button2, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gboolean torefine = gtk_toggle_button_get_active(button);
   constraint_ref *cf = (constraint_ref *) data;
   int katom = cf->katom;
   int kpar  = cf->kpar;
   int ph    = cf->ph;
//   int kconstr = par_in_constraint(katom+1, kpar+1);
   int kconstr;
   char string[30];

//   g_print("on_refine_par katom %d kpar %d kconstr = %d\n", katom+1, kpar+1, kconstr);
   if (kpar == 2)   // selection on x,y,z 
       for(int i=0; i<3; i++) {
           kconstr = crys[ph].par_in_constraint(katom+1, i+1);
           if (kconstr > 0) break;
       }
   else             // selection on B, occ
       kconstr = crys[ph].par_in_constraint(katom+1, kpar+1);

   if(kconstr == 0)
      return;

   for(i=0; i<crys[ph].Constr(kconstr-1).npar; i++)
   {
       if(crys[ph].Constr(kconstr-1).vpar[i] > 3)
          ScriviStringa(string,sizeof(string), "checkstru%d%d_",crys[ph].Constr(kconstr-1).vat[i]-1,crys[ph].Constr(kconstr-1).vpar[i]-1);
       else
          ScriviStringa(string,sizeof(string), "checkstru%d2_",crys[ph].Constr(kconstr-1).vat[i]-1);
       button2 = get_widget_num(dlg, string, ph);
       hnd = get_int(button2, "hnd");
       g_signal_handler_block(G_OBJECT(button2), hnd);
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button2), torefine);
       g_signal_handler_unblock(G_OBJECT(button2), hnd);
   }
}

void frame_atomic_parameters (GtkWidget *window1, GtkWidget *father, int ph)
{
  GtkWidget *scrolled_window;
  GtkWidget *hbox1;
  GtkWidget *frame1;
  GtkWidget *vbox2;
  GtkWidget *table1;
  GtkWidget *entry;
  GtkWidget *buttonlabel;
  GtkWidget *buttonpar;
  GtkWidget *checkbutton;

  char string[30];
  int hnd,i,j,k=1;

  hbox1 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (father), hbox1);
#ifdef IN_GTK3
    gtk_widget_set_vexpand(hbox1, TRUE);
#endif
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 5);

  scrolled_window = gtk_scrolled_window_new(NULL,NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (scrolled_window),
                                 GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolled_window, TRUE, TRUE, 0);
  gtk_widget_show(scrolled_window);

  table1 = table_new (crys[ph].GetNats(), 12, FALSE);
  gtk_widget_show (table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  table_set_row_spacings (table1, 4);
  table_set_col_spacings (table1, 4);
  add_to_scrollwin (scrolled_window, table1);
//
//   Scrivi le labels degli atomi sulla prima colonna
//
  for (i=0;i<crys[ph].GetNats();i++)
  {
    buttonlabel = gtk_toggle_button_new_with_label (crys[ph].GetAtomName1(i).c_str());
    gtk_widget_show (buttonlabel);
    ScriviStringa(string,sizeof(string), "buttonlabel%d_",i);
    HOOKUP_NUM(window1,string, buttonlabel, ph);
    table_attach (table1, buttonlabel, 0, 1, i+1, i+2);
    gtk_widget_set_size_request(buttonlabel, 50, 24);
    g_signal_connect (G_OBJECT(buttonlabel), "clicked", 
            G_CALLBACK(on_buttonlabel_active), GINT_TO_POINTER(ph*10000+i));
  }
  
//
//--Scrivi il tipo di parametro (x,y,z,B,occ.) sulla prima riga
//
   k = 7;
   buttonpar = gtk_toggle_button_new_with_label ("x       y       z");
   gtk_widget_show (buttonpar);
   table_attach (table1, buttonpar, 1, k, 0, 1);
   //g_object_set_data(G_OBJECT (window1),"buttonpar0", buttonpar);
   HOOKUP_NUM(window1,"buttonpar0_", buttonpar, ph);
   g_signal_connect (G_OBJECT(buttonpar), "clicked", 
              G_CALLBACK(on_buttonpar_active), GINT_TO_POINTER(ph*10+2));

   for (i=3;i<5;i++)
   {
       buttonpar = gtk_toggle_button_new_with_label (parametri[i]);
       gtk_widget_show (buttonpar);
       table_attach_exp (table1, buttonpar, k, k+2, 0, 1);
       ScriviStringa(string,sizeof(string), "buttonpar%d_",i-2);
       HOOKUP_NUM(window1,string, buttonpar, ph);
       //g_object_set_data(G_OBJECT (window1),string, buttonpar);
       g_signal_connect (G_OBJECT(buttonpar), "clicked", 
              G_CALLBACK(on_buttonpar_active), GINT_TO_POINTER(ph*10+i));
       k += 2;
   }
   k = 1;

  for (i=0;i<5;i++)
  {
//
//--Inserisci un entry ed un checkbutton per ogni parametro sulle righe successive
//
    for (j=0;j<crys[ph].GetNats();j++)
    {
     constraint_ref *cb_data = g_new0(constraint_ref, 1);
//
//---Inserisci entry 
//
     entry = gtk_entry_new ();
     ScriviStringa(string,sizeof(string),"entrystru%d%d_",j,i);
     HOOKUP_NUM(window1,string, entry, ph);
     gtk_widget_show (entry);
     if(i >= 2)
        table_attach_exp (table1, entry, k, k+1, j+1, j+2);
     else
        table_attach_exp (table1, entry, k, k+2, j+1, j+2);
//     gtk_widget_set_size_request (entry,75, 24);
     set_width_chars(GTK_ENTRY(entry), 10);
//
//---Inserisci checkbutton 
//
     if(i >= 2)
     {
        checkbutton = gtk_check_button_new();
        ScriviStringa(string,sizeof(string),"checkstru%d%d_",j,i);
        HOOKUP_NUM(window1,string, checkbutton, ph);
#ifdef IN_GTK3
       gtk_widget_set_halign(checkbutton, GTK_ALIGN_CENTER);
#endif
        table_attach (table1, checkbutton, k+1, k+2, j+1, j+2);
        cb_data->katom = j;
        cb_data->kpar  = i;
        cb_data->ph    = ph;
        hnd = g_signal_connect(G_OBJECT(checkbutton),"toggled",G_CALLBACK(on_refine_par),(gpointer) cb_data);
        g_object_set_data(G_OBJECT (checkbutton),"hnd", GINT_TO_POINTER(hnd));
        gtk_widget_show (checkbutton);
     }
    }
    k = k + 2;
  }

  frame1 = NEW_FRAME("Select by species");
  gtk_box_pack_start (GTK_BOX (hbox1), frame1, TRUE, TRUE, 5);
  gtk_widget_show (frame1);

  vbox2 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  add_to_frame (frame1, vbox2);

  for (i=0;i<crys[ph].GetNelems();i++)
  {
     //int kspe = specv.at(i);
     //if (Specie_active[i] == 1) 
     {
        checkbutton = gtk_check_button_new_with_label
           (crys[ph].GetElemName(i).c_str());
        gtk_box_pack_start (GTK_BOX (vbox2), checkbutton, FALSE, FALSE, 2);
		gtk_widget_show (checkbutton);
        ScriviStringa(string,sizeof(string), "buttonspe%d_",i);
        HOOKUP_NUM(window1,string, checkbutton, ph);
        g_signal_connect(G_OBJECT(checkbutton),"clicked",G_CALLBACK(on_buttonspec_active),GINT_TO_POINTER(ph*10+i)); 
     }
  }

}

void c_show_model(GtkWidget *widget, gpointer data)
{
   int ph = GPOINTER_TO_INT(data)+1;
   show_model_(&ph);
}

GtkWidget *create_table_refine_s(const char *str, float val, int rcod, int riga,
                        GtkWidget *table1=NULL)
{
  GtkWidget *table;
  static GtkSizeGroup *szgroup;
  if (riga)
      table = table1;
  else
  {
      szgroup = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
      table = table_new (1, 1, FALSE);
      gtk_widget_show (table);
      gtk_container_set_border_width (GTK_CONTAINER (table), 10);
      table_set_col_spacings (table, 10);
      table_set_row_spacings (table, 8);
  }

  GtkWidget *entryprof = entry_for_refine(str, val, rcod, NULL);
  gtk_widget_show (entryprof);
  gtk_size_group_add_widget(szgroup, get_widget(entryprof, "label"));
  table_attach (table, entryprof, 0, 1, riga, riga+1);
  HOOKUP_OBJECT (table, get_widget(entryprof, "entry"), "entryprof1");
  HOOKUP_OBJECT (table, get_widget(entryprof, "check"), "checkprof1");

  return table;
}

GtkWidget *scalasp(GtkWidget *rietveld_window, int ph)
{
  GtkWidget *frame2 = NEW_FRAME("Scale factor");
  gtk_widget_show(frame2);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 5);

  GtkWidget *table = create_table_refine_s("Scale",crys[ph].GetScale(),
              crys[ph].SC(), 0);
  add_to_frame (frame2, table);
  HOOKUP_NUM(rietveld_window,"checkscalr", get_widget(table, "checkprof1"), ph);
  HOOKUP_NUM(rietveld_window,"entryscalr", get_widget(table, "entryprof1"), ph);
  return frame2;
}

void page_atoms(GtkWidget *notebook, GtkWidget *rietveld_window, int ph)
{

  GtkWidget *table2;
  GtkWidget *frame1;
  GtkWidget *label1;
  GtkWidget *checkcell;
  GtkWidget *frame3;
  GtkWidget *table3;
  GtkWidget *label;
  GtkWidget *entrycell;
  GtkWidget *align;
  GtkWidget *box;
  GtkWidget *button2, *button3;

  int i;
  int k;
  char string[30];

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_FILL, 0, 0);
#else
  align = gtk_alignment_new(0.5f, 0.5f, 0.f, 1.f);
#endif

  gtk_widget_show (align);
  gtk_container_add (GTK_CONTAINER (notebook), align);

  table2 = table_new (3, 2, FALSE);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (align), table2);
  table_set_row_spacings (table2, 2);
  table_set_col_spacings (table2, 5);

  frame3 = NEW_FRAME (" ");
  gtk_widget_show (frame3);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 5);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(get_widget(frame3, "align"), FALSE);
#endif
  table_attach_exp (table2, frame3, 0, 1, 0, 1);

  label1 = gtk_frame_get_label_widget (GTK_FRAME (frame3));
  //g_object_set_data(G_OBJECT (rietveld_window), "label_cellp", label1);
  HOOKUP_NUM(rietveld_window, "label_cellp", label1, ph);

  table3 = table_new (2, 6, FALSE);
  gtk_widget_show (table3);
  add_to_frame (frame3, table3);
  gtk_container_set_border_width (GTK_CONTAINER (table3), 10);
  table_set_row_spacings (table3, 10);
  table_set_col_spacings (table3, 8);
//
//---Parametri a,b,c
//
  for(i = 0; i<3; i++)
  {
    k = i*4;
    label = gtk_label_new (labelcell[i]);
    gtk_widget_show (label); 
    table_attach_exp (table3, label, k, k+1, 0, 1);
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
    set_alignment(label, 0, 0.5);

    entrycell = gtk_entry_new ();
    HOOKUP_NUM(rietveld_window, labelcell[i], entrycell, ph);
    table_attach_exp (table3, entrycell, k+1, k+2, 0, 1);
    gtk_widget_show (entrycell);
     set_width_chars(GTK_ENTRY(entrycell), 10);

    checkcell = gtk_check_button_new();
    ScriviStringa(string,sizeof(string),"checkcell%d_",i); 
    HOOKUP_NUM(rietveld_window, string, checkcell, ph);
    table_attach (table3, checkcell,k+2, k+3, 0, 1);
    gtk_widget_show (checkcell);

    label = gtk_label_new ("      ");
    gtk_widget_show (label); 
    table_attach_exp (table3, label, k+3, k+4, 0, 1);
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
    set_alignment(label, 0., 0.);
  }
//
//---Parametri alfa,beta,gamma
//
  for(i = 0; i<3; i++)
  {
    k = i*4;
//    label = gtk_label_new (labelcell[i+3]);
    label = gtk_label_new (greek(i));
    gtk_widget_show (label); 
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
    set_alignment(label, 0, 0.5);
    table_attach_exp (table3, label, k, k+1, 1, 2);

    entrycell = gtk_entry_new ();
    HOOKUP_NUM(rietveld_window, labelcell[i+3], entrycell, ph);
    table_attach_exp (table3, entrycell, k+1, k+2, 1, 2);
    gtk_widget_show (entrycell);
//    gtk_widget_set_size_request (entrycell, 90, 24);
    set_width_chars(GTK_ENTRY(entrycell), 10);

    checkcell = gtk_check_button_new();
    ScriviStringa(string,sizeof(string),"checkcell%d_",i+3); 
    HOOKUP_NUM(rietveld_window, string, checkcell, ph);
    table_attach_exp (table3, checkcell,k+2, k+3, 1, 2);
    gtk_widget_show (checkcell);

    label = gtk_label_new ("      ");
    gtk_widget_show (label); 
    table_attach_exp (table3, label, k+3, k+4, 1, 2);
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
    set_alignment(label, 0., 0.);
  }

//  GtkWidget *frame2 = scalasp(rietveld_window, ph);
//  table_attach_exp (table2, frame2, 0, 1, 1, 2);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
  align = gtk_alignment_new(0.f, 0.5f, 0.f, 0.f);
#endif
  gtk_widget_show (align);
  table_attach (table2, align, 1, 2, 0, 1);

  box = vbox_new(TRUE, 0);
  gtk_widget_show (box);
  gtk_container_set_border_width (GTK_CONTAINER (box), 0);
  gtk_container_add (GTK_CONTAINER (align), box);
  HOOKUP_OBJECT (rietveld_window, box, "box_restr_constr");

  button3 = myimage_button (" _Restraints", "restraints.png");
  gtk_widget_show (button3);
  gtk_box_pack_start(GTK_BOX(box), button3, FALSE, FALSE, 10);
  g_signal_connect(G_OBJECT(button3),"clicked",G_CALLBACK(Newrestraints),GINT_TO_POINTER(ph));

  button2 = myimage_button (" _Constraints", "constraints.png");
  gtk_widget_show (button2);
  gtk_box_pack_start(GTK_BOX(box), button2, FALSE, FALSE, 10);
  g_signal_connect(G_OBJECT(button2), "clicked",
       G_CALLBACK(open_constraints), GINT_TO_POINTER(ph));

  button3 = myimage_button (" _Show model", "viewmol.png");
  gtk_widget_show (button3);
  gtk_box_pack_start(GTK_BOX(box), button3, FALSE, FALSE, 10);
  g_signal_connect(G_OBJECT(button3), "clicked",
       G_CALLBACK(c_show_model), GINT_TO_POINTER(ph));

  frame1 = NEW_FRAME(" ");
  gtk_widget_show (frame1);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 5);
  HOOKUP_OBJECT (rietveld_window, frame1, "frame_atpar");
#ifdef IN_GTK3
  gtk_widget_set_vexpand(get_widget(frame1, "align"), TRUE);
#endif
  table_attach(table2, frame1, 0, 2, 2, 3, TRUE);

  label1 = gtk_frame_get_label_widget (GTK_FRAME (frame1));
  HOOKUP_NUM (rietveld_window, "label_atomicp", label1, ph);

  frame_atomic_parameters(rietveld_window, get_widget(frame1, "align"), ph);
  set_tab_label (GTK_NOTEBOOK (notebook), 0, "Structure");
}
void page_crystal(GtkWidget *notebook, GtkWidget *rietveld_window, int ph)
{
  GtkWidget *align;

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_FILL, 0, 1);
#else
  align = gtk_alignment_new(0.5f, 0.5f, 0.f, 1.f);
#endif

  gtk_widget_show (align);
  gtk_container_add (GTK_CONTAINER (notebook), align);
  GtkWidget *vbox1 = vbox_new (FALSE,0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (align), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);
  GtkWidget *nb1 = NewNotebook (vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (nb1), 8);
  gtk_widget_show (nb1);
  page_atoms(nb1, rietveld_window, ph);
  page_profile(nb1, rietveld_window, ph);
  page_PO(nb1, rietveld_window, ph);

  set_tab_label (GTK_NOTEBOOK (notebook), CELLA+ph, crys[ph].GetName().c_str());
}

void profile_func(GtkWidget *wid, gpointer data)
{
     GtkWidget *container, *table;
     int val = get_combo_sel(wid)+1;
     GtkWidget *dlg = gtk_widget_get_toplevel(wid);
     int ph = GPOINTER_TO_INT(data);
//
//---Modifico il frame 'Profile parameters'
//
    
     container = get_widget_num(dlg, "profile_table", ph);
     table = gtk_bin_get_child(GTK_BIN(container));
     gtk_container_remove(GTK_CONTAINER(container), table);
     table = get_widget_num(dlg, g_strdup_printf("table_%d_", val),ph);
     gtk_container_add(GTK_CONTAINER(container), table);
}


GtkWidget *create_table_refine(r_param_type *paramv[], int nmix, int nfwhm1,
     int nfwhm2)
{
  GtkWidget *table, *entryprof;
  int i, k, riga, nr, nc;
  char stringa[30];

  nr = (nmix > 0) + (nfwhm1 > 0) + (nfwhm2 > 0) + 1;
  nc = MRmax(nfwhm1, nfwhm2);
  nc = MRmax(nc, 4);
  table = table_new (nr, nc, FALSE);
  gtk_widget_show (table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 10);
  table_set_col_spacings (table, 10);
  table_set_row_spacings (table, 8);
  GtkSizeGroup *szgroup   = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  k = 1;
  riga = 0;
//
//---Mixing
//

  for(i = 0; i<nmix; i++)
  {
      r_param_type *param1 = g_new0(r_param_type, 1);
      memcpy(param1, paramv[i], sizeof(r_param_type));
      param1->str[9] = '\0';
      entryprof = entry_for_refine(param1->str, param1->val, param1->rcod, NULL);
      ScriviStringa(stringa,sizeof(stringa),"entryprof%d", k);
      HOOKUP_OBJECT (table, get_widget(entryprof, "entry"), stringa);
      ScriviStringa(stringa,sizeof(stringa),"checkprof%d", k);
      HOOKUP_OBJECT (table, get_widget(entryprof, "check"), stringa);
      gtk_widget_show (entryprof);
      gtk_size_group_add_widget(szgroup, get_widget(entryprof, "label"));
      table_attach (table, entryprof, i, i+1, riga, riga+1);
      k++;
      g_free(param1);
  }
  if(nmix)
     riga++;
//
//---FWHM1
//
  for(i = 0; i<nfwhm1; i++)
  {
      r_param_type *param1 = g_new0(r_param_type, 1);
      memcpy(param1, paramv[i+nmix], sizeof(r_param_type));
      param1->str[9] = '\0';
      entryprof = entry_for_refine(param1->str, param1->val, param1->rcod, NULL);
      gtk_widget_show (entryprof);
      ScriviStringa(stringa,sizeof(stringa),"entryprof%d", k);
      HOOKUP_OBJECT (table, get_widget(entryprof, "entry"), stringa);
      ScriviStringa(stringa,sizeof(stringa),"checkprof%d", k);
      HOOKUP_OBJECT (table, get_widget(entryprof, "check"), stringa);
      gtk_size_group_add_widget(szgroup, get_widget(entryprof, "label"));
      table_attach (table, entryprof, i, i+1, riga, riga+1);
      k++;
      g_free(param1);
  }
  if(nfwhm1)
     riga++;

//
//---FWHM2
//
  for(i = 0; i<nfwhm2; i++)
  {
      r_param_type *param1 = g_new0(r_param_type, 1);
      memcpy(param1, paramv[i+nmix+nfwhm1], sizeof(r_param_type));
      param1->str[9] = '\0';
      entryprof = entry_for_refine(param1->str, param1->val, param1->rcod, NULL);
      gtk_widget_show (entryprof);
      ScriviStringa(stringa,sizeof(stringa),"entryprof%d", k);
      HOOKUP_OBJECT (table, get_widget(entryprof, "entry"), stringa);
      ScriviStringa(stringa,sizeof(stringa),"checkprof%d", k);
      HOOKUP_OBJECT (table, get_widget(entryprof, "check"), stringa);
      gtk_size_group_add_widget(szgroup, get_widget(entryprof, "label"));
      table_attach (table, entryprof, i, i+1, riga, riga+1);
      k++;
      g_free(param1);
  }
  if(nfwhm2)
     riga++;

//
//---Asymmetry
//
  for(int ia=0; ia<4; ia++)
  {
      r_param_type *param1 = g_new0(r_param_type, 1);
      memcpy(param1, paramv[ia+ASYM1], sizeof(r_param_type));
      param1->str[ia+ASYM1] = '\0';
      entryprof = entry_for_refine(param1->str, param1->val, param1->rcod, NULL);
      gtk_widget_show (entryprof);
      gtk_size_group_add_widget(szgroup, get_widget(entryprof, "label"));
      table_attach (table, entryprof, ia, ia+1, riga, riga+1);
      HOOKUP_NUM (table, "entryasym", get_widget(entryprof, "entry"), ia);
      HOOKUP_NUM (table, "checkasym", get_widget(entryprof, "check"), ia);
      g_free(param1);
  }

  return table;
}

GtkWidget *frame_preferential(GtkWidget *rietveld_window, int ph)
{
  GtkWidget *table1;
  GtkWidget *label;
  GtkWidget *entry;
  GtkWidget *entry1;
  GtkWidget *check1;
  int i, j;
  char string[30]; 
  
  table1 = table_new (2, 6, FALSE);
  //g_object_set_data (G_OBJECT (rietveld_window), "tableOP", table1);
  gtk_widget_show (table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  table_set_row_spacings (table1, 6);
  table_set_col_spacings (table1, 12);

  for(i = 0; i<4; i++)
  {
    label = gtk_label_new (labelsOP[i]);
    table_attach(table1, label, i+1, i+2, 0, 1);
    gtk_widget_show(label);
  }

//
//--Stringa del piano
//
    label = gtk_label_new ("plane");
    table_attach(table1, label, 0, 1, 1, 2);
    gtk_widget_show(label);
//
//--Entries per H,K,L 
//
    for (j=1;j<=3;j++)
    {
#ifdef IN_GTK3
      GtkWidget *a = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
      GtkWidget *a = gtk_alignment_new(0.5, 0.5, 0, 0);
#endif
      table_attach(table1, a, j, j+1, 1, 2);
      ScriviStringa(string,sizeof(string), "entryHKL%d_", j);
      entry = gtk_entry_new ();
      HOOKUP_NUM(rietveld_window, string, entry, ph);
       
//      table_attach(table1, entry, j, j+1, 1, 2);
      gtk_container_add(GTK_CONTAINER(a), entry);
      ScriviStringa(string, sizeof(string), "%d", crys[ph].HKLpo(j-1));
      gtk_entry_set_text(GTK_ENTRY(entry), g_strstrip(string));
//      gtk_widget_set_size_request(entry, 40, -1);
      set_width_chars(GTK_ENTRY(entry), 5);
      gtk_widget_show (entry);
      gtk_widget_show (a);
    }
//
//--Entry e check per G1
//
    entry1 = gtk_entry_new ();
    HOOKUP_NUM(rietveld_window, "entryG1_", entry1, ph);
    table_attach(table1, entry1, 4, 5, 1, 2);
    set_width_chars(GTK_ENTRY(entry1), 12);
    ScriviStringa(string, sizeof(string), "%-12.6f", crys[ph].Gpar());
    gtk_entry_set_text(GTK_ENTRY(entry1), string);
    gtk_widget_show (entry1);

    check1 = gtk_check_button_new();
    HOOKUP_NUM(rietveld_window, "checkG1_", check1, ph);
    table_attach(table1, check1, 5, 6, 1, 2);
    gtk_widget_show (check1);
    return table1;
}

void page_profile(GtkWidget *notebook, GtkWidget *rietveld_window, int ph)
{

  GtkWidget *tablep;
  GtkWidget *table;
  GtkWidget *box;
  GtkWidget *frame3;
  GtkWidget *align;
  GtkWidget *combo_func;
  int nmix, nfwhm1, nfwhm2;
  r_param_type *paramv[10];

  tablep = vbox_new(FALSE, 0);
  gtk_widget_show (tablep);
  gtk_container_add (GTK_CONTAINER (notebook), tablep);
  gtk_container_set_border_width (GTK_CONTAINER (tablep), 4);

  GtkWidget *frame2 = scalasp(rietveld_window, ph);
  gtk_box_pack_start(GTK_BOX(tablep), frame2, FALSE, FALSE, 4);

  frame3 = NEW_FRAME ("Peak Shape Functions");
  gtk_widget_show (frame3);
  gtk_box_pack_start(GTK_BOX(tablep), frame3, FALSE, FALSE, 4);

//
//---Profile parameters
//

  box = vbox_new(FALSE, 0);
  gtk_widget_show(box);
  add_to_frame (frame3, box);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
  align = gtk_alignment_new(0.f, 0.5f, 0.f, 0.f);
#endif

  gtk_widget_show(align);
  gtk_box_pack_start(GTK_BOX(box), align, FALSE, FALSE, 0);

//---Combo per selezionare il tipo di funzione di profilo
  combo_func = create_combo_str(G_CALLBACK(profile_func), GINT_TO_POINTER(ph));
  fill_my_combo(combo_func, label_profile, NFPROF, dataset[0].typefun[ph]);
  gtk_container_add (GTK_CONTAINER (align), combo_func);
  g_object_set_data(G_OBJECT (rietveld_window), "profile_func", combo_func);
  HOOKUP_NUM(rietveld_window, "profile_func", combo_func, ph);
  gtk_widget_show (combo_func);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_FILL, 0, 1);
#else
  align = gtk_alignment_new(0.f, 0.5f, 0.f, 1.f);
#endif

  gtk_widget_show(align);
  gtk_box_pack_start(GTK_BOX(box), align, FALSE, FALSE, 0);
  HOOKUP_NUM(rietveld_window, "profile_table", align, ph);

// Pearson
  get_par_profile(1, &nmix, &nfwhm1, &nfwhm2, paramv,ph);
  table = create_table_refine(paramv, nmix, nfwhm1, nfwhm2);
  gtk_container_add (GTK_CONTAINER (align), table);
  HOOKUP_REF_NUM (rietveld_window, "table_1_", table, ph);

// Voigt
  get_par_profile(2, &nmix, &nfwhm1, &nfwhm2, paramv,ph);
  table = create_table_refine(paramv, nmix, nfwhm1, nfwhm2);
  HOOKUP_REF_NUM (rietveld_window, "table_2_", table, ph);

// Tch
  get_par_profile(3, &nmix, &nfwhm1, &nfwhm2, paramv,ph);
  table = create_table_refine(paramv, nmix, nfwhm1, nfwhm2);
  HOOKUP_REF_NUM (rietveld_window, "table_3_", table, ph);

  set_tab_label (GTK_NOTEBOOK (notebook), 1, "Profile function");
}

void page_PO(GtkWidget *notebook, GtkWidget *rietveld_window, int ph)
{
  GtkWidget *vbox = vbox_new(FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 4);
  gtk_widget_show(vbox);

  GtkWidget *frame4 = NEW_FRAME ("March-Dollase Preferred Orientation");
  gtk_widget_show (frame4);
  gtk_box_pack_start(GTK_BOX(vbox), frame4, FALSE, FALSE, 4);
  GtkWidget *align = frame_preferential(rietveld_window, ph);
  add_to_frame(frame4, align);

  set_tab_label (GTK_NOTEBOOK (notebook), 2, "Corrections");
}

void page_background(GtkWidget *notebook, GtkWidget *rietveld_window)
{

  GtkWidget *tablep;
  GtkWidget *table;
  GtkWidget *frame1;
  GtkWidget *frame2;
  GtkWidget *vbox1;
  GtkWidget *label;
  GtkWidget *checkbutton;

  tablep = vbox_new(FALSE, 0); //table_new (4, 1, FALSE);
  gtk_widget_show (tablep);
  gtk_container_add (GTK_CONTAINER (notebook), tablep);
  gtk_container_set_border_width (GTK_CONTAINER (tablep), 4);

  frame1 = NEW_FRAME ("Background");
  gtk_widget_show (frame1);
  gtk_box_pack_start(GTK_BOX(tablep), frame1, FALSE, FALSE, 4);

  frame2 = NEW_FRAME("Line-shifts");
  gtk_widget_show(frame2);
  gtk_box_pack_start(GTK_BOX(tablep), frame2, FALSE, FALSE, 4);

//
//---Background
//

  vbox1 = hbox_new(FALSE, 0); 
  gtk_widget_show (vbox1);
  add_to_frame (frame1, vbox1);

  label = gtk_label_new(NULL);
  g_object_set_data(G_OBJECT (rietveld_window), "infoback", label);
  gtk_box_pack_start(GTK_BOX(vbox1), label, TRUE, TRUE, 0);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  set_alignment(label, 0., 0.);
  gtk_widget_show(label);

  checkbutton = myimage_button("Modify", "modibg.png");
  gtk_box_pack_end(GTK_BOX(vbox1), checkbutton, FALSE, FALSE, 4);
  g_signal_connect(G_OBJECT(checkbutton), "clicked", G_CALLBACK(open_poly_riet),
               NULL);
  gtk_widget_show (checkbutton);

  checkbutton = CHECK_BUTTON_WITH_LABEL ("Refine Background", NULL);
  g_object_set_data (G_OBJECT (rietveld_window), "check_background", checkbutton);
  gtk_box_pack_end(GTK_BOX(vbox1), checkbutton, TRUE, TRUE, 0);
  gtk_widget_show (checkbutton);

//
//---Zero & scale
//

  table = create_table_refine_s("zero-shift",dataset[0].zero,dataset[0].zcode,
                                0);
  add_to_frame (frame2, table);
  HOOKUP_OBJECT (rietveld_window, table, "zero_table");
  table_set_row_spacings(table, 8);
  HOOKUP_OBJECT (rietveld_window, get_widget(table, "checkprof1"), "check_zero");
  HOOKUP_OBJECT (rietveld_window, get_widget(table, "entryprof1"), "Zero");

  table = create_table_refine_s("sample displacement",dataset[0].sdisp,
                          dataset[0].sdcode, 1, table);
  HOOKUP_OBJECT (rietveld_window, table, "disp_table");
  table_set_row_spacings(table, 8);
  HOOKUP_OBJECT (rietveld_window, get_widget(table, "checkprof1"), "check_disp");
  HOOKUP_OBJECT (rietveld_window, get_widget(table, "entryprof1"), "disp");

  table = create_table_refine_s("sample transparency",dataset[0].stran,
                          dataset[0].stcode, 2, table);
  HOOKUP_OBJECT (rietveld_window, table, "tran_table");
  table_set_row_spacings(table, 8);
  HOOKUP_OBJECT (rietveld_window, get_widget(table, "checkprof1"), "check_tran");
  HOOKUP_OBJECT (rietveld_window, get_widget(table, "entryprof1"), "tran");

  set_tab_label (GTK_NOTEBOOK (notebook), PROF, "Powder Data");
}

void on_coeff_back               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
    GtkWidget *dlg, *spin;
    int code = 1;

    dlg = gtk_widget_get_toplevel(GTK_WIDGET(togglebutton));
    spin = get_widget(dlg, "add_back");

    backriet.autosel = gtk_toggle_button_get_active(togglebutton);
    gtk_widget_set_sensitive(GTK_WIDGET(spin), 1 - gtk_toggle_button_get_active(togglebutton));
    modify_background_(&backriet, &code);
    spin_button_set_value(spin,(float) backriet.ncoef);
}

void select_function_back  (GtkToggleButton *togglebutton, gpointer user_data)
{
    GtkWidget *dlg, *spin;
    GtkAdjustment *adj; 
    int val; 
    int code = 1;

    if(gtk_toggle_button_get_active(togglebutton))
    {
       dlg = gtk_widget_get_toplevel(GTK_WIDGET(togglebutton));
       val = GPOINTER_TO_INT(user_data);
       spin = get_widget(dlg,"add_back");
       adj = (GtkAdjustment *) adj_new ((float)backriet.ncoef,1,(float)ncoeff[val],1,10);
       spin_button_set_adjustment (spin, adj);
       spin_button_update (spin);
       backriet.btype = val + 1;
       modify_background_(&backriet, &code);
       spin_button_set_value(spin,(float) backriet.ncoef);
    }
}

void reset_radio_back(GtkWidget *window)
{
  GtkWidget *radio;

  radio = get_widget(window, label_back[backriet.btype-1]);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);
}

void close_background_riet (GtkButton *button, gpointer user_data)
{
  GtkWidget *label;
  char label_text[120];
  int ifOkay = GPOINTER_TO_INT(user_data);

//corr per rosi - ripristinare i parametri iniziali e chiamare la apply_background
  if(!ifOkay)
  {
      int code = 2;
      backriet = backriet_back;
      modify_background_(&backriet, &code);
  }

//corr  finestra_modale_chiusa2();
  gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
  if(rietveld_dialog != NULL)
  {
     label = get_widget(rietveld_dialog,"infoback");
     ScriviStringa(label_text,sizeof(label_text), "Function type: %s; Number of coefficients: %d",
                       label_back[backriet.btype-1],backriet.ncoef);
     gtk_label_set_text(GTK_LABEL(label),label_text);
  }
}

void update_coeff(GtkEditable *editable, gpointer user_data)
{
  GtkWidget *dlg, *spin;
  int new_value, code = 1;

  dlg = gtk_widget_get_toplevel(GTK_WIDGET(editable));
  spin = get_widget(dlg,"add_back");
  new_value = spin_button_get_value_as_int(spin); 
  backriet.ncoef = new_value;
  modify_background_(&backriet, &code);
}

GtkWidget* create_background_riet ()
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *hbox1;
  GtkWidget *frame1;
  GtkWidget *frame2;
  GSList *vbox2_group = NULL;
  GtkWidget *radiof[3];
  GtkWidget *checkbutton;
  GObject *add_adj;
  GtkWidget *add;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *table0;

  int i;

  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "Modify Function");

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));

  table0 = table_new (3, 1, FALSE);
  gtk_widget_show (table0);
  gtk_container_add (GTK_CONTAINER (vbox1), table0);
  gtk_container_set_border_width (GTK_CONTAINER (table0), 5);
  table_set_row_spacings(table0, 8);

  frame1 = NEW_FRAME ("Function type");
  g_object_set_data (G_OBJECT (window1), "frame1", frame1);
  gtk_widget_show (frame1);
  table_attach_exp(table0, frame1, 0, 1, 0, 1);

  frame2 = NEW_FRAME ("Number of Coefficients");
  g_object_set_data (G_OBJECT (window1), "frame_ncoeff", frame2);
  gtk_widget_show (frame2);
  table_attach_exp(table0, frame2, 0, 1, 1, 2);

  vbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  add_to_frame (frame1, vbox2);

  for (i=0;i<3;i++)
  {
    radiof[i] = RADIO_BUTTON_WITH_LABEL (vbox2_group, label_back[i], NULL);
    vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof[i]));
    g_object_set_data (G_OBJECT (window1), label_back[i], radiof[i]);
    gtk_widget_show (radiof[i]);
    if(i)
       gtk_box_pack_start (GTK_BOX (vbox2), radiof[i], FALSE, FALSE, 15);
    else
       gtk_box_pack_start (GTK_BOX (vbox2), radiof[i], FALSE, FALSE, 5);
  }
  /* default */
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiof[backriet.btype-1]), TRUE);

  vbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  add_to_frame (frame2, vbox2);

  checkbutton = CHECK_BUTTON_WITH_LABEL ("Automatic", NULL);
  g_object_set_data (G_OBJECT (window1), "check_back", checkbutton);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton), backriet.autosel);
  gtk_widget_show (checkbutton);

  add_adj = adj_new ((float)backriet.ncoef, 1, (float)ncoeff[backriet.btype-1], 1, 10);
  add = spin_button_new (GTK_ADJUSTMENT (add_adj), 0, 0);
  g_object_set_data (G_OBJECT (window1), "add_back", add);
  gtk_widget_show (add);
  gtk_box_pack_start (GTK_BOX (vbox2), add, FALSE, FALSE, 5);
  gtk_widget_set_sensitive(add, 1 - backriet.autosel);
  gtk_box_pack_start (GTK_BOX (vbox2), checkbutton, FALSE, FALSE, 25);

  hbox1 = hbox_new (FALSE, 10);
  if(backriet.btype == 1) gtk_widget_show (hbox1);
  table_attach_exp(table0, hbox1, 0, 1, 2, 3);
  g_object_set_data (G_OBJECT (window1),"hbox_origin", hbox1);

  button1 = OK_button();
  g_object_set_data (G_OBJECT (window1), "button1", button1);
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, 1);

  button2 = CANCEL_button();
  g_object_set_data (G_OBJECT (window1), "button2", button2);
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
         GTK_BUTTONBOX_SPREAD);

  /*  segnali  */
  g_signal_connect (G_OBJECT (checkbutton), "toggled",
                      G_CALLBACK (on_coeff_back),NULL);

  for(i=0; i<3; i++)
  {
    g_signal_connect (G_OBJECT (radiof[i]), "toggled",
                      G_CALLBACK (select_function_back),
                      GINT_TO_POINTER(i));
  }

  g_signal_connect (G_OBJECT(button2), "clicked", 
  G_CALLBACK(close_background_riet), GINT_TO_POINTER(0));

  g_signal_connect (G_OBJECT(button1), "clicked", 
            G_CALLBACK(close_background_riet), GINT_TO_POINTER(1));
  g_signal_connect(G_OBJECT(add), "value-changed",
            G_CALLBACK(update_coeff), GINT_TO_POINTER(1));

  return window1;
}

void open_poly_riet(GtkWidget *item, gpointer data)
{
     GtkWidget *dlg;
     int code = 0;
     //corr backriet_back = backriet;
     modify_background_(&backriet, &code); //init backriet
     backriet_back = backriet;
     dlg = create_background_riet();
     gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
     gtk_widget_show(dlg);
     gdk_window_raise(gtk_widget_get_window(dlg));
//corr     finestra_modale_aperta2(dlg);
}

void return_rietveld (GtkButton *button, gpointer user_data)
{
   gtk_widget_show(rietveld_dialog);
   finestra_modale_aperta2(rietveld_dialog);
}

void c_rietveld (GtkWidget *item, gpointer data)
{
   rietveld_();
}

void init_constraints()
{
   for(int nph=0; nph<numphC; nph++)
       crys[nph].free_constraints();

   for(int nph=1; nph<=numphC; nph++)
       get_constraints_(&nph);
}

/********************** C o n s t r a i n t s ****************************/
//#define MAXATOMS 9800

static GtkWidget *constraints_dlg = NULL, *father;
static int spec_sel;
static int to_delete = -1;
static int selezione = -1;


static void fill_stringa(char *stringa, size_t sz, int nonprimo, int iord, int ph)
{
   if(nonprimo)
      AppendiStringa(stringa, sz, " = ");
   AppendiStringa(stringa, sz, "B(");
   AppendiStringa(stringa, sz, crys[ph].GetAtomName1(iord).c_str());
   AppendiStringa(stringa, sz, ")");
}

void init_constraints2(int ph)
{
   GtkWidget *lista;
   int i, j, iord, nthc;
   char *stringa;

   lista = get_widget(constraints_dlg, "listaconstr");
   clear_list(lista);
   nthc = 0;
   for(i=0; i<crys[ph].Nconstraints(); i++)
   {
       if (crys[ph].Constr(i).typec == 1) {// don't display program constraints
           switch (crys[ph].Constr(i).code)
           {
           case 1:                         // thermal factor constraint
                crys[ph].ind_Con[nthc] = i;
                nthc++;
                stringa = g_new0(char, 256);
                for(j=0; j<crys[ph].Constr(i).npar; j++)
                {
                    iord = crys[ph].Constr(i).vat[j] - 1;
                    fill_stringa(stringa, 256, j, iord, ph);
                    crys[ph].dispo[iord] = 0;
                }
                add_line_to_list(lista, (gpointer) stringa);
                break;
            default:
                break;
            }
       }
   }
}

void riempi_listaAtomi(GtkWidget *lista, int ph)
{
  int i;
  char *riga;

  clear_list(lista);
  for(i=0; i<crys[ph].GetNats(); i++)
  {
     riga = g_strdup(crys[ph].GetAtomName1(i).c_str());
     add_line_to_list(lista, (gpointer) riga);
     if(crys[ph].dispo[i])
           set_cell_color(lista, i, 0, "blue");
     else
           set_cell_color(lista, i, 0, "red");
   }
   unselect_all(GTK_TREE_VIEW(lista));
}

void close_constraints(GtkButton *button, gpointer data)
{
  int ifOk = GPOINTER_TO_INT(data);

  if(ifOk)
  {
     int ph = ifOk - 1;
     GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
     GtkWidget *w = get_widget(dlg, "riding_model");
     crys[ph].SetRM(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(w)));
     w = get_widget(dlg, "spin_hyd");
     crys[ph].SetADP((float) spin_button_get_value(w));
     setta_constraints(ph);
  }
  
  close_dlg(button, GINT_TO_POINTER(11));

  if(father)
  {
     FillAtomicParameters(father);
     gtk_widget_show(father);
  }
}

void sele_dispo(GtkToggleButton *button, gpointer data)
{
   int i;
   int ph = GPOINTER_TO_INT(data);
   GtkWidget *lista = get_widget(constraints_dlg, "listaatomi");

   for(i=0; i<crys[ph].GetNats(); i++)
   {
       if(crys[ph].dispo[i])
          select_row(lista, i);
   }
}

void sele_spec(GtkWidget *list, gpointer data)
{
   int i, ph = GPOINTER_TO_INT(data);
   int nspec = crys[ph].GetNelems();

   GtkWidget *lista = get_widget(constraints_dlg, "listaatomi");
   GtkWidget *widget = get_widget(list, "entry");

   if((selezione == 0) || (selezione > nspec))
      return;
   spec_sel = crys[ph].GetElemptab(selezione-1);
   for(i=0; i<crys[ph].GetNats(); i++)
   {
       if((crys[ph].GetAtom(i).ptab == spec_sel) && crys[ph].dispo[i])
          select_row(lista, i);
   }
   gtk_entry_set_text(GTK_ENTRY(widget), " ");
}

static void del_constr(GtkButton *button, gpointer data)
{
   int i, iord, n_to_free;
   int ph = GPOINTER_TO_INT(data);
   GtkWidget *list = get_widget(constraints_dlg, "listaconstr");
   int constr_to_delete = crys[ph].ind_Con[to_delete];

   if(to_delete == -1)
      return;

   n_to_free = crys[ph].Constr(constr_to_delete).npar;
   for(i=0; i<n_to_free; i++)
   {
       iord = crys[ph].Constr(constr_to_delete).vat[i] - 1;
       crys[ph].dispo[iord] = 1;
   }
   crys[ph].del_constraint(constr_to_delete);
   for(i=constr_to_delete+1; i<crys[ph].Nconstraints(); i++)
       crys[ph].ind_Con[i-1] = crys[ph].ind_Con[i];

   remove_nth_line(list, to_delete+1);
   crys[ph].DecNconstr();
   list = get_widget(constraints_dlg, "listaatomi");
   riempi_listaAtomi(list, ph);
}

static void add_constr(GtkButton *button, gpointer data)
{
   int ph = GPOINTER_TO_INT(data);
   int nats1 = crys[ph].GetNats();
   int i, ksel, *selAt=g_new0(int, nats1);
   char *stringa;
   GtkWidget *list = get_widget(constraints_dlg, "listaconstr");
   
   ksel = 0;
   stringa = g_new0(char, 300);
   for(i=0; i<nats1; i++)
   {
       if(crys[ph].selected_r[i])
       {
          fill_stringa(stringa, 300, ksel, i, ph);
          crys[ph].dispo[i] = 0;
          crys[ph].selected_r[i] = 0;
          selAt[ksel] = i+1;
          ksel++;
       }
   }
   if(ksel >= 2)
   {
       int *vpar = g_new0(int, ksel);
       int *vat = g_new0(int, ksel);
       float *coef = g_new0(float, ksel);
       int kk;
       
       bool result = crys[ph].Reallocconstr();
       if(!result)
       {
           (void) cMsgWinErr("Error", "Not enough memory for constraints.", ERR_WINDOW);
           exit(1);
       }
       for (kk=0; kk<ksel; kk++)
       {
           vpar[kk] = 4;
           coef[kk] = 1;
           vat[kk]  = selAt[kk];
       }
       crys[ph].add_constraint(1, ksel, 0, vpar, vat, coef, 0.0, crys[ph].Nconstraints(), 1, 1);
       crys[ph].ind_Con[n_children(list)] = crys[ph].Nconstraints();
       crys[ph].IncNconstr();
      
       add_line_to_list(list, (gpointer) stringa);
   }
   else if(ksel == 1)
   {
      i = selAt[0] - 1;
      crys[ph].dispo[i] = 1;
   }
   list = get_widget(constraints_dlg, "listaatomi");
   riempi_listaAtomi(list, ph);
   unselect_all(GTK_TREE_VIEW(list));
   g_free(selAt);
}

static void add_selection (GtkTreeSelection *selec, gpointer data)
{
   GList *rowsel;
   int row, num_sel, riga;
   GtkTreePath *path;
   GtkTreeView *list = gtk_tree_selection_get_tree_view(selec);
   int ph = GPOINTER_TO_INT(data);

   rowsel = get_selections(GTK_WIDGET(list));
   num_sel = g_list_length(rowsel);
   for (row=0; row<crys[ph].GetNats(); row++)
        crys[ph].selected_r[row] = 0;
   for(row=0; row<num_sel; row++)
   {
      path = (GtkTreePath *) g_list_nth_data (rowsel, row);
      riga = atoi(gtk_tree_path_to_string(path));
      if(crys[ph].dispo[riga] == 0)
      {
         unselect_row(GTK_WIDGET(list), riga);
         crys[ph].selected_r[riga] = 0;
      }
      else
         crys[ph].selected_r[riga] = 1;
   }
   g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
   g_list_free (rowsel);
}


static void select_to_del (GtkTreeSelection *select, gpointer data)
{
   GtkWidget *button = get_widget(constraints_dlg, "del_co");
   GtkTreeIter iter;
   int row = row_selected(select);
 
   gtk_widget_set_sensitive(button, FALSE);
   to_delete = -1;
   if(row != -1)
   {
      if(gtk_tree_selection_get_selected (select, NULL, &iter))
      {
         gtk_widget_set_sensitive(button, TRUE);
         to_delete = row;
      }
      else
         gtk_widget_set_sensitive(button, FALSE);
   }
}

void clist_unselect_all(GtkButton *button, GtkWidget *list)
{
    unselect_all(GTK_TREE_VIEW(list));
}

static gboolean cb_sele(GtkTreeSelection *selection, GtkTreeModel *model,
                        GtkTreePath *path, gboolean path_currently_selected,
                        gpointer data)
{
    int row = atoi(gtk_tree_path_to_string(path));;
    GtkTreeView *list = gtk_tree_selection_get_tree_view(selection);
    int ph = GPOINTER_TO_INT(data);

    if(path_currently_selected)
    {
        if(crys[ph].dispo[row] == 1)
           set_cell_color(GTK_WIDGET(list), row, 0, "blue");
        else 
           set_cell_color(GTK_WIDGET(list), row, 0, "red");
    }
    else
    {
        if(crys[ph].dispo[row] == 1)
           set_cell_color(GTK_WIDGET(list), row, 0, "#ccccff");
        else
           set_cell_color(GTK_WIDGET(list), row, 0, "#ffcccc");
    }
    return TRUE;
}

void unselect_specie(GtkToggleButton *button, GtkWidget *combo)
{
    if(gtk_toggle_button_get_active(button))
    {
       GtkWidget *widget = get_widget(combo, "entry");
       gtk_entry_set_text(GTK_ENTRY(widget), " ");
    }
}

GtkWidget* create_constraints_dialog (int ph)
{
  GtkWidget *dialog1, *vbox1, *table1, *clist, *button, *align;
  GtkWidget *vbox, *frame, *combo_spe, *align1, *check;
  GSList *group = NULL;

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "Constraints");
//  gtk_window_set_title (GTK_WINDOW (dialog1), "Thermal Parameter Constraints");
//  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);
  gtk_widget_set_size_request (dialog1, 480, 400);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG (dialog1));
  gtk_container_set_border_width(GTK_CONTAINER(vbox1), 6);

  GtkWidget *notebook = NewNotebook (vbox1);
  //gtk_box_pack_start (GTK_BOX (vbox1), notebook, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (notebook), 8);
  gtk_widget_show (notebook);

//Primo tab Thermal Parameters

  GtkWidget *vbox2 = vbox_new (FALSE,0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (notebook), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 15);

  table1 = table_new (5, 2, FALSE);
  gtk_box_pack_start (GTK_BOX (vbox2), table1, TRUE, TRUE, 0);
  table_set_row_spacings (table1, 14);
  table_set_col_spacings (table1, 24);

  frame = FRAME_NEW("Atoms", MyBLUE);
  clist = create_selection(dialog1, frame, NULL, "listaatomi", 0);
  table_attach (table1, frame, 0, 1, 0, 3, TRUE);
  set_selection_mode(clist, GTK_SELECTION_MULTIPLE);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(clist, TRUE);
#endif

  (void) g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(clist))),
         "changed",  G_CALLBACK(add_selection), GINT_TO_POINTER(ph));
  gtk_tree_selection_set_select_function (gtk_tree_view_get_selection(GTK_TREE_VIEW(clist)),
                                         (GtkTreeSelectionFunc) cb_sele,
                                          GINT_TO_POINTER(ph),NULL);


  frame = gtk_frame_new("Selections");
  table_attach (table1, frame, 1, 2, 0, 2);

  vbox = vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(frame), vbox);

  button = RADIO_BUTTON_WITH_LABEL (group, " ", LABELCOLOR);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
  g_object_set_data(G_OBJECT(dialog1), "nascosto", button);
  
  button = RADIO_BUTTON_WITH_LABEL (group, "Select All", LABELCOLOR);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
  g_signal_connect(G_OBJECT(button), "toggled", 
                   G_CALLBACK(sele_dispo), GINT_TO_POINTER(ph));
  
  button = RADIO_BUTTON_WITH_LABEL (group, "Unselect All", LABELCOLOR);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
  g_signal_connect(G_OBJECT(button), "toggled", 
                   G_CALLBACK(clist_unselect_all), G_OBJECT(clist));
  
  button = RADIO_BUTTON_WITH_LABEL (group, "Select species", LABELCOLOR);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);

  combo_spe = create_combo(vbox, NULL, 0, 0, &selezione);
  g_object_set_data(G_OBJECT(dialog1), "combo_spe", combo_spe);
  gtk_widget_set_sensitive(combo_spe, FALSE);
  g_signal_connect(G_OBJECT(button), "toggled", 
                   G_CALLBACK(on_cb_attiva), combo_spe);
  g_signal_connect(G_OBJECT(button), "toggled", 
                   G_CALLBACK(unselect_specie), combo_spe);

#ifdef IN_GTK3
  align1 = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
  align1 = gtk_alignment_new(0.5f, 0.5f, 0.f, 0.f);
#endif

  button = myimage_button("Add", "add.png"); //xpm_button ("block_add.xpm");
  gtk_container_add(GTK_CONTAINER(align1), button);
  table_attach (table1, align1, 1, 2, 2, 3);
  g_signal_connect(G_OBJECT(button), "clicked", 
                    G_CALLBACK(add_constr), GINT_TO_POINTER(ph));
  set_tip(button, 
        "Select atoms for constraint and press this button");

  align = hseparator_new();
  table_attach (table1, align, 0, 2, 3, 4, TRUE);

  frame = gtk_frame_new("Constraints");
  table_attach (table1, frame, 0, 2, 4, 5, TRUE);

  align = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame), align);

  clist = create_selection(dialog1, align, NULL, "listaconstr", 0);
  (void) g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(clist))), 
               "changed", G_CALLBACK(select_to_del), NULL);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(clist, TRUE);
#endif

#ifdef IN_GTK3
  align1 = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
  align1 = gtk_alignment_new(0.5f, 0.5f, 0.f, 0.f);
#endif

  gtk_box_pack_start(GTK_BOX(align), align1, FALSE, FALSE, 6);
  button = myimage_button("Cut", "cancel.png"); //xpm_button ("block_del.xpm");
  gtk_widget_set_sensitive(button, FALSE);
  g_object_set_data(G_OBJECT(dialog1), "del_co", button);
  g_signal_connect(G_OBJECT(button), "clicked", 
                    G_CALLBACK(del_constr), GINT_TO_POINTER(ph));
  gtk_container_add(GTK_CONTAINER(align1), button);
  set_tip(button, "Select constraints to be deleted and press this button");
  set_tab_label (GTK_NOTEBOOK (notebook), 0, "Thermal Parameters");

//Secondo tab Hydrogens

  vbox2 = vbox_new (FALSE,0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (notebook), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 15);

  table1 = table_new (2, 3, FALSE);
  gtk_box_pack_start (GTK_BOX (vbox2), table1, TRUE, TRUE, 0);
  table_set_row_spacings (table1, 14);
  table_set_col_spacings (table1, 24);
  check = CHECK_BUTTON_WITH_LABEL ("Apply 'riding model' on H-X bonds", NULL);
  g_object_set_data (G_OBJECT (dialog1), "riding_model", check);
  gtk_widget_show (check);
  table_attach_exp(table1, check, 0, 3, 0, 1);
  GtkWidget *label = LABEL_NEW("ADP(H) =", NULL);
  set_alignment(label, 0., 0.5);
  table_attach_exp(table1, label, 0, 1, 1, 2);
  label = LABEL_NEW("* ADP(X)", NULL);
  set_alignment(label, 0., 0.5);
  table_attach_exp(table1, label, 2, 3, 1, 2);
  GtkWidget *spin = SPIN_NEW(0.10f, 5, 1.2f, 0.1f, 2);
  table_attach(table1, spin, 1, 2, 1, 2);
  set_width_chars(GTK_ENTRY(spin), 6);
  set_tab_label (GTK_NOTEBOOK (notebook), 1, "Hydrogens");
  g_object_set_data (G_OBJECT (dialog1), "spin_hyd", spin);

  button = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 1);
  g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK(close_constraints), GINT_TO_POINTER(ph+1));

  button =  CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 2);
  g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK(close_constraints), GINT_TO_POINTER(0));

  g_signal_connect_swapped (G_OBJECT(dialog1), "delete_event",
           G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
       GTK_BUTTONBOX_SPREAD);

  return dialog1;
}

void open_constraints(GtkWidget *widget, gpointer data)
{
   GtkWidget *lista;
   int ph = GPOINTER_TO_INT(data);

   father = gtk_widget_get_toplevel(widget); 
   //if (!constraints_dlg)
       constraints_dlg = create_constraints_dialog(ph);
//   init_constraints();
  gtk_window_set_transient_for(GTK_WINDOW(constraints_dlg), GTK_WINDOW(finestre[0]));
  int nspec = crys[ph].GetNelems();
  char **Species = g_new0(char *, nspec);
  for (int nn=0; nn<nspec; nn++)
      Species[nn] = g_strdup(crys[ph].GetElemName(nn).c_str());

   GtkWidget *combo_spe =  get_widget(constraints_dlg, "combo_spe");
   fill_combo(combo_spe, (const char **)Species, nspec, 0);
   combo_changed(combo_spe, G_CALLBACK(sele_spec), GINT_TO_POINTER(ph));
   for (int nn=0; nn<nspec; nn++)
     g_free(Species[nn]);
   g_free(Species);
   
   init_constraints2(ph);
   lista = get_widget(constraints_dlg, "listaatomi");
   riempi_listaAtomi(lista, ph);
   gtk_widget_show_all(constraints_dlg);
   lista = get_widget(constraints_dlg, "nascosto");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lista), TRUE);
   gtk_widget_hide(lista);

     GtkWidget *w = get_widget(constraints_dlg, "riding_model");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), crys[ph].RidingModel());
     w = get_widget(constraints_dlg, "spin_hyd");
     spin_button_set_value(w, (double) crys[ph].ADP());

   if(father)
      gtk_widget_hide(father);
   finestra_modale_aperta2(constraints_dlg);
}

extern "C" {

void passa_bkcond_(back_condition_type *backr)
{
   backriet = *backr;
}

void open_rietdlg_(refine_condition_type *refcondl,
                   back_condition_type *backr)
{
   refcond = *refcondl;
   backriet = *backr;
   specv.clear();
//
   init_constraints();
   open_rietveld_dlg();
}

void passa_num_constraints_(int *n, int *ph)
{
   crys[*ph-1].SetNconstr(*n);
}

void passa_constr_(int *code, int *npar, int *ref, int vpar[], int vat[],
      float coef[], float *sumc, int *quale, int *typec, int *npari, int *ph)
{
   int i;

   i = *quale - 1;
   crys[*ph-1].add_constraint(*code, *npar, *ref, vpar, vat, coef, *sumc,
      i, *typec, *npari);
}

void put_info_crystal_(int *numph,int *natoms,int *nelem,
                                  crystal_t *cryph)
{
   natomsC = natoms;
   nelemC  = nelem;
   numphC  = *numph;
   cryphC = cryph;
   crys = g_new0(Crystal, numphC);
}

void put_info_ph_(element_type *elem, atom_type *at, int *i)
{
   int j = *i-1;
   crys[j].FillCrystal(natomsC[j], nelemC[j], cryphC[j], at, elem);
}

void put_info_pr_(profile_function_t *pe,
                  profile_function_t *pv, profile_function_t *tchl,
                  int *typefun, int *i, int *k)
{
   int j = *i-1;
   dataset[*k-1].pear[j] = *pe;
   dataset[*k-1].pvoi[j] = *pv;
   dataset[*k-1].tch[j]  = *tchl;
   dataset[*k-1].typefun[j]  = *typefun;
}

void put_info_po_(int *kopcorr, int *hklpo, int *gcode, float *gpar, int *i)
{
   int j = *i-1;
   crys[j].SetKopcorr(*kopcorr);
   for(int k=0; k<3; k++)
       crys[j].SetHKLpo(k, hklpo[k]);
   crys[j].SetGpar(*gpar);
   crys[j].SetGcod(*gcode);
}

void put_info_dataset_(dataset_t *ds)
{
   dataset = g_new0(Dataset, 1);
   memcpy(dataset, ds, sizeof(dataset_t));
   dataset[0].typefun = g_new0(int, numphC);
   dataset[0].pvoi = g_new0(profile_function_t, numphC);
   dataset[0].pear = g_new0(profile_function_t, numphC);
   dataset[0].tch  = g_new0(profile_function_t, numphC);
}

void print_crystalc_()
{
   for(int nph=0; nph<numphC; nph++)
       crys[nph].PrintCrystal();
}

}

