#include "mrconfig.h"
extern int jscreen;
extern GtkWidget *finestre[6];
extern gboolean single_it;
extern _Dialogo *dialogo;
#ifndef SIR_PGM
extern style_type Style[NITEMS];
#else
void pop_from_vett(GtkWidget *dlg);
void push_in_vett(GtkWidget *dlg);
#endif

GtkWidget *viewer_window = NULL;
typedef struct {
                 GtkWidget *widget;
                 gpointer  pix;
                 char      *title;
                 int       width;
                 int       height;
                 int       ifResize;
                 void      (*cbResize)(int *, int *);
                 void      (*cbZoom)(int *);
               } _Viewer;
extern "C" void onopen_();
extern "C" void onclose_();
extern "C" void onzoom_event_(int *action);
extern "C" int iffortranwork_();
gboolean ManageExpose (GtkWidget *widget, gpointer obj, gpointer );
float *get_fcolor(int new_color);
void setta_foreground(int new_color, gpointer context);

static int NMESSAGES=12;
static bool AreaMessaggi = false;

gboolean destroy (GtkWidget *widget, GdkEvent *event, gpointer data)
{
   dialogo->viewerOpened = FALSE;
   viewer_window = NULL;
   return FALSE;
}

void on_zoomin(GtkButton *button, _Viewer *view)
{
    int action = 1;
    if(iffortranwork_())
       view->cbZoom(&action);
    else
       onzoom_event_(&action);
}

void on_zoomout(GtkButton *button, _Viewer *view)
{
    int action = -1;
    if(iffortranwork_())
       view->cbZoom(&action);
    else
       onzoom_event_(&action);
}

void on_zoomnormal(GtkButton *button, _Viewer *view)
{
    int action = 0;
    if(iffortranwork_())
       view->cbZoom(&action);
    else
       onzoom_event_(&action);
}

void on_close(GtkWidget *button, _Viewer *view)
{
    onclose_();
}

gboolean onViewer_configure_event     (GtkWidget       *widget,
                                       GdkEventConfigure *event,
                                       gpointer        data)
{
    _Viewer *view = (_Viewer *) data;
    gpointer pixmap;
    gpointer context;
    os_and_gc *rt;
    GtkAllocation allocation;
    gtk_widget_get_allocation(widget, &allocation);
    int x = (int)allocation.width;
    int y = (int)allocation.height;
    int wP = get_int(widget, "wP");
    int hP = get_int(widget, "hP");
    if((wP == x) && (hP == y))
       return TRUE;
    wP = x;
    hP = y;

    if (get_object(widget, "context") != NULL)
        context = get_object(widget, "context");
    else
        context = NULL;
    if (get_object(widget, "offscreen") != NULL)
        pixmap = get_object(widget, "offscreen");
    else
        pixmap = NULL;

    destroy_os_and_gc(pixmap, context);
    rt = get_os_and_gc(widget);
    pixmap = rt->os;
    context = rt->gc;
    g_free(rt);
    g_object_set_data(G_OBJECT(widget), "context", context);
    g_object_set_data( G_OBJECT(widget), "offscreen", pixmap);
    g_object_set_data( G_OBJECT(widget), "wP", GINT_TO_POINTER(wP));
    g_object_set_data( G_OBJECT(widget), "hP", GINT_TO_POINTER(hP));

    GdkColor colorWhite = White;
    set_foreground(context, &colorWhite);
    draw_rectangle (pixmap, context, TRUE, 0, 0,
                         (int)allocation.width,
                         (int)allocation.height);
    mr_send_viewer_pixmap(widget);

    if(view != NULL)
    {
       view->pix = pixmap;
       if(view->ifResize)
          view->cbResize(&x, &y);
    }
    return TRUE;
}

GtkWidget *CreateViewer(_Viewer *view)
{
  GtkWidget *window;
  GtkWidget *frame;
  GtkWidget *box1;
  GtkWidget *hbox;
  GtkWidget *button;
  GtkWidget *viewer;
 
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  
  gtk_window_set_position (GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
  (void) g_signal_connect (G_OBJECT (window), "destroy",
                      G_CALLBACK(destroy), NULL);
  gtk_window_set_title (GTK_WINDOW (window), view->title);
  gtk_container_set_border_width (GTK_CONTAINER (window), 0);
  gtk_window_set_resizable(GTK_WINDOW(window), view->ifResize);
  box1 = vbox_new(FALSE, 2);
  gtk_container_add(GTK_CONTAINER(window), box1);
  gtk_widget_show(box1);
  gtk_container_set_border_width(GTK_CONTAINER(box1), 6);
  
  if(view->ifResize)
  {
     frame = gtk_frame_new(NULL);
     gtk_widget_show (frame);
     gtk_box_pack_start (GTK_BOX (box1), frame, FALSE, FALSE, 0);

     hbox = hbox_new(FALSE, 0);
     gtk_widget_show (hbox);
     gtk_container_add (GTK_CONTAINER (frame), hbox);
  }

  /* Create the Drawable widget */
  viewer = gtk_drawing_area_new ();
  gtk_widget_set_size_request(viewer, view->width, view->height);
  gtk_box_pack_start (GTK_BOX (box1), viewer, TRUE, TRUE, 0);
  g_object_set_data(G_OBJECT(window), "viewer", viewer);
  g_object_set_data(G_OBJECT(viewer), "offscreen", NULL);
  g_object_set_data( G_OBJECT(viewer), "wP", GINT_TO_POINTER(0));
  g_object_set_data( G_OBJECT(viewer), "hP", GINT_TO_POINTER(0));
  view->widget = viewer;
  view->pix = NULL;
  (void) g_signal_connect (G_OBJECT (viewer), "configure_event",
                      G_CALLBACK (onViewer_configure_event),
                      (gpointer) view);
  (void) g_signal_connect (G_OBJECT (viewer), DRAW_EVENT,
                      G_CALLBACK (ManageExpose),
                      NULL);

  gtk_widget_show (viewer);

  if(view->ifResize)
  {
     button = toolbar_button("zoom_in.png");
     gtk_widget_show (button);
     gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 10);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         G_CALLBACK(on_zoomin), view);
     set_tip (button, "Zoom In(+)");

     button = toolbar_button("zoom_out.png");
     gtk_widget_show (button);
     gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 10);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         G_CALLBACK(on_zoomout), view);
     set_tip (button, "Zoom Out(-)");

     button = toolbar_button("zoom_normal.png");
     gtk_widget_show (button);
     gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 10);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         G_CALLBACK(on_zoomnormal), view);
     set_tip (button, "Zoom Fit(Reset View)");

     button = toolbar_button("cancel.png");
     gtk_widget_show (button);
     gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 10);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         G_CALLBACK(on_close), view);
     set_tip (button, "Close Viewer");

     (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
           G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  }
  else
     (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
           G_CALLBACK(on_close), view);
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window;
}

int altezza_viewer()
{
    GtkAllocation allocation;
    gtk_widget_get_allocation(get_widget(finestre[0], "DAbox"), &allocation);
    int htot = (int) allocation.height;
    gtk_widget_get_allocation(get_widget(finestre[0], drawingareaname), &allocation);
    int hDA = (int) allocation.height;
    int h = htot - hDA - 5;
#ifdef IN_GTK3
    h +=3;
#endif
    return h;
}

void do_configure(GtkWidget *widget, int w, int h)
{
    gpointer pixmap;
    _Viewer *view = (_Viewer *) get_object(widget, "view");
    gpointer context;
    os_and_gc *rt;
    int hnd = get_int(widget, "hnd_expose");
    g_signal_handler_block(G_OBJECT(widget), hnd);

    if (get_object(widget, "context") != NULL)
        context = get_object(widget, "context");
    else
        context = NULL;

    if (get_object(widget, "offscreen") != NULL)
        pixmap = get_object(widget, "offscreen");
    else
        pixmap = NULL;

    destroy_os_and_gc(pixmap, context);
    rt = get_os_and_gc(widget);
    pixmap = rt->os;
    context = rt->gc;
    g_free(rt);
    g_object_set_data(G_OBJECT(widget), "context", context);
    g_object_set_data( G_OBJECT(widget), "offscreen", pixmap);
#ifdef SIR_PGM
    setta_foreground(dialogo->jBackGround, context);
#else
    setta_foreground(Style[STYLE_BG].colline, context);
#endif
    draw_rectangle (pixmap, context, TRUE, 0, 0, w, h);
    if(view != NULL)
    {
       view->pix = pixmap;
       if(view->ifResize)
       {
//          g_print("do_configure %d  %d\n", w, h);
          mr_send_viewer_pixmap(widget);
          view->cbResize(&w, &h);
          mr_restore_pixmap();      //aggiunta il 26/03/2013
       }
    }
    g_signal_handler_unblock(G_OBJECT(widget), hnd);
}

gboolean onView_configure_event (GtkWidget *widget,
            GdkEventConfigure *event, gpointer)
{
    GtkAllocation alloc;
    gtk_widget_get_allocation(widget, &alloc);
    int w = (int)alloc.width;
    int h = altezza_viewer();
//mr 190414 aggiunto anche controllo su hP 
    int wP = get_int(widget, "wP");
    int hP = get_int(widget, "hP");
    if((wP == w) && (hP == h))
       return TRUE;
    do_configure(widget, w, h);
    g_object_set_data( G_OBJECT(widget), "wP", GINT_TO_POINTER(w));
    g_object_set_data( G_OBJECT(widget), "hP", GINT_TO_POINTER(h));
    g_signal_stop_emission_by_name(G_OBJECT(widget), "configure_event");
    return TRUE;
}

GtkWidget *CreateSideFrame(GtkWidget *main_window, int ori)
{
  GtkWidget *frame;

  if(ori == 'v')
     frame = hpaned_new();
  else
     frame = vpaned_new();
  gtk_widget_show (frame);
  g_object_set_data (G_OBJECT (main_window), "area_messaggi", frame);
  g_object_set_data (G_OBJECT (main_window), "paned2", frame);

  GtkWidget *frame2 = gtk_frame_new(NULL);
  gtk_paned_pack1((GtkPaned *)frame, frame2, TRUE, TRUE);
  gtk_widget_show (frame2);
  g_object_set_data (G_OBJECT (main_window), "area_testo", frame2);
  GtkWidget *vbox = vbox_new(FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_set_border_width(GTK_CONTAINER(vbox), 8);
  gtk_container_add(GTK_CONTAINER(frame2), vbox);
  for(int i=0; i<NMESSAGES; i++)
  {
      std::stringstream nome;
      nome << "messaggi" << i+1;
      GtkWidget *label = LABEL_NEW(" ", NULL);
      gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
      gtk_widget_show (label);
      g_object_set_data (G_OBJECT (main_window), nome.str().c_str(), label);
      set_alignment(label, 0., 0.);
      gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
#ifndef NOELLIPSIZE
      gtk_label_set_ellipsize(GTK_LABEL(label), PANGO_ELLIPSIZE_END);
#else
      gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
#endif
  }

  // Create the Drawable widget 
  GtkWidget *viewer = gtk_drawing_area_new ();
  gtk_paned_pack2((GtkPaned *)frame, viewer, TRUE, TRUE);
  g_object_set_data(G_OBJECT(main_window), "area_grafica2", viewer);
  g_object_set_data(G_OBJECT(viewer), "offscreen", NULL);
  int hnd = g_signal_connect (G_OBJECT (viewer), "configure_event",
                      G_CALLBACK (onView_configure_event), NULL);
  g_object_set_data(G_OBJECT(viewer), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(viewer), "wP", GINT_TO_POINTER(0));
  g_object_set_data(G_OBJECT(viewer), "hP", GINT_TO_POINTER(0));

  hnd = g_signal_connect (G_OBJECT (viewer), DRAW_EVENT,
                      G_CALLBACK (ManageExpose),
                      NULL);
  g_object_set_data(G_OBJECT(viewer), "hnd_expose", GINT_TO_POINTER(hnd));

  gtk_widget_show (viewer);

  return frame;
}

int nuovovisualizzatore1(int *action, int *x , int *y , int *ifRes, char *istring,
                         void (*cbResize)(int  *p1, int  *p2),
                         void (*cbZoom)(int  *p1))
{
  int Act = *action;

  if(!jscreen)
     return 0;

  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();

  GtkWidget *viewer_win = get_widget(finestre[0], "area_grafica2");
  switch(Act)
  {
  case 1:              // Open Viewer
  case 2:              // Open Viewer (compatibilita' con vecchio)
       if(!dialogo->viewerOpened)
       {
          _Viewer *view = g_new0(_Viewer, 1);
          view->title    = DuplicaStringa(istring);
          view->width    = -1;    //*x;
          view->height   = -1;    //*y;
          view->widget   = NULL;
          view->pix      = NULL;
          view->ifResize = *ifRes;
          view->cbResize = cbResize;
          view->cbZoom   = cbZoom;
          view->widget = viewer_win;
          if(view->ifResize)
          {
              int hnd = get_int(viewer_win, "hnd");
              if(hnd)
                 g_signal_handler_disconnect(G_OBJECT(viewer_win), hnd);
              hnd = g_signal_connect(G_OBJECT(viewer_win),  "configure_event",
                         G_CALLBACK (onView_configure_event), (gpointer) view);
              g_object_set_data(G_OBJECT(viewer_win), "hnd", GINT_TO_POINTER(hnd));
              g_object_set_data(G_OBJECT(viewer_win), "view", (gpointer) view);
          }
       }
  case 4:             // Restore Viewer
       mr_send_viewer_pixmap(viewer_win);
       break;

  case 3:              // Restore Main Window
       mr_restore_pixmap();
       break;
  case 5:              // Close Viewer
       mr_restore_pixmap();
       dialogo->viewerOpened = FALSE;
       break;
  }
  return 0;
}

int nuovovisualizzatore2(int *action, int *x , int *y , int *ifRes, char *istring,
                         void (*cbResize)(int  *p1, int  *p2),
                         void (*cbZoom)(int  *p1))
{
  static _Viewer view;
  int Act;
  static GtkWidget *my_dlg;
  GtkWidget *viewer_win;
  const char *string = DuplicaStringa(istring);

  Act = *action;

  if(!jscreen)
     return 0;
  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();
  switch(Act)
  {

  case 1:              // Open Viewer
  case 2:              // Open Viewer (compatibilita' con vecchio)

       if(!dialogo->viewerOpened)
       {
          view.title    = DuplicaStringa(string);
          view.width    = *x;
          view.height   = *y;
          view.widget   = NULL;
          view.pix      = NULL;
          view.ifResize = *ifRes;
          view.cbResize = cbResize;
          view.cbZoom   = cbZoom;
          my_dlg        = CreateViewer(&view);
#ifdef SIR_PGM
          push_in_vett(my_dlg);
#endif
          gtk_widget_show(my_dlg);
       }
       break;

  case 3:              // Restore Main Window

       mr_restore_pixmap();
       break;

  case 4:             // Restore Viewer

       if(my_dlg)
       {
          viewer_win = get_widget(my_dlg, "viewer");
          mr_send_viewer_pixmap(viewer_win);
       }
       else
       {
          MessageDialog("Programming Error", 0, 0, finestre[0], GTK_MESSAGE_ERROR,
                    GTK_BUTTONS_CLOSE, "Attempt to restore closed viewer");
          return -1;
       }
       break;

  case 5:              // Close Viewer
       
#ifdef SIR_PGM
       pop_from_vett(my_dlg);
#endif
       if(GTK_IS_WIDGET(my_dlg))
           gtk_widget_destroy (my_dlg);
       my_dlg = NULL;
       viewer_window = NULL;
       dialogo->viewerOpened = FALSE;
       break;

  }
  return 0;
}

extern "C" 
{
int nuovovisualizzatore_(int *action, int *x , int *y , int *ifRes, char *istring,
                         void (*cbResize)(int  *p1, int  *p2),
                         void (*cbZoom)(int  *p1))
{
  if(!jscreen)
      return 0;
  GtkWidget *wid = get_widget(finestre[0], "area_messaggi");
  if(gtk_widget_get_visible(wid))
     return nuovovisualizzatore1(action, x , y , ifRes, istring,
                         cbResize, cbZoom);
  else
     return nuovovisualizzatore2(action, x , y , ifRes, istring,
                         cbResize, cbZoom);
}

int is_new_viewer_opened_()
{
  if(!jscreen)
      return 0;
  GtkWidget *wid = get_widget(finestre[0], "area_messaggi");
  return gtk_widget_get_visible(wid);
}

void new_viewer_size_(int *x, int *y)
{
  if(!jscreen)
      return;
  GtkAllocation allocation;
  GtkWidget *viewer = get_widget(finestre[0], "area_grafica2");
  gtk_widget_get_allocation(viewer, &allocation);
  *x = (int) allocation.width;
  *y = altezza_viewer(); //(int) allocation.height;
}

void setmesg_(int *colore, int *fontsize, int *i, int *justify)
{
    if(!jscreen)
      return;
    if(*i > NMESSAGES)
       return;
    if(*colore < 0)
       *colore = dialogo->color_BLUE;
    int just = *justify;
    if((just < 0) || (just > 3))
       just = 0;
    float *fcol = get_fcolor(*colore);
    char *strcol = g_strdup_printf("#%2.2X%2.2X%2.2X", 
       (int) (fcol[0]*255),(int) (fcol[1]*255),(int) (fcol[2]*255));
    PangoFontDescription *newfdesc  = DefaultFont();
    pango_font_description_set_size (newfdesc, (*fontsize)*PANGO_SCALE);
    std::stringstream nome;
    nome << "messaggi" << *i;
    GtkWidget *label = get_widget(finestre[0], nome.str().c_str());
    char *strfont = pango_font_description_to_string(newfdesc);
    g_object_set_data(G_OBJECT(label), "markup", g_strdup_printf(
        "<span foreground=\"%s\" font_desc=\"%s\">%%s</span>",
        strcol, strfont));

    g_free(strcol);
    g_free(strfont);
    pango_font_description_free(newfdesc);
    g_free(fcol);
    //widget_modify_fg(label, GTK_STATE_NORMAL, gdkcolor);
    //widget_modify_fg(label, GTK_STATE_ACTIVE, gdkcolor);
    //widget_modify_font(label, newfdesc);
    //pango_font_description_free(newfdesc);
    gtk_label_set_justify (GTK_LABEL (label), (GtkJustification) just);
    switch(just)
    {
    case 0:
         set_alignment(label, 0.f, 0.5f);
         break;
    case 1:
         set_alignment(label, 1.f, 0.5f);
         break;
    case 2:
         set_alignment(label, 0.5f, 0.5f);
         break;
    }
}

void writemesg_(char *mesg, int *i)
{
    if(!jscreen)
      return;
    if(*i > NMESSAGES)
       return;
    if(AreaMessaggi)
       gtk_widget_show(get_widget(finestre[0], "area_messaggi"));
    std::stringstream nome;
    nome << "messaggi" << *i;
    GtkWidget *label = get_widget(finestre[0], nome.str().c_str());
    char *format = (char *) get_object(label, "markup");
    
    char *messaggio = g_strdup(toUTF8(mesg));
    char *markup = g_markup_printf_escaped (format, g_strstrip(messaggio));
    gtk_label_set_markup (GTK_LABEL (label), markup);
    g_free (markup);
//    gtk_label_set_text(GTK_LABEL(label),
//           g_strstrip(messaggio));
    while(gtk_events_pending())
         (void) gtk_main_iteration();
    g_free(messaggio);
}

void clearmesg_()
{
    if(!jscreen)
      return;
    for(int i=0; i<NMESSAGES; i++)
    {
        std::stringstream nome;
        nome << "messaggi" << i+1;
        GtkWidget *label = get_widget(finestre[0], nome.str().c_str());
        gtk_label_set_text(GTK_LABEL(label), " ");
    }
    while(gtk_events_pending())
         (void) gtk_main_iteration();
}

void hidemesg_()
{
    if(!jscreen)
      return;
    gtk_widget_hide(get_widget(finestre[0], "area_messaggi"));
}

void abilitapaned_(int *flag)
{
    if(!jscreen)
      return;
    AreaMessaggi = (*flag != 0);
}

extern "C" void showmesg_()
{
  if(!jscreen)
      return;
  GtkAllocation allocation;
  gtk_widget_get_allocation(finestre[0], &allocation);
  int w = (int) allocation.width;
  int h = (int) allocation.height;
  GtkWidget *paned1 = get_widget (finestre[0], "DAbox");
  gtk_paned_set_position(GTK_PANED(paned1), (int)(h*0.65));
  GtkWidget *paned2 = get_widget (finestre[0], "paned2");
  gtk_paned_set_position(GTK_PANED(paned2), w/2);
  gtk_widget_show(get_widget(finestre[0], "area_messaggi"));
}

}
