//#define HAVE_ADVANCED 1
#include <cstdio>
#include <cstring>
#include <utils.h>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <sir_application.h>
//#include <gtkdefs.h>
#define GL_GLEXT_PROTOTYPES 1
#include "glext.h"
#include "models.h"
#include "jav_cb.h"

#ifdef JAV
#include "callbacks.h"
#endif
#ifdef MAPS
#include "maps.h"
#endif

#define DISTMIN 0.1
#define DISTMAX 5.0
#define program_ico     "mr-jav"

#ifndef JAV_USE_CAIRO_RENDERING
#include <pango/pangoft2.h>
static PangoContext *ft2_context = NULL;
#endif

#include <filtri.h>
static const char *FilesToExport =
   "All Supported Files"
#if defined(SIR_PGM) || defined(JAV)
   "!(*.cif,*.mop,*.mol,*.sdf,*.pdb,*.ent,*.fhz,*.fh,*.frac,*.xyz,*.ins,*.res,*.pov)@"
#else
   "!(*.cif,*.mop,*.mol,*.sdf,*.pdb,*.ent,*.fhz,*.fh,*.frac,*.xyz,*.ins,*.res,*.pov,*.inp,*.gamin,*.nw,*.com,*.gau,*.gzmat,*.in,*.d12)@"
#endif
   "Crystallographic Information File (*.cif)@"
   "MDL Molfile (*.mol,*.sdf)@"
   "MOPAC Cartesian Format (*.mop)@"
   "Protein Data Bank (*.pdb,*.ent)@"
   "Fenske-Hall Z-matrix (*.fhz,*.fh)@"
   "Free Form Fractional (*.frac)@"
   "XYZ Cartesian Format (*.xyz)@"
   "SHELXL file (*.ins,*.res)@"
#if defined(SIR_PGM) || defined(JAV)
   "PovRay Format (*.pov)";
#else
   "PovRay Format (*.pov)@"
   "GAMESS Input (*.inp, *.gamin)@"
   "NWCHEM Input (*.nw)@"
   "GAUSSIAN Cartesian Input (*.com, *.gau)@"
   "GAUSSIAN Z-matrix Input (*.gzmat)@"
   "ABINIT Input (*.in)@"
   "CRYSTAL Input (*.d12)@"
   "Quantum Espresso Input (*.in)";
#endif
static int FILT_IN_WRITE[] = {ALL_FILES, CIF_FILE, MOL_FILE, MOP_FILE, PDB_FILE,
                       ZMT_FILE, FRA_FILE, XYZ_FILE, SHELX_FILE, POV_FILE,
                       GAMESS_IN, NWCHEM_IN, GAUSSIAN_CART_IN, GAUSSIAN_ZMAT_IN,
                       ABINIT_IN, CRYSTAL_IN, QE_IN};

namespace main_app {
       extern Application JavApp;
                   }

static float distH0[] =  { 1.10f,   //CH3 metilico
                           1.10f,   //CH2 metilenico
                           1.10f,   //CH metinico
                           1.08f,   //C_ALCHINO: in alchino terminale
                           1.08f,   //C_Ar: composti aromatici
                           1.08f,   //X=CH2 terminale
                           0.95f,   //distanza O-H         
                           1.01f,   //distanza N-H in ammina primaria      
                           1.01f,   //distanza N-H in ammina secondaria        
                           1.31f,   //distanza S-H 
                           1.10f,   //distanza B-H
                           1.10f,   //C_DEF 
                           1.01f};  //N_DEF

static float colorimappa[MAX_NUM_MAPS+2][4] = {
                    {0.537f, 0.706f, 1.0f,   1.0f}, // celeste
                    {1.0f,   1.0f,   0.65f,  1.0f}, // giallo
                    {0.5f,   0.769f, 0.769f, 1.0f}, // cyan
                    {0.808f, 0.565f, 0.808f, 1.0f}, // violet
                    {1.0f,   0.765f, 0.741f, 1.0f}, // pink
                    {0.0f,   0.9f,   0.0f,   1.0f}, // verde
                    {1.0f,   0.0f,   0.0f,   1.0f}  // rosso
                    };

typedef struct {
   int   nfound;    // numero di trovati nel modello 2
   float distmin;   // distanza minima
   float distm;     // distanza media
   float rmsd;      // RMSD calculated on all atoms
   float rmsd_nonH; // RMSD calculated on all non H-atoms
   int   *nv1;      // atomo 1 dell'associazione
   int   *nv2;      // aromo 2 dell'associazione
   float *vdist;    // distanza dell'associazione
   float errph;     // errore di fase
   int   nref;      // numero di riflessi per l'errore di fase
   float shift[4];  // shift applicato
   atom_type *at1;  // modello 1
   atom_type *at2;  // modello 2
   int   nass;      // numero di atomi associati nel modello 1
                } compare_info_type;
                   
typedef struct {
              len_spec sp[MAX_SPECIES];
              } _StructSpecies;

bool Importa(std::string fil, int wm, mat3x3 rmI);
void addCOD(GtkWidget *window, int whichModel, int ifAdd);

void PowderPattern(GtkWidget *window, int whichModel, std::string fn);
void PairDistribution(GtkWidget *window, int whichModel, std::string fn);

void aggiorna_centro(vet3 xyz);
extern "C" void cartesiantozmatrix_forc_(atom_type *atm, int *n, float I_coor[][3], int conn[][3], int *wm);
extern "C" void getangle_(int *whichModel);
extern "C" void gettorsion_(int *whichModel);
//extern "C" void jav_save_info_(const char *str, int *wm, int *ipage,
//                               int *ncolumns, int vet[], int *val, size_t idum);
extern "C" void get_stringsymmf_(int *koper, char *str, size_t idum);   
extern "C" void jav_sphere_(int *kat,float *dist, int *wm);
extern "C" void jav_edit_structure_(int *code, atom_type *atml, int *natoms, int *wm);
extern "C" void jav_edit_bond_properties_(int *code, f_bond_type *legs, int *wm,                                          int *legame);
extern "C" void jav_edit_angle_properties_(int *code, jav_anglebond_type *angs, int *wm, int *angolo);
extern "C" void jav_edit_torsion_properties_(int *code, jav_torsion_type *tors,
                   float *tval, int *whichModel);
extern "C" void jav_edit_bonds_(int *code, _BondTable bt[], _BondSetting *bs, int*n, int *wm);
extern "C" void jav_normalize_structure_(int *code, float vett[], int *wm);
extern "C" void getsname_(char *name, int dum);
//extern "C" float getspinfo_(_SpeciesInfo *info);
extern "C" int  jav_modify_object_(int *kptra,int *nptra,int *kptrb,int *nptrb,
                     int *cod, float *threshold, int *wm, int *spec=NULL,
                     char *newname=NULL, size_t idum=0);
extern "C" void jav_expand_selection_(int *kptra,int *nptra, int *wm);
extern "C" void jav_undo_redo_(int *code);
extern "C" void jav_import_structure_cod_(const char *filename, int *tipo, int *wm, size_t sz);
extern "C" void jav_import_structure_(const char *filename, int *tipo, int *wm, size_t sz);
extern "C" void jav_export_structure_(char *filename, int *tipo, int *wm, int *ifD, size_t sz);
extern "C" float getbonddistance_(int *val1, int *val2);
extern "C" void ges_add_fragments_win_(int *code, int *wm, int *kgeom=0,
       int *kspec1=0, int *kspec2=0, int *kpos=0, float *bdist=0, int *kadd=0);
extern "C" void jav_get_info_overlay1_(float *dist, int *nass, int *n0, int *n1,
                        int *n2, float *distmin, float *distm, float *rmsd,
                        float *rmsd_nonH, float *errph, int *nref, int *whichModel);
extern "C" void jav_get_info_overlay2_(float *dist, int *nv1, int *nv2,
                                       float *vdist, atom_type *at1,
                                       atom_type *at2, float *s, int *whichModel);
extern "C" void overlay_struct_(char *filnam, size_t ldum);
extern "C" void jav_polyhedra_(int *wm);
extern "C" int  presentnzo_();
extern "C" void getnzo_(int *irs, int *num);
extern "C" int jav_hydrogen_bonds_(int *wm);
extern "C" int jav_short_contacts_(int *wm);
extern "C" int jav_delete_hangings_(int *wm, int *check);
extern "C" int jav_grow_fragment_(int *wm);
extern "C" void putspeciesinfo_(int *nk, int nw[], int no[],
                                float raggi[2][MAX_SPECIES],
                                 _StructSpecies *sp);
//                                len_spec Species[MAX_SPECIES]);
extern "C" void jav_delete_model_(int *Which);
extern "C" void jav_expand_contacts_(int *whichAtom, int *whichModel, int *code,
                                int *ncontact);
extern "C" void jav_show_multbonds_(int *i);
extern "C" void jav_get_au_(atom_type *atomi, int *num_atomi, int *kmodel);
extern "C" void jav_transform_model_(int *result, int *koper,
                               float T[], int *wm, int *nptra, int *kptra);
extern "C" void jav_optimize_geometry_(int *whichModel, int *kptra, int *nptra);
extern "C" void jav_optimize_geometry_mopac_(int *code, int *whichModel, atom_type *kptra, int *nptra);

void OpenGLWindow();
void call_javs(GtkWidget *, gpointer);
gboolean ManageExpose (GtkWidget *widget, gpointer obj, gpointer data);

static _BondTable *CurBondTable = NULL;

const int Patterns[] = {0x0000, 0x00FF, 0x0101, 0x1C47};
#define HORIZONTAL 0
const char *labelP = "\n\nTo view polyhedra, only one model is allowed\n\n";

static GdkColor colorWhite = {0, 65535, 65535, 65535};

enum pagine {PAGE_STRUCTURE, PAGE_ATOMS, PAGE_BONDS, PAGE_ANGLES, PAGE_TORSIONS, PAGE_BARS, PAGE_CONTACTS, PAGE_EDIT_BONDS};

#ifdef MAPS
#define PAGE_POLYHEDRA 4
#else
#define PAGE_POLYHEDRA 3
#endif

extern bool have_fb;
enum objects {BG, AXES, CELL, CLIPPING, FOG, DISTS, LABFONT, LABPOS, GRID,
              TRED, PROJECTION, BG1=20, BG2, HYDB, SHORTC, DRAWAXES, MULTB};

enum codici {IFCELL, IFSYMM, PLOTSTYLE, IFLABELS, SYMLEVEL, IFPOLYHEDRA,
             IFGROW, IFHBONDS, IFSHORTC, IFDELHANG};


static const char modes[]  = {'S', 'R', 'F', 'M', 'Z', 'D', 'A', 'T'};

typedef struct {
                  gpointer  reg;
                  char      *lab;
               } _InfoReg;

static const char *projection[] = {"Perspective", "Orthographic"};

static const char *radProp[] = {"Covalent radius", "Thermal factor"};

static const char *glasses[] = {"Red-Blue",
                                "Red-Green",
                                "Red-Cyan",
                                "Blue-Red",
                                "Green-Red",
                                "Cyan-Red"};

typedef struct
      {
      bool ifVis;
      bool ifLabels;
      int  plotStyle;
      int  drawLigand;
      bool ifSymmetry;
      float klevel[3];
      int  FitOpt;
      bool ifDrawH;
      bool ifDrawW;
      int  colorMode;
      float labelcolor[4];
      int   nPolyStyles;
      bool  ifSurface;
      polyhedron_style *PolyStyle;
      } _model_info;

#ifdef MAPS
typedef struct
      {
      bool ifVis;
      float color_mappa[4];
      int  wireframe;
      myreal iso;
      float radius;
      float step;
      } _map_info;
#endif

typedef struct {
      double sc_atoms;
      float  scale_atoms[N_ELEMENTS];
      double sc_bonds;
      float  CellColor[3];
      float  AxesColor[3];
      float  DistColor[3];
      float  BgColor[4];
      float  BgColor1[4];
      float  BgColor2[4];
      float  ColorHB[4];
      float  ColorSC[4];
      bool  ShowMultBonds;
      int    BgType;
      int    nDivisions;
      int    GridPattern;
      int    smooth;
      int    ifAxes;
      int    ifDrawAxes;
      int    glasses_type;
      bool   ifOrtho;
      bool   ifCell;
      bool   ifGrid;
      bool   Clip;
      bool   fog;
      bool   Stereo;
      int    ell_tr;
      int    RadType;
      double ClipFactor;
      float  FogDensity;
      atom_color icolorSave[NUM_COLORS];
      std::string strInternetBrowser;
      char   *fontname;
      float xoffset;
      float yoffset;
      bool MSEnabled;
      int MSBuffers;
#ifdef MAPS
      float Radius;
      vet3 xyzC;
      bool  ifWhole;
      _map_info map_info[MAX_NUM_MAPS];
      _map_info surf_info[MAX_NUM_MODELS];
#endif
      _model_info model_info[MAX_NUM_MODELS];
      _LightInfo lightInfo[3];
      bool normalToV;
                } _SaveStruct;

static _SaveStruct SaveStruct;
static _SaveStruct DefaultValuesForP;

typedef struct {
                int z;
                int active;
               }_ContactType;
typedef struct {
                float tolmin, tolmax;
                int   hpresent, inter, intra, nminbond, hangat;
               } _ContactOptionType;

_ContactType donor0[] = { {7,1}, {8,1}, {16, 1}, {6, 0}};
const int NDONORS = sizeof(donor0)/sizeof(donor0[0]);
_ContactType acceptor0[] = { {7,1}, {8,1}, {16, 1}, {9, 0},
                             {17, 1}, {35, 1}, {53, 1}};
const int NACCEPTORS = sizeof(acceptor0)/sizeof(acceptor0[0]);
_ContactOptionType HBopt0 = {5.f, 0.f, 0, 1, 1, 3};
extern "C" void gethboptions_(_ContactType donor[], _ContactType acceptor[],
                         _ContactOptionType *HBopt);
extern "C" void puthboptions_(int *wm, _ContactType donor[], _ContactType acceptor[],
                         _ContactOptionType *HBopt);
_ContactType DSave[NDONORS], ASave[NACCEPTORS];
_ContactOptionType OptSave;


enum geoms {TETRA=1, OCTA, SQUARE,
            CUBE, TRIG, APRISM_TETRA,
            PRISM_TRIG, ICOSA, ISOLATED};

static const char *G_str[] = {"Tetrahedron", "Octahedron", "Square Plane",
                              "Cube", "Trigonal Plane", "Antiprism Tetragonal",
                              "Prism Trigonal", "Icosahedron", "Isolated Atoms"};
int NG_str = G_N_ELEMENTS(G_str);

const char *label_c(_ContactType ct)
{
    return get_nth_element_name(ct.z-1);
}

gboolean active_c(_ContactType ct)
{
    return ct.active;
}

namespace GLextmr
{
#include "actioncommons.h"
    static float GBB[16] = {1, 0, 0, 0,
                            0, 1, 0, 0,
                            0, 0, 1, 0,
                            0, 0, 0, 1};
    static int defaultW, defaultH;
    static int default_bond_mult = 0;
    extern int defBGcolor;
    int SaveSize[2];
    extern Model *ModelInfo; //[5];
    static Model ModelEdit;
    extern GtkWidget *GLWINDOW;
    extern int motion_type;
    int ifSmooth = 1;
    extern int nclicked;
    extern std::string defaultTitle;
    extern std::string defaultMessage;
    extern int defaultCell;
    extern int defaultFog;
    extern int defaultClip;
    extern int defaultPlotStyle;
    extern int defaultSymmetry;
    extern int defaultLabels;
    extern int defaultModify;
    extern int defaultBG;
    extern int defaultColor;
    extern float defaultBgColor[3];
    extern float defaultBgColor1[3];
    extern float defaultBgColor2[3];
    std::string LastModel = "";
    bool  useDefaultB = false;
    extern bool defaultDrawPar;
    extern bool PreviewMode;
    extern std::string BufferName;
    extern vet3 defaultV0;
    extern vet3 defaultabc;

    extern float  sc_bonds0;
    extern GLfloat  Range;
    int    sphereCentre = -1;
    bool   DrawSphere = false;
    float  SphereRadius;
    float  sphereRadius = 2.5f;
    float  SphereCentre[3];
    int    TypeS(char Code);
    void sync_radios();
    void sync_radio(const char *menuname, bool Flag);
    void SetBgFromDefaults();
    void LoadCairoTexture(GLWindow *gl);
    const char *Translate(char Code);
    void PrintSecondary(Model *md, std::ostream &os);
    int select_from_table(GtkWidget *dlg);
#ifdef MAPS
    extern Mappa *MapInfo;
    extern Mappa *VWSurface;
    void centre_settings(GtkWidget *window, GtkWidget *dlg, GtkWidget *vboxx);
    void map_settings(GtkWidget *window, GtkWidget *dlg, GtkWidget *vbox);
    extern float  raggioMappa;
    extern float  centroMappa[3];
    extern bool   defCentro;
#endif
    void LoadWinCursor(int flag);
    void sistema_elltr(GtkWidget *father);
    void matrix_to_quat( float a[], float q[] );
#ifdef JAV
    extern bool ifPreviousRun;
    void SetLastRun(GtkWidget *w, bool flag);
#endif

typedef struct {
               int   num;         // n.ordine
               float n1, n2, n3, n4, n5, n6;
               char  *lab1, *lab2, *lab3, *lab4, *lab5;
               int z;
               } jav_generic_type;

typedef struct {
                int   num;
                float val;
                char  *str;
              }  rowlist_type;

float getRFvalue();

enum sort_columns   {NO, F1, F2, F3, 
                     F4, F5, F6, A1,
                     A2, A3, A4, A5, NS};

void on_Screenshot(gpointer, gpointer data)
{
using namespace gtkext;
using namespace std;
   GtkWidget *window = (GtkWidget *) data;
   std::string fn;
   int whichModel = GetActiveModel() - 1;
   if((whichModel >= 0) && ModelInfo[whichModel].created)
      fn = g_path_get_basename(ModelInfo[whichModel].modname);
   else
      fn = "";

   do_Screenshot(window, fn);
}

int GetActiveModel()
{
   if(GLWINDOW == NULL)
      return 0;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   if(gl == NULL)
      return 0;
   return (gl->inModify + 1);
}

void SetActiveModel (int which)
{
   if(GLWINDOW == NULL)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   if(gl == NULL)
      return;
   gl->inModify = which - 1;
}

void GetMapColor(float colore[], int index_col)
{
   memcpy(colore, colorimappa[index_col], 4*sizeof(float));
}

#ifndef JAV
static void close_window (GtkWidget *widget, gpointer data)
{
// il problema di chiudere e riaprire la finestra Jav nasce da queste linee
// commentate; perchè le ho commentate Dio solo lo sa, comunque le ho
// reintrodotte più sotto
//
//#ifdef _WIN32
//  GLWindow *gl = (GLWindow *)data;
//  gl->Destroy(0);
//  return;
//#endif
   if(GLWINDOW)
   {
       int x, y;
       gtk_window_get_position(GTK_WINDOW(GLWINDOW), &x, &y);
       main_app::JavApp.UpdatePosition(x, y);
       gtk_widget_hide(GLWINDOW);
#ifdef LIBEXPO
          gtk_main_quit();
#endif
//mr 12072016 - Adesso le ricommento per via dei problemi con overlay se chiudo
// e riapro la finestra Jav e poi stiamo a vedere 
//#ifdef _WIN32
//       GLWindow *gl = (GLWindow *)data;
//       gl->Destroy(0);
//#endif
   }
}

static gboolean on_close_window (GtkWidget *widget, GdkEvent *, gpointer data)
{
   close_window(widget, data);
   return TRUE;
}

void on_Quit(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   close_window(window, gl);
}
#endif

void close_pango()
{
#ifndef JAV_USE_CAIRO_RENDERING
 if(ft2_context)
    g_object_unref (G_OBJECT (ft2_context));
 ft2_context = NULL;
#endif
}

void open_pango()
{
#ifndef JAV_USE_CAIRO_RENDERING
     #if PANGO_VERSION_MINOR < 6
       PangoFT2FontMap *fontmap = (PangoFT2FontMap *)pango_ft2_font_map_new();
       ft2_context = pango_ft2_font_map_create_context(fontmap);
     #else
       PangoFontMap *fontmap = pango_ft2_font_map_new();
       ft2_context = pango_context_new();
       pango_context_set_font_map(ft2_context, fontmap);
     #endif
#endif
}

#ifndef JAV_USE_CAIRO_RENDERING // render FreeType Fonts
PangoRectangle *get_text_rect(PangoFontDescription *fdesc, const char *testo)
{
    PangoRectangle *r2 = g_new0(PangoRectangle, 1);
    pango_context_set_font_description (ft2_context, fdesc);
    PangoLayout *layout = pango_layout_new (ft2_context);
    pango_layout_set_alignment (layout, PANGO_ALIGN_CENTER);
    pango_layout_set_markup (layout, testo, -1);
    pango_layout_get_pixel_extents(layout, NULL, r2);
    g_object_unref (G_OBJECT (layout));
    return r2;
}

void gl_pango_ft2_render_layout (PangoLayout *layout)
{
  PangoRectangle logical_rect;
  FT_Bitmap bitmap;
  GLvoid *pixels;
  guint32 *p;
  GLfloat color[4];
  guint32 rgb;
  GLfloat a;
  guint8 *row, *row_end;
  int i;

  pango_layout_get_extents (layout, NULL, &logical_rect);
  if (logical_rect.width == 0 || logical_rect.height == 0)
    return;

  bitmap.rows = PANGO_PIXELS (logical_rect.height);
  bitmap.width = PANGO_PIXELS (logical_rect.width);
  bitmap.pitch = bitmap.width;
  bitmap.buffer = g_new0(unsigned char, (bitmap.rows * bitmap.width));
  bitmap.num_grays = 256;
  bitmap.pixel_mode = ft_pixel_mode_grays;

  pango_ft2_render_layout (&bitmap, layout,
                           PANGO_PIXELS (-logical_rect.x), 0);
  pixels = g_malloc (bitmap.rows * bitmap.width * 4);
  p = (guint32 *) pixels;

  glGetFloatv (GL_CURRENT_COLOR, color);
#if !defined(GL_VERSION_1_2) && G_BYTE_ORDER == G_LITTLE_ENDIAN
  rgb =  ((guint32) (color[0] * 255.0))        |
        (((guint32) (color[1] * 255.0)) << 8)  |
        (((guint32) (color[2] * 255.0)) << 16);
#else
  rgb = (((guint32) (color[0] * 255.0)) << 24) |
        (((guint32) (color[1] * 255.0)) << 16) |
        (((guint32) (color[2] * 255.0)) << 8);
#endif
  a = color[3];

  row = bitmap.buffer + bitmap.rows * bitmap.width; 
  row_end = bitmap.buffer;  
  if (a == 1.0)
    {
      do
        {
          row -= bitmap.width;
          for (i = 0; i < bitmap.width; i++)
#if !defined(GL_VERSION_1_2) && G_BYTE_ORDER == G_LITTLE_ENDIAN
            *p++ = rgb | (((guint32) row[i]) << 24);
#else
            *p++ = rgb | ((guint32) row[i]);
#endif
        }
      while (row != row_end);
    }
  else
    {
      do
        {
          row -= bitmap.width;
          for (i = 0; i < bitmap.width; i++)
#if !defined(GL_VERSION_1_2) && G_BYTE_ORDER == G_LITTLE_ENDIAN
            *p++ = rgb | (((guint32) (a * row[i])) << 24);
#else
            *p++ = rgb | ((guint32) (a * row[i]));
#endif
        }
      while (row != row_end);
    }

  glPixelStorei (GL_UNPACK_ALIGNMENT, 4);

//  glDisable (GL_DEPTH_TEST);
  glEnable (GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

#if !defined(GL_VERSION_1_2)
  glDrawPixels (bitmap.width, bitmap.rows,
                GL_RGBA, GL_UNSIGNED_BYTE,
                pixels);
#else
  glDrawPixels (bitmap.width, bitmap.rows,
                GL_RGBA, GL_UNSIGNED_INT_8_8_8_8,
                pixels);
#endif

  glDisable (GL_BLEND);
//  glEnable (GL_DEPTH_TEST);
  g_free (bitmap.buffer);
  g_free (pixels);
}

void DrawText(int width, PangoFontDescription *font_desc, PangoAlignment alignment, 
              float color[], vet3 xy, const char *testo, PangoRectangle *r2,
              bool ifbg)
{
    glPushMatrix();
//    glLoadIdentity();

//Set font
    pango_context_set_font_description (ft2_context, font_desc);
//Text layout
    PangoLayout *layout = pango_layout_new (ft2_context);
    pango_layout_set_width (layout, width);
    pango_layout_set_alignment (layout, alignment);
    PangoAttribute *attr_background = pango_attr_background_new(0, 0, 0);
    PangoAttrList *attr_list = pango_attr_list_new();
    pango_attr_list_insert(attr_list, attr_background);
    pango_layout_set_attributes(layout, attr_list);
    pango_layout_set_markup (layout, testo, -1);

    if(r2 != NULL)
       pango_layout_get_pixel_extents(layout, NULL, r2);
//Set color
    glColor3fv(color);
// Text position
    glRasterPos3dv (xy.v);
// Render text
    gl_pango_ft2_render_layout (layout);
    g_object_unref (G_OBJECT (layout));
    pango_attr_list_unref(attr_list);

    glColor3f(1.f, 1.f, 1.f);
    glPopMatrix();
}

#else                // render with cairo

PangoRectangle *get_text_rect(PangoFontDescription *fdesc, const char *testo)
{
    PangoRectangle *r2 = g_new0(PangoRectangle, 1);
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");   
    int w = gl->Width;
    int h = gl->Height;
    cairo_surface_t *surface = cairo_image_surface_create(CAIRO_FORMAT_RGB24,
         w, h);
    cairo_t *cr = cairo_create(surface);
    PangoLayout *layout = pango_cairo_create_layout(cr);
    pango_layout_set_font_description (layout, fdesc);
    pango_layout_set_alignment (layout, PANGO_ALIGN_CENTER);
    pango_layout_set_markup (layout, testo, -1);
    pango_layout_get_pixel_extents(layout, NULL, r2);
    g_object_unref (G_OBJECT (layout));
    cairo_destroy(cr);
    cairo_surface_destroy(surface);
    return r2;
}

void gl_pango_render_layout (PangoLayout *layout, cairo_surface_t *surface,
                             float *color)
{
  PangoRectangle logical_rect,rect2;
  int stride;
  unsigned char *p;

  pango_layout_get_extents (layout, &rect2, &logical_rect);
  if (logical_rect.width == 0 || logical_rect.height == 0)
    return;
  cairo_surface_flush (surface);

  int w = PANGO_PIXELS(logical_rect.width) ;
  int h = PANGO_PIXELS(logical_rect.height) ;
  int x0 = PANGO_PIXELS(logical_rect.x);
  int y0 = PANGO_PIXELS(logical_rect.y);
  cairo_surface_t *image1 = cairo_image_surface_create(CAIRO_FORMAT_RGB24, w, h);
  cairo_t *cr = cairo_create (image1);
  cairo_set_source_surface (cr, surface, - x0, y0);
  cairo_rectangle (cr, 0, 0, w, h);
  cairo_fill (cr);
//  if(color)
//  {
//     cairo_set_source_rgba (cr, color[0], color[1], color[2], 0.0);
//     cairo_rectangle (cr, 0, 0, w, h);
//     cairo_fill(cr);
//  }

  p =  cairo_image_surface_get_data(image1);
  stride = cairo_image_surface_get_stride (image1);
  int nc = 4;

  unsigned char *buf = g_new0(unsigned char, nc*h*w);
     memset(buf, -1, nc*h*w);
//
     for(int i=0; i<nc*h*w; i+=nc)
     {
         buf[i]   = p[i+2];
         buf[i+1] = p[i+1];
         buf[i+2] = p[i];
         buf[i+3] = p[i+3];
     }

  glPixelStorei (GL_UNPACK_ALIGNMENT, nc);

  GdkPixbuf *dest; 
  GdkPixbuf *pixb = gdk_pixbuf_new_from_data (buf,
               GDK_COLORSPACE_RGB, TRUE,
               8, w, h, stride, NULL, NULL);

  int w1 = (int) (0.9 * w);
  int h1 = (int) (0.9 * h);
  GdkPixbuf *pixc = gdk_pixbuf_scale_simple (pixb, w1, h1,
                        GDK_INTERP_BILINEAR);
  dest = gdk_pixbuf_flip(pixc, FALSE);
  g_free(buf);
  unsigned char *p1 = gdk_pixbuf_get_pixels(dest);
  g_object_unref(pixb);
  g_object_unref(pixc);

  cairo_surface_destroy(image1);
  cairo_destroy(cr);

  if(color == NULL)
     glDisable (GL_DEPTH_TEST);
  glEnable (GL_BLEND);
//  glBlendFunc (GL_ONE, GL_SRC_ALPHA);
//  glBlendFunc (GL_SRC_ALPHA, GL_ONE);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

  glDrawPixels (w1, h1, GL_RGBA, GL_UNSIGNED_BYTE, p1);
  g_object_unref(dest);

  glDisable (GL_BLEND);
  glEnable (GL_DEPTH_TEST);
}

void DrawText(int width, PangoFontDescription *font_desc, PangoAlignment alignment, 
              float color[], vet3 xy, const char *testo, PangoRectangle *r2,
              bool ifbg)
{
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    glPushMatrix();
    if(!ifbg)
      glLoadIdentity();

//Text layout
    int w = gl->Width;
    int h = gl->Height;
    cairo_surface_t *surface = cairo_image_surface_create(CAIRO_FORMAT_RGB24,
         w, h);
    cairo_t *cr = cairo_create(surface);
    PangoLayout *layout = pango_cairo_create_layout(cr);
//Set font
    pango_layout_set_font_description (layout, font_desc);
    if(width != -1)
       pango_layout_set_width (layout, (int) (0.99 *width));
    pango_layout_set_alignment (layout, alignment);
    PangoAttribute *attr_background = pango_attr_background_new(0, 0, 0);
    PangoAttrList *attr_list = pango_attr_list_new();
    pango_attr_list_insert(attr_list, attr_background);
    pango_layout_set_attributes(layout, attr_list);
    pango_layout_set_markup (layout, testo, -1);
    if(r2 != NULL)
       pango_layout_get_pixel_extents(layout, NULL, r2);
//Black background
//     cairo_set_source_rgba (cr, 0, 0, 0, 1);
//     cairo_rectangle (cr, 0, 0, 50, 100);
//     cairo_fill(cr);

//Set color
    cairo_set_source_rgba(cr, color[0], color[1], color[2], 1.);
    cairo_move_to(cr, 0, 0);
    pango_cairo_show_layout(cr, layout);

// Text position
    glRasterPos3dv (xy.v);
// Render text
    if(ifbg)
       gl_pango_render_layout (layout, surface,gl->BgColor);
    else
       gl_pango_render_layout (layout, surface);
    g_object_unref (G_OBJECT (layout));
    cairo_destroy(cr);
    cairo_surface_destroy(surface);

    glColor3f(1.f, 1.f, 1.f);
    glPopMatrix();
}
#endif
#if 0
int *transFromCode(int opcode)
{
    int *traslation = g_new0(int, 3);
    int tcode = opcode % 1000;
    traslation[0] = tcode / 100 - 5;
    traslation[1] = (tcode % 100) / 10 - 5;
    traslation[2] = tcode % 10 - 5;
//    g_print("opcode %d, tcode %d, translation %d %d %d\n", opcode, tcode,
//      traslation[0], traslation[1], traslation[2]);
    return traslation;
}
#endif

void update_model(GtkWidget *father, GtkWidget *window)
{
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     if(g_object_get_data(G_OBJECT(father), "frame_models"))
     {
        GtkWidget *parent = get_widget(father, "frame_models");
        for(int i=0; i<gl->nModels; i++)
        {
            std::stringstream name;
            name << "model" << i;
            if(g_object_get_data(G_OBJECT(father), name.str().c_str()) == NULL)
               add_model(window, i, father, parent);
        }
        show_dialog(window, father);
     }
     else
     {
        GtkWidget *vbox = get_widget(father, "box_models");
        model_settings(window, father, vbox);
     }
}

void rewrite_models(GtkWidget *father, GtkWidget *window)
{
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     if(g_object_get_data(G_OBJECT(father), "frame_models"))
     {
        GtkWidget *parent = get_widget(father, "frame_models");
        remove_children(parent);
//        for(int i=0; i<gl->nModels; i++)
        GtkWidget *frame = add_model_selector(father);
        gtk_box_pack_start(GTK_BOX(parent), frame, FALSE, FALSE, 10);

        for(int i=0; i<MAX_NUM_MODELS; i++)
        {
            std::stringstream name;
            name << "model" << i;
            g_object_set_data(G_OBJECT(father), name.str().c_str(), NULL);
        }
        for(int i=0; i<gl->nModels; i++)
            add_model(window, i, father, parent);
        show_dialog(window, father);
     }
}

void setModelName(int whichModel)
{
   if(!GLWINDOW)
      return;
   if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
   {
      GtkWidget *father = get_widget(GLWINDOW, SettingsWindow);

      std::stringstream nome;
      nome << "modelname" << whichModel;
      GtkWidget *container = get_widget(father,  nome.str().c_str());
      std::string label_string = g_strdup_printf("%d - %s", whichModel+1,
           g_path_get_basename(ModelInfo[whichModel].modname));
      GtkWidget *label = gtk_frame_get_label_widget(GTK_FRAME(container));
      gtk_label_set_text(GTK_LABEL(label), label_string.c_str());
   }
}

void SalvaDati(GtkWidget *window)
{
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
    SaveStruct.smooth = gl->smooth;
    SaveStruct.glasses_type = gl->glasses_type;
    SaveStruct.ifOrtho = gl->ifOrtho;
    SaveStruct.sc_atoms = gl->sc_atoms;
    memcpy(SaveStruct.scale_atoms, gl->scale_atoms, N_ELEMENTS*sizeof(float));
    SaveStruct.sc_bonds = gl->sc_bonds;
    memcpy(SaveStruct.BgColor, gl->BgColor, 4*sizeof(float));
    memcpy(SaveStruct.BgColor1, gl->BgColor1, 4*sizeof(float));
    memcpy(SaveStruct.BgColor2, gl->BgColor2, 4*sizeof(float));
    memcpy(SaveStruct.ColorHB, gl->ColorHB, 4*sizeof(float));
    memcpy(SaveStruct.ColorSC, gl->ColorSC, 4*sizeof(float));
    SaveStruct.BgType = main_app::JavApp.Background;
    SaveStruct.MSEnabled = main_app::JavApp.IsMSEnabled();
    SaveStruct.MSBuffers = main_app::JavApp.MSBuffers();
    SaveStruct.ifAxes = gl->ifAxes;
    SaveStruct.ifDrawAxes = gl->ifDrawAxes;
    SaveStruct.ShowMultBonds = gl->ShowMultBonds;
    memcpy(SaveStruct.AxesColor, gl->AxesColor, 3*sizeof(float));
    memcpy(SaveStruct.DistColor, gl->DistColor, 3*sizeof(float));
    SaveStruct.ifCell = gl->ifCell;
    memcpy(SaveStruct.CellColor, gl->CellColor, 3*sizeof(float));
    SaveStruct.Clip = gl->Clip;
    SaveStruct.fog = gl->fog;
    SaveStruct.ClipFactor = gl->ClipFactor;
    SaveStruct.FogDensity = gl->FogDensity;
    SaveStruct.Stereo = gl->Stereo;
    SaveStruct.ifGrid = gl->ifGrid;
    SaveStruct.GridPattern = gl->GridPattern;
    SaveStruct.nDivisions = gl->nDivisions;
    SaveStruct.ell_tr = gl->ell_tr;
    SaveStruct.RadType = gl->RadType;
    for(int k=0; k<NUM_COLORS;k++)
        memcpy(SaveStruct.icolorSave[k], main_app::JavApp.app_color[k+N_OBJS], 4*sizeof(float));
    SaveStruct.strInternetBrowser = main_app::JavApp.InternetBrowser();
    SaveStruct.fontname = DuplicaStringa(gl->fontname);
    SaveStruct.xoffset = gl->xoffset;
    SaveStruct.yoffset = gl->yoffset;
#ifdef MAPS
    for(int i=0; i<MAX_NUM_MAPS; i++)
    {
        SaveStruct.map_info[i].ifVis = MapInfo[i].ifVis;
        SaveStruct.map_info[i].wireframe = MapInfo[i].wireframe;
        SaveStruct.map_info[i].iso = MapInfo[i].iso;
        memcpy(SaveStruct.map_info[i].color_mappa, MapInfo[i].color_mappa,
                4*sizeof(float));
    }
    for(int i=0; i<MAX_NUM_MODELS; i++)
    {
        SaveStruct.surf_info[i].ifVis = VWSurface[i].ifVis;
        SaveStruct.surf_info[i].wireframe = VWSurface[i].wireframe;
        SaveStruct.surf_info[i].iso = 1;
        SaveStruct.surf_info[i].radius = VWSurface[i].radius;
        SaveStruct.surf_info[i].step = VWSurface[i].step;
        memcpy(SaveStruct.surf_info[i].color_mappa, VWSurface[i].color_mappa,
                4*sizeof(float));
    }
    SaveStruct.Radius = gl->Radius;
    SaveStruct.ifWhole = gl->ifWhole;
    MRVectorCopy(gl->xyzC, &(SaveStruct.xyzC));
#endif
    for(int i=0; i<MAX_NUM_MODELS; i++)
    {
        SaveStruct.model_info[i].ifVis = ModelInfo[i].ifVis;
        SaveStruct.model_info[i].ifLabels = ModelInfo[i].ifLabels;
        SaveStruct.model_info[i].plotStyle = ModelInfo[i].plotStyle;
        SaveStruct.model_info[i].drawLigand = ModelInfo[i].drawLigand;
        SaveStruct.model_info[i].ifSymmetry = ModelInfo[i].ifSymmetry;
        memcpy(SaveStruct.model_info[i].klevel, ModelInfo[i].klevel,
               3*sizeof(float));
        SaveStruct.model_info[i].FitOpt = ModelInfo[i].FitOpt;
        SaveStruct.model_info[i].ifDrawH = ModelInfo[i].ifDrawH;
        SaveStruct.model_info[i].ifDrawW = ModelInfo[i].ifDrawW;
        SaveStruct.model_info[i].colorMode = ModelInfo[i].colorMode;
        SaveStruct.model_info[i].nPolyStyles = ModelInfo[i].nPolyStyles;
        SaveStruct.model_info[i].ifSurface = ModelInfo[i].ifSurface;
        memcpy(SaveStruct.model_info[i].labelcolor,
               ModelInfo[i].labelcolor, 4*sizeof(float));
        SaveStruct.model_info[i].PolyStyle = g_new0(polyhedron_style, 
               ModelInfo[i].nPolyStyles);
        for(int k=0; k<ModelInfo[i].nPolyStyles; k++)
            memcpy(&SaveStruct.model_info[i].PolyStyle[k], 
                   &ModelInfo[i].PolyStyle[k], sizeof(polyhedron_style));
    }
    memcpy(SaveStruct.lightInfo, gl->lightInfo, 3*sizeof(_LightInfo));
    SaveStruct.normalToV = gl->normalToV;
}

void RecuperaDati(GtkWidget *window, _SaveStruct *DataStruct=NULL)
{
    if(DataStruct == NULL)
       DataStruct = &SaveStruct;
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
    GtkWidget *dlg1 = get_widget(window, SettingsWindow);
    gl->smooth = DataStruct->smooth;
    gl->glasses_type = DataStruct->glasses_type;
    gl->ifOrtho = DataStruct->ifOrtho;
    gl->sc_atoms = DataStruct->sc_atoms;
    memcpy(gl->scale_atoms, DataStruct->scale_atoms, N_ELEMENTS*sizeof(float));
    gl->sc_bonds = DataStruct->sc_bonds;
    memcpy(gl->BgColor, DataStruct->BgColor, 4*sizeof(float));
    memcpy(gl->BgColor1, DataStruct->BgColor1, 4*sizeof(float));
    memcpy(gl->BgColor2, DataStruct->BgColor2, 4*sizeof(float));
    memcpy(gl->ColorHB, DataStruct->ColorHB, 4*sizeof(float));
    memcpy(gl->ColorSC, DataStruct->ColorSC, 4*sizeof(float));
    main_app::JavApp.Background = DataStruct->BgType;
    main_app::JavApp.Set_AA(param_ENABLE, DataStruct->MSEnabled?1:0);
    main_app::JavApp.Set_AA(param_BUFFERS, DataStruct->MSBuffers);
    gl->BgType = DataStruct->BgType;
    gl->ifAxes = DataStruct->ifAxes;
    gl->ifDrawAxes = DataStruct->ifDrawAxes;
    gl->ShowMultBonds = DataStruct->ShowMultBonds;
    memcpy(gl->AxesColor, DataStruct->AxesColor, 3*sizeof(float));
    memcpy(gl->DistColor, DataStruct->DistColor, 3*sizeof(float));
    memcpy(gl->CellColor, DataStruct->CellColor, 3*sizeof(float));
    gl->ToggleCell(DataStruct->ifCell);
    gl->Clip = DataStruct->Clip;
    gl->fog = DataStruct->fog;
    gl->ClipFactor = DataStruct->ClipFactor;
    gl->FogDensity = DataStruct->FogDensity;
    gl->Stereo = DataStruct->Stereo;
    gl->ifGrid = DataStruct->ifGrid;
    gl->GridPattern = DataStruct->GridPattern;
    gl->nDivisions = DataStruct->nDivisions;
    gl->ell_tr = DataStruct->ell_tr;
    gl->RadType = DataStruct->RadType;
    for(int k=0; k<NUM_COLORS;k++)
        memcpy(main_app::JavApp.app_color[k+N_OBJS], DataStruct->icolorSave[k], 4*sizeof(float));
    for(int k=0; k<gl->nModels;k++)
        ModelInfo[k].InitColors();
    main_app::JavApp.UpdateIB(g_strdup(DataStruct->strInternetBrowser.c_str()));
//    if(gl->fontname)
//       g_free(gl->fontname);
    gl->fontname = DuplicaStringa(DataStruct->fontname);
    gl->xoffset = DataStruct->xoffset;
    gl->yoffset = DataStruct->yoffset;
    main_app::JavApp.SetFont('P', gl->fontname);
    aggiorna_smooth(gl->smooth);
#ifdef MAPS
    gl->ifWhole = DataStruct->ifWhole;
    gl->Radius = DataStruct->Radius;
    MRVectorCopy(DataStruct->xyzC, &(gl->xyzC));
    set_values_for_centre(dlg1, window);
    for(int i=0; i<MAX_NUM_MAPS; i++)
    {
        MapInfo[i].ifVis = DataStruct->map_info[i].ifVis;
        MapInfo[i].wireframe = DataStruct->map_info[i].wireframe;
        MapInfo[i].iso = DataStruct->map_info[i].iso;
        memcpy(MapInfo[i].color_mappa, DataStruct->map_info[i].color_mappa,
                4*sizeof(float));
        if(i < gl->nMaps)
           set_values_for_map(i, dlg1, window);
    }
    for(int i=0; i<MAX_NUM_MODELS; i++)
    {
        VWSurface[i].ifVis = DataStruct->surf_info[i].ifVis;
        VWSurface[i].wireframe = DataStruct->surf_info[i].wireframe;
        VWSurface[i].iso = 1;
        VWSurface[i].radius = DataStruct->surf_info[i].radius;
        VWSurface[i].step = DataStruct->surf_info[i].step;
        memcpy(VWSurface[i].color_mappa, DataStruct->surf_info[i].color_mappa,
                4*sizeof(float));
        if(i < gl->nModels)
           set_values_for_surface(i, dlg1, window, !ModelInfo[i].ifSymmetry);
    }
#endif
#ifndef JAV
    defaultPlotStyle = DataStruct->model_info[0].plotStyle;
#endif
    for(int i=0; i<MAX_NUM_MODELS; i++)
    {
        ModelInfo[i].ifVis = DataStruct->model_info[i].ifVis;
        ModelInfo[i].ifLabels = DataStruct->model_info[i].ifLabels;
        ModelInfo[i].plotStyle = DataStruct->model_info[i].plotStyle;
        ModelInfo[i].drawLigand = DataStruct->model_info[i].drawLigand;
        if( (ModelInfo[i].ifSymmetry != DataStruct->model_info[i].ifSymmetry)
          ||(ModelInfo[i].FitOpt != DataStruct->model_info[i].FitOpt) 
          ||(ModelInfo[i].klevel[0] != DataStruct->model_info[i].klevel[0]) 
          ||(ModelInfo[i].klevel[1] != DataStruct->model_info[i].klevel[1])
          ||(ModelInfo[i].klevel[2] != DataStruct->model_info[i].klevel[2]) )
        {
           ModelInfo[i].ifSymmetry = DataStruct->model_info[i].ifSymmetry;
           ModelInfo[i].FitOpt = DataStruct->model_info[i].FitOpt;
           memcpy(ModelInfo[i].klevel, DataStruct->model_info[i].klevel,
             3*sizeof(float));
//           set_values_for_model(i, dlg1, window);
        }
        ModelInfo[i].ifDrawH = DataStruct->model_info[i].ifDrawH;
        ModelInfo[i].ifDrawW = DataStruct->model_info[i].ifDrawW;
        ModelInfo[i].colorMode = DataStruct->model_info[i].colorMode;
        ModelInfo[i].ifSurface = DataStruct->model_info[i].ifSurface;
        memcpy(ModelInfo[i].labelcolor, 
               DataStruct->model_info[i].labelcolor, 4*sizeof(float));
        if(ModelInfo[i].nPolyStyles == DataStruct->model_info[i].nPolyStyles)
        {
        for(int k=0; k<ModelInfo[i].nPolyStyles; k++)
            memcpy(&ModelInfo[i].PolyStyle[k], 
                   &DataStruct->model_info[i].PolyStyle[k], 
                   sizeof(polyhedron_style));
        }
        if(i < gl->nModels)
           set_values_for_model(i, dlg1, window);
    }
    main_app::JavApp.WritePalette();
#ifndef JAV
    main_app::JavApp.UpdatePS(defaultPlotStyle);
#endif
    memcpy(gl->lightInfo, DataStruct->lightInfo, 3*sizeof(_LightInfo));
    gl->normalToV = DataStruct->normalToV;
    set_values_for_advanced();
    gl->Redraw();
}

void about_render(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   std::string info_render;
   gl->RenderingInfo(info_render);
   GtkWidget *dialog = gtk_message_dialog_new (GTK_WINDOW(window),
                                 GTK_DIALOG_DESTROY_WITH_PARENT,
                                 GTK_MESSAGE_INFO,
                                 GTK_BUTTONS_CLOSE,
                                 "%s", info_render.c_str());
   gtk_dialog_run (GTK_DIALOG (dialog));
   gtk_widget_destroy (dialog);
}

void on_ResetScale(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   Range = 1.f;
   for(int i=0; i<gl->nModels; i++)
       ModelInfo[i].ifResize = true;
   gl->ResetView();
}

void on_ResetView(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");

   on_ResetScale(NULL, data);

   for(int j=0; j<3; j++)
   {
       if(gl->nModels)
          gl->xyzC.v[j] = ModelInfo[0].baricentro[j];
       else
          gl->xyzC.v[j] = centroMappa[j];
   }
   for(int i=0; i<gl->nModels; i++)
       ModelInfo[i].ifResize = true;
   gl->RiNormalizza();

   gl->ResetView(true, false);
   gl->ViewPlane('L');
}

void on_ViewPlanea(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ViewPlane('a');
}

void on_ViewPlaneb(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ViewPlane('b');
}

void on_ViewPlanec(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ViewPlane('c');
}

void on_ViewPlaneastar(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ViewPlane('A');
}

void on_ViewPlanebstar(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ViewPlane('B');
}

void on_ViewPlanecstar(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ViewPlane('C');
}

void on_ViewPlaneLSQ(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ViewPlane('L');
}

void on_ViewPlaneSelected(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ViewPlane('S');
   int wm = GetActiveModel() - 1;
   if(wm > -1)
      endModify(wm);
   gl->Redraw();
}

void on_Xplus(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->on_rotate(0, 1.);
}  

void on_Xminus(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->on_rotate(0, -1.);
}  

void on_Yplus(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->on_rotate(1, 1.);
}  

void on_Yminus(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->on_rotate(1, -1.);
}  

void on_Zplus(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->on_rotate(2, 1.);
}  

void on_Zminus(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->on_rotate(2, -1.);
}  

void on_ZoomIn(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->on_move(2, 40.f/gl->Width);
}  
   
void on_ZoomOut(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->on_move(2,-40.f/gl->Width);
}

std::string crea_nome(const char *str, int num)
{
   std::stringstream s;
   s << str;
   s << "_";
   s.width(2);
   s.fill('0');
   s << num;
   std::string stringa_ret(s.str());
   return stringa_ret;
}

void GesLabelsSpec(GLWindow *gl)
{
      for (int i = 0; i < gl->NSpecies; i++)
      {
           int z = gl->ListaSpecies[i];
           std::string name = crea_nome("Label", z);
           gpointer item2 = get_object(GLWINDOW, name.c_str());
           obj_set_active(item2, FALSE);
      }
}

void GesLabels(int stato, int force, GLWindow *gl)
{
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   ModelInfo[whichModel].ToggleLabels(stato);
   aggiornaProperties(whichModel);
   if(stato + force)
   {
      ModelInfo[whichModel].specialLab = 0;
      gpointer item2 = get_object(GLWINDOW, "LabelNonH");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelHeavy");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelSelected");
      obj_set_active(item2, FALSE);
      GesLabelsSpec(gl);
   }
   gl->Redraw();
}

void LabelsOnOff(gpointer item, gpointer data)
{
   if(!GLWINDOW)
      return;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   int stato = obj_get_active(item);
   GesLabels(stato, 0, gl);
}

void LabelsOff(gpointer item, gpointer data)
{
   if(!GLWINDOW)
      return;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   GesLabels(0, 1, gl);
}

void LabelsHOnOff(gpointer item, gpointer data)
{
   if(!GLWINDOW)
      return;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   int stato = obj_get_active(item);
   if(stato)
   {
      gpointer item2 = get_object(GLWINDOW, "Label All Atoms");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelHeavy");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelSelected");
      obj_set_active(item2, FALSE);
      GesLabelsSpec(gl);
   }
   ModelInfo[whichModel].specialLab = (stato != 0)?NONH:0;
   gl->Redraw();
}  
   
void LabelsHeavy(gpointer item, gpointer data)
{
   if(!GLWINDOW)
      return;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   int stato = obj_get_active(item);
   if(stato)
   {
      gpointer item2 = get_object(GLWINDOW, "Label All Atoms");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelNonH");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelSelected");
      obj_set_active(item2, FALSE);
      GesLabelsSpec(gl);
   }
   ModelInfo[whichModel].specialLab = (stato != 0)?HEAVY:0;
   gl->Redraw();
}  
   
void LabelsSelected(gpointer item, gpointer data)
{
   if(!GLWINDOW)
      return;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   int stato = obj_get_active(item);
   if(stato)
   {
      gpointer item2 = get_object(GLWINDOW, "Label All Atoms");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelNonH");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelHeavy");
      obj_set_active(item2, FALSE);
      GesLabelsSpec(gl);
   }
   ModelInfo[whichModel].specialLab = (stato != 0)?SELECTED:0;
   gl->Redraw();
}  
   
void CellOnOff(gpointer item, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   int stato = obj_get_active(item);
   gl->ToggleCell(stato);
   aggiornaProperties();
   gl->Redraw();
}  

void set_label_status(GtkWidget *window)
{
   gpointer item2 = get_object(window, "LabelNonH");
   gboolean stato = obj_get_active(item2);
   item2 = get_object(window, "LabelHeavy");
   stato += obj_get_active(item2);
   item2 = get_object(window, "LabelSelected");
   stato += obj_get_active(item2);
   item2 = get_object(window, "Label All Atoms");
   stato += obj_get_active(item2);
   if(!stato)
      obj_set_active(item2, TRUE);
}

void on_label_name(gpointer item, gpointer data)
{
   if(!obj_get_active(item))
      return;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   ModelInfo[whichModel].labelType = LABEL_ATOM;
   GtkWidget *window = (GtkWidget *) data;
   set_label_status(window);
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->Redraw();
}

void on_label_species(gpointer item, gpointer data)
{
   if(!obj_get_active(item))
      return;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   ModelInfo[whichModel].labelType = LABEL_SPECIES;
   GtkWidget *window = (GtkWidget *) data;
   set_label_status(window);
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->Redraw();
}

void on_label_number(gpointer item, gpointer data)
{
   if(!obj_get_active(item))
      return;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   ModelInfo[whichModel].labelType = LABEL_NUMBER;
   GtkWidget *window = (GtkWidget *) data;
   set_label_status(window);
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->Redraw();
}

void show_hide_hydro(int whichModel, bool show)
{
   ModelInfo[whichModel].ifDrawH = show;
   aggiornaProperties(whichModel);
}

void show_all(int whichModel)
{
   ModelInfo[whichModel].ifDrawH = true;
   for(int i=0; i<ModelInfo[whichModel].nats; i++)
       ModelInfo[whichModel].atm[i].hidden = false;
}

void hide_selected(int whichModel)
{
   ModelInfo[whichModel].ifDrawH = true;
   for(int i=0; i<ModelInfo[whichModel].nats; i++)
       ModelInfo[whichModel].atm[i].hidden = false;
   int natoms = (int) ModelInfo[whichModel].atoms_sel.size();
   for(int i=0; i<natoms; i++)
   {
      int k = ModelInfo[whichModel].atoms_sel.at(i)-1;
      ModelInfo[whichModel].atm[k].hidden = true;
   }
}

void hide_unselected(int whichModel)
{
   ModelInfo[whichModel].ifDrawH = true;
   for(int i=0; i<ModelInfo[whichModel].nats; i++)
       ModelInfo[whichModel].atm[i].hidden = true;
   int natoms = (int) ModelInfo[whichModel].atoms_sel.size();
   for(int i=0; i<natoms; i++)
   {
      int k = ModelInfo[whichModel].atoms_sel.at(i)-1;
      ModelInfo[whichModel].atm[k].hidden = false;
   }
}

void on_show_all(gpointer item, gpointer data)
{
   if(!obj_get_active(item))
      return;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   show_all(whichModel);
   gl->Redraw();
}

void on_hide_selected(gpointer item, gpointer data)
{
   if(!obj_get_active(item))
      return;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   hide_selected(whichModel);
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->Redraw();
}

void on_hide_unselected(gpointer item, gpointer data)
{
   if(!obj_get_active(item))
      return;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   hide_unselected(whichModel);
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->Redraw();
}

void on_hide_hydrogens(gpointer item, gpointer data)
{
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   show_hide_hydro(whichModel, (obj_get_active(item) == 0));
   gl->Redraw();
}

GtkWidget *gen_strutt(GtkWidget *dlg, int ifScroll, GtkWidget *vbox1)
{
   GtkWidget *scrolledwindow1;
   if(vbox1 == NULL)
      vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dlg));

   if(ifScroll)
   {
      scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
      gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 0);
      gtk_widget_set_size_request(scrolledwindow1, -1, 300);
      gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
        GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
   }

   GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
   gtk_viewport_set_shadow_type (GTK_VIEWPORT(viewport), GTK_SHADOW_NONE);
   if(ifScroll)
      gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);
   else
      gtk_container_add (GTK_CONTAINER (vbox1), viewport);
#if 0
   GdkColor *bgcolor = getBgColor(dlg);
   widget_modify_bg(viewport, GTK_STATE_NORMAL, bgcolor);
#endif

   GtkWidget *vbox = vbox_new(FALSE, 0);
   gtk_container_add (GTK_CONTAINER (viewport), vbox);
   gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
   g_object_set_data(G_OBJECT(dlg), "Vbox", vbox);
   return vbox;
}

GtkWidget *add_label(const char *string, GtkWidget *parent)
{
   GtkWidget *label = gtk_label_new(" ");
   gtk_label_set_markup(GTK_LABEL(label), string);
   set_alignment(label, 0., 0.);
   set_margins(label, 10, 10, 10, 10);
   gtk_box_pack_start(GTK_BOX(parent), label, FALSE, FALSE, 0);
   return label;
}     
      
void init_string(std::stringstream &os, const char *title, int flag)
{       
   const char *sm =  "<span foreground=\"blue\">";
   const char *em =  "</span>";
   switch (flag)
   {
   case 0:
   case 2:
      os << "\n\n";
      break;
   case 1:
      os.str("");
      os << std::fixed << std::right << std::setprecision( 3 );
      break;
   case 3:
      os << "\n\n";
      os << std::scientific << std::right << std::setprecision(12 );
      break;
   }
   if(flag / 2)
      os <<  sm << title << em << " ";
   else
      os <<  sm << title << em << "\n   ";
}

void set_motion_type(int t, int flag)
{
   if(!GLWINDOW)
      return;
   motion_type = t;
   LoadWinCursor(flag);
   if(flag == 3)
   {
      nclicked = 0;
           gpointer item = get_object(GLWINDOW, "Select None");
           obj_activate(item);
      if(t > (GEOM+1))
      {
         GtkWidget *dlg = get_widget (GLWINDOW, "geocalc");
         if(dlg == NULL)
            return;
         GtkWidget *label = get_widget (dlg, "hint");
         std::stringstream msg;
         msg <<  "Click on " << t - 10 << " atoms";
         set_label_text(label, msg.str().c_str(), MyRED, 1.2f);
         gtk_widget_show(label);
      }
   }
}

void dist_ang (GtkToggleButton *button, gpointer data)
{
   if(gtk_toggle_button_get_active(button))
   {
      int whichCalc = GPOINTER_TO_INT(data);
      set_motion_type(GEOM+1+whichCalc, 3);
   }
}

void add_result(GtkWidget *window, int p[][2], float result_op, int toclick,
                std::string &strRes)
{
    GtkWidget *dlg = get_widget(window, "geocalc");
    const char *str[] = {"Distance ",
                         "Angle ",
                         "Torsion Angle "};
    int mu[] = {Aring, Degree, Degree};
    GtkWidget *label;
    GtkTextIter start, end;
    std::stringstream strResults;

    strResults << str[toclick-2] << "(" ;
    for(int i=0; i<toclick; i++)
    {
        char *label = g_strdup(ModelInfo[p[i][0]].atm[p[i][1]].lab);
        strResults << g_strstrip(label);
        if(i != (toclick-1))
           strResults << ", ";
        g_free(label);
    }
    strResults << ") = ";
    strResults << result_op << " " << special_car(mu[toclick-2]);
    strRes = strResults.str();
    if(dlg == NULL)
       return;
    label = get_widget(dlg, "results");
    GtkTextBuffer *textb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(label));
    gtk_text_buffer_get_bounds (textb, &start, &end);
    gtk_text_buffer_insert_with_tags_by_name(textb, &end, strResults.str().c_str(),
                                   (int) strlen(strResults.str().c_str()), MONOSPACE_FONT, NULL);
    gtk_text_buffer_insert(textb, &end, "\n",  1);
}

void print_result (GtkWidget *window, const char *msg)
{
   GtkWidget *dlg = get_widget(window, "geocalc");
   if(dlg == NULL)
      return;
   GtkWidget *label = get_widget (dlg, "hint");
   set_label_text(label, msg, MyRED, 1.2f);
   gtk_widget_show(label);
}

void close_geometry(GtkWidget *button, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   GtkWidget *dlg = gtk_widget_get_toplevel(button);

/*
   for(int i=0; i<gl->nModels; i++)
   {
       for(int j=0; j<ModelInfo[i].nats; j++)
           ModelInfo[i].atm[j].drawLabel = 0;
   }
*/
   gtk_widget_destroy(dlg);
   g_object_set_data(G_OBJECT(window), "geocalc", NULL);
   set_motion_type(NO_MOVE, 0);
   gl->Redraw();
}

GtkWidget *create_geocalc (gpointer data)
{
  GtkWidget *dialog1;
  GtkWidget *vbox1;
  GtkWidget *label;
  GtkWidget *frame;
  GtkWidget *table;
  GtkWidget *button;

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "Geometric calculations");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG (dialog1));
  table = table_new(1, 3, TRUE);
  table_set_col_spacings(table, 6);
  gtk_box_pack_start(GTK_BOX(vbox1), table, FALSE, FALSE, 10);

  GtkSizeGroup *szgroup = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  GSList *group = NULL;
  button = RADIO_BUTTON_WITH_LABEL(group, " ", MyBLUE);
  group =  gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  button = RADIO_BUTTON_WITH_LABEL(group, "Distance", MyBLUE);
  g_object_set_data(G_OBJECT(dialog1), "default_op", button);
  gtk_size_group_add_widget(szgroup, button);
  group =  gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  table_attach(table, button, 0, 1, 0, 1);
  (void) g_signal_connect (G_OBJECT (button), "toggled",
         G_CALLBACK(dist_ang), GINT_TO_POINTER(1));
  std::string tooltip = "Distance between two atoms";
  set_tip( button, tooltip.c_str());

  button = RADIO_BUTTON_WITH_LABEL(group, "Angle", MyBLUE);
  gtk_size_group_add_widget(szgroup, button);
  group =  gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  table_attach(table, button, 1, 2, 0, 1);
  (void) g_signal_connect (G_OBJECT (button), "toggled",
         G_CALLBACK(dist_ang), GINT_TO_POINTER(2));
  tooltip.assign("Angle between three atoms");
  set_tip( button, tooltip.c_str());

  button = RADIO_BUTTON_WITH_LABEL(group, "Tors.Angle", MyBLUE);
  gtk_size_group_add_widget(szgroup, button);
  group =  gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  table_attach(table, button, 2, 3, 0, 1);
  (void) g_signal_connect (G_OBJECT (button), "toggled",
         G_CALLBACK(dist_ang), GINT_TO_POINTER(3));
  tooltip.assign("Torsion angle between four atoms");
  set_tip( button, tooltip.c_str());

  label = gtk_label_new(" ");
  gtk_box_pack_start(GTK_BOX(vbox1), label, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(dialog1), "hint", label);

  frame = FRAME_BOLD ("Results", MyBLUE, 1.2f);
  gtk_box_pack_start(GTK_BOX(vbox1), frame, TRUE, TRUE, 4);
  label = scrolled_text(frame);
  g_object_set_data (G_OBJECT (dialog1), "results", label);
  gtk_widget_set_size_request(frame, -1, 100);

  button = myimage_button("  _Close", "cancel.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 1);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(close_geometry), data);

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return dialog1;
}

void CalcoliGeometrici(gpointer, gpointer data)
{
using namespace gtkext;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   GtkWidget *dlg;

   if(!gl->nModels)
   {
      dlg_errmsg(GTK_WINDOW(window), "Sorry. No models loaded.");
      return;
   }
   gpointer item = get_object(window, "Select None");
   obj_activate(item);
   if(g_object_get_data(G_OBJECT(window), "geocalc"))
   {
      dlg = get_widget(window, "geocalc");
      gdk_window_raise(gtk_widget_get_window(dlg));
      return;
   }

   dlg = create_geocalc(data);
   g_object_set_data(G_OBJECT(window), "geocalc", dlg);
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(window));
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "default_op")), TRUE);
   gtk_widget_show_all(dlg);
}

int processHitsm (GLint hits, GLuint buffer[], gpointer , 
                  std::vector<PickResult> &vresult)
{
   int i;
   unsigned int j;
   GLuint names, *ptr;
   int result = 0;

   ptr = (GLuint *) buffer;
   vresult.clear();
   for (i = 0; i < hits; i++)  //  for each hit
   {
      PickResult r;
      names = *ptr;
      ptr++;
      float z1 =  (float) *ptr/0x7fffffff;
      ptr++;
      float z2 =  (float) *ptr/0x7fffffff;
      r.zm = (z1 + z2) / 2.f;
      ptr++;
      for (j = 0; j < names; j++)      //  for each name 
      {
         if(j == 0)
            r.type = *ptr;
         else if(j == 1)
            r.model = *ptr;
         else 
            r.object = *ptr;
         ptr++;
      }
      vresult.push_back(r);
      result = 1;
   }
   return result;
}

void pickMatrix(double x, double y, double deltax, double deltay,
                  GLint viewport[4])
{
    if (deltax <= 0 || deltay <= 0) {
        return;
    }

// Translate and scale the picked region to the entire window 
    glTranslated((viewport[2] - 2 * (x - viewport[0])) / deltax,
            (viewport[3] - 2 * (y - viewport[1])) / deltay, 0);
    glScaled(viewport[2] / deltax, viewport[3] / deltay, 1.0);
}

int *pickObjects(int x, int y, gpointer data, bool only_atoms,
                 double wp, double hp, bool ifMultiple)
     
{
   GLWindow *gl = (GLWindow *)data;
   int BUFSIZE = 0;
   GLint viewport[4];

   if(ifMultiple)
      BUFSIZE = 5000;
   else
      BUFSIZE = 100;
   GLuint *selectBuf = g_new0(GLuint, BUFSIZE);
   GLint hits;

   glGetIntegerv (GL_VIEWPORT, viewport);
   glSelectBuffer (BUFSIZE, selectBuf);
   (void) glRenderMode (GL_SELECT);

   glMatrixMode(GL_PROJECTION);
   glPushMatrix ();
   glLoadIdentity();

//  create wpxhp pixel picking region near cursor location 
   pickMatrix (x, y, wp, hp, viewport);

   gl->SetViewpoint(Range);

   glMatrixMode(GL_MODELVIEW);

   glInitNames();

   for(int i=0; i<gl->nModels;i++)
   {
       if (ModelInfo[i].ifVis)
       {
           if(only_atoms)
               ModelInfo[i].DrawAtoms(gl, i);
           else if (ModelInfo[i].IsProtein())         // Proteins
           {
               if(ModelInfo[i].plotStyle >= RIBBONS)
                  ModelInfo[i].DrawRibbons(gl, false, i);
               else
               {
                   ModelInfo[i].DrawBonds2(gl, i);
                   if(ModelInfo[i].plotStyle != C_ALPHA)
                      ModelInfo[i].DrawAtoms(gl, i);
               }
               ModelInfo[i].DrawBonds2(gl, i, true);    // Ligands
           }
           else
           {
               ModelInfo[i].DrawBonds(gl, i);
               ModelInfo[i].DrawAtoms(gl, i);
           }
       }
   }

   glMatrixMode (GL_PROJECTION);
   glPopMatrix ();
   glFlush ();

   hits = glRenderMode (GL_RENDER);
   glMatrixMode(GL_MODELVIEW);
   int *vres = g_new0(int, 4);
   if(hits > 0)
   {
      std::vector<PickResult> vresult;
      int result = processHitsm (hits, selectBuf, data, vresult);
      vres[0] = result;
      if(result)
      {
          int sz = (int) vresult.size();
          if(ifMultiple)
          {
             g_free(vres);
             vres = g_new0(int, 3*sz+1);
             vres[0] = sz;
             for(int i=0; i<sz; i++)
             {
                 PickResult v = vresult.at(i);
                 vres[3*i+1] = v.type;
                 vres[3*i+2] = v.model;
                 vres[3*i+3] = v.object;
             }   
          }
          else
          {
             int found = 0;
             float zmold = 1e6;
             for(int i=0; i<sz; i++)
             {
                 PickResult v = vresult.at(i);
                 if((v.type != 1) && (v.zm <= zmold))
                 {
                    vres[1] = v.type;
                    vres[2] = v.model;
                    vres[3] = v.object;
                    zmold   = v.zm;
                    found++;
                 }
             }
             if(found == 0)
             {
                zmold = 1e6;
                for(int i=0; i<sz; i++)
                {
                    PickResult v = vresult.at(i);
                    if(v.zm <= zmold)
                    {
                       vres[1] = v.type;
                       vres[2] = v.model;
                       vres[3] = v.object;
                       zmold   = v.zm;
                    }
                }
             }
          }
      }
   }
   g_free(selectBuf);
   return vres;
} 

void on_ClearExtra(gpointer,  gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   if(!gl->nModels)
      return;
   for(int k=0; k<gl->nModels; k++)
       for(int i=0; i<ModelInfo[k].nats; i++)
           ModelInfo[k].atm[i].drawLabel = 0;
   gl->DistAng_vet.clear();
   gl->PrintMess(" ");
   gl->Redraw();
}

void SelectAtom(GtkWidget *, int x, int y, gpointer data)
{
     GLWindow *gl = (GLWindow *)data;
     set_motion_type(NO_MOVE, 0);
     int result, whichModel, whichAtom, *p;
     p = pickObjects(x, y, data, true);
     result = p[0];
     whichModel = p[2];
     whichAtom  = p[3];
     g_free(p);
     if(result)
     {
        move_center(ModelInfo[whichModel].atm[whichAtom].xyzc, whichModel, whichAtom, false);
        const char *str = ModelInfo[whichModel].atm[whichAtom].lab;
        gl->PrintMess(str);
        vet3 xyzc = MRVectorSub(
          MRVectorMake(ModelInfo[whichModel].atm[whichAtom].xyzc), defaultV0);
        vet3 xyz = gl->FractToCart(xyzc);
        aggiorna_centro(xyz);
     }
}

gboolean SelectAtoms(GtkWidget *widget, int x, int y, gpointer data)
{
     GLWindow *gl = (GLWindow *)data;

     static int punti[4][2];
     int toclick = motion_type - GEOM;
     int result, *p;
     std::string results;
     p = pickObjects(x, y, data, true);
     result = p[0];
     if(result)
     {
        punti[nclicked][0] = p[2];        // whichModel
        punti[nclicked][1] = p[3];        // whichAtom
        ModelInfo[p[2]].UpdateSelectedAtom(p[3], false);
        nclicked = (int) ModelInfo[p[2]].atoms_sel.size(); //++;
        ModelInfo[p[2]].atm[p[3]].drawLabel = 1;
        gl->Redraw();
        if(toclick == 1)                  //sphere
        {
           for(int j=0; j<ModelInfo[p[2]].nats; j++)
               ModelInfo[p[2]].atm[j].drawLabel = 0;
           ModelInfo[p[2]].atm[p[3]].drawLabel = 1;
           nclicked = 0;
           gl->SetSphereCentre(p[2], p[3]);
           if(g_object_get_data(G_OBJECT(GLWINDOW), "sphere_dlg"))
           {
              GtkWidget *dlg = get_widget(GLWINDOW, "sphere_dlg");
              int whichModel = p[2]+1;
              g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(whichModel));
           }
        }
        else if(nclicked == toclick)           // end
        {
           float **Atomi = g_new0(float *, toclick);
           int  kmodel = GetActiveModel() - 1;
           for(int k=0; k<toclick; k++)
           {
              Atomi[k] = g_new0(float, 3);
              punti[k][1] = ModelInfo[kmodel].atoms_sel[k]-1;
              for(int kj=0;kj<3;kj++)
                  Atomi[k][kj] = ModelInfo[kmodel].atm[punti[k][1]].xyz[kj];
                  //Atomi[k][kj] = ModelInfo[punti[k][0]].atm[punti[k][1]].xyz[kj];
           }
           float result_op = calcDistAng(Atomi, toclick);
           DistAng_type v;
           switch(toclick)
           {
           case 2:
           case 3:
           case 4:
                v.op = toclick;
                for(int k=0; k<toclick; k++)
                {
                    v.wM[k] = punti[k][0];
                    v.wA[k] = punti[k][1];
//azzera le labels degli atomi per le misure
                    ModelInfo[v.wM[k]].atm[v.wA[k]].drawLabel = 0;
                }
                v.result = result_op;
                gl->DistAng_vet.push_back(v);
                break;
           default:
                break;
           }
           gdk_window_set_cursor(gtk_widget_get_window(widget),NULL);
           nclicked = 0;
           print_result(GLWINDOW, " ");
           add_result(GLWINDOW, punti, result_op, toclick, results);
           gpointer item = get_object(GLWINDOW, "Select None");
           obj_activate(item);
           gl->PrintMess(results.c_str());
        }
        else
        {
           //ModelInfo[p[2]].UpdateSelectedAtom(p[3], true);
//azzera le labels degli atomi per le misure
           if((motion_type > GEOM) && (motion_type <= (GEOM+4)))
              ModelInfo[p[2]].atm[p[3]].drawLabel = 0;

           if(nclicked == 0)
              print_result(GLWINDOW, "Click on first atom.");
           if(nclicked == 1)
              print_result(GLWINDOW, "Click on second atom.");
           else if(nclicked == 2)
              print_result(GLWINDOW, "Click on third atom.");
           else if(nclicked == 3)
              print_result(GLWINDOW, "Click on fourth atom.");
           return FALSE;
        }
    }
    else
        return FALSE;
    return TRUE;
}

void on_label_by_spec(gpointer item, gpointer data)
{
   if(!GLWINDOW)
      return;
   int whichSpec = GPOINTER_TO_INT(data);
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   int stato = obj_get_active(item);
   if(stato)
   {
      gpointer item2 = get_object(GLWINDOW, "Label All Atoms");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelNonH");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelHeavy");
      obj_set_active(item2, FALSE);
      item2 = get_object(GLWINDOW, "LabelSelected");
      obj_set_active(item2, FALSE);
//      ModelInfo[whichModel].notLabelH = (stato != 0)?-1:0;
   }
   ModelInfo[whichModel].specialLab = (stato != 0)?-1:0;
   ModelInfo[whichModel].LabelS[whichSpec] = (stato != 0)?1:0;
   gl->Redraw();
}

void select_bond_mult(gpointer item, gpointer data)
{
   default_bond_mult = GPOINTER_TO_INT(data);
}

#ifdef USE_ACTIONS
void update_menu(const char* menufather, const char *menutitle, bool ifChange=false, bool ifAddAtom=false)
{
   if(!GLWINDOW)
        return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gpointer item = get_object(GLWINDOW, menutitle);
   if(item == NULL)
      return;
   static const char *tipi[] = {"Single", "Double", "Triple"};
   GCallback cb = G_CALLBACK(g_object_get_data(G_OBJECT(item), "callback"));

   GtkUIManager *merge = (GtkUIManager *) get_object(GLWINDOW, "ui-manager");
   GtkActionGroup *ag = (GtkActionGroup *) get_object(GLWINDOW, "action_group");

   std::string new_string =
                     " <ui>"
                     "   <menubar name='MenuBar'>"
                     "     <menu action='";
   new_string.append(menufather);
   new_string.append("'>"
                     "     <placeholder name='");
   new_string.append(menutitle);
   new_string.append( "'>"
                     "       <menu action='");
   new_string.append(menutitle);
   new_string.append("'>");
   int nActs = gl->NSpecies + 1;
   if(!ifChange)
   {
      new_string.append("          <menuitem action='");
      new_string.append(menutitle);
      new_string.append("_00'/>");
//      nActs++;
   }
   if(ifAddAtom)
      nActs +=3;
   GtkAction **actions = g_new0(GtkAction *, nActs);
   int k = 0;
//   if(!ifChange)
//   {
         std::string a = menutitle;
         a.append("_00");
   if(!ifChange)
         actions[k] = gtk_action_new(g_strdup(a.c_str()), g_strdup("Ghosts"),
                                     NULL, NULL);
   else
         actions[k] = gtk_action_new(g_strdup(a.c_str()), g_strdup("Other"),
                                     NULL, NULL);
         g_signal_connect(G_OBJECT(actions[k]), "activate", cb, 
                          GINT_TO_POINTER(OTHERS));
         k++;
//   }
   for (int i = 0; i < gl->NSpecies; i++)
   {
          std::string item_lab;
          int z = gl->ListaSpecies[i];
          if(ifChange)
             item_lab.assign(get_nth_element_name(gl->ListaSpecies[i]-1));
          else
          {
             std::string spec = get_nth_element(gl->ListaSpecies[i]-1);
             item_lab = spec + " Atoms";
          }
          std::string a = crea_nome(menutitle, i+1);
          new_string.append("          <menuitem action='");
          new_string.append(a);
          new_string.append("'/>");
          actions[k] = gtk_action_new(g_strdup(a.c_str()),
                       g_strdup(item_lab.c_str()), NULL, NULL);
          g_signal_connect(G_OBJECT(actions[k]), "activate", cb, 
                           GINT_TO_POINTER(z));
          k++;
   }
   if(ifChange)
   {
      new_string.append("          <menuitem action='");
      new_string.append(menutitle);
      new_string.append("_00'/>");
   }
     if(ifAddAtom)
     {
        GSList *group = NULL;
        new_string.append("      <separator/>");
        for(int kk=0; kk<3; kk++)
        {
        new_string.append("          <menuitem action='");
        new_string.append(tipi[kk]);
        new_string.append("'/>");
        actions[k] = GTK_ACTION(gtk_radio_action_new(g_strdup(tipi[kk]),
             g_strdup(tipi[kk]), NULL, NULL, kk));
        gtk_radio_action_set_group(GTK_RADIO_ACTION(actions[k]), group);
        group = gtk_radio_action_get_group(GTK_RADIO_ACTION(actions[k]));
        if(kk == default_bond_mult)
#if GTK_MINOR_VERSION >= 10
           gtk_radio_action_set_current_value(GTK_RADIO_ACTION(actions[k]), kk);
#else
           g_object_set(G_OBJECT(actions[k]), "value", kk, NULL);
#endif

        g_signal_connect(G_OBJECT(actions[k]), "activate", 
                        G_CALLBACK(select_bond_mult), GINT_TO_POINTER(kk));
        k++;
        }
     }

   new_string.append( "      </menu>"
                      "     </placeholder>"
                      "     </menu>"
                      "   </menubar>"
                      " </ui>");
   for(int i=0; i<=MAX_SPECIES; i++)
   {
       std::string a = crea_nome(menutitle, i);
       GtkAction *act = gtk_action_group_get_action(ag, a.c_str());
       if(act != NULL)
          gtk_action_group_remove_action(ag, act);
   }
   for(int i=0; i<3; i++)
   {
       GtkAction *act = gtk_action_group_get_action(ag, tipi[i]);
       if(act != NULL)
          gtk_action_group_remove_action(ag, act);
   }

   std::string nome = menutitle;
   nome.append("actSpec");
   guint actSpecies = (guint) GPOINTER_TO_INT(g_object_get_data(G_OBJECT(merge), nome.c_str()));
   if(actSpecies)
        gtk_ui_manager_remove_ui(merge, actSpecies);

   for(int i=0; i<k; i++)
       gtk_action_group_add_action(ag, actions[i]);
   GError *error = NULL;
   actSpecies = gtk_ui_manager_add_ui_from_string(merge, new_string.c_str(), -1, &error);
   if(!actSpecies)
   {
      g_message ("building menus failed: %s", error->message);
      g_error_free (error);
   }
   else
      g_object_set_data(G_OBJECT(merge), nome.c_str(), GINT_TO_POINTER(actSpecies));
}

void update_menuLabel()
{
   const char* menufather = "ViewMenu";
   const char *menutitle = "Label";
   if(!GLWINDOW)
        return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gpointer item = get_object(GLWINDOW, menutitle);
   if(item == NULL)
      return;
   GCallback cb = G_CALLBACK(on_label_by_spec);

   GtkUIManager *merge = (GtkUIManager *) get_object(GLWINDOW, "ui-manager");
   GtkActionGroup *ag = (GtkActionGroup *) get_object(GLWINDOW, "action_group");

   std::string new_string =
                     " <ui>"
                     "   <menubar name='MenuBar'>"
                     "     <menu action='";
   new_string.append(menufather);
   new_string.append( "'>"
                     "       <menu action='");
   new_string.append(menutitle);
   new_string.append("'>");
   int nActs = gl->NSpecies;
   GtkToggleAction **actions = g_new0(GtkToggleAction *, nActs);
   int k = 0;
   
   for (int i = 0; i < gl->NSpecies; i++)
   {
          std::string item_lab;
          int z = gl->ListaSpecies[i]-1;
          std::string spec = get_nth_element(gl->ListaSpecies[i]-1);
          item_lab = spec + " Atoms";
          std::string a = crea_nome(menutitle, z+1);
          new_string.append("          <menuitem action='");
          new_string.append(a);
          new_string.append("'/>");
          actions[k] = gtk_toggle_action_new(g_strdup(a.c_str()),
                       g_strdup(item_lab.c_str()), NULL, NULL);
          g_signal_connect(G_OBJECT(actions[k]), "activate", cb, 
                           GINT_TO_POINTER(z));
          k++;
   }
   new_string.append( "      </menu>"
                      "     </menu>"
                      "   </menubar>"
                      " </ui>");
   for(int i=0; i<=N_ELEMENTS; i++)
   {
       std::string a = crea_nome(menutitle, i+1);
       GtkAction *act = gtk_action_group_get_action(ag, a.c_str());
       if(act != NULL)
          gtk_action_group_remove_action(ag, act);
   }

   std::string nome = menutitle;
   nome.append("actSpec");
   guint actSpecies = (guint) GPOINTER_TO_INT(g_object_get_data(G_OBJECT(merge), nome.c_str()));
   if(actSpecies)
        gtk_ui_manager_remove_ui(merge, actSpecies);

   for(int i=0; i<k; i++)
   {
       gtk_action_group_add_action(ag, GTK_ACTION(actions[i]));
       g_object_set_data(G_OBJECT(GLWINDOW), gtk_action_get_name(GTK_ACTION(actions[i])),
           (gpointer) actions[i]);
   }
   GError *error = NULL;
   actSpecies = gtk_ui_manager_add_ui_from_string(merge, new_string.c_str(), -1, &error);
   if(!actSpecies)
   {
      g_message ("building menus failed: %s", error->message);
      g_error_free (error);
   }
   else
      g_object_set_data(G_OBJECT(merge), nome.c_str(), GINT_TO_POINTER(actSpecies));
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   for (int i = 0; i < gl->NSpecies; i++)
   {
        int z = gl->ListaSpecies[i];
        std::string name = crea_nome("Label", z);
        gpointer item2 = get_object(GLWINDOW, name.c_str());
        obj_set_active(item2, ModelInfo[whichModel].LabelS[z-1], true);
   }
}

#else
void update_menuLabel()
{
     const char *menutitle = "Label";
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

     GtkWidget *item = get_widget(GLWINDOW, menutitle);
     if(item == NULL)
        return;
     GCallback cb = G_CALLBACK(on_label_by_spec);
     GtkWidget *menuitem = gtk_menu_new();
     gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), menuitem);
     gtk_widget_show(menuitem);
     item = gtk_check_menu_item_new_with_mnemonic("All Atoms");
     GtkWidget *label = gtk_bin_get_child(GTK_BIN(item));
     if(label != NULL)
        set_widget_font(label, "sans 9");
     gtk_widget_show(item);
     gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
     g_object_set_data(G_OBJECT(GLWINDOW), "Label All Atoms", item);
     int hnd = g_signal_connect( G_OBJECT(item), "activate",
        G_CALLBACK(LabelsOnOff), (gpointer)GLWINDOW);
     g_object_set_data(G_OBJECT(item), "hnd", GINT_TO_POINTER(hnd));

     item = gtk_menu_item_new_with_mnemonic("Delete All Labels");
     label = gtk_bin_get_child(GTK_BIN(item));
     if(label != NULL)
        set_widget_font(label, "sans 9");
     gtk_widget_show(item);
     gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
     g_object_set_data(G_OBJECT(GLWINDOW), "Delete All Labels", item);
     hnd = g_signal_connect( G_OBJECT(item), "activate",
        G_CALLBACK(LabelsOff), (gpointer)GLWINDOW);
     g_object_set_data(G_OBJECT(item), "hnd", GINT_TO_POINTER(hnd));

     item = gtk_check_menu_item_new_with_mnemonic("except Hydrogens");
     label = gtk_bin_get_child(GTK_BIN(item));
     if(label != NULL)
        set_widget_font(label, "sans 9");
     gtk_widget_show(item);
     gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
     g_object_set_data(G_OBJECT(GLWINDOW), "LabelNonH", item);
     hnd = g_signal_connect( G_OBJECT(item), "activate",
        G_CALLBACK(LabelsHOnOff), (gpointer)GLWINDOW);
     g_object_set_data(G_OBJECT(item), "hnd", GINT_TO_POINTER(hnd));
     item = gtk_check_menu_item_new_with_mnemonic("heavy atoms");
     label = gtk_bin_get_child(GTK_BIN(item));
     if(label != NULL)
        set_widget_font(label, "sans 9");
     gtk_widget_show(item);
     gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
     g_object_set_data(G_OBJECT(GLWINDOW), "LabelHeavy", item);
     hnd = g_signal_connect( G_OBJECT(item), "activate",
        G_CALLBACK(LabelsHeavy), (gpointer)GLWINDOW);
     g_object_set_data(G_OBJECT(item), "hnd", GINT_TO_POINTER(hnd));
     item = gtk_check_menu_item_new_with_mnemonic("selected atoms");
     label = gtk_bin_get_child(GTK_BIN(item));
     if(label != NULL)
        set_widget_font(label, "sans 9");
     gtk_widget_show(item);
     gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
     g_object_set_data(G_OBJECT(GLWINDOW), "LabelSelected", item);
     hnd = g_signal_connect( G_OBJECT(item), "activate",
        G_CALLBACK(LabelsSelected), (gpointer)GLWINDOW);
     g_object_set_data(G_OBJECT(item), "hnd", GINT_TO_POINTER(hnd));
     for (int i = 0; i < gl->NSpecies; i++)
     {
          std::string item_lab;
          int z = gl->ListaSpecies[i]-1;
          std::string a = crea_nome(menutitle, z+1);
          std::string spec = get_nth_element(gl->ListaSpecies[i]-1);
          item_lab = spec + " Atoms";
          item = gtk_check_menu_item_new_with_mnemonic(item_lab.c_str());
          label = gtk_bin_get_child(GTK_BIN(item));
          if(label != NULL)
             set_widget_font(label, "sans 9");
          gtk_widget_show(item);
          gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
          g_object_set_data(G_OBJECT(GLWINDOW), a.c_str(), item);
          hnd = g_signal_connect( G_OBJECT(item), "activate",
                        cb, GINT_TO_POINTER(z));
          g_object_set_data(G_OBJECT(item), "hnd", GINT_TO_POINTER(hnd));
     }

   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   
   gpointer item2 = get_object(GLWINDOW, "Label All Atoms");
   obj_set_active(item2, ModelInfo[whichModel].ifLabels, true);
   item2 = get_object(GLWINDOW, "LabelNonH");
   obj_set_active(item2, (ModelInfo[whichModel].specialLab==NONH), true);
   item2 = get_object(GLWINDOW, "LabelHeavy");
   obj_set_active(item2, (ModelInfo[whichModel].specialLab==HEAVY), true);
   item2 = get_object(GLWINDOW, "LabelSelected");
   obj_set_active(item2, (ModelInfo[whichModel].specialLab==SELECTED), true);
   for (int i = 0; i < gl->NSpecies; i++)
   {
        int z = gl->ListaSpecies[i];
        std::string name = crea_nome("Label", z);
        item2 = get_object(GLWINDOW, name.c_str());
        obj_set_active(item2, ModelInfo[whichModel].LabelS[z-1], true);
   }
}
#endif


void update_menu(const char *menutitle, bool ifChange=false, bool ifAddAtom=false)
{
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

     GtkWidget *item = get_widget(GLWINDOW, menutitle);
     if(item == NULL)
        return;
     GCallback cb = G_CALLBACK(g_object_get_data(G_OBJECT(item), "callback"));
     GtkWidget *menuitem = gtk_menu_new();
     gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), menuitem);
     gtk_widget_show(menuitem);
     if(!ifChange)
     {
        item = gtk_menu_item_new_with_label("Ghosts");
        GtkWidget *label = gtk_bin_get_child(GTK_BIN(item));
        if(label != NULL)
           set_widget_font(label, "sans 9");
        gtk_widget_show(item);
        gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
        g_signal_connect( G_OBJECT(item), "activate",
                        cb, GINT_TO_POINTER(OTHERS));
     }
     for (int i = 0; i < gl->NSpecies; i++)
     {
          std::string item_lab;
          int z = gl->ListaSpecies[i];
          if(ifChange)
             item_lab.assign(get_nth_element_name(gl->ListaSpecies[i]-1));
          else
          {
             std::string spec = get_nth_element(gl->ListaSpecies[i]-1);
             item_lab = spec + " Atoms";
          }
          item = gtk_menu_item_new_with_label(item_lab.c_str());
          GtkWidget *label = gtk_bin_get_child(GTK_BIN(item));
          if(label != NULL)
             set_widget_font(label, "sans 9");
          gtk_widget_show(item);
          gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
          g_signal_connect( G_OBJECT(item), "activate",
                        cb, GINT_TO_POINTER(z));
     }
     if(ifChange)
     {
        item = gtk_menu_item_new_with_label("Other");
        GtkWidget *label = gtk_bin_get_child(GTK_BIN(item));
        if(label != NULL)
           set_widget_font(label, "sans 9");
        gtk_widget_show(item);
        gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
        g_signal_connect( G_OBJECT(item), "activate",
                        cb, GINT_TO_POINTER(OTHERS));
     }
     if(ifAddAtom)
     {
        GSList *group = NULL;
        static const char *tipi[] = {"Single", "Double", "Triple"};
        item = gtk_separator_menu_item_new();
        gtk_widget_show(item);
        gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
        for(int kk=0; kk<3; kk++)
        {
        item = gtk_radio_menu_item_new_with_label(group, tipi[kk]);
        GtkWidget *label = gtk_bin_get_child(GTK_BIN(item));
        if(label != NULL)
           set_widget_font(label, "sans 9");
        gtk_widget_show(item);
        gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
        group = gtk_radio_menu_item_get_group (GTK_RADIO_MENU_ITEM (item));
        if(kk == default_bond_mult)
          gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (item), TRUE);
        g_signal_connect( G_OBJECT(item), "activate",
                        G_CALLBACK(select_bond_mult), GINT_TO_POINTER(kk));
        }
     }
}

void update_menu_delete()
{
     if(!GLWINDOW)
        return;
     gpointer item = get_object(GLWINDOW, "Delete All Type ...");
     if(item)
        g_object_set_data(G_OBJECT(item), "callback", (gpointer)on_delete_by_spec);

     item = get_object(GLWINDOW, "Select Type ...");
     if(item)
        g_object_set_data(G_OBJECT(item), "callback", (gpointer)on_select_by_spec);

     item = get_object(GLWINDOW, "Change Species");
     if(item)
        g_object_set_data(G_OBJECT(item), "callback", (gpointer)on_change_spec);

     item = get_object(GLWINDOW, "Add Atom");
     if(item)
        g_object_set_data(G_OBJECT(item), "callback", (gpointer)on_add_atom);

     item = get_object(GLWINDOW, "Popup Change Species");
     if(item)
        g_object_set_data(G_OBJECT(item), "callback", (gpointer)on_change_spec);
#ifdef USE_ACTIONS
     update_menu("Select", "Select Type ...");
     update_menu("Modify", "Delete All Type ...");
     update_menu("Modify", "Change Species", true);
     update_menu("Modify", "Add Atom", true, true);
     update_menuLabel();
#else
     update_menu("Select Type ...");
     update_menu("Delete All Type ...");
     update_menu("Change Species", true);
     update_menu("Add Atom", true, true);
     update_menuLabel();
#endif
     update_menu("Popup Change Species", true);
}

int get_undo_redo(int but)
{
   int stato;
   if(!GLWINDOW)
      return 0;
   if(but == 0)
      stato = get_int(GLWINDOW, "status_undo");
   else
      stato = get_int(GLWINDOW, "status_redo");
   return stato;
}

void set_children_status(gpointer item, gboolean active, GtkWidget *top=NULL)
{
     if(item == NULL)
        return;
     if(top == NULL)
        top = GLWINDOW;
     obj_set_sensitive(item, TRUE);
     GtkWidget *menuitem = NULL;
#ifdef USE_ACTIONS
     if(GTK_IS_ACTION(item))
     {
        menuitem = get_widget_from_action(GTK_ACTION(item));
        if(!menuitem)
           obj_set_sensitive(item, (active > 0));
     }
     else if(GTK_IS_WIDGET(item))
        menuitem = GTK_WIDGET(item);
#else
     menuitem = GTK_WIDGET(item);
#endif
     if(!menuitem)
        return;
     GtkWidget *submenu = gtk_menu_item_get_submenu(GTK_MENU_ITEM(menuitem));
     if(submenu == NULL)
        obj_set_sensitive(item, (active > 0));
     else
     {
        GList *children = gtk_container_get_children(GTK_CONTAINER(submenu));
        for(int i=0; i<(int)g_list_length(children); i++)
        {
            GtkWidget *w = (GtkWidget *)g_list_nth_data(children, i);
#ifdef USE_ACTIONS
            GtkAction *act = get_action_from_widget(w, top);
            if(GTK_IS_ACTION(act))
               gtk_action_set_sensitive(act, (active > 0));
#else
            gtk_widget_set_sensitive(w, (active > 0));
#endif
        }
        g_list_free(children);
     }
}

void set_mode(int whichMode, bool active)
{
   if(!GLWINDOW)
      return;
   const char *button_names[] = {"SelectOn", "RectSelect", "MolSelect", 
                                 "ManipulationOn", "ZoomOn",
                                 "MeasureD","MeasureA", "MeasureT" };

   bool activated = false;
   for(guint i=0; i<G_N_ELEMENTS(button_names); i++)
   {
       gpointer button = get_object(GLWINDOW, button_names[i]);
       if(obj_get_active(button))
       {
          activated = true;
          break;
       }
   }

   gpointer button = NULL;
   guint found = G_N_ELEMENTS(button_names);
   for(guint i=0; i<G_N_ELEMENTS(button_names); i++)
   {
       if(whichMode == modes[i])
       {
          button = get_object(GLWINDOW, button_names[i]);
          found = i;
          break;
       }
   }
   if(found != G_N_ELEMENTS(button_names))
   {
      if(active)
         obj_set_active(button, TRUE);
      for(guint j=0; j<G_N_ELEMENTS(button_names); j++)  // disattiva gli altri
      {
          if(j == found)
             continue;
          gpointer button1 = get_object(GLWINDOW, button_names[j]);
          obj_set_active(button1, FALSE);
      }
      return;
   }
   found = G_N_ELEMENTS(button_names);
   for(guint i=0; i<G_N_ELEMENTS(button_names); i++)
   {
       if((guint) whichMode == (i+'1'))
       {
          button = get_object(GLWINDOW, button_names[i]);
          found = i;
          break;
       }
   }
// se arriva dal menu' e nessun bottone e' attivo, deve attivare il bottone della toolbar
   if((found != G_N_ELEMENTS(button_names)) && !activated)
      obj_set_active(button, TRUE);
}

void updateModify(int active)
{
   if(!GLWINDOW)
      return;
     static int stat0_sav=1, stat1_sav=1;
     gpointer item = get_object(GLWINDOW, "Undo");

     std::string label = obj_get_label(item);
     stat0_sav = (strcmp(trim(label).c_str(), "Undo") != 0);
     item = get_object(GLWINDOW, "Redo");
     label = obj_get_label(item);
     stat1_sav = (strcmp(trim(label).c_str(), "Redo") != 0);

     int act_modi = active;
     int act_info = active;
     if(active == 3)
     {
        act_modi = 0;
        act_info = 1;
     }
     int stat0 = get_undo_redo(0);
     int stat1 = get_undo_redo(1);
     if(act_modi)
     {
        stat0 = stat0_sav;
        stat1 = stat1_sav;
     }
     else
     {
        stat0_sav = stat0;
        stat1_sav = stat1;
        stat0 = 0;
        stat1 = 0;
     }
     item = get_object(GLWINDOW, "Modify");
     gpointer item2 = get_object(GLWINDOW, "Select");
     gpointer button = get_object(GLWINDOW, "SelectOn");
     if(button)
        obj_set_sensitive(button, TRUE);
     gpointer button1 = get_object(GLWINDOW, "Selection Mode");
     if(button1)
        obj_set_sensitive(button1, TRUE);
     update_menu_delete();
     if(active == -99)
     {
        set_children_status(item, FALSE);
        set_children_status(item2, FALSE);
        if(button)
           obj_set_sensitive(button, FALSE);
        if(button1)
           obj_set_sensitive(button1, FALSE);
        item = get_object(GLWINDOW, "Tools");
        set_children_status(item, FALSE);
        item = get_object(GLWINDOW, "Geometry");
        set_children_status(item, FALSE);
        item = get_object(GLWINDOW, "Import");
        set_children_status(item, FALSE);
        set_mode('M', true);
        return;
     }
     if(button)
        obj_set_sensitive(button, act_modi);
     set_children_status(item, act_modi);
     set_children_status(item2, act_modi);
     item = get_object(GLWINDOW, "Geometry");
     set_children_status(item, TRUE);
     item = get_object(GLWINDOW, "Undo");
     set_children_status(item, stat0);
     item = get_object(GLWINDOW, "Redo");
     set_children_status(item, stat1);
     item = get_object(GLWINDOW, "Import Structure");
     set_children_status(item, act_modi);
     item = get_object(GLWINDOW, "Import Fragment");
     set_children_status(item, act_modi);

     if(active < 0)                // se non ci sono atomi
     {
        item = get_object(GLWINDOW, "Add fragments");
        set_children_status(item, TRUE);
        item = get_object(GLWINDOW, "Info");
        set_children_status(item, FALSE);
        item = get_object(GLWINDOW, "Tools");
        set_children_status(item, FALSE);
        return;
     }
     item = get_object(GLWINDOW, "Import");
     set_children_status(item, act_modi);
     item = get_object(GLWINDOW, "Tools");
     set_children_status(item, act_modi);
     item = get_object(GLWINDOW, "Info");
     set_children_status(item, act_info);
//     update_items_modify(active!=0);
     
     item = get_object(GLWINDOW, "Short Contacts");
     int val = obj_get_active(item);
     item = get_object(GLWINDOW, "Hydrogen Bonds");
     val += obj_get_active(item);
     item = get_object(GLWINDOW, "Delete Hanging Contacts");
     obj_set_sensitive(item, val);
     update_items_modify(act_modi > 0);
}

void update_items_modify(bool status, bool updateList)
{
     if(!GLWINDOW)
        return;
     gpointer item2 = get_object(GLWINDOW, "Modify residues");
     obj_set_visible(item2, FALSE);

     if(!status)
         return;
     int nAtomsSel = 0;
     int nBondsSel = 0;
     int nResidSel = 0;
     bool ncent = false;
     int inModify = GetActiveModel() - 1;
//     if(inModify > -1)
     {
        int wM = (inModify > -1)?inModify:0;
        nAtomsSel = (int) ModelInfo[wM].atoms_sel.size();
        nBondsSel = (int) ModelInfo[wM].bonds_sel.size();
        nResidSel = (int) ModelInfo[wM].resid_sel.size();
        ncent = !ModelInfo[wM].ifCentro;
        if(updateList)
           ModelInfo[wM].UpdateInfoSelections();
        if(ModelInfo[wM].IsProtein() && item2)
        {
           obj_set_visible(item2, TRUE);
           item2 = get_object(GLWINDOW, "Delete selected residue(s)");
           obj_set_sensitive(item2, nResidSel);
           item2 = get_object(GLWINDOW, "Delete side chain");
           obj_set_sensitive(item2, nResidSel);
           item2 = get_object(GLWINDOW, "Delete aromatic ring");
           obj_set_sensitive(item2, nResidSel);
        }
     }
     item2 = get_object(GLWINDOW, "Add Atom");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Duplicate Selected Atoms");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Expand to molecule");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Move Atoms");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Delete Selection");
     obj_set_sensitive(item2, nAtomsSel|nBondsSel|nResidSel);
     item2 = get_object(GLWINDOW, "Delete Bonds");
     obj_set_sensitive(item2, nBondsSel);
     item2 = get_object(GLWINDOW, "Select None");
     obj_set_sensitive(item2, nAtomsSel|nBondsSel|nResidSel);
     item2 = get_widget(GLWINDOW, "Add Bonds");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Change Species");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Rename");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Renumber");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Complete");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Regularize");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Enantiomorph");
     obj_set_sensitive(item2, ncent);
     item2 = get_object(GLWINDOW, "Methine C-H");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Methylene Group");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Methyl Group");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Aromatic C-H");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Hydroxyl O-H");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Terminal X=CH2");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Terminal B-H");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Acetylenic C-H");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Selected Atoms Plane");
     obj_set_sensitive(item2, nAtomsSel);
     item2 = get_object(GLWINDOW, "Optimize Selected Atoms");
     obj_set_sensitive(item2, nAtomsSel);
//     update_menu_delete();
}

void on_contacts_atom(GtkWidget *w, gpointer data)
{
    GtkWidget *father = gtk_widget_get_parent(w);
    int n = get_int(father, "whichObject");
    int whichAtom = n / 10 + 1;
    int whichModel = n % 10 + 1;
    int code = 1, ncontact=0;
    jav_expand_contacts_(&whichAtom, &whichModel, &code, &ncontact);
}

void on_contacts_mol(GtkWidget *w, gpointer data)
{
    GtkWidget *father = gtk_widget_get_parent(w);
    int n = get_int(father, "whichObject");
    int whichAtom = n / 10 + 1;
    int whichModel = n % 10 + 1;
    int code = 2, ncontact=0;
    jav_expand_contacts_(&whichAtom, &whichModel, &code, &ncontact);
}

void build_popup(int whichType, GtkWidget *window)
{
     GtkWidget *menu1 = gtk_menu_new ();
     std::stringstream nome;
     nome << "Popup " << whichType;
     g_object_set_data(G_OBJECT(window), nome.str().c_str(), menu1);
     switch(whichType)
     {
     case ATOMS_POPUP:
         {
         static const char *items[] = {"Delete Selected atoms or bonds", 
                                       "Change Species", 
                                       "Rename",
                                       "Expand Contacts from this Atom",
                                       "Expand Contacts from this Molecule"}; 
         static GCallback cb_func[] = {G_CALLBACK(on_delete),
                                       G_CALLBACK(on_change_spec),
                                       G_CALLBACK(on_rename),
                                       G_CALLBACK(on_contacts_atom),
                                       G_CALLBACK(on_contacts_mol)};
         int nitems = (int) (sizeof(items)/sizeof(items[0])) - 1;
         for (int i=0; i<nitems; i++)
         {
             std::stringstream nome;
             nome << "Popup " << items[i] ;
             GtkWidget *menu_item = gtk_menu_item_new_with_label(items[i]);
             gtk_menu_shell_append (GTK_MENU_SHELL (menu1), menu_item);
             gtk_widget_show (menu_item);
             g_object_set_data(G_OBJECT(window), nome.str().c_str(), menu_item);
             if(i == 1)
                g_object_set_data(G_OBJECT(menu_item), "callback", 
                      (gpointer)cb_func[i]);
             else
                g_signal_connect(G_OBJECT(menu_item), "activate", 
                       G_CALLBACK(cb_func[i]), (gpointer) window);
         }
         }
         break;
     case BONDS_POPUP:
     case BB_POPUP:
     case CALPHA_POPUP:
     case LIG_POPUP:
         {
         static const char *items[] = {"Delete Selected atoms or bonds", 
                                       "Delete Selected Bonds"};
         static GCallback cb_func[] = {G_CALLBACK(on_delete),
                                       G_CALLBACK(on_delete_bonds)};
         int nitems = (int) (sizeof(items)/sizeof(items[0]));
         for (int i=0; i<nitems; i++)
         {
             std::stringstream nome;
             nome << "Popup " << items[i] ;
             GtkWidget *menu_item = gtk_menu_item_new_with_label(items[i]);
             gtk_menu_shell_append (GTK_MENU_SHELL (menu1), menu_item);
             gtk_widget_show (menu_item);
             g_object_set_data(G_OBJECT(window), nome.str().c_str(), menu_item);
             g_signal_connect(G_OBJECT(menu_item), "activate", 
                       G_CALLBACK(cb_func[i]), (gpointer) window);
         }
         }
         break;
     case RESID_POPUP:
#ifdef JAV
         {
         static const char *items[] = {"Delete selected residue", 
                                       "Delete Side Chain", 
                                       "Delete Aromatic Ring"};
         static GCallback cb_func[] = {G_CALLBACK(on_delete_residue),
                                       G_CALLBACK(on_delete_sidechain),
                                       G_CALLBACK(on_delete_aromatic)};

         int nitems = (int) (sizeof(items)/sizeof(items[0]));
         for (int i=0; i<nitems; i++)
         {
             std::stringstream nome;
             nome << "Popup " << items[i] ;
             GtkWidget *menu_item = gtk_menu_item_new_with_label(items[i]);
             gtk_menu_shell_append (GTK_MENU_SHELL (menu1), menu_item);
             gtk_widget_show (menu_item);
             g_object_set_data(G_OBJECT(window), nome.str().c_str(), menu_item);
             g_signal_connect(G_OBJECT(menu_item), "activate", 
                       G_CALLBACK(cb_func[i]), (gpointer) window);
         }
         }
#endif
         break;
     }
}

void doPopup(int whichType, int whichObject)
{
   if(!GLWINDOW)
      return;
     std::stringstream nome;
     nome << "Popup " << whichType;
     GtkWidget *menu1 = get_widget(GLWINDOW, nome.str().c_str());
     if(!menu1)
        return;
     g_object_set_data(G_OBJECT(menu1), "whichObject", GINT_TO_POINTER(whichObject));
     if(GTK_IS_MENU(menu1))
        gtk_menu_popup (GTK_MENU (menu1),
            NULL, NULL, NULL, NULL, 3, gtk_get_current_event_time ());
}

bool IsModifyEnabled()
{
     gpointer item = get_object(GLWINDOW, "Properties");
     return (obj_get_sensitive(item) != 0);
}

int selectForPopup(int x, int y, gpointer data)
{
     if(!GLWINDOW)
        return 0;
     int result, whichModel, whichObject, whichType, *p;

     p = pickObjects(x, y, data);
     result = p[0];
     whichType  = p[1];
     whichModel = p[2];
     whichObject  = p[3];
     if(result)
     {
        switch (whichType)
        {
        case 0:             // Atoms
           if(!ModelInfo[whichModel].atm[whichObject].selected)
              return 0;
           break;
        case 1:            // Bonds
           if(!ModelInfo[whichModel].bonds[whichObject].selected)
              return 0;
           break;
        case 2:           // Bonds in c_alpha chain
        case 3:           // Bonds in backbone
        case 4:           // Bonds in ligands
           break;
        case 5:           // Residues
           if(!ModelInfo[whichModel].c_alphab[whichObject].selected)
              return 0;
           break;
        }
        if(IsModifyEnabled())
           doPopup(whichType, whichObject*10 + whichModel);
        g_object_set_data(G_OBJECT(GLWINDOW),
           "whichObject", GINT_TO_POINTER(whichObject));
     }

     return result;
}

int selectObject(int x, int y, gpointer data, bool sel_flag, bool only_atoms)
{
     GLWindow *gl = (GLWindow *)data;
     int result, whichModel, whichObject, whichType, *p;

     p = pickObjects(x, y, data, only_atoms);
     result = p[0];
     whichType  = p[1];
     whichModel = p[2];
     whichObject  = p[3];
     if(result)
     {
//      if(!sel_flag)
//         return result;
        const char *str;
        switch (whichType)
        {
        case 0:             // Atoms
           {
           if(sel_flag)
           {
              if(motion_type != SELECT_DEST)
                 ModelInfo[whichModel].UpdateSelectedAtom(whichObject);
              else
                 ModelInfo[whichModel].UpdateSelectedAtom(whichObject, true);
           }
           jav_atom_type *atomo = &(ModelInfo[whichModel].atm[whichObject]);
           std::string str1 =
                 g_strdup_printf("%s #%d ", 
                 g_strstrip(g_strdup(atomo->lab)), whichObject+1);
           if(atomo->numleg > 0)
                 str1.append("Dist: ");
           for(int kat=0; kat<atomo->numleg; kat++)
           {
               int j2 = atomo->leg[kat];
               jav_atom_type *atomo2 = &(ModelInfo[whichModel].atm[j2]);
               if(kat)
                  str1.append(", ");
               str1.append(g_strdup_printf("%s: %.3f", 
                 g_strstrip(g_strdup(atomo2->lab)),
                 atomo->dist[kat]));
           }
           str = g_strdup(str1.c_str());
//         str = g_strdup_printf("%s #%d (%.3f,%.3f,%.3f, %.3f, %.3f, %.3f) ",
//                        atomo->lab, whichObject+1,
//                        atomo->xyzc[0], atomo->xyzc[1], atomo->xyzc[2],
//                        atomo->och, atomo->H, atomo->B );
           }
           break;
        case 1:            // Bonds
        case 2:           // Bonds in c_alpha chain
        case 3:           // Bonds in backbone
        case 4:           // Bonds in ligands
           {
           if(sel_flag)
              ModelInfo[whichModel].UpdateSelectedBond(whichObject,whichType);
           jav_bond_type *bond;
           if(whichType == 1)
               bond = &(ModelInfo[whichModel].bonds[whichObject]);
           else if(whichType == 2)
               bond = &(ModelInfo[whichModel].bonds_ca[whichObject]);
           else if(whichType == 3)
               bond = &(ModelInfo[whichModel].bonds_bb[whichObject]);
           else 
               bond = &(ModelInfo[whichModel].bonds_lig[whichObject]);
           char *at1 = ModelInfo[whichModel].atm[bond->n1-1].lab;
           char *at2 = ModelInfo[whichModel].atm[bond->n2-1].lab;
           str = g_strdup_printf("%s-%s d=%.3f #%d",
                          g_strchomp(at1), g_strchomp(at2),
                          bond->dist, whichObject+1);
           }
           break;
        case 5:           // Residues
           if(sel_flag)
              ModelInfo[whichModel].UpdateSelectedResidue(whichObject);
           str = g_strdup_printf("%s", ModelInfo[whichModel].c_alphab[whichObject].ResLab.c_str());
           break;
        }
        gl->PrintMess(str);
        update_items_modify(IsModifyEnabled());
     }
     else
        gl->PrintMess(" ");
     return result;
}

void selectObjects(int x, int y, gpointer data, double wp, double hp)
{
     GLWindow *gl = (GLWindow *)data;
     int result, whichType, whichModel, whichObject, *p;

     if(wp < 1)
        wp = 1;
     if(hp < 1)
        hp = 1;
     p = pickObjects(x, y, data, false, wp, hp, true);
     result = p[0];
     if(result)
     {
        int sz = result;
        for(int i=0; i<sz; i++)
        {
            whichType    = p[3*i+1];
            whichModel   = p[3*i+2];
            whichObject  = p[3*i+3];
            switch(whichType)
            {
            case 0:
                 ModelInfo[whichModel].UpdateSelectedAtom(whichObject);
                 break;
            case 1:
            case 2:
            case 3:
            case 4:
                 ModelInfo[whichModel].UpdateSelectedBond(whichObject,
                           whichType);
                 break;
            case 5:
                 ModelInfo[whichModel].UpdateSelectedResidue(whichObject);
/*
                 int nr = ModelInfo[whichModel].c_alpha[whichObject].residue;
                 int ch = ModelInfo[whichModel].c_alpha[whichObject].chain;
                 std::vector<int> atoms = ModelInfo[whichModel].Chains[ch].Residues[nr].atoms;
                 for(int i=0; i<(int) atoms.size(); i++)
                 {
                     int n = atoms.at(i);
                     ModelInfo[whichModel].UpdateSelectedAtom(n);
                 }
*/
                 break;
            }
        }
        update_items_modify(IsModifyEnabled());
     }
     gl->Redraw();
}

void on_select(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");

//   set_motion_type(NO_MOVE, 0);
   for(int i=0; i<gl->nModels; i++)
   {
       ModelInfo[i].atoms_sel.clear();
       ModelInfo[i].bonds_sel.clear();
       ModelInfo[i].resid_sel.clear();
       for(int j=0; j<ModelInfo[i].nats; j++)
       {
           ModelInfo[i].atm[j].selected = true;
           ModelInfo[i].atoms_sel.push_back(j+1);
       }
       for(int j=0; j<ModelInfo[i].nconn_prot; j++)
       {
           ModelInfo[i].bonds[j].selected = true;
           ModelInfo[i].bonds_sel.push_back(j+1);
       }
       if(ModelInfo[i].IsProtein())
       {
          for(int j=0; j<(int)ModelInfo[i].c_alphab.size(); j++)
          {
              ModelInfo[i].c_alphab[j].selected = true;
              ModelInfo[i].resid_sel.push_back(j+1);
          }
       }
   }
   gl->Redraw();
   update_items_modify(IsModifyEnabled());
   gl->PrintMess(" ");
}

void on_unselect(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");

//   set_motion_type(NO_MOVE, 0);
   for(int i=0; i<gl->nModels; i++)
   {
       for(int j=0; j<ModelInfo[i].nats; j++)
           ModelInfo[i].atm[j].selected = false;
       for(int j=0; j<ModelInfo[i].nconn_prot; j++)
           ModelInfo[i].bonds[j].selected = false;
       ModelInfo[i].atoms_sel.clear();
       ModelInfo[i].bonds_sel.clear();
       ModelInfo[i].resid_sel.clear();
       if(ModelInfo[i].IsProtein())
       {
          for(int j=0; j<(int)ModelInfo[i].c_alphab.size(); j++)
              ModelInfo[i].c_alphab[j].selected = false;
       }
   }
   gl->Redraw();
   update_items_modify(true);
   gl->PrintMess(" ");
}

void on_invselect(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   for(int whichModel=0; whichModel< gl->nModels; whichModel++)
   {
   ModelInfo[whichModel].atoms_sel.clear();
   ModelInfo[whichModel].bonds_sel.clear();
   for(int j=0; j<ModelInfo[whichModel].nats; j++)
   {
       bool stato = ModelInfo[whichModel].atm[j].selected;
       ModelInfo[whichModel].atm[j].selected = !stato;
       if(!stato)
          ModelInfo[whichModel].atoms_sel.push_back(j+1);
   }
   for(int j=0; j<ModelInfo[whichModel].nconn_prot; j++)
   {
       bool stato = ModelInfo[whichModel].bonds[j].selected;
       ModelInfo[whichModel].bonds[j].selected = !stato;
       if(!stato)
          ModelInfo[whichModel].bonds_sel.push_back(j+1);
   }
   if(ModelInfo[whichModel].IsProtein())
   {
      for(int j=0; j<(int)ModelInfo[whichModel].c_alphab.size(); j++)
      {
          bool stato = ModelInfo[whichModel].c_alphab[j].selected;
          ModelInfo[whichModel].c_alphab[j].selected = !stato;
          if(!stato)
             ModelInfo[whichModel].resid_sel.push_back(j+1);
      }
   }
   }
   update_items_modify(true);
   gl->Redraw();
}

bool SelezionaSpecie(int whichSpec)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   bool found = false;
   if(!GLWINDOW)
      return found;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return found;
   if(!ModelInfo[whichModel].created)
        return found;
    for(int j=0; j<ModelInfo[whichModel].nats; j++)
    {
        ModelInfo[whichModel].atm[j].selected = false;
        int spec = ModelInfo[whichModel].atm[j].Z;
        if(spec == whichSpec)
        {
           found = true;
           break;
        }
    }
    ModelInfo[whichModel].atoms_sel.clear();
    if(found)
    {
       for(int j=0; j<ModelInfo[whichModel].nats; j++)
       {
           int spec = ModelInfo[whichModel].atm[j].Z;
           if(spec == whichSpec)
           {
              ModelInfo[whichModel].atm[j].selected = true;
              ModelInfo[whichModel].atoms_sel.push_back(j+1);
           }
       }
    }
    update_items_modify(true);
    gl->Redraw();
    return found;
}

void on_select_by_spec(gpointer, gpointer data)
{
   int whichSpec = GPOINTER_TO_INT(data);
   SelezionaSpecie(whichSpec);
}

void SelezionaAtomi(int whichModel, GList *atoms_to_sel)
{
    if(GLWINDOW == NULL)
       return;
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    for(int j=0; j<ModelInfo[whichModel].nats; j++)
        ModelInfo[whichModel].atm[j].selected = false;
    ModelInfo[whichModel].atoms_sel.clear();
    for(int j=0; j<(int) g_list_length(atoms_to_sel); j++)
    {
        int jat = GPOINTER_TO_INT(g_list_nth_data(atoms_to_sel, j));
        ModelInfo[whichModel].atm[jat].selected = true;
        ModelInfo[whichModel].atoms_sel.push_back(jat+1);
    }
    gl->Redraw();
}

void on_delete_by_spec(gpointer item, gpointer data)
{
   int whichSpec = GPOINTER_TO_INT(data);
   if(SelezionaSpecie(whichSpec))
      on_delete(item, data);
}

void endselect()
{
     if(!GLWINDOW)
        return;
   gpointer button = get_object(GLWINDOW, "ManipulationOn");
   obj_set_active(button, TRUE);
}

void endModify(int whichModel, bool exitSelect)
{
     if(!GLWINDOW)
        return;
//    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    if(exitSelect)
       endselect();
    if(!ModelInfo[whichModel].created)
       return;
    ModelInfo[whichModel].atoms_sel.clear();
    for(int i=0; i<ModelInfo[whichModel].nats; i++)
        ModelInfo[whichModel].atm[i].selected = false;
    ModelInfo[whichModel].bonds_sel.clear();
    for(int i=0; i<ModelInfo[whichModel].nconn_prot; i++)
        ModelInfo[whichModel].bonds[i].selected = false;
    if(ModelInfo[whichModel].IsProtein())
    {
       ModelInfo[whichModel].resid_sel.clear();
       for(int i=0; i<(int)ModelInfo[whichModel].c_alphab.size(); i++)
           ModelInfo[whichModel].c_alphab[i].selected = false;
    }
//    gl->Redraw();
    update_items_modify(true);
}

RESIDUE GetResiduo(int whichModel, int whichChain, int whichResidue)
{
     return (ModelInfo[whichModel].Chains[whichChain].Residues[whichResidue]);
}

void FillLabelBij(GtkWidget *dlg, float Bij[])
{
    GtkLabel *label = GTK_LABEL(get_widget(dlg, "bij"));
    gtk_label_set_text (label, " ");
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    if(!Bij)
       return;
    GtkWidget *combo = get_widget(dlg, "iso_combo");
    int val = combo_get_val(combo);

    if(Bij[0])
    {
       std::string sm = "<b>";
       std::string em = "</b>";
       std::stringstream bijval;
       if(val == 1)
       {
          std::string beta (sm + special_car_greek('b'));
          bijval << beta << "11 "+em << fToStr2(Bij[0], 5) << "; " <<
                    beta << "22 "+em << fToStr2(Bij[1], 5) << "; " <<
                    beta << "33 "+em << fToStr2(Bij[2], 5) << "; " <<
                    beta << "12 "+em << fToStr2(Bij[3], 5) << "; " <<
                    beta << "13 "+em << fToStr2(Bij[4], 5) << "; " <<
                    beta << "23 "+em << fToStr2(Bij[5], 5);
       }
       else
       {
          float c = (float) (2*M_PI*M_PI);
          float Uij[6] = {Bij[0] / (c * (float) gl->MMRec.m[0]),
                          Bij[1] / (c * (float) gl->MMRec.m[4]),
                          Bij[2] / (c * (float) gl->MMRec.m[8]),
                          Bij[3] / (c * gl->CellR[0] * gl->CellR[1]),
                          Bij[4] / (c * gl->CellR[0] * gl->CellR[2]),
                          Bij[5] / (c * gl->CellR[1] * gl->CellR[2])};
          bijval << sm+"U11 "+em << fToStr2(Uij[0], 5) << "; " <<
                    sm+"U22 "+em << fToStr2(Uij[1], 5) << "; " <<
                    sm+"U33 "+em << fToStr2(Uij[2], 5) << "; " <<
                    sm+"U12 "+em << fToStr2(Uij[3], 5) << "; " <<
                    sm+"U13 "+em << fToStr2(Uij[4], 5) << "; " <<
                    sm+"U23 "+em << fToStr2(Uij[5], 5);
       }
       gtk_label_set_markup (label, bijval.str().c_str());
    }
}

static void selected_atom(GtkTreeSelection  *sele, gpointer data)
{
//#ifdef JAV
//     return;
//#endif
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     GtkTreeView *tree_view;
     int row;
     GtkWidget *dlg = (GtkWidget *)data;
     int whichModel = get_int(dlg, "whichModel") - 1;

     for(int i=0; i<ModelInfo[whichModel].nats; i++)
         ModelInfo[whichModel].atm[i].selected = false;
     ModelInfo[whichModel].atoms_sel.clear();

     tree_view = gtk_tree_selection_get_tree_view(sele);
     if(ModelInfo[whichModel].isPDB)
     {
        row = row_selected(sele);
        if(row != -1)
        {
           int whichChain = get_int(dlg, "whichChain");
           int whichResidue = get_int(dlg, "whichResidue");
           RESIDUE rr = GetResiduo(whichModel, whichChain, whichResidue);
           int katom = rr.atoms[row];
           g_object_set_data(G_OBJECT(dlg), "whichAtom", GINT_TO_POINTER(row));
           ModelInfo[whichModel].atm[katom].selected = true;
           ModelInfo[whichModel].atoms_sel.push_back(katom+1);
        }
     }
     else
     {
        GList *rowsel = NULL;
        rowsel = get_selections(GTK_WIDGET(tree_view));
        FillLabelBij(dlg, NULL);
        if(rowsel)
        {
           int num_sel = g_list_length(rowsel);
           for(int i=0; i<num_sel; i++)
           {
                GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
                gpointer riga =
                    get_selection_from_pathC(tree_view, path, 0);
                row = GPOINTER_TO_INT(riga) - 1;
                ModelInfo[whichModel].atm[row].selected = true;
                ModelInfo[whichModel].atoms_sel.push_back(row+1);
                if(num_sel == 1)
                {
                   if(ModelInfo[whichModel].atm[row].Bij[0])
                   {
                      FillLabelBij(dlg, ModelInfo[whichModel].atm[row].Bij);
                   }
                }
           }
           g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
           g_list_free (rowsel);
           g_object_set_data(G_OBJECT(dlg), "whichAtom", GINT_TO_POINTER(0));
        }
     }
     gl->Redraw();
     update_items_modify(true, false);
}

static void selected_bond(GtkTreeSelection  *sele, gpointer data)
{
//#ifdef JAV
//     return;
//#endif
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     GtkTreeView *tree_view;
     int row;
     GtkWidget *dlg = (GtkWidget *)data;
     int whichModel = get_int(dlg, "whichModel") - 1;

     for(int i=0; i<ModelInfo[whichModel].nconn_prot; i++)
         ModelInfo[whichModel].bonds[i].selected = false;
     ModelInfo[whichModel].bonds_sel.clear();
     tree_view = gtk_tree_selection_get_tree_view(sele);
     GList *rowsel = NULL;
     rowsel = get_selections(GTK_WIDGET(tree_view));
     if(rowsel)
     {
        int num_sel = g_list_length(rowsel);
        for(int i=0; i<num_sel; i++)
        {
             GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
             gpointer riga =
                 get_selection_from_pathC(tree_view, path, 0);
             row = GPOINTER_TO_INT(riga) - 1;
             ModelInfo[whichModel].bonds[row].selected = true;
             ModelInfo[whichModel].bonds_sel.push_back(row+1);
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
     }
     gl->Redraw();
     update_items_modify(true, false);
}

void SelezionaLegame(int whichModel, int n1, int n2)
{
     if(ModelInfo[whichModel].Equivs[n1].empty())
        return;
     if(ModelInfo[whichModel].Equivs[n2].empty())
        return;
     int n1eq = (int) ModelInfo[whichModel].Equivs[n1].size();
     int n2eq = (int) ModelInfo[whichModel].Equivs[n2].size();
     int neq  = MRmin(n1eq, n2eq);
     for(int keq=0; keq<neq; keq++)
     {
         int ieq1 = ModelInfo[whichModel].Equivs[n1].at(keq);
         int ieq2 = ModelInfo[whichModel].Equivs[n2].at(keq);
         int bb1 = ModelInfo[whichModel].FindConn(ieq1, ieq2);
         if(bb1 != -1)
         {
             ModelInfo[whichModel].atm[ieq1].selected = true;
             ModelInfo[whichModel].atm[ieq2].selected = true;
             ModelInfo[whichModel].atoms_sel.push_back(ieq1+1);
             ModelInfo[whichModel].atoms_sel.push_back(ieq2+1);
             ModelInfo[whichModel].bonds[bb1].selected = true;
             ModelInfo[whichModel].bonds_sel.push_back(bb1+1);
         }
     }
}

void SelezionaAngolo(int whichModel, int n1, int n2, int n3)
{
     if(ModelInfo[whichModel].Equivs[n1].empty())
        return;
     if(ModelInfo[whichModel].Equivs[n2].empty())
        return;
     if(ModelInfo[whichModel].Equivs[n3].empty())
        return;
     int n1eq = (int) ModelInfo[whichModel].Equivs[n1].size();
     int n2eq = (int) ModelInfo[whichModel].Equivs[n2].size();
     int n3eq = (int) ModelInfo[whichModel].Equivs[n3].size();
     int neq  = MRmin(MRmin(n1eq, n2eq), n3eq);
     for(int keq=0; keq<neq; keq++)
     {
         int ieq1 = ModelInfo[whichModel].Equivs[n1].at(keq);
         int ieq2 = ModelInfo[whichModel].Equivs[n2].at(keq);
         int ieq3 = ModelInfo[whichModel].Equivs[n3].at(keq);
         int bb1 = ModelInfo[whichModel].FindConn(ieq1, ieq2);
         int bb2 = ModelInfo[whichModel].FindConn(ieq2, ieq3);
         if((bb1 != -1) && (bb2 !=-1))
         {
             ModelInfo[whichModel].atm[ieq1].selected = true;
             ModelInfo[whichModel].atm[ieq2].selected = true;
             ModelInfo[whichModel].atm[ieq3].selected = true;
             ModelInfo[whichModel].atoms_sel.push_back(ieq1+1);
             ModelInfo[whichModel].atoms_sel.push_back(ieq2+1);
             ModelInfo[whichModel].atoms_sel.push_back(ieq3+1);
             ModelInfo[whichModel].bonds[bb1].selected = true;
             ModelInfo[whichModel].bonds_sel.push_back(bb1+1);
             ModelInfo[whichModel].bonds[bb2].selected = true;
             ModelInfo[whichModel].bonds_sel.push_back(bb2+1);
         }
     }
}

static void seleziona_angolo(int whichModel, int row)
{
     int n1 = ModelInfo[whichModel].anglebonds[row].n1 - 1;
     int n2 = ModelInfo[whichModel].anglebonds[row].n2 - 1;
     int n3 = ModelInfo[whichModel].anglebonds[row].n3 - 1;

     SelezionaAngolo (whichModel, n1, n2, n3);
}

static void selected_anglebond(GtkTreeSelection  *sele, gpointer data)
{
//#ifdef JAV
//     return;
//#endif
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     GtkTreeView *tree_view;
     int row;
     GtkWidget *dlg = (GtkWidget *)data;
     int whichModel = get_int(dlg, "whichModel") - 1;

     for(int i=0; i<ModelInfo[whichModel].nats; i++)
         ModelInfo[whichModel].atm[i].selected = false;
     for(int i=0; i<ModelInfo[whichModel].nconn_prot; i++)
         ModelInfo[whichModel].bonds[i].selected = false;
     ModelInfo[whichModel].atoms_sel.clear();
     ModelInfo[whichModel].bonds_sel.clear();
     tree_view = gtk_tree_selection_get_tree_view(sele);
     GList *rowsel = NULL;
     rowsel = get_selections(GTK_WIDGET(tree_view));
     if(rowsel)
     {
        int num_sel = g_list_length(rowsel);
        for(int i=0; i<num_sel; i++)
        {
             GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
             gpointer riga =
                 get_selection_from_pathC(tree_view, path, 0);
             row = GPOINTER_TO_INT(riga) - 1;
             g_object_set_data(G_OBJECT(dlg), "whichAngle", GINT_TO_POINTER(row));
             seleziona_angolo(whichModel, row);
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
     }
     gl->Redraw();
     update_items_modify(true, false);
}

static void selected_contact(GtkTreeSelection  *sele, gpointer data)
{
     //return;
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     GtkTreeView *tree_view;
     int row;
     PixNum *numb;
     GtkWidget *dlg = (GtkWidget *)data;
     int whichModel = get_int(dlg, "whichModel") - 1;
     for(int i=0; i<ModelInfo[whichModel].nlegsH; i++)
         ModelInfo[whichModel].legsH[i].selected = false;
     for(int i=0; i<ModelInfo[whichModel].nlegsW; i++)
         ModelInfo[whichModel].legsW[i].selected = false;
     tree_view = gtk_tree_selection_get_tree_view(sele);
     GList *rowsel = NULL;
     rowsel = get_selections(GTK_WIDGET(tree_view));
     if(rowsel)
     {
        int num_sel = g_list_length(rowsel);
        for(int i=0; i<num_sel; i++)
        {
             GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
             gpointer riga =
                 get_selection_from_pathC(tree_view, path, 0);
             numb = (PixNum *) riga;
             row = numb->num - 1;
             int nlegsH = ModelInfo[whichModel].nlegsH;
             if(row < nlegsH)
                ModelInfo[whichModel].legsH[row].selected = true;
             else
                ModelInfo[whichModel].legsW[row-nlegsH].selected = true;
             //ModelInfo[whichModel].bonds_sel.push_back(row+1);
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
     }
     gl->Redraw();
     update_items_modify(true, false);
}

void UpdateInfoAtoms()
{
   if(GLWINDOW == NULL)
      return;
   if(g_object_get_data(G_OBJECT(GLWINDOW), InfoAtomsW))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, InfoAtomsW);
      int whichModel = get_int(dlg, "whichModel") - 1;
      if(whichModel < 0)
         return;
#ifndef JAV
      ModelInfo[whichModel].RF = getRFvalue();
#else
      ModelInfo[whichModel].RF = 0;
#endif
      int wm = whichModel + 1;
      getangle_(&wm);
      gettorsion_(&wm);
      ModelInfo[whichModel].FillStructureInfo(dlg);
      ModelInfo[whichModel].FillListAtoms(dlg);
      ModelInfo[whichModel].FillListConn(dlg);
      ModelInfo[whichModel].FillListAng(dlg);
      ModelInfo[whichModel].FillListTors(dlg);
      ModelInfo[whichModel].FillBarChart(dlg);
      ModelInfo[whichModel].FillListContacts(dlg);
      ModelInfo[whichModel].UpdateInfoSelections();
   }
}

#if 0
void get_row_from_val(GtkWidget *list, std::vector<int> &iord)
{
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GType tipo = gtk_tree_model_get_column_type(model, 0);
    GtkTreeIter iter;
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    int i = 0;
    while (valid)
    {
       if(tipo == G_TYPE_INT)
       {
          int val;
          gtk_tree_model_get(model, &iter, 0, &val, -1);
          iord.at(val-1) = i;
       }
       else if(tipo == PIX_NUM_TYPE)
       {
          PixNum *numb = g_new0(PixNum, 1);
          int val;
          gtk_tree_model_get(model, &iter, 0,  &numb, -1);
          val = numb->num;
          iord.at(val-1) = i;
       }
       i++;
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}   
#endif

char *getStringSymm(int *koper, int nops=0)
{
   if((nops == 0) && (GLWINDOW != NULL))
   {
      GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
      nops = gl->sy.nsymop;
   }
   size_t sz = 31;
   char *stringa = g_new0(char, sz);
   if((*koper > 0) && (*koper <= nops))
      get_stringsymmf_(koper, stringa, sz);   
   else
      CopiaStringa(stringa, 31, "Error");
   return (stringa);
}

void Model::UpdateInfoSelections()
{
     if(!GLWINDOW)
        return;
     if(isPDB)
        return;
   if(g_object_get_data(G_OBJECT(GLWINDOW), InfoAtomsW))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, InfoAtomsW);
      GtkWidget *list = get_widget(dlg, "atoms");
      std::vector<int> iord (nats, 0);
      get_row_from_val(list, 0, iord);
      unselect_all(GTK_TREE_VIEW(list), true);
      int nsel = (int) atoms_sel.size();
      for(int i=0; i<nsel; i++)
      {
         int kk = (int) atoms_sel[i] - 1;
         select_row(list, iord.at(kk), true);
      }
      list = get_widget(dlg, "conn");
      iord.resize(nconn_prot);
      get_row_from_val(list, 0, iord);
      unselect_all(GTK_TREE_VIEW(list), true);
      nsel = (int) bonds_sel.size();
      for(int i=0; i<nsel; i++)
      {
         int kk = (int) bonds_sel[i] - 1;
         if(kk < nconn_prot)
            select_row(list, iord.at(kk), true);
      }
   }
}

float U_or_B(float B, GtkWidget *dlg)
{
   GtkWidget *combo = get_widget(dlg, "iso_combo");
   if(!combo)
      return B;
   int whichIso = combo_get_val(combo);
   if(whichIso == 1)
      return B;
   else
      return (float) (B/(8*M_PI*M_PI));
}

void Model::FillListAtoms(GtkWidget *dlg, bool is_edit)
{
       int natoms = nats;
       if(is_edit)
          natoms = nats_au;
       else
       {
          if(isPDB)
          {
             gtk_widget_hide(get_widget(dlg, "frame_noPDB"));
             gtk_widget_show(get_widget(dlg, "frame_PDB"));
             FillLists(dlg);
             return;
          }
          gtk_widget_show(get_widget(dlg, "frame_noPDB"));
          gtk_widget_hide(get_widget(dlg, "frame_PDB"));
       }
       GtkTreeView *list = GTK_TREE_VIEW(get_widget(dlg, "atoms"));
       GtkTreeSelection *selection = gtk_tree_view_get_selection(list);
       GtkTreeIter iter;
       GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
       int hnd = get_int(GTK_WIDGET(list), "hnd");
       g_signal_handler_block(G_OBJECT(selection), hnd);
       gtk_list_store_clear(GTK_LIST_STORE(list_store));
       int alt = get_int(dlg, "alt");
       gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"),
                    -1, (int) MRmin(1.7f*(natoms+1)*alt, 20*alt));
       for(int i=0; i<natoms; i++)
       {
           int ieq = i;
           if(is_edit)
              ieq = Equivs[i].at(0);
           char *label1 = g_strdup(atm[ieq].lab);
           char *label2;
           if(atm[ieq].color >= 0)
           //if(atm[ieq].ptab > 0)
           {
              label2 = g_new0(char, LEN_SPEC+1);
              CopiaStringan( label2, LEN_SPEC+1, LabSpec[atm[ieq].color], LEN_SPEC);
              //CopiaStringan( label2, 5, get_nth_element(atm[ieq].ptab-1), 4 );
           }
           else
              label2 = g_strdup("Q");
           gtk_list_store_append (list_store, &iter);
           int ko = atm[ieq].op.op;
           char *label3 = g_strdup(getStringSymm(&ko));
           float occ = atm[ieq].och;
           if(!is_edit)
              occ *= atm[ieq].ocry;
           int z = atm[ieq].Z;
           float ub = U_or_B(atm[ieq].B, dlg);
           gtk_list_store_set (list_store, &iter, 
              0, i+1, 1, g_strstrip(label1), 2, label2, 3, atm[ieq].H,
              4, atm[ieq].xyzc[0], 5, atm[ieq].xyzc[1], 6,atm[ieq].xyzc[2], 
              7, ub, 8, occ, 9, g_strstrip(label3), 10, z, -1);
       }
       g_signal_handler_unblock(G_OBJECT(selection), hnd);
}

#if 0
void SaveSelection(GtkWidget *list, std::vector<int> &sel_vet)
{
    GList *rowsel = get_selections(list);
    GtkTreeIter iter;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GType tipo = gtk_tree_model_get_column_type(model, 0);
    int nsel = (int) g_list_length(rowsel);
    for(int i=0; i<nsel; i++)
    {
      int val;
      GtkTreePath *path =  static_cast<GtkTreePath *> (g_list_nth_data (rowsel, i));
      gtk_tree_model_get_iter (model, &iter, path);
      if(tipo == G_TYPE_INT)
         gtk_tree_model_get(model, &iter, 0, &val, -1);
      else if(tipo == PIX_NUM_TYPE)
      {
          PixNum *numb = g_new0(PixNum, 1);
          gtk_tree_model_get(model, &iter, 0,  &numb, -1);
          val = numb->num;
      }
      else
          continue;
      sel_vet.push_back(val-1);
    }
    g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
}   

void RedoSelection(GtkWidget *list, int num, std::vector<int> &sel_vet)
{
    std::vector<int> iord(num, 0);
    get_row_from_val(list, iord);
    int nsel = (int) sel_vet.size();
    unselect_all(GTK_TREE_VIEW(list), true);
    for(int i=0; i<nsel; i++)
    {
        int kk = iord.at(sel_vet.at(i));
        select_row(list, kk, true);
    }
}
#endif

void Model::FillListConn(GtkWidget *dlg, bool if_edit)
{
       GtkTreeView *list = GTK_TREE_VIEW(get_widget(dlg, "conn"));
       GtkTreeSelection *selection = gtk_tree_view_get_selection(list);
       GtkTreeIter iter;
       GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
       int hnd = get_int(GTK_WIDGET(list), "hnd");
       if(hnd)
          g_signal_handler_block(G_OBJECT(selection), hnd);
       gtk_list_store_clear(GTK_LIST_STORE(list_store));
       int alt = get_int(dlg, "alt");
       int nconn_eff = 0;
       for(int i=0; i<nconn_prot; i++)
       {
           int n1 = bonds[i].n1 - 1;
           int n2 = bonds[i].n2 - 1;
//291113           if( (n1 >= nats_au) || (n2 >= nats_au))
//291113               continue;
           float dist = bonds[i].dist;
           char *label1 = g_strdup(atm[n1].lab);
           char *label2 = g_strdup(atm[n2].lab);
           gtk_list_store_append (list_store, &iter);
           //std::string labtype = GetBondType(n1, n2);
           std::string labtype = GetType(2, 0, n1, n2);
           if(if_edit)
           {

              gtk_list_store_set (list_store, &iter, 0, i+1, 1, labtype.c_str(),
                 2, g_strstrip(label1),
                 3, g_strstrip(label2), 4, dist, -1);
           }
           else
           {
              int ko = atm[n1].op.op;
              char *label3 = g_strdup(getStringSymm(&ko));
              ko = atm[n2].op.op;
              char *label4 = g_strdup(getStringSymm(&ko));

              gtk_list_store_set (list_store, &iter, 0, i+1, 
                 1, labtype.c_str(), 2, g_strstrip(label1),
                 3, g_strstrip(label2), 4, dist, 5, g_strstrip(label3),
                 6, g_strstrip(label4), -1);
           }
           nconn_eff++;
       }
       gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"),
          -1, (int) MRmin(1.7f*(nconn_eff+1)*alt, 20*alt));
       if(hnd)
          g_signal_handler_unblock(G_OBJECT(selection), hnd);
}

static void barra(GtkWidget *widget, gpointer outPix, gpointer context,
           int x1, int y1, int w, int h, float col[], const char *string)
{
     GdkRectangle rect;
     gpointer region;

     rect.x      = x1;
     rect.y      = y1;
     rect.width  = w;
     rect.height = h;

     draw_rectangle2(outPix, context, TRUE, x1, y1, w, h, col);
     region = region_rectangle(&rect);
     int nreg = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(widget), "nreg"));
     nreg++;
     g_object_set_data(G_OBJECT(widget), "nreg", GINT_TO_POINTER(nreg));
     char nome[20];
     _InfoReg *InfoRegs = g_new0(_InfoReg , 1);
     ScriviStringa(nome, sizeof(nome), "reg%d", nreg - 1);
     InfoRegs->reg = region;
     int sz = (int) strlen(string) + 1;
     InfoRegs->lab = g_new0(char, sz);
     CopiaStringa(InfoRegs->lab, sz, string);
     g_object_set_data(G_OBJECT(widget), nome, InfoRegs);
}

static void AddInfoChain(std::stringstream &os, CHAIN ch)
{
   int nother=0, namino=0, nnucle=0;
   for(int rr=0; rr<ch.nResidues; rr++)
   {   
       int which = ch.Residues[rr].code;
       if(which == 0)
          nother++;
       else if(which < N_AMINO)
          namino++;
       else
          nnucle++;
   }
   if(namino)
      os << ch.id << " " << "(" << namino << " residues)";
   else
      os << ch.id ;
}

void Model::FillStructureInfo(GLWindow *gl, std::stringstream &os, bool im)
{
using namespace std;
  std::string sm = "";
  std::string em = "";
  static const char *numbStrings[] =
  {"Number of Coils      ",
   "Number of Helices    ",
   "Number of Sheets     ",
   "Number of Turns      "};
  if(im)
  {
     sm.assign("<span foreground=\"blue\">");
     em.assign("</span>");
  }

  float volume = (float) CellVolume(gl->Cell);
  os << "Name                 " << sm << g_path_get_basename(modname) << em << "\n";
  os << "Cell Lengths         a     " << sm << fToStr2(gl->Cell[0], 3)  << em
     << "  b    " << sm << fToStr2(gl->Cell[1], 3) << em
     << "  c     " << sm << fToStr2(gl->Cell[2], 3) << em << "\n";
  os << "Cell Angles          alpha " << sm << fToStr2(gl->Cell[3], 3) << em
     << "  beta " << sm << fToStr2(gl->Cell[4], 3) << em
     << "  gamma " << sm << fToStr2(gl->Cell[5], 3) << em << "\n";
  if(!str_white(gl->sy.spg))
  {
     os << "Space Group          " << sm << gl->sy.spg;
     if(gl->sy.icent == 1)
        os << " (centrosymmetric) ";
     else
        os << " (non-centrosymmetric) ";
     os << em << "\n";
  }
  else
     os << "Space Group symbol   " << sm << "n.a. " << em << "\n";
  os << "Symmetry operations\n" ;
  for(int i=1; i<=gl->sy.nsymop; i++)
  {
      os << "                   "  << sm << setw(3) << i << ") " 
         << getStringSymm(&i) << em << "\n";
  }
  os << "Cell Volume          " << sm << fToStr2(volume, 3) << em << "\n";
  os << "Cell Content         ";
  for(int i=0; i<numSpec; i++)
  {
      char *label2 = g_new0(char, LEN_SPEC+1);
      CopiaStringan( label2, LEN_SPEC+1, LabSpec[i], LEN_SPEC);
      char c = g_ascii_toupper(label2[0]);
      label2[0] = c;
      os << sm << label2 
         << setw(5) << Content[i] << em << "\n";
      if(i != (numSpec -1))
         os << "                     " ;
      g_free(label2);
  }
  gchar *strvol = g_strdup(fToStr2(VolumePerAtom(volume, gl->sy.nsymop), 3).c_str());
  os << "Volume per atom      " << sm << g_strstrip(strvol) << em << "\n";
  if(MRabs(RF) > 1e-8)
  {
     strvol = g_strdup(fToStr2(RF, 3).c_str());
     os << "R-Factor (All refl.) " << sm << g_strstrip(strvol) << " %" << em << "\n";
  }
  os << "Atoms in model       " << sm << nats << em ;
  if(ifSymmetry)
      os << " (symmetry equivalent included)";
  os << "\n";
  if(nResAmino > 0)
  {
     os << "Number of chains     " << sm << nChains << em << "\n";
     os << "Chains               " << sm;
     for(int kk=0; kk<nChains; kk++)
     {
         if(kk)
            os << ", ";
         AddInfoChain(os, Chains[kk]);
     }
         //os << Chains[kk].id << " ";
     os << em << "\n";
     int kfin = (int)(sizeof(numbStructs)/sizeof(numbStructs[0]));
     for(int ks=0; ks<kfin; ks++)
         if(numbStructs[ks] > 0)
             os << numbStrings[ks] << sm << numbStructs[ks] << em << "\n";
  }
}

void Model::FillStructureInfo(GtkWidget *dlg)
{
using namespace std;
  if(!GLWINDOW)
     return;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  std::stringstream s, os;
  s << PAGE_STRUCTURE;
  GtkWidget *label = get_widget(dlg, s.str().c_str());

  FillStructureInfo(gl, os, true);

  GtkWidget *box = get_widget(dlg , "box_tasti");
  gtk_widget_hide(box);
  if(nResAmino > 0)
     gtk_widget_show(box);
  gtk_label_set_markup(GTK_LABEL(label), toUTF8(os.str().c_str()));
}

void Model::FillBarChart(GtkWidget *dlg)
{
  if(nats <= 0)
     return;
  if(numSpec <= 0)
     return;
  GtkAllocation alloc;
  gtk_widget_get_allocation(dlg, &alloc);
  int LargBar = 15;
  int delta = 20;
  int margx = 10;
  int w, h, width = delta*nats_au + 2*margx + 100;
  int x1, y1, xini = margx, xfin = delta*nats_au + 95;

  int maxwidth = alloc.width;
  if (width > maxwidth)
       w = maxwidth;
  else
       w = width + 50;
  std::vector<float> nno;
  for(int i=0; i<numSpec; i++)
      nno.push_back((float) Species[i]);
  float maxNo = *max_element(nno.begin(), nno.end());
  int maxheight = alloc.height;
  int height = MRmax(400, (int) maxNo * 18);
  if (height > maxheight)
       h = maxheight;
  else
       h = -1;

  xfin = w - margx;

  GtkWidget *scrollwin = get_widget(dlg, "scrollwin");

  gtk_widget_set_size_request(scrollwin, w, h);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrollwin),
      GTK_POLICY_AUTOMATIC, (h>0)?GTK_POLICY_AUTOMATIC:GTK_POLICY_NEVER);
  GtkWidget *viewer = get_widget(dlg, "viewer");
  gtk_widget_set_size_request(viewer, width, height);
  PangoFontDescription *f = (PangoFontDescription *)get_object(viewer, "font");
  gpointer context = get_object(viewer, "context");
  gpointer pixmap  = get_object(viewer, "offscreen");
  if((context == NULL) || (pixmap == NULL))
     return;

  std::vector<float> Inte;
  for(int i=0; i<nats_au; i++)
      Inte.push_back(atm_au[i].H);
  float maxInte = *max_element(Inte.begin(), Inte.end());
       
  GdkColor colore = {0, 32768, 32768, 32768};
  GdkColor colorb = {0, 0, 0, 0};
  GdkColor colorw = {0, 65535, 65535, 65535};

  set_foreground(context, &colorw);
  gtk_widget_get_allocation(viewer, &alloc);
  draw_rectangle(pixmap, context, TRUE, alloc.x, alloc.y, alloc.width,
                 alloc.height);

  set_foreground(context, &colore);
  int h0 = 10, h1 = height - 5;
  //draw_line(pixmap, context, xini, h1, w, h1);
  
  for(int i=0; i<numSpec; i++)
  {
      std::stringstream os;
      os << std::setw(3) << Species[i] << " " << get_nth_element(Species[i]-1) << " ";
      int hpix = (int) (nno[i] / maxNo * (float)(h1 - h0) + 0.5f);
      set_foreground(context, &colore);
      for(int ix=xini; ix<xfin; ix+=6)
          draw_line(pixmap, context, ix, h1 - hpix, ix+2, h1 - hpix);
      float col1[4];
      memcpy(col1, light_diffuse[Species[i]-1], 4*sizeof(float));
      draw_rectangle2(pixmap, context, TRUE, xini, h1-hpix-2, 8, 8, col1);
      draw_string(pixmap, f, context, xini+10, h1-hpix-4, os.str().c_str(),
                  &colorb, &colorw);
  }

  y1 = h1;
  x1 = 100;
  for(int i=0; i<nats_au; i++)
  {
      std::stringstream os;
      float inten =  Inte[i];
      std::string lab = atm_au[i].lab;
      std::remove(lab.begin(), lab.end(), ' ');
      os << strstrip(lab) << " - Height = " << std::setw(10) 
         << std::fixed << std::right << std::setprecision(2) << inten;
      int hpix = (int) ((MRabs(inten/maxInte)) * (float)(h1 - h0) + 0.5f);
      int index1  = atm_au[i].Z-1;
      float col1[4];
      memcpy(col1, light_diffuse[index1], 4*sizeof(float));
      barra(viewer, pixmap, context, x1, y1-hpix, LargBar, hpix, col1, os.str().c_str());
      x1 += delta;
  }

  if(gtk_widget_get_window(viewer))
     draw_drawable(gtk_widget_get_window(viewer), context, pixmap, 0, 0);
  if(h > 0)
     gtk_adjustment_set_value(gtk_scrolled_window_get_vadjustment(
        GTK_SCROLLED_WINDOW(scrollwin)), 1000);
}

void Model::FillListSphere(GtkWidget *dlg, int nrows, int atomi[], 
                           float vdist[], op_type vsym[])
{
    GtkTreeView *list = GTK_TREE_VIEW(get_widget(dlg, "sphere_list"));
    GtkTreeSelection *selection = gtk_tree_view_get_selection(list);
    int alt = get_int(GTK_WIDGET(list), "alt");
    GtkTreeIter iter;
    GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    int hnd = get_int(GTK_WIDGET(list), "hnd");
    g_signal_handler_block(G_OBJECT(selection), hnd);
    gtk_list_store_clear(GTK_LIST_STORE(list_store));
    for(int i=0; i<nats; i++)
        atm[i].drawLabel = 0;
    atm[sphereCentre-1].drawLabel = 1;
    int nr = MRmin(nrows+3, 6);
    gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"),
        -1, nr*alt);
    for(int i=0; i<nrows; i++)
    {
        int ii = atomi[i] - 1;
        atm[ii].drawLabel = 1;
        char *label1 = g_strdup(atm[ii].lab);
        char *label2;

//NEW        
           int opnum = vsym[i].op;
           int tra[3] = {vsym[i].tra[0], vsym[i].tra[1], vsym[i].tra[2]};
           label2 = g_strdup(getStringSymm(&opnum));
           std::string labstr = g_strdup_printf("(%s)",g_strchomp(label2)); 
           if(tra[0] + tra[1] + tra[2])
              labstr.append(g_strdup_printf("+(%d,%d,%d)",tra[0], tra[1], tra[2]));
           label2 = g_strdup(labstr.c_str());

#if 0                       //OLD
           int tra[3] = {atm[ii].op.tra[0], atm[ii].op.tra[1], atm[ii].op.tra[2]};
           label2 = g_strdup(getStringSymm(&atm[ii].op.op));
           std::string labstr = g_strdup_printf("(%s)",g_strchomp(label2)); 
           if(tra[0] + tra[1] + tra[2])
              labstr.append(g_strdup_printf("+(%d,%d,%d)",tra[0], tra[1], tra[2]));
           label2 = g_strdup(labstr.c_str());
        if(vsym[i] == 1555)
           label2 = g_strdup(" ");
        else
        {
           int opnum = vsym[i] / 1000;
           int *tra = transFromCode(vsym[i]);
           label2 = g_strdup(getStringSymm(&opnum));
           std::string labstr = g_strdup_printf("(%s)",g_strchomp(label2)); 
           if(tra[0] + tra[1] + tra[2])
              labstr.append(g_strdup_printf("+(%d,%d,%d)",tra[0], tra[1], tra[2]));
           label2 = g_strdup(labstr.c_str());
        }
#endif

        gtk_list_store_append (list_store, &iter);
        gtk_list_store_set (list_store, &iter,
              0, ii, 1, g_strstrip(label1), 2, vdist[i],
              3, g_strstrip(label2), -1);
    }
    g_signal_handler_unblock(G_OBJECT(selection), hnd);
}

GdkPixbuf *pixbuf_get_from_window(GtkWidget *widget)
{
    GtkAllocation allocation;
    gtk_widget_get_allocation(widget, &allocation);
    if(!gdk_window_is_viewable(gtk_widget_get_window(widget)))
       return NULL;
#if GTK_MAJOR_VERSION < 3
    return (gdk_pixbuf_get_from_drawable (NULL, gtk_widget_get_window(widget),
                       gdk_colormap_get_system(),
                       0, 0, 0, 0, allocation.width,
                       allocation.height));
#else
    return (gdk_pixbuf_get_from_window (gtk_widget_get_window(widget),
                       0, 0, allocation.width, allocation.height));
#endif
}

void SetClip(bool active, bool ifRedraw)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gl->Clip = active;
   gpointer entry = get_object(GLWINDOW, "box_Clip");
   obj_set_sensitive(entry, active);
   entry = get_object(GLWINDOW, "Clip");
   if(active && (entry != NULL))
      gl->ClipFactor = gtk_range_get_value(GTK_RANGE(entry));
   else
      gl->ClipFactor = 1.0;
   gl->change_clip_value();
   if(ifRedraw)
      gl->Redraw();
}

void on_toggle_filter(GtkToggleButton *button, gpointer data)
{
   if(!GLWINDOW)
      return;
   if(!gtk_toggle_button_get_active(button))
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gl->glasses_type = GPOINTER_TO_INT(data);
   gl->Redraw ();
}

void on_change_divisions(GtkWidget *button, gpointer )
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gl->nDivisions = spin_button_get_value_as_int(button);
   gl->Redraw ();
}

void on_change_scale(GtkRange *button, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

   int which = GPOINTER_TO_INT(data);
   if(which == -1)
      gl->sc_bonds = gtk_range_get_value(button);
   else
   {
      gl->scale_atoms[which-1] = (float) gtk_range_get_value(button);
      GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
      GtkWidget *chainb = get_widget(dlg, "chainbutton");
      gboolean joined = mr_chain_button_get_active(MR_CHAIN_BUTTON(chainb));
      if(joined)
      {
         for (int i=0; i<gl->NSpecies; i++)
         {
              std::stringstream scale;
              int  index = gl->ListaSpecies[i]-1;
              if(index == (which-1))
                 continue;
              scale << "scale" << i+1;
              GtkWidget *range = get_widget(dlg, scale.str().c_str());
              int hnd = get_int(range, "hnd");
              g_signal_handler_block(G_OBJECT(range), hnd);
              gtk_range_set_value(GTK_RANGE(range), gl->scale_atoms[which-1]);
              gl->scale_atoms[index] = gl->scale_atoms[which-1];
              g_signal_handler_unblock(G_OBJECT(range), hnd);
          }
      }
      gl->sc_atoms = 1;
      for(int i=0; i<N_ELEMENTS; i++)
          gl->sc_atoms = MRmax(gl->sc_atoms, gl->scale_atoms[i]);
   }
   gl->Redraw();
}

void on_toggle_smooth(GtkToggleButton *button, gpointer )
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gl->smooth = !gtk_toggle_button_get_active(button);
   aggiorna_smooth(gl->smooth);
   gl->Redraw ();
}

#ifdef HAVE_ADVANCED
void on_toggle_softrend(GtkToggleButton *button, gpointer )
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int softrend = gtk_toggle_button_get_active(button);
   aggiorna_rendering(softrend);
//   if(softrend)
   {
      gl->Destroy(-1);
#ifdef JAV
      OpenGLWindow();
      gl->Restore();
#else
      call_javs(NULL, NULL);
#endif
   }
}
#endif

#ifndef GTK_COMBO_BOX
void on_select_linestyle (GtkWidget *widget, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int selection;
   get_comboselection (widget, &selection);

   if(selection != -1)
      gl->GridPattern = selection;
   gl->Redraw ();
}
#else
void on_select_linestyle(GtkWidget *combo, gpointer )
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int selection = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
   gl->GridPattern = selection;
   gl->Redraw ();
}
#endif

#ifdef GTK_FONT_BUTTON
void ChangedFont(GtkFontButton *fb, gpointer )
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
//   if(gl->fontname  != NULL)
//      g_free(gl->fontname);
   gl->fontname = DuplicaStringa(font_button_get_font_name(GTK_WIDGET(fb)));
   gl->Redraw ();
   main_app::JavApp.SetFont('P', gl->fontname);
}
#endif

void on_change_offset(GtkWidget *button, gpointer data)
{
   if(!GLWINDOW)
      return;
   int which = GPOINTER_TO_INT(data);
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   if(which == 1)
      gl->xoffset = (float) spin_button_get_value(button);
   else
      gl->yoffset = (float) spin_button_get_value(button);
   gl->Redraw ();
}

void toggle_light(GtkToggleButton *button, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int which = GPOINTER_TO_INT(data);
   int active = gtk_toggle_button_get_active(button);
   gl->lightInfo[JAV_LIGHT0+which-1].enabled = (active != 0);
   gl->SetLightsAndDraw();
}

void on_change_xl(GtkWidget *spin, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int which = GPOINTER_TO_INT(data);
   int whichLight = which / 100 - 1;
   int whichComp = which % 100 - 1;
   gl->lightInfo[whichLight].position[whichComp] = (float) spin_button_get_value(spin);
   gl->SetLightsAndDraw();
}

#ifdef GTK_COLOR_BUTTON
void ChangedLight(GtkWidget *cb, GParamSpec *, gpointer data)
#else
void ChangedLight(GtkWidget *cb, GtkStyle *style, gpointer data)
#endif
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   float light[4];
   color_button_get_color(cb, light);
   int which = GPOINTER_TO_INT(data);
   int whichLight = which / 100 - 1;
   int whichComp = which % 100;
   switch(whichComp)
   {
   case 1:        // diffuse
        memcpy(gl->lightInfo[whichLight].diffuse, light, 3*sizeof(float));
        break;
   case 2:        // specular
        memcpy(gl->lightInfo[whichLight].specular, light, 3*sizeof(float));
        break;
   }
   gl->SetLightsAndDraw();
}

#ifdef GTK_COLOR_BUTTON
void ChangedColor(GtkWidget *cb, GParamSpec *, gpointer data)
#else
void ChangedColor(GtkWidget *cb, GtkStyle *style, gpointer data)
#endif
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   float light[4];
   color_button_get_color(cb, light);
   int which = GPOINTER_TO_INT(data);
   switch(which)
   {
   case BG:
       memcpy(gl->BgColor, light, 3*sizeof(float));
       main_app::JavApp.putfCol(BGC, light);
       if(gl->BgType <= TYPE_FLAT)
          gl->SetBgColor();
       break;
   case BG1:
       memcpy(gl->BgColor1, light, 3*sizeof(float));
       main_app::JavApp.putfCol(BGC+1, light);
       if(gl->BgType > TYPE_FLAT)
       {
          gl->SetBgColor();
          LoadCairoTexture(gl);
       }
       break;
   case BG2:
       memcpy(gl->BgColor2, light, 3*sizeof(float));
       main_app::JavApp.putfCol(BGC+2, light);
       if(gl->BgType > TYPE_FLAT)
       {
          gl->SetBgColor();
          LoadCairoTexture(gl);
       }
       break;
   case AXES:
       memcpy(gl->AxesColor, light, 3*sizeof(float));
       main_app::JavApp.putfCol(AXESC, light);
       break;
   case CELL:
       memcpy(gl->CellColor, light, 3*sizeof(float));
       main_app::JavApp.putfCol(CELLC, light);
       break;
   case DISTS:
       memcpy(gl->DistColor, light, 3*sizeof(float));
       main_app::JavApp.putfCol(INFOS, light);
       break;
   case HYDB:
       memcpy(gl->ColorHB, light, 3*sizeof(float));
       main_app::JavApp.putfCol(HBC, light);
       UpdateInfoAtoms();
       break;
   case SHORTC:
       memcpy(gl->ColorSC, light, 3*sizeof(float));
       main_app::JavApp.putfCol(SCC, light);
       UpdateInfoAtoms();
       break;
   default:
       if( which >= 100 )
       {
          int indspe = which/100-1;
          main_app::JavApp.putfCol(indspe+N_OBJS, light);
          for(int k=0; k<gl->nModels; k++)
              memcpy(ModelInfo[k].light_diffuse[indspe], light, 3*sizeof(float));
       }
       break;
   }
   gl->Redraw ();
}

void create_color_table(GtkWidget *father, GLWindow *gl)
{
  GtkWidget *vbox2 = get_widget(father, "atoms_prop");
  GList *children = gtk_container_get_children(GTK_CONTAINER(vbox2));
  for(int i=0; i< (int)g_list_length(children); i++)
      gtk_container_remove(GTK_CONTAINER(vbox2), GTK_WIDGET(g_list_nth_data(children, i)));

  GtkWidget *label = LABEL_NEW("Atom", NULL);
  set_alignment(label, 0, 0.5f);
  gtk_widget_show(label);
  table_attach_exp(vbox2, label, 0, 1, 0, 1);
  label = LABEL_NEW("Colour", NULL);
  set_alignment(label, 0, 0.5f);
  gtk_widget_show(label);
  table_attach_exp(vbox2, label, 1, 2, 0, 1);
  label = LABEL_NEW("Radius                      ", NULL);
  set_alignment(label, 0, 0.5f);
  table_attach_exp(vbox2, label, 2, 3, 0, 1);
  gtk_widget_show(label);

  GtkWidget *button = mr_chain_button_new();
  gtk_widget_show(button);
  table_attach(vbox2, button, 3, 4, 0, 1);
  g_object_set_data(G_OBJECT(father), "chainbutton", button);
  for (int i=0; i<gl->NSpecies; i++)
  {
       std::stringstream lab, but, scale;
       lab << "lab" << i+1;
       but << "but" << i+1;
       scale << "scale" << i+1;
       int  index1 = gl->ListaSpecies[i];
       float color[4];
       memcpy(color, main_app::JavApp.app_color[index1-1+N_OBJS], 4*sizeof(float)); 
       GtkWidget *label = LABEL_NEW(get_nth_element_name(index1-1), NULL);
       set_alignment (label, 0., 0.5);
       gtk_widget_show(label);
       g_object_set_data(G_OBJECT(father), lab.str().c_str(), label);
       table_attach(vbox2, label, 0, 1, i+1, i+2);
       GtkWidget *button = color_button(color, "Pick a color");
       g_object_set_data(G_OBJECT(father), but.str().c_str(), button);
#ifdef IN_GTK3
       GtkWidget *align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
       GtkWidget *align = gtk_alignment_new(0, 0.5f, 0, 0);
#endif
       table_attach(vbox2, align, 1, 2, i+1, i+2);
       gtk_container_add(GTK_CONTAINER(align), button);
       gtk_widget_show(align);
       gtk_widget_show(button);
#ifdef GTK_COLOR_BUTTON
       g_signal_connect(G_OBJECT(button), "notify::color", G_CALLBACK(ChangedColor), GINT_TO_POINTER(100*index1));
#else
       g_signal_connect(G_OBJECT(button), COLOR_CHANGED, G_CALLBACK(ChangedColor), GINT_TO_POINTER(100*index1));
#endif
       GtkWidget *range = hscale_new_with_range(0.2f, 3, 0.01);
       g_object_set_data(G_OBJECT(father), "r_atoms", range);
       g_object_set_data(G_OBJECT(father), scale.str().c_str(), range);
       gtk_scale_set_value_pos(GTK_SCALE(range), GTK_POS_RIGHT);
       int hnd = g_signal_connect(G_OBJECT(range), "value-changed", G_CALLBACK(on_change_scale), GINT_TO_POINTER(index1));
       g_object_set_data(G_OBJECT(range), "hnd", GINT_TO_POINTER(hnd));
       gtk_widget_show(range);
       table_attach_exp(vbox2, range, 2, 3, i+1, i+2);
  }
}
void OLDcreate_color_table(GtkWidget *father, GLWindow *gl)
{
   GtkWidget *vbox2 = get_widget(father, "table_col");
   GList *children = gtk_container_get_children(GTK_CONTAINER(vbox2));
   for(int i=0; i< (int)g_list_length(children); i++)
      gtk_container_remove(GTK_CONTAINER(vbox2), GTK_WIDGET(g_list_nth_data(children, i)));

  for (int i=0; i<gl->NSpecies; i++)
  {
       std::stringstream lab, but;
       lab << "lab" << i+1;
       but << "but" << i+1;
       int  index1 = gl->ListaSpecies[i];
       float color[4];
       memcpy(color, main_app::JavApp.app_color[index1-1+N_OBJS], 4*sizeof(float)); 
       GtkWidget *vbox3 = vbox_new(FALSE, 0);
       table_attach(vbox2, vbox3, i%9, i%9+1, i/9, i/9+1);
//       GdkColor *colore = ToGdkColor(color);
       GtkWidget *label = LABEL_NEW(get_nth_element(index1-1), NULL);
       set_alignment (label, 0.5, 0.);
       gtk_widget_show(label);
       g_object_set_data(G_OBJECT(father), lab.str().c_str(), label);
       gtk_box_pack_start(GTK_BOX(vbox3), label, FALSE, FALSE, 4);
       GtkWidget *button = color_button(color, "Pick a color");
#ifdef IN_GTK3
       GtkWidget *align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
       GtkWidget *align = gtk_alignment_new(0.5, 0, 0., 0.);
#endif
       gtk_box_pack_start(GTK_BOX(vbox3), align, FALSE, FALSE, 0);
       gtk_container_add(GTK_CONTAINER(align), button);
       gtk_widget_show(align);
       g_object_set_data(G_OBJECT(father), but.str().c_str(), button);
       gtk_widget_show(button);
       gtk_widget_show(vbox3);
#ifdef GTK_COLOR_BUTTON
       g_signal_connect(G_OBJECT(button), "notify::color", G_CALLBACK(ChangedColor), GINT_TO_POINTER(100*index1));
#else
       g_signal_connect(G_OBJECT(button), COLOR_CHANGED, G_CALLBACK(ChangedColor), GINT_TO_POINTER(100*index1));
#endif
  }
}

void toggle_pvis(GtkToggleButton *but, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   Model m = ModelInfo[whichModel];
   int which = GPOINTER_TO_INT(data);
   m.PolyStyle[which].visible = (gtk_toggle_button_get_active(but) != 0);
   gl->Redraw();
}

#ifdef IN_GTK3
void ChangedPolyColor(GtkWidget *cb, gpointer data)
#else
void ChangedPolyColor(GtkWidget *cb, GtkStyle *style, gpointer data)
#endif
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   Model m = ModelInfo[whichModel];
   if(m.PolyStyle == NULL)
      return;

   float color[4];
   mycolor_button_get_color(cb, color);
   int which = GPOINTER_TO_INT(data);
   for(int i=0; i<4; i++)
       m.PolyStyle[which].colore[i] = color[i];
   gl->Redraw();
}

#ifdef IN_GTK3
void ChangedPolyBColor(GtkWidget *cb, gpointer data)
#else
void ChangedPolyBColor(GtkWidget *cb, GtkStyle *style, gpointer data)
#endif
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   Model m = ModelInfo[whichModel];
   if(m.PolyStyle == NULL)
      return;

   float color[4];
   mycolor_button_get_color(cb, color);
   int which = GPOINTER_TO_INT(data);
   for(int i=0; i<4; i++)
       m.PolyStyle[which].Bcolore[i] = color[i];
   gl->Redraw();
}

void on_change_transp(GtkRange *button, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   Model m = ModelInfo[whichModel];
   int which = GPOINTER_TO_INT(data);
   m.PolyStyle[which].transparency = (int) gtk_range_get_value(button);
   gl->Redraw ();
}

void on_change_linewidth(GtkWidget *button, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   Model m = ModelInfo[whichModel];
   int which = GPOINTER_TO_INT(data);
   m.PolyStyle[which].line_width = (float) spin_button_get_value(button);
   gl->Redraw ();
}

void on_toggle_edges(GtkToggleButton *button, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   Model m = ModelInfo[whichModel];
   int which = GPOINTER_TO_INT(data);
   m.PolyStyle[which].ifBorder = (gtk_toggle_button_get_active(button) == 1);
   gl->Redraw ();
}

void set_values_for_polyhedra(GtkWidget *father, GLWindow *gl)
{
  GtkWidget *frame = get_widget(father, "frame_polyhedra");
  if(frame == NULL)
     return;
/*
  const char *titles[] = { "Central atom", "Show pol.", "Colour", 
                           "Transparency", "Show edges",
                           "Edges colour", "Line width"};
*/
  const char *titles[] = { "Centre", "Show", "Colour", 
                           "Transparency", "   ", "Show",
                           "Colour", "Line width"};
  int ncolumns = (int) (sizeof(titles)/sizeof(titles[0]));
  int whichModel = GetActiveModel() - 1;
  remove_children(frame);
  if((whichModel == -1) || (gl->nModels == 0))
     return;
   if(!ModelInfo[whichModel].created)
        return;

  Model m = ModelInfo[whichModel];
  int npol = m.nPolyStyles;
  if(npol == 0)
  {
     GtkWidget *label = LABEL_NEW("\n\nNo polyhedra in model\n\n", MyBLUE);
     gtk_container_add(GTK_CONTAINER(frame), label);
     gtk_widget_show_all(frame);
     return;
  }
  GtkWidget *vbox2 = table_new(npol+2, ncolumns, FALSE);
  //gtk_container_add(GTK_CONTAINER(frame), vbox2);
#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  GtkWidget *align = gtk_alignment_new(0, 0, 0.8f, 0.1f);
#endif
  gtk_container_add(GTK_CONTAINER(frame), align);
  gtk_container_add(GTK_CONTAINER(align), vbox2);
//  gtk_container_set_border_width(GTK_CONTAINER(vbox2), 6);
  table_set_row_spacings(vbox2, 4);
  table_set_col_spacings(vbox2, 4);
  GtkWidget *label = LABEL_BOLD("Planes", NULL, 1.f);
  set_alignment(label, 0.5, 0.0);
  table_attach(vbox2, label, 0, 4, 0, 1, TRUE);
  label = LABEL_BOLD("Edges", NULL, 1.f);
  set_alignment(label, 0.5, 0.0);
  table_attach(vbox2, label, 5, ncolumns, 0, 1, TRUE);
  for(int i=0; i<ncolumns; i++)
  {
      label = LABEL_NEW(titles[i], MyBLUE);
      set_alignment(label, 0.5, 0.0);
#ifdef IN_GTK3
      GtkWidget *align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
      GtkWidget *align = gtk_alignment_new(0.5, 0.5, 0., 0.);
#endif
      table_attach(vbox2, align, i, i+1, 1, 2, TRUE);
      gtk_container_add(GTK_CONTAINER(align), label);
  }
  for(int i=0; i<npol; i++)
  {
      std::stringstream base;
      base << i;
      std::string nome;
//Central atom
      int v = m.PolyStyle[i].vert;
      std::string lab = m.atm_au[v].lab;
      GtkWidget *label = LABEL_NEW(lab.c_str(), MyBLUE);
//      set_alignment(label, 0.5f, 0.5f);
      set_alignment(label, 0.5, 0.0);
#ifdef IN_GTK3
      GtkWidget *align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
      GtkWidget *align = gtk_alignment_new(0.5, 0.5, 0., 0.);
#endif
      table_attach(vbox2, align, 0, 1, i+2, i+3, TRUE);
      gtk_container_add(GTK_CONTAINER(align), label);
//Show polyhedron
      nome.assign("visible");
      nome.append(base.str());
      label = gtk_check_button_new();
      g_object_set_data(G_OBJECT(father), nome.c_str(), label);
#ifdef IN_GTK3
      align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
      align = gtk_alignment_new(0.5, 0.5, 0., 0.);
#endif
      table_attach(vbox2, align, 1, 2, i+2, i+3);
      gtk_container_add(GTK_CONTAINER(align), label);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), (m.PolyStyle[i].visible == true));
      g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(toggle_pvis),
          GINT_TO_POINTER(i));
//Polyhedron color
      nome.assign("colore");
      nome.append(base.str());
      label = mycolor_button(m.PolyStyle[i].colore, "Pick a color to be used for polyhedra");
      g_object_set_data(G_OBJECT(father), nome.c_str(), label);
#ifdef IN_GTK3
      align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
      align = gtk_alignment_new(0.5, 0.5, 0., 0.);
#endif
      table_attach(vbox2, align, 2, 3, i+2, i+3);
      gtk_container_add(GTK_CONTAINER(align), label);
      g_signal_connect(G_OBJECT(label), COLOR_CHANGED, G_CALLBACK(ChangedPolyColor), GINT_TO_POINTER(i));
//Transparency
      nome.assign("Transparency");
      nome.append(base.str());
      label = hscale_new_with_range(0, 100, 1);
      gtk_scale_set_digits(GTK_SCALE(label), 0);
      gtk_scale_set_value_pos(GTK_SCALE(label), GTK_POS_BOTTOM);
      gtk_scale_set_draw_value(GTK_SCALE(label), TRUE);
      gtk_range_set_value(GTK_RANGE(label), m.PolyStyle[i].transparency);
      g_object_set_data(G_OBJECT(father), nome.c_str(), label);
#ifdef IN_GTK3
      align = new_alignment(GTK_ALIGN_FILL, GTK_ALIGN_CENTER, 0, 0);
#else
      align = gtk_alignment_new(0.5, 0.5, 1., 0.);
#endif
      table_attach(vbox2, align, 3, 4, i+2, i+3, TRUE);
      gtk_container_add(GTK_CONTAINER(align), label);
      int hnd = g_signal_connect(G_OBJECT(label), "value-changed", G_CALLBACK(on_change_transp), GINT_TO_POINTER(i));
      g_object_set_data(G_OBJECT(label), "hnd", GINT_TO_POINTER(hnd));
//Show polyhedron edges
      nome.assign("ifBorder");
      nome.append(base.str());
      label = gtk_check_button_new();
      g_object_set_data(G_OBJECT(father), nome.c_str(), label);
#ifdef IN_GTK3
      align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
      align = gtk_alignment_new(0.5, 0.5, 0., 0.);
#endif
      table_attach(vbox2, align, 5, 6, i+2, i+3);
      gtk_container_add(GTK_CONTAINER(align), label);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), (m.PolyStyle[i].ifBorder == true));
      g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(on_toggle_edges),
          GINT_TO_POINTER(i));
//Edges color
      nome.assign("Bcolore");
      nome.append(base.str());
      label = mycolor_button(m.PolyStyle[i].Bcolore, "Pick a color to be used for polyhedra edges");
      g_object_set_data(G_OBJECT(father), nome.c_str(), label);
#ifdef IN_GTK3
      align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
      align = gtk_alignment_new(0.5, 0.5, 0., 0.);
#endif
      table_attach(vbox2, align, 6, 7, i+2, i+3);
      gtk_container_add(GTK_CONTAINER(align), label);
      g_signal_connect(G_OBJECT(label), COLOR_CHANGED, G_CALLBACK(ChangedPolyBColor), GINT_TO_POINTER(i));
//Line width
      nome.assign("line_width");
      nome.append(base.str());
      label  = spin_button_new_with_range(0.1, 10, 0.1);
      set_width_chars(GTK_ENTRY(label), 4);
      spin_button_set_value(label, m.PolyStyle[i].line_width);
      g_object_set_data(G_OBJECT(father), nome.c_str(), label);
#ifdef IN_GTK3
      align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
      align = gtk_alignment_new(0.5, 0.5, 0., 0.);
#endif
      table_attach(vbox2, align, 7, 8, i+2, i+3);
      gtk_container_add(GTK_CONTAINER(align), label);
      hnd = g_signal_connect(G_OBJECT(label), "value-changed", G_CALLBACK(on_change_linewidth), GINT_TO_POINTER(i));
      g_object_set_data(G_OBJECT(label), "hnd", GINT_TO_POINTER(hnd));
  }

  gtk_widget_show_all(frame);
}

void on_change_norm(GtkToggleButton *radio, gpointer data)
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  gl->normalToV = (gtk_toggle_button_get_active(radio) != 0);
  if(gl->normalToV )
  {
     for(int i=0; i<gl->nModels; i++)
         ModelInfo[i].CalcolaNormali();
  }
  gl->Redraw();
}

void block_handlers_for_advanced()
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  GtkWidget *father;
  if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
     father = get_widget(GLWINDOW, SettingsWindow);
  else
     return;

  GtkWidget *check = get_widget(father, "smooth");
  int hnd = get_int(check, "hnd");
  g_signal_handler_block (G_OBJECT (check), hnd);
  check = get_widget(father, "softrend");
  if(check)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_block (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "msaa");
  hnd = get_int(check, "hnd");
  g_signal_handler_block (G_OBJECT (check), hnd);
//  check = get_widget(father, "nsamples");
//  hnd = get_int(check, "hnd");
//  g_signal_handler_block (G_OBJECT (check), hnd);
  check = get_widget(father, "multbondscheck");
  hnd = get_int(check, "hnd");
  g_signal_handler_block (G_OBJECT (check), hnd);
  check = get_widget(father, "nperv");
  hnd = get_int(check, "hnd");
  g_signal_handler_block (G_OBJECT (check), hnd);
  std::string name1 = glasses[gl->glasses_type];
  GtkWidget *radio = get_widget(father, name1.c_str());
  hnd = get_int(radio, "hnd");
  g_signal_handler_block (G_OBJECT (radio), hnd);
  radio = get_widget(father, "if3d");
  hnd = get_int(radio, "hnd");
  g_signal_handler_block (G_OBJECT (radio), hnd);
  check = get_widget(father, "ifgrid");
  hnd = get_int(check, "hnd");
  g_signal_handler_block (G_OBJECT (check), hnd);
  check = get_widget(father, "grid_d");
  hnd = get_int(check, "hnd");
  g_signal_handler_block (G_OBJECT (check), hnd);
  GtkWidget *combo = get_widget(father, "line_s");
  hnd = get_int(combo, "hnd");
  g_signal_handler_block (G_OBJECT (combo), hnd);
//  int wp = gl->ifOrtho?1:0;
  for(int wp=0; wp<2; wp++)
  {
  std::string name2 = projection[wp];
  radio = get_widget(father, name2.c_str());
  hnd = get_int(radio, "hnd");
  g_signal_handler_block (G_OBJECT (radio), hnd);
  }
  GtkWidget *r1 = get_widget(father, "r_atoms");
//  hnd = get_int(r1, "hnd");
//  g_signal_handler_block (G_OBJECT (r1), hnd);
  r1 = get_widget(father, "r_bonds");
  hnd = get_int(r1, "hnd");
  g_signal_handler_block (G_OBJECT (r1), hnd);
  r1 = get_widget(father, "ell_tr");
  hnd = get_int(r1, "hnd");
  g_signal_handler_block (G_OBJECT (r1), hnd);
  for(int wp=0; wp<2; wp++)
  {
  std::string name2 = radProp[wp];
  radio = get_widget(father, name2.c_str());
  hnd = get_int(radio, "hnd");
  g_signal_handler_block (G_OBJECT (radio), hnd);
  }
  check = get_widget(father, "axescheck");
  hnd = get_int(check, "hnd");
  g_signal_handler_block (G_OBJECT (check), hnd);
  check = get_widget(father, "cellcheck");
  hnd = get_int(check, "hnd");
  g_signal_handler_block (G_OBJECT (check), hnd);
  check = get_widget(father, "clipcheck");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_block (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "fogcheck");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_block (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "fogspin");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_block (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "clipspin");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_block (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "xoff");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_block (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "yoff");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_block (G_OBJECT (check), hnd);
  }
}

void unblock_handlers_for_advanced()
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  GtkWidget *father;
  if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
     father = get_widget(GLWINDOW, SettingsWindow);
  else
     return;

  GtkWidget *check = get_widget(father, "smooth");
  int hnd = get_int(check, "hnd");
  g_signal_handler_unblock (G_OBJECT (check), hnd);
  check = get_widget(father, "msaa");
  hnd = get_int(check, "hnd");
  g_signal_handler_unblock (G_OBJECT (check), hnd);
//  check = get_widget(father, "nsamples");
//  hnd = get_int(check, "hnd");
//  g_signal_handler_unblock (G_OBJECT (check), hnd);
  check = get_widget(father, "softrend");
  if(check)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_unblock (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "multbondscheck");
  hnd = get_int(check, "hnd");
  g_signal_handler_unblock (G_OBJECT (check), hnd);
  check = get_widget(father, "nperv");
  hnd = get_int(check, "hnd");
  g_signal_handler_unblock (G_OBJECT (check), hnd);
  std::string name1 = glasses[gl->glasses_type];
  GtkWidget *radio = get_widget(father, name1.c_str());
  hnd = get_int(radio, "hnd");
  g_signal_handler_unblock (G_OBJECT (radio), hnd);
  radio = get_widget(father, "if3d");
  hnd = get_int(radio, "hnd");
  g_signal_handler_unblock (G_OBJECT (radio), hnd);
  check = get_widget(father, "ifgrid");
  hnd = get_int(check, "hnd");
  g_signal_handler_unblock (G_OBJECT (check), hnd);
  check = get_widget(father, "grid_d");
  hnd = get_int(check, "hnd");
  g_signal_handler_unblock (G_OBJECT (check), hnd);
  GtkWidget *combo = get_widget(father, "line_s");
  hnd = get_int(combo, "hnd");
  g_signal_handler_unblock (G_OBJECT (combo), hnd);
//  int wp = gl->ifOrtho?1:0;
  for(int wp=0; wp<2; wp++)
  {
  std::string name2 = projection[wp];
  radio = get_widget(father, name2.c_str());
  hnd = get_int(radio, "hnd");
  g_signal_handler_unblock (G_OBJECT (radio), hnd);
  }
  GtkWidget *r1 = get_widget(father, "r_atoms");
//  hnd = get_int(r1, "hnd");
//  g_signal_handler_unblock (G_OBJECT (r1), hnd);
  r1 = get_widget(father, "r_bonds");
  hnd = get_int(r1, "hnd");
  g_signal_handler_unblock (G_OBJECT (r1), hnd);
  r1 = get_widget(father, "ell_tr");
  hnd = get_int(r1, "hnd");
  g_signal_handler_unblock (G_OBJECT (r1), hnd);
  for(int wp=0; wp<2; wp++)
  {
  std::string name2 = radProp[wp];
  radio = get_widget(father, name2.c_str());
  hnd = get_int(radio, "hnd");
  g_signal_handler_unblock (G_OBJECT (radio), hnd);
  }
  check = get_widget(father, "axescheck");
  hnd = get_int(check, "hnd");
  g_signal_handler_unblock (G_OBJECT (check), hnd);
  check = get_widget(father, "cellcheck");
  hnd = get_int(check, "hnd");
  g_signal_handler_unblock (G_OBJECT (check), hnd);
  check = get_widget(father, "clipcheck");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_unblock (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "fogcheck");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_unblock (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "fogspin");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_unblock (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "clipspin");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_unblock (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "xoff");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_unblock (G_OBJECT (check), hnd);
  }
  check = get_widget(father, "yoff");
  if(check != NULL)
  {
     hnd = get_int(check, "hnd");
     g_signal_handler_unblock (G_OBJECT (check), hnd);
  }
}

void set_values_for_advanced()
{
  GtkWidget *father;
   if(!GLWINDOW)
      return;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
     father = get_widget(GLWINDOW, SettingsWindow);
  else
     return;

//advanced
  GtkWidget *check = get_widget(father, "smooth");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), !gl->smooth);
  check = get_widget(father, "msaa");
  gtk_widget_set_sensitive(check, main_app::JavApp.IsMSSupported()?1:0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), main_app::JavApp.IsMSEnabled());
  check = get_widget(father, "nsamples");
  MRcombo_set_val(check, gl->GetCurNSamples(), true);
#ifdef HAVE_ADVANCED
  check = get_widget(father, "softrend");
  if(check)
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), main_app::JavApp.ForceSoftRendering());
#endif
  check = get_widget(father, "nperv");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), gl->normalToV);
  check = get_widget(father, "nperf");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), !gl->normalToV);
// display options
  std::string name1 = glasses[gl->glasses_type];
  GtkWidget *radio = get_widget(father, name1.c_str());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);
  radio = get_widget(father, "if3d");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), gl->Stereo);
  check = get_widget(father, "ifgrid");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), gl->ifGrid);
  check = get_widget(father, "grid_d");
  spin_button_set_value(check, gl->nDivisions);
  GtkWidget *combo = get_widget(father, "line_s");
  for(int i=0; i<(int)(sizeof(Patterns)/sizeof(Patterns[0])); i++)
  {
      if(gl->GridPattern == Patterns[i])
         combo_set_val(combo, i+1);
  }
  int wp = gl->ifOrtho?1:0;
  std::string name2 = projection[wp];
  radio = get_widget(father, name2.c_str());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);
// atoms & bonds
  create_color_table(father, gl);
  GtkWidget *r1;
  for (int i=0; i<gl->NSpecies; i++)
  {
       int  index = gl->ListaSpecies[i]-1;
       std::stringstream scale;
       scale << "scale" << i+1;
       r1 = get_widget(father, scale.str().c_str());
       gtk_range_set_range(GTK_RANGE(r1), 0.2, 3.0);
       gtk_range_set_value(GTK_RANGE(r1), gl->scale_atoms[index]);
  }
  r1 = get_widget(father, "r_bonds");
  gtk_range_set_range(GTK_RANGE(r1), 0.2, 3.0);
  gtk_range_set_value(GTK_RANGE(r1), gl->sc_bonds);
  r1 = get_widget(father, "ell_tr");
  gtk_range_set_range(GTK_RANGE(r1), 0, 100);
  gtk_range_set_value(GTK_RANGE(r1), gl->ell_tr);
  //sistema_elltr(father);
  wp = gl->RadType?1:0;
  name2.assign(radProp[wp]);
  radio = get_widget(father, name2.c_str());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);
  sistema_elltr(father);
  GtkWidget *cb = get_widget(father, "hbcolor");
  color_button_set_color(cb, gl->ColorHB);
  cb = get_widget(father, "sccolor");
  color_button_set_color(cb, gl->ColorSC);
  check = get_widget(father, "multbondscheck");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), gl->ShowMultBonds);

// drawing options
  combo = get_widget(father, "bgtype");
  MRcombo_set_val(combo, gl->BgType, true);
  cb = get_widget(father, "bgcolor0");
  color_button_set_color(cb, gl->BgColor);

  if(gl->BgType == TYPE_FLAT)
     gtk_widget_show(cb);
  else
     gtk_widget_hide(cb);

  cb = get_widget(father, "bgcolor1");
  color_button_set_color(cb, gl->BgColor1);
  if(gl->BgType > TYPE_FLAT)
     gtk_widget_show(cb);
  else
     gtk_widget_hide(cb);
  cb = get_widget(father, "bgcolor2");
  color_button_set_color(cb, gl->BgColor2);
  if(gl->BgType > TYPE_FLAT)
     gtk_widget_show(cb);
  else
     gtk_widget_hide(cb);
  check = get_widget(father, "axescheck");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), gl->ifAxes);
  check = get_widget(father, "axesdrawcheck");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), gl->ifDrawAxes);
  cb = get_widget(father, "axescolor");
  gtk_widget_set_sensitive(cb,  gl->ifAxes);
  color_button_set_color(cb, gl->AxesColor);
  check = get_widget(father, "cellcheck");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), gl->ifCell);
  cb = get_widget(father, "cellcolor");
  gtk_widget_set_sensitive(cb,  gl->ifCell);
  color_button_set_color(cb, gl->CellColor);
#ifdef GTK_FONT_BUTTON
  cb = get_widget(father, "labfont");
  font_button_set_font_name(cb, gl->fontname);
#endif
  cb = get_widget(father, "infoscolor");
  color_button_set_color(cb, gl->DistColor);
  check = get_widget(father, "clipcheck");
  if(check != NULL)
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), gl->Clip);
  check = get_widget(father, "fogcheck");
  if(check != NULL)
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), gl->fog);
  check = get_widget(father, "fogspin");
  if(check != NULL)
     spin_button_set_value(check, gl->FogDensity);
  check = get_widget(father, "clipspin");
  if(check != NULL)
     spin_button_set_value(check, gl->ClipFactor);
  check = get_widget(father, "xoff");
  if(check != NULL)
     spin_button_set_value(check, gl->xoffset);
  check = get_widget(father, "yoff");
  if(check != NULL)
     spin_button_set_value(check, gl->yoffset);

//Polyhedra
  set_values_for_polyhedra(father, gl);

//Lighting
  float color[4];
  for(int i=1; i<=2; i++)
  {
      std::string prefix = g_strdup_printf("Light %d", i);
      std::string nome = prefix + "check";
      check = get_widget(father, nome.c_str());
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check),
          gl->lightInfo[JAV_LIGHT0+i-1].enabled);
      memcpy(color, gl->lightInfo[JAV_LIGHT0+i-1].diffuse, 4*sizeof(float));
      nome.assign(prefix + " diffuse");
      cb = get_widget(father, nome.c_str());
      color_button_set_color(cb, color);
      memcpy(color, gl->lightInfo[JAV_LIGHT0+i-1].specular, 4*sizeof(float));
      nome.assign(prefix + " specular");
      cb = get_widget(father, nome.c_str());
      color_button_set_color(cb, color);
      nome.assign(prefix + "x");
      check = get_widget(father, nome.c_str());
      spin_button_set_value(check, gl->lightInfo[JAV_LIGHT0+i-1].position[0]);
      nome.assign(prefix + "y");
      check = get_widget(father, nome.c_str());
      spin_button_set_value(check, gl->lightInfo[JAV_LIGHT0+i-1].position[1]);
      nome.assign(prefix + "z");
      check = get_widget(father, nome.c_str());
      spin_button_set_value(check, gl->lightInfo[JAV_LIGHT0+i-1].position[2]);
  }
  check = get_widget(father, "ambient_check");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check),
          gl->lightInfo[JAV_AMBIENT].enabled);
  cb = get_widget(father, "ambient_light");
  memcpy(color, gl->lightInfo[JAV_AMBIENT].diffuse, 4*sizeof(float));
  color_button_set_color(cb, color);
}

void on_change_ellstyle(GtkRange *button, gpointer )
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

   gl->ell_tr = (int) gtk_range_get_value(button);
   gl->Redraw();
}

void fill_contact_table(GtkWidget *father)
{
   GtkWidget *table = get_widget(father, "table_con");
   const float colore[] = {1, 1, 1, 1};

   GtkWidget *label = LABEL_NEW ("Hydrogen Bonds", NULL);
   set_alignment(label, 0., 0.5);
   set_margins(label, 0, 0, 4, 4);
   GtkWidget *hbox = hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   GtkWidget *cb = color_button(colore, "Pick a color to be used for drawing hydrogen bonds");
   gtk_box_pack_start(GTK_BOX(hbox), cb, FALSE, FALSE, 4);
   table_attach(table, hbox, 0, 1, 0, 1);
   g_object_set_data(G_OBJECT(father), "hbcolor", cb);
#ifdef GTK_COLOR_BUTTON
   g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(ChangedColor), GINT_TO_POINTER(HYDB));
#else
   g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(ChangedColor), GINT_TO_POINTER(HYDB));
#endif

   hbox = hbox_new(FALSE, 0);
   label = LABEL_NEW ("Short Contacts", NULL);
   set_alignment(label, 0., 0.5);
   set_margins(label, 0, 0, 4, 4);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   cb = color_button(colore, "Pick a color to be used for drawing short contacts");
   table_attach(table, hbox, 1, 2, 0, 1);
   gtk_box_pack_start(GTK_BOX(hbox), cb, FALSE, FALSE, 4);
   g_object_set_data(G_OBJECT(father), "sccolor", cb);
#ifdef GTK_COLOR_BUTTON
   g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(ChangedColor), GINT_TO_POINTER(SHORTC));
#else
   g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(ChangedColor), GINT_TO_POINTER(SHORTC));
#endif
}

void selection_cb(GtkWidget *, int val)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gl->BgType = val;
   if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, SettingsWindow);
      GtkWidget *cb  = get_widget(dlg, "bgcolor0");
      GtkWidget *cb1 = get_widget(dlg, "bgcolor1");
      GtkWidget *cb2 = get_widget(dlg, "bgcolor2");
      float light[4];
      if(val < TYPE_FLAT)
      {
         light[0] = (float) val;
         light[1] = (float) val;
         light[2] = (float) val;
         light[3] = 1.f;
         gtk_widget_hide(cb);
         gtk_widget_hide(cb1);
         gtk_widget_hide(cb2);
         memcpy(gl->BgColor, light, 3*sizeof(float));
         main_app::JavApp.putfCol(BGC, light);
         gl->SetBgColor();
      }
      else if(val > TYPE_FLAT)
      {
         gtk_widget_hide(cb);
         gtk_widget_show(cb1);
         gtk_widget_show(cb2);
         color_button_get_color(cb2, light);
         memcpy(gl->BgColor2, light, 3*sizeof(float));
         main_app::JavApp.putfCol(BGC+2, light);
         color_button_get_color(cb1, light);
         memcpy(gl->BgColor1, light, 3*sizeof(float));
         main_app::JavApp.putfCol(BGC+1, light);
         gl->SetBgColor();
      }
      else
      {
         gtk_widget_show(cb);
         gtk_widget_hide(cb1);
         gtk_widget_hide(cb2);
         color_button_get_color(cb, light);
         memcpy(gl->BgColor, light, 3*sizeof(float));
         main_app::JavApp.putfCol(BGC, light);
         gl->SetBgColor();
      }
      if(gl->BgType > TYPE_FLAT)
         LoadCairoTexture(gl);
      gl->Redraw ();
   }
}

void ChangedVal(GtkWidget *tb, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int which = GPOINTER_TO_INT(data);
   switch(which)
   {
   case CLIPPING:
       gl->ClipFactor = spin_button_get_value(tb);
       gl->change_clip_value();
       break;
   case FOG:
       gl->FogDensity = (float) spin_button_get_value(tb);
       break;
   }
   gl->Redraw ();
}

void ChangedRadType(GtkToggleButton *tb, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gl->RadType = GPOINTER_TO_INT(data);
   gl->Redraw ();
}

void ChangedVis(GtkToggleButton *tb, gpointer data)
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int which = GPOINTER_TO_INT(data);
   switch(which)
   {
   case AXES:
       gl->ifAxes = gtk_toggle_button_get_active(tb);
       break;
   case DRAWAXES:
       gl->ifDrawAxes = gtk_toggle_button_get_active(tb);
       break;
   case MULTB:
       gl->ShowMultBonds = (gtk_toggle_button_get_active(tb) != 0);
       if(get_object(GLWINDOW, "ShowMB") != NULL)
      {
         gpointer check = get_object(GLWINDOW, "ShowMB");
         obj_set_active(check, gl->ShowMultBonds, true);
      }

       if(gl->ShowMultBonds)
       {
          for(int i=1; i<=gl->nModels; i++)
              jav_show_multbonds_(&i);
          return;
       }
       break;
   case CELL:
       sync_radio("View Cell Edges", (gtk_toggle_button_get_active(tb)!=0));
       break;
   case GRID:
       gl->ifGrid = (gtk_toggle_button_get_active(tb) != 0);
       break;
   case TRED:
       gl->ToggleStereo(gtk_toggle_button_get_active(tb));
       break;
   case PROJECTION:
       gl->SetOrtho(!gtk_toggle_button_get_active(tb));
       break;
   case PROJECTION+1:
       gl->SetOrtho(gtk_toggle_button_get_active(tb));
       break;
   case CLIPPING:
       SetClip((gtk_toggle_button_get_active(tb)!=0));
       break;
   case FOG:
       gl->ToggleFog(gtk_toggle_button_get_active(tb));
       break;
   }
   gl->Redraw ();
}

void set_browser(GtkWidget *button, gpointer data)
{
  std::string fn;
  GtkWidget *w = (GtkWidget *) data;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
  const gchar *deffn = gtk_entry_get_text(GTK_ENTRY(w));
  fn = gtkext::dlg_select_file(dlg, deffn, gtkext::eSELECT_ALIEN, "*.*");
  gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
  if( !fn.empty() )
  {
    main_app::JavApp.UpdateIB(g_strdup(fn.c_str()));
    gtk_entry_set_text(GTK_ENTRY(w), fn.c_str());
  }
}

void PageCentre(GtkWidget *vbox1,  GtkWidget *father)
{
#ifdef MAPS
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  centre_settings(GLWINDOW, father, vbox1, true);
  g_object_set_data(G_OBJECT(father), "box_centre", vbox1);
  gtk_widget_set_sensitive(get_widget(father, "whm"), (gl->nMaps > 0));
#endif
}

void PageModels(GtkWidget *vbox1,  GtkWidget *father)
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

  GtkWidget *vbox = gen_strutt(father, 1, vbox1);
  g_object_set_data(G_OBJECT(father), "box_models", vbox);
  if(gl->nModels > 0)
      model_settings(GLWINDOW, father, vbox);
}

void PageMaps(GtkWidget *vbox1,  GtkWidget *father)
{
  int sc = 0;      // no scrolled window
#ifdef JAV
  sc = 1;
#endif
  GtkWidget *vbox = gen_strutt(father, sc, vbox1);
  g_object_set_data(G_OBJECT(father), "box_maps", vbox);
#ifdef MAPS
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  centre_settings(GLWINDOW, father, vbox1, true);
  g_object_set_data(G_OBJECT(father), "box_centre", vbox1);
  gtk_widget_set_sensitive(get_widget(father, "whm"), (gl->nMaps > 0));
  if(gl->nMaps > 0)
      map_settings(GLWINDOW, father, vbox, true);
#endif
}

void PageAtomProp(GtkWidget *vboxx, GtkWidget *father)
{
  GtkWidget *frame = gen_strutt(father, 1, vboxx);
  GtkWidget *table = table_new (MAX_SPECIES+1, 4, FALSE);
  gtk_container_add (GTK_CONTAINER (frame), table);
  table_set_row_spacings(table, 6);
  table_set_col_spacings(table, 20);
  g_object_set_data(G_OBJECT(father), "atoms_prop", table);
  GtkWidget *label = LABEL_NEW("Atom", NULL);
  set_alignment(label, 0, 0.5f);
  table_attach_exp(table, label, 0, 1, 0, 1);
  label = LABEL_NEW("Colour", NULL);
  set_alignment(label, 0, 0.5f);
  table_attach_exp(table, label, 1, 2, 0, 1);
  label = LABEL_NEW("Radius", NULL);
  set_alignment(label, 0, 0.5f);
  table_attach_exp(table, label, 2, 3, 0, 1);
  gtk_widget_show_all(table);

  frame = NEW_FRAME("Radius proportional to:");
  gtk_box_pack_start (GTK_BOX (vboxx), frame, FALSE, FALSE, 4);
  GtkWidget *vb = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vb);
  gtk_container_set_border_width(GTK_CONTAINER(vb), 4);
  GSList *radtype_group = NULL;
  for(int i=0; i<2; i++)
  {
      std::string name1 = radProp[i];
      GtkWidget *radio = RADIO_BUTTON_WITH_LABEL(radtype_group, name1.c_str(), NULL);
      radtype_group =  gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      g_object_set_data(G_OBJECT(father), name1.c_str(), radio);
      gtk_box_pack_start(GTK_BOX(vb), radio, TRUE, TRUE, 2);
      int hnd = g_signal_connect(G_OBJECT(radio), "toggled", G_CALLBACK(ChangedRadType), GINT_TO_POINTER(i));
      g_object_set_data(G_OBJECT(radio), "hnd", GINT_TO_POINTER(hnd));
  }
  g_object_set_data(G_OBJECT(father), "radtype_frame", frame);
  gtk_widget_set_sensitive(frame, FALSE);

  frame = NEW_FRAME("Thermal ellipsoids");
  gtk_box_pack_start (GTK_BOX (vboxx), frame, FALSE, FALSE, 4);
  vb = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vb);
  gtk_container_set_border_width(GTK_CONTAINER(vb), 4);
  GtkWidget *range = create_range(father, vb, "Transparency (0=Solid, 100=Transparent)",
            HORIZONTAL);
  gtk_scale_set_digits(GTK_SCALE(range), 0);
  gtk_range_set_value(GTK_RANGE(range), 0);
  g_object_set_data(G_OBJECT(father), "ell_tr", range);
  g_object_set_data(G_OBJECT(father), "ell_frame", frame);
  gtk_widget_set_sensitive(frame, FALSE);
  int hnd = g_signal_connect(G_OBJECT(range), "value-changed", G_CALLBACK(on_change_ellstyle), NULL);
  g_object_set_data(G_OBJECT(range), "hnd", GINT_TO_POINTER(hnd));
}

void PageBondProp(GtkWidget *vboxx, GtkWidget *father)
{
  GtkWidget *frame = NEW_FRAME("Radius tuning ");
  gtk_box_pack_start (GTK_BOX (vboxx), frame, FALSE, FALSE, 4);
  GtkWidget *range = hscale_new_with_range(0.1f, 3, 0.01f);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), range);
  g_object_set_data(G_OBJECT(father), "r_bonds", range);
  int hnd = g_signal_connect(G_OBJECT(range), "value-changed", G_CALLBACK(on_change_scale), GINT_TO_POINTER(-1));
  g_object_set_data(G_OBJECT(range), "hnd", GINT_TO_POINTER(hnd));
  frame = NEW_FRAME("Contact colours ");
  gtk_box_pack_start (GTK_BOX (vboxx), frame, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(father), "frame_con", frame);
  GtkWidget *hb = table_new(1, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), hb);
  g_object_set_data(G_OBJECT(father), "table_con", hb);
  table_set_col_spacings(hb, 20);
  fill_contact_table(father);
  GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Show Multiple Bonds", NULL);
  g_object_set_data(G_OBJECT(father), "multbondscheck", check);
  gtk_box_pack_start (GTK_BOX (vboxx), check, FALSE, FALSE, 4);
  hnd = g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(ChangedVis), GINT_TO_POINTER(MULTB));
  g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));
}

void PageRadius(GtkWidget *vboxx, GtkWidget *father)
{
  GtkWidget *hboxx1 = hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vboxx), hboxx1, FALSE, FALSE, 4);

  GtkWidget *frame = NEW_FRAME("Radius tuning ");
  gtk_box_pack_start (GTK_BOX (hboxx1), frame, TRUE, TRUE, 4);
  GtkWidget *hb = hbox_new(TRUE, 0);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), hb);
  GtkWidget *vb = hbox_new(FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hb), vb, TRUE, TRUE, 0);
  GtkWidget *range = create_range(father, vb, "Atoms", HORIZONTAL);
  g_object_set_data(G_OBJECT(father), "r_atoms", range);
  int hnd = g_signal_connect(G_OBJECT(range), "value-changed", G_CALLBACK(on_change_scale), GINT_TO_POINTER(1));
  g_object_set_data(G_OBJECT(range), "hnd", GINT_TO_POINTER(hnd));
  vb = hbox_new(FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hb), vb, TRUE, TRUE, 20);
  range = create_range(father, vb, "Bonds", HORIZONTAL);
  g_object_set_data(G_OBJECT(father), "r_bonds", range);
  hnd = g_signal_connect(G_OBJECT(range), "value-changed", G_CALLBACK(on_change_scale), GINT_TO_POINTER(2));
  g_object_set_data(G_OBJECT(range), "hnd", GINT_TO_POINTER(hnd));
  frame = NEW_FRAME("Thermal ellipsoids");
  gtk_box_pack_start (GTK_BOX (vboxx), frame, FALSE, FALSE, 4);
  vb = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vb);
  gtk_container_set_border_width(GTK_CONTAINER(vb), 4);
  range = create_range(father, vb, "Transparency (0=Solid, 100=Transparent)",
            HORIZONTAL);
  gtk_scale_set_digits(GTK_SCALE(range), 0);
  gtk_range_set_value(GTK_RANGE(range), 0);
  g_object_set_data(G_OBJECT(father), "ell_tr", range);
  g_object_set_data(G_OBJECT(father), "ell_frame", frame);
  gtk_widget_set_sensitive(frame, FALSE);
  hnd = g_signal_connect(G_OBJECT(range), "value-changed", G_CALLBACK(on_change_ellstyle), NULL);
  g_object_set_data(G_OBJECT(range), "hnd", GINT_TO_POINTER(hnd));

  frame = NEW_FRAME("Atom colours ");
  gtk_box_pack_start (GTK_BOX (vboxx), frame, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(father), "frame_col", frame);
  hb = table_new(2, 9, FALSE);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), hb);
  g_object_set_data(G_OBJECT(father), "table_col", hb);
  table_set_row_spacings(hb, 4);
  table_set_col_spacings(hb, 4);

  frame = NEW_FRAME("Contact colours ");
  gtk_box_pack_start (GTK_BOX (vboxx), frame, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(father), "frame_con", frame);
  hb = table_new(1, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), hb);
  g_object_set_data(G_OBJECT(father), "table_con", hb);
  table_set_col_spacings(hb, 20);
  fill_contact_table(father);
  gtk_widget_show_all(hboxx1);
}

void PagePolyhedra(GtkWidget *vboxx, GtkWidget *father)
{
  GtkWidget *frame = gen_strutt(father, 1, vboxx);
  g_object_set_data(G_OBJECT(father), "frame_polyhedra", frame);
}

void PageDrawing(GtkWidget *vbox1,  GtkWidget *father)
{
  const char *strings[] = {"Black", "White", "Flat Color", 
                           "Horizontal Gradient","Vertical Gradient",
                           "Diagonal Gradient" , "Radial Gradient"};
  int nitems =  (int) (sizeof(strings)/sizeof(strings[0]));
#ifndef USE_CAIRO_TEXTURES
  nitems = 6;
#endif
  GtkWidget *table = table_new(6, 3, FALSE);
#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  GtkWidget *align = gtk_alignment_new(0., 0., 0., 0.);
#endif
  gtk_box_pack_start(GTK_BOX(vbox1), align, TRUE, TRUE, 10);
  gtk_container_add(GTK_CONTAINER(align), table);
  table_set_row_spacings(table, 16);
  table_set_col_spacings(table, 20);
  GtkWidget *check = LABEL_NEW ("Background: ", MyBLUE);
  set_alignment(check, 0, 0.5);
  table_attach(table, check, 0, 1, BG, BG+1, TRUE);
  check = LABEL_NEW ("Cell Axes: ", MyBLUE);
  set_alignment(check, 0, 0.5);
  table_attach(table, check, 0, 1, AXES, AXES+1, TRUE);
  check = LABEL_NEW ("Cell Edges: ", MyBLUE);
  set_alignment(check, 0, 0.5);
  table_attach(table, check, 0, 1, CELL, CELL+1, TRUE);
  check = LABEL_NEW ("Label Font: ", MyBLUE);
  set_alignment(check, 0, 0.5);
  table_attach(table, check, 0, 1, LABFONT, LABFONT+1, TRUE);
  check = LABEL_NEW ("Label Offset: ", MyBLUE);
  set_alignment(check, 0, 0.5);
  table_attach(table, check, 0, 1, LABPOS, LABPOS+1, TRUE);
  check = LABEL_NEW ("Distances, angles, torsion angles: ", MyBLUE);
  set_alignment(check, 0, 0.5);
  table_attach(table, check, 0, 2, DISTS, DISTS+1, TRUE);
  check = LABEL_NEW ("Clip: ", MyBLUE);
  set_alignment(check, 0, 0.5);
  table_attach(table, check, 0, 1, CLIPPING, CLIPPING+1, TRUE);
  check = LABEL_NEW ("Fog: ", MyBLUE);
  set_alignment(check, 0, 0.5);
  table_attach(table, check, 0, 1, FOG, FOG+1, TRUE);

  int hnd;
  GtkWidget *cb = font_button("monospace 8");
  table_attach(table, cb, 1, 2, LABFONT, LABFONT+1, TRUE);
  g_object_set_data(G_OBJECT(father), "labfont", cb);
#ifdef GTK_FONT_BUTTON
  hnd = g_signal_connect(G_OBJECT(cb), "font-set", G_CALLBACK(ChangedFont), GINT_TO_POINTER(LABFONT));
  g_object_set_data(G_OBJECT(cb), "hnd", GINT_TO_POINTER(hnd));
#endif

  GtkWidget *combobg = MRcombo_new(strings, selection_cb, 0, nitems);
  g_object_set_data(G_OBJECT(father), "bgtype", combobg);
  table_attach(table, combobg, 1, 2, BG, BG+1, TRUE);

  GtkWidget *spin  = SPIN_WITH_LABEL("x: ", NULL, -1.5f, 1.5f, 0.5f, 0.01, 2);
  g_object_set_data(G_OBJECT(father), "xoff", get_widget(spin, "spin"));
  table_attach(table, spin, 1, 2, LABPOS, LABPOS+1, TRUE);
  hnd = g_signal_connect(G_OBJECT(get_widget(spin, "spin")), "value-changed", G_CALLBACK(on_change_offset), GINT_TO_POINTER(1));
  g_object_set_data(G_OBJECT(get_widget(spin, "spin")), "hnd", GINT_TO_POINTER(hnd));

  check = CHECK_BUTTON_WITH_LABEL ("Visible", NULL);
  table_attach(table, check, 1, 2, AXES, AXES+1, TRUE);
  g_object_set_data(G_OBJECT(father), "axescheck", check);

  check = CHECK_BUTTON_WITH_LABEL ("Visible", NULL);
  table_attach(table, check, 1, 2, CELL, CELL+1, TRUE);
  g_object_set_data(G_OBJECT(father), "cellcheck", check);

  check = CHECK_BUTTON_WITH_LABEL ("Enable", NULL);
  g_object_set_data(G_OBJECT(father), "clipcheck", check);
  table_attach(table, check, 1, 2, CLIPPING, CLIPPING+1, TRUE);
  hnd = g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(ChangedVis), GINT_TO_POINTER(CLIPPING));
  g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));

  check = CHECK_BUTTON_WITH_LABEL ("Enable", NULL);
  g_object_set_data(G_OBJECT(father), "fogcheck", check);
  table_attach(table, check, 1, 2, FOG, FOG+1, TRUE);
  hnd = g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(ChangedVis), GINT_TO_POINTER(FOG));
  g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));

  GtkWidget *hbox = hbox_new(TRUE, 0); 
  table_attach(table, hbox, 2, 3, BG, BG+1, TRUE);
  const float colore[] = {1, 1, 1, 1};
  for(int i=0; i<3; i++)
  {
      cb = color_button(colore, "Pick a color to be used for background");
      gtk_box_pack_start(GTK_BOX(hbox), cb, FALSE, FALSE, 0);
      std::stringstream nome;
      nome << "bgcolor" << i;
      g_object_set_data(G_OBJECT(father), nome.str().c_str(), cb);
      int cbdata = BG1+i-1;
      if(i == 0)
         cbdata = i;
#ifdef GTK_COLOR_BUTTON
      g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(ChangedColor), GINT_TO_POINTER(cbdata));
#else
      g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(ChangedColor), GINT_TO_POINTER(cbdata));
#endif
  }

  check = get_widget(father, "axescheck");
  cb = color_button(colore, "Pick a color to be used for drawing cell axes");
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  align = gtk_alignment_new(0., 0., 0., 0.);
#endif
  gtk_container_add(GTK_CONTAINER(align), cb);
//  table_attach(table, align, 2, 3, AXES, AXES+1, TRUE);
  g_object_set_data(G_OBJECT(father), "axescolor", cb);
#ifdef GTK_COLOR_BUTTON
  g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(ChangedColor), GINT_TO_POINTER(AXES));
#else
  g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(ChangedColor), GINT_TO_POINTER(AXES));
#endif
  gtk_widget_set_sensitive(cb , FALSE);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), cb);
  hnd = g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(ChangedVis), GINT_TO_POINTER(AXES));
  g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));

  check = get_widget(father, "cellcheck");
  cb = color_button(colore, "Pick a color to be used for drawing cell edges");
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  align = gtk_alignment_new(0., 0., 0., 0.);
#endif
  table_attach(table, align, 2, 3, CELL, CELL+1, TRUE);
  gtk_container_add(GTK_CONTAINER(align), cb);
  g_object_set_data(G_OBJECT(father), "cellcolor", cb);
#ifdef GTK_COLOR_BUTTON
  g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(ChangedColor), GINT_TO_POINTER(CELL));
#else
  g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(ChangedColor), GINT_TO_POINTER(CELL));
#endif
  gtk_widget_set_sensitive(cb , FALSE);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), cb);
  hnd = g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(ChangedVis), GINT_TO_POINTER(CELL));
  g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));

//NEW
  GtkWidget *check2 = CHECK_BUTTON_WITH_LABEL ("Display in cell", NULL);
  table_attach(table, check2, 2, 3, AXES, AXES+1, TRUE);
  g_object_set_data(G_OBJECT(father), "axesdrawcheck", check2);
  gtk_widget_set_sensitive(check2 , FALSE);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), check2);
  hnd = g_signal_connect(G_OBJECT(check2), "toggled", G_CALLBACK(ChangedVis), GINT_TO_POINTER(DRAWAXES));
  g_object_set_data(G_OBJECT(check2), "hnd", GINT_TO_POINTER(hnd));

//END NEW




  check = get_widget(father, "clipcheck");
  spin = SPIN_NEW(0, 1, 1, 0.05, 2);
  g_object_set_data(G_OBJECT(father), "clipspin", spin);
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  align = gtk_alignment_new(0., 0., 0., 0.);
#endif
  table_attach(table, align, 2, 3, CLIPPING, CLIPPING+1, TRUE);
  gtk_container_add(GTK_CONTAINER(align), spin);
  gtk_widget_set_sensitive(spin , FALSE);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), spin);
  hnd = g_signal_connect(G_OBJECT(spin), "value-changed", G_CALLBACK(ChangedVal), GINT_TO_POINTER(CLIPPING));
  g_object_set_data(G_OBJECT(spin), "hnd", GINT_TO_POINTER(hnd));

  check = get_widget(father, "fogcheck");
  spin = SPIN_NEW(0, 2, 0.3, 0.05, 2);
  g_object_set_data(G_OBJECT(father), "fogspin", spin);
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  align = gtk_alignment_new(0., 0., 0., 0.);
#endif
  table_attach(table, align, 2, 3, FOG, FOG+1, TRUE);
  gtk_container_add(GTK_CONTAINER(align), spin);
  gtk_widget_set_sensitive(spin , FALSE);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), spin);
  hnd = g_signal_connect(G_OBJECT(spin), "value-changed", G_CALLBACK(ChangedVal), GINT_TO_POINTER(FOG));
  g_object_set_data(G_OBJECT(spin), "hnd", GINT_TO_POINTER(hnd));

  cb = color_button(colore, "Pick a color to be used for drawing distances, angles and torsion angles");
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  align = gtk_alignment_new(0., 0., 0., 0.);
#endif
  gtk_container_add(GTK_CONTAINER(align), cb);
  table_attach(table, align, 2, 3, DISTS, DISTS+1, TRUE);
  g_object_set_data(G_OBJECT(father), "infoscolor", cb);
#ifdef GTK_COLOR_BUTTON
  g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(ChangedColor), GINT_TO_POINTER(DISTS));
#else
  g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(ChangedColor), GINT_TO_POINTER(DISTS));
#endif
  spin  = SPIN_WITH_LABEL("y: ", NULL, -1.5f, 1.5f, -0.5f, 0.01, 2);
  g_object_set_data(G_OBJECT(father), "yoff", get_widget(spin, "spin"));
  table_attach(table, spin, 2, 3, LABPOS, LABPOS+1, TRUE);
  hnd = g_signal_connect(G_OBJECT(get_widget(spin, "spin")), "value-changed", G_CALLBACK(on_change_offset), GINT_TO_POINTER(2));
  g_object_set_data(G_OBJECT(get_widget(spin, "spin")), "hnd", GINT_TO_POINTER(hnd));
}

void PageDisplay(GtkWidget *vbox1,  GtkWidget *father)
{
  const char *line_stipples[] = {"Continuous",
                                 "Dashed    ",
                                 "Dotted    ",
                                 "Dash/Dot  "};
  const int nstipples = (int) (sizeof(line_stipples)/sizeof(line_stipples[0]));
   if(!GLWINDOW)
      return;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

#ifndef HAVE_ADVANCED
  GtkWidget *frame1 = AAFrame(father);
  gtk_box_pack_start(GTK_BOX(vbox1), frame1, FALSE, FALSE, 10);
#endif
  GtkWidget *frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, TRUE, TRUE, 4);
  GtkWidget *fw = CHECK_BUTTON_WITH_LABEL ("View Grid", MyBLUE);
  gtk_frame_set_label_widget(GTK_FRAME(frame), fw);
  g_object_set_data(G_OBJECT(father), "ifgrid", fw);
  GtkWidget *vbox2 = hbox_new(TRUE, 0); 
  gtk_container_add(GTK_CONTAINER(frame), vbox2);
  gtk_widget_set_sensitive(vbox2, FALSE);
  g_signal_connect(G_OBJECT(fw), "toggled", G_CALLBACK(on_cb_attiva), vbox2);
  int hnd = g_signal_connect(G_OBJECT(fw), "toggled", G_CALLBACK(ChangedVis), GINT_TO_POINTER(GRID));
  g_object_set_data(G_OBJECT(fw), "hnd", GINT_TO_POINTER(hnd));
  GtkWidget *spin  = SPIN_WITH_LABEL("Nr. of grid divisions: ", NULL, 1, 40, gl->nDivisions, 1, 0);
  g_object_set_data(G_OBJECT(father), "grid_d", get_widget(spin, "spin"));
  gtk_container_set_border_width(GTK_CONTAINER(spin), 4);
  gtk_box_pack_start(GTK_BOX(vbox2), spin,TRUE, TRUE, 2);
  hnd = g_signal_connect(G_OBJECT(get_widget(spin, "spin")), "value-changed", G_CALLBACK(on_change_divisions), NULL);
  g_object_set_data(G_OBJECT(get_widget(spin, "spin")), "hnd", GINT_TO_POINTER(hnd));
#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
  GtkWidget *align = gtk_alignment_new(0, 0.5, 0, 0);
#endif
#ifdef GTK_COMBO_BOX
  GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, GDK_TYPE_PIXBUF);
  GtkTreeIter iter;
  GdkPixbuf *stipples[nstipples];
  gtk_list_store_clear(store);
  for(int i=0; i<nstipples; i++)
  {
      stipples[i] = create_pixbuf(g_strdup_printf("ls%d.png", i+1));
      gtk_list_store_append (store, &iter);
      gtk_list_store_set (store, &iter, 0, line_stipples[i],
                                        1, stipples[i],-1);
  }
  GtkTreeModel *model = GTK_TREE_MODEL(store);

  GtkWidget *combo = gtk_combo_box_new_with_model(model);
  GtkCellRenderer *cell = gtk_cell_renderer_text_new ();
  gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (combo),
                                    cell, TRUE);
  gtk_cell_layout_add_attribute (GTK_CELL_LAYOUT (combo), cell,
                                        "text", 0);
  cell = gtk_cell_renderer_pixbuf_new ();
  gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (combo),
                                    cell, TRUE);
  gtk_cell_layout_add_attribute (GTK_CELL_LAYOUT (combo), cell,
                                        "pixbuf", 1);

  gtk_container_add(GTK_CONTAINER(align), combo);
  GtkWidget *hbox = hbox_new(FALSE, 0);
  GtkWidget *label = LABEL_NEW("Line style: ", NULL);
  set_alignment (label, 0.0, 0.5);
  gtk_box_pack_start(GTK_BOX(hbox), label,FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), align,FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(vbox2), hbox,TRUE, TRUE, 2);
  hnd = g_signal_connect(G_OBJECT(combo), "changed", G_CALLBACK(on_select_linestyle), NULL);
  g_object_set_data(G_OBJECT(combo), "hnd", GINT_TO_POINTER(hnd));
#else
  const char *old_line_stipples[] = {"Continuous _________",
                                 "Dashed     _ _ _ _ _",
                                 "Dotted     . . . . .",
                                 "Dash/Dot   _._._._._"};

  GtkWidget *combo = create_combo (NULL, old_line_stipples, nstipples, 2, NULL, G_CALLBACK(on_select_linestyle));
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(combo, "entry")), FALSE);
  set_widget_fontN(combo);
  gtk_container_add(GTK_CONTAINER(align), get_widget(combo, "parent"));
#endif
  g_object_set_data(G_OBJECT(father), "line_s", combo);

  frame = FRAME_NEW ("Projection type", MyBLUE);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, TRUE, TRUE, 4);
  hbox = hbox_new(TRUE, 2);
  gtk_container_add(GTK_CONTAINER(frame), hbox);
  GSList *proj_group = NULL;
  for(int i=0; i<2; i++)
  {
      std::string name1 = projection[i];
      GtkWidget *radio = RADIO_BUTTON_WITH_LABEL(proj_group, projection[i], NULL);
      proj_group =  gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      g_object_set_data(G_OBJECT(father), name1.c_str(), radio);
      gtk_box_pack_start(GTK_BOX(hbox), radio, TRUE, TRUE, 2);
      hnd = g_signal_connect(G_OBJECT(radio), "toggled", G_CALLBACK(ChangedVis), GINT_TO_POINTER(i+PROJECTION));
      g_object_set_data(G_OBJECT(radio), "hnd", GINT_TO_POINTER(hnd));
  }


  frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, TRUE, TRUE, 4);
  fw = CHECK_BUTTON_WITH_LABEL ("View 3D (available only for black or white background)", MyBLUE);
  gtk_frame_set_label_widget(GTK_FRAME(frame), fw);
  int num_rows = (GLASSES_TYPES-1)/2 + 1;
  GtkWidget *table = table_new(num_rows, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(frame), table);
  gtk_widget_set_sensitive(table, FALSE);
  g_signal_connect(G_OBJECT(fw), "toggled", G_CALLBACK(on_cb_attiva), table);
  hnd = g_signal_connect(G_OBJECT(fw), "toggled", G_CALLBACK(ChangedVis), GINT_TO_POINTER(TRED));
  g_object_set_data(G_OBJECT(fw), "hnd", GINT_TO_POINTER(hnd));
  GSList *glass_group = NULL;
  for(int i=0; i<GLASSES_TYPES; i++)
  {
      std::string name1 = glasses[i];
      GtkWidget *radio = RADIO_BUTTON_WITH_LABEL(glass_group, glasses[i], NULL);
      glass_group =  gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      g_object_set_data(G_OBJECT(father), name1.c_str(), radio);
      table_attach(table, radio, i/2, i/2 +1, i%2, i%2+1, TRUE);
      hnd = g_signal_connect(G_OBJECT(radio), "toggled", G_CALLBACK(on_toggle_filter), GINT_TO_POINTER(i));
      g_object_set_data(G_OBJECT(radio), "hnd", GINT_TO_POINTER(hnd));
  }
  g_object_set_data(G_OBJECT(father), "if3d", fw);
}

void PageLighting(GtkWidget *vbox1,  GtkWidget *father)
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  float color[4];

  for(int i=1; i<=2; i++)
  {
      std::string prefix = g_strdup_printf("Light %d", i);
      GtkWidget *frame = NEW_FRAME(prefix.c_str());
      gtk_box_pack_start(GTK_BOX(vbox1), frame, FALSE, FALSE, 2);
      GtkWidget *table = table_new(3, 4, FALSE);
      table_set_row_spacings(table, 10);
      table_set_col_spacings(table, 10);
      gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), table);
      std::string nome = prefix + "check";
      GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Enabled", NULL);
      g_object_set_data(G_OBJECT(father), nome.c_str(), check);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check),
          gl->lightInfo[JAV_LIGHT0+i-1].enabled);
      int hnd = g_signal_connect(G_OBJECT(check), "toggled",
          G_CALLBACK(toggle_light), GINT_TO_POINTER(i));
      g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));
      table_attach(table, check, 0, 1, 0, 1);
      GtkWidget *label = LABEL_NEW("Diffuse colour:", NULL);
      set_alignment(label, 0, 0.5f);
      table_attach(table, label, 0, 1, 1, 2);
      memcpy(color, gl->lightInfo[JAV_LIGHT0+i-1].diffuse, 4*sizeof(float));
      nome.assign(prefix + " diffuse");
      GtkWidget *cb = color_button(color, nome.c_str());
      g_object_set_data(G_OBJECT(father), nome.c_str(), cb);
      table_attach(table, cb, 1, 2, 1, 2);
#ifdef GTK_COLOR_BUTTON
       g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(ChangedLight), GINT_TO_POINTER(100*i+1));
#else
       g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(ChangedLight), GINT_TO_POINTER(100*i+1));
#endif

      nome.assign(prefix + " specular");
      label = LABEL_NEW("Specular colour:", NULL);
      set_alignment(label, 0, 0.5f);
      table_attach(table, label, 2, 3, 1, 2);
      memcpy(color, gl->lightInfo[JAV_LIGHT0+i-1].specular, 4*sizeof(float));
      cb = color_button(color, nome.c_str());
      g_object_set_data(G_OBJECT(father), nome.c_str(), cb);
#ifdef GTK_COLOR_BUTTON
       g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(ChangedLight), GINT_TO_POINTER(100*i+2));
#else
       g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(ChangedLight), GINT_TO_POINTER(100*i+2));
#endif
      table_attach(table, cb, 3, 4, 1, 2);
      label = LABEL_NEW("Position", NULL);
      set_alignment(label, 0, 0.5f);
      table_attach(table, label, 0, 1, 2, 3);
      nome.assign(prefix + "x");
      GtkWidget *spin = SPIN_WITH_LABEL("x:", NULL, -10.f, 10.f,
            gl->lightInfo[JAV_LIGHT0+i-1].position[0], 0.1f, 2);
      table_attach(table, spin, 1, 2, 2, 3);
      g_object_set_data(G_OBJECT(father), nome.c_str(), get_widget(spin, "spin"));
      hnd = g_signal_connect(G_OBJECT(get_widget(spin, "spin")),"value-changed",
                   G_CALLBACK(on_change_xl), GINT_TO_POINTER(100*i+1));
      g_object_set_data(G_OBJECT(get_widget(spin, "spin")), "hnd",
               GINT_TO_POINTER(hnd));
      nome.assign(prefix + "y");
      spin = SPIN_WITH_LABEL("y:", NULL, -10.f, 10.f, 
            gl->lightInfo[JAV_LIGHT0+i-1].position[1], 0.1f, 2);
      g_object_set_data(G_OBJECT(father), nome.c_str(), get_widget(spin, "spin"));
      hnd = g_signal_connect(G_OBJECT(get_widget(spin, "spin")),"value-changed",
                   G_CALLBACK(on_change_xl), GINT_TO_POINTER(100*i+2));
      g_object_set_data(G_OBJECT(get_widget(spin, "spin")), "hnd",
               GINT_TO_POINTER(hnd));
      table_attach(table, spin, 2, 3, 2, 3);
      nome.assign(prefix + "z");
      spin = SPIN_WITH_LABEL("z:", NULL, -10.f, 10.f, 
            gl->lightInfo[JAV_LIGHT0+i-1].position[2], 0.1f, 2);
      g_object_set_data(G_OBJECT(father), nome.c_str(), get_widget(spin, "spin"));
      hnd = g_signal_connect(G_OBJECT(get_widget(spin, "spin")),"value-changed",
                   G_CALLBACK(on_change_xl), GINT_TO_POINTER(100*i+3));
      g_object_set_data(G_OBJECT(get_widget(spin, "spin")), "hnd",
               GINT_TO_POINTER(hnd));
      table_attach(table, spin, 3, 4, 2, 3);
  }
  {
      GtkWidget *frame = NEW_FRAME("Ambient light");
      gtk_box_pack_start(GTK_BOX(vbox1), frame, FALSE, FALSE, 2);
      GtkWidget *table = table_new(2, 4, FALSE);
      table_set_row_spacings(table, 10);
      table_set_col_spacings(table, 10);
      gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), table);
      GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Enabled", NULL);
      g_object_set_data(G_OBJECT(father), "ambient_check", check);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check),
          gl->lightInfo[JAV_AMBIENT].enabled);
      int hnd = g_signal_connect(G_OBJECT(check), "toggled",
          G_CALLBACK(toggle_light), GINT_TO_POINTER(3));
      g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));
      table_attach(table, check, 0, 1, 0, 1);
      GtkWidget *label = LABEL_NEW("Diffuse colour:", NULL);
      set_alignment(label, 0, 0.5f);
      table_attach(table, label, 0, 1, 1, 2);
      memcpy(color, gl->lightInfo[JAV_AMBIENT].diffuse, 4*sizeof(float));
      GtkWidget *cb = color_button(color, "Ambient light");
      g_object_set_data(G_OBJECT(father), "ambient_light", cb);
#ifdef GTK_COLOR_BUTTON
       g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(ChangedLight), GINT_TO_POINTER(301));
#else
       g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(ChangedLight), GINT_TO_POINTER(301));
#endif
      table_attach(table, cb, 1, 2, 1, 2);
  } 
}

void PageAdvanced(GtkWidget *vbox1,  GtkWidget *father)
{
  GtkWidget *entry = entry_for_filesel(vbox1, "Internet Browser:", "ib", 0, 1);
  GtkWidget *Btn = get_widget(entry, "browse");
  g_signal_connect (G_OBJECT(Btn), "clicked", G_CALLBACK (set_browser), entry);
  gtk_entry_set_text(GTK_ENTRY(entry), main_app::JavApp.InternetBrowser().c_str());

  GtkWidget *frame = NEW_FRAME("Compute normals");
  gtk_box_pack_start(GTK_BOX(vbox1), frame, FALSE, FALSE, 10);
  GSList *group = NULL;
  GtkWidget *hbox = hbox_new(TRUE, 0);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), hbox);
  GtkWidget *radio = gtk_radio_button_new_with_label (group, "Per face");
  g_object_set_data(G_OBJECT(father), "nperf", radio);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  gtk_box_pack_start (GTK_BOX (hbox), radio, TRUE, TRUE, 0);
  radio = gtk_radio_button_new_with_label (group, "Per vertex");
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  g_object_set_data(G_OBJECT(father), "nperv", radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, TRUE, TRUE, 10);
  int hnd =  g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback) on_change_norm, NULL);
  g_object_set_data(G_OBJECT(radio), "hnd", GINT_TO_POINTER(hnd));

#ifdef HAVE_ADVANCED
  frame = AAFrame(father);
  gtk_box_pack_start(GTK_BOX(vbox1), frame, FALSE, FALSE, 10);
#endif

  const char *message = "If you experience any trouble with OpenGL, you can\n"
                        "try turning on some of the following features.";
  GtkWidget *label = NEW_FRAME(message);
  gtk_box_pack_end(GTK_BOX(vbox1), label, FALSE, FALSE, 10);
  hbox = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(get_widget(label, "align")), hbox);
  GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Disable line smooth", NULL);
  g_object_set_data(G_OBJECT(father), "smooth", check);
  gtk_box_pack_start (GTK_BOX (hbox), check, TRUE, TRUE, 0);
  hnd = g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_toggle_smooth), NULL);
  g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));
#ifdef HAVE_ADVANCED
  check = CHECK_BUTTON_WITH_LABEL ("Disable hardware rendering", NULL);
  g_object_set_data(G_OBJECT(father), "softrend", check);
  gtk_box_pack_start (GTK_BOX (hbox), check, TRUE, TRUE, 0);
  hnd = g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_toggle_softrend), NULL);
  g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));
#endif
}

void poly_col(GtkWidget *, int val)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   Model m = ModelInfo[whichModel];
   if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, SettingsWindow);
      GtkWidget *cb  = get_widget(dlg, "polycolor");
      float color[4];
      color_button_get_color(cb, color);
      for(int i=0; i<4; i++)
          m.PolyStyle[val].colore[i] = color[i];
      gl->Redraw();
   }
}

void edges_col(GtkWidget *, int val)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   Model m = ModelInfo[whichModel];
   if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, SettingsWindow);
      GtkWidget *cb  = get_widget(dlg, "edgescolor");
      float color[4];
      color_button_get_color(cb, color);
      for(int i=0; i<4; i++)
          m.PolyStyle[val].Bcolore[i] = color[i];
      gl->Redraw();
   }
}

void default_preferences(GtkWidget *, gpointer data)
{
  GtkWidget *window = (GtkWidget *) data;
  main_app::JavApp.ResettaPalette();
  RecuperaDati(window, &DefaultValuesForP);
}

void ok_preferences(GtkWidget *button, gpointer data)
{
  main_app::JavApp.WritePalette();
#ifndef JAV
  main_app::JavApp.UpdatePS(ModelInfo[0].plotStyle);
#endif
  chiudi_dlg(button, data);
}

void close_preferences(GtkWidget *button, gpointer data)
{
// restore previous values
  RecuperaDati(GLWINDOW);
  chiudi_dlg(button, data);
}

void FillDefaultsPreferences(GtkWidget *, _SaveStruct *DefaultValues)
{
  DefaultValues->sc_atoms = 1.;
  for(int i=0; i<N_ELEMENTS; i++)
      DefaultValues->scale_atoms[i] = 1;
  DefaultValues->sc_bonds = sc_bonds0;
  if(defaultCell >= 0)
     DefaultValues->ifCell = (defaultCell != 0);
  else
     DefaultValues->ifCell = false;
  memcpy(DefaultValues->CellColor, main_app::JavApp.getdefCol(CELLC), 3*sizeof(float));
  DefaultValues->ifAxes = 1;
  DefaultValues->ifDrawAxes = 1;
  DefaultValues->ShowMultBonds = false;
  DefaultValues->BgType = main_app::JavApp.DefBg;
  DefaultValues->MSEnabled = main_app::JavApp.IsMSEnabled();
  DefaultValues->MSBuffers = main_app::JavApp.MSBuffers();
  memcpy(DefaultValues->DistColor, main_app::JavApp.getdefCol(INFOS), 3*sizeof(float));
  memcpy(DefaultValues->AxesColor, main_app::JavApp.getdefCol(AXESC), 3*sizeof(float));
  memcpy(DefaultValues->BgColor, main_app::JavApp.getdefCol(BGC), 4*sizeof(float));
  memcpy(DefaultValues->BgColor1, main_app::JavApp.getdefCol(BGC+1), 4*sizeof(float));
  memcpy(DefaultValues->BgColor2, main_app::JavApp.getdefCol(BGC+2), 4*sizeof(float));
  memcpy(DefaultValues->ColorHB, main_app::JavApp.getdefCol(HBC), 4*sizeof(float));
  memcpy(DefaultValues->ColorSC, main_app::JavApp.getdefCol(SCC), 4*sizeof(float));
  DefaultValues->ifOrtho = true;
  DefaultValues->ifGrid = false;
  DefaultValues->Clip = false;
  DefaultValues->fog  = false;
  DefaultValues->ClipFactor = 1;
  DefaultValues->FogDensity = 0.3f;
  DefaultValues->nDivisions = 5;
  DefaultValues->GridPattern = 0x00FF;
  DefaultValues->Stereo = false;
  DefaultValues->glasses_type = REDBLUE;
  DefaultValues->smooth = true;
  DefaultValues->ell_tr = 0;
  DefaultValues->RadType = 0;
  DefaultValues->strInternetBrowser = g_strdup(GetBrowser());
  DefaultValues->fontname = 
     DuplicaStringa( main_app::JavApp.FontP().c_str());
  DefaultValues->xoffset = 0.5f;
  DefaultValues->yoffset = -0.5f;
  for(int k=0; k<NUM_COLORS;k++)
      memcpy(DefaultValues->icolorSave[k], main_app::JavApp.getdefCol(k+N_OBJS), 4*sizeof(float));

  for(int i=0; i<MAX_NUM_MODELS; i++)
  {
        DefaultValues->model_info[i].ifVis = true;
        if((defaultPlotStyle >= 0) && (defaultPlotStyle < POLYPEPTIDE))
           DefaultValues->model_info[i].plotStyle = defaultPlotStyle;
        else
           DefaultValues->model_info[i].plotStyle = STICK_AND_BALLS;
        if(defaultLabels >= 0)
           DefaultValues->model_info[i].ifLabels = (defaultLabels != 0);
        else
           DefaultValues->model_info[i].ifLabels = false;
        DefaultValues->model_info[i].drawLigand = -1;
        DefaultValues->model_info[i].ifSymmetry = false;
        DefaultValues->model_info[i].klevel[0] = 0.1f;
        DefaultValues->model_info[i].klevel[1] = 0.1f;
        DefaultValues->model_info[i].klevel[2] = 0.1f;
        DefaultValues->model_info[i].FitOpt = 1;
        DefaultValues->model_info[i].ifDrawH = 1;
        DefaultValues->model_info[i].ifDrawW = 0;
        DefaultValues->model_info[i].colorMode = 0;
        DefaultValues->model_info[i].nPolyStyles = ModelInfo[i].nPolyStyles;
        DefaultValues->model_info[i].ifSurface = false;
        memcpy(DefaultValues->model_info[i].labelcolor,
               ModelInfo[i].labelcolor, 4*sizeof(float));
        DefaultValues->model_info[i].PolyStyle = g_new0(polyhedron_style,
               ModelInfo[i].nPolyStyles);
        for(int k=0; k<ModelInfo[i].nPolyStyles; k++)
        {
            memcpy(&DefaultValues->model_info[i].PolyStyle[k],
                   &ModelInfo[i].PolyStyle[k], sizeof(polyhedron_style));
            int index1  = ModelInfo[i].atm_au[ModelInfo[i].PolyStyle[k].vert].Z-1;
            index1 = index1 + N_OBJS;
            memcpy(DefaultValues->model_info[i].PolyStyle[k].colore, main_app::JavApp.getdefCol(index1), 4*sizeof(float));
            memcpy(DefaultValues->model_info[i].PolyStyle[k].Bcolore, main_app::JavApp.getdefCol(index1), 4*sizeof(float));
            TuneHSV( DefaultValues->model_info[i].PolyStyle[k].Bcolore, 0.2f);
            DefaultValues->model_info[i].PolyStyle[k].line_width = 1.5f;
        }
  }
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
#ifdef MAPS
    for(int i=0; i<MAX_NUM_MAPS; i++)
    {
        DefaultValues->map_info[i].ifVis = true;
        DefaultValues->map_info[i].iso = (float) 1.5 * MapInfo[i].sigma;
        int index_color = i;
        for(int nf=0; nf < MapInfo[i].ifDifference ; nf++)
        {
            int k = i+nf*MAX_NUM_MAPS;
            if(MapInfo[k].ifDifference == 2)
               index_color = MAX_NUM_MAPS;
            else if(MapInfo[k].ifDifference == 3)
               index_color = MAX_NUM_MAPS + 1;
            DefaultValues->map_info[k].wireframe = 0;
            memcpy(DefaultValues->map_info[k].color_mappa,
               colorimappa[index_color], 4*sizeof(float));
        }
    }
    for(int i=0; i<MAX_NUM_MODELS; i++)
    {
        DefaultValues->surf_info[i].ifVis = false;
        DefaultValues->surf_info[i].iso = 1;
        DefaultValues->surf_info[i].wireframe = 0;
        DefaultValues->surf_info[i].radius = 1.2f;
        DefaultValues->surf_info[i].step = 0.3f;
        memcpy(DefaultValues->surf_info[i].color_mappa,
               colorimappa[i], 4*sizeof(float));
    }
    DefaultValues->Radius = raggioMappa;
    DefaultValues->ifWhole = false;
    for(int j=0; j<3; j++)
    {
        if(gl->nModels && !defCentro) // && !gl->nMaps)
            DefaultValues->xyzC.v[j] = ModelInfo[0].baricentro[j];
        else
            DefaultValues->xyzC.v[j] = centroMappa[j];
    }
#endif
    gl->DefaultLights(DefaultValues->lightInfo);
    DefaultValues->normalToV = gl->normalToV;
}

//NEW

static GtkWidget *AppendPage(GtkNotebook *notebook, const gchar *label,
                 const gchar *icon, GtkTreeStore *tree, GtkTreeIter *parent,
                 GtkTreeIter *iter, gint pagenum)
{
  GtkWidget *vbox = vbox_new (FALSE, 12);
  gtk_widget_show (vbox);
  gtk_notebook_append_page (notebook, vbox, NULL);
  GdkPixbuf *pixbuf, *small_pix;

  pixbuf = create_pixbuf (icon);
  small_pix = gdk_pixbuf_scale_simple(pixbuf, 24, 24, GDK_INTERP_BILINEAR);

  gtk_tree_store_append (tree, iter, parent);
  gtk_tree_store_set (tree, iter,
                      0, small_pix,
                      1, label,
                      2, pagenum,
                      3, label,
                      4, pixbuf,
                      -1);
  if (pixbuf)
    g_object_unref (pixbuf);
  if (small_pix)
    g_object_unref (small_pix);

  return vbox;
}

static void notebook_page_callback (GtkNotebook *notebook, gpointer page,
                                 guint page_num, GtkTreeSelection *sel)
{
  GtkTreeView  *view;
  GtkTreeModel *model;
  GtkTreeIter   iter;
  gboolean      iter_valid;

  view  = gtk_tree_selection_get_tree_view (sel);
  model = gtk_tree_view_get_model (view);

  for (iter_valid = gtk_tree_model_get_iter_first (model, &iter);
       iter_valid;
       iter_valid = gtk_tree_model_iter_next (model, &iter))
    {
      guint index;

      gtk_tree_model_get (model, &iter, 2, &index, -1);

      if (index == page_num)
        {
          gtk_tree_selection_select_iter (sel, &iter);
          return;
        }
      if (gtk_tree_model_iter_has_child (model, &iter))
        {
          gint num_children;
          gint i;

          num_children = gtk_tree_model_iter_n_children (model, &iter);

          for (i = 0; i < num_children; i++)
            {
              GtkTreeIter child_iter;

              gtk_tree_model_iter_nth_child (model, &child_iter, &iter, i);
              gtk_tree_model_get (model, &child_iter, 2, &index, -1);

              if (index == page_num)
                {
                  GtkTreePath *path;

                  path = gtk_tree_model_get_path (model, &child_iter);
                  gtk_tree_view_expand_to_path (view, path);
                  gtk_tree_selection_select_iter (sel, &child_iter);
                  return;
                }
            }
        }
    }
}

static void tree_select_callback (GtkTreeSelection *sel, GtkNotebook *notebook)
{
  GtkWidget    *label;
  GtkWidget    *image;
  GtkTreeModel *model;
  GtkTreeIter   iter;
  gchar        *text;
  GdkPixbuf    *pixbuf;
  gint          page;

  if (! gtk_tree_selection_get_selected (sel, &model, &iter))
    return;

  label = get_widget (GTK_WIDGET (notebook), "label");
  image = get_widget (GTK_WIDGET (notebook), "image");

  gtk_tree_model_get (model, &iter,
                      3, &text,
                      4, &pixbuf,
                      2, &page,
                      -1);

  gtk_label_set_text (GTK_LABEL (label), text);
  g_free (text);

  gtk_image_set_from_pixbuf (GTK_IMAGE (image), pixbuf);
  if (pixbuf)
    g_object_unref (pixbuf);

  int hnd = get_int(GTK_WIDGET(notebook), "hnd");
  g_signal_handler_block(G_OBJECT(notebook), hnd);
  gtk_notebook_set_current_page (GTK_NOTEBOOK (notebook), page);
  g_signal_handler_unblock(G_OBJECT(notebook), hnd);
}

GtkWidget *create_advanced(gpointer data)
{
   if(!GLWINDOW)
      return NULL;
  SalvaDati(GLWINDOW);
  FillDefaultsPreferences(GLWINDOW, &DefaultValuesForP);
  GtkWidget *window = (GtkWidget *) data;
  GtkWidget *dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "Preferences");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
 
  GtkWidget *hbox = hbox_new (FALSE, 12);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 12);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox, TRUE, TRUE, 0);
  gtk_widget_show (hbox);

  GtkWidget *frame = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (frame),
                                       GTK_SHADOW_IN);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (frame),
                                  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_box_pack_start (GTK_BOX (hbox), frame, FALSE, FALSE, 0);
  gtk_widget_show (frame);

  GtkTreeStore *tree = gtk_tree_store_new (5,
                             GDK_TYPE_PIXBUF, G_TYPE_STRING,
                             G_TYPE_INT, G_TYPE_STRING, GDK_TYPE_PIXBUF);
  GtkWidget *tv = gtk_tree_view_new_with_model (GTK_TREE_MODEL (tree));
  g_object_unref (tree);
  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (tv), FALSE);

  GtkTreeViewColumn *column = gtk_tree_view_column_new ();

  GtkCellRenderer *cell = gtk_cell_renderer_pixbuf_new ();
  gtk_tree_view_column_pack_start (column, cell, FALSE);
  gtk_tree_view_column_set_attributes (column, cell, "pixbuf", 0, NULL);
  cell = gtk_cell_renderer_text_new ();
  gtk_tree_view_column_pack_start (column, cell, TRUE);
  gtk_tree_view_column_set_attributes (column, cell, "text", 1, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (tv), column);
  gtk_container_add (GTK_CONTAINER (frame), tv);

  GtkWidget *vbox = vbox_new (FALSE, 12);
  gtk_box_pack_start (GTK_BOX (hbox), vbox, TRUE, TRUE, 0);
  gtk_widget_show (vbox);

  GtkWidget *ebox = gtk_event_box_new ();
  widget_set_selected (ebox);
  gtk_box_pack_start (GTK_BOX (vbox), ebox, FALSE, TRUE, 0);
  gtk_widget_show (ebox);

  hbox = hbox_new (FALSE, 6);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 6);
  gtk_container_add (GTK_CONTAINER (ebox), hbox);
  gtk_widget_show (hbox);

  GtkWidget *label = LABEL_BOLD (NULL, NULL, 1.f);
  set_alignment (label, 0.0, 0.5);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
  gtk_widget_show (label);
  GtkWidget *image = gtk_image_new ();
  gtk_box_pack_end (GTK_BOX (hbox), image, FALSE, FALSE, 0);
  gtk_widget_show (image);

  GtkWidget *notebook = gtk_notebook_new ();
  gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook), FALSE);
  gtk_notebook_set_show_border (GTK_NOTEBOOK (notebook), FALSE);
  gtk_box_pack_start (GTK_BOX (vbox), notebook, TRUE, TRUE, 0);
  widget_modify_bg(notebook, GTK_STATE_NORMAL, &colorWhite);   //NEW
  g_object_set_data(G_OBJECT(dialog1), "nb", notebook);
  g_object_set_data (G_OBJECT (notebook), "label", label);
  g_object_set_data (G_OBJECT (notebook), "image", image);
  gtk_widget_show (notebook);

  GtkTreeSelection *sel = gtk_tree_view_get_selection (GTK_TREE_VIEW (tv));
  g_signal_connect (sel, "changed",
                    G_CALLBACK (tree_select_callback),
                    notebook);
  int hnd = g_signal_connect (notebook, "switch-page",
                    G_CALLBACK (notebook_page_callback),
                    sel);
  g_object_set_data (G_OBJECT (notebook), "hnd", GINT_TO_POINTER(hnd));
  gint pagenum = 0;
  GtkTreeIter top_iter;

  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Models ", "model_settings_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
  PageModels(vbox, dialog1);
  gtk_tree_selection_select_iter (sel, &top_iter);
  gchar *pkg = g_ascii_strdown(PACKAGE, -1);

  if(!strstr(pkg, "expo"))
  {
#ifdef MAPS
//  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Centre ", "target_48",
//          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
//  PageCentre(vbox, dialog1);
  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Maps ", "map_settings_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
  PageMaps(vbox, dialog1);
#endif
  }

  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Atoms", "ats_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
  gtk_widget_show_all(vbox);
  PageAtomProp(vbox, dialog1);
  gtk_widget_show_all(vbox);
  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Bonds", "bonds_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
  gtk_widget_show_all(vbox);
  PageBondProp(vbox, dialog1);
  gtk_widget_show_all(vbox);
  if(strstr(pkg, "expo"))
  {
#ifdef MAPS
  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Maps ", "map_settings_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
  PageMaps(vbox, dialog1);
#endif
  }
  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Polyhedra", "pol_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
  PagePolyhedra(vbox, dialog1);
  gtk_widget_show_all(vbox);
  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Drawing Options", "drawing_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
  PageDrawing(vbox, dialog1);
  gtk_widget_show_all(vbox);
  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Display Options", "display_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
  PageDisplay(vbox, dialog1);
  gtk_widget_show_all(vbox);
  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Lighting", "light_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
  PageLighting(vbox, dialog1);
  gtk_widget_show_all(vbox);
#ifdef HAVE_ADVANCED
  vbox = AppendPage(GTK_NOTEBOOK (notebook), "Advanced", "adv_48",
          GTK_TREE_STORE (tree), NULL, &top_iter, pagenum++);
#else
  vbox = vbox_new(FALSE, 0);
#endif
  PageAdvanced(vbox, dialog1);

  gtk_widget_show_all(vbox);
  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = SettingsWindow;

  GtkWidget *button = OK_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_OK);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(ok_preferences), (gpointer) st);
  g_object_set_data(G_OBJECT(dialog1), "okbutton", button);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

  button = DEFAULTS_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_ACCEPT);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(default_preferences), data);
  button = CANCEL_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_CANCEL);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(close_preferences), (gpointer) st);
  g_signal_connect_swapped(G_OBJECT(dialog1), "delete-event", G_CALLBACK(gtk_button_clicked), button);
  gtk_tree_view_expand_all (GTK_TREE_VIEW (tv));
  GtkTreePath *path = gtk_tree_model_get_path (GTK_TREE_MODEL (tree), &top_iter);
  gtk_tree_view_collapse_row (GTK_TREE_VIEW (tv), path);
  gtk_tree_path_free (path);
  gtk_widget_show (tv);
  gtk_widget_show (notebook);
  gtk_widget_show(dialog1);
  return dialog1;
}
//END NEW

void AdvancedSettings(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GtkWidget *dlg;

   if(g_object_get_data(G_OBJECT(window), SettingsWindow))
   {
      dlg = get_widget(window, SettingsWindow);
      gdk_window_raise(gtk_widget_get_window(dlg));
      return;
   }
   dlg = create_advanced(data);
   g_object_set_data(G_OBJECT(window), SettingsWindow, dlg);
   g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(1));
   block_handlers_for_advanced();
   set_values_for_advanced();
   unblock_handlers_for_advanced();
}

void on_PolyhedraProperties(gpointer,  gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GtkWidget *dlg, *nb;
   if(g_object_get_data(G_OBJECT(window), SettingsWindow))
   {
      dlg = get_widget(window, SettingsWindow);
      gdk_window_raise(gtk_widget_get_window(dlg));
      nb = get_widget(dlg, "nb");
      gtk_notebook_set_current_page(GTK_NOTEBOOK(nb), PAGE_POLYHEDRA);
      return;
   }
   dlg = create_advanced(data);
   g_object_set_data(G_OBJECT(window), SettingsWindow, dlg);
   block_handlers_for_advanced();
   set_values_for_advanced();
   unblock_handlers_for_advanced();
   nb = get_widget(dlg, "nb");
   gtk_notebook_set_current_page(GTK_NOTEBOOK(nb), PAGE_POLYHEDRA);
}

void TbOnOff(gpointer item, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ToggleTb(obj_get_active(item));
//   gl->ToggleTb(gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(item)));
}

//NEW 

void Model::FillListAng(GtkWidget *dlg)
{
    GtkTreeView *list = GTK_TREE_VIEW(get_widget(dlg, "angleb"));
    GtkTreeSelection *selection = gtk_tree_view_get_selection(list);
    GtkTreeIter iter;
    GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    int hnd = get_int(GTK_WIDGET(list), "hnd");
    g_signal_handler_block(G_OBJECT(selection), hnd);
    gtk_list_store_clear(GTK_LIST_STORE(list_store));
    int alt = get_int(dlg, "alt");
    int nconn_eff = 0;
    for(int i=0; i<nangbonds; i++)
    {
        int n1 = anglebonds[i].n1 - 1;
        int n2 = anglebonds[i].n2 - 1;
        int n3 = anglebonds[i].n3 - 1;
        if( (n1 >= nats_au) || (n2 >= nats_au) || (n3 >= nats_au) )
             continue;
        float ang = anglebonds[i].fv;
        char *label1 = g_strdup(atm_au[n1].lab);
        char *label2 = g_strdup(atm_au[n2].lab);
        char *label3 = g_strdup(atm_au[n3].lab);
        std::string labtype = GetType(3, 1, n1, n2, n3);
        gtk_list_store_append (list_store, &iter);
        gtk_list_store_set (list_store, &iter, 0, i+1, 
              1, labtype.c_str(), 2, g_strstrip(label1),
              3, g_strstrip(label2), 4, g_strstrip(label3), 5, ang, -1);
        nconn_eff++;
    }
    gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"),
         -1, (int) MRmin(1.7f*(nconn_eff+1)*alt, 20*alt));
    g_signal_handler_unblock(G_OBJECT(selection), hnd);
}

void Model::FillListTors(GtkWidget *dlg)
{
    GtkTreeView *list = GTK_TREE_VIEW(get_widget(dlg, "torsions"));
    GtkTreeSelection *selection = gtk_tree_view_get_selection(list);
    GtkTreeIter iter;
    GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    int hnd = get_int(GTK_WIDGET(list), "hnd");
    g_signal_handler_block(G_OBJECT(selection), hnd);
    gtk_list_store_clear(GTK_LIST_STORE(list_store));
    int alt = get_int(dlg, "alt");
    int ntors_eff = 0;
    for(int i=0; i<ntorsions; i++)
    {
        int n1 = torsions[i].n1 - 1;
        int n2 = torsions[i].n2 - 1;
        int n3 = torsions[i].n3 - 1;
        int n4 = torsions[i].n4 - 1;
        if( (n1 >= nats_au) || (n2 >= nats_au) || 
            (n3 >= nats_au) || (n4 >= nats_au) )
               continue;
        float val = torsions[i].fv;
        char *label1 = g_strdup(atm_au[n1].lab);
        char *label2 = g_strdup(atm_au[n2].lab);
        char *label3 = g_strdup(atm_au[n3].lab);
        char *label4 = g_strdup(atm_au[n4].lab);
        gtk_list_store_append (list_store, &iter);
        gtk_list_store_set (list_store, &iter, 0, i+1,
              1, GetType(4, 1, n1, n2, n3, n4).c_str(), 2, g_strstrip(label1),
              3, g_strstrip(label2), 4, g_strstrip(label3),
              5, g_strstrip(label4), 6, val, -1);
        ntors_eff++;
    }
    gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"),
         -1, (int) MRmin(1.7f*(ntors_eff+1)*alt, 20*alt));
    g_signal_handler_unblock(G_OBJECT(selection), hnd);
}

static void selected_model(GtkWidget *combo, gpointer )
{
    GtkWidget *dlg = gtk_widget_get_toplevel(combo);
    int whichModel = combo_get_val(combo);
    if(whichModel > 0)
    {
       g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(whichModel));
       SetActiveModel(whichModel);
       UpdateInfoAtoms();
       gtk_window_set_title(GTK_WINDOW (dlg),
             toUTF8(g_path_get_basename(ModelInfo[whichModel-1].modname)));
    }
}

bool sort_by_z ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.z < elem2.z);
}

bool sort_by_zd ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.z > elem2.z);
}

bool sort_by_num ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.num < elem2.num);
}

bool sort_by_numd ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.num > elem2.num);
}

bool sort_by_num1 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n1 < elem2.n1);
}

bool sort_by_num1d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n1 > elem2.n1);
}

bool sort_by_num2 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n2 < elem2.n2);
}

bool sort_by_num2d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n2 > elem2.n2);
}

bool sort_by_num3 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n3 < elem2.n3);
}

bool sort_by_num3d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n3 > elem2.n3);
}

bool sort_by_num4 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n4 < elem2.n4);
}

bool sort_by_num4d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n4 > elem2.n4);
}

bool sort_by_num5 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n5 < elem2.n5);
}

bool sort_by_num5d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n5 > elem2.n5);
}

bool sort_by_num6 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n6 < elem2.n6);
}

bool sort_by_num6d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (elem1.n6 > elem2.n6);
}

bool sort_by_lab1 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab1, elem2.lab1) < 0);
}

bool sort_by_lab1d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab1, elem2.lab1) > 0);
}

bool sort_by_lab2 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab2, elem2.lab2) < 0);
}

bool sort_by_lab2d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab2, elem2.lab2) > 0);
}

bool sort_by_lab3 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab3, elem2.lab3) < 0);
}

bool sort_by_lab3d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab3, elem2.lab3) > 0);
}

bool sort_by_lab4 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab4, elem2.lab4) < 0);
}

bool sort_by_lab4d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab4, elem2.lab4) > 0);
}

bool sort_by_lab5 ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab5, elem2.lab5) < 0);
}

bool sort_by_lab5d ( jav_generic_type elem1, jav_generic_type elem2 )
{
   return (g_ascii_strcasecmp(elem1.lab5, elem2.lab5) > 0);
}

std::vector<rowlist_type> ReadList(int page, GtkWidget *treeview, int *num_elems, std::vector<jav_generic_type> &Rows)
{
    GtkWidget *father = gtk_widget_get_toplevel(treeview);
    int whichModel = get_int(father, "whichModel") - 1;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    //std::vector<jav_generic_type> Rows;
    std::vector<rowlist_type> Row_Ls;
    GtkTreeIter iter;
    Rows.clear();

    switch (page)
    {
    case PAGE_ATOMS:
       {
       jav_generic_type Row;
       rowlist_type Ls[10];
       gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
       int i = 0;
       while (valid)
       {
          gtk_tree_model_get(model, &iter,
              0, &Row.num, 1, &Row.lab1, 2, &Row.lab2,
              3, &Row.n6, 4, &Row.n1, 5, &Row.n2, 6, &Row.n3,
              7, &Row.n4, 8, &Row.n5, 9, &Row.lab3, 10, &Row.z, -1);
          Row.lab4 = g_strdup(" ");
          Row.lab5 = g_strdup(" ");
          Rows.push_back (Row);
          i++;
          valid = gtk_tree_model_iter_next (model, &iter);
          Ls[0].num = Row.num;
          Ls[1].str = g_strdup(Row.lab1);
          Ls[2].str = g_strdup(Row.lab2);
          Ls[3].val = Row.n6;
          Ls[4].val = Row.n1;
          Ls[5].val = Row.n2;
          Ls[6].val = Row.n3;
          Ls[7].val = Row.n4;
          Ls[8].val = Row.n5;
          Ls[9].str = g_strdup(Row.lab3);
          for(int k=0; k<10;k++)
              Row_Ls.push_back (Ls[k]);
       }
       *num_elems = i;
       }
       break;
    case PAGE_BONDS:
       *num_elems = ModelInfo[whichModel].nconn_prot;
       for(int i=0; i<ModelInfo[whichModel].nconn_prot; i++)
       {
             rowlist_type Ls[10];
             jav_generic_type Row;
             if((ModelInfo[whichModel].bonds[i].n1 > ModelInfo[whichModel].nats) || 
                (ModelInfo[whichModel].bonds[i].n2 > ModelInfo[whichModel].nats))
                continue;
             Row.n1 = (float) ModelInfo[whichModel].bonds[i].n1;
             Row.n2 = (float) ModelInfo[whichModel].bonds[i].n2;
             Row.n3 = 0;
             Row.n4 = 0;
             Row.n5 = ModelInfo[whichModel].bonds[i].dist;
             Row.n6 = 0;
             Row.num = i+1;
             Row.lab1 = g_strdup(ModelInfo[whichModel].atm[(int) Row.n1-1].lab);
             Row.lab2 = g_strdup(ModelInfo[whichModel].atm[(int) Row.n2-1].lab);
             int ko = ModelInfo[whichModel].atm[(int) Row.n1-1].op.op;
             Row.lab3 = g_strdup(getStringSymm(&ko));
             ko = ModelInfo[whichModel].atm[(int) Row.n2-1].op.op;
             Row.lab4 = g_strdup(getStringSymm(&ko));
             Row.lab5 = g_strdup(ModelInfo[whichModel].GetType(2, 0, (int) Row.n1-1, (int) Row.n2-1).c_str());
             Rows.push_back (Row);
             Ls[0].num = Row.num;
             Ls[1].str = g_strdup(Row.lab5);
             Ls[2].str = g_strdup(Row.lab1);
             Ls[3].str = g_strdup(Row.lab2);
             Ls[4].val = Row.n5;
             Ls[5].str = g_strdup(Row.lab3);
             Ls[6].str = g_strdup(Row.lab4);
             Ls[7].num = 0;
             Ls[8].num = 0;
             Ls[9].num = 0;
             for(int k=0; k<10;k++)
                 Row_Ls.push_back (Ls[k]);
       }
       break;
    case PAGE_EDIT_BONDS:             // Edit bonds
       *num_elems = ModelEdit.nconn_prot;
       for(int i=0; i<ModelEdit.nconn_prot; i++)
       {
             rowlist_type Ls[10];
             jav_generic_type Row;
             if((ModelEdit.bonds[i].n1 > ModelEdit.nats) || 
                (ModelEdit.bonds[i].n2 > ModelEdit.nats))
                continue;
             Row.n1 = (float) ModelEdit.bonds[i].n1;
             Row.n2 = (float) ModelEdit.bonds[i].n2;
             Row.n3 = 0;
             Row.n4 = 0;
             Row.n5 = ModelEdit.bonds[i].dist;
             Row.n6 = 0;
             Row.num = i+1;
             Row.lab1 = g_strdup(ModelEdit.atm[(int) Row.n1-1].lab);
             Row.lab2 = g_strdup(ModelEdit.atm[(int) Row.n2-1].lab);
             Row.lab3 = g_strdup(ModelEdit.GetType(2, 0, (int) Row.n1-1, (int) Row.n2-1).c_str());
             Row.lab4 = g_strdup(" ");
             Row.lab5 = g_strdup(" ");
             Rows.push_back (Row);
             Ls[0].num = Row.num;
             Ls[1].str = g_strdup(Row.lab3);
             Ls[2].str = g_strdup(Row.lab1);
             Ls[3].str = g_strdup(Row.lab2);
             Ls[4].val = Row.n5;
             Ls[5].str = g_strdup(Row.lab4);
             Ls[6].str = g_strdup(Row.lab5);
             Ls[7].num = 0;
             Ls[8].num = 0;
             Ls[9].num = 0;
             for(int k=0; k<10;k++)
                 Row_Ls.push_back (Ls[k]);
       }
       break;
    case PAGE_ANGLES:
       *num_elems = ModelInfo[whichModel].nangbonds;
       for(int i=0; i<ModelInfo[whichModel].nangbonds; i++)
       {
             rowlist_type Ls[10];
             jav_generic_type Row;
             if((ModelInfo[whichModel].anglebonds[i].n1 > ModelInfo[whichModel].nats_au) ||
                (ModelInfo[whichModel].anglebonds[i].n2 > ModelInfo[whichModel].nats_au) ||
                (ModelInfo[whichModel].anglebonds[i].n3 > ModelInfo[whichModel].nats_au))
                continue;
             Row.n1 = (float) ModelInfo[whichModel].anglebonds[i].n1;
             Row.n2 = (float) ModelInfo[whichModel].anglebonds[i].n2;
             Row.n3 = (float) ModelInfo[whichModel].anglebonds[i].n3;
             Row.n4 = 0;
             Row.n5 = ModelInfo[whichModel].anglebonds[i].fv;
             Row.n6 = 0;
             Row.num = i+1;
             Row.lab1 = g_strdup(ModelInfo[whichModel].atm_au[(int)Row.n1-1].lab);
             Row.lab2 = g_strdup(ModelInfo[whichModel].atm_au[(int)Row.n2-1].lab);
             Row.lab3 = g_strdup(ModelInfo[whichModel].atm_au[(int)Row.n3-1].lab);
             Row.lab4 = g_strdup(" ");
             Row.lab5 = g_strdup(ModelInfo[whichModel].GetType(3, 1, (int) Row.n1-1, (int) Row.n2-1, (int) Row.n3-1).c_str());
             Rows.push_back (Row);
             Ls[0].num = Row.num;
             Ls[1].str = g_strdup(Row.lab5);
             Ls[2].str = g_strdup(Row.lab1);
             Ls[3].str = g_strdup(Row.lab2);
             Ls[4].str = g_strdup(Row.lab3);
             Ls[5].val = Row.n5;
             Ls[6].num = 0;
             Ls[7].num = 0;
             Ls[8].num = 0;
             Ls[9].num = 0;
             for(int k=0; k<10;k++)
                 Row_Ls.push_back (Ls[k]);
       }
       break;
    case PAGE_TORSIONS:
       *num_elems = ModelInfo[whichModel].ntorsions;
       for(int i=0; i<ModelInfo[whichModel].ntorsions; i++)
       {
             rowlist_type Ls[10];
             jav_generic_type Row;
             if((ModelInfo[whichModel].torsions[i].n1 > ModelInfo[whichModel].nats_au) ||
                (ModelInfo[whichModel].torsions[i].n2 > ModelInfo[whichModel].nats_au) ||
                (ModelInfo[whichModel].torsions[i].n3 > ModelInfo[whichModel].nats_au) ||
                (ModelInfo[whichModel].torsions[i].n4 > ModelInfo[whichModel].nats_au))
                continue;
             Row.n1 = (float) ModelInfo[whichModel].torsions[i].n1;
             Row.n2 = (float) ModelInfo[whichModel].torsions[i].n2;
             Row.n3 = (float) ModelInfo[whichModel].torsions[i].n3;
             Row.n4 = (float) ModelInfo[whichModel].torsions[i].n4;
             Row.n5 = ModelInfo[whichModel].torsions[i].fv;
             Row.n6 = 0;
             Row.num = i+1;
             Row.lab1 = g_strdup(ModelInfo[whichModel].atm_au[(int)Row.n1-1].lab);
             Row.lab2 = g_strdup(ModelInfo[whichModel].atm_au[(int)Row.n2-1].lab);
             Row.lab3 = g_strdup(ModelInfo[whichModel].atm_au[(int)Row.n3-1].lab);
             Row.lab4 = g_strdup(ModelInfo[whichModel].atm_au[(int)Row.n4-1].lab);
             Row.lab5 = g_strdup(ModelInfo[whichModel].GetType(4, 1, (int) Row.n1-1, (int) Row.n2-1, (int) Row.n3-1, (int) Row.n4-1).c_str());
             Rows.push_back (Row);
             Ls[0].num = Row.num;
             Ls[1].str = g_strdup(Row.lab5);
             Ls[2].str = g_strdup(Row.lab1);
             Ls[3].str = g_strdup(Row.lab2);
             Ls[4].str = g_strdup(Row.lab3);
             Ls[5].str = g_strdup(Row.lab4);
             Ls[6].num = 0;
             Ls[7].num = 0;
             Ls[8].num = 0;
             Ls[9].num = 0;
             for(int k=0; k<10;k++)
                 Row_Ls.push_back (Ls[k]);
       }
       break;
    case PAGE_CONTACTS:
       *num_elems = 0;
       if(GetInfo(IFHBONDS, whichModel))
       {
          for(int i=0; i<ModelInfo[whichModel].nlegsH; i++)
          {
             rowlist_type Ls[10];
             jav_generic_type Row;
             Row.n1 = (float) MRabs(ModelInfo[whichModel].legsH[i].n1);
             Row.n2 = (float) MRabs(ModelInfo[whichModel].legsH[i].n2);
             Row.n3 = 0;
             Row.n4 = 0;
             Row.n5 = ModelInfo[whichModel].legsH[i].dist;
             Row.n6 = 0;
             Row.num = i+1;
             Row.lab1 = g_strdup(ModelInfo[whichModel].atm[(int) Row.n1-1].lab);
             Row.lab2 = g_strdup(ModelInfo[whichModel].atm[(int) Row.n2-1].lab);
             int ko = ModelInfo[whichModel].atm[(int) Row.n1-1].op.op;
             Row.lab3 = g_strdup(getStringSymm(&ko));
             ko = ModelInfo[whichModel].atm[(int) Row.n2-1].op.op;
             Row.lab4 = g_strdup(getStringSymm(&ko));
             Row.lab5 = g_strdup(" ");
             Rows.push_back (Row);
             Ls[0].num = Row.num;
             Ls[1].str = g_strdup(Row.lab1);
             Ls[2].str = g_strdup(Row.lab2);
             Ls[3].val = Row.n5;
             Ls[4].str = g_strdup(Row.lab3);
             Ls[5].str = g_strdup(Row.lab4);
             Ls[6].num = 0;
             Ls[7].num = 0;
             Ls[8].num = 0;
             Ls[9].num = 0;
             for(int k=0; k<10;k++)
                 Row_Ls.push_back (Ls[k]);
          }
          *num_elems += ModelInfo[whichModel].nlegsH;
       }
       if(GetInfo(IFSHORTC, whichModel))
       {
          for(int i=0; i<ModelInfo[whichModel].nlegsW; i++)
          {
             rowlist_type Ls[10];
             jav_generic_type Row;
             Row.n1 = (float) MRabs(ModelInfo[whichModel].legsW[i].n1);
             Row.n2 = (float) MRabs(ModelInfo[whichModel].legsW[i].n2);
             Row.n3 = 1;
             Row.n4 = 0;
             Row.n5 = ModelInfo[whichModel].legsW[i].dist;
             Row.n6 = 0;
             Row.num = i+(*num_elems)+1;
             Row.lab1 = g_strdup(ModelInfo[whichModel].atm[(int) Row.n1-1].lab);
             Row.lab2 = g_strdup(ModelInfo[whichModel].atm[(int) Row.n2-1].lab);
             int ko = ModelInfo[whichModel].atm[(int) Row.n1-1].op.op;
             Row.lab3 = g_strdup(getStringSymm(&ko));
             ko = ModelInfo[whichModel].atm[(int) Row.n2-1].op.op;
             Row.lab4 = g_strdup(getStringSymm(&ko));
             Row.lab5 = g_strdup(" ");
             Rows.push_back (Row);
             Ls[0].num = Row.num;
             Ls[1].str = g_strdup(Row.lab1);
             Ls[2].str = g_strdup(Row.lab2);
             Ls[3].val = Row.n5;
             Ls[4].str = g_strdup(Row.lab3);
             Ls[5].str = g_strdup(Row.lab4);
             Ls[6].num = 0;
             Ls[7].num = 0;
             Ls[8].num = 0;
             Ls[9].num = 0;
             for(int k=0; k<10;k++)
                 Row_Ls.push_back (Ls[k]);
          }
          *num_elems += ModelInfo[whichModel].nlegsW;
       }
       break;

    }
    return Row_Ls;
}
void sort_col_g(GtkWidget *column, gpointer data)
{
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    bool (*sort_by_col)(jav_generic_type, jav_generic_type);
    int num_elems;
    int ncol = GPOINTER_TO_INT(data);
    int ordin = get_int(column, "set_order");
    GtkWidget *treeview = get_widget(column, "father");
    GtkWidget *father = gtk_widget_get_toplevel(treeview);
    int whichModel = get_int(father, "whichModel") - 1;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    GtkListStore *list_store = GTK_LIST_STORE(model);
    GtkTreeIter iter;

    if(ordin > 0)
       ordin = -1;
    else
       ordin = 1;
    g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(ordin));
    switch (ordin*(ncol+1))
    {
    case -NO-1:
         sort_by_col = sort_by_numd;
         break;
    case -F1-1:
         sort_by_col = sort_by_num1d;
         break;
    case -F2-1:
         sort_by_col = sort_by_num2d;
         break;
    case -F3-1:
         sort_by_col = sort_by_num3d;
         break;
    case -F4-1:
         sort_by_col = sort_by_num4d;
         break;
    case -F5-1:
         sort_by_col = sort_by_num5d;
         break;
    case -F6-1:
         sort_by_col = sort_by_num6d;
         break;
    case -A1-1:
         sort_by_col = sort_by_lab1d;
         break;
    case -A2-1:
         sort_by_col = sort_by_lab2d;
         break;
    case -A3-1:
         sort_by_col = sort_by_lab3d;
         break;
    case -A4-1:
         sort_by_col = sort_by_lab4d;
         break;
    case -A5-1:
         sort_by_col = sort_by_lab5d;
         break;
    case -NS-1:
         sort_by_col = sort_by_zd;
         break;
    case NO+1:
         sort_by_col = sort_by_num;
         break;
    case F1+1:
         sort_by_col = sort_by_num1;
         break;
    case F2+1:
         sort_by_col = sort_by_num2;
         break;
    case F3+1:
         sort_by_col = sort_by_num3;
         break;
    case F4+1:
         sort_by_col = sort_by_num4;
         break;
    case F5+1:
         sort_by_col = sort_by_num5;
         break;
    case F6+1:
         sort_by_col = sort_by_num6;
         break;
    case A1+1:
         sort_by_col = sort_by_lab1;
         break;
    case A2+1:
         sort_by_col = sort_by_lab2;
         break;
    case A3+1:
         sort_by_col = sort_by_lab3;
         break;
    case A4+1:
         sort_by_col = sort_by_lab4;
         break;
    case A5+1:
         sort_by_col = sort_by_lab5;
         break;
    case NS+1:
         sort_by_col = sort_by_z;
         break;
    }

    GtkWidget *father_b = get_widget(treeview, "father_b");
    int page;
    if(strstr(gtk_widget_get_name(father_b), "atoms"))
       page = PAGE_ATOMS;
    else if(strstr(gtk_widget_get_name(father_b), "anglebonds"))
       page = PAGE_ANGLES;
    else if(strstr(gtk_widget_get_name(father_b), "torsion"))
       page = PAGE_TORSIONS;
    else if(strstr(gtk_widget_get_name(father_b), "contacts"))
       page = PAGE_CONTACTS;
    else if(strstr(gtk_widget_get_name(father_b), "conns"))
       page = PAGE_EDIT_BONDS;
    else
       page = PAGE_BONDS;
    std::vector<int>sel_vet;
    SaveSelection(treeview, 0, sel_vet);

    std::vector<jav_generic_type> Rows;
    Rows.clear();
    std::vector<rowlist_type> Ls = ReadList(page, treeview,
          &num_elems, Rows);

    sort(Rows.begin(), Rows.end(), sort_by_col);    
       
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    int i = 0;
    while (valid)
    {
       if(page == PAGE_ATOMS)          // atoms
       {
          float n1 = Rows[i].n1;
          float n2 = Rows[i].n2;
          float n3 = Rows[i].n3;
          float n4 = Rows[i].n4;
          float n5 = Rows[i].n5;
          float n6 = Rows[i].n6;
          int n  = Rows[i].num;
          char *label1 = g_strdup(Rows[i].lab1);
          char *label2 = g_strdup(Rows[i].lab2);
          char *label3 = g_strdup(Rows[i].lab3);
          int z = Rows[i].z;
          gtk_list_store_set (list_store, &iter,
              0, n, 1, g_strstrip(label1), 2, g_strstrip(label2),
              3, n6, 4, n1, 5, n2, 6, n3,
              7, n4, 8, n5, 9, g_strstrip(label3), 10, z, -1);
       }
       else if(page == PAGE_CONTACTS)
       {
          PixNum  *numb = g_new0(PixNum , 1);
          int n1 = (int) Rows[i].n1 - 1;
          int n2 = (int) Rows[i].n2 - 1;
          int n3 = (int) Rows[i].n3;
          int n  = Rows[i].num;
          float dist = Rows[i].n5;
          char *label1 = g_strdup(ModelInfo[whichModel].atm[n1].lab);
          char *label2 = g_strdup(ModelInfo[whichModel].atm[n2].lab);
          int ko = ModelInfo[whichModel].atm[n1].op.op;
          char *label3 = g_strdup(getStringSymm(&ko));
          ko = ModelInfo[whichModel].atm[n2].op.op;
          char *label4 = g_strdup(getStringSymm(&ko));
          numb->num = n;
          if(n3 == 0)
             numb->icon = create_rect(gl->ColorHB);
          else
             numb->icon = create_rect(gl->ColorSC);
          gtk_list_store_set (list_store, &iter, 0, (gpointer) numb, 
                     1, g_strstrip(label1), 2, g_strstrip(label2),
                     3, dist, 4, g_strstrip(label3),
                     5, g_strstrip(label4), -1);
       }
       else if(page == PAGE_BONDS)
       {
          int n1 = (int) Rows[i].n1 - 1;
          int n2 = (int) Rows[i].n2 - 1;
          int n  = Rows[i].num;
          float dist = Rows[i].n5;
          char *label1 = g_strdup(ModelInfo[whichModel].atm[n1].lab);
          char *label2 = g_strdup(ModelInfo[whichModel].atm[n2].lab);
          int ko = ModelInfo[whichModel].atm[n1].op.op;
          char *label3 = g_strdup(getStringSymm(&ko));
          ko = ModelInfo[whichModel].atm[n2].op.op;
          char *label4 = g_strdup(getStringSymm(&ko));
          char *label5 = g_strdup(Rows[i].lab5);
          gtk_list_store_set (list_store, &iter, 0, n, 1, label5,
                     2, g_strstrip(label1), 3, g_strstrip(label2), 4, dist,
                     5, g_strstrip(label3), 6, g_strstrip(label4), -1);
       }
       else if(page == PAGE_EDIT_BONDS)
       {
          int n1 = (int) Rows[i].n1 - 1;
          int n2 = (int) Rows[i].n2 - 1;
          int n  = Rows[i].num;
          float dist = Rows[i].n5;
          char *label1 = g_strdup(ModelEdit.atm[n1].lab);
          char *label2 = g_strdup(ModelEdit.atm[n2].lab);
          char *label3 = g_strdup(Rows[i].lab3);
          gtk_list_store_set (list_store, &iter, 0, n, 1, label3, 
                     2, g_strstrip(label1), 3, g_strstrip(label2), 4, dist,
                     -1);
       }
       else                 // anglebonds & torsions
       {
          int n1 = (int) Rows[i].n1 - 1;
          int n2 = (int) Rows[i].n2 - 1;
          int n3 = (int) Rows[i].n3 - 1;
          int n4 = (int) Rows[i].n4 - 1;
          int n  = Rows[i].num;
          float dist = Rows[i].n5;
          char *label1 = g_strdup(ModelInfo[whichModel].atm_au[n1].lab);
          char *label2 = g_strdup(ModelInfo[whichModel].atm_au[n2].lab);
          if(n3 >= 0)
          {
              char *label3 = g_strdup(ModelInfo[whichModel].atm_au[n3].lab);
              char *label5 = g_strdup(Rows[i].lab5);
              if(n4 >= 0)
              {
                  char *label4 = g_strdup(ModelInfo[whichModel].atm_au[n4].lab);
                  gtk_list_store_set (list_store, &iter, 0, n, 
                     1, g_strstrip(label5), 2, g_strstrip(label1),
                     3, g_strstrip(label2), 4, g_strstrip(label3), 
                     5, g_strstrip(label4), 6, dist, -1);
              }
              else
                  gtk_list_store_set (list_store, &iter, 0, n, 
                      1, g_strstrip(label5), 
                      2, g_strstrip(label1), 3, g_strstrip(label2),
                      4, g_strstrip(label3), 5, dist, -1);
          }
          else
             gtk_list_store_set (list_store, &iter, 0, n, 1, g_strstrip(label1),
                 2, g_strstrip(label2), 3, dist, -1);
       }
       i++;
       valid = gtk_tree_model_iter_next (model, &iter);
    }
    RedoSelection(treeview, 0, num_elems, sel_vet);
}

void InfoAtoms(GtkWidget *window, GLWindow *gl, int action)
{
using namespace gtkext;
   GtkWidget *dlg;
   GList *listModels = NULL;

   if(!gl->nModels)
   {
      dlg_errmsg(GTK_WINDOW(window), "Sorry. No models loaded.");
      return;
   }
   for(int i=0; i<gl->nModels; i++)
       listModels = g_list_append(listModels, 
             g_path_get_basename(ModelInfo[i].modname));

   if(g_object_get_data(G_OBJECT(window), InfoAtomsW))
   {
      dlg = get_widget(window, InfoAtomsW);
      gdk_window_raise(gtk_widget_get_window(dlg));
   }
   else
   {
      dlg = create_info(window, listModels);
      g_object_set_data(G_OBJECT(window), InfoAtomsW, dlg);
      g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(1));
   }
   UpdateInfoAtoms();

   if(action >= 0)
   {
      GtkWidget *nb = get_widget(dlg, "nb");
      gtk_notebook_set_current_page(GTK_NOTEBOOK(nb), action);
   }
}

void StructureInfo(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   InfoAtoms(window, gl, PAGE_STRUCTURE);
}

void ListAtoms(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   InfoAtoms(window, gl, PAGE_ATOMS);
}

void ListConn(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   InfoAtoms(window, gl, PAGE_BONDS);
}

void ListAng(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   InfoAtoms(window, gl, PAGE_ANGLES);
}

void ListTors(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   InfoAtoms(window, gl, PAGE_TORSIONS);
}

void ViewIntensitiesHistogram(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   InfoAtoms(window, gl, PAGE_BARS);
}

void ListContacts(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   InfoAtoms(window, gl, PAGE_CONTACTS);
}

void draw_barchart(gpointer data)
{
   GtkWidget *dlg = ( GtkWidget * ) data;
   int whichModel = get_int(dlg, "whichModel") - 1;
   ModelInfo[whichModel].FillBarChart(dlg);
}

#ifndef GTK_TOOLTIP
static void print_label(GtkWidget *statusb, const char *riga)
{
    gtk_statusbar_pop(GTK_STATUSBAR(statusb), 1);
    (void) gtk_statusbar_push(GTK_STATUSBAR(statusb), 1, toUTF8(riga));
}
#endif

static gboolean on_MouseMove (GtkWidget *widget, GdkEventMotion *event,
                              gpointer )
{
  int x = (int)event->x;
  int y = (int)event->y;
  int i;
  int nreg = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(widget), "nreg"));

  for(i=0; i<nreg; i++)
  {
      char nome[20];
      ScriviStringa(nome, sizeof(nome), "reg%d", i);
      _InfoReg *info = (_InfoReg *) g_object_get_data(G_OBJECT(widget), nome);
      if(info->reg == NULL)
         return TRUE;
      if(point_in_region(info->reg, x, y))
      {
#ifndef GTK_TOOLTIP
         print_label(get_widget(widget, "statusbar"), info->lab);
#else
         gtk_widget_set_tooltip_text(widget, info->lab);
#endif
         return FALSE;
      }
  }

#ifndef GTK_TOOLTIP
    print_label(get_widget(widget, "statusbar"), " ");
#else
    gtk_widget_set_has_tooltip(widget, FALSE);
#endif

   return TRUE;
}

static gboolean on_ConfigureEvent (GtkWidget *widget, GdkEventConfigure *,
                             gpointer user_data)
{
    gpointer pixmap;
    gpointer context;
    os_and_gc *rt;
    GtkAllocation allocation;
    gtk_widget_get_allocation(widget, &allocation);

    int w = (int)allocation.width;
    int h = (int)allocation.height;

    if (get_object(widget, "context") != NULL)
        context = get_object(widget, "context");
    else
        context = NULL;

    if (get_object(widget, "offscreen") != NULL)
        pixmap = get_object(widget, "offscreen");
    else
        pixmap = NULL;

    destroy_os_and_gc(pixmap, context);
    rt = get_os_and_gc(widget);
    pixmap = rt->os;
    context = rt->gc;
    g_free(rt);
    g_object_set_data(G_OBJECT(widget), "context", context);
    g_object_set_data( G_OBJECT(widget), "offscreen", pixmap);
    GdkColor colorw = {0, 65535, 65535, 65535};
    set_foreground(context, &colorw);
    draw_rectangle (pixmap, context, TRUE, 0, 0, w, h);
    draw_barchart(user_data);
    return TRUE;
}

void creabarchart (GtkWidget *father, GtkWidget *notebook, PangoFontDescription *fontlist)
{
  GtkWidget *parentbox = vbox_new (FALSE, 2);
  gtk_widget_show (parentbox);
  gtk_container_add (GTK_CONTAINER (notebook), parentbox);

  GtkWidget *scrollwin = gtk_scrolled_window_new(NULL, NULL);
  gtk_container_set_border_width (GTK_CONTAINER (scrollwin), 0);
#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 1, 0);
  gtk_frame_set_shadow_type(GTK_FRAME(align), GTK_SHADOW_ETCHED_OUT);
#else
  GtkWidget *align = gtk_alignment_new(0.5f, 0.5f, 0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrollwin), GTK_SHADOW_ETCHED_OUT);
#endif
  gtk_box_pack_start (GTK_BOX (parentbox), align, TRUE, TRUE, 0);
  gtk_widget_show (align);
  gtk_container_add(GTK_CONTAINER(align), scrollwin);
  g_object_set_data(G_OBJECT(father), "scrollwin", (gpointer) scrollwin);
  gtk_widget_show (scrollwin);

  GtkWidget *viewer = gtk_drawing_area_new ();
  add_to_scrollwin(scrollwin, viewer);
  g_object_set_data(G_OBJECT(father), "viewer", viewer);
  g_object_set_data(G_OBJECT(viewer), "offscreen", NULL);
  g_object_set_data(G_OBJECT(viewer), "font", (gpointer) fontlist);

  (void) g_signal_connect (G_OBJECT (viewer), "configure_event",
                      G_CALLBACK (on_ConfigureEvent),
                      (gpointer) father);
  (void) g_signal_connect (G_OBJECT (viewer), DRAW_EVENT,
                      G_CALLBACK (ManageExpose),
                      NULL);
  gtk_widget_set_events(viewer, GDK_POINTER_MOTION_MASK );
  g_signal_connect (G_OBJECT (viewer), "motion_notify_event",
                      G_CALLBACK (on_MouseMove), NULL);

  gtk_widget_show (viewer);

#ifndef GTK_TOOLTIP
  GtkWidget *statusb = gtk_statusbar_new ();
  g_object_set_data (G_OBJECT (viewer), "statusbar", statusb);
  gtk_widget_show (statusb);
  widget_modify_font(GTK_STATUSBAR(statusb)->label, fontlist);
  gtk_box_pack_start (GTK_BOX (parentbox), statusb, FALSE, FALSE, 2);
#endif

  std::stringstream s;
  s << PAGE_BARS;
  g_object_set_data(G_OBJECT(notebook), s.str().c_str(), (gpointer) viewer);
  set_tab_label (GTK_NOTEBOOK (notebook), PAGE_BARS, "Bar Chart");
}

static void selected_residue (GtkTreeSelection *selection, gpointer data)
{
    GtkTreeIter iter;
    GtkTreeModel *model;
    GtkTreeView *treeview = gtk_tree_selection_get_tree_view(selection);
    GtkWidget *dlg = (GtkWidget *)data;
    int wm = get_int(dlg, "whichModel") - 1;

    if (gtk_tree_selection_get_selected (selection, &model, &iter))
    {
       char *linea = DuplicaStringa(get_selected_row_path(GTK_WIDGET(treeview)));
       GtkTreePath *path = gtk_tree_path_new_from_string(linea);
       if(gtk_tree_view_expand_row (treeview, path, 0) == 0)
       {
          int nodi[3];
          get_int_tokens(linea, ":", 2, nodi);
//          g_print ("chain %d residue %d\n", nodi[0]+1, nodi[1]+1);
          ModelInfo[wm].FillListaAtomi(dlg, nodi);
          g_object_set_data(G_OBJECT(dlg), "whichChain", GINT_TO_POINTER(nodi[0]));
          g_object_set_data(G_OBJECT(dlg), "whichResidue", GINT_TO_POINTER(nodi[1]));
          g_object_set_data(G_OBJECT(dlg), "whichAtom", GINT_TO_POINTER(-1));
       }
    }
}

static void selected_iso(GtkWidget *combo, gpointer )
{
    const char *title[] = {"  B  ", "  U  "};
    const char *tit_PDB[] = {"Atoms    (    x       y      z   )    occ.    B ",
                             "Atoms    (    x       y      z   )    occ.    U "};
    int val = combo_get_val(combo);
    GtkWidget *dlg = gtk_widget_get_toplevel(combo);
    int whichModel = get_int(dlg, "whichModel") - 1;
    ModelInfo[whichModel].FillListAtoms(dlg);
    GtkWidget *lista = get_widget(dlg, "atoms");
    GtkTreeSelection *sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(lista));
    int hnd = get_int(lista, "hnd");
    g_signal_handler_block(G_OBJECT(sel), hnd);
    for(int i=0; i<ModelInfo[whichModel].nats; i++)
    {
        if(ModelInfo[whichModel].atm[i].selected)
           select_row(lista, i);
    }
    g_signal_handler_unblock(G_OBJECT(sel), hnd);
    if(ModelInfo[whichModel].atoms_sel.size() == 1)
    {
      int row = ModelInfo[whichModel].atoms_sel.at(0) - 1 ;
      if(ModelInfo[whichModel].atm[row].Bij[0])
      {
         FillLabelBij(dlg, ModelInfo[whichModel].atm[row].Bij);
      }
    }

    GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(lista), 7);
    GtkWidget *label = gtk_tree_view_column_get_widget(column);
    gtk_label_set_text(GTK_LABEL(label), title[val-1]);
    gtk_tree_view_column_set_title(column, title[val-1]);
    lista = get_widget(dlg, "atoms_PDB");
    column = gtk_tree_view_get_column(GTK_TREE_VIEW(lista), 0);
    gtk_tree_view_column_set_title(column, tit_PDB[val-1]);
    label = gtk_tree_view_column_get_widget(column);
    gtk_label_set_text(GTK_LABEL(label), tit_PDB[val-1]);
//??    FillLabelBij(dlg, NULL);
}

static void on_edit_cell_and_apply (GtkCellRendererText *cell, const gchar *path_string,
                          const gchar *new_text, gpointer data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
  GtkTreeIter iter;

  gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (cell), "column"));
  gint gt = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (cell), "gtype"));
  int row;

  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, 0, &row, -1);
  switch (gt)
  {
  case G_TYPE_STRING:
       {
             gchar *old_text;
             gtk_tree_model_get (model, &iter, column, &old_text, -1);
             g_free (old_text);
             gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                            g_strdup(new_text), -1);
       }
       break;
  case G_TYPE_FLOAT:
       {
             float val = (float) atof(new_text);
             gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                            val, -1);
       break;
       }
  case G_TYPE_INT:
       {
             int val =  atoi(new_text);
             gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                            val, -1);
       }
       break;
  }
  gpointer obj_par = g_object_get_data(G_OBJECT(model), "father");
  GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(obj_par));
  gtk_button_clicked(GTK_BUTTON(get_widget(dlg, "apply_b")));
}

void crealistaatomi (GtkWidget *father, GtkWidget *notebook, PangoFontDescription *fontlist)
{
  GtkWidget *label;
  const char *strings[] = {"  B  ", "  U  "};

  GtkWidget *parentbox = vbox_new (FALSE, 4);
  gtk_widget_show (parentbox);
  gtk_container_add (GTK_CONTAINER (notebook), parentbox);
  const char *titles[] = { "Number", "Label", "Type", "Intensity",
                           "Xfrac", "Yfrac","Zfrac",
                           "  B  "," s.o.f.", "Symm.Op", "z"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_FLOAT,
                    G_TYPE_FLOAT, G_TYPE_FLOAT, G_TYPE_FLOAT,
                    G_TYPE_FLOAT, G_TYPE_FLOAT, G_TYPE_STRING, G_TYPE_INT};
  int  sizes[] = { 0, 0, 0, 0,
                   0, 0, 0,
                   0, 0, 0, -1 };
  int precs[] = { 0, 0, 0, 2,
                  5, 5, 5,
                  5, 5, 0, 0};

  int sort_type[] = {NO, A1, NS, F6,
                     F1, F2, F3, 
                     F4, F5, A3, NS};
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));

#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_START, 1, 0);
#else
  GtkWidget *align = gtk_alignment_new(0.5, 0, 1, 0);
#endif
  gtk_widget_show (align);
  gtk_box_pack_start(GTK_BOX(parentbox), align, FALSE,FALSE, 10);

  GtkWidget *hbox = hbox_new(FALSE, 0);
  label = LABEL_NEW("ADP type:    ", MyBLUE);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE,FALSE, 4);
  GtkWidget *combo = create_combo(hbox, strings, 2, 1, NULL, G_CALLBACK(selected_iso), false);
  g_object_set_data(G_OBJECT(father), "iso_combo", combo);
  //gtk_box_pack_start(GTK_BOX(parentbox), hbox, FALSE,FALSE, 10);
  gtk_container_add(GTK_CONTAINER(align), hbox);
  label = LABEL_NEW(" ", NULL);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE,FALSE, 10);
  g_object_set_data(G_OBJECT(father), "bij", label);
  PangoFontDescription *fontlist2 = get_font(0.99f, 9);
  widget_modify_font(label, fontlist2);

//PDB
  GtkWidget *frame = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_NONE);
  g_object_set_data(G_OBJECT(father), "frame_PDB", frame);
  gtk_box_pack_start (GTK_BOX (parentbox), frame, TRUE, TRUE, 4);
  GtkWidget *hbox1 = hpaned_new();
  gtk_container_add(GTK_CONTAINER(frame), hbox1);

  frame = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
  gtk_paned_pack1((GtkPaned *)hbox1, frame, TRUE, FALSE);
  create_tree_store (father, frame, "Chains", G_CALLBACK(selected_residue), father);

  frame = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
  gtk_paned_pack2((GtkPaned *)hbox1, frame, TRUE, FALSE);
  GtkWidget *list = createSelection(father, frame,
    "Atoms    (    x       y      z   )    occ.    B ",
                      "atoms_PDB", 0, MyBLUE);
  set_widget_fontN(list);
  GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), 0);
  label = gtk_tree_view_column_get_widget(column);
  if(label)
     set_widget_fontN(label);
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_atom), father);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));

// other
  list =
  new_selection(father, parentbox, "atoms", ncol, titles, sizes, types, precs);
  g_object_set_data(G_OBJECT(list), "father_b", parentbox);
  g_object_set_data(G_OBJECT(father), "frame_noPDB", get_widget(list, "frame"));
  gtk_widget_set_name(parentbox, "atoms");
  widget_modify_font(list, fontlist);
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
      gtk_tree_view_column_set_clickable(column, TRUE);
      g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(-1));
      g_object_set_data(G_OBJECT(column), "father", list);
      g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(sort_col_g),
                 GINT_TO_POINTER(sort_type[i]));
  }
  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_atom), father);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));

  std::stringstream s;
  s << PAGE_ATOMS;
  g_object_set_data(G_OBJECT(notebook), s.str().c_str(), (gpointer) list);
  set_tab_label (GTK_NOTEBOOK (notebook), PAGE_ATOMS, "Atoms");
}

void crealistalegami (GtkWidget *father, GtkWidget *notebook, PangoFontDescription *fontlist)
{
  GtkWidget *label;
  GtkWidget *parentbox = vbox_new (FALSE, 2);
  gtk_widget_show (parentbox);
  gtk_container_add (GTK_CONTAINER (notebook), parentbox);
  gtk_widget_set_name(parentbox, "bonds");

  const char *titles[] = { "Number", "Type", "Atom 1", "Atom 2", "Distance",
                           "Symm.Op1", "Symm.Op2"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING,
                    G_TYPE_FLOAT, G_TYPE_STRING, G_TYPE_STRING};
//  int  sizes[] = { 60, 90, 90, 160 };
  int  sizes[] = { 0, 0, 0, 0, 0 , 0, 0};
  int  precs[] = { 0, 0, 0, 0, 5 , 0, 0};
  int sort_type[] = {NO, A5, A1, A2, F5, A3, A4};
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  GtkWidget *list = 
  new_selection(father, parentbox, "conn", ncol, titles, sizes, types, precs);
  g_object_set_data(G_OBJECT(list), "father_b", parentbox);
  widget_modify_font(list, fontlist);
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
      gtk_tree_view_column_set_clickable(column, TRUE);
      g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(-1));
      g_object_set_data(G_OBJECT(column), "father", list);
      g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(sort_col_g),
                 GINT_TO_POINTER(sort_type[i]));
  }
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_bond), father);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));

  std::stringstream s;
  s << PAGE_BONDS;
  g_object_set_data(G_OBJECT(notebook), s.str().c_str(), (gpointer) list);
  set_tab_label (GTK_NOTEBOOK (notebook), PAGE_BONDS, "Bonds");
}


void crealistaangoli (GtkWidget *father, GtkWidget *parent,
           PangoFontDescription *fontlist, bool ifEdit=false)
{
  GtkWidget *label;
  GtkWidget *parentbox = vbox_new (FALSE, 2);
  gtk_widget_show (parentbox);
  gtk_container_add (GTK_CONTAINER (parent), parentbox);
  gtk_widget_set_name(parentbox, "anglebonds");

  const char *titles[] = { "Number", "Type", "Start Atom", "Vertex", "End Atom", "Angle"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_FLOAT };
//  int  sizes[] = { 60, 90, 90, 90, 160 };
  int  sizes[] = { 0, 0, 0, 0, 0, 0 };
  int  precs[] = { 0, 0, 0, 0, 0, 2 };
  int sort_type[] = {NO, A5, A1, A2, A3, F5};     // label atomi
  bool editable[] = {false, false, false, false, false, true};
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  GtkWidget *list;
  if (ifEdit)
      list = new_selection(father, parentbox, "angleb", ncol, titles, sizes,
              types, precs, editable, G_CALLBACK(on_edit_cell_and_apply));
  else
      list = new_selection(father, parentbox, "angleb", ncol, titles, sizes,
              types, precs);

  g_object_set_data(G_OBJECT(list), "father_b", parentbox);
  widget_modify_font(list, fontlist);
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
      gtk_tree_view_column_set_clickable(column, TRUE);
      g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(-1));
      g_object_set_data(G_OBJECT(column), "father", list);
      g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(sort_col_g),
                 GINT_TO_POINTER(sort_type[i]));
  }
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  if(!ifEdit)
     set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_anglebond), father);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));
  if(!ifEdit)
  {
     std::stringstream s;
     s << PAGE_ANGLES;
     g_object_set_data(G_OBJECT(parent), s.str().c_str(), (gpointer) list);
     set_tab_label (GTK_NOTEBOOK (parent), PAGE_ANGLES, "Angles");
  }
}

static void seleziona_torsion(int whichModel, int row)
{
     int n1 = ModelInfo[whichModel].torsions[row].n1 - 1;
     int n2 = ModelInfo[whichModel].torsions[row].n2 - 1;
     int n3 = ModelInfo[whichModel].torsions[row].n3 - 1;
     int n4 = ModelInfo[whichModel].torsions[row].n4 - 1;
     if(ModelInfo[whichModel].Equivs[n1].empty())
        return;
     if(ModelInfo[whichModel].Equivs[n2].empty())
        return;
     if(ModelInfo[whichModel].Equivs[n3].empty())
        return;
     if(ModelInfo[whichModel].Equivs[n4].empty())
        return;
     int n1eq = (int) ModelInfo[whichModel].Equivs[n1].size();
     int n2eq = (int) ModelInfo[whichModel].Equivs[n2].size();
     int n3eq = (int) ModelInfo[whichModel].Equivs[n3].size();
     int n4eq = (int) ModelInfo[whichModel].Equivs[n4].size();
     int neq  = MRmin(MRmin(n1eq, n2eq), MRmin(n3eq, n4eq));
     for(int keq=0; keq<neq; keq++)
     {
         int ieq1 = ModelInfo[whichModel].Equivs[n1].at(keq);
         int ieq2 = ModelInfo[whichModel].Equivs[n2].at(keq);
         int ieq3 = ModelInfo[whichModel].Equivs[n3].at(keq);
         int ieq4 = ModelInfo[whichModel].Equivs[n4].at(keq);
         int bb1 = ModelInfo[whichModel].FindConn(ieq1, ieq2);
         int bb2 = ModelInfo[whichModel].FindConn(ieq2, ieq3);
         int bb3 = ModelInfo[whichModel].FindConn(ieq3, ieq4);
         if((bb1 != -1) && (bb2 !=-1) && (bb3 != -1))
         {
             ModelInfo[whichModel].atm[ieq1].selected = true;
             ModelInfo[whichModel].atm[ieq2].selected = true;
             ModelInfo[whichModel].atm[ieq3].selected = true;
             ModelInfo[whichModel].atm[ieq4].selected = true;
             ModelInfo[whichModel].atoms_sel.push_back(ieq1+1);
             ModelInfo[whichModel].atoms_sel.push_back(ieq2+1);
             ModelInfo[whichModel].atoms_sel.push_back(ieq3+1);
             ModelInfo[whichModel].atoms_sel.push_back(ieq4+1);
             ModelInfo[whichModel].bonds[bb1].selected = true;
             ModelInfo[whichModel].bonds_sel.push_back(bb1+1);
             ModelInfo[whichModel].bonds[bb2].selected = true;
             ModelInfo[whichModel].bonds_sel.push_back(bb2+1);
             ModelInfo[whichModel].bonds[bb3].selected = true;
             ModelInfo[whichModel].bonds_sel.push_back(bb3+1);
         }
     }
}

static void selected_torsion(GtkTreeSelection  *sele, gpointer data)
{
   if(!GLWINDOW)
      return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     GtkTreeView *tree_view;
     int row;
     GtkWidget *dlg = (GtkWidget *)data;
     int whichModel = get_int(dlg, "whichModel") - 1;

     for(int i=0; i<ModelInfo[whichModel].nats; i++)
         ModelInfo[whichModel].atm[i].selected = false;
     for(int i=0; i<ModelInfo[whichModel].nconn_prot; i++)
         ModelInfo[whichModel].bonds[i].selected = false;
     ModelInfo[whichModel].atoms_sel.clear();
     ModelInfo[whichModel].bonds_sel.clear();
     tree_view = gtk_tree_selection_get_tree_view(sele);
     GList *rowsel = NULL;
     rowsel = get_selections(GTK_WIDGET(tree_view));
     if(rowsel)
     {
        int num_sel = g_list_length(rowsel);
        for(int i=0; i<num_sel; i++)
        {
             GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
             gpointer riga =
                 get_selection_from_pathC(tree_view, path, 0);
             row = GPOINTER_TO_INT(riga) - 1;
             g_object_set_data(G_OBJECT(dlg), "whichTors", GINT_TO_POINTER(row));
             seleziona_torsion(whichModel, row);
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
     }
     gl->Redraw();
     update_items_modify(true);
}

void crealistatorsioni (GtkWidget *father, GtkWidget *notebook, PangoFontDescription *fontlist, bool ifEdit=false)
{
  GtkWidget *label;
  GtkWidget *parentbox = vbox_new (FALSE, 2);
  gtk_widget_show (parentbox);
  gtk_container_add (GTK_CONTAINER (notebook), parentbox);
  gtk_widget_set_name(parentbox, "torsions");

  const char *titles[] = { "Number", "Type", "Atom 1", "Atom 2", "Atom 3", 
                           "Atom4", "Angle"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING,G_TYPE_STRING, 
                    G_TYPE_STRING, G_TYPE_STRING, G_TYPE_FLOAT };
//  int  sizes[] = { 60, 90, 90, 90, 90, 160 };
  int  sizes[] = { 0, 0, 0, 0, 0, 0, 0 };
  int  precs[] = { 0, 0, 0, 0, 0, 0, 2 };
  bool editable[] = {false, false, false, false, false, false, true};
  int sort_type[] = {NO, A5, A1, A2, A3, A4, F5};   
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  GtkWidget *list;
  if(ifEdit)
     list = new_selection(father, parentbox, "torsions", ncol, titles, sizes, types, precs, editable, G_CALLBACK(on_edit_cell_and_apply));
  else
     list = new_selection(father, parentbox, "torsions", ncol, titles, sizes, types, precs);
  g_object_set_data(G_OBJECT(father), "frame_tors", get_widget(list, "frame"));
  g_object_set_data(G_OBJECT(list), "father_b", parentbox);
  widget_modify_font(list, fontlist);
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
      gtk_tree_view_column_set_clickable(column, TRUE);
      g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(-1));
      g_object_set_data(G_OBJECT(column), "father", list);
      g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(sort_col_g),
                 GINT_TO_POINTER(sort_type[i]));
  }
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  if(!ifEdit)
     set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_torsion), father);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));

  if(!ifEdit)
  {
     std::stringstream s;
     s << PAGE_TORSIONS;
     g_object_set_data(G_OBJECT(notebook), s.str().c_str(), (gpointer) list);
     set_tab_label (GTK_NOTEBOOK (notebook), PAGE_TORSIONS, "Torsion Angles");
  }
}

void on_cancel_edit_tors(GtkWidget *button, gpointer data)
{
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  int whichModel = get_int(dlg, "whichModel");
  jav_torsion_type angs = ModelInfo[whichModel-1].torsions[0];
  int code = 2;
  float tval = 0;
  jav_edit_torsion_properties_(&code, &angs, &tval, &whichModel);
  chiudi_dlg(button, data);
  updateModify(1);
}

void on_apply_edit_tors(GtkWidget *button, GtkWidget *dlg)
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  int whichModel = get_int(dlg, "whichModel");
  int seltor = get_int(dlg, "whichTors");
  GtkWidget *list = get_widget(dlg, "torsions");
  jav_torsion_type *angs = ModelInfo[whichModel-1].FromListToTors(list);
  jav_torsion_type ang = ModelInfo[whichModel-1].torsions[seltor];
  int code = 3;
  int nangs =  ModelInfo[whichModel-1].ntorsions;
  float tval = angs[seltor].fv;
  jav_edit_torsion_properties_(&code, &ang, &tval, &whichModel);
  angs[seltor].fv = ang.fv;
  ModelInfo[whichModel-1].FillTors(nangs, angs);
  ModelInfo[whichModel-1].FromTorsToList(list, angs);
  if(seltor >= 0)
  {
     seleziona_torsion(whichModel-1, seltor);
     gl->Redraw();
  }
}

void on_ok_edit_tors(GtkWidget *button, gpointer data)
{
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  int whichModel = get_int(dlg, "whichModel");
  int code = 1;
  jav_torsion_type angs = ModelInfo[whichModel-1].torsions[0];
  float tval = 0;
  jav_edit_torsion_properties_(&code, &angs, &tval, &whichModel);
  chiudi_dlg(button, data);
  on_unselect(NULL, (gpointer) GLWINDOW);
  updateModify(1);
}

GtkWidget *on_edit_tors(GtkWidget *window)
{
  GtkWidget *dialog1;
  GtkWidget *button;
  int lar, alt;

  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1),
             toUTF8(g_path_get_basename(ModelInfo[0].modname)));
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
  g_object_set_data(G_OBJECT(dialog1), "alt", GINT_TO_POINTER(alt));

  int inModify = GetActiveModel() - 1;
  g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(inModify+1));
  crealistatorsioni (dialog1, vbox1, fontlist, true);
  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = EditTorsW;

  button = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 1);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_ok_edit_tors), (gpointer) st);
  button = APPLY_button();
  //gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 2);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_apply_edit_tors), dialog1);
  g_object_set_data(G_OBJECT(dialog1), "apply_b", button);
  button = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 3);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_cancel_edit_tors), (gpointer) st);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show_all(dialog1);

  g_object_set_data(G_OBJECT(dialog1), "whichTors", GINT_TO_POINTER(-1));
  return dialog1;
}

void UpdateTorsEdit()
{
   if(GLWINDOW == NULL)
      return;
   if(g_object_get_data(G_OBJECT(GLWINDOW), EditTorsW))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, EditTorsW);
      int whichModel = get_int(dlg, "whichModel") - 1;
      if(whichModel < 0)
         return;
      ModelInfo[whichModel].FillListTors(dlg);
   }
}

void TorsEdit(GtkWidget *window, GLWindow *gl)
{
using namespace gtkext;
   GtkWidget *dlg;
   int whichModel = GetActiveModel();
   gettorsion_(&whichModel);
   if(!ModelInfo[whichModel-1].ntorsions)
   {
      dlg_errmsg(GTK_WINDOW(GLWINDOW), "Sorry. No torsion angles on current model.");
      return;
   }
   if(g_object_get_data(G_OBJECT(window), EditTorsW))
   {
      dlg = get_widget(window, EditTorsW);
      gdk_window_raise(gtk_widget_get_window(dlg));
   }
   else
   {
      dlg = on_edit_tors(window);
      g_object_set_data(G_OBJECT(window), EditTorsW, dlg);
      int inModify = GetActiveModel();
      g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(inModify));
   }
   updateModify(-99);
   int code = 0;
   jav_torsion_type angs = ModelInfo[whichModel-1].torsions[0];
   float tval = 0;
   jav_edit_torsion_properties_(&code, &angs, &tval, &whichModel);
   UpdateTorsEdit();

}

void OnTorsEdit(gpointer, gpointer data)
{
using namespace gtkext;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   if(!ModelInfo[whichModel].nlegs_au)
   {
      dlg_errmsg(GTK_WINDOW(GLWINDOW), "Sorry. No torsion angles on current model.");
      return;
   }
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   TorsEdit(window, gl);
}

void ViewText(GtkWidget *button, gpointer )
{
using namespace gtkext;
   GtkWidget *window = gtk_widget_get_toplevel(button);
   int kmodel = get_int(window, "whichModel") - 1;
   if(kmodel < 0)
      return;
   std::string fn = ModelInfo[kmodel].modname;
   if( !g_file_test(toUTF8(fn.c_str()), G_FILE_TEST_EXISTS) )
   {
      dlg_errmsg(GTK_WINDOW(window), "Error in open file %s", fn.c_str());
      return;
   }
   gtkext::text_window(GTK_WINDOW(window), fn.c_str(), "*.*", 0, ModelInfo[kmodel].modname);
}

void ViewSecondary(GtkWidget *button, gpointer )
{
   GtkWidget *window = gtk_widget_get_toplevel(button);
   int kmodel = get_int(window, "whichModel") - 1;
   if(kmodel < 0)
      return;
   std::string secfn = g_strdup_printf( "%s%c.1tmp",
       g_path_get_dirname(main_app::JavApp.ConfDir().c_str()),
       G_DIR_SEPARATOR);
   std::ofstream os;
   os.open(fromUTF8(secfn).c_str());
   if(!os)
      return;
   PrintSecondary(&ModelInfo[kmodel], os);
   os.close();
   gtkext::text_window(GTK_WINDOW(window), secfn.c_str(), "*.*", 0, ModelInfo[kmodel].modname);
   Cancella( secfn.c_str());
}

void move_center(vet3 posi, int whichModel, int whichAtom, bool ifDrawCenter)
{
   float pos1[3] = {(float) posi.x, (float) posi.y, (float) posi.z};
   move_center(pos1, whichModel, whichAtom, ifDrawCenter);
}

void move_center(float posi[], int whichModel, int whichAtom, bool ifDrawCenter)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

   float xyz1[3] = {(float) gl->xyzC.x, (float) gl->xyzC.y, (float) gl->xyzC.z};
   float xyz2[3] = {posi[0], posi[1], posi[2]};
   float l[3];
   for(int j=0; j<3; j++)
       l[j] = xyz2[j]-xyz1[j];
   int nstep = 20;
   float step = 0.05f;
   float t = 0.f;
   for(int k=0; k<nstep; k++)
   {
       float xyz3[3];
       t += step;
       for(int j=0; j<3; j++)
           xyz3[j] = xyz1[j] + l[j] * t;
       for(int j=0; j<3; j++)
              gl->xyzC.v[j] = (double) xyz3[j];
//       g_print("centro %f %f %f\n", gl->xyzC[0], gl->xyzC[1], gl->xyzC[2]);
       if(gl->ifDrawPar)
          gl->CalcPar(gl->xyzC, gl->abcPar);

       gl->RiNormalizza();
       gl->ifAxes = 0;
       gl->Redraw();
       while(gtk_events_pending())
         (void) gtk_main_iteration();
   }

   for(int j=0; j<3; j++)
       gl->xyzC.v[j] = posi[j];
   
   if(gl->ifDrawPar)
      gl->CalcPar(gl->xyzC, gl->abcPar);
   gl->RiNormalizza();
   gl->DrawCenter = ifDrawCenter;
   if((whichModel > -1) && (whichAtom > -1) )
   {
      for(int i=0; i<ModelInfo[whichModel].nats; i++)
          ModelInfo[whichModel].atm[i].drawLabel = 0;
      ModelInfo[whichModel].atm[whichAtom].drawLabel = 1;
   }

   gl->ifAxes = 1;
   gl->Redraw();
#ifdef MAPS
   update_center();
#endif
   while(gtk_events_pending())
         (void) gtk_main_iteration();
}

gboolean gotoresidue(GtkWidget *ebox, GdkEventButton *, gpointer data)
{
    int whichModel = get_int(ebox, "whichModel");
    int katom = GPOINTER_TO_INT(data);
    float posi[3];
    for (int i=0; i<3; i++)
          posi[i] = ModelInfo[whichModel].atm[katom].xyzc[i];
    move_center(posi, whichModel, katom, false);
    return TRUE;
}

GtkWidget *NEW_LABEL(const char *string, const gchar *fore, const gchar *bg)
{
    GtkWidget *label;
    
    GtkWidget *ebox = gtk_event_box_new();
    gtk_widget_show (ebox);

    label = gtk_label_new(NULL);
    g_object_set_data(G_OBJECT(ebox), "label", label);
    if(!string)
       return label;
    PangoFontDescription *newfdesc  = get_fontN(MONOSPACE_FONT);
    pango_font_description_set_size (newfdesc, 10*PANGO_SCALE);

    pango_font_description_set_weight(newfdesc,PANGO_WEIGHT_HEAVY);

    if(fore)
       setta_colore(label, fore);
    if(bg)
       setta_colorebg(ebox, bg);
    widget_modify_font(label, newfdesc);
    gtk_label_set_markup(GTK_LABEL(label), string);
    gtk_container_add(GTK_CONTAINER(ebox), label);
    gtk_widget_set_events(ebox, GDK_BUTTON_PRESS_MASK );
    return ebox;
}

const char *get_header(char *filnam)
{
    std::string head = "XXXX";
    char rigar[MAX_LEN+1];

    FILE *fp = fOpen(filnam, "r");
    if(!fp)
       return "XXXX";
    while(fgets(rigar,MAX_LEN,fp) != NULL)
    {
       if(strstr(rigar, "HEADER"))
       {
          int fin = (int) strlen(rigar)-1;
          char head1[5];
          if(rigar[fin-5] == ' ')
          {
             for(int i=0; i<4; i++)
                 head1[i] = rigar[fin-4+i];
             head1[4] = '\0';
             head = head1;
          }
          break;
       }
    }
    fclose(fp);
    return g_strdup(head.c_str());
}

void ExportFasta(int kmodel,  std::ofstream &fil)
{
   const char *header = get_header(ModelInfo[kmodel].modname);
   for(int kk=0; kk<ModelInfo[kmodel].nChains; kk++)
   {
       CHAIN ch = ModelInfo[kmodel].Chains[kk];
       if(ch.nAmino == 0)
           continue;
       fil << ">" << header << ":" << ch.id << "|PDBID|CHAIN|SEQUENCE" <<  "\n";
       int punt = 0;
       for(int rr=0; rr<ch.nResidues; rr++)
       {
           std::string tname(ch.Residues[rr].name);
           int p = (int) tname.find_last_of( " " );
           std::string rname;
           if (p >= 0)
               rname = tname.substr(p+1);
           else
               rname = tname;

           if (rname.at(0) == ' ')
               rname.erase(rname.begin());
           int which = IsAminoNucle(rname.c_str());
           const char *t;
           if(which)
              t = g_strdup(get_AminoCode(which));
           else
              continue;
           if(strcmp(t,"X"))
           {
              fil << t;
              punt++;
           }
           if(punt == 80)
           {
              fil << "\n";
              punt = 0;
           }
       }
       fil << "\n";
   }
}

void ExportPir(int kmodel,  std::ofstream &fil)
{
   fil << ">---------+----------+----------+----------+----------+" << "\n\n";
   int punt = 0;
   for(int kk=0; kk<ModelInfo[kmodel].nChains; kk++)
   {
       CHAIN ch = ModelInfo[kmodel].Chains[kk];
       if(ch.nAmino == 0)
           continue;
       for(int rr=0; rr<ch.nResidues; rr++)
       {
           std::string tname(ch.Residues[rr].name);
           int p = (int) tname.find_last_of( " " );
           std::string rname;
           if (p >= 0)
               rname = tname.substr(p+1);
           else
               rname = tname;

           if (rname.at(0) == ' ')
               rname.erase(rname.begin());
           int which = IsAminoNucle(rname.c_str());
           const char *t;
           if(which)
              t = g_strdup(get_AminoCode(which));
           else
              continue;
           if(strcmp(t,"X"))
           {
              fil << t;
              punt++;
           }
           if((punt % 10) == 0)
           {
              fil << " ";
//              punt++;
              if(punt >= 50)
              {
                 fil << "\n";
                 punt = 0;
              }
           }
       }
   }
   fil << "*\n";
}

void SaveSequence(GtkWidget *but, gpointer data)
{
using namespace gtkext;
   GtkWidget *dlg = gtk_widget_get_toplevel(but);
   int kmodel = GPOINTER_TO_INT(data);
   int tipo;
   const char *filter = "Fasta format(*.seq)@Pir format(*.pir)";
   char *savefile = g_new0(char, MaxLenFilename);
   FilselItem local_it;
   local_it = saveas(dlg, filter, savefile, false);
   if(local_it.exitCode > 0)
   {
       char *f1 = g_build_filename(local_it.cwd, local_it.fileinp, NULL);
       tipo = local_it.nfilt;
       std::ofstream os;
       os.open(f1);
       if(!os)
          return;
       if(tipo == 0)
          ExportFasta(kmodel, os);
       else
          ExportPir(kmodel, os);
       os.close();
   }
}

void FillSequence(GtkWidget *box, int kmodel, int ifOther)
{
   const char *bgcolors[] = {"green", "red", "yellow", "blue","magenta"};
   const char *fgcolors[] = {"black", "white", "black", "white","white"};
   for(int kk=0; kk<ModelInfo[kmodel].nChains; kk++)
   {
       CHAIN ch = ModelInfo[kmodel].Chains[kk];
       if( !ifOther && (ch.nAmino == 0) )
           continue;
       std::stringstream fil;
       fil << "Chain: " << ch.id;
       GtkWidget *label = FRAME_BOLD(fil.str().c_str(), MyBLUE, 1.2f, 0);
       gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 10);
       gtk_frame_set_shadow_type(GTK_FRAME(label), GTK_SHADOW_NONE);
       GtkWidget *hbox = hbox_new(FALSE, 0);
       gtk_container_add(GTK_CONTAINER(label), hbox);
       for(int rr=0; rr<ch.nResidues; rr++)
       {
           std::string tname(ch.Residues[rr].name);
           int code = ch.Residues[rr].code;
           int p = (int) tname.find_last_of( " " );
           std::string rname;
           if (p >= 0)
               rname = tname.substr(p+1);
           else
               rname = tname;

           if (rname.at(0) == ' ')
               rname.erase(rname.begin());
           int which = IsAminoNucle(rname.c_str());
           const char *t, *color, *color2;
           if(NANonStd(code))
              t = "N"; 
           else if(which)
              t = g_strdup(get_AminoCode(which));
           else
              t = "X"; 
           RESIDUE r1;
           if(strcmp(t,"X"))
           {
              color  = NULL;
              color2 = NULL;
              r1 = GetResiduo(kmodel, kk, rr);
              tname.append("\n");
              tname.append(Translate(r1.secondary));
              color  = bgcolors[TypeS(r1.secondary)];
              color2 = fgcolors[TypeS(r1.secondary)];
           }
           else if(!ifOther)
              continue;
           else
           {
              color  = NULL;
              color2 = NULL;
           }
           GtkWidget *ebox = NEW_LABEL(t, color2, color);
           g_object_set_data(G_OBJECT(ebox), "whichModel", GINT_TO_POINTER(kmodel));
           if(which)
           {
              int katom;
              if(which < N_AMINO)
                 katom = ModelInfo[kmodel].FindAtom("CA", r1);
              else
                 katom = ModelInfo[kmodel].FindAtom("O5'", r1);
              g_signal_connect (G_OBJECT (ebox), "button_press_event",
                      G_CALLBACK (gotoresidue), GINT_TO_POINTER(katom));
           }
           set_tip (ebox, tname.c_str());
           gtk_box_pack_start (GTK_BOX (hbox), ebox, FALSE, FALSE, 0);
       }
   }
}

void RefillSequence(GtkToggleButton *button, gpointer data)
{
   int kmodel = GPOINTER_TO_INT(data);
   GtkWidget *box = get_widget(GTK_WIDGET(button), "box2");
   remove_children(box);
   FillSequence(box, kmodel, gtk_toggle_button_get_active(button));
   gtk_widget_show_all(box);
}

void ViewSequence(int kmodel)
{
   GtkWidget *dlg;
   if(g_object_get_data(G_OBJECT(GLWINDOW), SequenceWindow))
   {
      dlg = get_widget(GLWINDOW, SequenceWindow);
      gdk_window_raise(gtk_widget_get_window(dlg));
      return;
   }

   dlg = gtk_dialog_new();
   std::string title = "Sequence: ";
   title.append(g_path_get_basename(ModelInfo[kmodel].modname));
   gtk_window_set_title(GTK_WINDOW(dlg), toUTF8(title.c_str()));
   GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
   gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), scrolledwindow1, TRUE, TRUE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
   gtk_widget_set_size_request(scrolledwindow1, 450, 350);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
        GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

   GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
   gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);

   GtkWidget *box = vbox_new(FALSE, 0);
   gtk_container_add (GTK_CONTAINER (viewport), box);
   gtk_container_set_border_width(GTK_CONTAINER(box), 5);
   GtkWidget *but = CHECK_BUTTON_BOLD ("View not Amino", MyBLUE, 1.1f);
   gtk_box_pack_start (GTK_BOX (box), but, FALSE, FALSE, 2);
   GtkWidget *box2 = vbox_new(FALSE, 0);
   g_object_set_data(G_OBJECT(but), "box2", box2);
   g_signal_connect(G_OBJECT(but), "toggled", G_CALLBACK(RefillSequence), GINT_TO_POINTER(kmodel));
   FillSequence(box2, kmodel, 0);
   gtk_box_pack_start (GTK_BOX (box), box2, TRUE, TRUE, 10);

  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = GLWINDOW;
  st->name = SequenceWindow;
  GtkWidget *button = myimage_button("  _Export", "save.png");
  gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_ACCEPT);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(SaveSequence), GINT_TO_POINTER(kmodel));
  button = CLOSE_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(chiudi_dlg), (gpointer) st);
  g_signal_connect_swapped(G_OBJECT(dlg), "delete-event", G_CALLBACK(gtk_button_clicked), button);
  g_object_set_data(G_OBJECT(GLWINDOW), SequenceWindow, dlg);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

   gtk_widget_show_all(dlg);
}

void on_ViewSequenceButton(GtkWidget *button, gpointer )
{
   GtkWidget *window = gtk_widget_get_toplevel(button);
   int kmodel = get_int(window, "whichModel") - 1;
   if(kmodel < 0)
      return;
   ViewSequence(kmodel);
}

void creastructureinfo (GtkWidget *father, GtkWidget *notebook, PangoFontDescription *fontlist)
{
  PangoFontDescription *fontd = pango_font_description_copy(fontlist);
//  int sz = pango_font_description_get_size(fontd);
//  pango_font_description_set_size(fontd, (int)((double)sz*1.25));

  GtkWidget *parentbox = vbox_new (FALSE, 2);
  gtk_widget_show (parentbox);
  gtk_container_add (GTK_CONTAINER (notebook), parentbox);

  GtkWidget *sc = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sc),
      GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (sc);
  gtk_box_pack_start(GTK_BOX(parentbox), sc, TRUE, TRUE, 0);

  GtkWidget *vbox = vbox_new(FALSE, 0);
  add_to_scrollwin(sc, vbox);
  GtkWidget *dum = LABEL_NEW("", NULL);
  gtk_box_pack_start(GTK_BOX(vbox), dum, FALSE, FALSE, 0);
  gtk_widget_show(dum);
  gtk_label_set_selectable(GTK_LABEL(dum), TRUE);
  GtkWidget *info = LABEL_NEW("info", NULL);
  gtk_box_pack_start(GTK_BOX(vbox), info, TRUE, TRUE, 0);
//  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(sc), info);
  gtk_widget_show(info);
  widget_modify_font(info, fontd);
  pango_font_description_free(fontd);
  widget_modify_bg(gtk_bin_get_child(GTK_BIN(sc)), GTK_STATE_NORMAL, &colorWhite);
  gtk_label_set_selectable(GTK_LABEL(info), TRUE);

  GtkWidget *hbox = hbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  g_object_set_data(G_OBJECT(father), "box_tasti", (gpointer) hbox);

  GtkWidget *but = gtk_button_new_with_label("  Text  ");
  gtk_box_pack_start(GTK_BOX(hbox), but, FALSE, FALSE, 2);
  g_signal_connect(G_OBJECT(but), "clicked", G_CALLBACK(ViewText), NULL);
  but = gtk_button_new_with_label("Sequence");
  gtk_box_pack_start(GTK_BOX(hbox), but, FALSE, FALSE, 2);
  g_signal_connect(G_OBJECT(but), "clicked", G_CALLBACK(on_ViewSequenceButton), NULL);
  but = gtk_button_new_with_label("Secondary");
  gtk_box_pack_end(GTK_BOX(hbox), but, FALSE, FALSE, 2);
  g_signal_connect(G_OBJECT(but), "clicked", G_CALLBACK(ViewSecondary), NULL);

  std::stringstream s;
  s << PAGE_STRUCTURE;
  g_object_set_data(G_OBJECT(notebook), s.str().c_str(), (gpointer) info);
  g_object_set_data(G_OBJECT(father), s.str().c_str(), (gpointer) info);
  set_tab_label (GTK_NOTEBOOK (notebook), PAGE_STRUCTURE, "Structure");
}

static void onTog(GtkToggleButton *but, int *val)
{
  *val = gtk_toggle_button_get_active(but);
}

bool scegliColonne (int *vet, char **cols, int num)
{
   if(!GLWINDOW)
      return false;
  GtkWidget *dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "Details selection");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));

  GtkWidget *label = label_boxed("Select the columns to be saved.");
  gtk_box_pack_start(GTK_BOX(vbox1), label, FALSE, FALSE, 4);

  GtkWidget *hbox1 = hbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, FALSE, 4);
  GtkWidget *hbox2 = hbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, FALSE, 4);
#ifndef IN_GTK3
  GtkSizeGroup *sz = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
#endif
  for(int i=0; i<num; i++)
  {
      label = gtk_label_new(cols[i]);
      gtk_box_pack_start(GTK_BOX(hbox1), label, TRUE, TRUE, 0);
#ifndef IN_GTK3
      gtk_size_group_add_widget(sz, label);
#endif
      label = gtk_check_button_new();
      gtk_box_pack_start(GTK_BOX(hbox2), label, TRUE, TRUE, 0);
#ifndef IN_GTK3
      gtk_size_group_add_widget(sz, label);
#endif
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), vet[i]);
#ifdef IN_GTK3
      gtk_widget_set_halign(label, GTK_ALIGN_CENTER);
#endif
      g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(onTog),
                       &vet[i]);
  }
  GtkWidget *button = OK_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_OK);
  button = CANCEL_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_CANCEL);
  gtk_widget_show_all(dialog1);
  int result = gtk_dialog_run(GTK_DIALOG(dialog1));
  gtk_widget_destroy(dialog1);
  if(result == GTK_RESPONSE_OK)
     return true;
  for(int i=0; i<num; i++)
      vet[i] = 1;
  return false;
}

void save_viewer(GtkWidget *view, GtkWidget *window)
{
using namespace gtkext;
     std::string curdir = getPWD();
     std::string fn;
     fn =  dlg_select_file(window, fn, eSELECT_TO_WRITE, "*.png", false);
     if(!str_white(fn.c_str()))
        save_pixbuf_from_window(view, fromUTF8(fn).c_str());
     dir_set_current(curdir.c_str());
}

void export_info(std::ostream &os, int vet[], char *titoli[], int ncolumns,
      GType types[], int pr[], std::vector<rowlist_type> Ls)
{
using namespace std;
    int wi = 12;
    if(Ls.empty())
       return;
    int n = (int) Ls.size()/10;
    for (int i=0; i<ncolumns; i++)
    {
         if(!vet[i])
            continue;
         if(types[i] == G_TYPE_FLOAT)
         {
            int diff = MRabs((int)strlen(titoli[i]) -pr[i] - 5) -1;
            os.width(diff);
            os.fill(' ');
            os << left << "";
            os.width(wi-diff);
            os.fill(' ');
            os << left << titoli[i];
         }
         else
         {
            os.width(wi);
            os.fill(' ');
            os << left << titoli[i];
         }
    }
    os << "\n";
    for (int j=0; j<n; j++)
    {
         for (int i=0; i<ncolumns; i++)
         {
              rowlist_type Row = Ls.at(j*10+i);
              if(!vet[i])
                 continue;
              os.width(wi);
              os.fill(' ');
              if(types[i] == G_TYPE_STRING)
                 os << left << g_strstrip(g_strdup(Row.str));
              else if(types[i] == G_TYPE_INT)
                 os << left << Row.num;
              else if(types[i] == G_TYPE_FLOAT)
                 os << left << fToStr2(Row.val, pr[i]);
         }
         os << "\n";
    }
}

//#ifndef JAV
void save_info (GtkButton *button, GtkWidget *nb)
{
using namespace gtkext;
   GtkWidget *dlg = gtk_widget_get_toplevel(nb);
   int ipage = gtk_notebook_get_current_page(GTK_NOTEBOOK(nb));
   std::stringstream s;
   s << ipage;
   GtkWidget *list = get_widget(nb, s.str().c_str());
//   GtkWidget *combo = get_widget(dlg, "iso_combo");
//   int val = combo_get_val(combo);
   int whichModel = GetActiveModel() - 1;
   std::string fn;
   if(ModelInfo[whichModel].created)
      fn = g_path_get_basename(ModelInfo[whichModel].modname);
   else
      fn = "";
   size_t pos = fn.find_last_of(".");
   if(pos != std::string::npos)
      fn.erase(pos);
   fn.append(".txt");

   if(ipage == PAGE_BARS)               // bar chart
   {
      save_viewer(list, dlg);
      return;
   }
   else if(ipage == PAGE_STRUCTURE)
   {
      GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
      FilselItem local_item;
      std::string bckfile;
      std::string curdir = getPWD();
      local_item = gtkext::saveas(dlg, "*.txt", fn.c_str());
      dir_set_current(curdir.c_str());
      if(local_item.exitCode > 0)
      {
          bckfile = local_item.cwd;
          bckfile.append(local_item.fileinp);
//        bckfile.append(str_cut(local_item.fileinp, "."));
//        bckfile.append(".txt");
          int whichModel = get_int(dlg, "whichModel")-1;
          char *filbck = g_strdup(fromUTF8(bckfile).c_str());
          std::stringstream os;
          ModelInfo[whichModel].FillStructureInfo(gl, os, false);
          std::ofstream f;
          f.open(filbck);
          g_free(filbck);
          if(!f)
             return;
          f << os.str();
          f.close();
//        ipage = ipage + 1;
//        whichModel = whichModel + 1;
//          jav_save_info_(filbck, &whichModel, &ipage, &ncolumns,
//              NULL, &val, strlen(filbck));
      }
      return;
   } 
   GList *cols = gtk_tree_view_get_columns(GTK_TREE_VIEW(list));
   int ncolumns = (int) g_list_length(cols);
   if(ipage == PAGE_ATOMS) 
      ncolumns--;
   char **titoli = g_new0(char *, ncolumns);
   int  *pr = g_new0(int, ncolumns);
   GType *types = g_new0(GType, ncolumns);
   for(int i=0; i<ncolumns; i++)
   {
       GtkTreeViewColumn *c = (GtkTreeViewColumn *)g_list_nth_data(cols, i);
       titoli[i] = g_strdup(gtk_tree_view_column_get_title(c));
       types[i] = gtk_tree_model_get_column_type(
          gtk_tree_view_get_model(GTK_TREE_VIEW(list)), i);
       pr[i] = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(c), "precision"));
   }
   g_list_free(cols);
   int *vet = g_new0(int, ncolumns);
   for(int i=0; i<ncolumns; i++)
       vet[i] = 1;
   if(scegliColonne(vet, titoli, ncolumns))
   {
      FilselItem local_item;
      std::string bckfile;
      std::string curdir = getPWD();
      local_item = gtkext::saveas(dlg, "*.txt", fn.c_str());
      dir_set_current(curdir.c_str());
      if(local_item.exitCode > 0)
      {
          bckfile = local_item.cwd;
          bckfile.append(local_item.fileinp);
//          bckfile.append(str_cut(local_item.fileinp, "."));
//          bckfile.append(".txt");
          int num_elems = 0;
          std::vector<rowlist_type> Ls;
          std::vector<jav_generic_type> Rows;
          Ls = ReadList(ipage, list, &num_elems, Rows);
          char *filbck = g_strdup(fromUTF8(bckfile).c_str());
          std::ofstream os;
          os.open(filbck);
          g_free(filbck);
          if(!os)
             return;
          export_info(os, vet, titoli, ncolumns, types, pr, Ls);
          os.close();
//        ipage = ipage + 1;
//        int whichModel = get_int(dlg, "whichModel");
//          jav_save_info_(filbck, &whichModel, &ipage, &ncolumns,
//              vet, &val, strlen(filbck));
      }
   }
   g_free(vet);
   for(int i=0; i<ncolumns; i++)
       g_free(titoli[i]);
   g_free(titoli);
}
//#endif

void Model::FillListContacts(GtkWidget *dlg)
{
       GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
       GtkTreeView *list = GTK_TREE_VIEW(get_widget(dlg, "cont"));
       GtkTreeSelection *selection = gtk_tree_view_get_selection(list);
       GtkTreeIter iter;
       GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
       int hnd = get_int(GTK_WIDGET(list), "hnd");
       g_signal_handler_block(G_OBJECT(selection), hnd);
       gtk_list_store_clear(GTK_LIST_STORE(list_store));
       int alt = get_int(dlg, "alt");
       int nconn_eff = 0;
       
       if(GetInfo(IFHBONDS, nModello))
       {
          for(int i=0; i<nlegsH; i++)
          {
              PixNum  *numb = g_new0(PixNum , 1);
              int n1 = MRabs(legsH[i].n1) - 1;
              int n2 = MRabs(legsH[i].n2) - 1;
              float dist = legsH[i].dist;
              char *label1 = g_strdup(atm[n1].lab);
              char *label2 = g_strdup(atm[n2].lab);
              int ko = atm[n1].op.op;
              char *label3 = g_strdup(getStringSymm(&ko));
              ko = atm[n2].op.op;
              char *label4 = g_strdup(getStringSymm(&ko));
              gtk_list_store_append (list_store, &iter);
              numb->num = i+1;
              numb->icon = create_rect(gl->ColorHB);

              gtk_list_store_set (list_store, &iter, 0, (gpointer) numb, //i+1,
                 1, g_strstrip(label1), 2, g_strstrip(label2),
                 3, dist, 4, g_strstrip(label3), 
                 5, g_strstrip(label4), -1);
              nconn_eff++;
              g_free(numb);
          }
       }
       int i0 = nconn_eff;
       if(GetInfo(IFSHORTC, nModello))
       {
          for(int i=0; i<nlegsW; i++)
          {
              PixNum  *numb = g_new0(PixNum , 1);
              int n1 = MRabs(legsW[i].n1) - 1;
              int n2 = MRabs(legsW[i].n2) - 1;
              float dist = legsW[i].dist;
              char *label1 = g_strdup(atm[n1].lab);
              char *label2 = g_strdup(atm[n2].lab);
              int ko = atm[n1].op.op;
              char *label3 = g_strdup(getStringSymm(&ko));
              ko = atm[n2].op.op;
              char *label4 = g_strdup(getStringSymm(&ko));
              gtk_list_store_append (list_store, &iter);
              numb->num = i0+i+1;
              numb->icon = create_rect(gl->ColorSC);
              gtk_list_store_set (list_store, &iter, 0, (gpointer) numb,
                 1, g_strstrip(label1), 2, g_strstrip(label2),
                 3, dist, 4, g_strstrip(label3), 
                 5, g_strstrip(label4), -1);
              nconn_eff++;
              g_free(numb);
          }
       }
       gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"),
          -1, (int) MRmin(1.7f*(nconn_eff+1)*alt, 20*alt));
       g_signal_handler_unblock(G_OBJECT(selection), hnd);
}

void crealistacontacts (GtkWidget *father, GtkWidget *notebook, PangoFontDescription *fontlist)
{
  GtkWidget *label;
  GtkWidget *parentbox = vbox_new (FALSE, 2);
  gtk_widget_show (parentbox);
  gtk_container_add (GTK_CONTAINER (notebook), parentbox);
  gtk_widget_set_name(parentbox, "contacts");

  const char *titles[] = { "Number", "Atom 1", "Atom 2", "Distance",
                           "Symm.Op1", "Symm.Op2"};
  GType types[] = { PIX_NUM_TYPE, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_FLOAT,
                    G_TYPE_STRING, G_TYPE_STRING};
  int  sizes[] = { 0, 0, 0, 0, 0, 0 };
  int  precs[] = { 0, 0, 0, 5, 0, 0 };
  int sort_type[] = {NO, A1, A2, F5, A3, A4}; 
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  GtkWidget *list = 
  new_selection(father, parentbox, "cont", ncol, titles, sizes, types, precs);
  g_object_set_data(G_OBJECT(list), "father_b", parentbox);
  widget_modify_font(list, fontlist);
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
      gtk_tree_view_column_set_clickable(column, TRUE);
      g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(-1));
      g_object_set_data(G_OBJECT(column), "father", list);
      if(sort_type[i] >= 0)
      g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(sort_col_g),
                 GINT_TO_POINTER(sort_type[i]));
  }
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_contact), father);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));

  std::stringstream s;
  s << PAGE_CONTACTS;
  g_object_set_data(G_OBJECT(notebook), s.str().c_str(), (gpointer) list);
  set_tab_label (GTK_NOTEBOOK (notebook), PAGE_CONTACTS, "Contacts");
}

void on_info_switch_page (GtkNotebook *notebook, GtkWidget *page,
                          guint page_num, gpointer data)
{
   GtkWidget *dlg = (GtkWidget *)data;
   int whichModel = get_int(dlg, "whichModel") - 1;
   GtkWidget *but = get_widget(dlg, "export_b");
   gtk_widget_set_sensitive(but, TRUE);
   if(!ModelInfo[whichModel].isPDB)
      return;
   if (page_num == PAGE_ATOMS)
       gtk_widget_set_sensitive(but, FALSE);
}

GtkWidget *create_info (GtkWidget *window, GList *listModels)
{
   if(!GLWINDOW)
      return NULL;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  GtkWidget *dialog1;
  GtkWidget *button;
  GtkWidget *frame;
  GtkWidget *combo=NULL;
  int lar, alt;
//  GtkSizeGroup *szgroup = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
//  GtkSizeGroup *szgroup1 = gtk_size_group_new(GTK_SIZE_GROUP_VERTICAL);
  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1),
             toUTF8(g_path_get_basename(ModelInfo[0].modname)));
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
  g_object_set_data(G_OBJECT(dialog1), "alt", GINT_TO_POINTER(alt));
 
  if(gl->nModels > 1)
  {
     frame = FRAME_BOLD("Select model", MyBLUE, 1.1f);
     gtk_box_pack_start(GTK_BOX(vbox1), frame, FALSE, FALSE, 10);
     combo = create_combo (NULL, NULL, 0, 0, NULL, G_CALLBACK(selected_model), false);
     block_handler(combo);
     set_popdown_strings(combo, listModels);
     unblock_handler(combo);
     gtk_container_add(GTK_CONTAINER(frame), get_widget(combo, "parent"));
     gtk_container_set_border_width(GTK_CONTAINER(get_widget(combo, "parent")), 8);
  }
  else
     g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(1));

  GtkWidget *notebook = NewNotebook(vbox1);
//  widget_modify_bg(notebook, GTK_STATE_NORMAL, &colorWhite);   //NEW
  gtk_widget_show (notebook);
  g_object_set_data(G_OBJECT(dialog1), "nb", notebook);
  creastructureinfo (dialog1, notebook, fontlist);
  crealistaatomi (dialog1, notebook, fontlist);
  crealistalegami (dialog1, notebook, fontlist);
  crealistaangoli (dialog1, notebook, fontlist);
  crealistatorsioni (dialog1, notebook, fontlist);
  creabarchart (dialog1, notebook, fontlist);
  crealistacontacts (dialog1, notebook, fontlist);

//#ifndef JAV
  button = myimage_button("_Export", "save.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 1);
  g_object_set_data(G_OBJECT(dialog1), "export_b", button);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(save_info), notebook);
//#endif

  button = myimage_button("  _Close", "cancel.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = InfoAtomsW;

  (void) g_signal_connect(G_OBJECT (notebook), "switch-page",
         G_CALLBACK(on_info_switch_page), (gpointer) dialog1);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(chiudi_dlg), (gpointer) st);

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show_all(dialog1);
  g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(1));

  if(combo != NULL)
     combo_set_val(combo, 1);

  g_object_set_data(G_OBJECT(dialog1), "whichAtom", GINT_TO_POINTER(-1));
  return dialog1;
}

void on_select_mode(gpointer, gpointer )
{
   set_mode('S', true);
}

void on_mol_select_mode(gpointer, gpointer )
{
   set_mode('F', true);
}

void on_rect_select_mode(gpointer, gpointer )
{
   set_mode('R', true);
}

void on_zoom_mode(gpointer, gpointer )
{
   set_mode('Z', true);
}

void on_manipulation_mode(gpointer, gpointer )
{
   set_mode('M', true);
}

void PointerMode(gpointer item, gpointer data)
{
   int modo = GPOINTER_TO_INT(data);
   if(!obj_get_active(item))
   {
      set_mode(modo+'1', false);
      return;
   }
   switch(modo)
   {
   case 0:
        set_motion_type(ON_SELECT, 1);
        break;
   case 1:
        set_motion_type(RECT_SELECT, 1);
        break;
   case 2:
        set_motion_type(MOL_SELECT, 1);
        break;
   case 3:
        set_motion_type(NO_MOVE, 0);
        break;
   case 4:
        set_motion_type(ZOOM_MODE, 4);
        break;
   case 5:
   case 6:
   case 7:
        set_motion_type(GEOM-3+modo, 3);
        break;
   }
   set_mode(modes[modo], false);
}

void close_sphere(GtkWidget *button, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   GtkWidget *dlg = gtk_widget_get_toplevel(button);

   for(int i=0; i<gl->nModels; i++)
   {
       for(int j=0; j<ModelInfo[i].nats; j++)
           ModelInfo[i].atm[j].drawLabel = 0;
   }
   gtk_widget_destroy(dlg);
   g_object_set_data(G_OBJECT(window), "sphere_dlg", NULL);
   set_motion_type(NO_MOVE, 0);
   gl->SetSphereCentre(-1, -1, false);
   gl->SetSphereRadius(-1, false);
   DrawSphere = false;
   on_unselect(NULL, (gpointer) GLWINDOW);
   gl->Redraw();
   updateModify(1);
}

static void selected_row_sphere(GtkTreeSelection  *sele, gpointer data)
{
   if(!GLWINDOW)
      return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     GtkTreeView *tree_view;
     int row;
     GtkWidget *dlg = (GtkWidget *)data;
     int whichModel = get_int(dlg, "whichModel") - 1;

     for(int i=0; i<ModelInfo[whichModel].nats; i++)
         ModelInfo[whichModel].atm[i].selected = false;
     ModelInfo[whichModel].atoms_sel.clear();

     tree_view = gtk_tree_selection_get_tree_view(sele);
     GList *rowsel = NULL;
     rowsel = get_selections(GTK_WIDGET(tree_view));
     if(rowsel)
     {
        int num_sel = g_list_length(rowsel);
        for(int i=0; i<num_sel; i++)
        {
             GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
             gpointer riga =
                 get_selection_from_pathC(tree_view, path, 0);
             row = GPOINTER_TO_INT(riga);
             ModelInfo[whichModel].atm[row].selected = true;
             ModelInfo[whichModel].atoms_sel.push_back(row+1);
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
     }
     gl->Redraw();
}

void crealistasphere (GtkWidget *father, GtkWidget *parentbox)
{
  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  int alt, lar;
  get_metrics(fontlist, &lar, &alt);

  const char *titles[] = { "Number", "Atom", "Distance", "Symm.Op"};
  int  sizes[] = { -1, 0, 0, 0 };
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_FLOAT, G_TYPE_STRING };
  int precs[] = { 0, 0, 3, 0 };
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  GtkWidget *list =
  new_selection(father, parentbox, "sphere_list", ncol, titles, sizes, types, precs);
  widget_modify_font(list, fontlist);
  g_object_set_data(G_OBJECT(list), "alt", GINT_TO_POINTER(alt));
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      GtkWidget *label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
  }
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_row_sphere), father);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));
}

void on_change_radius(GtkWidget *spin, gpointer data)
{
   GLWindow *gl = (GLWindow *) data;
   float r = (float) spin_button_get_value(spin);
   gl->SetSphereRadius(r);
}

void scelto_centro(GtkEntry *entry, gpointer data)
{
   char *lab = g_strstrip(g_strdup(gtk_entry_get_text(entry)));
   GLWindow *gl = (GLWindow *)data;
   int wm = 0, wa = -1;
   for(int i=0; i<ModelInfo[wm].nats; i++)
   {
       char *lab1 =  g_strstrip(g_strdup(ModelInfo[wm].atm[i].lab));
       if(g_ascii_strcasecmp(lab, lab1) == 0)
       {
          wa = i;
          break;
       }
   }
   if(wa > -1)
      gl->SetSphereCentre(wm, wa, true);  
   set_error_color(GTK_WIDGET(entry), (wa < 0));
}

GtkWidget *create_sphere_dlg (gpointer data)
{
  GtkWidget *dialog1;
  GtkWidget *vbox1;
  GtkWidget *label;
  GtkWidget *frame;
  GtkWidget *spin;
  GtkWidget *button;
  GtkWidget *window = (GtkWidget *) data;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "Sphere");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG (dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
  g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(1));

  frame = gtk_frame_new(NULL);
  gtk_box_pack_start(GTK_BOX(vbox1), frame, FALSE, FALSE, 4);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);

  GtkWidget *vbox = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame), vbox);
  label = LABEL_NEW("Click on centre or enter label of atom", MyRED);
  gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(dialog1), "hint", label);
  set_motion_type(GEOM+1, 3);

  GtkWidget *table = table_new(2, 2, FALSE);
  gtk_box_pack_start(GTK_BOX(vbox), table, FALSE, FALSE, 4);
  table_set_col_spacings(table, 8);
  table_set_row_spacings(table, 8);
  label = LABEL_NEW("Radius of the sphere", NULL);
  set_alignment(label, 0., 0.5);
  table_attach_exp(table, label, 0, 1, 0, 1);
  spin = SPIN_NEW(0.1, 6.f, sphereRadius, 0.05f, 3);
  g_object_set_data(G_OBJECT(dialog1), "sphere_radius", spin);
  set_width_chars(GTK_ENTRY(spin), 10);
  table_attach_exp(table, spin, 1, 2, 0, 1);
  int hnd = g_signal_connect(G_OBJECT(spin), "value-changed",
                   G_CALLBACK(on_change_radius), (gpointer) gl);
  g_object_set_data(G_OBJECT(spin), "hnd", GINT_TO_POINTER(hnd));
/*
  spin = SPIN_WITH_LABEL("Radius of the sphere", NULL, 0.1, 6.f, sphereRadius, 0.05f, 3);
  g_object_set_data(G_OBJECT(dialog1), "sphere_radius", get_widget(spin, "spin"));
  gtk_box_pack_start(GTK_BOX(vbox), spin, FALSE, FALSE, 4);
  int hnd = g_signal_connect(G_OBJECT(get_widget(spin, "spin")), "value-changed",
                   G_CALLBACK(on_change_radius), (gpointer) gl);
  g_object_set_data(G_OBJECT(get_widget(spin, "spin")), "hnd",
               GINT_TO_POINTER(hnd));
*/

  label = LABEL_NEW("Centre of the sphere: ", NULL);
  set_alignment(label, 0., 0.5);
  table_attach_exp(table, label, 0, 1, 1, 2);
  label = gtk_entry_new();
  g_object_set_data(G_OBJECT(dialog1), "sphere_centre", label);
  set_width_chars(GTK_ENTRY(label), 10);
  hnd = g_signal_connect(G_OBJECT(label), "activate", G_CALLBACK(scelto_centro),
         (gpointer) gl);
  g_object_set_data(G_OBJECT(label), "hnd", GINT_TO_POINTER(hnd));
  
  table_attach_exp(table, label, 1, 2, 1, 2);
  gtk_widget_set_can_focus(label, TRUE);
  gtk_widget_grab_focus(label);
//  gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 4);

  frame = FRAME_BOLD ("Results", MyBLUE, 1.2f);
  gtk_box_pack_start(GTK_BOX(vbox1), frame, TRUE, TRUE, 4);
  crealistasphere(dialog1, frame);

  gl->SetSphereCentre(-1, -1);
  gl->SetSphereRadius(-1);
  button = myimage_button("  _Close", "cancel.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 1);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(close_sphere), data);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return dialog1;

}

void on_Sphere(gpointer,  gpointer data)
{
using namespace gtkext;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   GtkWidget *dlg;

   if(!gl->nModels)
   {
      dlg_errmsg(GTK_WINDOW(window), "Sorry. No models loaded.");
      return;
   }
   updateModify(-99);
   if(g_object_get_data(G_OBJECT(window), "sphere_dlg"))
   {
      dlg = get_widget(window, "sphere_dlg");
      gdk_window_raise(gtk_widget_get_window(dlg));
      return;
   }

   dlg = create_sphere_dlg(data);
   g_object_set_data(G_OBJECT(window), "sphere_dlg", dlg);
   gtk_widget_show_all(dlg);
}

void GLWindow::DeleteAllMapModels()
{
    for(int i=0; i<nModels; i++)
    { 
        ModelInfo[i].freeModel();
        ModelInfo[i].created = 0;
    } 
    nModels = 0;
    for(int i=0; i<nMaps; i++)
    { 
        MapInfo[i].freeMap();
        if((MapInfo[i].ifDifference <= 1))
            usedC[i] = -1; 
    } 
    nMaps = 0;
}

void GLWindow::SetSphereCentre(int wm, int wa, bool ifRedraw)
{
    if((wm != -1) && (wa != -1))
    {
        sphereCentre = wa + 1;
        DrawSphere = true;
        for(int i=0; i<3; i++)
            SphereCentre[i] = ModelInfo[wm].atm[wa].xyzN[i];
        float dist = sphereRadius;
        int kat = sphereCentre;
        int kmodel = wm+1;
        jav_sphere_(&kat,&dist, &kmodel);
    }
    else
    {
        sphereCentre = -1;
        DrawSphere = false;
    }
    if(g_object_get_data(G_OBJECT(GLWINDOW), "sphere_dlg"))
    {
       GtkWidget *dlg = get_widget(GLWINDOW, "sphere_dlg");
       GtkWidget *label = get_widget(dlg, "sphere_centre");
       std::string lab_str = "";//"Centre of the sphere: ";
       if(DrawSphere)
          lab_str.append(ModelInfo[wm].atm[wa].lab);
//       gtk_label_set_text(GTK_LABEL(label), lab_str.c_str());
       int hnd = get_int(label, "hnd");
       g_signal_handler_block(G_OBJECT(label), hnd);
       gtk_entry_set_text(GTK_ENTRY(label), trim(lab_str).c_str());
       g_signal_handler_unblock(G_OBJECT(label), hnd);
       label = get_widget(dlg, "sphere_radius");
       hnd = get_int(label, "hnd");
       g_signal_handler_block(G_OBJECT(label), hnd);
       if(DrawSphere)
          spin_button_set_value(label, sphereRadius);
       else
          spin_button_set_value(label, 1.5);
       g_signal_handler_unblock(G_OBJECT(label), hnd);
    }
    if(ifRedraw)
       Redraw();
}

void GLWindow::SetSphereRadius(float r, bool ifRedraw)
{
    if(r > 0)
       sphereRadius = r;
//    SphereRadius = 2.f * Range * r / deltav;
    SphereRadius = 2.f * sphereRadius / deltav;
    if(sphereCentre > 0)
    {
       float dist = sphereRadius;
       int kat = sphereCentre;
       int kmodel = 1;
       if(g_object_get_data(G_OBJECT(GLWINDOW), "sphere_dlg"))
       {
          GtkWidget *dlg = get_widget(GLWINDOW, "sphere_dlg");
          kmodel = get_int(dlg, "whichModel");
       }
       jav_sphere_(&kat,&dist, &kmodel);
    }
    if(ifRedraw)
       Redraw();
}

void GLWindow::drawSphere()
{
   if(DrawSphere)
   {
//       float mat_e[4] = {0.38f, 0.85f, 0.85f, 0.3f};  //light cyan
       float mat_e[4] = {0.837f, 1.0f, 1.0f,   1.0f};//light cyan
       SetLightForSelected(1, mat_e, 0.3f);
       glPushMatrix();
       glTranslatef( SphereCentre[0], SphereCentre[1], SphereCentre[2]);
       int subd = (int) (250.f * SphereRadius);
       Sfera (TRUE, SphereRadius, subd);
       glPopMatrix();
       ResetLightForSelected();
   }
}

void GLWindow::AggiornaListaSpecie()
{
      NSpecies = 0;
      for(int j=0; j<MAX_NUM_MODELS*MAX_SPECIES;j++)
          ListaSpecies[j] = -1;
      if(!nModels)
          return;
      int *p;
      for (int k=0; k< nModels; k++)
      {
           for (int i=0; i< ModelInfo[k].numSpec; i++)
           {
                int sp = ModelInfo[k].Species[i];
                p = std::find(ListaSpecies, ListaSpecies+NSpecies, sp);
                if(p == ListaSpecies+NSpecies)
                {
                   ListaSpecies[NSpecies] = sp;
                   NSpecies++;
                }
           }
      }
      std::vector<int> myvector (ListaSpecies, ListaSpecies+NSpecies);
      sort (myvector.begin(), myvector.end());
      for(int i=0; i<NSpecies; i++)
          ListaSpecies[i] = myvector.at(i);
}

void selected_atom_to_edit(GtkTreeSelection  *sele, gpointer data)
{
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     GtkTreeView *tree_view;
     int row;
     GtkWidget *dlg = (GtkWidget *)data;
     int whichModel = get_int(dlg, "whichModel") - 1;

     int natoms = MRmin(ModelInfo[whichModel].nats_au, ModelInfo[whichModel].nats);
     for(int i=0; i<natoms; i++)
     {
         if(ModelInfo[whichModel].Equivs[i].empty())
            continue;
         int neq = (int) ModelInfo[whichModel].Equivs[i].size();
         for(int keq=0; keq<neq; keq++)
         {
             int ieq = ModelInfo[whichModel].Equivs[i].at(keq);
             ModelInfo[whichModel].atm[ieq].selected = false;
         }
     }
     ModelInfo[whichModel].atoms_sel.clear();

     tree_view = gtk_tree_selection_get_tree_view(sele);
     GList *rowsel = NULL;
     rowsel = get_selections(GTK_WIDGET(tree_view));
     GtkWidget *but = get_widget(dlg, "delete_b");
     if(but)
        gtk_widget_set_sensitive(but, (rowsel != NULL));

     if(rowsel)
     {
        int num_sel = g_list_length(rowsel);
        for(int i=0; i<num_sel; i++)
        {
             GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
             gpointer riga =
                 get_selection_from_pathC(tree_view, path, 0);
             row = GPOINTER_TO_INT(riga) - 1;
             if(row >= natoms)
                continue;
             if(ModelInfo[whichModel].Equivs[row].empty())
                continue;
             int neq = (int) ModelInfo[whichModel].Equivs[row].size();
             for(int keq=0; keq<neq; keq++)
             {
                 int ieq = ModelInfo[whichModel].Equivs[row].at(keq);
                 ModelInfo[whichModel].atm[ieq].selected = true;
                 ModelInfo[whichModel].atoms_sel.push_back(ieq+1);
             }
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
        g_object_set_data(G_OBJECT(dlg), "whichAtom", GINT_TO_POINTER(0));
        but = get_widget(dlg, "bondinfo_b");
        if(but)
        {
           ModelInfo[whichModel].FillBondLengths(but, whichModel+1, row+1);
           gtk_widget_show_all(but);
        }
     }
     gl->Redraw();
}

static void on_edit_cell (GtkCellRendererText *cell, const gchar *path_string,
                          const gchar *new_text, gpointer data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
  GtkTreeIter iter;

  gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (cell), "column"));
  gint gt = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (cell), "gtype"));

  gtk_tree_model_get_iter (model, &iter, path);
  switch (gt)
  {
  case G_TYPE_STRING:
       {
             gchar *old_text;
             gtk_tree_model_get (model, &iter, column, &old_text, -1);
             g_free (old_text);
             gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                            g_strdup(new_text), -1);
       } 
       break;
  case G_TYPE_FLOAT:
       {
             float val = (float) atof(new_text);
             gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                            val, -1);
       break;
       } 
  case G_TYPE_INT:
       {
             int val =  atoi(new_text);
             gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                            val, -1);
       } 
       break;
  }
}

void on_cancel_edit_structure(GtkWidget *button, gpointer data)
{
  int code = 2;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  int whichModel = get_int(dlg, "whichModel");
  atom_type *atml = ModelEdit.FromIlmatomToAtom();
  int natoms = ModelEdit.nats_au;
  jav_edit_structure_(&code, atml, &natoms,&whichModel);
  chiudi_dlg(button, data);
  updateModify(1);
}

void on_apply_edit_structure(GtkWidget *button, gpointer data)
{
  int code = 3;
  if(data != NULL)
     code = GPOINTER_TO_INT(data);
  GtkWidget *dlg = get_widget(button, "toplevel");
  GtkWidget *list = get_widget(dlg, "atoms");
  int whichModel = get_int(dlg, "whichModel");
  int natoms = 0;
  atom_type *atml = ModelEdit.FromListToAtom(list, &natoms);
  jav_edit_structure_(&code, atml, &natoms,&whichModel);
}

void on_ok_edit_structure(GtkWidget *button, gpointer data)
{
  int code = 1;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  GtkWidget *list = get_widget(dlg, "atoms");
  int whichModel = get_int(dlg, "whichModel");
  int natoms = 0;
  atom_type *atml = ModelEdit.FromListToAtom(list, &natoms);
  jav_edit_structure_(&code, atml, &natoms,&whichModel);
  chiudi_dlg(button, data);
  updateModify(1);
}

static void reorder_items(GtkTreeModel *model, int row_deleted)
{
    GtkTreeIter iter;
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    jav_generic_type Row;
    while (valid)
    {
       gtk_tree_model_get(model, &iter,
              0, &Row.num, 1, &Row.lab1, 2, &Row.lab2,
              3, &Row.n6, 4, &Row.n1, 5, &Row.n2, 6, &Row.n3,
              7, &Row.n4, 8, &Row.n5, 9, &Row.lab3, -1);
       if(Row.num >= row_deleted)
       {
          Row.num--;
          gtk_list_store_set (GTK_LIST_STORE (model), &iter,
              0, Row.num, 1, Row.lab1, 2, Row.lab2,
              3, Row.n6, 4, Row.n1, 5, Row.n2, 6, Row.n3,
              7, Row.n4, 8, Row.n5, 9, Row.lab3, -1);
       }
       valid = gtk_tree_model_iter_next (model, &iter);
   }
}

static void on_remove(GtkWidget *button, gpointer data)
{
  GtkTreeIter iter;
  GtkTreeView *treeview = (GtkTreeView *)data;
  GtkTreeModel *model = gtk_tree_view_get_model (treeview);
  GtkTreeSelection *selection = gtk_tree_view_get_selection (treeview);
  GtkWidget *father = gtk_widget_get_toplevel(button);
  GtkWidget *apply_b = get_widget(father, "apply_b");

  if (gtk_tree_selection_get_selected (selection, NULL, &iter))
  {
      gint val;
      GtkTreePath *path;

      gtk_tree_model_get(model, &iter, 0, &val, -1);
      path = gtk_tree_model_get_path (model, &iter);
      gtk_list_store_remove (GTK_LIST_STORE (model), &iter);
      reorder_items(model, val);
      gtk_tree_path_free (path);
      on_apply_edit_structure(apply_b, GINT_TO_POINTER(-val));
  }
}

static void on_add(GtkWidget *, gpointer data)
{
    GtkTreeIter iter;
    GtkTreeView *treeview = (GtkTreeView *)data;
    GtkTreeModel *model = gtk_tree_view_get_model(treeview);
    jav_generic_type Row;
    Row.n1 = 0;
    Row.n2 = 0;
    Row.n3 = 0;
    Row.n4 = 1.f;
    Row.n5 = 1.f;
    Row.n6 = 0;
    Row.num = n_children(GTK_WIDGET(data)) + 1;
    Row.lab1 = g_strdup(" ");
    Row.lab2 = g_strdup(" ");
    Row.lab3 = g_strdup(" ");
    Row.lab4 = g_strdup(" ");
    Row.lab5 = g_strdup(" ");
    gtk_list_store_append (GTK_LIST_STORE (model), &iter);
    gtk_list_store_set (GTK_LIST_STORE (model), &iter,
              0, Row.num, 1, Row.lab1, 2, Row.lab2,
              3, Row.n6, 4, Row.n1, 5, Row.n2, 6, Row.n3,
              7, Row.n4, 8, Row.n5, 9, Row.lab3, -1);
    GtkTreePath *path = gtk_tree_model_get_path(model, &iter);
    GtkTreeViewColumn *column = gtk_tree_view_get_column(treeview, 1);
    gtk_tree_view_scroll_to_cell(treeview, path, column, FALSE, 0, 0);
    gtk_tree_view_set_cursor(treeview, path, column, TRUE);
//    select_row(GTK_WIDGET(treeview), Row.num-1);
}

void creaeditatomi (GtkWidget *father, GtkWidget *parent, PangoFontDescription *fontlist)
{
  GtkWidget *label;

  GtkWidget *parentbox = vbox_new (FALSE, 2);
  gtk_widget_show (parentbox);
  gtk_container_add (GTK_CONTAINER (parent), parentbox);
  const char *titles[] = { "Number", "Label", "Type", "Intensity",
                           "Xfrac", "Yfrac","Zfrac",
                           "  B  "," Occ.", "Symm.Op", "z"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_FLOAT,
                    G_TYPE_FLOAT, G_TYPE_FLOAT, G_TYPE_FLOAT,
                    G_TYPE_FLOAT, G_TYPE_FLOAT, G_TYPE_STRING, G_TYPE_INT};
  int  sizes[] = { 0, 0, 0, -1,
                   0, 0, 0,
                   0, 0, -1, -1 };
  int precs[] = { 0, 0, 1, 5,
                  5, 5, 5,
                  5, 3, 0, 0};

  int sort_type[] = {NO, A1, NS, F6,
                     F1, F2, F3,
                     F4, F5, A3, NS};

  bool editable[] = {false, true, true, false,
                     true, true, true,
                     true, true, false, false};

  GtkWidget *hbox = hbox_new(FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start(GTK_BOX(parentbox), hbox, TRUE, TRUE, 5);

  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  GtkWidget *list =
  new_selection(father, hbox, "atoms", ncol, titles, sizes, types, precs,
                editable, G_CALLBACK(on_edit_cell_and_apply));
  g_object_set_data(G_OBJECT(list), "father_b", parentbox);
  gtk_widget_set_name(parentbox, "atoms");
  widget_modify_font(list, fontlist);
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
      gtk_tree_view_column_set_clickable(column, TRUE);
      g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(-1));
      g_object_set_data(G_OBJECT(column), "father", list);
      g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(sort_col_g),
                 GINT_TO_POINTER(sort_type[i]));
  }
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_atom_to_edit), father);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));

  GtkWidget *vvbox = vbox_new(TRUE, 0);
  gtk_widget_show (vvbox);
  gtk_box_pack_start(GTK_BOX(hbox), vvbox, FALSE, FALSE, 5);

  GtkWidget *button = myimage_button("   Add", "add1atom");
  gtk_widget_show (button);
  gtk_box_pack_start(GTK_BOX(vvbox), button, FALSE, FALSE, 5);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_add), (gpointer) list);

  button = myimage_button("Delete", "delete");
  gtk_widget_show (button);
  gtk_box_pack_end(GTK_BOX(vvbox), button, FALSE, FALSE, 5);
  g_object_set_data(G_OBJECT(father), "delete_b", button);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_remove), (gpointer) list);
  gtk_widget_set_sensitive(button, FALSE);
}

GtkWidget *on_edit_structure (GtkWidget *window)
{
  GtkWidget *dialog1;
  GtkWidget *button;
  int lar, alt;

  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1),
             toUTF8(g_path_get_basename(ModelInfo[0].modname)));
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
  g_object_set_data(G_OBJECT(dialog1), "alt", GINT_TO_POINTER(alt));

  int inModify = GetActiveModel() - 1;
  g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(inModify+1));
  creaeditatomi (dialog1, vbox1, fontlist);

  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = EditAtomsW;

  button = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 1);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_ok_edit_structure), (gpointer) st);
  button = APPLY_button();
  //gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 2);
  g_object_set_data(G_OBJECT(button), "toplevel", (gpointer) dialog1);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_apply_edit_structure), NULL);
  g_object_set_data(G_OBJECT(dialog1), "apply_b", button);
  button = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 3);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_cancel_edit_structure), (gpointer) st);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show_all(dialog1);

  g_object_set_data(G_OBJECT(dialog1), "whichAtom", GINT_TO_POINTER(-1));
  return dialog1;
}

void Model::FillComboSpec(GtkWidget *dlg)
{
#ifdef GTK_CELL_RENDERER_COMBO
  GtkWidget *list = get_widget(dlg, "atoms");
  GtkTreeViewColumn *col = gtk_tree_view_get_column(GTK_TREE_VIEW(list), 2);
  GtkCellRenderer *cell = (GtkCellRenderer *) g_object_get_data(
                   G_OBJECT(col), "renderer");
  GtkListStore *model = gtk_list_store_new (1, G_TYPE_STRING);
  GtkTreeIter iter;
  for(int i=0; i < numSpec; i++)
  {
      gtk_list_store_append (model, &iter);
      gtk_list_store_set (model, &iter, 0, g_strdup(GetSpecies(i)), -1);
  }
  g_object_set(G_OBJECT(cell), "model", model, "has-entry", FALSE,
               "text-column", 0, "editable", TRUE, NULL);
#endif
}

void UpdateAtomsEdit()
{
   if(GLWINDOW == NULL)
      return;
   if(g_object_get_data(G_OBJECT(GLWINDOW), EditAtomsW))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, EditAtomsW);
      int whichModel = get_int(dlg, "whichModel") - 1;
      if(whichModel < 0)
         return;
      ModelEdit.FillListAtoms(dlg, true);
      ModelEdit.FillComboSpec(dlg);
   }
}

void AtomsEdit(GtkWidget *window, GLWindow *gl)
{
   GtkWidget *dlg;
   if(g_object_get_data(G_OBJECT(window), EditAtomsW))
   {
      dlg = get_widget(window, EditAtomsW);
      gdk_window_raise(gtk_widget_get_window(dlg));
   }
   else
   {
      dlg = on_edit_structure(window);
      g_object_set_data(G_OBJECT(window), EditAtomsW, dlg);
      int inModify = GetActiveModel();
      g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(inModify));
   }
   GtkWidget *but = get_widget(dlg, "delete_b");
   gtk_widget_set_sensitive(but, FALSE);
   updateModify(-99);
   int whichModel = get_int(dlg, "whichModel");
//   atom_type *atml = ModelInfo[whichModel-1].FromIlmatomToAtom();
   int code = 0;
   int natoms = ModelInfo[whichModel-1].nats_au;
   atom_type *atml = g_new0(atom_type, natoms);
   jav_edit_structure_(&code, atml, &natoms,&whichModel);
   if(ModelEdit.created)
      ModelEdit.freeModel();
   //ModelEdit = Model();
   //memcpy(&ModelEdit,  &ModelInfo[whichModel-1], ModelEdit.truesize());
   ModelEdit = *(ModelInfo[whichModel-1].Clone());
   ModelEdit.freeVectors(false);
   ModelEdit.nats = natoms;
   ModelEdit.FillAtoms(atml);
   UpdateAtomsEdit();
}

void StructureEdit(gpointer, gpointer data)
{
using namespace gtkext;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   if(!ModelInfo[whichModel].nats_au)
   {
      dlg_errmsg(GTK_WINDOW(GLWINDOW), "Sorry. No atoms on current model.");
      return;
   }
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   AtomsEdit(window, gl);
}

static void selected_bond_to_edit(GtkTreeSelection  *sele, gpointer data)
{
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     GtkTreeView *tree_view;
     int row;
     GtkWidget *dlg = (GtkWidget *)data;
     int whichModel = get_int(dlg, "whichModel") - 1;

     int nl = ModelInfo[whichModel].nconn_prot;
     int nl_au = ModelInfo[whichModel].nlegs_au;
     tree_view = gtk_tree_selection_get_tree_view(sele);
     GtkTreeModel *model = gtk_tree_view_get_model(tree_view);

     GtkTreeIter iter;
     if(gtk_tree_selection_get_selected(sele, &model, &iter))
     {
        GtkTreePath *path = gtk_tree_model_get_path (model, &iter);
        gpointer riga =
                 get_selection_from_pathC(tree_view, path, 0);
        row = GPOINTER_TO_INT(riga) - 1;
        if(row < 0) 
            return;
        g_object_set_data(G_OBJECT(dlg), "whichBond", GINT_TO_POINTER(row));
        for(int i=0; i<ModelInfo[whichModel].nconn_prot; i++)
            ModelInfo[whichModel].bonds[i].selected = false;
        ModelInfo[whichModel].bonds_sel.clear();
        if(nl == nl_au)
        {
           ModelInfo[whichModel].bonds[row].selected = true;
           ModelInfo[whichModel].bonds_sel.push_back(row+1);
        }
        else
        {
           int nn1 = ModelEdit.bonds[row].n1;
           int nn2 = ModelEdit.bonds[row].n2;
           for(int i=0; i<ModelInfo[whichModel].nconn_prot; i++)
           {
               int n1 = ModelInfo[whichModel].bonds[i].n1;
               int n2 = ModelInfo[whichModel].bonds[i].n2;
               int n1eq = ModelInfo[whichModel].iEqui[n1];
               int n2eq = ModelInfo[whichModel].iEqui[n2];
               if((n1eq == nn1) && (n2eq == nn2))
               {
                  ModelInfo[whichModel].bonds[i].selected = true;
                  ModelInfo[whichModel].bonds_sel.push_back(i+1);
               }
           }
        }
     }
     gl->Redraw();
}

void on_cancel_edit_bonds(GtkWidget *button, gpointer data)
{
  int code = 2;
  int selbond = 1;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  int whichModel = get_int(dlg, "whichModel");
  f_bond_type *legm = ModelEdit.FromIlmbondToLegm();
  jav_edit_bond_properties_(&code, legm, &whichModel, &selbond);
  chiudi_dlg(button, data);
  updateModify(1);
}

void on_apply_edit_bonds(GtkWidget *button, GtkWidget *dlg)
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  int code = 3;
  GtkWidget *list = get_widget(dlg, "conn");
  int whichModel = get_int(dlg, "whichModel");
  f_bond_type *legm = ModelEdit.FromListToLegm(list);
  int selbond = get_int(dlg, "whichBond") + 1;
  jav_edit_bond_properties_(&code, legm, &whichModel, &selbond);
  ModelEdit.FromLegmToList(list, legm);
  if(selbond >= 1)
  {
     ModelInfo[whichModel-1].bonds[selbond-1].selected = true;
     ModelInfo[whichModel-1].bonds_sel.push_back(selbond);
     gl->Redraw();
  }
}

void on_ok_edit_bonds(GtkWidget *button, gpointer data)
{
  int code = 1;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  GtkWidget *list = get_widget(dlg, "conn");
  int whichModel = get_int(dlg, "whichModel");
  f_bond_type *legm = ModelEdit.FromListToLegm(list);
  int selbond = get_int(dlg, "whichBond")+1;
  jav_edit_bond_properties_(&code, legm, &whichModel, &selbond);
  chiudi_dlg(button, data);
  on_unselect(NULL, (gpointer) GLWINDOW);
  updateModify(1);
}

void creaeditbonds (GtkWidget *father, GtkWidget *parent, PangoFontDescription *fontlist)
{
  GtkWidget *label;

  GtkWidget *parentbox = vbox_new (FALSE, 2);
  gtk_widget_show (parentbox);
  gtk_container_add (GTK_CONTAINER (parent), parentbox);
  const char *titles[] = { "Number", "Type", "Atom 1", "Atom 2", "Distance"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_FLOAT};
  int  sizes[] = { 0, 0, 0, 0, 0 };
  int  precs[] = { 0, 0, 0, 0, 5 };
  int sort_type[] = {NO, A3, A1, A2, F5 };
  bool editable[] = { false, false, false, false, true };
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));

  GtkWidget *list =
  new_selection(father, parentbox, "conn", ncol, titles, sizes, types, precs,
                editable, G_CALLBACK(on_edit_cell_and_apply));
  g_object_set_data(G_OBJECT(list), "father_b", parentbox);
  gtk_widget_set_name(parentbox, "conns");
  widget_modify_font(list, fontlist);
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
      gtk_tree_view_column_set_clickable(column, TRUE);
      g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(-1));
      g_object_set_data(G_OBJECT(column), "father", list);
      g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(sort_col_g),
                 GINT_TO_POINTER(sort_type[i]));
  }
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_bond_to_edit), father);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));
}

GtkWidget *on_edit_bonds (GtkWidget *window)
{
  GtkWidget *dialog1;
  GtkWidget *button;
  int lar, alt;

  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1),
             toUTF8(g_path_get_basename(ModelInfo[0].modname)));
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
  g_object_set_data(G_OBJECT(dialog1), "alt", GINT_TO_POINTER(alt));

  int inModify = GetActiveModel() - 1;
  g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(inModify+1));
  creaeditbonds (dialog1, vbox1, fontlist);

  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = EditBondsW;

  button = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 1);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_ok_edit_bonds), (gpointer) st);
  button = APPLY_button();
  //gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 2);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_apply_edit_bonds), dialog1);
  g_object_set_data(G_OBJECT(dialog1), "apply_b", button);
  button = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 3);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_cancel_edit_bonds), (gpointer) st);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show_all(dialog1);

  g_object_set_data(G_OBJECT(dialog1), "whichBond", GINT_TO_POINTER(-1));
  return dialog1;
}

void UpdateBondsEdit()
{
   if(GLWINDOW == NULL)
      return;
   if(g_object_get_data(G_OBJECT(GLWINDOW), EditBondsW))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, EditBondsW);
      int whichModel = get_int(dlg, "whichModel") - 1;
      if(whichModel < 0)
         return;
      ModelEdit.FillListConn(dlg, true);
   }
}

void BondsEdit(GtkWidget *window, GLWindow *gl)
{
   GtkWidget *dlg;
   if(g_object_get_data(G_OBJECT(window), EditBondsW))
   {
      dlg = get_widget(window, EditBondsW);
      gdk_window_raise(gtk_widget_get_window(dlg));
   }
   else
   {
      dlg = on_edit_bonds(window);
      g_object_set_data(G_OBJECT(window), EditBondsW, dlg);
      int inModify = GetActiveModel();
      g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(inModify));
   }
   updateModify(-99);
   int whichModel = get_int(dlg, "whichModel");
   int code = 0;
   int selbond = 1;
   int nlegs = ModelInfo[whichModel-1].nlegs_au;
   f_bond_type *legm = g_new0(f_bond_type, nlegs);
   jav_edit_bond_properties_(&code, legm, &whichModel, &selbond);
   if(ModelEdit.created)
      ModelEdit.freeModel();
   //ModelEdit = Model();
   //memcpy(&ModelEdit,  &ModelInfo[whichModel-1], ModelEdit.truesize());
   ModelEdit = *(ModelInfo[whichModel-1].Clone());
   ModelEdit.freeVectors(false);
   ModelEdit.FillLegs(&nlegs, &nlegs, legm, true);
   ModelEdit.CopyAtoms(ModelInfo[whichModel-1].atm_au,
       ModelInfo[whichModel-1].nats_au);
   UpdateBondsEdit();
}

void PropsEdit(gpointer, gpointer data)
{
using namespace gtkext;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   if(!ModelInfo[whichModel].nlegs_au)
   {
      dlg_errmsg(GTK_WINDOW(GLWINDOW), "Sorry. No bonds on current model.");
      return;
   }
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   BondsEdit(window, gl);
}

void on_cancel_edit_angles(GtkWidget *button, gpointer data)
{
  int code = 2;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  int whichModel = get_int(dlg, "whichModel");
  jav_anglebond_type *angs = ModelInfo[whichModel-1].anglebonds;
  int angolo = 1;
  jav_edit_angle_properties_(&code, angs, &whichModel, &angolo);
  chiudi_dlg(button, data);
  updateModify(1);
}

void on_apply_edit_angles(GtkWidget *button, GtkWidget *dlg)
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  int code = 3;
  GtkWidget *list = get_widget(dlg, "angleb");
  int whichModel = get_int(dlg, "whichModel");
  jav_anglebond_type *angs = ModelInfo[whichModel-1].FromListToAngs(list);
  int nangs =  ModelInfo[whichModel-1].nangbonds;
  int selangle = get_int(dlg, "whichAngle");
  int angolo = selangle + 1;
  jav_edit_angle_properties_(&code, angs, &whichModel, &angolo);
  ModelInfo[whichModel-1].FillAngs(nangs, angs);
  ModelInfo[whichModel-1].FromAngsToList(list, angs);
  if(selangle >= 0)
  {
     seleziona_angolo(whichModel-1, selangle);
     gl->Redraw();
  }
}

void on_ok_edit_angles(GtkWidget *button, gpointer data)
{
  int code = 1;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  GtkWidget *list = get_widget(dlg, "angleb");
  int whichModel = get_int(dlg, "whichModel");
  int angolo = 1;
  jav_anglebond_type *angs = ModelInfo[whichModel-1].FromListToAngs(list);
  jav_edit_angle_properties_(&code, angs, &whichModel, &angolo);
  chiudi_dlg(button, data);
  on_unselect(NULL, (gpointer) GLWINDOW);
  updateModify(1);
}

GtkWidget *on_edit_angles (GtkWidget *window)
{
  GtkWidget *dialog1;
  GtkWidget *button;
  int lar, alt;

  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1),
             toUTF8(g_path_get_basename(ModelInfo[0].modname)));
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
  g_object_set_data(G_OBJECT(dialog1), "alt", GINT_TO_POINTER(alt));

  int inModify = GetActiveModel() - 1;
  g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(inModify+1));
  crealistaangoli (dialog1, vbox1, fontlist, true);
  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = EditAnglesW;

  button = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 1);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_ok_edit_angles), (gpointer) st);
  button = APPLY_button();
  //gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 2);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_apply_edit_angles), dialog1);
  g_object_set_data(G_OBJECT(dialog1), "apply_b", button);
  button = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 3);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_cancel_edit_angles), (gpointer) st);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show_all(dialog1);

  g_object_set_data(G_OBJECT(dialog1), "whichAngle", GINT_TO_POINTER(-1));
  return dialog1;
}

void UpdateAnglesEdit()
{
   if(GLWINDOW == NULL)
      return;
   if(g_object_get_data(G_OBJECT(GLWINDOW), EditAnglesW))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, EditAnglesW);
      int whichModel = get_int(dlg, "whichModel") - 1;
      if(whichModel < 0)
         return;
      ModelInfo[whichModel].FillListAng(dlg);
   }
}

void AngsEdit(GtkWidget *window, GLWindow *gl)
{
using namespace gtkext;
   GtkWidget *dlg;
   int whichModel = GetActiveModel();
   getangle_(&whichModel);
   if(!ModelInfo[whichModel-1].nangbonds)
   {
      dlg_errmsg(GTK_WINDOW(GLWINDOW), "Sorry. No angles on current model.");
      return;
   }
   jav_anglebond_type *angs;
   if(g_object_get_data(G_OBJECT(window), EditAnglesW))
   {
      dlg = get_widget(window, EditAnglesW);
      gdk_window_raise(gtk_widget_get_window(dlg));
   }
   else
   {
      dlg = on_edit_angles(window);
      g_object_set_data(G_OBJECT(window), EditAnglesW, dlg);
      int inModify = GetActiveModel();
      g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(inModify));
   }
   updateModify(-99);
   int code = 0;
   angs = g_new0(jav_anglebond_type, ModelInfo[whichModel-1].nangbonds);
   int angolo = 1;
   jav_edit_angle_properties_(&code, angs, &whichModel, &angolo);
   UpdateAnglesEdit();

}

void OnAngsEdit(gpointer, gpointer data)
{
using namespace gtkext;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   if(!ModelInfo[whichModel].nlegs_au)
   {
      dlg_errmsg(GTK_WINDOW(GLWINDOW), "Sorry. No angles on current model.");
      return;
   }
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   AngsEdit(window, gl);
}

void autov(double a[3][3], double eigen[3], double t[3][3], int *icod)
{
   double aik[3];
   double eps1 = .1e-10, eps2 = eps1, eps3 = .1e-9;
   double sigma1 = 0, offdsq = 0;
   int itmax = 50, n = 3, nm1 = n-1;
   for(int i=0; i<3; i++)
       for(int j=0; j<3; j++)
           t[i][j] = 0;
   for(int i=0; i<n; i++)
   {
      sigma1 = sigma1 + (double) (a[i][i] * a[i][i]);
      t[i][i] = 1.f;
      int ip1 = i+1;
      if(i >= (n-1))
         break;
      for(int j=ip1; j<n; j++)
          offdsq = offdsq + (double) (a[i][j]*a[i][j]);
   }

//    inizio iter. jacobi

   for(int iter=0; iter<itmax; iter++)
   {
       for(int i=0; i<nm1; i++)
       {
           int ip1 = i + 1;
           for(int j=ip1; j<n; j++)
           {
               double q = MRabs((double) (a[i][i] - a[j][j]));
               double csa, sna;
               if (q > eps1)
               {
                   if(MRabs((double) a[i][j]) <= eps2)
                   {
                      a[i][j] = 0.f;
                      continue;
                   }
                   double p = 2.0 * a[i][j] * q / (double) (a[i][i] - a[j][j]);
                   double spq = sqrt( p * p + q * q);
                   csa = sqrt( (1.0 + q / spq) / 2.0 );
                   sna = p / ( 2.0 * csa * spq );
               }
               else
               {
                   csa = 1./sqrt(2.0);
                   sna = csa;
               }
               for(int k=0; k<n; k++)
               {
                  double holdki = t[k][i];
                  t[k][i] = holdki * csa + t[k][j] * sna;
                  t[k][j] = holdki * sna - t[k][j] * csa;
               }
               for(int k=0; k<n; k++)
               {
                  if (k <= j) 
                  {
                      aik[k] = a[i][k];
                      a[i][k] = csa * aik[k] + sna * a[k][j];
                      if (k == j) 
                          a[j][k] = sna * aik[k] - csa * a[j][k];
                  }
                  else
                  {
                      double holdik = a[i][k];
                      a[i][k] = csa * holdik + sna * a[j][k];
                      a[j][k] = sna * holdik - csa * a[j][k];
                  }
               }
               aik[j] = sna * aik[i] - csa * aik[j];
               for(int k=0; k<=j; k++)
               {
                  if (k <= i) 
                  {
                     double holdki = a[k][i];
                     a[k][i] = csa * holdki + sna * a[k][j];
                     a[k][j] = sna * holdki - csa * a[k][j];
                  }
                  else
                     a[k][j] = sna * aik[k] - csa * a[k][j];
               }
               a[i][j] = 0.f;
           }
       }
       double sigma2 = 0.0;
       for(int i=0; i<n; i++)
       {
            eigen[i] = a[i][i];
            sigma2 = sigma2 + eigen[i]*eigen[i];
       }
       if (MRabs(sigma2) <= 1.e-07)
       {
            *icod = 0;
            return;
       }
       else
       {
            double aaa = 1.0 - sigma1 / sigma2;
            if (aaa >= eps3)
            {
                sigma1 = sigma2;
                continue;
            }
       }
       *icod = 1;
       return;
   }
   *icod = 0;
}

float *get_coeff(int action)
{
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return NULL;
   if(!ModelInfo[whichModel].created)
        return NULL;
   float *coef = g_new0(float, 3);//4);
   int nats, *vet;
   if(action == 'L')
   {
      nats = ModelInfo[whichModel].nats;
      if(nats <= 0)
         return NULL;
      vet = g_new0(int, nats);
      for(int i=0; i<nats; i++)
          vet[i] = i+1;
   }
   else
   {
      nats = (int) ModelInfo[whichModel].atoms_sel.size();
      if(nats <= 0)
         return NULL;
      vet = g_new0(int, nats);
      for(int i=0; i<nats; i++)
          vet[i] = ModelInfo[whichModel].atoms_sel.at(i);
   }
   float bc[3] = {0, 0, 0};
   for(int j=0; j<3; j++)
   {
       for(int i=0; i<nats; i++)
       {
           int k = vet[i] - 1;
           bc[j] += ModelInfo[whichModel].atm[k].xyz[j];
       }
       bc[j] /= nats;
   }
   double xd[3], ainer[3][3];
   for(int i1=0; i1<3; i1++)
   {
       for(int i2=0; i2<3; i2++)
           ainer[i1][i2] = 0;
   }

   for (int i=0; i<nats; i++)
   {
       int k = vet[i] - 1;
       for(int j=0; j<3; j++)
           xd[j] = ModelInfo[whichModel].atm[k].xyz[j] - bc[j];
       for(int i1=0; i1<3; i1++)
       {
           for(int i2=0; i2<3; i2++)
               ainer[i1][i2] = ainer[i1][i2]+xd[i1]*xd[i2];
       }
   }   

   double ainert[3][3];
   for(int i=0; i<3; i++)
       for(int j=0; j<3; j++)
           ainert[i][j] = ainer[j][i];
   g_free (vet);
   double eval[3], evec[3][3];
   int icod;
   autov(ainert, eval, evec, &icod);
   for(int i=0; i<2; i++)
   {
      for(int j=i+1; j<3; j++)
      {
          if(eval[i] > eval[j])
          {
             double Dum = eval[i];
             eval[i] = eval[j];
             eval[j] = Dum;
             for(int k=0; k<3; k++)
             {
                  Dum = evec[k][i];
                  evec[k][i] = evec[k][j];
                  evec[k][j] = Dum;
             }
          }
      }
   }
   for(int i=0; i<3; i++)
       coef[i] = (float) evec[i][0];
   return coef;
}

bool jav_modify(int *kptra,int *nptra,int *kptrb,int *nptrb, int *cod,
                float *threshold = NULL,
                int wm = -1, int *spec=NULL, char *newname=NULL, size_t idum=0)
{
   int which;
   float thr;
   if(threshold)
      thr = *threshold;
   else
      thr = 0.6f;
   if(wm == -1)
      which = GetActiveModel();
   else
      which = wm + 1;
   bool result =
       (jav_modify_object_(kptra,nptra, kptrb, nptrb, cod, &thr, 
          &which, spec, newname, idum) == 0);
   if(result)
   {
      GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
      UpdateInfoAtoms();
      gl->Redraw();
   }
   return result;
}

void on_undo(gpointer, gpointer )
{
   int code = -1;
   jav_undo_redo_(&code);
   UpdateInfoAtoms();
}

void on_redo(gpointer, gpointer )
{
   int code = 1;
   jav_undo_redo_(&code);
   UpdateInfoAtoms();
}

void on_delete(gpointer item, gpointer data)
{
    if(!GLWINDOW)
        return;
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    int current_wm = GetActiveModel() - 1;
    for(int whichModel=0; whichModel< gl->nModels; whichModel++)
    {
       if(gl->nModels > 1)
          SetActive(whichModel);
       int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
       int *kptra = g_new0(int, nptra);
       for(int i=0; i<nptra; i++)
           kptra[i] = ModelInfo[whichModel].atoms_sel[i];
       int nptrb = (int) ModelInfo[whichModel].bonds_sel.size();
       int *kptrb = g_new0(int, nptrb);
       for(int i=0; i<nptrb; i++)
           kptrb[i] = ModelInfo[whichModel].bonds_sel[i];
       int icod = 1;
       if(jav_modify(kptra,&nptra,kptrb,&nptrb,&icod,NULL,whichModel))
       {
          gl->DistAng_vet.clear();
          endModify(whichModel);
       }
    }
    SetActive(current_wm);
}

void on_delete_bonds(gpointer item, gpointer data)
{
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
    int nptra = 0;
    int nptrb = (int) ModelInfo[whichModel].bonds_sel.size();
    int *kptrb = g_new0(int, nptrb);
    for(int i=0; i<nptrb; i++)
        kptrb[i] = ModelInfo[whichModel].bonds_sel[i];
    int icod = 1;
    if(jav_modify(NULL,&nptra,kptrb,&nptrb,&icod))
       endModify(whichModel);
}

void get_threshold(GtkWidget *win, float *threshold)
{
   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(dlg), "Set threshold value");
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(win));
   gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER_ON_PARENT);

   GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   GtkWidget *hbox =  table_new(1, 2, FALSE);
   gtk_container_set_border_width (GTK_CONTAINER (hbox), 20);
   gtk_container_add (GTK_CONTAINER (vbox), hbox);
   table_set_col_spacings(hbox, 20);
   GtkWidget *label = gtk_label_new (" Threshold: ");
   set_alignment (label, 0, 0.5f);
   table_attach_exp(hbox, label, 0, 1, 0, 1);
   GtkWidget  *entry = gtk_entry_new();
   set_width_chars(GTK_ENTRY(entry), 10);
   gtk_entry_set_text(GTK_ENTRY(entry), "0.6");
   table_attach_exp(hbox, entry, 1, 2, 0, 1);

   GtkWidget *button = OK_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK);
   gtk_widget_grab_focus(button);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
             GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all(dlg);
   int response = gtk_dialog_run(GTK_DIALOG(dlg));
   if(response == GTK_RESPONSE_OK)
   {
      *threshold = (float) atof(gtk_entry_get_text(GTK_ENTRY(entry)));
   }
   else
      *threshold = 0.6f;
   gtk_widget_destroy(dlg);
}


void on_delete_dup(gpointer item, gpointer data)
{
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
    int nptra = 0;
    int nptrb = 0;
    int icod = 31;
    float threshold;
    get_threshold(GLWINDOW, &threshold);
    if(jav_modify(NULL,&nptra,NULL,&nptrb,&icod,&threshold))
       endModify(whichModel);
}

void on_buildbonds(gpointer, gpointer )
{
    int nptra = 0;
    int nptrb = 0;
    int icod = 4;
    jav_modify(NULL,&nptra,NULL,&nptrb,&icod);        
}

void on_assemble(gpointer, gpointer )
{
    int nptra = 0;
    int nptrb = 0;
    int icod = 5;
    jav_modify(NULL,&nptra,NULL,&nptrb,&icod);
}

void on_addbond(gpointer, gpointer )
{
using namespace gtkext;
    int whichModel = GetActiveModel() - 1;
    if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
    int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
    if(nptra < 2)
    {
      dlg_errmsg(GTK_WINDOW(GLWINDOW), "Sorry. You should select 2 atoms at least.");
      return;
    }
    int *kptra = g_new0(int, nptra);
    for(int i=0; i<nptra; i++)
        kptra[i] = ModelInfo[whichModel].atoms_sel[i];
    int nptrb = 0;
    int icod = 2;
    if(jav_modify(kptra,&nptra,NULL,&nptrb,&icod))
       endModify(whichModel);
}

void on_change_spec(gpointer item, gpointer data)
{
    int whichZ = GPOINTER_TO_INT(data);
    int whichModel = GetActiveModel() - 1;
    if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
    int whichSpec;
    if(whichZ < OTHERS)
    {
       int i;
       for (i=0; i< ModelInfo[whichModel].numSpec; i++)
       {
            if(ModelInfo[whichModel].Species[i] == whichZ)
               break;
       }
       if( i == ModelInfo[whichModel].numSpec)
           return;
       whichSpec = i+1;
    }
    else
    {
       int result = select_from_table(GLWINDOW);
       if(result < 0)
          return;
       whichSpec = -(result+1);
    }

    int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
    int *kptra = g_new0(int, nptra);
    for(int i=0; i<nptra; i++)
        kptra[i] = ModelInfo[whichModel].atoms_sel[i];
    int nptrb = 0;
    int icod = 3;
    if(jav_modify(kptra,&nptra,NULL,&nptrb,&icod,NULL,whichModel, &whichSpec))
       endModify(whichModel);
}

void on_rename(gpointer item, gpointer data)
{
    GtkWidget *window = (GtkWidget *) data;
    GtkWidget *dlg;
    GtkWidget *button;
 
    dlg = gtk_dialog_new ();
    gtk_window_set_title (GTK_WINDOW (dlg), "Rename");
    gtk_window_set_default_size (GTK_WINDOW (dlg), 210, 180);
    gtk_container_set_border_width (GTK_CONTAINER (dlg), 10);
    GtkWidget *vbox =  gtk_dialog_get_content_area(GTK_DIALOG(dlg));

    int whichModel = GetActiveModel() - 1;
    if(whichModel == -1)
         return;
   if(!ModelInfo[whichModel].created)
        return;
    int nptr = (int) ModelInfo[whichModel].atoms_sel.size();
    std::string stringa;
    stringa.assign("Atoms: ");
    for(int i=0; i<nptr; i++)
    {
        char *line = ModelInfo[whichModel].atm[ModelInfo[whichModel].atoms_sel.at(i)-1].lab;
        stringa.append(g_strchomp(line));
        if(i != (nptr-1))
           stringa.append(", ");
    }
    GtkWidget *label = LABEL_NEW(stringa.c_str(), MyBLUE);
    gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
    set_alignment(label, 0., 0.);
    gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 5);
    gtk_widget_show (label);
    GtkWidget *hbox = hbox_new(FALSE, 0);
    gtk_widget_show (hbox);
    gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 5);
    label = LABEL_NEW("New name", NULL);
    gtk_widget_show (label);
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 5);
    GtkWidget *entry = gtk_entry_new();
    gtk_widget_show (entry);
    gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 10);

    button = CLOSE_button();
    gtk_widget_show(button);
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
    button = OK_button();
    gtk_widget_show(button);
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK);

    gtk_widget_set_sensitive(window, FALSE);
    gtk_widget_show(dlg);
    int result = gtk_dialog_run(GTK_DIALOG(dlg));
    if(result == GTK_RESPONSE_OK)
    {
       const char *name = gtk_entry_get_text(GTK_ENTRY(entry));
       if(!str_white(name))
       {
       int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
       int *kptra = g_new0(int, nptra);
       for(int i=0; i<nptra; i++)
           kptra[i] = ModelInfo[whichModel].atoms_sel[i];
       int nptrb = 0;
       int newspec = 0;
       int icod = 6;
       char *newname = g_strdup(fromUTF8(name).c_str());
       size_t sz = strlen(newname);
       gtk_widget_hide(dlg);
       if(jav_modify(kptra,&nptra,NULL,&nptrb,&icod,NULL,whichModel, &newspec,newname,sz))
          endModify(whichModel);
       g_free(newname);
       }
    }
    gtk_widget_destroy(dlg);
    gtk_widget_set_sensitive(window, true);
}

void on_renumber(gpointer, gpointer )
{
    GtkWidget *window;
    GtkWidget *hbox;
    GtkWidget *frame;
    GtkWidget *label;
    GtkWidget *spin;
    GtkWidget *radio;
    GtkWidget *entry;
    GtkWidget *button;
    GSList *group = NULL;

    window = gtk_dialog_new();
    gtk_window_set_title (GTK_WINDOW (window), "ReNumber");
    gtk_container_set_border_width (GTK_CONTAINER (window), 5);

    frame = FRAME_NEW ("Label prefix", MyBLUE);
    gtk_box_pack_start(GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(window))), frame, FALSE, 
                       FALSE, 10);

    entry = gtk_entry_new();

    hbox = vbox_new(FALSE, 2);
    gtk_container_add(GTK_CONTAINER(frame), hbox);
    radio = gtk_radio_button_new_with_label (group, "Atomic species");
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
    radio = gtk_radio_button_new_with_label (group, "User defined string");
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
    g_object_set_data (G_OBJECT (window), "userdef", radio);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
		       (GCallback) on_cb_attiva, entry);

    gtk_box_pack_start (GTK_BOX (hbox), entry, FALSE, FALSE, 0);
    gtk_widget_set_sensitive(entry, FALSE);
    g_object_set_data (G_OBJECT (window), "entry", entry);
    hbox = hbox_new(FALSE, 2);
    gtk_box_pack_start(GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(window))), hbox, FALSE, 
                       FALSE, 10);
    gtk_widget_show(hbox);

    label = gtk_label_new("Initial Sequence Number");
    set_alignment(label, 0.,0.5);
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);

    spin = SPIN_NEW (1, 10000, 1, 1, 0);
    g_object_set_data(G_OBJECT(window), "spin", spin);
    spin_button_set_numeric (spin, TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), spin, FALSE, FALSE, 2);

// buttons: OK & Cancel 
    button = OK_button();
    gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_OK);
    gtk_widget_grab_focus (button);

    button = CANCEL_button();
    gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_CANCEL);
    gtk_widget_show_all(window);
    int result = gtk_dialog_run(GTK_DIALOG(window));
    entry = get_widget(window, "entry");
    if(result == GTK_RESPONSE_OK)
    {
       int whichModel = GetActiveModel() - 1;
       if((whichModel != -1) && ModelInfo[whichModel].created)
       {
          int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
          int *kptra = g_new0(int, nptra);
          for(int i=0; i<nptra; i++)
              kptra[i] = ModelInfo[whichModel].atoms_sel[i];
          int nptrb = 0;

          GtkWidget *spin = get_widget(window, "spin");
          int spec = spin_button_get_value_as_int (spin);
          spin = get_widget(window, "userdef");
          char *newname;
          int icod = 8;
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(spin)))
             newname = g_strdup(fromUTF8(gtk_entry_get_text(GTK_ENTRY(entry))).c_str());
          else
             newname = g_strdup(" ");
          size_t sz = strlen(newname);
          gtk_widget_hide(window);
          if(jav_modify(kptra,&nptra,NULL,&nptrb,&icod,NULL,whichModel, &spec,newname,sz))
             endModify(whichModel);
          g_free(newname);
       }
    }
    gtk_widget_destroy(window);
}

void on_sortbyspec(gpointer, gpointer )
{
    int whichModel = GetActiveModel() - 1;
    if(whichModel == -1)
       return;
   if(!ModelInfo[whichModel].created)
        return;
    if(ModelInfo[whichModel].nats <= 0)
       return;
    int nptra = 0;
    int nptrb = 0;
    int icod = 7;
    jav_modify(NULL,&nptra,NULL,&nptrb,&icod);        
}

bool DistanceFromUI(const char *title, float *bond_d)
{
  GtkWidget *window;
  GtkWidget *box1;
  GtkWidget *button1;

  window = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (window), 7);
  gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
  gtk_window_set_title(GTK_WINDOW(window), title);

  box1 = gtk_dialog_get_content_area(GTK_DIALOG(window));
  GtkWidget *frame = FRAME_NEW ("Bond Length", MyBLUE);
  g_object_set_data (G_OBJECT (window), "frame", frame);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (box1), frame, FALSE, FALSE, 10);
  GObject *adj = adj_new (1.390f,0.9f, 1.6f, 0.01f, 0.1f);
  GtkWidget *hscale = hscale_new (GTK_ADJUSTMENT (adj));
  gtk_widget_show (hscale);
  gtk_container_add (GTK_CONTAINER (frame), hscale);
  gtk_scale_set_value_pos (GTK_SCALE (hscale), GTK_POS_BOTTOM);
  gtk_scale_set_digits (GTK_SCALE (hscale), 3);

  button1 = OK_button();
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG(window), button1, GTK_RESPONSE_OK);
  button1 = CANCEL_button();
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG(window), button1, GTK_RESPONSE_CANCEL);
  int result = gtk_dialog_run(GTK_DIALOG(window));
  if(result == GTK_RESPONSE_OK)
      *bond_d =  (float) gtk_adjustment_get_value(GTK_ADJUSTMENT(adj));
  gtk_widget_destroy(window);
  return(result == GTK_RESPONSE_OK);
}

void on_complete(gpointer, gpointer )
{
using namespace gtkext;
    int icod = 9;
    int whichModel = GetActiveModel() - 1;
    if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
    int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
    if((nptra < 3) || (nptra > 5))
    {
      dlg_errmsg(GTK_WINDOW(GLWINDOW), "Sorry. You should select 3, 4 or 5 atoms.");
      return;
    }
    float bond_d;
    bool result = DistanceFromUI("Complete", &bond_d);
    if(result)
    {
        int *kptra = g_new0(int, nptra);
        for(int i=0; i<nptra; i++)
            kptra[i] = ModelInfo[whichModel].atoms_sel[i];
        int nptrb = (int) (bond_d*1000);
        if(jav_modify(kptra,&nptra,NULL,&nptrb,&icod))
           endModify(whichModel);
    }

}

void on_regularize(gpointer, gpointer )
{
using namespace gtkext;
    int icod = 10;
    int whichModel = GetActiveModel() - 1;
    if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
    int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
    if(nptra < 3)
    {
      dlg_errmsg(GTK_WINDOW(GLWINDOW), "Sorry. You should select more than 2 atoms.");
      return;
    }
    float bond_d;
    bool result = DistanceFromUI("Regularize", &bond_d);
    if(result)
    {
        int *kptra = g_new0(int, nptra);
        for(int i=0; i<nptra; i++)
            kptra[i] = ModelInfo[whichModel].atoms_sel[i];
        int nptrb = (int) (bond_d*1000);
        if(jav_modify(kptra,&nptra,NULL,&nptrb,&icod))
           endModify(whichModel);
    }
}

void do_move_atoms()
{
    int whichModel = GetActiveModel() - 1;
    if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
    int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
    int *kptra = g_new0(int, nptra);
    for(int i=0; i<nptra; i++)
        kptra[i] = ModelInfo[whichModel].atoms_sel[i];
    int nptrb = 0;
    int icod = 24;
    if(jav_modify(kptra,&nptra,NULL,&nptrb,&icod))
       endModify(whichModel);
}

void on_hydro(gpointer item, gpointer )
{
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     const char *labels[] = {"Automatic", "Methine C-H", "Methylene Group",
                             "Methyl Group", "Aromatic C-H", "Hydroxyl O-H",
                             "Terminal X=CH2", "Terminal B-H", "Acetylenic C-H"};
     int icod;
     int whichModel = GetActiveModel() - 1;
     if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
     if(ModelInfo[whichModel].nats <= 0)
        return;
     const char *label = obj_get_label(item);
     for(int i=0; i<(int)(sizeof(labels)/sizeof(labels[0])); i++)
     {
         if(strcmp(label, labels[i]) == 0)
         {
            icod = 12+i;
            break;
         }
     }
     int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
     int nptrb = 0;
     int *kptra = g_new0(int, nptra);
     for(int i=0; i<nptra; i++)
         kptra[i] = ModelInfo[whichModel].atoms_sel[i];
     if(jav_modify(kptra,&nptra,NULL,&nptrb,&icod))
     {
        gl->DistAng_vet.clear();
        endModify(whichModel);
     }
}

void on_enant(gpointer,  gpointer )
{
   int icod = 11;
   int nptra = 0;
   int nptrb = 0;
   jav_modify(NULL,&nptra,NULL,&nptrb,&icod);        
}

void on_togglelabels(gpointer, gpointer )
{
   bool Flag;
   int whichModel = GetActiveModel() - 1;
   if(whichModel < 0)
      Flag = false;
   else if(!ModelInfo[whichModel].created)
      Flag = false;
   else
      Flag = !ModelInfo[whichModel].ifLabels;
   sync_radio("Label All Atoms", Flag);
}

void on_togglecell(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   sync_radio("View Cell Edges", !gl->ifCell);
}

void aggiornaMenuSym()
{
   int whichModel = GetActiveModel() - 1;
   if(get_object(GLWINDOW, "Packing") != NULL)
   {
      gboolean ifsy = ModelInfo[whichModel].ifSymmetry;
      gpointer item1 = get_object(GLWINDOW, "Packing");
      gpointer item2 = get_object(GLWINDOW, "Expand");
      gpointer item3 = get_object(GLWINDOW, "Reduce");
      {
         obj_set_active(item1, ifsy, true);
         float symlevel = Minimo(ModelInfo[whichModel].klevel, 3);
         obj_set_sensitive(item2, ifsy && (symlevel < MAX_SYMLEVEL));
         symlevel = Massimo(ModelInfo[whichModel].klevel, 3);
         obj_set_sensitive(item3, ifsy && (symlevel > 0));
      }
      gpointer but = get_object(GLWINDOW, "SymmOn");
      obj_set_active(but, ifsy, true);
   }
}

void setsymm(int symcheck)
{
   int whichModel = GetActiveModel() - 1;
   if(whichModel < 0)
   {
      aggiornaMenuSym();
      return;
   }
   if(!ModelInfo[whichModel].created)
   {
        aggiornaMenuSym();
        return;
   }
   int i = whichModel + 1;
   ModelInfo[whichModel].ifSymmetry = (symcheck != 0);
   aggiornaProperties(whichModel);
   aggiornaMenuSym();
   CApplicaSimmetria(&i);
}

void on_togglesymm(gpointer item, gpointer )
{
   int symcheck = obj_get_active(item);
   setsymm(symcheck);
}

void PackOnOff(gpointer item, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   gboolean active = obj_get_active(item);
   gpointer check = get_object(window, "SymmOn");
   if(check != NULL)
      obj_set_active(check, active, true);
   setsymm(active);
}

void changePacking(gpointer data, float quanto)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   if(ModelInfo[whichModel].ifSymmetry)
   {
      for(int km=0; km<3; km++)
      {
          ModelInfo[whichModel].klevel[km] += quanto;
          if(ModelInfo[whichModel].klevel[km] > MAX_SYMLEVEL)
             ModelInfo[whichModel].klevel[km] = MAX_SYMLEVEL;
          if(ModelInfo[whichModel].klevel[km] < 1e-6)
             ModelInfo[whichModel].klevel[km] = 0;
      }
      int j = whichModel + 1;
      LoadWinCursor(5);
      //ShowWaitCursor(window);
      CApplicaSimmetria(&j);
      //HideWaitCursor(window);
      LoadWinCursor(0);
      gl->Redraw ();
   }
}

void IncPack(gpointer item, gpointer data)
{
      int whichModel = GetActiveModel() - 1;
      if(whichModel == -1)
         return;
   if(!ModelInfo[whichModel].created)
        return;
      float symlevel = Minimo(ModelInfo[whichModel].klevel, 3);
      if(symlevel >= MAX_SYMLEVEL)
         return;
      changePacking(data, 0.1f);
      symlevel = Minimo(ModelInfo[whichModel].klevel, 3);
      obj_set_sensitive(item, (symlevel < MAX_SYMLEVEL));
}

void DecPack(gpointer item, gpointer data)
{
      int whichModel = GetActiveModel() - 1;
      if(whichModel == -1)
         return;
      if(!ModelInfo[whichModel].created)
        return;
      float symlevel = Massimo(ModelInfo[whichModel].klevel, 3);
      if(symlevel <= 0)
         return;
      changePacking(data, -0.1f);
      symlevel = Massimo(ModelInfo[whichModel].klevel, 3);
      obj_set_sensitive(item, (symlevel > 0));
}

void ShowMB(gpointer item, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->ShowMultBonds = (obj_get_active(item) != 0);
   if(gl->ShowMultBonds)
   {
      for(int i=1; i<=gl->nModels; i++)
          jav_show_multbonds_(&i);
   }
   else
      gl->Redraw();
   int whichModel = GetActiveModel() - 1;
   if(whichModel >= 0)
      aggiornaProperties(whichModel);
}

void calcolava()
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   float xyzs[4][3];
   for(int i=0; i<4; i++)
       for(int j=0; j<3; j++)
           xyzs[i][j] = 0;
   for(int j=0; j<3; j++)
       xyzs[j+1][j] = 0.8f;
   for(int i=0; i<4; i++)
   {
       vet3 v1 = gl->FractToCart(xyzs[i]);
       for(int j=0; j<3; j++)
           xyzs[i][j] = (float) v1.v[j];
  }
   for(int i=1; i<4; i++)
   {
       float vmod = 0;
       for(int j=0; j<3; j++)
           vmod +=  xyzs[i][j]*xyzs[i][j];
       vmod = sqrt(vmod);
       for(int j=0; j<3; j++)
           xyzs[i][j] = xyzs[i][j]/vmod;
  }
  std::vector<float> tvet;
  std::vector<float> mini, maxi;
  int j;

  for(j=0; j<3; j++)
  {
      for(int i=0; i<4; i++)
          tvet.push_back(xyzs[i][j]);
      maxi.push_back(*max_element(tvet.begin(), tvet.end()));
      mini.push_back(*min_element(tvet.begin(), tvet.end()));
      tvet.clear();
  }
  for(j=0; j<3; j++)
      tvet.push_back(maxi[j]-mini[j]);
  float  delta0 = *max_element(tvet.begin(), tvet.end());
  delta0 *= 1.7f;
  tvet.clear();
  float xdd[3];
  for(int j=0; j<3; j++)
  {
      float delta2 = maxi[j] - mini[j];
      xdd[j] = (delta0 - delta2) / 2.f - mini[j];
  }
 for(int i=0; i<4; i++)
  {
      for(int j=0; j<3; j++)
      {
          float t = (xyzs[i][j] + xdd[j]) / delta0;
          gl->xyzsN[i].v[j] = -1.f + 2.f*t;
      }
  }
}

void importFileCOD(std::string fn, int tipo)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
//   int sz = (int) strlen(fn.c_str()) + 1;
//   char *filenam = g_new0(char, sz);
//   CopiaStringa(filenam, sz, fn.c_str());
   char *filenam = g_strdup(fromUTF8(fn).c_str());
   size_t sz = strlen(filenam);
   int which = 1;
   gl->DistAng_vet.clear();
   jav_import_structure_cod_ (filenam, &tipo, &which, sz);
   g_free(filenam);
   UpdateInfoAtoms();
}

void importFile(std::string fn, int tipo)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
//   int sz = (int) strlen(fn.c_str()) + 1;
//   char *filenam = g_new0(char, sz);
//   CopiaStringa(filenam, sz, fn.c_str());
   char *filenam = g_strdup(fromUTF8(fn).c_str());
   size_t sz = strlen(filenam);
   int which = 1;
   gl->DistAng_vet.clear();
   jav_import_structure_ (filenam, &tipo, &which, sz);
   g_free(filenam);
   UpdateInfoAtoms();
}

void exportFile(std::string fn, int tipo)
{
//   int sz = (int) strlen(fn.c_str()) + 1;
//   char *filenam = g_new0(char, sz);
//   CopiaStringa(filenam, sz, fn.c_str());
   char *filenam = g_strdup(fromUTF8(fn).c_str());
   size_t sz = strlen(filenam);
   int which = 1;
   int ifD = 0;
   if(tipo >= 1000)
   {
      tipo -= 1000;
      ifD = 1;
   }
   jav_export_structure_ (filenam, &tipo, &which, &ifD, sz);
   g_free(filenam);
}

void on_import(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *)data;
   int whichModel = 0;
   std::string filt = FilesToImport, filt1 = filt;
   size_t n = filt.find_first_of(',');
   if(n != std::string::npos)
      filt1 = filt.erase(n, std::string::npos);
   std::string fn;
   if(ModelInfo[whichModel].created)
      fn = g_path_get_basename(ModelInfo[whichModel].modname) + filt1.substr(1);
   else
      fn = "";
   int nfilt;
   fn =  gtkext::dlg_select_file(window, fn, gtkext::eSELECT_TO_READ,
           FilesToImport, false, NULL, false, &nfilt);
   int tipo = 0;
   if(nfilt >= 0)
      tipo = FILT_IN_READ[nfilt];
   if(str_white(fn.c_str()))
       return;
   importFile(fn, tipo);
}
  
void on_export(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *)data;
   int whichModel = 0;
   std::string filt = FilesToExport, filt1 = filt;
   size_t n = filt.find_first_of(',');
   if(n != std::string::npos)
      filt1 = filt.erase(n, std::string::npos);
   std::string fn;
   if(ModelInfo[whichModel].created)
      fn = g_path_get_basename(ModelInfo[whichModel].modname);
   else
      fn = "";
   int nfilt;
   bool ifDisp = false;
   fn =  gtkext::dlg_select_file(window, fn, gtkext::eSELECT_TO_WRITE,
           FilesToExport, false, NULL, false, &nfilt, true, &ifDisp);
   int tipo = 0;
   if(nfilt >= 0)
      tipo = FILT_IN_WRITE[nfilt];
   if(str_white(fn.c_str()))
       return;
   if(ifDisp)
      tipo += 1000;
   exportFile(fn, tipo);
}
  
void on_move_atoms(gpointer, gpointer data)
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  gl->PrintMess("Select atom to minimize distances");
  updateModify(-99);
  while(gtk_events_pending())
         (void) gtk_main_iteration();
  set_motion_type(SELECT_DEST, 1);
}

static void combo_tipo_changed(GtkWidget *combo, gpointer )
{
     GtkWidget *dlg = gtk_widget_get_toplevel(combo);
     //static const char *titles[] = {"Add tetrahedron", "Add octahedron"};
     int kgeom = combo_get_val(combo);
     if((kgeom > 0) && (kgeom <ISOLATED))
     {
        std::string newtitle = "Add ";
        newtitle.append(G_str[kgeom-1]);
        gtk_window_set_title(GTK_WINDOW(dlg), newtitle.c_str());
     }
}

static void aggiorna_dist(GtkWidget *dlg)
{
     int whichModel = get_int(dlg, "whichModel");
     GtkWidget *combo1 = get_widget(dlg, "kspec1");
     GtkWidget *combo2 = get_widget(dlg, "kspec2");
     GtkWidget *combo3 = get_widget(dlg, "center");
     GtkWidget *radio = get_widget(dlg, "centered");
     int val1 = combo_get_val(combo1);
     int nspec1 = get_int(combo1, "nSpec");
     if(val1 > nspec1)
     {
          char *ele = combo_get_text(combo1);
          val1 = -is_valid_symbol(ele);
     }
     int val2 = combo_get_val(combo2);
     int nspec2 = get_int(combo2, "nSpec");
     if(val2 > nspec2)
     {
          char *ele = combo_get_text(combo2);
          val2 = -is_valid_symbol(ele);
     }

     if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio)))
     {
        int inde = combo_get_val(combo3);
        val1 = ModelInfo[whichModel].atm[inde -1].color + 1;
     }
     if((val1 == 0) || (val2 == 0))
        return;
     float distance = getbonddistance_(&val1, &val2);
     gtk_entry_set_text(GTK_ENTRY(get_widget(dlg, "bdist")), fToStr(distance, 3).c_str());
     std::string newlab = ModelInfo[whichModel].GetSpecies(val1-1);
     newlab.append(" - ");
     newlab.append(ModelInfo[whichModel].GetSpecies(val2-1));
     newlab.append(" distance");
     gtk_label_set_text(GTK_LABEL(get_widget(dlg, "bdistlab")), newlab.c_str());
}

static void combo_selection_changed(GtkWidget *combo, gpointer )
{
     GtkWidget *dlg = gtk_widget_get_toplevel(combo);
     aggiorna_dist(dlg);
}

static void radio_selection_changed(GtkWidget *radio, gpointer )
{
     GtkWidget *dlg = gtk_widget_get_toplevel(radio);
     aggiorna_dist(dlg);
}

void on_close_add_frag(GtkWidget *button, gpointer data)
{
    GtkWidget *dlg = gtk_widget_get_toplevel(button);
    int icode = GPOINTER_TO_INT(data);
    int whichModel = GetActiveModel();
    if(whichModel == 0)
        return;
    if(icode)
       ges_add_fragments_win_(&icode, &whichModel);
    gtk_widget_destroy(dlg);
    updateModify(1);
}

void on_ok_add_frag(GtkWidget *button, gpointer data)
{
    GtkWidget *dlg = gtk_widget_get_toplevel(button);
    GtkWidget *spin = get_widget(dlg, "numatoms");
    GtkWidget *combo = get_widget(dlg, "combotipo");
    int itipo = GPOINTER_TO_INT(data);
    int kadd = 1 - itipo / 10;
    int kgeom = itipo % 10;
    if(combo != NULL)
       kgeom = combo_get_val(combo);
    int whichModel = GetActiveModel();
    if(whichModel == 0)
        return;
    if(kgeom == ISOLATED)
    {
       int nspec = get_int(get_widget(dlg, "kspec"), "nSpec");
       int katoms = spin_button_get_value_as_int(spin);
       int kspec = combo_get_val(get_widget(dlg, "kspec"));
       if(kspec > nspec)
       {
          char *ele = combo_get_text(get_widget(dlg, "kspec"));
          kspec = -is_valid_symbol(ele);
       }
       if(kspec == 0)
          return;
       int icod = 3;
       int dum = 0;
       float fdum = 0.f;
       ges_add_fragments_win_(&icod, &whichModel, &kgeom, &kspec, &katoms,
                                 &dum, &fdum, &kadd);
       on_close_add_frag(button, GINT_TO_POINTER(0));
    }
    else
    {
       GtkWidget *label = get_widget(dlg, "bdist");
       float bdist = (float) atof(gtk_entry_get_text(GTK_ENTRY(label)));
       GtkWidget *combo1 = get_widget(dlg, "kspec1");
       int kspec1 = combo_get_val(combo1);
       int nspec1 = get_int(combo1, "nSpec");
       if(kspec1 > nspec1)
       {
          char *ele = combo_get_text(combo1);
          kspec1 = -is_valid_symbol(ele);
       }
       if(kspec1 == 0)
          return;

       GtkWidget *combo2 = get_widget(dlg, "kspec2");
       int kspec2 = combo_get_val(combo2);
       int nspec2 = get_int(combo2, "nSpec");
       if(kspec2 > nspec2)
       {
          char *ele = combo_get_text(combo2);
          kspec2 = -is_valid_symbol(ele);
       }
       if(kspec2 == 0)
          return;
       int kpos = 0;
       int icod = 3;
       if(kadd)
       {
          GtkWidget *radio = get_widget(dlg, "random");
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio)))
             kpos = 0;
          else
             kpos = combo_get_val(get_widget(dlg, "center"));
       }
       ges_add_fragments_win_(&icod, &whichModel, &kgeom, &kspec1, &kspec2,
                                 &kpos, &bdist, &kadd);
    }
}

void on_select_other(GtkButton *but, GtkWidget *combo)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(but));
   int nSpec = get_int(combo, "nSpec");
   int result = select_from_table(dlg);
   if(result < 0)
      return;
   combo_insert_text(combo, nSpec, get_nth_element(result));
   combo_set_val(combo, nSpec+1);
}

void  on_add_frag(GtkWidget *mainw,  int itipo)
{
   int kgeom = itipo % 10;
   int kadd = 1 - itipo / 10;
   GtkWidget *dlg, *vbox, *button;
//   static const char *titles[] = {"Add tetrahedron", "Add octahedron", "Add square plane", "Add isolated atoms"};
   int code;
   int whichModel = GetActiveModel();
   if(whichModel == 0)
        return;
   if(kadd && !ModelInfo[whichModel-1].created)
        return;
   int nSpec;
   structure_info_type StructInfo;
   if(ModelInfo[whichModel-1].created)
      nSpec = ModelInfo[whichModel-1].numSpec;
   else
   {
      int ifCalc = 0, wm=1;
      getstructureinfo_(&StructInfo, &ifCalc, &wm);
      nSpec = StructInfo.nspec;
   }
   char **Specie = g_new0(char *, nSpec);
   for (int i = 0; i < nSpec; i++)
   {
        std::string spec;
        if(ModelInfo[whichModel-1].created)
           spec.assign(ModelInfo[whichModel-1].GetSpecies(i));
        else
        {
           int which = StructInfo.zspec[i] - 1;
           if(which >= 0)
              spec.assign(get_nth_element(which));
           else
              spec.assign("Q");
        }
        Specie[i] = g_strdup(spec.c_str());
   }
   code = 0;
   int kspec1, kspec2, idum;
   ges_add_fragments_win_(&code, &whichModel, &idum, &kspec1, &kspec2);
   dlg = gtk_dialog_new ();
   std::string newtitle = "Add ";
   newtitle.append(G_str[kgeom-1]);
   gtk_window_set_title(GTK_WINDOW(dlg), newtitle.c_str());
   //gtk_window_set_title(GTK_WINDOW(dlg), titles[kgeom-1]);
   gtk_container_set_border_width(GTK_CONTAINER(dlg), 8);
   g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(whichModel-1));
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(mainw));
   gtk_window_set_destroy_with_parent(GTK_WINDOW(dlg), TRUE);

   vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   if(kgeom == ISOLATED)
   {
      int kspec = 1;
      GtkWidget *table = table_new(2, 2, TRUE);
      table_set_row_spacings(table, 10);
      table_set_col_spacings(table, 4);
      gtk_container_set_border_width(GTK_CONTAINER(table), 8);
      gtk_box_pack_start(GTK_BOX(vbox), table, TRUE, TRUE, 0);
      GtkWidget *label = LABEL_NEW("Number of atoms to add", MyBLUE);
      set_alignment(label, 0, 0.5);
      table_attach(table, label, 0, 1, 0, 1, TRUE);
      GtkWidget *spin = spin_button_new_with_range(1, 100, 1);
      spin_button_set_digits(spin, 0);
      table_attach(table, spin, 1, 2, 0, 1, TRUE);
      g_object_set_data(G_OBJECT(dlg), "numatoms", spin);

      GtkWidget *hbox = hbox_new(TRUE, 0);
      table_attach(table, hbox, 0, 1, 1, 2, TRUE);
      label = LABEL_NEW("Species", MyBLUE);
      set_alignment(label, 0, 0.5);
      gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);

      GtkWidget *combo = create_combo(NULL, (const char **)Specie, nSpec,
          kspec, NULL, NULL, false);
      gtk_box_pack_start(GTK_BOX(hbox), get_widget(combo, "parent"),
          TRUE, TRUE, 0);
      g_object_set_data(G_OBJECT(dlg), "kspec", combo);
      g_object_set_data(G_OBJECT(combo), "nSpec", GINT_TO_POINTER(nSpec));
      button = myimage_button("     Table", "tableicon.png");
      table_attach(table, button, 1, 2, 1, 2, FALSE);
      g_signal_connect(G_OBJECT(button), "clicked", 
             G_CALLBACK(on_select_other), combo);
      button = OK_button();
      gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK);
      g_signal_connect(G_OBJECT(button), "clicked", 
                         G_CALLBACK(on_ok_add_frag), GINT_TO_POINTER(itipo));

      button = CANCEL_button();
      gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
      g_signal_connect(G_OBJECT(button), "clicked", 
                         G_CALLBACK(on_close_add_frag), GINT_TO_POINTER(0));
      gtk_widget_show_all(dlg);
      updateModify(-99);
   }
   else
   {
      int i, numAtoms;            //, kspec1=nSpec, kspec2=nSpec-1;
      GtkWidget *label, *frame;
      GList *lista_atomi = NULL;

      numAtoms = ModelInfo[whichModel-1].nats;
      for(i=0; i<numAtoms;i++)
          lista_atomi = g_list_append (lista_atomi,  ModelInfo[whichModel-1].atm[i].lab);
      if(kgeom < ISOLATED)
      {
#ifdef IN_GTK3
         GtkWidget *align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
         GtkWidget *align = gtk_alignment_new(0.5, 0.5, 0, 0);
#endif
         gtk_box_pack_start(GTK_BOX(vbox), align, FALSE, FALSE, 4);
         GtkWidget *combotipo = create_combo(align, G_str, NG_str-1, kgeom, NULL,
              G_CALLBACK(combo_tipo_changed), false);
         g_object_set_data(G_OBJECT(dlg), "combotipo", combotipo);
      }
      GSList *group = NULL;
      frame = NEW_FRAME("Position");
      gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 10);
      g_object_set_data(G_OBJECT(dlg), "frame_position", frame);
      GtkWidget *table = hbox_new(FALSE, 0); 
      add_to_frame(frame, table);
      GtkWidget *radio = RADIO_BUTTON_WITH_LABEL(group, "Random position", MyBLUE);
      gtk_box_pack_start(GTK_BOX(table), radio, TRUE, FALSE, 0);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      g_object_set_data(G_OBJECT(dlg), "random", radio);

      radio = RADIO_BUTTON_WITH_LABEL(group, "Centered on atom", MyBLUE);
      gtk_box_pack_start(GTK_BOX(table), radio, TRUE, FALSE, 10);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      g_object_set_data(G_OBJECT(dlg), "centered", radio);
      gtk_widget_set_sensitive(radio, numAtoms > 0);
      g_signal_connect(G_OBJECT(radio), "toggled", G_CALLBACK(radio_selection_changed), NULL);

      GtkWidget *combo = create_combo(NULL, NULL, 0, 0, NULL,
                                G_CALLBACK(combo_selection_changed), false);
      gtk_box_pack_start(GTK_BOX(table), get_widget(combo, "parent"), FALSE, FALSE, 4);
      g_object_set_data(G_OBJECT(dlg), "center", combo);
      fill_my_combog(combo, lista_atomi);
      gtk_widget_set_sensitive(combo, FALSE);
      g_signal_connect(G_OBJECT(radio), "toggled", G_CALLBACK(on_cb_attiva), combo);

      frame = NEW_FRAME("Species");
      gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 10);
      table = table_new(2, 3, FALSE);
      add_to_frame(frame, table);
      table_set_row_spacings(table, 10);
      table_set_col_spacings(table, 10);
      label = LABEL_NEW("Origin", MyBLUE);
      set_alignment(label, 0, 0.5);
      table_attach(table, label, 0, 1, 0, 1);

      combo = create_combo(NULL, (const char **)Specie, nSpec, 0, NULL,
              G_CALLBACK(combo_selection_changed), false);
      table_attach(table, get_widget(combo, "parent"), 1, 2, 0, 1);
      g_object_set_data(G_OBJECT(dlg), "kspec1", combo);
      g_signal_connect(G_OBJECT(radio), "toggled", G_CALLBACK(on_cb_disattiva), combo);
      g_object_set_data(G_OBJECT(combo), "nSpec", GINT_TO_POINTER(nSpec));
      button = myimage_button("     Table", "tableicon.png");
      table_attach(table, button, 2, 3, 0, 1);
      g_signal_connect(G_OBJECT(button), "clicked", 
             G_CALLBACK(on_select_other), combo);

      label = LABEL_NEW("Vertices", MyBLUE);
      set_alignment(label, 0, 0.5);
      table_attach(table, label, 0, 1, 1, 2);

      combo = create_combo(NULL, (const char **)Specie, nSpec, 0, NULL,
              G_CALLBACK(combo_selection_changed), false);
      table_attach(table, get_widget(combo, "parent"), 1, 2, 1, 2);
      g_object_set_data(G_OBJECT(dlg), "kspec2", combo);
      g_object_set_data(G_OBJECT(combo), "nSpec", GINT_TO_POINTER(nSpec));
      button = myimage_button("     Table", "tableicon.png");
      table_attach(table, button, 2, 3, 1, 2);
      g_signal_connect(G_OBJECT(button), "clicked", 
             G_CALLBACK(on_select_other), combo);

      frame = gtk_frame_new(NULL);
      gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 10);
      table = table_new(1, 2, TRUE);
      table_set_row_spacings(table, 10);
      table_set_col_spacings(table, 4);
      gtk_container_set_border_width(GTK_CONTAINER(table), 8);
      gtk_container_add(GTK_CONTAINER(frame), table);
      label = LABEL_NEW("Bond distance", MyBLUE);
      set_alignment(label, 0, 0.5);
      table_attach(table, label, 0, 1, 0, 1, TRUE);
      g_object_set_data(G_OBJECT(dlg), "bdistlab", label);

      label = gtk_entry_new();
      table_attach (table, label, 1, 2, 0, 1, TRUE);
      g_object_set_data(G_OBJECT(dlg), "bdist", label);

      button = QUIT_button();
      gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK);
      g_signal_connect(G_OBJECT(button), "clicked", 
                         G_CALLBACK(on_close_add_frag), GINT_TO_POINTER(1));

      button = APPLY_button();
      gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_APPLY);
      g_signal_connect(G_OBJECT(button), "clicked", 
                         G_CALLBACK(on_ok_add_frag), GINT_TO_POINTER(itipo));

      button = CANCEL_button();
      gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
      g_signal_connect(G_OBJECT(button), "clicked", 
                         G_CALLBACK(on_close_add_frag), GINT_TO_POINTER(2));
      g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
      g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);

      combo_set_val(get_widget(dlg, "kspec1"), kspec1);
      combo_set_val(get_widget(dlg, "kspec2"), kspec2);
      combo_set_val(get_widget(dlg, "center"), 1);

      gtk_widget_show_all(dlg);
      if(!kadd)
         gtk_widget_hide(get_widget(dlg, "frame_position"));
      updateModify(-99);

      gtk_window_resize(GTK_WINDOW(dlg), 2, 2);
      g_list_free(lista_atomi);
   }
   for (int i = 0; i < ModelInfo[whichModel-1].numSpec; i++)
      g_free(Specie[i]);
   g_free(Specie);
}

void on_add_frag_fromfile(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *)data;
   std::string filt = FilesToImport, filt1 = filt;
   size_t n = filt.find_first_of(',');
   if(n != std::string::npos)
      filt1 = filt.erase(n, std::string::npos);
   std::string fn;
   int nfilt;
   fn =  gtkext::dlg_select_file(window, fn, gtkext::eSELECT_TO_READ,
           FilesToImport, false, NULL, false, &nfilt);
   if(str_white(fn.c_str()))
       return;
   int tipo = 0;
   if(nfilt >= 0)
      tipo = FILT_IN_READ[nfilt];

   std::string curdir = getPWD();
   int icod = 22;
   int nptra = 1, nptrb = tipo, idum = 0;
   int *kptra = g_new0(int, 1);
   kptra[0] = 0;
   char *filnam = g_strdup(fromUTF8(fn).c_str());
   jav_modify(kptra, &nptra, NULL, &nptrb, &icod, NULL,-1, &idum, 
              filnam, strlen(filnam));
   dir_set_current(curdir.c_str());
   g_free(filnam);
}

void on_add_tetra(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, TETRA);
}

void on_add_octa(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, OCTA);
}

void on_add_squarep(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, SQUARE);
}

void on_add_cube(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, CUBE);
}

void on_add_trigp(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, TRIG);
}

void on_add_antip(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, APRISM_TETRA);
}

void on_add_prismt(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data,  PRISM_TRIG);
}

void on_add_icos(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, ICOSA);
}

void on_add_isolated(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, ISOLATED);
}

void on_import_tetra(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, 10+TETRA);
}

void on_import_octa(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, 10+OCTA);
}

void on_import_squarep(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, 10+SQUARE);
}

void on_import_trigp(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, 10+TRIG);
}

void on_import_antip(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, 10+APRISM_TETRA);
}

void on_import_prismt(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, 10+PRISM_TRIG);
}

void on_import_icos(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, 10+ICOSA);
}

void on_import_cube(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, 10+CUBE);
}

void on_import_isolated(gpointer, gpointer data)
{
    on_add_frag((GtkWidget *) data, 10+ISOLATED);
}

void on_dup_all(gpointer, gpointer data)
{
    int nptra = 0;
    int nptrb = 0;
    int icod = 29;
    jav_modify(NULL,&nptra,NULL,&nptrb,&icod);        
}

void on_dup_sel(gpointer, gpointer data)
{
    int whichModel = GetActiveModel() - 1;
    int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
    int *kptra = g_new0(int, nptra);
    for(int i=0; i<nptra; i++)
        kptra[i] = ModelInfo[whichModel].atoms_sel[i];
    int nptrb = 0;
    int icod = 29;
    jav_modify(kptra,&nptra,NULL,&nptrb,&icod);        
    endModify(whichModel);
}

void on_expand_sel(gpointer, gpointer data)
{
    int whichModel = GetActiveModel();
    int nptra = (int) ModelInfo[whichModel-1].atoms_sel.size();
    int *kptra = g_new0(int, ModelInfo[whichModel-1].nats);
    for(int i=0; i<nptra; i++)
        kptra[i] = ModelInfo[whichModel-1].atoms_sel[i];
    for(int i=nptra; i<ModelInfo[whichModel-1].nats; i++)
        kptra[i] = 0;
    jav_expand_selection_(kptra,&nptra,&whichModel);
    ModelInfo[whichModel-1].atoms_sel.clear();
    for(int i=0; i<nptra; i++)
    {
        if(kptra[i] > 0)
        {
           ModelInfo[whichModel-1].atoms_sel.push_back(kptra[i]);
           ModelInfo[whichModel-1].atm[kptra[i]-1].selected = true;
        }
    }
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    gl->Redraw();
}

void on_overlay(gpointer, gpointer data)
{
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   if(ModelInfo[whichModel].nats <= 0)
      return;
   GtkWidget *window = (GtkWidget *) data;
   std::string fn = LastModel;
   std::string curdir = getPWD();
   fn =  gtkext::dlg_select_file(window, fn, gtkext::eSELECT_TO_READ, 
          FilesToImport, false, NULL, false);
   if(str_white(fn.c_str()))
       return;
   LastModel.assign(fn);
   char *filnam = g_strdup(fromUTF8(fn).c_str());
//   char *filnam = g_strdup(fn.c_str());
/*
   int icod = 23;
   int nptra = 0, nptrb = 0, idum = 0;
   jav_modify(NULL, &nptra, NULL, &nptrb, &icod, &idum,
              filnam, (int)strlen(filnam)+1);
*/
   overlay_struct_(filnam, strlen(filnam));
   dir_set_current(curdir.c_str());
   g_free(filnam);
}

namespace overlay {
                    compare_info_type  *compare_info;
                  }
        
void overlay_couple_selected(GtkTreeSelection  *sele, GtkWidget *dlg)
{
     using namespace overlay;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     GtkTreeView *tree_view;
     int natom;
     int whichModel = get_int(dlg, "whichModel") - 1;

     for(int i=0; i<ModelInfo[whichModel].nats; i++)
         ModelInfo[whichModel].atm[i].selected = false;
     ModelInfo[whichModel].atoms_sel.clear();

     tree_view = gtk_tree_selection_get_tree_view(sele);
     GList *rowsel = NULL;
     rowsel = get_selections(GTK_WIDGET(tree_view));
     if(rowsel)
     {
        int num_sel = g_list_length(rowsel);
        for(int i=0; i<num_sel; i++)
        {
             GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
             int riga = atoi(gtk_tree_path_to_string(path));
             natom = compare_info->nv1[riga] - 1;
             ModelInfo[whichModel].atm[natom].selected = true;
             ModelInfo[whichModel].atoms_sel.push_back(natom+1);
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
        g_object_set_data(G_OBJECT(dlg), "whichAtom", GINT_TO_POINTER(0));
     }
     gl->Redraw();
     update_items_modify(true, false);
}

void FillOverlayInfo(GtkWidget *dlg)
{
  using namespace overlay;
  GtkWidget *spin = get_widget(dlg, "distance");
  float dist = (float) spin_button_get_value(spin);
  int n0, n1, n2, nass;
  int whichModel = get_int(dlg, "whichModel") - 1;
  int overlayModel = get_int(dlg, "overlayModel");
  
  compare_info = g_new0(compare_info_type, 1);
  jav_get_info_overlay1_(&dist, &nass, &n0, &n1, &n2, &(compare_info->distmin),
                         &(compare_info->distm), &(compare_info->rmsd),
                         &(compare_info->rmsd_nonH),
                         &(compare_info->errph),
                         &(compare_info->nref), &overlayModel);
  compare_info->nfound = n0;
  compare_info->nass = nass;
  atom_type *at1    = g_new0(atom_type, n1);
  atom_type *at2    = g_new0(atom_type, n2);
  int       *nv1    = g_new0(int, nass);
  int       *nv2    = g_new0(int, nass);
  float     *vdist  = g_new0(float, nass);
  jav_get_info_overlay2_(&dist, nv1, nv2, vdist, at1, at2,
                         compare_info->shift, &overlayModel);
  compare_info->at1    = at1; 
  compare_info->at2    = at2; 
  compare_info->nv1    = nv1; 
  compare_info->nv2    = nv2; 
  compare_info->vdist  = vdist;
  
  GtkTreeView *list = GTK_TREE_VIEW(get_widget(dlg, "listacoppie"));
  GtkTreeIter iter;
  GtkTreeViewColumn *column  = gtk_tree_view_get_column (list, 4);
  GtkWidget *w = gtk_tree_view_column_get_widget(column);
  gtk_label_set_text (GTK_LABEL(w), g_strdup_printf("x,y,z (%s)",
      g_path_get_basename(ModelInfo[overlayModel-1].modname)));
  GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
  gtk_list_store_clear(GTK_LIST_STORE(list_store));
  int alt = get_int(dlg, "alt");
  gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"), -1,
         (int) MRmin(1.5f*(compare_info->nass+1)*alt, 18*alt));

  for(int i=0; i<compare_info->nass; i++)
  {
      int n1 = compare_info->nv1[i] - 1;
      int n2 = compare_info->nv2[i] - 1;
      char *lab1 = g_new0(char, 17);
      char *lab2 = g_new0(char, 17);
      CopiaStringan(lab1, 17, compare_info->at1[n1].lab, 16);
      CopiaStringan(lab2, 17, compare_info->at2[n2].lab, 16);
      std::string coord1 = fToStr2(compare_info->at1[n1].xc[0], 3);
      for(int j=1; j<3; j++)
      {
          coord1.append(" ");
          coord1.append(fToStr2(compare_info->at1[n1].xc[j], 3));
      }
      std::string coord2 = fToStr2(compare_info->at2[n2].xc[0], 3);
      for(int j=1; j<3; j++)
      {
          coord2.append(" ");
          coord2.append(fToStr2(compare_info->at2[n2].xc[j], 3));
      }
      gtk_list_store_append (list_store, &iter);
      gtk_list_store_set (list_store, &iter, 0, g_strstrip(lab1), 
                          1, coord1.c_str(), 2, compare_info->vdist[i],
              3, g_strstrip(lab2), 4, coord2.c_str(), -1);
  }
  std::stringstream results;
  results << "Atoms in " << g_path_get_basename(ModelInfo[whichModel].modname) << ": " << n1 << "\n";
  results << "Atoms in " << g_path_get_basename(LastModel.c_str()) << ": " << n2 << "\n";
  results << "Matches found:     " << n0 << "\n";
  results << "Mean Phase Error:  " 
          << std::fixed << std::right << std::setprecision( 3 )
          << compare_info->errph << " using "
          << std::fixed << std::right << std::setprecision( 3 )
          << compare_info->nref << " reflections\n";
  results << "<Dist>:             " << compare_info->distm << "\n";
  results << "RMSD:               " << compare_info->rmsd << "\n";
  if(compare_info->rmsd_nonH >= 0)
     results << "RMSD (non H atoms): " << compare_info->rmsd_nonH << "\n";
  GtkWidget *label = get_widget(dlg, "results");
  gtk_label_set_text(GTK_LABEL(label), results.str().c_str());
}

void on_change_dist(GtkWidget *, GtkWidget *dlg)
{
   FillOverlayInfo(dlg);
}

static void selected_model_for_overlay(GtkWidget *combo, gpointer )
{
    GtkWidget *dlg = gtk_widget_get_toplevel(combo);
    int whichModel = combo_get_val(combo);
    if(whichModel > 0)
       g_object_set_data(G_OBJECT(dlg), "overlayModel", GINT_TO_POINTER(whichModel+1));
   FillOverlayInfo(dlg);
}

GtkWidget *create_overlay_info (GtkWidget *window, GList *listModels)
{
  GtkWidget *dialog1;
  GtkWidget *button;
  GtkWidget *frame;
  GtkWidget *list;
  GtkWidget *align;
  GtkWidget *spin;
  GtkWidget *label;
  int lar, alt;
  const char *titles[] = { "Atom", "Coordinates", "Distance",
                           "Atom", "Coordinates"};
  GType types[] = { G_TYPE_STRING, G_TYPE_STRING, G_TYPE_FLOAT,
                    G_TYPE_STRING, G_TYPE_STRING};
  int  sizes[] = { 0, 0, 0, 0, 0};
  int  precs[] = { 0, 0, 3, 0, 0};
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));

  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "Overlay Info");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
  g_object_set_data(G_OBJECT(dialog1), "alt", GINT_TO_POINTER(alt));

  frame = FRAME_BOLD("Matches", MyBLUE, 1.1f);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  list = new_selection(dialog1, frame, "listacoppie", ncol, titles, sizes, types, precs);
  gtk_widget_show (list);
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  (void) g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (overlay_couple_selected), dialog1);

  frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);

  GtkWidget *hbox = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER (frame), hbox);
  spin = SPIN_WITH_LABEL("Distance limit ", NULL, 0.001f, 3.f, 0.6f, 0.01f, 3);
  g_object_set_data(G_OBJECT(dialog1), "distance", get_widget(spin, "spin"));
  gtk_box_pack_start(GTK_BOX(hbox), spin, FALSE, FALSE, 0);
  g_signal_connect(G_OBJECT(get_widget(spin, "spin")), "value-changed",
                   G_CALLBACK(on_change_dist), dialog1);
  GtkWidget *combo = create_combo (NULL, NULL, 0, 0, NULL, G_CALLBACK(selected_model_for_overlay));
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(combo, "entry")), FALSE);
  block_handler(combo);
  set_popdown_strings(combo, listModels);
  combo_set_val(combo, (int) g_list_length(listModels));
  unblock_handler(combo);
  gtk_box_pack_end(GTK_BOX(hbox), get_widget(combo, "parent"), FALSE, FALSE, 4);
  gtk_container_set_border_width(GTK_CONTAINER(get_widget(combo, "parent")), 8);
  label = LABEL_NEW("Select model", NULL);
  gtk_box_pack_end(GTK_BOX(hbox), label, FALSE, FALSE, 0);


  frame = FRAME_BOLD("Results", MyBLUE, 1.1f);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);

  align = gtk_frame_new(NULL);
  gtk_widget_show (align);
  gtk_container_set_border_width (GTK_CONTAINER (align), 6);
  gtk_frame_set_shadow_type(GTK_FRAME(align), GTK_SHADOW_NONE);
  gtk_container_add(GTK_CONTAINER (frame), align);

  label = gtk_label_new("");
  gtk_widget_show (label);
  gtk_container_add(GTK_CONTAINER (align), label);
  set_alignment(label, 0., 0.5);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  widget_modify_font(label, fontlist);
  g_object_set_data(G_OBJECT(dialog1), "results", label);

  button = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button, 1);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = InfoOverlay;
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(chiudi_dlg), (gpointer) st);
  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show_all(dialog1);
  return dialog1;
}

void on_overlay_info(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   GtkWidget *dlg;
   GList *listModels = NULL;

   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   if(str_white(LastModel.c_str()) || (gl->nModels <= 1))
   {
      gtkext::dlg_errmsg(GTK_WINDOW(window), "Sorry. You should load another model to overlay.");
       return;
   }
   for(int i=1; i<gl->nModels; i++)
       listModels = g_list_append(listModels,
              g_path_get_basename(ModelInfo[i].modname));
   if(g_object_get_data(G_OBJECT(window), InfoOverlay))
   {
      dlg = get_widget(window, InfoOverlay);
      gdk_window_raise(gtk_widget_get_window(dlg));
   }
   else
   {
      dlg = create_overlay_info(window, listModels);
      g_object_set_data(G_OBJECT(window), InfoOverlay, dlg);
   }
   g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(whichModel+1));
   g_object_set_data(G_OBJECT(dlg), "overlayModel", GINT_TO_POINTER(gl->nModels));
   FillOverlayInfo(dlg);
}

float getRFvalue()
{
  structure_info_type StructInfo;
  int ifCalc = 1;
  int wm =  GetActiveModel();
  getstructureinfo_(&StructInfo, &ifCalc, &wm);
  return StructInfo.r_factor;
}

void PolyOnOff(gpointer item, gpointer )
{
   gboolean active = obj_get_active(item);
   int result = 0;

   int whichModel = GetActiveModel();
   if(whichModel == 0)
        return;
   if(ModelInfo[whichModel-1].nats > 0)
   {
       result++;
       ModelInfo[whichModel-1].ifPoly = (active != 0);
       jav_polyhedra_(&whichModel);
   }
}

void Model::SetEllVal(int na, float Ell[3][3], float CD[3][3], float semax[3])
{
      float bf = (float) (atm[na].B / (8 * M_PI * M_PI));
      float Ell_val;
      if (bf <= 0.0000001f)
      {
          int kspec = atm[na].color;
          float Rs2 = radii[kspec][0] * radii[kspec][0] / 9;
          bf = Rs2;
      }
      Ell_val = 1.f / bf;
      for(int j=0; j<3; j++)
      {
          for(int k=0; k<3;k++)
          {
              Ell[j][k] = 0;
              CD[j][k] = 0;
              if(j == k)
              {
                 Ell[j][j] = Ell_val;
                 CD[j][j] = 1.f;
              }
          }
      }
      semax[0] = semax[1] = semax[2] = (float)sqrt(bf);
}

void Model::NorEll(int na, float el[3][3], float Ell[3][3], float CD[3][3],
        float semax[3], int *ifIso)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   float P = 0.5f;
   float FProb = (((((23.326f*P)-55.693f)*P+51.552f)*P-22.75f)*P+6.447f)*P+0.296f;
   double del[3][3], eigen[3], t3[3][3];
   int iCod;
   mat3x3 trm = MRMatrix3Transpose(gl->rmC);
   mat3x3 ba = MRMatrix3Multiply(MRMatrixMakeFromArray(el), trm);
   mat3x3 be = MRMatrix3Multiply(gl->rmC, ba);
   bool result;
   mat3x3 resultM = MRMatrix3Invert(be, &result);
   if(!result)
   {
      *ifIso = 1;
      SetEllVal(na, Ell, CD, semax);
      return;
   }
   for(int i=0; i<3; i++)
   {
      for(int j=0; j<3; j++)
      {
          t3[i][j] = 0.;
          del[i][j] = resultM.m[i*3+j];//[i][j];
      }
   }
   autov(del, eigen, t3, &iCod);
   //      g_print("Atm %s, ", atm[na].lab);
   //      g_print("eigen %.4f %.4f %.4f\n", eigen[0], eigen[1], eigen[2]);
   result = (iCod != 0) && (eigen[0] > 0) && (eigen[1] > 0) && (eigen[2] > 0);

   if(!result)
   {
      *ifIso = 1;
      SetEllVal(na, Ell, CD, semax);
      return;
   }
   for(int i=0; i<2 ; i++)
   {
       for(int j=i+1; j<3; j++)
       {
            double ps = t3[0][i]*t3[0][j]+t3[1][i]*t3[1][j]+t3[2][i]*t3[2][j];
            if (MRabs(ps) > 0.000001f)
                result = false;
       }
   }
   if(!result)
   {
      *ifIso = 1;
      SetEllVal(na, Ell, CD, semax);
      return;
   }

   for(int j=0; j<3; j++)
       semax[j] = (float) (1./sqrt(MRabs(eigen[j])));
   for(int j=0; j<3; j++)
   {
       double q = 0;
       for(int i=0; i<3; i++)
           q += t3[i][j] * t3[i][j];
       for(int i=0; i<3; i++)
       {
           if(MRabs(t3[i][j]) > 1.e-15)
               t3[i][j] = sqrt(t3[i][j]*t3[i][j]/q)*t3[i][j]/MRabs(t3[i][j]);
       }
   }
   for(int j=0; j<3; j++)
       for(int i=0; i<3; i++)
           CD[i][j] = (float) t3[i][j];
   for(int j=0; j<3; j++)
       for(int i=0; i<3; i++)
           Ell[i][j] =  el[i][j] / FProb;
   return;
}

void Model::PreparaEllissoidi(GLWindow *gl)
{
    float el[3][3];
    float pp2 = (float) (M_PI * M_PI * 2);
    int ifIso = 0;
    int pnat = 0;
    int pdraw = 0;
    std::string outStr;
    outStr.assign("Problems with anisotropic thermal parameters of atom(s)\n");
    std::string drawStr;
    drawStr.assign("Problems with ellipsoid semiaxes of atom(s)\n");
    for(int i=0; i<nats; i++)
    {
        float Ell[3][3], CD[3][3], semax[3];
        if (atm[i].Bij[0] > 0.f)
        {
            Ell[0][0] = atm[i].Bij[0];
            Ell[0][1] = atm[i].Bij[3];    //[1];
            Ell[1][0] = atm[i].Bij[3];    //[1];
            Ell[0][2] = atm[i].Bij[4];    //[2];
            Ell[2][0] = atm[i].Bij[4];    //[2];
            Ell[1][1] = atm[i].Bij[1];    //[3];
            Ell[1][2] = atm[i].Bij[5];    //[4];
            Ell[2][1] = atm[i].Bij[5];    //[4];
            Ell[2][2] = atm[i].Bij[2];    //[5];
            for(int jj=0; jj<3;jj++)
            {
              for(int kk=jj;kk<3;kk++)
              {
                  el[jj][kk] = Ell[jj][kk] / pp2;
                  if(jj != kk)
                     el[jj][kk] = el[jj][kk]/2.f;
              }
            }
            el[1][0] = el[0][1];
            el[2][0] = el[0][2];
            el[2][1] = el[1][2];
            ifIso = 0;
            NorEll(i, el, Ell, CD, semax, &ifIso);
            if(ifIso)
            {
               pnat++;
               outStr.append( g_strstrip(g_strdup(atm[i].lab)) );
               outStr.append( " " );

            }
         }
         else
            SetEllVal(i, Ell, CD, semax);

         int X = 0, Y = 1, Z = 2;
         float Mat[] = {
                     CD[X][0], CD[Y][0], CD[Z][0], 0,
                     CD[X][1], CD[Y][1], CD[Z][1], 0,
                     CD[X][2], CD[Y][2], CD[Z][2], 0,
                     0, 0, 0, 1};
         memcpy(atm[i].mat, Mat, 16*sizeof(float));

         float semin = 9999.f;
         for(int kk=0; kk<3; kk++)
         {
             if(semin > semax[kk])
                semin =  semax[kk];
         }
         atm[i].scala[3] = 0;
         for(int kk=0; kk<3; kk++)
         {
             atm[i].scala[kk] = semax[kk]/semin;
             if(atm[i].scala[3] < atm[i].scala[kk])
                atm[i].scala[3] = atm[i].scala[kk];
         }
         if(atm[i].scala[3] < 1e-8)
            atm[i].scala[3] = 1;

         if(atm[i].scala[3] > 20)
         {
            SetEllVal(i, Ell, CD, semax);
            for(int kk=0; kk<4; kk++)
                atm[i].scala[kk] = 1;
            semin = 0.2f;
            pdraw++;
            drawStr.append( g_strstrip(g_strdup(atm[i].lab)) );
            drawStr.append( " " );
         }

         atm[i].semin = 5 * semin;
#if 0
         {
         g_print("Atm %s, ", atm[i].lab);
         for(int kk=0; kk<3; kk++)
           g_print("cd %.4f %.4f %.4f ", CD[0][kk], CD[1][kk], CD[2][kk]);
         g_print("\n");
         g_print("Atm %s, semin %.4f scala %.4f %.4f %.4f\n", atm[i].lab, atm[i].semin, 
             atm[i].scala[0], atm[i].scala[1], atm[i].scala[2]);
         g_print("Atm %s, semax %.4f %.4f %.4f\n", atm[i].lab, semax[0],
             semax[1], semax[2]);
         }
#endif
    }
//Corrado: Uncomment for silent-error
//    return;

    if(pnat)
    {
       outStr.append(".\n");   //Set to isotropic.");
       //MessageDialog(GLWINDOW, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
       //              outStr.c_str());
    }
    if(pdraw)
    {
       drawStr.append(". Draw as isotropic.");
       MessageDialog(GLWINDOW, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
                     drawStr.c_str());
    }
}

int GetInfo(int code, int whichModel)
{
      if(GLWINDOW ==NULL)
         return 0;
      GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
      int result;
      gpointer ck;
      switch(code)
      {
      default:
           result = 0;
           break;
      case IFCELL:
           result = gl->ifCell?1:0;
           break;
      case IFSYMM:
           result = ModelInfo[whichModel].ifSymmetry?1:0;
           break;
      case PLOTSTYLE:
           result = ModelInfo[whichModel].plotStyle + 1;
           break;
      case IFLABELS:
           result = ModelInfo[whichModel].ifLabels?1:0;
           break;
      case SYMLEVEL:
           result = 0;
           break;
      case IFPOLYHEDRA:
           result = ModelInfo[whichModel].ifPoly;
           break;
      case IFGROW:
           ck = get_object(GLWINDOW, "Grow Fragment");
           result = obj_get_active(ck);
           break;
      case IFHBONDS:
           ck = get_object(GLWINDOW, "Hydrogen Bonds");
           result = obj_get_active(ck);
           break;
      case IFSHORTC:
           ck = get_object(GLWINDOW, "Short Contacts");
           result = obj_get_active(ck);
           break;
      case IFDELHANG:
           ck = get_object(GLWINDOW, "Delete Hanging Contacts");
           result = obj_get_active(ck);
           break;
      }
      return result;
}

void GrowOnOff(gpointer item, gpointer data)
{
   int ifgrow = 0;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   ifgrow = obj_get_active(item);
   gl->ifGrow = ifgrow;
   int result = 0;
   int current_wm = GetActiveModel() - 1;

   for(int k=0; k<gl->nModels; k++)
   {
       if(gl->nModels > 1)
          SetActive(k);
       if(ModelInfo[k].nats <= 0)
          continue;
       int wm = k + 1;
       result += jav_grow_fragment_(&wm);
   }
   if(!result)
   {
       obj_set_active(item, FALSE, true);
       gl->ifGrow = FALSE;
   }
   SetActive(current_wm);
}

void HydBondsOnOff(gpointer item, gpointer data)
{
   int ifhbonds = 0;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");

   ifhbonds = obj_get_active(item);
   int result = 0;
   int current_wm = GetActiveModel() - 1;
   gl->ifHBonds = ifhbonds;
   for(int k=0; k<gl->nModels; k++)
   {
       if(gl->nModels > 1)
          SetActive(k);
       if(ModelInfo[k].nats <= 0)
          continue;
       int wm = k + 1;
       result += jav_hydrogen_bonds_(&wm);
   }
   if(!result)
   {
       obj_set_active(item, FALSE, true);
       gl->ifHBonds = FALSE;
   }
   gpointer check = get_object(window, "Delete Hanging Contacts");
   obj_set_sensitive(check, gl->ifHBonds+gl->ifShortc);
   if(!gl->ifHBonds)
   {
      obj_set_active(check, FALSE, true);
      gl->ifDelHang = obj_get_active(check);
   }
   SetActive(current_wm);
}

void ShortContOnOff(gpointer item, gpointer data)
{
   int ifshcont = 0;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   ifshcont = obj_get_active(item);
   int current_wm = GetActiveModel() - 1;

   gl->ifShortc = ifshcont;
   int result = 0;
   for(int k=0; k<gl->nModels; k++)
   {
       if(gl->nModels > 1)
          SetActive(k);
       if(ModelInfo[k].nats <= 0)
          continue;
       int wm = k + 1;
       result += jav_short_contacts_(&wm);
   }
   if(!result)
   {
       obj_set_active(item, FALSE, true);
       gl->ifShortc = FALSE;
   }
   gpointer check = get_object(window, "Delete Hanging Contacts");
//   obj_set_sensitive(check, gl->ifShortc);
   obj_set_sensitive(check, gl->ifHBonds+gl->ifShortc);
   if(!gl->ifShortc)
   {
      obj_set_active(check, FALSE, true);
      gl->ifDelHang = obj_get_active(check);
   }
   SetActive(current_wm);
}

void DelHangContOnOff(gpointer item, gpointer data)
{
   int ifdelhang = 0;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   ifdelhang = obj_get_active(item);
   gl->ifDelHang = ifdelhang;
   int current_wm = GetActiveModel() - 1;

   for (int i=0;i<ModelInfo[current_wm].nlegsH; i++)
   {
// hang atom?
        int n2 = MRabs(ModelInfo[current_wm].legsH[i].n2);
//        if((gl->ifDelHang)  && (ModelInfo[current_wm].legsH[i].n2 < 0))
        if((gl->ifDelHang)  && (ModelInfo[current_wm].legsH[i].ordleg == 1))
            ModelInfo[current_wm].atm[n2-1].hidden = true;
        else
            ModelInfo[current_wm].atm[n2-1].hidden = false;
   }

   for (int i=0;i<ModelInfo[current_wm].nlegsW; i++)
   {
// hang atom?
        int n2 = MRabs(ModelInfo[current_wm].legsW[i].n2);
//        if((gl->ifDelHang)  && (ModelInfo[current_wm].legsW[i].n2 < 0))
        if((gl->ifDelHang)  && (ModelInfo[current_wm].legsW[i].ordleg == 1))
            ModelInfo[current_wm].atm[n2-1].hidden = true;
        else
            ModelInfo[current_wm].atm[n2-1].hidden = false;
   }
   ModelInfo[current_wm].ifResize = true;
   gl->RiNormalizza();
   gl->Redraw();
}

void set_values_for_HBOpt(GtkWidget *father, _ContactType d[], _ContactType a[],
                       _ContactOptionType opt)
{
  for(int i=0; i<NDONORS; i++)
  {
      std::stringstream nome;
      nome << "d" << i;
      GtkWidget *check = get_widget(father, nome.str().c_str());
      gtk_button_set_label(GTK_BUTTON(check), label_c(d[i]));
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), active_c(d[i]));
  }
  for(int i=0; i<NACCEPTORS; i++)
  {
      std::stringstream nome;
      nome << "a" << i;
      GtkWidget *check = get_widget(father, nome.str().c_str());
      gtk_button_set_label(GTK_BUTTON(check), label_c(a[i]));
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), active_c(a[i]));
  }
  GtkWidget *check = get_widget(father, "inter");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), opt.inter);
  check = get_widget(father, "intra");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), opt.intra);
  check = get_widget(father, "nminbond");
//03082017  if(opt.intra)
     spin_button_set_value(check, opt.nminbond);
  check = get_widget(father, "hpresent");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), opt.hpresent);
  check = get_widget(father, "tolmin");
  spin_button_set_value(check, MRabs(opt.tolmin));
  check = get_widget(father, "tolmax");
  spin_button_set_value(check, MRabs(opt.tolmax));
  check = get_widget(father, "signmin");
  int sign = 1;
  if(opt.tolmin > 0)
     sign = 2;
  combo_set_val(check, sign);
  check = get_widget(father, "signmax");
  sign = 2;
  if(opt.tolmax < 0)
     sign = 1;
  combo_set_val(check, sign);
}

void get_values_for_HBOpt(GtkWidget *father, _ContactType d[], _ContactType a[],
                       _ContactOptionType *opt)
{
  for(int i=0; i<NDONORS; i++)
  {
      std::stringstream nome;
      nome << "d" << i;
      GtkWidget *check = get_widget(father, nome.str().c_str());
      d[i].active = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));
  }
  for(int i=0; i<NACCEPTORS; i++)
  {
      std::stringstream nome;
      nome << "a" << i;
      GtkWidget *check = get_widget(father, nome.str().c_str());
      a[i].active = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));
  }
  GtkWidget *check = get_widget(father, "inter");
  opt->inter = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));
  check = get_widget(father, "intra");
  opt->intra = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));
  check = get_widget(father, "nminbond");
  if(opt->intra)
     opt->nminbond = spin_button_get_value_as_int(check);
  check = get_widget(father, "hpresent");
  opt->hpresent = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));
  GtkWidget *spin = get_widget(father, "tolmin");
  opt->tolmin = (float) spin_button_get_value(spin);
  GtkWidget *combo = get_widget(father, "signmin");
  int sign = combo_get_val(combo);
  if(sign == 1)
     opt->tolmin = -opt->tolmin;
  spin = get_widget(father, "tolmax");
  opt->tolmax = (float) spin_button_get_value(spin);
  combo = get_widget(father, "signmax");
  sign = combo_get_val(combo);
  if(sign == 1)
     opt->tolmax = -opt->tolmax;

}

void apply_HBopt(GtkWidget *button, gpointer )
{
   GtkWidget *father = gtk_widget_get_toplevel(button);
   _ContactType donor[NDONORS], acceptor[NACCEPTORS];
   _ContactOptionType HBopt;
   get_values_for_HBOpt(father, donor, acceptor, &HBopt);
   int wm = GetActiveModel();
   puthboptions_(&wm,donor, acceptor, &HBopt);
}

void ok_HBopt(GtkWidget *button, gpointer data)
{
  apply_HBopt(button, data);
  chiudi_dlg(button, data);
}

void default_HBopt(GtkWidget *, gpointer data)
{
  GtkWidget *father = (GtkWidget *) data;
  set_values_for_HBOpt(father, donor0, acceptor0, HBopt0);
  int wm = GetActiveModel();
  puthboptions_(&wm,donor0, acceptor0, &HBopt0);
}

void RestoreHBOptions(_ContactType donor[], _ContactType acceptor[],
                         _ContactOptionType *HBopt)
{
   memcpy(donor, DSave, NDONORS*sizeof(_ContactType));
   memcpy(acceptor, ASave, NACCEPTORS*sizeof(_ContactType));
   memcpy(HBopt, &OptSave, sizeof(_ContactOptionType));
}

void close_HBopt(GtkWidget *button, gpointer data)
{
   _ContactType donor[NDONORS], acceptor[NACCEPTORS];
   _ContactOptionType HBopt;
   RestoreHBOptions(donor, acceptor, &HBopt);
   int wm = GetActiveModel();
   puthboptions_(&wm,donor, acceptor, &HBopt);
   chiudi_dlg(button, data);
}

GtkWidget *create_HBOpt(gpointer data)
{
  const char *plusmin[] = {"minus", "plus"};

  GtkWidget *window = (GtkWidget *) data;
  GtkWidget *dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "H-bonds Options");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));

  GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Require hydrogen atom to be present", NULL);
  gtk_box_pack_start(GTK_BOX (vbox1), check, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(dialog1), "hpresent", check);

  GtkWidget *hbox = table_new(1, 2, TRUE);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox, TRUE, TRUE, 4);
  GtkWidget *frame1 = FRAME_BOLD("Donor atom types", MyBLUE, 1.1f);
  table_attach(hbox, frame1, 0, 1, 0, 1, TRUE);
  GtkWidget *frame2 = FRAME_BOLD("Acceptor atom types", MyBLUE, 1.1f);
  table_attach(hbox, frame2, 1, 2, 0, 1, TRUE);
  GtkWidget *vb = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame1), vb);
  for(int i=0; i<NDONORS; i++)
  {
      std::stringstream nome;
      nome << "d" << i;
      check = CHECK_BUTTON_WITH_LABEL (label_c(donor0[i]), NULL);
      g_object_set_data(G_OBJECT(dialog1), nome.str().c_str(), check);
      gtk_box_pack_start(GTK_BOX(vb), check, FALSE, FALSE, 0);
  }
  vb = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame2), vb);
  for(int i=0; i<NACCEPTORS; i++)
  {
      std::stringstream nome;
      nome << "a" << i;
      check = CHECK_BUTTON_WITH_LABEL (label_c(acceptor0[i]), NULL);
      g_object_set_data(G_OBJECT(dialog1), nome.str().c_str(), check);
      gtk_box_pack_start(GTK_BOX(vb), check, FALSE, FALSE, 0);
  }
  GtkWidget *frame3 = NEW_FRAME("Contact distance range");
  gtk_box_pack_start(GTK_BOX (vbox1), frame3, TRUE, FALSE, 4);

  GtkWidget *table = table_new(2, 3, FALSE);
  add_to_frame(frame3, table);
  table_set_col_spacings(table, 8);
  GtkWidget *label = LABEL_NEW("Minimum = sum of vdW radii", NULL);
  set_alignment(label, 0, 0.5f);
  table_attach(table, label, 0, 1, 0, 1);
  label = LABEL_NEW("Maximum = sum of vdW radii", NULL);
  set_alignment(label, 0, 0.5f);
  table_attach(table, label, 0, 1, 1, 2);
  GtkWidget *combo = create_combo(NULL, plusmin, 2, 1, NULL);
  set_width_chars(GTK_ENTRY(get_widget(combo, "entry")), 6);
  table_attach(table, get_widget(combo, "parent"), 1, 2, 0, 1);
  g_object_set_data(G_OBJECT(dialog1), "signmin", combo);
  GtkWidget *spin  = SPIN_NEW(0, 10, 0, 0.01, 2);
  g_object_set_data(G_OBJECT(dialog1), "tolmin", spin);
  set_width_chars(GTK_ENTRY(spin), 4);
  table_attach(table, spin, 2, 3, 0, 1);
  combo = create_combo(NULL, plusmin, 2, 2, NULL);
  table_attach(table, get_widget(combo, "parent"), 1, 2, 1, 2);
  set_width_chars(GTK_ENTRY(get_widget(combo, "entry")), 6);
  g_object_set_data(G_OBJECT(dialog1), "signmax", combo);
  spin  = SPIN_NEW(0, 10, 0, 0.01, 2);
  g_object_set_data(G_OBJECT(dialog1), "tolmax", spin);
  set_width_chars(GTK_ENTRY(spin), 4);
  table_attach(table, spin, 2, 3, 1, 2);

  check = CHECK_BUTTON_WITH_LABEL ("Intermolecular", NULL);
  gtk_box_pack_start(GTK_BOX (vbox1), check, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(dialog1), "inter", check);

  hbox = hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX (vbox1), hbox, FALSE, FALSE, 4);
  check = CHECK_BUTTON_WITH_LABEL ("Intramolecular: donor and acceptor separated by >", NULL);
#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  GtkWidget *align = gtk_alignment_new(0, 0, 0, 0);
#endif
  gtk_box_pack_start(GTK_BOX (hbox), align, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(align), check);
  g_object_set_data(G_OBJECT(dialog1), "intra", check);
  label  = spin_button_new_with_range(0, 10, 1);
  spin_button_set_digits(label, 0);
  gtk_widget_set_sensitive(label, FALSE);
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  align = gtk_alignment_new(0, 0, 0, 0);
#endif
  gtk_box_pack_start(GTK_BOX (hbox), align, FALSE, FALSE, 4);
  gtk_container_add(GTK_CONTAINER(align), label);
  g_object_set_data(G_OBJECT(dialog1), "nminbond", label);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), label);
  label = LABEL_NEW("bonds", NULL);
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_FILL, 0, 1);
#else
  align = gtk_alignment_new(0, 0, 0, 1);
#endif
  gtk_box_pack_start(GTK_BOX (hbox), align, FALSE, FALSE, 4);
  gtk_container_add(GTK_CONTAINER(align), label);
  set_alignment(label, 0, 0.5f);

  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = HBOptWindow;

  GtkWidget *button = OK_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_OK);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(ok_HBopt), (gpointer) st);
  button = APPLY_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_APPLY);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(apply_HBopt), data);
  button = DEFAULTS_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_ACCEPT);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(default_HBopt), dialog1);
  button = CANCEL_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_CANCEL);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(close_HBopt), (gpointer) st);
  g_signal_connect_swapped(G_OBJECT(dialog1), "delete-event", G_CALLBACK(gtk_button_clicked), button);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);
  gtk_widget_show_all(dialog1);
  return dialog1;

}

void SaveHBoptions(_ContactType donor[], _ContactType acceptor[],
                         _ContactOptionType *HBopt)
{
   memcpy(DSave, donor, NDONORS*sizeof(_ContactType));
   memcpy(ASave, acceptor, NACCEPTORS*sizeof(_ContactType));
   memcpy(&OptSave, HBopt, sizeof(_ContactOptionType));
}

void on_EditHbonds(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GtkWidget *dlg;
   if(g_object_get_data(G_OBJECT(window), HBOptWindow))
   {
      dlg = get_widget(window, HBOptWindow);
      gdk_window_raise(gtk_widget_get_window(dlg));
      return;
   }
   dlg = create_HBOpt(data);
   g_object_set_data(G_OBJECT(window), HBOptWindow, dlg);
   _ContactType donor[NDONORS], acceptor[NACCEPTORS];
   _ContactOptionType HBopt;
   gethboptions_(donor, acceptor, &HBopt);
   SaveHBoptions(donor, acceptor, &HBopt);
   set_values_for_HBOpt(dlg, donor, acceptor, HBopt);
}

void GetFormDist(GtkWidget *list, float vett[])
{
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GtkTreeIter iter;
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    int i = 0;
    while (valid && (i<NHDistances))
    {
       gtk_tree_model_get(model, &iter, 1, &vett[i], -1);
       i++;
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

void FillFormDist(GtkWidget *list, float vett[])
{
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GtkTreeIter iter;
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    int i = 0;
    while (valid && (i<NHDistances))
    {
       gtk_list_store_set(GTK_LIST_STORE(model), &iter, 1, vett[i], -1);
       i++;
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

void on_cancel_edit_hydro(GtkWidget *button, gpointer data)
{
  int code = 3;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  int whichModel = get_int(dlg, "whichModel");
  jav_normalize_structure_(&code, ModelInfo[whichModel-1].distHn, &whichModel);
  chiudi_dlg(button, data);
  updateModify(1);
}

void on_apply_edit_hydro(GtkWidget *button, gpointer )
{
  int code = 2;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  GtkWidget *list = get_widget(dlg, "disthn_list");
  int whichModel = get_int(dlg, "whichModel");
  GetFormDist(list, ModelInfo[whichModel-1].distHn);
  jav_normalize_structure_(&code, ModelInfo[whichModel-1].distHn, &whichModel);
  updateModify(-99);
}

void on_default_edit_hydro(GtkWidget *button, gpointer )
{
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  GtkWidget *list = get_widget(dlg, "disthn_list");
  int whichModel = get_int(dlg, "whichModel") - 1;
  memcpy( ModelInfo[whichModel].distHn, distH0, NHDistances*sizeof(float));
  FillFormDist(list, ModelInfo[whichModel].distHn);
}

void on_ok_edit_hydro(GtkWidget *button, gpointer data)
{
  int code = 1;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  GtkWidget *list = get_widget(dlg, "disthn_list");
  int whichModel = get_int(dlg, "whichModel");
  GetFormDist(list, ModelInfo[whichModel-1].distHn);
  jav_normalize_structure_(&code, ModelInfo[whichModel-1].distHn, &whichModel);
  chiudi_dlg(button, data);
  updateModify(1);
}

GtkWidget *crea_norm_hydro (GtkWidget *window)
{
  GtkWidget *dialog1;
  GtkWidget *button;
  const char *titles[] = { "Atom Type", "Bond Lenght" };
  GType types[] = { G_TYPE_STRING, G_TYPE_FLOAT };
  int  sizes[] = { 0, 0 };
  int precs[] = { 0, 2};
  bool editable[] = {false, true};
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  int alt, lar;
  const char *labeldist[] = {"Methyl group CH3",
                             "Methilene group CH3",
                             "Methine CH",
                             "Acetylenic CH",
                             "Aromatic CH",
                             "Terminal X=CH2",
                             "O-H",
                             "N-H in primary amine",
                             "N-H in secondary amine",
                             "S-H",
                             "B-H"};

  int whichModel = GetActiveModel() - 1;
  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1),
                     "Normalising Hydrogen Atom Positions");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
  g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(whichModel+1));
  GtkWidget *list =
  new_selection(dialog1, vbox1, "hydrogens", ncol, titles, sizes,
                types, precs, editable, G_CALLBACK(on_edit_cell));
  widget_modify_font(list, fontlist);
  gtk_widget_set_size_request(get_widget(list, "scrollwin"), -1, (NHDistances+6)*alt);
  g_object_set_data(G_OBJECT(dialog1), "disthn_list", list);

  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      GtkWidget *label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
      gtk_tree_view_column_set_clickable(column, FALSE);
      g_object_set_data(G_OBJECT(column), "father", list);
  }
  GtkTreeIter iter;
  GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(
             GTK_TREE_VIEW(list)));
  gtk_list_store_clear(list_store);
  for(int i=0; i<(int)(sizeof(labeldist)/sizeof(labeldist[0])); i++)
  {
      gtk_list_store_append (list_store, &iter);
      gtk_list_store_set (list_store, &iter, 0, labeldist[i], -1);
  }

  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = EditHDist;

  button = OK_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, 1);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_ok_edit_hydro), (gpointer) st);
  button = APPLY_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, 2);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_apply_edit_hydro), NULL);
  g_object_set_data(G_OBJECT(dialog1), "apply_b", button);
  button = DEFAULTS_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, 3);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_default_edit_hydro), NULL);
  button = CANCEL_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, 4);
  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_cancel_edit_hydro), (gpointer) st);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show_all(dialog1);

  return dialog1;
}

void on_norm_hydro(gpointer, gpointer data)
{
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
   GtkWidget *window = (GtkWidget *) data;
   GtkWidget *dlg;
   if(g_object_get_data(G_OBJECT(window), EditHDist))
   {
      dlg = get_widget(window, EditHDist);
      gdk_window_raise(gtk_widget_get_window(dlg));
   }
   else
   {
      dlg = crea_norm_hydro(window);
      g_object_set_data(G_OBJECT(window), EditHDist, dlg);
      g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(whichModel+1));
   }
   updateModify(-99);
   whichModel = get_int(dlg, "whichModel");
   int code = 0;
   jav_normalize_structure_(&code, ModelInfo[whichModel-1].distHn, &whichModel);
   FillFormDist(get_widget(dlg, "disthn_list"), ModelInfo[whichModel-1].distHn);
}

void SetActive(int which)
{
// DA RIFARE
#ifdef JAV
//   int wm = which + 1;
//     csetmodel_(&wm);
   int nk, no[MAX_SPECIES], nw[MAX_SPECIES];
   float raggi[2][MAX_SPECIES];
   _StructSpecies StructSpecies;

   for(int i=0; i<MAX_SPECIES; i++)
   {
        raggi[0][i] = raggi[1][i] = 0;
        no[i] = 0;
        nw[i] = 0;
        memcpy(&(StructSpecies.sp), ModelInfo[which].LabSpec, sizeof(_StructSpecies));
   }
   nk = ModelInfo[which].numSpec;
   for (int j=0; j< ModelInfo[which].numSpec; j++)
   {
        no[j] = ModelInfo[which].Species[j];
        nw[j] = ModelInfo[which].Content[j];
        raggi[0][j] = ModelInfo[which].radii[j][0];
        raggi[1][j] = ModelInfo[which].radii[j][1];
   }
   putspeciesinfo_(&nk, nw, no, raggi, &StructSpecies);
#endif
}

bool GLWindow::poliedri()
{     
   for(int i=0; i<nModels; i++)    
       if(ModelInfo[i].ifPoly)
          return true;
   return false;
}     

#ifdef MAPS
void SettaSurface(int which, int ifView)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   ModelInfo[which].ifSurface = (ifView != 0);
   VWSurface[which].ifVis = (ifView != 0);
   gl->Redraw();
}

void RicalcolaSurface(int which, GtkWidget *dlg)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   float step = VWSurface[which].step;
   float radius = VWSurface[which].radius;
   VWSurface[which].freeMap();
   gl->usedC[which] = -1;
   ShowWaitCursor(dlg);
   ModelInfo[which].CreaMappa(which+1, radius, step);
   VWSurface[which].ifVis = true;
   HideWaitCursor(dlg);
   gl->RunMCAll();
   gl->Redraw();
}
#endif

void delete_model(gpointer, gpointer data)
{
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     int Which = GPOINTER_TO_INT(data);
     ModelInfo[Which-1].freeModel();
     for(int i=Which; i<gl->nModels; i++)
         ModelInfo[i-1] = ModelInfo[i];
     ModelInfo[gl->nModels-1].created = 0;
     gl->nModels--;
     gl->DistAng_vet.clear();
     aggiornaProperties(-1);
     if(GetActiveModel() == Which)
        SetActiveModel(1);
     update_menu_deletemodel();
     jav_delete_model_(&Which);
     gl->RiNormalizza();
     gl->Redraw();
}

#ifdef USE_ACTIONS
void update_menu_deletemodel()
{
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

   gpointer item = get_object(GLWINDOW, "Delete Model");
   if(item == NULL)
      return;
   GtkUIManager *merge = (GtkUIManager *) get_object(GLWINDOW, "ui-manager");
   GtkActionGroup *ag = (GtkActionGroup *) get_object(GLWINDOW, "action_group");

   std::string new_string =
                     " <ui>"
                     "   <menubar name='MenuBar'>"
                     "     <menu action='Tools'>"
                     "     <placeholder name='Delete Model'";
   GtkAction **actions;
   if(gl->nModels <= 1)
      new_string.append("/>");
   else
   {
      new_string.append(">"
                        "       <menu action='Delete Model'>");
      actions = g_new0(GtkAction *, gl->nModels-1);
      for (int i=1; i < gl->nModels; i++)
      {
           //std::string a = g_strdup_printf("Delete Model_%.2d", i);
           std::string a = crea_nome("Delete Model_", i);
           std::string item_lab = g_path_get_basename(ModelInfo[i].modname);
           new_string.append("          <menuitem action='");
           new_string.append(a);
           new_string.append("'/>");
           actions[i-1] = gtk_action_new(g_strdup(a.c_str()),
                          g_strdup(item_lab.c_str()), NULL, NULL);
           g_signal_connect(G_OBJECT(actions[i-1]), "activate",
                      G_CALLBACK(delete_model), GINT_TO_POINTER(i+1));
      }
      new_string.append( "      </menu>"
                         "     </placeholder>");
   }
   new_string.append( "     </menu>"
                      "   </menubar>"
                      " </ui>");
   for(int i=1; i<=MAX_NUM_MODELS; i++)
   {
       //std::string a = g_strdup_printf("Delete Model_%.2d", i);
       std::string a = crea_nome("Delete Model_", i);
       GtkAction *act = gtk_action_group_get_action(ag, a.c_str());
       if(act != NULL)
          gtk_action_group_remove_action(ag, act);
   }
   guint actModels = (guint) GPOINTER_TO_INT(g_object_get_data(G_OBJECT(merge), "overlay_models"));
   if(actModels)
        gtk_ui_manager_remove_ui(merge, actModels);
   if(gl->nModels > 1)
   {
      for(int i=1; i<gl->nModels; i++)
          gtk_action_group_add_action(ag, actions[i-1]);
      GError *error = NULL;
      actModels = gtk_ui_manager_add_ui_from_string(merge, new_string.c_str(), -1, &error);
      if(!actModels)
      {
         g_message ("building menus failed: %s", error->message);
         g_error_free (error);
      }
      else
         g_object_set_data(G_OBJECT(merge), "overlay_models", GINT_TO_POINTER(actModels));
   }
   else
      g_object_set_data(G_OBJECT(merge), "overlay_models", GINT_TO_POINTER(0));
}
#else
void update_menu_deletemodel()
{
     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

     GtkWidget *item = get_widget(GLWINDOW, "Delete Model");
     if(item == NULL)
        return;
     if(gl->nModels <= 1)
     {
        GtkWidget *menuitem = gtk_menu_new();
        gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), menuitem);
        gtk_widget_show(menuitem);
        gtk_widget_set_sensitive(item, FALSE);
        return;
     }
     gtk_widget_set_sensitive(item, TRUE);
     GtkWidget *menuitem = gtk_menu_new();
     gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), menuitem);
     gtk_widget_show(menuitem);
     for (int i=1; i < gl->nModels; i++)
     {
          if(!ModelInfo[i].created)
             continue;
          std::string item_lab = 
              g_path_get_basename(ModelInfo[i].modname);
          item = gtk_menu_item_new_with_label(item_lab.c_str());
          GtkWidget *label = gtk_bin_get_child(GTK_BIN(item));
          if(label != NULL)
             set_widget_font(label, "sans 9");
          gtk_widget_show(item);
          gtk_menu_shell_append(GTK_MENU_SHELL(menuitem),item );
          g_signal_connect( G_OBJECT(item), "activate",
                        G_CALLBACK(delete_model), GINT_TO_POINTER(i+1));
     }
}
#endif
void PassaModello (atom_type *atml, f_bond_type *legm, 
                   int *nats, int *nats_au, int *nlegs, int *nlegs_au,
                   element_type *celem, int *nelem, 
                   int *which,
                   int *nmodels, int *ifPdb, char *name, bool *ifNewModel,
                   int ifResize=1,
                   int *het=NULL)

{
using namespace gtkext;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

  structure_info_type StructInfo;
  int status[50], plotStyle, colorMode;
  float fstatus[3];
  statusSav vec;
  *ifNewModel = true;

  int k = *which - 1;
  gl->nModels = *nmodels;

//  gl->DistAng_vet.clear();

  if(k == 0)
      gl->Normalized = 0;
//  sync_radios();

  if(ModelInfo[k].created)
  {
      *ifNewModel = false;
      status[0]  = (ModelInfo[k].ifVis)? 1 : 0;
      status[1]  = (ModelInfo[k].ifSymmetry)? 1 : 0;
      status[2]  = (ModelInfo[k].ifDrawH)? 1 : 0;
      status[3]  = ModelInfo[k].plotStyle;
      status[4]  = ModelInfo[k].colorMode;
      status[5]  = ModelInfo[k].ifLabels;
      status[6]  = ModelInfo[k].ifChangedSymmetry;
      status[7]  = ModelInfo[k].drawLigand;
      status[9]  = ModelInfo[k].ifPoly;
      status[10] = (ModelInfo[k].ifDrawW)? 1 : 0;
      status[11] = ModelInfo[k].specialLab;
      status[12] = ModelInfo[k].labelType;
      fstatus[0] = ModelInfo[k].klevel[0];
      fstatus[1] = ModelInfo[k].klevel[1];
      fstatus[2] = ModelInfo[k].klevel[2];
      status[16] = ModelInfo[k].FitOpt;
      for(int i=0; i<NUM_COLORS; i++)
          memcpy(vec.light_diffuse[i], ModelInfo[k].light_diffuse[i], 4*sizeof(float));
      memcpy(vec.labelcolor, ModelInfo[k].labelcolor, 4*sizeof(float));
      memcpy(vec.light_chain, ModelInfo[k].light_chain, 4*sizeof(float));
      memcpy(vec.LabelS, ModelInfo[k].LabelS, N_ELEMENTS*sizeof(int));

      char *oldname = g_strdup(ModelInfo[k].modname);
      ModelInfo[k].freeModel();
      ModelInfo[k] = Model (status, fstatus, vec); 
      int sz1 = (int) strlen(oldname) + 1;
      ModelInfo[k].modname = g_new0(char, sz1);
      CopiaStringa(ModelInfo[k].modname, sz1, oldname);
      ModelInfo[k].ifResize = (ifResize != 0);
      g_free(oldname);
  }
  else
  {
      ModelInfo[k] = Model ();
      colorMode = BY_SPECIES;
      if(*nats <= NATS_LIM)
      {
         plotStyle = STICK_AND_BALLS;
         gl->fog = false;
         SetClip(false, false);
         gl->ClipFactor = 1.f;
      }
      else
      {
         plotStyle = WIRES;
         gl->fog = true;
         SetClip(true, false);
         gl->ClipFactor = 0.5f;
      }
      if(defaultFog >= 0)
         gl->fog = (defaultFog > 0);
      if(defaultClip >= 0)
      {
         gl->ClipFactor = (defaultClip > 0)?0.5f:1.f;
         SetClip((defaultClip > 0), false);
      }
      if((defaultPlotStyle >= 0) && (defaultPlotStyle <PLOT_STYLES))
         plotStyle = defaultPlotStyle;
      if((defaultColor >= 0) && (defaultColor <COLOR_MODES))
         colorMode = defaultColor;
      ModelInfo[k].plotStyle = plotStyle;
      ModelInfo[k].colorMode = colorMode;
      if(defaultLabels >= 0)
         ModelInfo[k].ifLabels = (defaultLabels != 0);
      else
         ModelInfo[k].ifLabels = false;

      if(str_white(name))
      {
         ModelInfo[k].modname = g_new0(char, 80);
         getsname_(ModelInfo[k].modname, 80);
      }
      else
      {
         int sz = (int) strlen(name) + 1;
         ModelInfo[k].modname = g_new0(char, sz);
         CopiaStringa(ModelInfo[k].modname, sz, name);
      }
      if(str_white(ModelInfo[k].modname))
      {
         const char *tit = gtk_window_get_title(GTK_WINDOW(GLWINDOW));
         if(!str_white(tit))
         {
            char *tmp = g_path_get_basename(tit);
            int sz = (int) strlen(tmp) + 1;
            ModelInfo[k].modname = g_new0(char, sz);
            CopiaStringa(ModelInfo[k].modname, sz, tmp);
            g_free(tmp);
         }
      }
      if(str_white(ModelInfo[k].modname))
         ModelInfo[k].modname = g_strdup("Untitled");
      ModelInfo[k].ifResize = 1;
  }
//  ModelInfo[k].ifResize = (ifResize != 0);
  ModelInfo[k].nModello = k;

  ModelInfo[k].created = true;
  ModelInfo[k].isPDB = (*ifPdb != 0);

  int ifCalc = 0;
  int wm = k+1;
  getstructureinfo_(&StructInfo, &ifCalc, &wm);
  for(int j=0; j<6; j++)
      gl->Cell[j] = StructInfo.cell[j];
  for(int i1=0; i1<16; i1++)
      gl->sy.spg[i1] = StructInfo.spaceg[i1];
  gl->sy.spg[16] = '\0';
  gl->sy.icent = StructInfo.icent;
  ModelInfo[k].ifCentro = (StructInfo.icent == 1);
  //getspinfo_(&(ModelInfo[k].info));
  gl->CalcolaMatrici();
  calcolava();
  ModelInfo[k].numSpec = *nelem;   //StructInfo.nspec;
  int *countz = g_new0(int, N_ELEMENTS);
  ModelInfo[k].radMax = 0;
  for (int i=0; i< ModelInfo[k].numSpec; i++)
  {
       ModelInfo[k].Species[i] = celem[i].z;  //StructInfo.zspec[i];
       ModelInfo[k].Content[i] = (int) celem[i].nw; //StructInfo.vspec[i];
       ModelInfo[k].ptab[i] = celem[i].ptab;
       ModelInfo[k].radii[i][0] = celem[i].c_radius;
       ModelInfo[k].radii[i][1] = celem[i].w_radius;
       ModelInfo[k].radMax = MRmax(ModelInfo[k].radMax, celem[i].w_radius);
       //if((StructInfo.zspec[i] > 0) && (StructInfo.zspec[i] <= N_ELEMENTS))
       //    countz[StructInfo.zspec[i]-1]++;
       if((celem[i].z > 0) && (celem[i].z <= N_ELEMENTS))
           countz[celem[i].z-1]++;
       for(int kl=0; kl<LEN_SPEC; kl++)
           ModelInfo[k].LabSpec[i][kl] = celem[i].lab[kl];
  }
  ModelInfo[k].radMax *= 2.f;
  if(PreviewMode)
     ModelInfo[k].radMax /= 2;
  ModelInfo[k].numT = 0;
  int Nelem = 0;
  for (int i=0; i< N_ELEMENTS; i++)
  {
       if(countz[i] > 0)
          Nelem++;
  }
  for (int i=0; i< Nelem; i++)
      ModelInfo[k].numT += (i+1);
  ModelInfo[k].numT *= 3;
  g_free(countz);
  gl->AggiornaListaSpecie();
  ModelInfo[k].RF = StructInfo.r_factor;
  gl->sy.nsymop = StructInfo.nsymmstr;

  ModelInfo[k].nats_au = *nats_au;
  ModelInfo[k].nats= *nats;
  if(ModelInfo[k].nats <= 0)
  {
     updateModify(-1);
     gl->Redraw();
     if( ModelInfo[k].nats_au <= 0)      // 24032016
         return;
  }
  //else if( ModelInfo[k].nats_au <= 0)    // pezza 31072018
  //{
     //ModelInfo[k].nats = 0;
     //return;
  //}

  ModelInfo[k].atm = g_new0(jav_atom_type, ModelInfo[k].nats);
  ModelInfo[k].atm_au = g_new0(jav_atom_type, ModelInfo[k].nats_au);
  ModelInfo[k].iEqui = g_new0(int, ModelInfo[k].nats);
  ModelInfo[k].Secondary = g_new0(char, ModelInfo[k].nats);
  ModelInfo[k].nChains = 0;
  ModelInfo[k].Bmin = 1.e10;
  ModelInfo[k].Bmax = -1.e10;
  for(int j=0; j<3; j++)
      ModelInfo[k].baricentro[j] = 0;
  int *nzo = NULL;
  int ifnzo = presentnzo_();
  if(PreviewMode)
     ifnzo = 0;
  if (ifnzo > 0)
  {
      nzo = g_new0(int, ModelInfo[k].nats_au);
      getnzo_(nzo, &ModelInfo[k].nats_au);
  }

  if(ModelInfo[k].nats > 0)          // 24032016
     ModelInfo[k].FillAtoms(atml, StructInfo, false, nzo, het);

//NEW Get Asymmetric unit

   int whichModel = k+1;
   int natoms = ModelInfo[k].nats_au;
   atom_type *atml_au = g_new0(atom_type, natoms);
   jav_get_au_(atml_au, &natoms,&whichModel);
   ModelInfo[k].FillAtoms(atml_au, StructInfo, true, nzo, het);

  if(nzo)
  {
     g_free(nzo);
     nzo = NULL;
  }
  for(int j=0; j<3; j++)
      ModelInfo[k].baricentro[j] /= ModelInfo[k].nats;
  
//new 270613
  bool set_centre = true;
  if(!gl->Normalized)
  {
     if(gl->nMaps)
     {
        for(int j=0; j<gl->nMaps;j++)
        {
            if(IsMapVisible(j))
               set_centre = false;
        }
     }
  }
  if(set_centre)
//270613   if(!gl->nMaps && !gl->Normalized)
//end new
  {
      for(int j=0; j<3; j++)
          gl->xyzC.v[j] = ModelInfo[k].baricentro[j];
  }
  ModelInfo[k].FillLegs(nlegs, nlegs_au, legm);

  ModelInfo[k].PreparaEllissoidi(gl);
  ModelInfo[k].GetEquivs();

  if(ModelInfo[k].isPDB)
  {
     ModelInfo[k].PreparaTabelle();
     if(*ifNewModel && ModelInfo[k].IsProtein())
     {
         ModelInfo[k].plotStyle = CARTOONS;
         ModelInfo[k].colorMode = BY_STRUCT;
     }
  }
//  ModelInfo[k].CreaMappa(k+1);
}

void sync_radios()
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = GetActiveModel() - 1;
   sync_radio("Perspective Projection", !gl->ifOrtho);
   sync_radio("View Cell Edges", gl->ifCell);
   sync_radio("View Grid", gl->ifGrid);
   sync_radio("Show Toolbars", gl->ShowTb);
   sync_radio("Show Legend(s)", gl->ShowLegend);
   SetClip(gl->Clip);
   sync_radio("Grow Fragment", gl->ifGrow!=0);
   sync_radio("Hydrogen Bonds", gl->ifHBonds!=0);
   sync_radio("Short Contacts", gl->ifShortc!=0);
   sync_radio("Delete Hanging Contacts", gl->ifDelHang!=0);
   gpointer check = get_object(GLWINDOW, "Delete Hanging Contacts");
   obj_set_sensitive(check, (gl->ifHBonds || gl->ifShortc));
   sync_radio("Polyhedra", gl->poliedri());
   sync_radio("Center on map", gl->CenterOnMap);
   if(whichModel != -1)
   {
      sync_radio("Label All Atoms", ModelInfo[whichModel].ifLabels);
      switch(ModelInfo[whichModel].labelType)
      {
      case 0:
           sync_radio("Atom name", true);
           break;
      case 1:
           sync_radio("Atom species", true);
           break;
      case 2:
           sync_radio("Atom number", true);
           break;
      }
   }
}

void get_values_for_BondSetting(GtkWidget *dlg, _BondTable btable[],
                                _BondSetting *BSetting)
{
  GtkWidget *spin = get_widget(dlg, "tolmin");
  BSetting->tolmin = (float) spin_button_get_value(spin);
  GtkWidget *combo = get_widget(dlg, "signmin");
  int sign = combo_get_val(combo);
  if(sign == 1)
     BSetting->tolmin = -BSetting->tolmin;
  spin = get_widget(dlg, "tolmax");
  BSetting->tolmax = (float) spin_button_get_value(spin);
  combo = get_widget(dlg, "signmax");
  sign = combo_get_val(combo);
  if(sign == 1)
     BSetting->tolmax = -BSetting->tolmax;
  spin = get_widget(dlg, "angb");
  BSetting->angle = (float) spin_button_get_value(spin);
  GtkWidget *list = get_widget(dlg, "bond_table");
  GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
  GtkTreeIter iter;
  gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
  int i = 0;
  float distmin, distmax;
  while (valid)
  {
       gtk_tree_model_get (model, &iter, 3, &distmin, 4, &distmax, -1);
       btable[i].distmin = distmin;
       btable[i].distmax = distmax;
       i++;
       valid = gtk_tree_model_iter_next (model, &iter);
  }
}

void set_values_for_BondSetting(GtkWidget *dlg, _BondTable btable[],
                                _BondSetting *BSetting)
{
  GtkWidget *spin = get_widget(dlg, "tolmin");
  spin_button_set_value(spin, MRabs(BSetting->tolmin));
  GtkWidget *combo = get_widget(dlg, "signmin");
  int sign = 1;
  if(BSetting->tolmin > 0)
     sign = 2;
  combo_set_val(combo, sign);
  spin = get_widget(dlg, "tolmax");
  spin_button_set_value(spin, MRabs(BSetting->tolmax));
  combo = get_widget(dlg, "signmax");
  sign = 2;
  if(BSetting->tolmax < 0)
     sign = 1;
  combo_set_val(combo, sign);
  spin = get_widget(dlg, "angb");
  spin_button_set_value(spin, BSetting->angle);
  GtkWidget *list = get_widget(dlg, "bond_table");
  GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
  GtkTreeIter iter;
  gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
  int i = 0;
  float distmin, distmax;
  while (valid)
  {
       gtk_tree_model_get (model, &iter, 3, &distmin, 4, &distmax, -1);
       gtk_list_store_set (GTK_LIST_STORE (model), &iter, 3, btable[i].distmin,
                           4, btable[i].distmax, -1);
       i++;
       valid = gtk_tree_model_iter_next (model, &iter);
  }
}

void apply_bondsetting(GtkWidget *button, gpointer )
{
   GtkWidget *father = gtk_widget_get_toplevel(button);
   int numT = get_int(father, "numT");
   int icode = 3;
   _BondTable *btable = CurBondTable;
   _BondSetting BSetting;
   get_values_for_BondSetting(father, btable, &BSetting);
   int wm = GetActiveModel();
   jav_edit_bonds_(&icode, btable, &BSetting, &numT,&wm);
}

void ok_bondsetting(GtkWidget *button, gpointer data)
{
   GtkWidget *father = gtk_widget_get_toplevel(button);
   int numT = get_int(father, "numT");
   int icode = 1;
   _BondTable *btable = CurBondTable;
   _BondSetting BSetting;
   get_values_for_BondSetting(father, btable, &BSetting);
   chiudi_dlg(button, data);
   int wm = GetActiveModel();
   jav_edit_bonds_(&icode, btable, &BSetting, &numT,&wm);
}

void close_bondsetting(GtkWidget *button, gpointer data)
{
   GtkWidget *father = gtk_widget_get_toplevel(button);
   int numT = get_int(father, "numT");
   int icode = 2;
   _BondTable *btable = CurBondTable;
   _BondSetting BSetting;
   get_values_for_BondSetting(father, btable, &BSetting);
   chiudi_dlg(button, data);
   int wm = GetActiveModel();
   jav_edit_bonds_(&icode, btable, &BSetting, &numT,&wm);
}

void reset_bondsetting(GtkWidget *button, gpointer data)
{
   GtkWidget *father = gtk_widget_get_toplevel(button);
   int numT = get_int(father, "numT");
   int icode = 4;
   _BondTable *btable = CurBondTable;
   _BondSetting BSetting;
   get_values_for_BondSetting(father, btable, &BSetting);
   int wm = GetActiveModel();
   jav_edit_bonds_(&icode, btable, &BSetting, &numT,&wm);
   set_values_for_BondSetting(father, btable, &BSetting);
}

static void on_edit_distances (GtkCellRendererText *cell, const gchar *path_string,
                          const gchar *new_text, gpointer data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
  GtkTreeIter iter;

  gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (cell), "column"));
  gint gt = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (cell), "gtype"));

  gtk_tree_model_get_iter (model, &iter, path);
  if(gt == G_TYPE_FLOAT)
  {
     float val = (float) atof(new_text);
     if(val > 0)
        gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
         val, -1);
  }
}

GtkWidget *create_BondSetting(int numt, _BondTable btable[],
                              _BondSetting BSetting, gpointer data)

{
  const char *plusmin[] = {"minus", "plus"};
  int defmin = 1, defmax = 2;
  if(BSetting.tolmin > 0)
     defmin = 2;
  if(BSetting.tolmax < 0)
     defmax = 1;
  GtkWidget *window = (GtkWidget *) data;
  GtkWidget *dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "Bond Settings");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
  int lar, alt;
  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);

  GtkWidget *frame = NEW_FRAME("Bond distance range");
  gtk_box_pack_start(GTK_BOX(vbox1), frame, FALSE, FALSE, 4);
  GtkWidget *table = table_new(2, 3, FALSE);
  table_set_row_spacings(table, 10);
  table_set_col_spacings(table, 4);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), table);
  GtkWidget *label = gtk_label_new("distance >= MinDist ");
  set_alignment(label, 0, 0.5f);
  table_attach_all(table, label, 0, 1, 0, 1);
  GtkWidget *combo = create_combo(NULL, plusmin, 2, defmin, NULL);
  set_width_chars(GTK_ENTRY(get_widget(combo, "entry")), 6);
  table_attach(table, get_widget(combo, "parent"), 1, 2, 0, 1);
  g_object_set_data(G_OBJECT(dialog1), "signmin", combo);
  GtkWidget *spin  = SPIN_NEW(0, 1.5, MRabs(BSetting.tolmin), 0.01, 2);
  g_object_set_data(G_OBJECT(dialog1), "tolmin", spin);
  set_width_chars(GTK_ENTRY(spin), 4);
  table_attach(table, spin, 2, 3, 0, 1);
  label = gtk_label_new("distance <= MaxDist ");
  set_alignment(label, 0, 0.5f);
  table_attach_all(table, label, 0, 1, 1, 2);
  combo = create_combo(NULL, plusmin, 2, defmax, NULL);
  table_attach(table, get_widget(combo, "parent"), 1, 2, 1, 2);
  set_width_chars(GTK_ENTRY(get_widget(combo, "entry")), 6);
  g_object_set_data(G_OBJECT(dialog1), "signmax", combo);
  spin  = SPIN_NEW(0, 1.5, MRabs(BSetting.tolmax), 0.01, 2);
  g_object_set_data(G_OBJECT(dialog1), "tolmax", spin);
  set_width_chars(GTK_ENTRY(spin), 4);
  table_attach(table, spin, 2, 3, 1, 2);

  table = table_new(1, 3, FALSE);
  table_set_row_spacings(table, 10);
  table_set_col_spacings(table, 4);
  gtk_container_set_border_width (GTK_CONTAINER (table), 4);
  gtk_box_pack_start(GTK_BOX(vbox1), table, FALSE, FALSE, 4);
  label = LABEL_NEW("Bond Angles >= ", NULL);
  set_alignment(label, 0, 0.5f);
  table_attach_all(table, label, 0, 1, 1, 2);
  spin  = SPIN_NEW(0, 180, BSetting.angle, 1, 1);
  set_width_chars(GTK_ENTRY(spin), 4);
  g_object_set_data(G_OBJECT(dialog1), "angb", spin);
  table_attach(table, spin, 1, 2, 1, 2);
  label = LABEL_NEW(" degrees", NULL);
  set_alignment(label, 0, 0.5f);
  table_attach_all(table, label, 2, 3, 1, 2);

  const char *titles[] = { "No.", "Atom 1", "Atom 2", "MinDist",
                           "MaxDist", "Type"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING,
                    G_TYPE_FLOAT, G_TYPE_FLOAT, G_TYPE_INT};
  int  sizes[] = { 0, 0, 0, 0 , 0, 0};
  int  precs[] = { 0, 0, 0, 3 , 3, 0};
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  bool editable[] = {false, false, false, true, true, false};
  GtkWidget *list =
  new_selection(dialog1, vbox1, "bond_table", ncol, titles, sizes, types, precs,
                editable, G_CALLBACK(on_edit_distances));
  widget_modify_font(list, fontlist);
  gtk_widget_set_size_request(get_widget(list, "scrollwin"), -1,
     (int)MRmin(1.7f*(numt)*alt,15*alt));
  GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
  GtkListStore *list_store = GTK_LIST_STORE(model);
  gtk_list_store_clear(list_store);
  GtkTreeIter iter;

  for (int r=0; r<numt; r++)
  {
       int n = btable[r].z1 - 1;
       const char *labstr1 = get_nth_element(n);
       n = btable[r].z2 - 1;
       const char *labstr2 = get_nth_element(n);
       gtk_list_store_append (list_store, &iter);
       gtk_list_store_set (list_store, &iter, 0, r+1, 1, labstr1,
              2, labstr2, 3, btable[r].distmin, 4, btable[r].distmax,
              5, btable[r].typeb, -1);
  }

  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  st->name = BondSettingWindow;

  GtkWidget *button = OK_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_OK);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(ok_bondsetting), (gpointer) st);
  button = APPLY_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_APPLY);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(apply_bondsetting), data);
  button = DEFAULTS_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_ACCEPT);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(reset_bondsetting), (gpointer) st);
  g_signal_connect_swapped(G_OBJECT(dialog1), "delete-event", G_CALLBACK(gtk_button_clicked), button);
  button = CANCEL_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_CANCEL);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(close_bondsetting), (gpointer) st);
  g_signal_connect_swapped(G_OBJECT(dialog1), "delete-event", G_CALLBACK(gtk_button_clicked), button);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);
  gtk_widget_show_all(dialog1);
  return dialog1;
}

void on_bondsetting(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GtkWidget *dlg;
#ifdef JAV
    int wm = GetActiveModel();
    if(wm <= 0)
       return;
#else
    int wm = 1;
#endif
   if(g_object_get_data(G_OBJECT(window), BondSettingWindow))
   {
      dlg = get_widget(window, BondSettingWindow);
      gdk_window_raise(gtk_widget_get_window(dlg));
      return;
   }
   int maxnumT = ModelInfo[wm-1].numT;
   if(!maxnumT)
      return;
   _BondTable *btable = g_new0(_BondTable, maxnumT);
   _BondSetting BSetting;
   int icode = 0;
   int numT = 0;
   jav_edit_bonds_(&icode, btable, &BSetting, &numT,&wm);
   if(CurBondTable != NULL)
      g_free(CurBondTable);
   CurBondTable = g_new0(_BondTable, numT);
   memcpy(CurBondTable, btable, numT*sizeof(_BondTable));
   g_free(btable);
   dlg = create_BondSetting(numT, CurBondTable, BSetting, data);
   g_object_set_data(G_OBJECT(window), BondSettingWindow, dlg);
   g_object_set_data(G_OBJECT(dlg), "numT", GINT_TO_POINTER(numT));
}

void on_newcentre(gpointer, gpointer data)
{
using namespace gtkext;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   set_motion_type(SELECT_CENTRE, 1);
   gl->PrintMess("Click on one atom to define the new position.");
}

void on_CenterOnMap(gpointer item, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gl->CenterOnMap = (obj_get_active(item) != 0);
   gl->RiNormalizza();
   gl->Redraw();
}

void SetLightSystem(float colore[], float alpha, int blend)
{
     float color1[4];
     glEnable (GL_LIGHTING);
     glEnable (GL_NORMALIZE);
     glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
     glEnable(GL_COLOR_MATERIAL);
     for(int i=0; i<3; i++)
         color1[i] = colore[i];
     color1[3] = alpha;
     glColor4fv(color1);
     glLineWidth(1.) ;
     glShadeModel(GL_SMOOTH);
     glPolygonMode( GL_FRONT_AND_BACK, GL_FILL ) ;
     glEnable (GL_BLEND);
     switch (blend)
     {
     default:
     case 0:
          glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
          break;
     case 1:
          glBlendFunc (GL_SRC_ALPHA, GL_SRC_COLOR);
          break;
     }
}

void on_clickselect(gpointer, gpointer data)
{
using namespace gtkext;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   bool visibleModel = false;
   for(int i=0; i<gl->nModels; i++)
         if(ModelInfo[i].ifVis)
            visibleModel = true;
   if(!visibleModel)
   {
        dlg_errmsg(GTK_WINDOW(window), "Sorry. No visible atoms.");
        return;
   }
   set_motion_type(SELECT_CENTRE, 1);
   gl->PrintMess("Click on atom to define the center of the plot.");
}

void SelezionaNonGhost(int whichModel)
{
    ModelInfo[whichModel].atoms_sel.clear();
    for(int j=0; j<ModelInfo[whichModel].nats; j++)
    {
        int spec = ModelInfo[whichModel].atm[j].Z;
        if(spec != OTHERS)
           ModelInfo[whichModel].atoms_sel.push_back(j+1);
    }
}

#define CACHE_SIZE      240
void disegnaSfera (double radius, int slices, bool textureCoords)
{
    GLint i,j;
    GLfloat sinCache1a[CACHE_SIZE];
    GLfloat cosCache1a[CACHE_SIZE];
    GLfloat sinCache2a[CACHE_SIZE];
    GLfloat cosCache2a[CACHE_SIZE];
    GLfloat sinCache1b[CACHE_SIZE];
    GLfloat cosCache1b[CACHE_SIZE];
    GLfloat sinCache2b[CACHE_SIZE];
    GLfloat cosCache2b[CACHE_SIZE];
    GLfloat angle;
    GLfloat zLow, zHigh;
    GLfloat sintemp1 = 0.0, sintemp2 = 0.0, sintemp3 = 0.0, sintemp4 = 0.0;
    GLfloat costemp3 = 0.0, costemp4 = 0.0;
    GLint start, finish;
    float PI= (float) M_PI;

    if (slices >= CACHE_SIZE) slices = CACHE_SIZE-1;
    if (slices < 2 || radius < 0.0) {
         return;
    }

    /* Cache is the vertex locations cache */
    /* Cache2 is the various normals at the vertices themselves */


    for (i = 0; i < slices; i++) {
         angle = 2 * PI * i / slices;
         sinCache1a[i] = sinf(angle);
         cosCache1a[i] = cosf(angle);
         sinCache2a[i] = sinCache1a[i];
         cosCache2a[i] = cosCache1a[i];
    }

    for (j = 0; j <= slices; j++) {
         angle = PI * j / slices;
         sinCache2b[j] = sinf(angle);
         cosCache2b[j] = cosf(angle);
         sinCache1b[j] = (float)radius * sinf(angle);
         cosCache1b[j] = (float)radius * cosf(angle);
    }
    sinCache1b[0] = 0;
    sinCache1b[slices] = 0;

    sinCache1a[slices] = sinCache1a[0];
    cosCache1a[slices] = cosCache1a[0];
    sinCache2a[slices] = sinCache2a[0];
    cosCache2a[slices] = cosCache2a[0];

// Do ends of sphere as TRIANGLE_FAN's (if not texturing)
    if (!(textureCoords))
    {
        start = 1;
        finish = slices - 1;

// Low end first (j == 0 iteration)
        sintemp2 = sinCache1b[1];
        zHigh = cosCache1b[1];
        sintemp3 = sinCache2b[1];
        costemp3 = cosCache2b[1];
        glNormal3f(sinCache2a[0] * sinCache2b[0],
        cosCache2a[0] * sinCache2b[0],
        cosCache2b[0]);
        glBegin(GL_TRIANGLE_FAN);
        glVertex3d(0.0, 0.0, radius);
        for (i = slices; i >= 0; i--)
        {
             glNormal3f(sinCache2a[i] * sintemp3,
             cosCache2a[i] * sintemp3,
             costemp3);
             glVertex3f(sintemp2 * sinCache1a[i],
                 sintemp2 * cosCache1a[i], zHigh);
        }
        glEnd();

// High end next (j == slices-1 iteration) 
        sintemp2 = sinCache1b[slices-1];
        zHigh = cosCache1b[slices-1];
        sintemp3 = sinCache2b[slices-1];
        costemp3 = cosCache2b[slices-1];
        glNormal3f(sinCache2a[slices] * sinCache2b[slices],
           cosCache2a[slices] * sinCache2b[slices], cosCache2b[slices]);
        glBegin(GL_TRIANGLE_FAN);
        glVertex3d(0.0, 0.0, -radius);
        for (i = 0; i <= slices; i++)
        {
             glNormal3f(sinCache2a[i] * sintemp3,
                cosCache2a[i] * sintemp3, costemp3);
             glVertex3f(sintemp2 * sinCache1a[i],
                sintemp2 * cosCache1a[i], zHigh);
        }
        glEnd();
    }
    else
    {
        start = 0;
        finish = slices;
    }
    for (j = start; j < finish; j++)
    {
         zLow = cosCache1b[j];
         zHigh = cosCache1b[j+1];
         sintemp1 = sinCache1b[j];
         sintemp2 = sinCache1b[j+1];
         sintemp3 = sinCache2b[j+1];
         costemp3 = cosCache2b[j+1];
         sintemp4 = sinCache2b[j];
         costemp4 = cosCache2b[j];

         glBegin(GL_QUAD_STRIP);
         for (i = 0; i <= slices; i++)
         {
              glNormal3f(sinCache2a[i] * sintemp3,
                cosCache2a[i] * sintemp3, costemp3);
              if (textureCoords)
                  glTexCoord2f(1-(float)i/slices, 1-(float)(j+1)/slices);
              glVertex3f(sintemp2 * sinCache1a[i],
                sintemp2 * cosCache1a[i], zHigh);
              glNormal3f(sinCache2a[i] * sintemp4,
                cosCache2a[i] * sintemp4, costemp4);
              if (textureCoords)
                  glTexCoord2f(1-(float)i/slices, 1-(float)j/ slices);
              glVertex3f(sintemp1 * sinCache1a[i],
                sintemp1 * cosCache1a[i], zLow);
         }
         glEnd();
    }
}

void disegnaCilindro(double radius, double h, int slices)
{
    int  DEF_D=5;
    if(slices > 180)
       DEF_D = MRmax(1, (int)(900.f/(float)slices));

    glBegin(GL_QUAD_STRIP);
    for (int j=0;j<=360;j+=DEF_D)
    {
      double c1 = Cos(j);
      double s1 = Sin(j);
      glNormal3d(radius*c1,radius*s1,h);
      glVertex3d(radius*c1,radius*s1,h);
      glNormal3d(radius*c1,radius*s1,0);
      glVertex3d(radius*c1,radius*s1,0);
    }
    glEnd();
}

void disegnaCono(double raggio, double h, int subdiv)
{
    int  DEF_D=5;
    if(subdiv > 180)
       DEF_D = MRmax(1, (int)(900.f/(float)subdiv));
    int nAngs = 360/DEF_D + 1;
    double *cs = g_new0(double, nAngs);
    double *ss = g_new0(double, nAngs);
    int i=0;
    for (int k=0;k<=360;k+=DEF_D)
    {
         cs[i] = Cos(k);
         ss[i] = Sin(k);
         i++;
    }
   
    // sides 
    i = 0;
    glBegin(GL_TRIANGLES);
    for (int k=0;k<360;k+=DEF_D)
    {
      glNormal3d(0,0,h);
      glVertex3d(0,0,h);
      glNormal3d(raggio*cs[i],raggio*ss[i],0);
      glVertex3d(raggio*cs[i],raggio*ss[i],0);
      glNormal3d(raggio*cs[i+1],raggio*ss[i+1],0);
      glVertex3d(raggio*cs[i+1],raggio*ss[i+1],0);
      i++;
    }
    glEnd();
 
    // bottom circle  (rotate back)
    glRotated(90,1,0,0);
    i = 0;
    glBegin(GL_TRIANGLES);
    for (int k=0;k<360;k+=DEF_D)
    {
      glVertex3d(0,0,0);
      glVertex3d(raggio*cs[i],0,raggio*ss[i]);
      glVertex3d(raggio*cs[i+1],0,raggio*ss[i+1]);
      i++;
    }
    glEnd();
}

bool FromWinToCoord(GLdouble winx, GLdouble winy, GLdouble winz,
                const GLdouble modelMatrix[16],
                const GLdouble projMatrix[16],
                const GLint viewport[4],
                GLdouble *objx, GLdouble *objy, GLdouble *objz)
{
    bool result;
    vet4 in = MRVector4Make(winx, winy, winz, 1.0);
    mat4x4 modelM = MRMatrixMakeFromArray(modelMatrix);
    mat4x4 projM = MRMatrixMakeFromArray(projMatrix);
    mat4x4 finalM = MRMatrixInvert(MRMatrixMultiply(modelM, projM), &result);
    if(!result)
    {
       g_print("not inverted\n");
       return false;
    }

    // Map x and y from window coordinates
    vet4 out = MRVector4MapFromViewport(in, viewport);

    // Map to range -1 to 1
    in = MRVector4AddScalar(MRVector4MultiplyScalar(out, 2), -1);

    out = MRMatrixMultiplyVector(finalM, in);
    if (MRabs(out.v[3]) < 1e-10)
        return false;
    in = MRVector4DivideScalar(out, out.v[3]);
    *objx = in.v[0];
    *objy = in.v[1];
    *objz = in.v[2];
    return true;
}
bool FromCoordToWin(GLdouble objx, GLdouble objy, GLdouble objz,
              const GLdouble modelMatrix[16],
              const GLdouble projMatrix[16],
              const GLint viewport[4],
              GLdouble *winx, GLdouble *winy, GLdouble *winz)
{
    vet4 in = MRVector4Make(objx, objy, objz, 1.0);
    mat4x4 modelM = MRMatrixMakeFromArray(modelMatrix);
    mat4x4 projM = MRMatrixMakeFromArray(projMatrix);
    vet4 out = MRMatrixMultiplyVector(modelM, in);
    in = MRMatrixMultiplyVector(projM, out);

    if (MRabs(in.v[3]) < 1e-10)
        return false;
    out = MRVector4DivideScalar(in, in.v[3]);
    // Map x, y and z to range 0-1
    in = MRVector4AddScalar(MRVector4MultiplyScalar(out, 0.5), 0.5);

    // Map x,y to viewport
    out = MRVector4MapToViewport(in, viewport);

    *winx=out.v[0];
    *winy=out.v[1];
    *winz=out.v[2];
    return true;
}

vet3 DrawDistLines(int n, vet3 points[])
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   glColor4fv(gl->DistColor);
   glBegin(GL_LINE_STRIP);
   for(int k=0; k<n; k++)
       glVertex3dv(points[k].v);
   glEnd();
   return MRVectorMedium(points[0], points[1]);
}

vet3 DrawDistDihedral(int n, vet3 p[])
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   glPolygonMode( GL_FRONT_AND_BACK, GL_LINE ) ;
   glColor4fv(gl->DistColor);

   glBegin(GL_POLYGON);
   vet3 P0 = MRVectorMedium(p[0], p[1]);
   glVertex3dv(P0.v);
   glVertex3dv(p[1].v);
   vet3 P = MRVectorMedium(p[1], p[2]);
   glVertex3dv(P.v);
   vet3 v1 = MRVectorSub(P, p[1]);
   vet3 P1 = MRVectorAdd(P0, v1);
   glVertex3dv(P1.v);
   glEnd();

   glBegin(GL_POLYGON);
   P0 = MRVectorMedium(p[1], p[2]);
   glVertex3dv(P0.v);
   glVertex3dv(p[2].v);
   P = MRVectorMedium(p[2], p[3]);
   glVertex3dv(P.v);
   vet3 v2 = MRVectorSub(P, p[2]);
   P = MRVectorAdd(P0, v2);
   glVertex3dv(P.v);
   glEnd();

   return MRVectorMedium(P1, P);
}

vet3 DrawDistAngles(int n, vet3 p[], double ang)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   glPolygonMode( GL_FRONT_AND_BACK, GL_LINE ) ;
// Angles
   double rad = MRVectorDistance(p[0], p[1]);
   for(int k=1; k<n-1; k++)
   {
       double d =  MRVectorDistance(p[k], p[k+1]);
       if(d < rad)
          rad = d;
   }
   rad *= 0.5f;
   vet3 u = MRVectorSub(p[0], p[1]);
   vet3 v = MRVectorSub(p[2], p[1]);
   vet3 vnorm1 = MRVectorCrossProduct(u, v);
   vet3 w = MRVectorCrossProduct(vnorm1, u);
   u = MRVectorNormalize(u);
   w = MRVectorNormalize(w);
   glBegin(GL_LINE_STRIP);
   glColor4fv(gl->DistColor);
   vet3 points;
   for(int deg=1; deg <=(int) ang; deg++)
   {
       double coseno =  cos(DEGTORAD(deg));
       double seno   =  sin(DEGTORAD(deg));
       vet3 tmp = MRVectorAdd(
                     MRVectorMultiplyScalar(u, coseno),
                     MRVectorMultiplyScalar(w, seno));
       tmp = MRVectorMultiplyScalar(tmp, rad);
       points = MRVectorAdd(p[1], tmp);
       glVertex3dv(points.v);
   }
   glEnd();
   int degc = (int)(0.5f * ang);
   double coseno =  cos(DEGTORAD(degc));
   double seno   =  sin(DEGTORAD(degc));
   vet3 tmp = MRVectorAdd(
                     MRVectorMultiplyScalar(u, coseno),
                     MRVectorMultiplyScalar(w, seno));
   tmp = MRVectorMultiplyScalar(tmp, rad);
   return MRVectorAdd(p[1], tmp);
}

void change_residue(GtkWidget *button, gpointer data)
{
     int displacement = GPOINTER_TO_INT(data);
     GtkWidget *dlg = gtk_widget_get_toplevel(button);
     GtkWidget *store = get_widget(dlg, "Chains");
     GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(store));
     GList *rowsel = NULL;
     rowsel = get_selections(store);
     if(rowsel)
     {
        GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, 0);
        if(displacement)
           gtk_tree_path_next (path);
        else
           gtk_tree_path_prev (path);
        gtk_tree_view_scroll_to_cell (GTK_TREE_VIEW(store), path, NULL, FALSE,
           0, 0);
        gtk_tree_selection_select_path(selection, path);
        char *linea = gtk_tree_path_to_string(path);
        int nodi[3];
        get_int_tokens(linea, ":", 2, nodi);
        int whichModel = get_int(dlg, "whichModel") - 1;
        if(whichModel >= 0)
        {
           if(ModelInfo[whichModel].Chains[nodi[0]].nResidues > (nodi[1]+1))
           {
              RESIDUE r0 = GetResiduo(whichModel, nodi[0], nodi[1]);
              int Calpha = 0;
              int k0 = r0.atoms[0];
              int kk = ModelInfo[whichModel].FindAtom("CA", r0);
              if(kk != -1)
                 Calpha = kk - k0;
              store = get_widget(dlg, "atoms_PDB");
              select_row(GTK_WIDGET(store), Calpha);
              gtk_button_clicked(GTK_BUTTON(get_widget(dlg, "gobutt")));
           }
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
     }
}

void gotoatom(GtkWidget *button, gpointer data)
{
using namespace gtkext;
     GtkWidget *window = (GtkWidget *) data;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     GtkWidget *dlg = gtk_widget_get_toplevel(button);
     int whichModel = get_int(dlg, "whichModel") - 1;
     int whichAtom = get_int(dlg, "whichAtom");
     if(whichAtom < 0)
     {
        dlg_errmsg(GTK_WINDOW(window), "Sorry. No atom selected");
        return;
     }
     int katom = whichAtom;
     if( ModelInfo[whichModel].isPDB)
     {
          int whichChain = get_int(dlg, "whichChain");
          int whichResidue = get_int(dlg, "whichResidue");
          RESIDUE rr = GetResiduo(whichModel, whichChain, whichResidue);
          katom = rr.atoms[whichAtom];
      }

     float posi[3];
     for (int i=0; i<3; i++)
          posi[i] = ModelInfo[whichModel].atm[katom].xyzc[i];
     memcpy(gl->CentreColor, ModelInfo[whichModel].labelcolor, 3*sizeof(float));
     move_center(posi, whichModel, katom, false);  //true);
}

static void selected_model_goto(GtkWidget *combo, gpointer )
{
    GtkWidget *dlg = gtk_widget_get_toplevel(combo);
    int whichModel = combo_get_val(combo);
    if(whichModel > 0)
    {
       g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(whichModel));
       ModelInfo[whichModel-1].FillLists(dlg);
    }
}

static void selected_atom_goto(GtkTreeSelection  *sele, gpointer data)
{
     int row;
     GtkWidget *dlg = (GtkWidget *)data;

     row = row_selected(sele);
     if(row != -1)
        g_object_set_data(G_OBJECT(dlg), "whichAtom", GINT_TO_POINTER(row));
}

GtkWidget *create_gotoatom (gpointer data, GList *listModels, int ifGoto)
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

  GtkWidget *window = (GtkWidget *) data;
  GtkWidget *dialog1;
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *frame;
  GtkWidget *combo=NULL;

  dialog1 = gtk_dialog_new ();
  if(ifGoto)
     gtk_window_set_title (GTK_WINDOW (dialog1), "Go to atom");
  else
     gtk_window_set_title (GTK_WINDOW (dialog1), "Atoms List");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 8);
//  gtk_widget_set_size_request(dialog1, -1, 300);
  GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog1));
  gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog1), TRUE);
  gtk_window_set_transient_for(GTK_WINDOW(dialog1), GTK_WINDOW(GLWINDOW));
 
  label = LABEL_BOLD("Select an atom for Centering", "Red", 1.1f);
  if(ifGoto)
     gtk_box_pack_start(GTK_BOX(vbox1), label, FALSE, FALSE, 10);

  if(gl->nModels > 1)
  {
     frame = FRAME_BOLD("Select model", "blue", 1.1f);
     gtk_box_pack_start(GTK_BOX(vbox1), frame, FALSE, FALSE, 10);
     combo = create_combo (NULL, NULL, 0, 0, NULL, G_CALLBACK(selected_model_goto));
     gtk_editable_set_editable(GTK_EDITABLE(get_widget(combo, "entry")), FALSE);
     block_handler(combo);
     set_popdown_strings(combo, listModels);
     unblock_handler(combo);
     gtk_container_add(GTK_CONTAINER(frame), get_widget(combo, "parent"));
     gtk_container_set_border_width(GTK_CONTAINER(get_widget(combo, "parent")), 8);
  }
  else
     g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(1));

// PDB files

  frame = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_NONE);
  g_object_set_data(G_OBJECT(dialog1), "frame_PDB", frame);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, TRUE, TRUE, 4);

  GtkWidget *vbox2 = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame), vbox2);
  if(ifGoto)
  {
      GtkWidget *hbox = hbutton_box_new();
      gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);
      gtk_box_pack_start (GTK_BOX (vbox2), hbox, FALSE, FALSE, 4);
      button = myimage_button ("_Previous Residue", "previousgr.png");
      gtk_container_add(GTK_CONTAINER(hbox), button);
      (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(change_residue), GINT_TO_POINTER(0));
      button = myimage_button ("  _Next Residue", "nextgr.png");
      gtk_container_add(GTK_CONTAINER(hbox), button);
      (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(change_residue), GINT_TO_POINTER(1));
  }

  GtkWidget *hbox1 = hpaned_new();
  gtk_box_pack_start (GTK_BOX (vbox2), hbox1, TRUE, TRUE, 4);

  frame = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
  gtk_paned_pack1((GtkPaned *)hbox1, frame, TRUE, FALSE);
  create_tree_store (dialog1, frame, "Chains", G_CALLBACK(selected_residue), dialog1);

  frame = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
  gtk_paned_pack2((GtkPaned *)hbox1, frame, TRUE, FALSE);
  GtkWidget *list = createSelection(dialog1, frame, 
    "Atoms    (    x       y      z   )    occ.    B ",
                      "atoms_PDB", 0, "blue");
  set_widget_fontN(list);
  gtk_widget_set_size_request(get_widget(list, "scrollwin"), -1, 300);
  GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), 0);
  label = gtk_tree_view_column_get_widget(column);
  if(label)
     set_widget_fontN(label);
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  (void) g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_atom_goto), dialog1);

// CIF, SHELX

  list = createSelection(dialog1, vbox1, 
    "Atoms            (    x       y      z   )    occ.    B ",
                "atoms_o", 0, "blue");
  g_object_set_data(G_OBJECT(dialog1), "frame_noPDB", get_widget(list, "frame"));
  set_widget_fontN(list);
  column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), 0);
  label = gtk_tree_view_column_get_widget(column);
  if(label)
     set_widget_fontN(label);
  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  (void) g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_atom_goto), dialog1);

  if(ifGoto)
  {
     button = myimage_button("", "go.png");
     gtk_dialog_add_action_widget(GTK_DIALOG (dialog1), button, 1);
     g_object_set_data(G_OBJECT(dialog1), "gobutt", button);
     (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(gotoatom), data);
  }
  button = myimage_button("  _Close", "cancel.png");
  gtk_dialog_add_action_widget(GTK_DIALOG (dialog1), button, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);

  chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
  st->window = window;
  if(ifGoto)
     st->name = "gotoatom";
  else
     st->name = "listatoms";

  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(chiudi_dlg), (gpointer) st);

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show_all(dialog1);
//  g_object_set_data(G_OBJECT(dialog1), "whichModel", GINT_TO_POINTER(1));
//  ModelInfo[0].FillLists(dialog1);
  if(combo && (gl->nModels > 1))
     combo_set_val(combo, 1);

  g_object_set_data(G_OBJECT(dialog1), "whichAtom", GINT_TO_POINTER(-1));
  return dialog1;
}

void GoToAtom(gpointer, gpointer data)
{
using namespace gtkext;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   GtkWidget *dlg;
   GList *listModels = NULL;

   if(!gl->nModels)
   {
      dlg_errmsg(GTK_WINDOW(window), "Sorry. No models loaded.");
      return;
   }
   for(int i=0; i<gl->nModels; i++)
       listModels = g_list_append(listModels,
             g_path_get_basename(ModelInfo[i].modname));

   if(g_object_get_data(G_OBJECT(window), "gotoatom"))
   {
      dlg = get_widget(window, "gotoatom");
      gdk_window_raise(gtk_widget_get_window(dlg));
   }
   else
   {
      dlg = create_gotoatom(data, listModels, 1);
      g_object_set_data(G_OBJECT(window), "gotoatom", dlg);
      g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(1));
   }
   int whichModel = get_int(dlg, "whichModel") - 1;
   if(whichModel < 0)
      return;
    ModelInfo[whichModel].FillLists(dlg);
}

void on_add_atom(gpointer, gpointer data)
{
    int whichZ = GPOINTER_TO_INT(data);
    int whichModel = GetActiveModel() - 1;
    if(whichModel == -1)
        return;
   if(!ModelInfo[whichModel].created)
        return;
    int whichSpec;
    if(whichZ < OTHERS)
    {
       int i;
       for (i=0; i< ModelInfo[whichModel].numSpec; i++)
       {
            if(ModelInfo[whichModel].Species[i] == whichZ)
               break;
       }
       if( i == ModelInfo[whichModel].numSpec)
           return;
       whichSpec = i+1;
    }
    else
    {
       int result = select_from_table(GLWINDOW);
       if(result < 0)
          return;
       whichSpec = -(result+1);
    }

    int nptra = (int) ModelInfo[whichModel].atoms_sel.size();
    int *kptra = g_new0(int, nptra);
    for(int i=0; i<nptra; i++)
        kptra[i] = ModelInfo[whichModel].atoms_sel[i];
    int nptrb = default_bond_mult+1;
    int icod = 32;
    //g_print("icod %d whichSpec %d mult %d\n", icod, whichSpec, nptrb);
    if(jav_modify(kptra,&nptra,NULL,&nptrb,&icod,NULL,whichModel, &whichSpec))
       endModify(whichModel);
}

void fill_matrices(GtkWidget *dlg, int RMatrix[3][3], float TMatrix[3])
{
    for(int i=0; i<3;i++)
    {
       for(int j=0;j<3;j++)
       {
           std::stringstream nome, val;
           nome << "T" << i << j;
           GtkWidget *entry = get_widget(dlg, nome.str().c_str());
           val << RMatrix[i][j];
           gtk_entry_set_text (GTK_ENTRY(entry), val.str().c_str());
       }
       std::stringstream nome, val;
       nome << "T" << i;
       GtkWidget *entry = get_widget(dlg, nome.str().c_str());
       val << TMatrix[i];
       gtk_entry_set_text (GTK_ENTRY(entry), val.str().c_str());
    }
}

static void selected_symmop(GtkTreeSelection  *sele, gpointer data)
{
    int RMatrix[3][3];
    float TMatrix[3];
    GtkWidget *dlg = (GtkWidget *)data;
    int row = row_selected(sele) + 1;
    if(row <= 0)
       return;
    if(get_matrices(getStringSymm(&row), RMatrix, TMatrix))
    {
#if 0
       for(int i=0; i<3; i++)
       {
           for(int j=0; j<3; j++)
               printf("%d ", RMatrix[i][j]);
           printf("\n");
       }
       for(int i=0; i<3; i++)
           printf("%f ",TMatrix[i]);
       printf("\n");
#endif
       fill_matrices(dlg, RMatrix, TMatrix);
    }
    else
      printf("Something wrong with symmetry operators\n");
}

void ListaOps(GLWindow *gl, GtkWidget *father, GtkWidget *parentbox)
{
  const char *titles[] = { "Number", "x' y' z'"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING};
  int  sizes[] = { 0, 0 };
  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  GtkWidget *list =
     new_selection(father, parentbox, "symmops", ncol, titles, sizes, types);
  gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(list), FALSE);
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
/*
  GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
  gtk_list_store_clear(GTK_LIST_STORE(list_store));
  GtkTreeIter iter;

  for(int i=1; i<=gl->sy.nsymop; i++)
  {
     gtk_list_store_append (list_store, &iter);
     gtk_list_store_set (list_store, &iter,
              0, i, 1, getStringSymm(&i), -1);
  }
*/
  g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_symmop), father);
/*
  gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"),
          -1, (int) MRmin((gl->sy.nsymop+1)*20, 400));
*/
}

void FillTransformW(GLWindow *gl)
{
   if(GLWINDOW == NULL)
      return;
   if(g_object_get_data(G_OBJECT(GLWINDOW), TransformW))
   {
      GtkWidget *dlg = get_widget(GLWINDOW, TransformW);
      int whichModel = get_int(dlg, "whichModel") - 1;
      if(whichModel < 0)
         return;
      GtkWidget *w = get_widget(dlg, "on_selected");
      gtk_widget_set_sensitive(w, !ModelInfo[whichModel].atoms_sel.empty());
      w = get_widget(dlg, "symmops");
      GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(w)));
      gtk_list_store_clear(GTK_LIST_STORE(list_store));
      GtkTreeIter iter;

      for(int i=1; i<=gl->sy.nsymop; i++)
      {
         gtk_list_store_append (list_store, &iter);
         gtk_list_store_set (list_store, &iter,
              0, i, 1, getStringSymm(&i), -1);
      }
      gtk_widget_set_size_request(get_widget(GTK_WIDGET(w), "scrollwin"),
          -1, (int) MRmin((gl->sy.nsymop+1)*20, 400));

      select_row(w, 0);
   }
}

void do_transform(GtkWidget *dlg, int whichB)
{
  int result = whichB;
  int whichModel = get_int(dlg, "whichModel") - 1;
  float T[3];
  GtkWidget *w;
  for(int i=0; i<3;i++)
  {
            std::stringstream nome;
            nome << "T" << i;
            w = get_widget(dlg, nome.str().c_str());
            T[i] = (float) atof(gtk_entry_get_text(GTK_ENTRY(w)));
  }
  int wm = whichModel + 1;
  int check_only_sel = 0;
  w = get_widget(dlg, "symmops");
  GtkTreeSelection *sele = gtk_tree_view_get_selection(GTK_TREE_VIEW(w));
  w = get_widget(dlg, "on_selected");
  if(gtk_widget_get_sensitive(w))
           check_only_sel = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(w));
  int nptra = 0;
  int *kptra = NULL;
  if(check_only_sel && !ModelInfo[whichModel].atoms_sel.empty())
  {
           nptra = (int) ModelInfo[whichModel].atoms_sel.size();
           kptra = g_new0(int, nptra);
           for(int i=0; i<nptra; i++)
               kptra[i] = ModelInfo[whichModel].atoms_sel[i];
  }

  int koper = row_selected(sele) + 1;
  jav_transform_model_(&result, &koper, T, &wm, &nptra, kptra);
}

void on_ok_transform(GtkWidget *button, gpointer data)
{
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  do_transform(dlg, 1);
}

void on_copy_transform(GtkWidget *button, gpointer data)
{
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  do_transform(dlg, 2);
}

//void on_undo_transform(GtkWidget *button, gpointer data)
//{
//  GtkWidget *dlg = gtk_widget_get_toplevel(button);
//  do_transform(dlg, 3);
//}

void on_close_transform(GtkWidget *button, gpointer data)
{
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  do_transform(dlg, 4);
  chiudi_dlg(button, data);
  updateModify(1);
}

GtkWidget *TransformModel(GtkWidget *window, GLWindow *gl,  int whichModel)
{
    GtkWidget *dlg, *label, *vbox, *frame, *button, *table, *table2, *entry;

    dlg = gtk_dialog_new();
    gtk_window_set_title (GTK_WINDOW (dlg), "Transform Model");

    vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
    gtk_container_set_border_width (GTK_CONTAINER (vbox), 4);

    label = LABEL_BOLD("Transform the X coordinates of the model to obtain", "blue", 1.2f);
    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);
    label = LABEL_BOLD("X' = RX + T", "blue", 1.3f);
    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 4);

    GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Only on selected atoms", NULL);
    gtk_box_pack_start (GTK_BOX (vbox), check, FALSE, FALSE, 4);
    g_object_set_data (G_OBJECT(dlg), "on_selected", check);
    ListaOps(gl, dlg, vbox);

#ifdef IN_GTK3
    frame = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
    frame = gtk_alignment_new(0.5f, 0.5f, 0, 0);
#endif
    gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);

    table = table_new(3, 4, FALSE);
    gtk_container_add(GTK_CONTAINER(frame), table);
    table_set_row_spacings(table, 8);
    table_set_col_spacings(table, 8);
    gtk_container_set_border_width (GTK_CONTAINER (table), 12);
    label = LABEL_BOLD("R =", "red", 1.5);
    table_attach(table, label, 0, 1, 1, 2, TRUE);
    label = LABEL_BOLD("T =", "red", 1.5);
    table_attach(table, label, 2, 3, 1, 2, TRUE);

    table2 = table_new (3, 3, FALSE);
    gtk_widget_show (table2);
    gtk_container_set_border_width (GTK_CONTAINER (table2), 0);
    table_attach(table, table2, 1, 2, 0, 3, TRUE);
    table_set_row_spacings (table2, 8);
    table_set_col_spacings (table2, 4);

    for(int i=0; i<3;i++)
    {
     for(int j=0;j<3;j++)
     {
         std::stringstream nome;
         nome << "T" << i << j;
         entry = gtk_entry_new ();
         set_width_chars (GTK_ENTRY(entry), 4);
         gtk_widget_show (entry);
         g_object_set_data(G_OBJECT(dlg), nome.str().c_str(), entry);
         table_attach (table2, entry, j, j+1, i, i+1, TRUE);
         gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
     }
    }

    table2 = table_new (3, 1, FALSE);
    gtk_widget_show (table2);
    gtk_container_set_border_width (GTK_CONTAINER (table2), 0);
    table_attach(table, table2, 3, 4, 0, 3, TRUE);
    table_set_row_spacings (table2, 8);
    table_set_col_spacings (table2, 4);

    for(int i=0; i<3;i++)
    {
         std::stringstream nome;
         nome << "T" << i;
         entry = gtk_entry_new ();
         set_width_chars (GTK_ENTRY(entry), 4);
         gtk_widget_show (entry);
         g_object_set_data(G_OBJECT(dlg), nome.str().c_str(), entry);
         table_attach (table2, entry, 0, 1, i, i+1, TRUE);
         gtk_entry_set_text (GTK_ENTRY(entry), "0");
         g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);
    }

    chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
    st->window = window;
    st->name = TransformW;

    button = myimage_button("_Transform", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, 1); 
    (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_ok_transform), (gpointer) st);

    button = myimage_button(" _Copy", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, 2); 
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button)), GTK_BUTTONBOX_SPREAD);
    (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_copy_transform), (gpointer) st);

//  button = myimage_button(" _Undo", "undo.png");
//  gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, 3); 
//  (void) g_signal_connect(G_OBJECT (button), "clicked",
//       G_CALLBACK(on_undo_transform), (gpointer) st);

    button = myimage_button(" _Close", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, 4); 
    (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(on_close_transform), (gpointer) st);
    (void) g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
    (void) g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);


    gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(window));
    gtk_widget_show_all(dlg);
    return dlg;
}

void on_transform(gpointer, gpointer data)
{
   GtkWidget *dlg;
   int whichModel = GetActiveModel() - 1;
   if(whichModel == -1)
        return;

   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   if(!gl->sy.nsymop)
      return;
   if(g_object_get_data(G_OBJECT(window), TransformW))
   {
      dlg = get_widget(window, TransformW);
      gdk_window_raise(gtk_widget_get_window(dlg));
   }
   else
   {
      dlg = TransformModel(window, gl, whichModel);
      g_object_set_data(G_OBJECT(window), TransformW, dlg);
      g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(1));
   }
   updateModify(3);
   FillTransformW(gl);
   gtk_widget_show_all(dlg);
   do_transform(dlg, 3);
}

void on_import_cod(gpointer, gpointer data)
{
   int whichModel = GetActiveModel();
   if(whichModel == 0)
        return;
   if(!ModelInfo[whichModel-1].created)
        return;

   GtkWidget *window = (GtkWidget *)data;
   addCOD(window, whichModel, 0);
}

void on_add_frag_fromcod(gpointer, gpointer data)
{
   int whichModel = GetActiveModel();
   if(whichModel == 0)
        return;
   if(!ModelInfo[whichModel-1].created)
        return;

   GtkWidget *window = (GtkWidget *)data;
   addCOD(window, whichModel, 1);
}


#ifdef USE_OPENBABEL

void addSMILES(GtkWidget *window, int ifAdd)
{
   GtkWidget *dlg, *vbox, *button, *w;
   int code = 35;
   int whichModel = GetActiveModel();
   if(whichModel == 0)
        return;
   if(!ModelInfo[whichModel-1].created)
        return;

   dlg = gtk_dialog_new ();
   gtk_window_set_title(GTK_WINDOW(dlg), "Add SMILES");
   gtk_container_set_border_width(GTK_CONTAINER(dlg), 8);
   g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(whichModel-1));
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(window));
   gtk_window_set_destroy_with_parent(GTK_WINDOW(dlg), TRUE);

   vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   w = LABEL_NEW("Enter SMILES fragment:", NULL);
   gtk_widget_show (w);
   set_alignment(w, 0., 0.5);
   gtk_label_set_justify(GTK_LABEL(w), GTK_JUSTIFY_LEFT);
   gtk_box_pack_start (GTK_BOX (vbox), w, FALSE, FALSE, 4);
   w = gtk_entry_new ();
   gtk_widget_show (w);
   gtk_box_pack_start (GTK_BOX (vbox), w, FALSE, FALSE, 4);

   button = OK_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

   button = CANCEL_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
   gtk_widget_show_all(dlg);

   int result = gtk_dialog_run(GTK_DIALOG(dlg));
   if(result == GTK_RESPONSE_OK)
   {
      int nptra = ifAdd, nptrb = 0, spec = 0;
      float thr = 0;
      char *newname = g_strdup( gtk_entry_get_text(GTK_ENTRY(w)));
      size_t sz = strlen(newname);
      ShowWaitCursor(dlg);
      jav_modify_object_(NULL, &nptra, NULL, &nptrb, &code, &thr,
          &whichModel, &spec, newname, sz);
      HideWaitCursor(dlg);
   }
   gtk_widget_destroy(dlg);
}

void on_add_frag_fromsmiles(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *)data;
   addSMILES(window, 1);
}

void on_import_smiles(gpointer, gpointer data)
{
   GtkWidget *window = (GtkWidget *)data;
   addSMILES(window, 0);
}

// MOPAC
namespace for_MOPAC
{
const char *methods[] = {"AM1", "MNDO", "MNDO-d", "PM3", "PM6", "PM7", "RM1"};
int nmethods = (int) G_N_ELEMENTS(methods);
const char *multi[] = {"Singlet", "Doublet", "Triplet", "Quartet", "Quintet"};
int nmulti = (int) G_N_ELEMENTS(multi);
const char *formats[] = {"Cartesian", "Z-matrix"};
int nformats = (int) G_N_ELEMENTS(formats);
typedef float coord_type[3];
typedef int   conn_type[3];
int Nmethod = 5;
int Nmulti = 0;
int Nformat = 0;
int Ncharge = 0;
std::string newTitle = "Title";
}

gchar *toPreview(const gchar *str1)
{
    gchar *str2 = g_new0(char, strlen(str1)+1);
    int k = 0;
    for(size_t i=0; i< strlen(str1); i++)
    {
       if(str1[i] != '-')
          str2[k++] = g_ascii_toupper(str1[i]);
    }
    return str2;
}

void Model::FillPreview(std::stringstream &strm)
{
    for(int i=0; i<nats_au; i++)
    {
        if(atm_au[i].color >= 0)
        {
           char *label2 = g_new0(char, LEN_SPEC+1);
           CopiaStringan( label2, LEN_SPEC+1, LabSpec[atm_au[i].color], LEN_SPEC);
           strm << label2 << " ";
           g_free(label2);
        }
        else
           strm << "Q     ";
        for(int j=0; j<3; j++)
            strm << fToStr2(atm_au[i].xyz[j], 5) << "   1   ";
        strm << "\n";
    }
}

void Model::FillPreview(std::stringstream &strm, float I_coor[][3], int conn[][3])
{
    for(int i=0; i<nats_au; i++)
    {
        if(atm_au[i].color >= 0)
        {
           char *label2 = g_new0(char, LEN_SPEC+1);
           CopiaStringan( label2, LEN_SPEC+1, LabSpec[atm_au[i].color], LEN_SPEC);
           strm << label2 << " ";
           g_free(label2);
        }
        else
           strm << "Q     ";

        if(i == 0)
        {
           for(int j=0; j<3; j++)
              strm << fToStr2(0, 5) << "   1   ";
           strm << "0 0 0";
        }
        else if(i == 1)
        {
           strm << fToStr2(I_coor[1][0], 5) << "   1   ";
           for(int j=0; j<2; j++)
              strm << fToStr2(0, 5) << "   1   ";
           strm << conn[0][0];
           strm << " 0 0";
        }
        else if(i == 2)
        {
           strm << fToStr2(I_coor[2][0], 5) << "   1   ";
           strm << fToStr2(I_coor[2][1], 5) << "   1   ";
           strm << fToStr2(0, 5) << "   1   ";
           strm << conn[2][0] << " ";
           strm << conn[2][1];
           strm << " 0";
        }
        else
        {
           if (I_coor[i][2]< 0)
               I_coor[i][2] = 360 + I_coor[i][2];
           strm << fToStr2(I_coor[i][0], 5) << "   1   ";
           strm << fToStr2(I_coor[i][1], 5) << "   1   ";
           strm << fToStr2(I_coor[i][2], 5) << "   1   ";
           strm << conn[i][0] << " ";
           strm << conn[i][1] << " ";
           strm << conn[i][2];
        }
        strm << "\n";
    }
}

static void FillPreview(GtkWidget *dlg)
{
using namespace for_MOPAC;
    GtkWidget *text;

    text = get_widget(dlg, "testo");
    GtkTextIter start, end;
    GtkTextBuffer *text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
    gtk_text_buffer_get_bounds (text_buffer, &start, &end);
    gtk_text_buffer_delete(text_buffer, &start, &end);

    Nmethod = combo_get_val(get_widget(dlg, "methods")) - 1;
    Nmulti = combo_get_val(get_widget(dlg, "multi")) - 1;
    Nformat = combo_get_val(get_widget(dlg, "formats")) - 1;
    Ncharge = spin_button_get_value_as_int(get_widget(dlg, "charge"));
    newTitle.assign(gtk_editable_get_chars(GTK_EDITABLE(get_widget(dlg, "Title")), 0, -1));
    std::stringstream strm;
    strm << "AUX LARGE CHARGE=" << Ncharge << " " << toPreview(multi[Nmulti])
         << " " << toPreview(methods[Nmethod]) << "\n";
    strm << newTitle << "\n";
    strm << "\n";
    int wm = get_int(dlg, "whichModel");
    if(Nformat == 0)
    {
        ModelInfo[wm].FillPreview(strm);
    }
    else
    {
        atom_type *atml = ModelInfo[wm].FromJavatomToAtom();
        int natoms = ModelInfo[wm].nats_au;
        coord_type *I_coor = g_new0(coord_type, natoms);
        //conn_type *conn = g_new0(conn_type, ModelInfo[wm].nlegs_au);
        conn_type *conn = g_new0(conn_type, natoms);
        wm++;
        cartesiantozmatrix_forc_(atml, &natoms, I_coor, conn, &wm);
        wm--;
        ModelInfo[wm].FillPreview(strm, &I_coor[0], &conn[0]);
    }
    put_text(text, strm.str().c_str());
    gtk_widget_set_sensitive(get_widget(dlg, "content"), TRUE);
    gtk_widget_set_sensitive(get_widget(dlg, "reset"), FALSE);
}

void set_mopac(GtkWidget *button, gpointer data)
{
using namespace main_app;
  std::string fn;
  GtkWidget *w = (GtkWidget *) data;
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  const gchar *deffn = gtk_entry_get_text(GTK_ENTRY(w));
  fn = gtkext::dlg_select_file(dlg, deffn, gtkext::eSELECT_ALIEN, "*.*");
  if( !fn.empty() )
  {
    gtk_entry_set_text(GTK_ENTRY(w), fn.c_str());
    JavApp.UpdatePovray( fn.c_str());
  }
}

static void combo_methods_changed(GtkWidget *combo, gpointer )
{
    FillPreview(gtk_widget_get_toplevel(combo));
}

static void combo_multi_changed(GtkWidget *combo, gpointer )
{
    FillPreview(gtk_widget_get_toplevel(combo));
}

static void combo_formats_changed(GtkWidget *combo, gpointer )
{
    FillPreview(gtk_widget_get_toplevel(combo));
}

void charge_changed(GtkWidget *tb, gpointer )
{
    FillPreview(gtk_widget_get_toplevel(tb));
}

static void title_changed(GtkWidget *w, gpointer )
{
    FillPreview(gtk_widget_get_toplevel(w));
}

static void changed_preview_text(GtkTextBuffer *tb, GtkWidget *dlg)
{
    gtk_widget_set_sensitive(get_widget(dlg, "content"), FALSE);
    gtk_widget_set_sensitive(get_widget(dlg, "reset"), TRUE);
}

static void close_mopac_window(GtkWidget *w, gpointer )
{
    gtk_widget_destroy(gtk_widget_get_toplevel(w));
}

static void submit_mopac(GtkWidget *w, gpointer )
{
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    GtkWidget *dlg = gtk_widget_get_toplevel(w);
    int wm = get_int(dlg, "whichModel");
    std::string nomemod = ModelInfo[wm].modname;
    size_t posi = nomemod.find_last_of('.');
    std::string nomefile = nomemod.substr(0, posi);
    std::string nomeout = nomemod.substr(0, posi);
    nomefile.append("_mopac.mop");
    nomeout.append("_mopac.out");
//Save Preview 
    GtkTextIter start, end;
    GtkWidget *textw = get_widget(dlg, "testo");
    GtkTextBuffer *text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (textw));
    gtk_text_buffer_get_bounds (text_buffer, &start, &end);
    char *buffer = g_strdup(fromUTF8(gtk_text_iter_get_text (&start, &end)).c_str());
    FILE *fp = fOpen(nomefile.c_str(), "w");
    (void) fputs(buffer, fp);
    (void) fclose(fp);
    g_free(buffer);
//Run MOPAC
    std::string cmd(gtk_entry_get_text(GTK_ENTRY(get_widget(dlg, "mopac_prog"))));
    std::vector<std::string> args;
    std::string msg;

    args.push_back(toUTF8(nomefile.c_str()));
    gtk_widget_destroy(dlg);
    gl->PrintMess("Running MOPAC ...");
// la seguente per forzare il cambio di cursore

    gtk_widget_grab_focus(GLWINDOW);
//
    LoadWinCursor(5);
// le 2 seguenti per PrintMess
     while(gtk_events_pending())
         (void) gtk_main_iteration();
//
    char *buff1 = g_new0(char, 1024);
    int i = run_command(cmd, args, msg, 1, NULL, &buff1);
    gl->PrintMess("Running MOPAC ... done!");
    //HideWaitCursor(GLWINDOW);
    LoadWinCursor(0);
    if((i == -1) && !str_white(msg.c_str()))
        gtkext::dlg_errmsg(GTK_WINDOW(GLWINDOW), msg);
#ifndef _WIN32
    else if(!strstr(buff1, "normally"))
       g_print("%s\n", buff1);
#endif
    else
    {
       bool result = Importa(nomeout, wm+1, gl->omI);
       if(!result)
       {
           
           msg.assign("MOPAC generated error.\nRead the end of the output file:\n");
           msg.append(g_build_filename(getPWD(), nomeout.c_str(), NULL));
           gtkext::dlg_errmsg(GTK_WINDOW(GLWINDOW), msg);
       }
       gl->PrintMess(" ");
    }
}

static void reset_mopac_window(GtkWidget *w, GtkWidget *table)
{
    FillPreview(gtk_widget_get_toplevel(w));
    gtk_widget_set_sensitive(table, TRUE);
    gtk_widget_set_sensitive(w, FALSE);
}

const std::string findMOPAC()
{
using namespace main_app;
   if(!strstr(JavApp.PovrayP().c_str(), "MOPAC"))
   {
       //char *mopac_prog = find_program_in_path("MOPAC2012.EXE");
       std::vector<std::string> Files;
       find_pattern_in_dir("mopac*.exe", Files);
       char *mopac_prog = NULL;
       if(!Files.empty())
       {
          sort(Files.begin(), Files.end());
          size_t k = Files.size() - 1;
          mopac_prog = g_strdup(Files.at(k).c_str());
          Files.clear();
       }

       if(mopac_prog == NULL)
       {
#ifdef _WIN32
          //mopac_prog = g_strdup("C:\\Program Files\\MOPAC\\MOPAC2012.exe");
          find_pattern_in_dir("mopac*.exe", Files, "C:\\Program Files\\MOPAC\\");
#else
          find_pattern_in_dir("mopac*.exe", Files, "/opt/mopac");
#endif
          //mopac_prog = g_strdup("/opt/mopac/MOPAC2012.exe");
          if(!Files.empty())
          {
             sort(Files.begin(), Files.end());
             size_t k = Files.size() - 1;
             mopac_prog = g_strdup(Files.at(k).c_str());
          }          
       }
       if(mopac_prog != NULL)
          JavApp.UpdatePovray(mopac_prog);
    }
    return JavApp.PovrayP();
}

void open_mopac_window(int wm)
{
using namespace for_MOPAC;
   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(dlg), "MOPAC Input");
   gtk_container_set_border_width(GTK_CONTAINER(dlg), 8);
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(GLWINDOW));
   gtk_window_set_destroy_with_parent(GTK_WINDOW(dlg), TRUE);
   g_object_set_data(G_OBJECT(dlg), "whichModel", GINT_TO_POINTER(wm));

   GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   GtkWidget *table = table_new(5, 5, FALSE);
   gtk_box_pack_start(GTK_BOX(vbox1), table, TRUE, TRUE, 0);
   table_set_row_spacings(table, 12);
   table_set_col_spacings(table, 12);
   g_object_set_data(G_OBJECT(dlg), "content", table);
   
//Preview
   GtkWidget *frame = gtk_frame_new(NULL);
   GtkWidget *text;
   gtk_container_set_border_width(GTK_CONTAINER(frame), 4);
   text = scrolled_text(frame);
   g_object_set_data(G_OBJECT(dlg), "testo", text);
   GtkTextBuffer *text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
   g_signal_connect(G_OBJECT(text_buffer), "changed",
       G_CALLBACK(changed_preview_text), dlg);
   int lar, alt;
   PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
   get_metrics(fontlist, &lar, &alt);
   widget_modify_font(text, fontlist);

   int nr = MRmin(ModelInfo[wm].nats_au+4, 12);
   gtk_widget_set_size_request(get_widget(GTK_WIDGET(text), "scrollwin"),
        70*lar, nr*alt);
   gtk_widget_set_size_request(dlg, 70*lar, -1);

   GtkWidget *label = LABEL_NEW("Title: ", NULL);
   set_alignment(label, 0, 0.5);
   table_attach_exp(table, label, 0, 1, 0, 1);

   GtkWidget *entry = gtk_entry_new();
   table_attach_exp(table, entry, 1, 4, 0, 1);
   gtk_entry_set_text(GTK_ENTRY(entry), newTitle.c_str());
   g_object_set_data(G_OBJECT(dlg), "Title", entry);
   g_signal_connect(G_OBJECT(entry), "activate", G_CALLBACK(title_changed), dlg);

   label = LABEL_NEW("Method: ", NULL);
   set_alignment(label, 0, 0.5);
   table_attach_exp(table, label, 0, 1, 1, 2);

   GtkWidget *combo = create_combo(NULL, methods, nmethods, Nmethod+1, NULL,
              G_CALLBACK(combo_methods_changed), false);
   table_attach(table, get_widget(combo, "parent"), 1, 2, 1, 2);
      g_object_set_data(G_OBJECT(dlg), "methods", combo);

   label = LABEL_NEW("Charge: ", NULL);
   set_alignment(label, 0, 0.5);
   table_attach_exp(table, label, 2, 3, 1, 2);

   GtkWidget *spin = SPIN_NEW(-99, 99, Ncharge, 1, 0);
   g_object_set_data(G_OBJECT(dlg), "charge", spin);
   g_signal_connect(G_OBJECT(spin), "value-changed", G_CALLBACK(charge_changed),      dlg);
   table_attach_exp(table, spin, 3, 4, 1, 2);

   label = LABEL_NEW("Multiplicity: ", NULL);
   set_alignment(label, 0, 0.5);
   table_attach_exp(table, label, 0, 1, 2, 3);

   combo = create_combo(NULL, multi, nmulti, Nmulti+1, NULL,
              G_CALLBACK(combo_multi_changed), false);
   table_attach(table, get_widget(combo, "parent"), 1, 2, 2, 3);
      g_object_set_data(G_OBJECT(dlg), "multi", combo);

   label = LABEL_NEW("Format: ", NULL);
   set_alignment(label, 0, 0.5);
   table_attach_exp(table, label, 2, 3, 2, 3);

   combo = create_combo(NULL, formats, nformats, Nformat+1, NULL,
              G_CALLBACK(combo_formats_changed), false);
   table_attach(table, get_widget(combo, "parent"), 3, 4, 2, 3);
      g_object_set_data(G_OBJECT(dlg), "formats", combo);

   label = LABEL_NEW("MOPAC Program: ", NULL);
   set_alignment(label, 0, 0.5);
   table_attach_exp(table, label, 0, 1, 3, 4);

   entry = gtk_entry_new();
   table_attach_exp(table, entry, 1, 4, 3, 4);
   GtkWidget *Btn = gtk_button_new_with_label(" ... ");
   g_signal_connect (G_OBJECT(Btn), "clicked", G_CALLBACK (set_mopac), entry);
   table_attach(table, Btn, 4, 5, 3, 4);
   g_object_set_data(G_OBJECT(dlg), "mopac_prog", entry);

   std::string mopac_prog = findMOPAC();
   if(g_file_test(mopac_prog.c_str(), G_FILE_TEST_EXISTS))
      gtk_entry_set_text(GTK_ENTRY(entry), mopac_prog.c_str());

   GtkWidget *expander = gtk_expander_new("Preview");
   gtk_container_add(GTK_CONTAINER(expander), frame);
   gtk_box_pack_end(GTK_BOX(vbox1), expander, TRUE, TRUE, 0);
   //table_attach(table, expander, 0, 5, 4, 5);
#if defined (IN_GTK3) && (GTK_MINOR_VERSION >= 2)
   gtk_expander_set_resize_toplevel(GTK_EXPANDER(expander), TRUE);
#endif
   //FillPreview(dlg);

   GtkWidget *button = myimage_button("Submit", "apply.png");
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 1);
   (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(submit_mopac), NULL);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
      GTK_BUTTONBOX_SPREAD);

   button = RESET_button();
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 3);
   (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(reset_mopac_window), table);
    gtk_widget_set_sensitive(button, FALSE);
    g_object_set_data(G_OBJECT(dlg), "reset", button);

   button = CANCEL_button();
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 2);
   (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(close_mopac_window), NULL);

   (void) g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);

   FillPreview(dlg);
   gtk_widget_show_all(dlg);
}

void on_optimize(gpointer item, gpointer )
{
     int whichModel = GetActiveModel();
     if(whichModel == 0)
        return;
   if(!ModelInfo[whichModel-1].created)
        return;
     if(ModelInfo[whichModel-1].nats <= 0)
        return;
     const char *label = obj_get_label(item);
     int nptra = 0;
     int *kptra = NULL;
     if(strstr(label, "Selected"))
     {
        nptra = (int) ModelInfo[whichModel-1].atoms_sel.size();
        kptra = g_new0(int, nptra);
        for(int i=0; i<nptra; i++)
            kptra[i] = ModelInfo[whichModel-1].atoms_sel[i];
     }
     else if(strstr(label, "MOPAC"))
     {
        int code = 0;
        atom_type *kptr = NULL;
        jav_optimize_geometry_mopac_(&code, &whichModel, kptr, &nptra);
        open_mopac_window(whichModel-1);
        return;
     }
     //ShowWaitCursor(GLWINDOW);
     LoadWinCursor(5);
     jav_optimize_geometry_(&whichModel, kptra, &nptra);
     //HideWaitCursor(GLWINDOW);
     LoadWinCursor(0);
}

void view_mopac_out(gpointer , gpointer data)
{
    GtkWidget *window = (GtkWidget *) data;
    int wm = GetActiveModel() - 1;
    std::string nomemod = ModelInfo[wm].modname;
    size_t posi = nomemod.find_last_of('.');
    std::string nomeout = nomemod.substr(0, posi);
    nomeout.append("_mopac.out");
    char *tmp = g_build_filename(getPWD(), nomeout.c_str(), NULL);
    if( !g_file_test(toUTF8(tmp), G_FILE_TEST_EXISTS) )
    {
       gtkext::dlg_errmsg(GTK_WINDOW(window), "Error in open file %s", tmp);
       return;
    }
    gtkext::text_window(GTK_WINDOW(window), tmp, "*.out", 0, tmp);
}
#else

void on_optimize(gpointer item, gpointer )
{
}

void on_add_frag_fromsmiles(gpointer, gpointer data)
{
}

void on_import_smiles(gpointer, gpointer data)
{
}
#endif

void on_dftd(gpointer , gpointer data)
{
   GtkWidget *window = (GtkWidget *)data;
   int whichModel = GetActiveModel() - 1;
   std::string fn;
   if(ModelInfo[whichModel].created)
      fn = g_path_get_basename(ModelInfo[whichModel].modname);
   else
      fn = "";
   int nfilt;
   fn =  gtkext::dlg_select_file(window, fn, gtkext::eSELECT_TO_WRITE,
           "NWCHEM Input (*.nw)@ABINIT Input (*.in)@CRYSTAL Input (*.d12)"
           "@Quantum Espresso Input (*.in)", false, NULL, false, &nfilt);
   int tipo = NWCHEM_IN_DFTD + nfilt;
// per l'allineamento
   if(nfilt >= 3)
      tipo++;

   if(str_white(fn.c_str()))
       return;
   exportFile(fn, tipo);
}

void on_pdp(gpointer , gpointer data)
{
   GtkWidget *window = (GtkWidget *)data;
   int whichModel = GetActiveModel();
   std::string fn;
   if(ModelInfo[whichModel-1].created)
      fn = g_path_get_basename(ModelInfo[whichModel-1].modname);
   else
      fn = "";

   PowderPattern(window, whichModel, fn);
}

void on_pdf(gpointer , gpointer data)
{
   GtkWidget *window = (GtkWidget *)data;
   int whichModel = GetActiveModel();
   std::string fn;
   if(ModelInfo[whichModel-1].created)
      fn = g_path_get_basename(ModelInfo[whichModel-1].modname);
   else
      fn = "";
   if(!ModelInfo[whichModel-1].nats_au)
      return;

   PairDistribution(window, whichModel, fn);
}

}   // end namespace

int GetNz(int atomic_num)
{
    using namespace GLextmr;
    int which = GetActiveModel() - 1;
    for (int i=0; i<ModelInfo[which].numSpec; i++)
    {
        if(atomic_num == ModelInfo[which].Species[i])
           return (i+1)*nzc;
    }
    return 0;
}

void set_check_active(const char *name, gboolean active)
{
using namespace GLextmr;
    gpointer w = get_object(GLWINDOW, name);
    obj_set_active(w, active, true);
}

extern "C" void put_found_(int *kfound, int *vat, float *vdist, op_type *vsym)
{
using namespace GLextmr;
   if(!GLWINDOW)
      return;
    if(g_object_get_data(G_OBJECT(GLWINDOW), "sphere_dlg"))
    {
       GtkWidget *dlg = get_widget(GLWINDOW, "sphere_dlg");
       int whichModel = get_int(dlg, "whichModel") - 1;
       ModelInfo[whichModel].FillListSphere(dlg, *kfound, vat, vdist, vsym);
    }
}

void  aggiorna_dimensioni(GtkWidget *mainwin)
{
  GtkAllocation allocation;
  gtk_widget_get_allocation(mainwin, &allocation);
  int w = (int)allocation.width;
  int h = (int)allocation.height;
  main_app::JavApp.UpdateDime(w, h);
}

void  aggiorna_ps(int val)
{
   main_app::JavApp.UpdatePS(val);
}

void  aggiorna_bg(int val)
{
   main_app::JavApp.UpdateBG(val);
}

void  set_defbg(int val)
{
using namespace GLextmr;
    defaultBG = val;
    switch(defaultBG)
    {
    default:
         defaultBG = TYPE_BLACK;
    case TYPE_BLACK:
         for(int i=0; i<3; i++)
             defaultBgColor[i] = 0.f;
         break;
    case TYPE_WHITE:
         for(int i=0; i<3; i++)
             defaultBgColor[i] = 1.f;
         break;
    }
}

void  aggiorna_smooth(int val)
{
   main_app::JavApp.UpdateBestv(val);
}

#ifdef HAVE_ADVANCED
void  aggiorna_rendering(int val)
{
   main_app::JavApp.UpdateRend(val);
}
#endif

extern "C" void csystem_(char *string)
{
     int idum = system(string);
     if(idum !=  0)
        g_print("Error in system(%s)\n", string);
}

extern "C" void jav_get_style_(float colors[], float colcell[], float vfact[], float B[3][3])
{
using namespace GLextmr;

   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = 0;
   int nsp = ModelInfo[whichModel].numSpec;
   for(int i=0; i<nsp; i++)
   {
        int index1 = ModelInfo[whichModel].Species[i] - 1;
        float color1[3];
        if(index1 >= N_ELEMENTS)
           index1 = OTHERS;
        memcpy(color1,  ModelInfo[whichModel].light_diffuse[index1], 3*sizeof(float));
        for(int j=0; j<3; j++)
            colors[j*nsp+i] = color1[j];
   }
   for(int j=0; j<3; j++)
       colcell[j] = gl->CellColor[j];
   vfact[0] = (float) gl->sc_atoms;
   vfact[1] = (float) gl->sc_bonds;
   for(int i=0; i<3; i++)
       for(int j=0; j<3; j++)
           B[i][j] = (float)gl->Rotm.m[3*i+j];
}

extern "C" void setmodify_(int *active)
{
using namespace GLextmr;
      defaultModify = *active;
      updateModify(defaultModify);
}

extern "C" int isopened_glwindow_()
{
using namespace GLextmr;

      return ((GLWINDOW != NULL) && gtk_widget_get_visible(GLWINDOW));
}

extern "C" void set_cell_(int *ifC)
{
using namespace GLextmr;
      if(GLWINDOW !=NULL)
      {
         GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
         gl->ifCell = ((*ifC) != 0);
         aggiornaProperties();
         gpointer but = get_object(GLWINDOW, "View Cell Edges");
         obj_set_active(but, *ifC, true);
      }
      defaultCell = *ifC;
}

extern "C" void set_fog_(int *ifC)
{
using namespace GLextmr;
      if(GLWINDOW !=NULL)
      {
         GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
         gl->fog = ((*ifC) != 0);
         set_values_for_advanced();    
      }
      defaultFog = *ifC;
}

extern "C" void set_clip_(int *ifC)
{
using namespace GLextmr;
      if(GLWINDOW !=NULL)
      {
         GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
         SetClip((*ifC) != 0, false);
         gl->ClipFactor = ((*ifC) != 0)?0.5f:1.f;
         set_values_for_advanced();    
      }
      defaultClip = *ifC;
}

extern "C" void set_usedefaultb_(float B[3][3])
{
using namespace GLextmr;
    if(PreviewMode)
       return;
    useDefaultB = true;
    float BB[] = {
                  B[0][0], B[0][1], B[0][2], 0,
                  B[1][0], B[1][1], B[1][2], 0,
                  B[2][0], B[2][1], B[2][2], 0,
                  0, 0, 0, 1};
    for(int i=0; i<16; i++)
        GBB[i] = BB[i];
}

extern "C" void set_style_(int *ps, int *which)
{
using namespace GLextmr;
// le due seguenti per superare il problema sul preview 
     if(PreviewMode && (defaultPlotStyle != -1))
        return;
//
     int plotStyle = *ps - 1;
     if((plotStyle < 0) || (plotStyle >  VANDERWAALS))
        plotStyle = STICK_AND_BALLS;
     int i = *which - 1;
      if(GLWINDOW && ModelInfo[i].created)
      {
//prova mr
         return;
//end prova
         ModelInfo[i].plotStyle = plotStyle;
         aggiornaProperties(i);
         GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
         gl->Redraw();
      }
      defaultPlotStyle = plotStyle;
}

extern "C" void set_labels_(int *action, int *which)
{
using namespace GLextmr;
      int i = *which - 1;
      if(GLWINDOW && ModelInfo[i].created)
      {
         ModelInfo[i].ifLabels = ((*action) != 0);
         aggiornaProperties(i);
      }
      defaultLabels = *action;
}

extern "C" void set_symm_(int *action, float *klevel, int *which)
{
using namespace GLextmr;
      int i = *which - 1;
      if(GLWINDOW && ModelInfo[i].created)
      {
         for(int k=0; k<3; k++)
             ModelInfo[i].klevel[k] = *klevel;
         gpointer tb = get_object(GLWINDOW, "SymmOn");
         if(tb != NULL)
            obj_set_active(tb, *action);
         else
            aggiornaMenuSym();
         aggiornaProperties(i);
      }
      defaultSymmetry = *action;
}

extern "C" void set_message_(char *msg)
{
using namespace GLextmr;
      if(GLWINDOW && ModelInfo[0].created)
      {
         GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
         gl->PrintMess(msg);
      }
      defaultMessage = msg;
}

extern "C" void set_title_(char *title)
{
using namespace GLextmr;
      if(GLWINDOW !=NULL)
         gtk_window_set_title(GTK_WINDOW(GLWINDOW), toUTF8(title));
      defaultTitle = title;
}

extern "C" void set_bg_(int *tipoBg, int col1[], int col2[])
{
using namespace GLextmr;
    defaultBG = *tipoBg;
    switch(defaultBG)
    {
    default:
    case TYPE_BLACK:
    case TYPE_WHITE:
         set_defbg(defaultBG);
         break;
    case TYPE_FLAT:
         for(int i=0; i<3; i++)
             defaultBgColor[i] = (float) col1[i]/255.f;
         break;
    case TYPE_HGRAD:
    case TYPE_VGRAD:
    case TYPE_DGRAD:
    case TYPE_RGRAD:
         for(int i=0; i<3; i++)
         {
             defaultBgColor1[i] = (float) col1[i]/255.f;
             defaultBgColor2[i] = (float) col2[i]/255.f;
         }
         break;
    }
    if(GLWINDOW !=NULL)
       SetBgFromDefaults();
}

extern "C" void get_info_fromc_(int vetinfo[], int *wm)
{
using namespace GLextmr;
      int whichModel = *wm - 1;
      for(int i=0; i<9;i++)
          vetinfo[i] = GetInfo(i, whichModel);
}

extern "C" void passaangle_(int *wM, jav_anglebond_type *angle, int *nangles)
{
using namespace GLextmr;
  int k = *wM - 1;
  ModelInfo[k].FillAngs(*nangles, angle);
//  ViewAngle();
}

extern "C" void passatorsion_(int *wM, jav_torsion_type *torsion, int *ntorsions)
{
using namespace GLextmr;
  int k = *wM - 1;
  ModelInfo[k].ntorsions = *ntorsions;
  if(ModelInfo[k].torsions)
     g_free(ModelInfo[k].torsions);
  ModelInfo[k].torsions = g_new0(jav_torsion_type,  ModelInfo[k].ntorsions);
  for(int i=1; i<=ModelInfo[k].ntorsions; i++)
  {
      ModelInfo[k].torsions[i-1].n1 = torsion[i-1].n1;
      ModelInfo[k].torsions[i-1].n2 = torsion[i-1].n2;
      ModelInfo[k].torsions[i-1].n3 = torsion[i-1].n3;
      ModelInfo[k].torsions[i-1].n4 = torsion[i-1].n4;
      ModelInfo[k].torsions[i-1].fv = torsion[i-1].fv;
  }
}

extern "C" void set_undoredo_(int *but, int *stato, char *str=NULL)
{
using namespace GLextmr;
   gpointer item;
   std::string label_menu;
   if(*but == 0)
   {
        item = get_object(GLWINDOW, "Undo");
        label_menu.assign("Undo ");
        g_object_set_data(G_OBJECT(GLWINDOW), "status_undo",
            GINT_TO_POINTER(*stato));
   }
   else
   {
        item = get_object(GLWINDOW, "Redo");
        label_menu.assign("Redo ");
        g_object_set_data(G_OBJECT(GLWINDOW), "status_redo",
            GINT_TO_POINTER(*stato));
   }
   obj_set_sensitive(item, *stato);
   if(str != NULL)
   {
      label_menu.append(str);
      obj_set_label(item, label_menu.c_str());
   }
}

extern "C" void passamodello_(atom_type *atml, f_bond_type *legm, 
       int *nats, int *nats_au, int *nlegs, int *nlegs_au, element_type *celem, int *nelem, 
       int *icent, int *whichModel, int *nmodelli,
       int *ifResize)
{
using namespace GLextmr;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  int hnd = get_int(GLWINDOW, "expose_hnd");
  GtkWidget *da = get_widget(GLWINDOW, "drawingarea");
  if(hnd)
     g_signal_handler_block(G_OBJECT(da), hnd);
  int ifPDB = 0;
  bool ifNewM = true;
  int k = *whichModel - 1;
  SetActiveModel(1); //active model

  PassaModello(atml, legm, nats, nats_au, nlegs, nlegs_au, 
               celem, nelem, whichModel, nmodelli, &ifPDB, NULL, &ifNewM, *ifResize);
  UpdateInfoAtoms();
  gl->RiNormalizza();
  gl->SetSphereCentre(-1, -1, false);
  gl->SetSphereRadius(-1, false);
  aggiornaMenuSym();
  aggiornaProperties(k);
  if(ifNewM || defaultModify)
     updateModify(defaultModify);
  if(!(useDefaultB) && ifNewM )
     gl->ViewPlane('L');
  else if(useDefaultB)
  {
     gl->RotB = MRMatrixMakeFromArray(GBB);
     gl->view_quat = MRMatrixToQuat(gl->RotB);
     gl->Rotm = MRMatrix4MakeFromQuat(gl->view_quat);
     useDefaultB = false;
  }
  update_menu_deletemodel();
  if(hnd)
     g_signal_handler_unblock(G_OBJECT(da), hnd);
}

extern "C" void passamodellojav_(atom_type *atml, f_bond_type *legm,
       int *nats, int *nats_au, int *nlegs, int *nlegs_au,
       element_type *celem, int *nelem, 
       int *icent, int *nmodels, int *which, int *ifPdb, char *name, int *ifR, int het[])
{
using namespace GLextmr;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  bool ifNewM = true;
  PassaModello(atml, legm, nats, nats_au, nlegs, nlegs_au,
               celem, nelem, which, nmodels, ifPdb, name, &ifNewM, *ifR, het);
  if(!PreviewMode)
  {
#ifdef JAV
     int k = *which - 1;
     update_infos_model(k, ifNewM);
     update_infos_cell(gl->nMaps + gl->nModels);
     SetLastRun(GLWINDOW, false);
#endif
     UpdateInfoAtoms();
     gl->SetSphereCentre(-1, -1, false);
     gl->SetSphereRadius(-1, false);
     aggiornaMenuSym();
     if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
     {
         GtkWidget *dlg = get_widget(GLWINDOW, SettingsWindow);
         set_values_for_polyhedra(dlg, gl);
     }
  }

  gl->RiNormalizza();
#ifndef JAV
  if(ifNewM || defaultModify)
     updateModify(defaultModify);
  if(PreviewMode)
  {
     SelezionaNonGhost(*which - 1);
     gl->ViewPlane('S', false);
     ModelInfo[*which-1].atoms_sel.clear();
     if(!have_fb)
        gl->Redraw();
  }
  else if(!(useDefaultB) && ifNewM )
     gl->ViewPlane('L');
  else if(useDefaultB)
  {
     gl->RotB = MRMatrixMakeFromArray(GBB);
     gl->view_quat = MRMatrixToQuat(gl->RotB);
     gl->Rotm = MRMatrix4MakeFromQuat(gl->view_quat);
     useDefaultB = false;
  }
#else
  if(ifNewM && (gl->nModels==1))
  {
     ifNewM = false;
     gl->ResetView(true, false);
     gl->ViewPlane('L', true);
  }
  else
     gl->Redraw();
#endif
}

extern "C" void jav_draw_()
{
using namespace GLextmr;

  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  if(gl != NULL)
  {
#ifdef JAV
     if(PreviewMode)
        return;
#endif
     gl->Redraw();
     while(gtk_events_pending())
         (void) gtk_main_iteration();
  }
}

extern "C" void set_polyhedra_button_(int *action)
{
using namespace GLextmr;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   for(int whichModel=0; whichModel<gl->nModels; whichModel++)
   {
       if(ModelInfo[whichModel].created)
           ModelInfo[whichModel].ifPoly = ((*action) != 0);
   }
   gpointer check = get_object(GLWINDOW, "Polyhedra");
   obj_set_active(check, *action, true);
}

extern "C" void set_grow_fragment_button_(int *action)
{
using namespace GLextmr;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gpointer check = get_object(GLWINDOW, "Grow Fragment");
   obj_set_active(check, *action, true);
   gl->ifGrow = obj_get_active(check);
}

extern "C" void set_contacts_button_(int *action)
{
using namespace GLextmr;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gpointer check = get_object(GLWINDOW, "Hydrogen Bonds");
   obj_set_active(check, *action, true);
   gl->ifHBonds = obj_get_active(check);
   check = get_object(GLWINDOW, "Short Contacts");
   obj_set_active(check, *action, true);
   gl->ifShortc = obj_get_active(check);
   check = get_object(GLWINDOW, "Delete Hanging Contacts");
   obj_set_sensitive(check, *action);
   if(!*action)
   {
      obj_set_active(check, *action, true);
      gl->ifDelHang = obj_get_active(check);
   }
}

extern "C" void passapoliedri_(int *npoly, polyhedron_type *poly)
{
using namespace GLextmr;
   if(GLWINDOW == NULL)
      return;
//#ifdef JAV
      int whichModel = GetActiveModel() - 1;
//#else
//      int whichModel = 0;
//#endif
   if(whichModel == -1)
      return;
   if(!ModelInfo[whichModel].created)
        return;
   ModelInfo[whichModel].FillPolyhedra(*npoly, poly);
   ModelInfo[whichModel].FillPolyhedraStyles();
   if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
   {
       GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
       GtkWidget *dlg = get_widget(GLWINDOW, SettingsWindow);
       set_values_for_polyhedra(dlg, gl);
   }
}

extern "C" void jav_passa_legami_(f_bond_type *legm, int *nleg, int *icode)
{
using namespace GLextmr;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
//#ifdef JAV
      int wm = GetActiveModel() - 1;
//#else
//      int wm = 0;
//#endif
   switch(*icode)
   {
   case 1:
        ModelInfo[wm].nlegsH = *nleg;
        if(ModelInfo[wm].legsH != NULL)
        {
           g_free(ModelInfo[wm].legsH);
           ModelInfo[wm].legsH = NULL;
        }
        if(*nleg > 0)
        {
           ModelInfo[wm].legsH = g_new0(jav_bond_type, ModelInfo[wm].nlegsH);
           for (int i=0;i<ModelInfo[wm].nlegsH; i++)
           {
              ModelInfo[wm].legsH[i].n1 = legm[i].n1;
              int n2 = MRabs(legm[i].n2);
              ModelInfo[wm].legsH[i].n2 = legm[i].n2;
              ModelInfo[wm].legsH[i].dist = legm[i].dist;
              ModelInfo[wm].legsH[i].ordleg = legm[i].ord;
//              g_print("%d %d %d\n", i+1, legm[i].n1, legm[i].n2);
// hang atom?
              if(gl->ifDelHang)
              {
//                 if(legm[i].n2 < 0)
                 if(legm[i].ord == 1)
                    ModelInfo[wm].atm[n2-1].hidden = true;
              }
           }
        }
        break;
   case 2:
        ModelInfo[wm].nlegsW = *nleg;
        if(ModelInfo[wm].legsW != NULL)
        {
           g_free(ModelInfo[wm].legsW);
           ModelInfo[wm].legsW = NULL;
        }
        if(*nleg > 0)
        {
           ModelInfo[wm].legsW = g_new0(jav_bond_type, ModelInfo[wm].nlegsW);
           for (int i=0;i<ModelInfo[wm].nlegsW; i++)
           {
              ModelInfo[wm].legsW[i].n1 = legm[i].n1;
              int n2 = MRabs(legm[i].n2);
              ModelInfo[wm].legsW[i].n2 = legm[i].n2;
              ModelInfo[wm].legsW[i].dist = legm[i].dist;
              ModelInfo[wm].legsW[i].ordleg = legm[i].ord; // 06082018
//              g_print("%d %d %d\n", i+1, legm[i].n1, legm[i].n2);
// hang atom?
              if(gl->ifDelHang)
              {
//                 if(legm[i].n2 < 0)
                 if(legm[i].ord == 1)
                    ModelInfo[wm].atm[n2-1].hidden = true;
              }
           }
        }
        break;
   }
   UpdateInfoAtoms();
   gl->Redraw();
}

extern "C" void enable_polyhedra_button_(int *action)
{
using namespace GLextmr;
   gpointer check = get_object(GLWINDOW, "Polyhedra");
   obj_set_active(check, FALSE);
   obj_set_sensitive(check, *action);
}

extern "C" void enable_contacts_button_(int *action)
{
using namespace GLextmr;
   gpointer check = get_object(GLWINDOW, "Hydrogen Bonds");
   obj_set_active(check, FALSE);
   obj_set_sensitive(check, *action);
   check = get_object(GLWINDOW, "Short Contacts");
   obj_set_active(check, FALSE);
   obj_set_sensitive(check, *action);
}

#if 0
extern "C" void getmodelinfo_(int *wm)
{
#ifdef JAV
using namespace GLextmr;

   int nk, no[MAX_SPECIES], nw[MAX_SPECIES];
   float raggi[2][MAX_SPECIES];
   _StructSpecies StructSpecies;
//   len_spec Species[MAX_SPECIES];

   for(int i=0; i<MAX_SPECIES; i++)
   {
        raggi[0][i] = raggi[1][i] = 0;
        no[i] = 0;
        nw[i] = 0;
        memcpy(&(StructSpecies.sp), ModelInfo[*wm-1].info.Species, sizeof(_StructSpecies));
//        memcpy(&Species[i], ModelInfo[*wm-1].info.Species[i], 4);
   }
   nk = ModelInfo[*wm-1].numSpec;
   for (int j=0; j< ModelInfo[*wm-1].numSpec; j++)
   {
        no[j] = ModelInfo[*wm-1].Species[j];
        nw[j] = ModelInfo[*wm-1].Content[j];
        raggi[0][j] = ModelInfo[*wm-1].radii[j][0];
        raggi[1][j] = ModelInfo[*wm-1].radii[j][1];
   }
   putspeciesinfo_(&nk, nw, no, raggi, &StructSpecies);
//   putspeciesinfo_(&nk, nw, no, raggi, Species);
#endif
}
#endif

extern "C" void setname_(char *nome, int *kmod)
{
using namespace GLextmr;
   int whichModel = *kmod - 1;
   if((whichModel < 0) || (whichModel > MAX_NUM_MODELS))
      return;
   if(ModelInfo[whichModel].created)
   {
      ModelInfo[whichModel].modname = g_strdup(nome);
      setModelName(whichModel);
      update_menu_deletemodel();
   }
}

extern "C" void vediparallelepipedo_(int *ifShow)
{
using namespace GLextmr;
   if(GLWINDOW == NULL)
   {
      defaultDrawPar = (*ifShow != 0);
      return;
   }
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gl->ifDrawPar = (*ifShow != 0);
   gl->Redraw();
}

extern "C" void passaparallelepipedo_(float v0[], float v1[], float abc[])
{
using namespace GLextmr;
   if(GLWINDOW == NULL)
   {
      MRVectorCopy(MRVectorMedium(v0, v1), &defaultV0);
      MRVectorCopy(MRVectorMake(abc), &defaultabc);
#ifdef MAPS
      for(int j=0; j<3; j++)
          centroMappa[j] = (v0[j] + v1[j]) * 0.5f;
      defCentro = true;
//      g_print("Input: x y z: %f %f %f\n", centroMappa[0], centroMappa[1], centroMappa[2]);
      raggioMappa = MRmax(abc[0], abc[1]);
      raggioMappa = 0.75f * MRmax(raggioMappa, abc[2]);
#endif
      return;
   }
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
//   gl->CalcPar(v0, abc);
   MRVectorCopy(MRVectorMedium(v0, v1), &(gl->xyzC));
   MRVectorCopy(MRVectorMake(abc), &(gl->abcPar));
   gl->CalcPar(gl->xyzC, gl->abcPar);
   gl->RiNormalizza();
   gl->Redraw ();
}

extern "C" void NewVolume(float v[])
{
using namespace GLextmr;
   if(GLWINDOW == NULL)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   MRVectorCopy(MRVectorMake(v), &(gl->abcPar));
   gl->CalcPar(gl->xyzC, gl->abcPar);
#ifdef MAPS
   gl->Radius = MRmax(v[0], v[1]);
   gl->Radius = 0.75f * MRmax(gl->Radius, v[2]);
   for(int i=0; i<gl->nMaps; i++)
       MapInfo[i].FromRadTorad(gl);
#endif
   gl->RiNormalizza();
   gl->Redraw ();
#ifdef MAPS
   update_center();
#endif
}

extern "C" void NewTrasl(float xd[])
{
using namespace GLextmr;
   if(GLWINDOW == NULL)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   
   vet3 xdc = gl->CartToFract(xd);
   vet3 posi = MRVectorAdd(defaultV0, xdc);
   move_center(posi, -1, -1, false);
}

extern "C" void GetNewVolumeInfo(float abc[], float xc[])
{
using namespace GLextmr;
   if(GLWINDOW == NULL)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   for (int i=0; i<3; i++)
   {
        abc[i] = (float) gl->abcPar.v[i];
        xc[i]  = (float) gl->xyzC.v[i];
   }
}

extern "C" void close_glwindow_()
{
using namespace GLextmr;

     if(GLWINDOW == NULL)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     if(gl)
        gl->Destroy(0);
}

gboolean on_delete_event  (gpointer w, GdkEvent *, gpointer )
{
  obj_activate(w);
  return TRUE;
}

extern "C" void open_glwindow_()
{
using namespace GLextmr;
using namespace main_app;
//#ifndef JAV
     if(GLWINDOW)
     {
        gtk_widget_show(GLWINDOW);
#ifndef _WIN32
        gdk_window_raise(gtk_widget_get_window(GLWINDOW));
#endif
        return;
     }

#ifndef JAV
     bool result = JavApp.Initialize();
     if(!result)
        return;
     if(defaultPlotStyle == -1)
        defaultPlotStyle = JavApp.PlotType;
     if(PreviewMode)
     {
         SaveSize[0] = JavApp.Kscrx;
         SaveSize[1] = JavApp.Kscry;
         JavApp.Kscrx = defaultW;
         JavApp.Kscry = defaultH;
     }
#endif

     JavApp.InitGraphics();
#ifdef GDK_WINDOWING_WIN32
      TestMultiSampling();
#endif
     ifSmooth = JavApp.Bestv;
     char *title;
     if(!str_white(defaultTitle.c_str()))
         title = DuplicaStringa(defaultTitle.c_str());
     else
#ifdef JAV
         title = DuplicaStringa("Jav");
#else
         title = DuplicaStringa("No title");
#endif
     if((JavApp.XStart < 0) || (JavApp.YStart < 0))
     {
         GdkRectangle rect;
#if (GTK_MAJOR_VERSION > 2) && (GTK_MINOR_VERSION >= 22)
         GdkMonitor *mon = gdk_display_get_primary_monitor(gdk_display_get_default());
         if(mon == NULL)
            mon = gdk_display_get_monitor_at_point(gdk_display_get_default(), 0, 0);
         if(mon != NULL)
            gdk_monitor_get_geometry(mon, &rect);
         else
         {
            rect.width = 800;
            rect.height = 600;
         }
#else
         GdkScreen *sc = gdk_screen_get_default();
         gdk_screen_get_monitor_geometry(sc, 0, &rect);
#endif

         int ww = rect.width;
         int hh = rect.height;
         //int ww = gdk_screen_get_width(sc);
         //int hh = gdk_screen_get_height(sc);
         JavApp.Kscrx = ww / 2;
         JavApp.Kscry = hh / 2;
         JavApp.XStart = JavApp.Kscrx / 2;
         JavApp.YStart = JavApp.Kscry / 2;
         JavApp.UpdateDime(JavApp.Kscrx, JavApp.Kscry);
     }

     GtkWidget *main_window = create_GLwindow(JavApp.Kscrx, JavApp.Kscry,
          title, JavApp.Bestv, JavApp.XStart, JavApp.YStart);
     g_free(title);
#ifdef JAV     
     set_win_main(main_window);
     gdk_window_set_icon_name (gtk_widget_get_window(main_window), "Jav");
     set_icon(main_window, program_ico);
#else
     GLWindow *glx = (GLWindow *)g_object_get_data(G_OBJECT(main_window), "glwindow");
     g_signal_connect(G_OBJECT(main_window), "delete_event",
         G_CALLBACK(on_close_window), (gpointer) glx);
#endif
     if(PreviewMode)
     {
        g_signal_connect(G_OBJECT(main_window), "delete_event",
        G_CALLBACK(close_offscreen), NULL);
     }
     else
     {
#ifndef USE_ACTIONS
     GtkAccelGroup *accel_group = gtk_accel_group_new ();
     gtk_window_add_accel_group (GTK_WINDOW (main_window), accel_group);

     GtkWidget *menubar = CreateMenubar(main_window, menu_entries,
                          n_menu_entries, 18, 18);
     GtkWidget *vtoolbar = CreateToolbar(main_window, 1, vtb_entries,
                                         n_vtb_entries);
     GtkWidget *toolbar = CreateToolbar(main_window, 0, tb_entries,
                                         n_tb_entries);
#else
     GtkActionGroup *group = CreateActionGroup(main_window, n_menu_entries, menu_entries, "MenuBar");
     group = CreateActionGroup(main_window, n_tb_entries, tb_entries, "HToolBar");
     group = CreateActionGroup(main_window, n_vtb_entries, vtb_entries, "VToolBar");
     GtkUIManager *merge = gtk_ui_manager_new ();
     gtk_ui_manager_insert_action_group (merge, group, -1);
     gtk_window_add_accel_group (GTK_WINDOW (main_window),
                                  gtk_ui_manager_get_accel_group (merge));
     g_object_set_data_full (G_OBJECT (main_window), "ui-manager", merge,
                              g_object_unref);
     GtkWidget *menubar = CreateMenubar(main_window, menu_info, merge, group);
     set_tooltips_on_menu(main_window, n_menu_entries,
            (mr_action_entry *) menu_entries);

     GtkWidget *toolbar = CreateToolbar(main_window, tb_info, merge, group,
                            "HToolBar", 0);
     GtkWidget *vtoolbar = CreateToolbar(main_window, vtb_info, merge, group,
                            "VToolBar", 1);
#ifdef MAPS
     {
     GtkWidget *toolitem = gtk_ui_manager_get_widget (merge, "/VToolBar/Sigma");
     if(toolitem)
     {
        GtkWidget *vbox = vbox_new(FALSE, 0);
        GtkWidget *button = create_range(main_window, vbox, special_car_greek('s'),
            1, "Sigma");
        gtk_widget_show_all(vbox);
        gtk_container_add(GTK_CONTAINER(toolitem), vbox);
        int hnd = g_signal_connect ((gpointer) button, "value-changed",
                    G_CALLBACK(on_sigma), main_window);
        g_object_set_data (G_OBJECT (button), "hnd", GINT_TO_POINTER(hnd));
        g_object_set_data (G_OBJECT (main_window), "Sigma", button);
        gtk_widget_set_sensitive(vbox, FALSE);
     }
     }
#endif  //MAPS
#ifdef JAV
     {
     GtkWidget *toolitem = gtk_ui_manager_get_widget (merge, "/VToolBar/Clip");
     if(toolitem)
     {
        GtkWidget *vbox = vbox_new(FALSE, 0);
        GtkWidget *button = create_range(main_window, vbox, "Clip",1);
        gtk_widget_show_all(vbox);
        gtk_container_add(GTK_CONTAINER(toolitem), vbox);
        int hnd = g_signal_connect ((gpointer) button, "value-changed",
                    G_CALLBACK(on_clip), main_window);
        g_object_set_data (G_OBJECT (button), "hnd", GINT_TO_POINTER(hnd));
        g_object_set_data (G_OBJECT (main_window), "Clip", button);
        gtk_widget_set_sensitive(vbox, FALSE);
     }
     }
#endif  //JAV
#endif  //USE_ACTIONS

#ifdef JAV
     g_object_set_data(G_OBJECT(main_window), "fontU", DuplicaStringa(JavApp.FontU().c_str()));
#endif
     g_object_set_data(G_OBJECT(main_window), "menubar", menubar);
     gtk_widget_show (vtoolbar);
     g_object_set_data(G_OBJECT(main_window), "vtoolbar", vtoolbar);
     gtk_box_pack_start (GTK_BOX (get_widget(main_window, "hbox")), vtoolbar,
                         FALSE, FALSE, 0);
     gtk_widget_show (toolbar);
     g_object_set_data(G_OBJECT(main_window), "toolbar", toolbar);
     gtk_box_pack_start (GTK_BOX (get_widget(main_window, "vbox")), toolbar,
                         FALSE, FALSE, 0);

     GtkWidget *vbox = get_widget(main_window, "vbox");
     GtkWidget *frame = gtk_frame_new(NULL);
     gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, TRUE, 0);
     gtk_box_reorder_child(GTK_BOX(vbox), frame, 0);
//#ifdef MAC_INTEGRATION
//#ifdef JAV
//     SetMainMenu(menubar, true);
//#else
//     SetMainMenu(menubar, false);
//#endif
//#else
#if defined(MAC_INTEGRATION) && defined(JAV1)
     SetMainMenu(menubar, true);
#else
     gtk_widget_show(frame);
     gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);
     gtk_container_add (GTK_CONTAINER (frame), menubar);
     gtk_widget_show(menubar);
#endif
     frame = get_widget(main_window, "toolbar");
     gtk_box_reorder_child(GTK_BOX(vbox), frame, 1);
     gtk_widget_show(frame);
     g_signal_connect_swapped(G_OBJECT(main_window), "delete_event",
        G_CALLBACK(on_delete_event), get_object(main_window,"Exit"));
     gtk_widget_show(main_window);

     GdkCursor *cross_cursor, *move_cursor, *wait_cursor,
       *zoom_cursor;
     cross_cursor = create_my_cursor(CROSS_CURSOR);
     move_cursor = create_my_cursor(MOVE_CURSOR);
//   wait_cursor = gdk_cursor_new(GDK_WATCH);
     wait_cursor = gdk_cursor_new_for_display(gdk_display_get_default(), GDK_WATCH);
//     wait_cursor = create_my_cursor(WAIT_CURSOR);
     zoom_cursor = create_my_cursor(ZOOM_CURSOR);
     g_object_set_data(G_OBJECT(main_window), "wait_cursor",
             wait_cursor);
     g_object_set_data(G_OBJECT(main_window), "move_cursor",
             move_cursor);
     g_object_set_data(G_OBJECT(main_window), "cross_cursor",
             cross_cursor);
     g_object_set_data(G_OBJECT(main_window), "zoom_cursor",
             zoom_cursor);
#ifndef JAV
     if(!JavApp.IfMaximized)
        gtk_window_move (GTK_WINDOW (main_window), JavApp.XStart, JavApp.YStart);
     else
        gtk_window_maximize(GTK_WINDOW (main_window));
#endif

    GtkWidget *entry = get_widget(GLWINDOW, "Clip");
    if(entry != NULL)
    {
       gtk_range_set_range(GTK_RANGE(entry), 0.01, 1.0);
       gtk_range_set_value(GTK_RANGE(entry), 0.5);
    }
    }         //end !PreviewMode
     ModelInfo = g_new0(Model, MAX_NUM_MODELS);
     for(int i=0; i<MAX_NUM_MODELS; i++)
         ModelInfo[i] = Model();
#ifdef MAPS
     MapInfo = g_new0(Mappa, 2*MAX_NUM_MAPS);
     for(int i=0; i<2*MAX_NUM_MAPS; i++)
         MapInfo[i] = Mappa(i);
     VWSurface = g_new0(Mappa, MAX_NUM_MODELS);
     for(int i=0; i<MAX_NUM_MODELS; i++)
         VWSurface[i] = Mappa(i, true);
#endif

#ifdef JAV
    if(!PreviewMode)
    {
       SetLastRun(main_window, ifPreviousRun);
       sync_radios();
       update_modify_menu();
    }
    else
    {
     GLWindow *glx = (GLWindow *)g_object_get_data(G_OBJECT(main_window), "glwindow");
       glx->Redraw();
    }
#endif
}

void OpenGLWindow()
{
    open_glwindow_();
}

extern "C" void cleardistang_()
{
using namespace GLextmr;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  for(int k=0; k<gl->nModels; k++)
       for(int i=0; i<ModelInfo[k].nats; i++)
           ModelInfo[k].atm[i].drawLabel = 0;
  gl->DistAng_vet.clear();
}

extern "C" void get_packing_info_(float klevelv[], int *kfitopt, int *kmod)
{
using namespace GLextmr;
   int whichModel = *kmod - 1;
   if(whichModel < 0)
       return;
   for(int i=0; i<3; i++)
       klevelv[i] = ModelInfo[whichModel].klevel[i];
   *kfitopt = ModelInfo[whichModel].FitOpt+1;
}

extern "C" void jav_setta_preview_(int *ifPreview, char *png)
{
using namespace GLextmr;
     PreviewMode = (*ifPreview != 0);
     if(PreviewMode)
     {
        BufferName.assign(png);
        set_defbg(1);
        useDefaultB = false;
     }
}

extern "C" void jav_setta_size_(int *w, int *h)
{
using namespace main_app;
using namespace GLextmr;
   defaultW = *w;
   defaultH = *h;
}

extern "C" void jav_setta_colmode_(int *c)
{
using namespace GLextmr;
   defaultColor = *c - 1;
}

extern "C" void setta_style_(int *ps)
{
using namespace GLextmr;
     int plotStyle = *ps - 1;
     if((plotStyle < 0) || (plotStyle >= PLOT_STYLES))
        plotStyle = STICK_AND_BALLS;
      defaultPlotStyle = plotStyle;
}

bool sortByZ ( int elem1, int elem2 )
{
   int i1 = ZFromPtab(elem1-1);
   int i2 = ZFromPtab(elem2-1);
   if(i1 != i2)
      return (i1 < i2);
   else
      return (elem1 < elem2);
}

int SpecFromAtm(atom_type atm[], std::vector<int> &specv, int nats)
{
    std::vector<int>::iterator it;
    for(int i=0; i<nats; i++)
    {
        it = find (specv.begin(), specv.end(), atm[i].ptab);
        if(it != specv.end())
           continue;
        specv.push_back(atm[i].ptab);
    }
    if(specv.empty())
       return 0;
    std::sort(specv.begin(), specv.end(), sortByZ);
    return (int)specv.size();
}

void DisegnaSelezione(int whichModel, int code, int n[])
{
using namespace GLextmr;

     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");

    if(whichModel == -1)
       whichModel = GetActiveModel() - 1;

    on_unselect(NULL, (gpointer) GLWINDOW);
    if(code == 1)
       SelezionaLegame(whichModel, n[0], n[1]);
    else if(code == 2)
       SelezionaAngolo(whichModel, n[0], n[1], n[2]);
    gl->Redraw();
}

void Attesa(const char *msg)
{
using namespace GLextmr;

   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gl->PrintMess(msg);
// la seguente per forzare il cambio di cursore

    gtk_widget_grab_focus(GLWINDOW);
//
    ShowWaitCursor(GLWINDOW);
    LoadWinCursor(5);
// le 2 seguenti per PrintMess
     while(gtk_events_pending())
         (void) gtk_main_iteration();
//
}

void FineAttesa(const char *msg)
{
using namespace GLextmr;

   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    gl->PrintMess(msg);
    HideWaitCursor(GLWINDOW);
    LoadWinCursor(0);
}   

extern "C" void gtkmainloop_()
{
    gtk_main();
}

